# -*- coding: utf-8 -*-
# Generated by Django 1.11.11 on 2018-04-03 20:07

import catmaid.fields
import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion

forward = """
    SELECT disable_history_tracking_for_table('stack'::regclass,
            get_history_table_name('stack'::regclass));
    SELECT drop_history_view_for_table('stack'::regclass);

    ALTER TABLE stack
    ADD COLUMN downsample_factors integer3d[] DEFAULT NULL;

    UPDATE stack
    SET downsample_factors = ARRAY(
        SELECT (1 << s, 1 << s, 1)::integer3d
        FROM generate_series(0, num_zoom_levels) AS r(s)
    )
    WHERE num_zoom_levels <> -1;

    ALTER TABLE stack
    DROP COLUMN num_zoom_levels;

    ALTER TABLE stack__history
    ADD COLUMN downsample_factors integer3d[] DEFAULT NULL;

    UPDATE stack__history
    SET downsample_factors = ARRAY(
        SELECT (1 << s, 1 << s, 1)::integer3d
        FROM generate_series(0, num_zoom_levels) AS r(s)
    )
    WHERE num_zoom_levels <> -1;

    ALTER TABLE stack__history
    DROP COLUMN num_zoom_levels;

    SELECT create_history_view_for_table('stack'::regclass);
    SELECT enable_history_tracking_for_table('stack'::regclass,
            get_history_table_name('stack'::regclass), FALSE);
    """

backward = """
    SELECT disable_history_tracking_for_table('stack'::regclass,
            get_history_table_name('stack'::regclass));
    SELECT drop_history_view_for_table('stack'::regclass);

    ALTER TABLE stack
    ADD COLUMN num_zoom_levels integer NOT NULL DEFAULT -1;

    UPDATE stack
    SET num_zoom_levels = coalesce(array_length(downsample_factors, 1), 0) - 1
    WHERE downsample_factors IS NOT NULL;

    ALTER TABLE stack
    DROP COLUMN downsample_factors;

    ALTER TABLE stack__history
    ADD COLUMN num_zoom_levels integer NOT NULL DEFAULT -1;

    UPDATE stack__history
    SET num_zoom_levels = coalesce(array_length(downsample_factors, 1), 0) - 1
    WHERE downsample_factors IS NOT NULL;

    ALTER TABLE stack__history
    DROP COLUMN downsample_factors;

    SELECT create_history_view_for_table('stack'::regclass);
    SELECT enable_history_tracking_for_table('stack'::regclass,
            get_history_table_name('stack'::regclass), FALSE);
    """


class Migration(migrations.Migration):

    dependencies = [
        ('catmaid', '0036_update_sampler_interval_constraints'),
    ]

    operations = [
        migrations.RunSQL(
            forward,
            backward,
            [
                migrations.RemoveField(
                    model_name='stack',
                    name='num_zoom_levels',
                ),
                migrations.AddField(
                    model_name='stack',
                    name='downsample_factors',
                    field=catmaid.fields.DownsampleFactorsField(
                        help_text='Downsampling factors along each dimensions for each zoom level.',
                        size=None),
                ),
            ],
        ),
    ]
