"""Change comp gen resources to not use FKs

Revision ID: a929c366aeef
Revises: 255c01bd1e49
Create Date: 2018-09-19 21:30:32.257969

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'a929c366aeef'
down_revision = '255c01bd1e49'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('comp_gen_resources', schema=None) as batch_op:
        batch_op.drop_constraint('comp_gen_resources_current_comp_id_fkey', type_='foreignkey')
        batch_op.drop_constraint('comp_gen_resources_previous_comp_id_fkey', type_='foreignkey')

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('comp_gen_resources', schema=None) as batch_op:
        batch_op.create_foreign_key('comp_gen_resources_previous_comp_id_fkey', 'competitions', ['previous_comp_id'], ['id'])
        batch_op.create_foreign_key('comp_gen_resources_current_comp_id_fkey', 'competitions', ['current_comp_id'], ['id'])

    # ### end Alembic commands ###
