# -*- coding: utf-8 -*-
# Generated by Django 1.11.20 on 2019-04-11 08:31


from django.db import migrations

hierarchies = {
    3394: 4401,  # EUTF
    4531: 7350,  # Nuffic
}


def create_hierarchies(apps, schema):
    ProjectHierarchy = apps.get_model('rsr', 'ProjectHierarchy')
    Project = apps.get_model('rsr', 'Project')
    Organisation = apps.get_model('rsr', 'Organisation')
    for org_id, project_id in hierarchies.items():
        try:
            root_project = Project.objects.get(id=project_id)
            organisation = Organisation.objects.get(id=org_id)
        except (Project.DoesNotExist, Organisation.DoesNotExist):
            return

        ProjectHierarchy.objects.get_or_create(
            organisation=organisation,
            root_project=root_project,
            max_depth=2
        )


def delete_hierarchies(apps, schema):
    ProjectHierarchy = apps.get_model('rsr', 'ProjectHierarchy')
    project_ids = list(hierarchies.values())
    ProjectHierarchy.objects.filter(root_project_id__in=project_ids).delete()


class Migration(migrations.Migration):

    dependencies = [
        ('rsr', '0145_projecthierarchy'),
    ]

    operations = [
        migrations.RunPython(create_hierarchies, delete_hierarchies)
    ]
