# -*- coding: utf-8 -*-
# Generated by Django 1.11.22 on 2019-07-25 01:21


from django.db import migrations
from akvo.rsr.models.result.disaggregation_aggregation import DisaggregationAggregation


def migrate_period_disaggregations(apps, schema_editor):
    Disaggregation = apps.get_model('rsr', 'Disaggregation')
    IndicatorPeriodDisaggregation = apps.get_model('rsr', 'IndicatorPeriodDisaggregation')

    disaggregation_aggregation = DisaggregationAggregation(
        Disaggregation.objects,
        IndicatorPeriodDisaggregation.objects
    )

    disaggregation_leafs = Disaggregation.objects.filter(
        update__period__child_periods__isnull=True,
        dimension_value__isnull=False
    )

    for disaggregation in disaggregation_leafs:
        disaggregation_aggregation.aggregate(
            disaggregation.update.period,
            disaggregation.dimension_value
        )


class Migration(migrations.Migration):

    dependencies = [
        ('rsr', '0160_indicatorperioddisaggregation'),
    ]

    operations = [
        migrations.RunPython(migrate_period_disaggregations),
    ]
