"""add user preferences

Revision ID: efa99b5579e6
Revises: a55e8b8d40ca
Create Date: 2019-01-22 20:05:08.626769

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'efa99b5579e6'
down_revision = 'a55e8b8d40ca'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('user_settings',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.Column('setting_code', sa.String(length=128), nullable=True),
    sa.Column('setting_value', sa.String(length=128), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    with op.batch_alter_table('user_settings', schema=None) as batch_op:
        batch_op.create_index(batch_op.f('ix_user_settings_setting_code'), ['setting_code'], unique=False)
        batch_op.create_index(batch_op.f('ix_user_settings_setting_value'), ['setting_value'], unique=False)
        batch_op.create_index(batch_op.f('ix_user_settings_user_id'), ['user_id'], unique=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('user_settings', schema=None) as batch_op:
        batch_op.drop_index(batch_op.f('ix_user_settings_user_id'))
        batch_op.drop_index(batch_op.f('ix_user_settings_setting_value'))
        batch_op.drop_index(batch_op.f('ix_user_settings_setting_code'))

    op.drop_table('user_settings')
    # ### end Alembic commands ###
