"""Added WeeklyBlacklist, and results mod and verified user flags to users

Revision ID: 347361bd5358
Revises: ababcdcdefef
Create Date: 2019-05-08 11:49:58.025943

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '347361bd5358'
down_revision = 'ababcdcdefef'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('weekly_blacklist',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.Column('reason', sa.String(length=256), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    with op.batch_alter_table('users', schema=None) as batch_op:
        batch_op.add_column(sa.Column('always_blacklist', sa.Boolean(), nullable=True))
        batch_op.add_column(sa.Column('is_results_mod', sa.Boolean(), nullable=True))
        batch_op.add_column(sa.Column('is_verified', sa.Boolean(), nullable=True))

    with op.batch_alter_table('weekly_metrics', schema=None) as batch_op:
        batch_op.drop_column('mobile_hits')
        batch_op.drop_column('desktop_hits')
        batch_op.drop_column('bot_hits')

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('weekly_metrics', schema=None) as batch_op:
        batch_op.add_column(sa.Column('bot_hits', sa.INTEGER(), autoincrement=False, nullable=True))
        batch_op.add_column(sa.Column('desktop_hits', sa.INTEGER(), autoincrement=False, nullable=True))
        batch_op.add_column(sa.Column('mobile_hits', sa.INTEGER(), autoincrement=False, nullable=True))

    with op.batch_alter_table('users', schema=None) as batch_op:
        batch_op.drop_column('is_verified')
        batch_op.drop_column('is_results_mod')
        batch_op.drop_column('always_blacklist')

    op.drop_table('weekly_blacklist')
    # ### end Alembic commands ###
