"""Add a family type for dataset

Revision ID: 12aa2de68f7
Revises: 3a330ab4ce99
Create Date: 2014-09-12 07:28:20.378736

"""

# revision identifiers, used by Alembic.
revision = '12aa2de68f7'
down_revision = '3a330ab4ce99'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.add_column('data_set', sa.Column('family_type', sa.Text()))
    op.execute("update data_set set family_type='streetnetwork' where type = 'osm' or type = 'geopal'")
    op.execute("update data_set set family_type='pt' where type = 'gtfs' or type = 'fusio'")
    op.execute("update data_set set family_type='poi' where type = 'poi'")
    op.execute("update data_set set family_type='synonym' where type = 'synonym'")
    op.execute("update data_set set family_type='fare' where type = 'fare'")
    op.alter_column('data_set', 'family_type', nullable=False)
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('data_set', 'family_type')
    ### end Alembic commands ###
