"""Added summary table

Revision ID: 48c16211f99
Revises: 404db3c1f74
Create Date: 2016-10-08 22:36:11.305570

"""

# revision identifiers, used by Alembic.
revision = '48c16211f99'
down_revision = '2105015bafe'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('summary',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=True),
    sa.Column('modified', sa.DateTime(), nullable=True),
    sa.Column('title', sa.String(length=128), nullable=True),
    sa.Column('path', sa.String(length=256), nullable=True),
    sa.Column('date', sa.Date(), nullable=True),
    sa.Column('course_id', sa.Integer(), nullable=True),
    sa.Column('education_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['course_id'], ['course.id'], name=op.f('fk_summary_course_id_course')),
    sa.ForeignKeyConstraint(['education_id'], ['education.id'], name=op.f('fk_summary_education_id_education')),
    sa.PrimaryKeyConstraint('id', name=op.f('pk_summary')),
    sqlite_autoincrement=True
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('summary')
    ### end Alembic commands ###
