"""Removed degree table and degree foreignkey from education.

Revision ID: 94f861ea7006
Revises: c0c867df20d3
Create Date: 2017-01-15 17:22:59.906637

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = '94f861ea7006'
down_revision = 'c0c867df20d3'


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('education_ibfk_1', 'education', type_='foreignkey')
    op.drop_column('education', 'degree_id')
    op.drop_table('degree')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('education',
                  sa.Column('degree_id',
                            mysql.INTEGER(display_width=11),
                            autoincrement=False, nullable=False))
    op.create_table('degree',
                    sa.Column('id',
                              mysql.INTEGER(display_width=11), nullable=False),
                    sa.Column('created', mysql.DATETIME(), nullable=True),
                    sa.Column('modified', mysql.DATETIME(), nullable=True),
                    sa.Column('name',
                              mysql.VARCHAR(length=128), nullable=False),
                    sa.Column('abbreviation',
                              mysql.VARCHAR(length=128), nullable=False),
                    sa.PrimaryKeyConstraint('id'),
                    mysql_default_charset='latin1',
                    mysql_engine='InnoDB'
                    )
    op.create_foreign_key('education_ibfk_1',
                          'education', 'degree', ['degree_id'], ['id'])
    # ### end Alembic commands ###
