"""add field max_duration_criteria and max_duration_fallback_mode on instances

Revision ID: 2a77596bdf40
Revises: 499761993c22
Create Date: 2015-03-24 11:15:37.044713

"""

# revision identifiers, used by Alembic.
revision = '2a77596bdf40'
down_revision = '499761993c22'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    bind = op.get_bind()
    enum_criteria = sa.Enum('time', 'duration', name='max_duration_criteria')
    impl_criteria = enum_criteria.dialect_impl(bind.dialect)
    impl_criteria.create(bind, checkfirst=True)

    enum_mode = sa.Enum('walking', 'bss', 'bike', 'car', name='max_duration_fallback_mode')
    impl_mode = enum_mode.dialect_impl(bind.dialect)
    impl_mode.create(bind, checkfirst=True)

    op.add_column(
        'instance', sa.Column('max_duration_criteria', enum_criteria, nullable=False, server_default='time')
    )
    op.add_column(
        'instance', sa.Column('max_duration_fallback_mode', enum_mode, nullable=False, server_default='walking')
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('instance', 'max_duration_fallback_mode')
    op.drop_column('instance', 'max_duration_criteria')
    ### end Alembic commands ###
