"""add metric table for keeping track of ed's duration

Revision ID: 3aaddd5707bd
Revises: 2e0ac7e0a7a7
Create Date: 2015-10-22 10:08:09.805921

"""

# revision identifiers, used by Alembic.
revision = '3aaddd5707bd'
down_revision = '2e0ac7e0a7a7'

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        'metric',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('job_id', sa.Integer(), nullable=False),
        sa.Column(
            'type',
            sa.Enum(
                'ed2nav',
                'fusio2ed',
                'gtfs2ed',
                'osm2ed',
                'geopal2ed',
                'synonym2ed',
                'poi2ed',
                name='metric_type',
            ),
            nullable=False,
        ),
        sa.Column('dataset_id', sa.Integer(), nullable=True),
        sa.Column('duration', postgresql.INTERVAL(), nullable=True),
        sa.ForeignKeyConstraint(['dataset_id'], ['data_set.id']),
        sa.ForeignKeyConstraint(['job_id'], ['job.id']),
        sa.PrimaryKeyConstraint('id'),
    )
    op.add_column('data_set', sa.Column('uid', postgresql.UUID(), nullable=True))
    op.create_unique_constraint('data_set_uid_idx', 'data_set', ['uid'])
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('data_set_uid_idx', 'data_set')
    op.drop_column('data_set', 'uid')
    op.drop_table('metric')
    sa.Enum(name='metric_type').drop(op.get_bind(), checkfirst=False)
    ### end Alembic commands ###
