"""add vj_class and meta_vj_name in vehicle_journey

Revision ID: 4ccd66ece649
Revises: 1651f9b235f5
Create Date: 2015-10-30 09:44:26.809218

"""

# revision identifiers, used by Alembic.
revision = '4ccd66ece649'
down_revision = '1651f9b235f5'

from alembic import op
import sqlalchemy as sa
import geoalchemy2 as ga
from sqlalchemy.dialects import postgresql


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('rel_metavj_vj', schema='navitia')
    op.add_column('vehicle_journey', sa.Column('meta_vj_name', sa.TEXT(), nullable=True), schema='navitia')
    op.add_column(
        'vehicle_journey',
        sa.Column(
            'vj_class',
            postgresql.ENUM(u'Theoric', u'Adapted', u'RealTime', name='vj_classification'),
            server_default=u'Theoric',
            default=u'Theoric',
            nullable=False,
        ),
        schema='navitia',
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('vehicle_journey', 'vj_class', schema='navitia')
    op.drop_column('vehicle_journey', 'meta_vj_name', schema='navitia')
    sa.Enum(name='vj_classification').drop(op.get_bind(), checkfirst=False)
    op.create_table(
        'rel_metavj_vj',
        sa.Column('meta_vj', sa.BIGINT(), nullable=True),
        sa.Column('vehicle_journey', sa.BIGINT(), nullable=True),
        sa.Column(
            'vj_class',
            postgresql.ENUM(u'Theoric', u'Adapted', u'RealTime', name='vj_classification'),
            nullable=False,
        ),
        sa.ForeignKeyConstraint(['meta_vj'], [u'navitia.meta_vj.id'], name=u'rel_metavj_vj_meta_vj_fkey'),
        sa.ForeignKeyConstraint(
            ['vehicle_journey'], [u'navitia.vehicle_journey.id'], name=u'rel_metavj_vj_vehicle_journey_fkey'
        ),
        schema='navitia',
    )  ### end Alembic commands ###
