"""add table autocomplete which keeps tracks of data source for world wide autocomplete

Revision ID: 596a1d3d5157
Revises: 18862ea09b6d
Create Date: 2016-04-08 09:56:45.535055

"""

# revision identifiers, used by Alembic.
revision = '596a1d3d5157'
down_revision = '18862ea09b6d'

from alembic import op
import sqlalchemy as sa

source_street = sa.Enum('OSM', name='source_street')
source_address = sa.Enum('BANO', 'OSM', name='source_address')
source_poi = sa.Enum('FUSIO', 'OSM', name='source_poi')
source_admin = sa.Enum('OSM', name='source_admin')


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        'autocomplete_parameter',
        sa.Column('created_at', sa.DateTime(), nullable=False),
        sa.Column('updated_at', sa.DateTime(), nullable=True),
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('name', sa.Text(), nullable=False),
        sa.Column('street', source_street, nullable=True),
        sa.Column('address', source_address, nullable=True),
        sa.Column('poi', source_poi, nullable=True),
        sa.Column('admin', source_admin, nullable=True),
        sa.PrimaryKeyConstraint('id'),
        sa.UniqueConstraint('name'),
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('autocomplete_parameter')
    sa.Enum(name='source_street').drop(op.get_bind(), checkfirst=False)
    sa.Enum(name='source_address').drop(op.get_bind(), checkfirst=False)
    sa.Enum(name='source_poi').drop(op.get_bind(), checkfirst=False)
    sa.Enum(name='source_admin').drop(op.get_bind(), checkfirst=False)
    ### end Alembic commands ###
