"""make news.slug unique and not nullable

Revision ID: 95639507ec8b
Revises: e21cfb702854
Create Date: 2018-08-09 00:35:39.510051

"""

# revision identifiers, used by Alembic.
revision = '95639507ec8b'
down_revision = 'e21cfb702854'
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('news', 'slug',
               existing_type=sa.VARCHAR(length=200),
               nullable=False)
    op.create_unique_constraint('news_slug_key', 'news', ['slug'])
    op.create_index(op.f('ix_news_slug'), 'news', ['slug'], unique=True)
    # ### end Alembic commands ###

def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('news_slug_key', 'news', type_='unique')
    op.drop_index(op.f('ix_news_slug'), table_name='news')
    op.alter_column('news', 'slug',
               existing_type=sa.VARCHAR(length=200),
               nullable=True)
    # ### end Alembic commands ###
