"""Removing unused tables. Adding tag index.

Revision ID: c4e6d5863a94
Revises: 47683b299022
Create Date: 2017-01-15 13:49:21.292205

"""

# revision identifiers, used by Alembic.
revision = 'c4e6d5863a94'
down_revision = '47683b299022'
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('wikicomment')
    op.create_index(op.f('ix_tags_project_id'), 'tags', ['project_id'], unique=False)
    op.create_index(op.f('ix_tags_value'), 'tags', ['value'], unique=False)
    op.drop_index('public_tags_project_id0_idx', table_name='tags')
    op.drop_index('public_tags_value1_idx', table_name='tags')
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_index('public_tags_value1_idx', 'tags', ['value'], unique=False)
    op.create_index('public_tags_project_id0_idx', 'tags', ['project_id'], unique=False)
    op.drop_index(op.f('ix_tags_value'), table_name='tags')
    op.drop_index(op.f('ix_tags_project_id'), table_name='tags')
    op.create_table('wikicomment',
    sa.Column('id', sa.INTEGER(), nullable=False),
    sa.Column('link', sa.VARCHAR(length=255), autoincrement=False, nullable=True),
    sa.Column('users_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.Column('datetimeon', postgresql.TIMESTAMP(), autoincrement=False, nullable=True),
    sa.Column('content', sa.TEXT(), autoincrement=False, nullable=True),
    sa.PrimaryKeyConstraint('id', name='wikicomment_pkey')
    )
    ### end Alembic commands ###
