"""Configuration for deleted papers and their reasons for deletion."""

skipped_msg = 'this identifier erroneously skipped during software upgrade'
DELETED_PAPERS = {
    # document_id: reasons
    'alg-geom/9311009': 'was a duplicate of alg-geom/9311003',
    'alg-geom/9505034': 'was a duplicate of hep-th/9505179',
    'astro-ph/0004056': 'was a duplicate of physics/0004007',
    'astro-ph/0005013': 'was a duplicate of physics/0004071',
    'astro-ph/0005282': 'was a duplicate of physics/0005034',
    'astro-ph/0010130': 'was resubmitted as physics/0010050',
    'astro-ph/0011476': 'was a duplicate of astro-ph/0011480',
    'astro-ph/0110242': 'was a duplicate of astro-ph/0110255',
    'astro-ph/0202103': 'was a duplicate of nucl-th/0201053',
    'astro-ph/0312537': 'was a duplicate of astro-ph/0310424',
    'astro-ph/0410245': 'was a duplicate of quant-ph/0410065',
    'astro-ph/9406072': 'abstract-only submission',
    'astro-ph/9407045': 'was a duplicate of hep-ph/9407302',
    'astro-ph/9412089': 'was a duplicate of astro-ph/9501050',
    'astro-ph/9502017': 'was a duplicate of astro-ph/9501105',
    'astro-ph/9503100': 'was a duplicate of astro-ph/9503050',
    'astro-ph/9509026': 'was a duplicate of astro-ph/9509018',
    'astro-ph/9509132': 'was a duplicate of astro-ph/9509131',
    'astro-ph/9804324': 'was a duplicate of astro-ph/9712062',
    'astro-ph/9810505': 'was a duplicate of astro-ph/9810416',
    'astro-ph/9903191': 'was a duplicate of astro-ph/9903192',
    'cond-mat/0006067': 'was a duplicate of cond-mat/0006066',
    'cond-mat/0011036': 'was a duplicate of cond-mat/0011037',
    'cond-mat/0103465': 'was a duplicate of cond-mat/0011097',
    'cond-mat/0107243': 'was a duplicate of quant-ph/9910073',
    'cond-mat/0202476': 'was a duplicate of cond-mat/0202447',
    'cond-mat/0203191': 'was a duplicate of cond-mat/0203254',
    'cond-mat/0203478': 'was a duplicate of cond-mat/0203476',
    'cond-mat/0207217': 'was a duplicate of cond-mat/0207218',
    'cond-mat/0210072': 'was a duplicate of cond-mat/0101030',
    'cond-mat/0211393': 'was a duplicate of astro-ph/0109474',
    'cond-mat/0307544': 'was a duplicate of cond-mat/0307520',
    'cond-mat/0401321': 'was a duplicate of cond-mat/0401322',
    'cond-mat/0401508': 'was a duplicate of cond-mat/0401506',
    'cond-mat/0403639': 'was a duplicate of cond-mat/0403642',
    'cond-mat/0404097': 'was a duplicate of nlin/0403053',
    'cond-mat/0408699': 'was a duplicate of cond-mat/0305647',
    'cond-mat/0409136': 'was a duplicate of cond-mat/0405341',
    'cond-mat/0409496': 'was a duplicate of cond-mat/0403455',
    'cond-mat/0410327': 'was a duplicate of cond-mat/0410329',
    'cond-mat/0509526': 'was a duplicate of cond-mat/0509556',
    'cond-mat/9411086': 'was a duplicate of cond-mat/9411081',
    'cond-mat/9506106': 'was a duplicate of cond-mat/9506118',
    'cond-mat/9509002': 'was a duplicate of cond-mat/9509010',
    'cond-mat/9812170': 'was a duplicate of hep-th/9410234',
    'cond-mat/9902363': 'was a duplicate of cond-mat/9902365',
    'cond-mat/9906353': 'was a duplicate of cond-mat/9906354',
    'cond-mat/9909373': 'was a duplicate of gr-qc/9909077',
    'cs/0110033': 'was a duplicate of cs/0109047',
    'cs/0110045': 'was a duplicate of cs/0109057',
    'cs/0211034': 'was a duplicate of cs/0211035',
    'cs/0412082': 'was a duplicate of cs/0412081',
    'cs/0504098': 'was a duplicate of cs/0505019',
    'cs/9809044': 'was a duplicate of cs/9809063',
    'funct-an/9506002': 'was a duplicate of funct-an/9406003',
    'funct-an/9506004': 'was a duplicate of alg-geom/9506004',
    'gr-qc/0010093': 'was a duplicate of gr-qc/0010087',
    'gr-qc/0110007': 'was a duplicate of hep-th/0110003',
    'gr-qc/0506027': 'was a duplicate of gr-qc/0101124',
    'gr-qc/9509049': 'was a duplicate of gr-qc/9509042',
    'gr-qc/9909010': 'was a duplicate of gr-qc/9811023',
    'hep-ex/0111005': 'was a duplicate of hep-ph/0109254',
    'hep-lat/9401038': 'was a duplicate of hep-th/9401143',
    'hep-lat/9411038': 'was a duplicate of cond-mat/9411091',
    'hep-lat/9501031': 'was a duplicate of chao-dyn/9501017',
    'hep-ph/0107035': 'was a duplicate of hep-ph/0107047',
    'hep-ph/0107050': 'was a duplicate of hep-ph/0107055',
    'hep-ph/0110154': 'was a duplicate of hep-ph/0110169',
    'hep-ph/0205321': 'was a duplicate of hep-ph/0205320',
    'hep-ph/0212183': 'was a duplicate of hep-ph/0211388',
    'hep-ph/0310262': 'was a duplicate of hep-ph/0310264',
    'hep-ph/0403238': 'was a duplicate of hep-ph/0403237',
    'hep-ph/0410079': 'was a duplicate of hep-ph/0204177',
    'hep-ph/0504283': 'was a duplicate of hep-ph/0504284',
    'hep-ph/0505107': 'was a duplicate of hep-ph/0505108',
    'hep-ph/0506290': 'was a duplicate of hep-ph/0506291',
    'hep-ph/9305237': 'was a duplicate of astro-ph/9305010',
    'hep-ph/9407253': 'was a duplicate. Reported by SLAC SPIRES in 1995',
    'hep-ph/9812218': 'was a duplicate of nucl-ex/9812001',
    'hep-ph/9907237': 'was a duplicate of hep-ph/9410316',
    'hep-th/9208004': 'was a duplicate of alg-geom/9208001',
    'hep-th/9210144': 'was a duplicate of hep-th/9206065',
    'hep-th/9412223': 'was a duplicate of hep-th/9501133',
    'hep-th/9507073': 'was a duplicate of q-alg/9509003',
    'math/0104278': 'was a duplicate of gr-qc/0104095',
    'math/0111133': 'was a duplicate of math/0111144',
    'math/0204217': 'was a duplicate of cond-mat/0204055',
    'math/0211316': 'was a duplicate of math/0211341',
    'math/0212240': 'was a duplicate of math/0202020',
    'math/0306294': 'was a duplicate of math/0306295',
    'math/0412557': 'was a duplicate of math/0402446',
    'math/0501384': 'was a duplicate of math/0501385',
    'math/0501435': 'was a duplicate of math/0011083',
    'math/0503458': 'was a duplicate of math/0309222, '
                    'erroneously submitted by journal',
    'math/0510190': 'was a duplicate of math/0509721',
    'math/9911220': 'was a duplicate of math/9911219',
    'math-ph/0107029': 'was a duplicate of quant-ph/0103107',
    'math-ph/0204017': 'was a duplicate of quant-ph/0204048',
    'math-ph/0501027': 'was a duplicate of math-ph/0501028',
    'nlin/0010046': 'was a duplicate of math/0008078',
    'nlin/0105070': 'was a duplicate of nlin/0104072',
    'nucl-ex/0410004': 'was a duplicate of nucl-ex/0407023',
    'nucl-ex/0412040': 'was a duplicate of astro-ph/0410168',
    'nucl-th/0002009': 'was a duplicate of nucl-th/0002008',
    'nucl-th/0005001': 'was a duplicate of hep-ph/0005001',
    'nucl-th/0106003': 'was a duplicate of nucl-th/0005035',
    'nucl-th/0207028': 'was a duplicate of cond-mat/0207297',
    'nucl-th/0409069': 'was a duplicate of nucl-th/0409070',
    'physics/0012045': 'was a duplicate of cond-mat/0012308',
    'physics/0111090': 'was a duplicate of physics/0111064',
    'physics/0202011': 'was a duplicate of physics/0004023',
    'physics/0205056': 'was a duplicate of cond-mat/0205392',
    'physics/0208058': 'was a duplicate of physics/0004023',
    'physics/0412135': 'was a duplicate of physics/0412136',
    'physics/0603059': 'was a duplicate of gr-qc/0603024',
    'q-alg/9412011': 'was a duplicate of q-alg/9501023',
    'q-bio/0402020': 'was a duplicate of nlin/0402010',
    'quant-ph/0001022': 'was a duplicate of physics/0001012',
    'quant-ph/0011022': 'was a duplicate of hep-th/0001108',
    'quant-ph/0110073': 'was a duplicate of quant-ph/0110089',
    'quant-ph/0212051': 'was a duplicate of quant-ph/0204055',
    'quant-ph/0301102': 'was a duplicate of cond-mat/0301352',
    'quant-ph/0411165': 'was a duplicate of physics/0406014',
    'quant-ph/0505222': 'was a duplicate of cond-mat/0505716',
    'quant-ph/9904040': 'was a duplicate of math/9807137',
    'quant-ph/9907089': 'was a duplicate of quant-ph/9802048',
    'astro-ph/0509510': skipped_msg,
    'cond-mat/0509460': skipped_msg,
    'gr-qc/0509073': skipped_msg,
    'hep-ex/0509023': skipped_msg,
    'hep-lat/0509055': skipped_msg,
    'hep-ph/0509174': skipped_msg,
    'hep-th/0509134': skipped_msg,
    'math-ph/0509037': skipped_msg,
    'nucl-ex/0509023': skipped_msg,
    'nucl-th/0509043': skipped_msg,
    'physics/0509151': skipped_msg,
    'quant-ph/0509115': skipped_msg,
    'math/0509389': skipped_msg,
    'nlin/0509031': skipped_msg,
    'cs/0509051': skipped_msg,
    'q-bio/0509021': skipped_msg,
    'astro-ph/0605426': 'was a duplicate of astro-ph/0605425',
    'hep-th/0611096': 'was a duplicate of math-ph/0611023',
    '0901.4014': 'was a duplicate of 0901.3831',
    '1005.5600': 'was a duplicate of 1005.4557',
    '1005.5618': 'was a duplicate of 1004.2179',
    '1005.0836': 'was a duplicate of 1005.0206',
    '1005.0837': 'was a duplicate of 1001.3394',
    '1008.3138': 'was replacement of 1006.3352, now 1006.3352v3',
    '1008.3153': 'was a duplicate of 1007.0437',
    '1105.2364': 'was a duplicate of cs/9311102',
    '1105.2365': 'was a duplicate of cs/9402103',
    '1105.2519': 'was a duplicate of cs/9412102',
    '1105.2536': 'was a duplicate of cs/9610101',
}
