"""link slug added to news.

Revision ID: e21cfb702854
Revises: 51742dea4d0d
Create Date: 2018-08-08 23:50:21.283502

"""

# revision identifiers, used by Alembic.
revision = 'e21cfb702854'
down_revision = '51742dea4d0d'
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa
from sqlalchemy import text
from slugify import slugify

def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('news', sa.Column('slug', sa.String(length=200), nullable=True))

    table_sql = text('SELECT id, title, datetimeon FROM news')
    connection = op.get_bind()
    rows = connection.execute(table_sql)

    slugs = {}
    for row in rows:
        the_id, title, datetimeon = row
        year, month = datetimeon.year, datetimeon.month

        the_slug_start = f'{year}/{month}/'
        max_length = 200 - len(the_slug_start)
        the_slug = the_slug_start + slugify(title, max_length=max_length)
        if the_slug in slugs:
            the_slug = the_slug_start + slugify(f'{title}-{the_id}', max_length=max_length)
        slugs[the_slug] = the_id

        sql = """UPDATE news SET slug='%s' WHERE id=%s """ % (the_slug, the_id)
        op.execute(sql)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('news', 'slug')
    # ### end Alembic commands ###
