import sys, os, glob
import pandas as pd, numpy as np
import ujson
import datetime
from ast import literal_eval
from get_workflow_info import get_workflow_info, translate_non_alphanumerics, get_short_slug

aggfile_in  = 'wildwatch-kenya-classifications_aggregated_wfid2030_v321.78.csv'
aggfile_out = 'wildwatch-kenya-classifications_aggregated_wfid2030_v321.78_speciesfrac.csv'

workflow_file  = 'wildwatch-kenya-workflows.csv'
workflow_cfile = 'wildwatch-kenya-workflow_contents.csv'

workflow_id = 2030
workflow_version = "321.78"

workflow_df  = pd.read_csv(workflow_file)
workflow_cdf = pd.read_csv(workflow_cfile)
workflow_info = get_workflow_info(workflow_df, workflow_cdf, workflow_id, workflow_version)

aggregations = pd.read_csv(aggfile_in)




# aggregations.columns
# ['subject_ids',
#  'class_count',
#  't3_aardvark_are_there_any_young_present_count',
#  't3_aardvark_arethereanyyoungpresent_a0_yes_count',
#  't3_aardvark_arethereanyyoungpresent_a1_no_count',
#  't3_aardvark_count',
#  't3_aardvark_how_many_count',
#  't3_aardvark_howmany_a0_1_count',
#  't3_aardvark_howmany_a10_1150_count',
#  't3_aardvark_howmany_a11_51_count',
#  't3_aardvark_howmany_a1_2_count',
#  't3_aardvark_howmany_a2_3_count',
#  't3_aardvark_howmany_a3_4_count',
#  't3_aardvark_howmany_a4_5_count',
#  't3_aardvark_howmany_a6_7_count',
#  't3_aardvark_whatbehaviorsdoyousee_a0_resting_count',
#  't3_aardvark_whatbehaviorsdoyousee_a1_standing_count',
#  't3_aardvark_whatbehaviorsdoyousee_a2_moving_count',
#  't3_aardvark_whatbehaviorsdoyousee_a3_eating_count',
#  't3_aardvark_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_baboon_are_there_any_young_present_count',
#  't3_baboon_arethereanyyoungpresent_a0_yes_count',
#  't3_baboon_arethereanyyoungpresent_a1_no_count',
#  't3_baboon_count',
#  't3_baboon_how_many_count',
#  't3_baboon_howmany_a0_1_count',
#  't3_baboon_howmany_a10_1150_count',
#  't3_baboon_howmany_a11_51_count',
#  't3_baboon_howmany_a1_2_count',
#  't3_baboon_howmany_a2_3_count',
#  't3_baboon_howmany_a3_4_count',
#  't3_baboon_howmany_a4_5_count',
#  't3_baboon_howmany_a5_6_count',
#  't3_baboon_howmany_a6_7_count',
#  't3_baboon_howmany_a7_8_count',
#  't3_baboon_howmany_a8_9_count',
#  't3_baboon_howmany_a9_10_count',
#  't3_baboon_whatbehaviorsdoyousee_a0_resting_count',
#  't3_baboon_whatbehaviorsdoyousee_a1_standing_count',
#  't3_baboon_whatbehaviorsdoyousee_a2_moving_count',
#  't3_baboon_whatbehaviorsdoyousee_a3_eating_count',
#  't3_baboon_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_batearedfox_are_there_any_young_present_count',
#  't3_batearedfox_arethereanyyoungpresent_a0_yes_count',
#  't3_batearedfox_arethereanyyoungpresent_a1_no_count',
#  't3_batearedfox_count',
#  't3_batearedfox_how_many_count',
#  't3_batearedfox_howmany_a0_1_count',
#  't3_batearedfox_howmany_a11_51_count',
#  't3_batearedfox_howmany_a1_2_count',
#  't3_batearedfox_howmany_a2_3_count',
#  't3_batearedfox_howmany_a4_5_count',
#  't3_batearedfox_howmany_a5_6_count',
#  't3_batearedfox_howmany_a6_7_count',
#  't3_batearedfox_whatbehaviorsdoyousee_a0_resting_count',
#  't3_batearedfox_whatbehaviorsdoyousee_a1_standing_count',
#  't3_batearedfox_whatbehaviorsdoyousee_a2_moving_count',
#  't3_batearedfox_whatbehaviorsdoyousee_a3_eating_count',
#  't3_batearedfox_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_birdother_are_there_any_young_present_count',
#  't3_birdother_arethereanyyoungpresent_a0_yes_count',
#  't3_birdother_arethereanyyoungpresent_a1_no_count',
#  't3_birdother_count',
#  't3_birdother_how_many_count',
#  't3_birdother_howmany_a0_1_count',
#  't3_birdother_howmany_a10_1150_count',
#  't3_birdother_howmany_a11_51_count',
#  't3_birdother_howmany_a1_2_count',
#  't3_birdother_howmany_a2_3_count',
#  't3_birdother_howmany_a3_4_count',
#  't3_birdother_howmany_a4_5_count',
#  't3_birdother_howmany_a5_6_count',
#  't3_birdother_howmany_a6_7_count',
#  't3_birdother_howmany_a7_8_count',
#  't3_birdother_howmany_a8_9_count',
#  't3_birdother_howmany_a9_10_count',
#  't3_birdother_whatbehaviorsdoyousee_a0_resting_count',
#  't3_birdother_whatbehaviorsdoyousee_a1_standing_count',
#  't3_birdother_whatbehaviorsdoyousee_a2_moving_count',
#  't3_birdother_whatbehaviorsdoyousee_a3_eating_count',
#  't3_birdother_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_buffalo_are_there_any_young_present_count',
#  't3_buffalo_arethereanyyoungpresent_a0_yes_count',
#  't3_buffalo_arethereanyyoungpresent_a1_no_count',
#  't3_buffalo_count',
#  't3_buffalo_how_many_count',
#  't3_buffalo_howmany_a0_1_count',
#  't3_buffalo_howmany_a10_1150_count',
#  't3_buffalo_howmany_a11_51_count',
#  't3_buffalo_howmany_a1_2_count',
#  't3_buffalo_howmany_a2_3_count',
#  't3_buffalo_howmany_a3_4_count',
#  't3_buffalo_howmany_a4_5_count',
#  't3_buffalo_howmany_a5_6_count',
#  't3_buffalo_howmany_a6_7_count',
#  't3_buffalo_howmany_a7_8_count',
#  't3_buffalo_howmany_a8_9_count',
#  't3_buffalo_howmany_a9_10_count',
#  't3_buffalo_whatbehaviorsdoyousee_a0_resting_count',
#  't3_buffalo_whatbehaviorsdoyousee_a1_standing_count',
#  't3_buffalo_whatbehaviorsdoyousee_a2_moving_count',
#  't3_buffalo_whatbehaviorsdoyousee_a3_eating_count',
#  't3_buffalo_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_bushbuck_are_there_any_young_present_count',
#  't3_bushbuck_arethereanyyoungpresent_a0_yes_count',
#  't3_bushbuck_arethereanyyoungpresent_a1_no_count',
#  't3_bushbuck_count',
#  't3_bushbuck_how_many_count',
#  't3_bushbuck_howmany_a0_1_count',
#  't3_bushbuck_howmany_a10_1150_count',
#  't3_bushbuck_howmany_a11_51_count',
#  't3_bushbuck_howmany_a1_2_count',
#  't3_bushbuck_howmany_a2_3_count',
#  't3_bushbuck_howmany_a3_4_count',
#  't3_bushbuck_howmany_a4_5_count',
#  't3_bushbuck_howmany_a5_6_count',
#  't3_bushbuck_howmany_a7_8_count',
#  't3_bushbuck_howmany_a8_9_count',
#  't3_bushbuck_howmany_a9_10_count',
#  't3_bushbuck_whatbehaviorsdoyousee_a0_resting_count',
#  't3_bushbuck_whatbehaviorsdoyousee_a1_standing_count',
#  't3_bushbuck_whatbehaviorsdoyousee_a2_moving_count',
#  't3_bushbuck_whatbehaviorsdoyousee_a3_eating_count',
#  't3_bushbuck_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_caracal_are_there_any_young_present_count',
#  't3_caracal_arethereanyyoungpresent_a0_yes_count',
#  't3_caracal_arethereanyyoungpresent_a1_no_count',
#  't3_caracal_count',
#  't3_caracal_how_many_count',
#  't3_caracal_howmany_a0_1_count',
#  't3_caracal_howmany_a1_2_count',
#  't3_caracal_howmany_a3_4_count',
#  't3_caracal_howmany_a4_5_count',
#  't3_caracal_howmany_a5_6_count',
#  't3_caracal_howmany_a6_7_count',
#  't3_caracal_whatbehaviorsdoyousee_a0_resting_count',
#  't3_caracal_whatbehaviorsdoyousee_a1_standing_count',
#  't3_caracal_whatbehaviorsdoyousee_a2_moving_count',
#  't3_caracal_whatbehaviorsdoyousee_a3_eating_count',
#  't3_caracal_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_cheetah_are_there_any_young_present_count',
#  't3_cheetah_arethereanyyoungpresent_a0_yes_count',
#  't3_cheetah_arethereanyyoungpresent_a1_no_count',
#  't3_cheetah_count',
#  't3_cheetah_how_many_count',
#  't3_cheetah_howmany_a0_1_count',
#  't3_cheetah_howmany_a11_51_count',
#  't3_cheetah_howmany_a1_2_count',
#  't3_cheetah_howmany_a2_3_count',
#  't3_cheetah_howmany_a3_4_count',
#  't3_cheetah_howmany_a4_5_count',
#  't3_cheetah_whatbehaviorsdoyousee_a0_resting_count',
#  't3_cheetah_whatbehaviorsdoyousee_a1_standing_count',
#  't3_cheetah_whatbehaviorsdoyousee_a2_moving_count',
#  't3_cheetah_whatbehaviorsdoyousee_a3_eating_count',
#  't3_cheetah_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_civet_are_there_any_young_present_count',
#  't3_civet_arethereanyyoungpresent_a0_yes_count',
#  't3_civet_arethereanyyoungpresent_a1_no_count',
#  't3_civet_count',
#  't3_civet_how_many_count',
#  't3_civet_howmany_a0_1_count',
#  't3_civet_howmany_a10_1150_count',
#  't3_civet_howmany_a11_51_count',
#  't3_civet_howmany_a1_2_count',
#  't3_civet_howmany_a2_3_count',
#  't3_civet_howmany_a3_4_count',
#  't3_civet_howmany_a4_5_count',
#  't3_civet_howmany_a7_8_count',
#  't3_civet_whatbehaviorsdoyousee_a0_resting_count',
#  't3_civet_whatbehaviorsdoyousee_a1_standing_count',
#  't3_civet_whatbehaviorsdoyousee_a2_moving_count',
#  't3_civet_whatbehaviorsdoyousee_a3_eating_count',
#  't3_civet_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_crane_are_there_any_young_present_count',
#  't3_crane_arethereanyyoungpresent_a0_yes_count',
#  't3_crane_arethereanyyoungpresent_a1_no_count',
#  't3_crane_count',
#  't3_crane_how_many_count',
#  't3_crane_howmany_a0_1_count',
#  't3_crane_howmany_a10_1150_count',
#  't3_crane_howmany_a1_2_count',
#  't3_crane_howmany_a2_3_count',
#  't3_crane_howmany_a3_4_count',
#  't3_crane_howmany_a4_5_count',
#  't3_crane_howmany_a5_6_count',
#  't3_crane_howmany_a7_8_count',
#  't3_crane_howmany_a8_9_count',
#  't3_crane_howmany_a9_10_count',
#  't3_crane_whatbehaviorsdoyousee_a0_resting_count',
#  't3_crane_whatbehaviorsdoyousee_a1_standing_count',
#  't3_crane_whatbehaviorsdoyousee_a2_moving_count',
#  't3_crane_whatbehaviorsdoyousee_a3_eating_count',
#  't3_crane_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_dikdik_are_there_any_young_present_count',
#  't3_dikdik_arethereanyyoungpresent_a0_yes_count',
#  't3_dikdik_arethereanyyoungpresent_a1_no_count',
#  't3_dikdik_count',
#  't3_dikdik_how_many_count',
#  't3_dikdik_howmany_a0_1_count',
#  't3_dikdik_howmany_a10_1150_count',
#  't3_dikdik_howmany_a11_51_count',
#  't3_dikdik_howmany_a1_2_count',
#  't3_dikdik_howmany_a2_3_count',
#  't3_dikdik_howmany_a3_4_count',
#  't3_dikdik_howmany_a4_5_count',
#  't3_dikdik_howmany_a5_6_count',
#  't3_dikdik_howmany_a6_7_count',
#  't3_dikdik_howmany_a7_8_count',
#  't3_dikdik_howmany_a8_9_count',
#  't3_dikdik_howmany_a9_10_count',
#  't3_dikdik_whatbehaviorsdoyousee_a0_resting_count',
#  't3_dikdik_whatbehaviorsdoyousee_a1_standing_count',
#  't3_dikdik_whatbehaviorsdoyousee_a2_moving_count',
#  't3_dikdik_whatbehaviorsdoyousee_a3_eating_count',
#  't3_dikdik_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_duiker_are_there_any_young_present_count',
#  't3_duiker_arethereanyyoungpresent_a0_yes_count',
#  't3_duiker_arethereanyyoungpresent_a1_no_count',
#  't3_duiker_count',
#  't3_duiker_how_many_count',
#  't3_duiker_howmany_a0_1_count',
#  't3_duiker_howmany_a10_1150_count',
#  't3_duiker_howmany_a1_2_count',
#  't3_duiker_howmany_a2_3_count',
#  't3_duiker_howmany_a3_4_count',
#  't3_duiker_howmany_a4_5_count',
#  't3_duiker_howmany_a5_6_count',
#  't3_duiker_howmany_a7_8_count',
#  't3_duiker_whatbehaviorsdoyousee_a0_resting_count',
#  't3_duiker_whatbehaviorsdoyousee_a1_standing_count',
#  't3_duiker_whatbehaviorsdoyousee_a2_moving_count',
#  't3_duiker_whatbehaviorsdoyousee_a3_eating_count',
#  't3_duiker_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_eland_are_there_any_young_present_count',
#  't3_eland_arethereanyyoungpresent_a0_yes_count',
#  't3_eland_arethereanyyoungpresent_a1_no_count',
#  't3_eland_count',
#  't3_eland_how_many_count',
#  't3_eland_howmany_a0_1_count',
#  't3_eland_howmany_a10_1150_count',
#  't3_eland_howmany_a11_51_count',
#  't3_eland_howmany_a1_2_count',
#  't3_eland_howmany_a2_3_count',
#  't3_eland_howmany_a3_4_count',
#  't3_eland_howmany_a4_5_count',
#  't3_eland_howmany_a5_6_count',
#  't3_eland_howmany_a6_7_count',
#  't3_eland_howmany_a7_8_count',
#  't3_eland_howmany_a8_9_count',
#  't3_eland_howmany_a9_10_count',
#  't3_eland_whatbehaviorsdoyousee_a0_resting_count',
#  't3_eland_whatbehaviorsdoyousee_a1_standing_count',
#  't3_eland_whatbehaviorsdoyousee_a2_moving_count',
#  't3_eland_whatbehaviorsdoyousee_a3_eating_count',
#  't3_eland_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_elephant_are_there_any_young_present_count',
#  't3_elephant_arethereanyyoungpresent_a0_yes_count',
#  't3_elephant_arethereanyyoungpresent_a1_no_count',
#  't3_elephant_count',
#  't3_elephant_how_many_count',
#  't3_elephant_howmany_a0_1_count',
#  't3_elephant_howmany_a10_1150_count',
#  't3_elephant_howmany_a11_51_count',
#  't3_elephant_howmany_a1_2_count',
#  't3_elephant_howmany_a2_3_count',
#  't3_elephant_howmany_a3_4_count',
#  't3_elephant_howmany_a4_5_count',
#  't3_elephant_howmany_a5_6_count',
#  't3_elephant_howmany_a6_7_count',
#  't3_elephant_howmany_a7_8_count',
#  't3_elephant_whatbehaviorsdoyousee_a0_resting_count',
#  't3_elephant_whatbehaviorsdoyousee_a1_standing_count',
#  't3_elephant_whatbehaviorsdoyousee_a2_moving_count',
#  't3_elephant_whatbehaviorsdoyousee_a3_eating_count',
#  't3_elephant_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_gazelle_are_there_any_young_present_count',
#  't3_gazelle_arethereanyyoungpresent_a0_yes_count',
#  't3_gazelle_arethereanyyoungpresent_a1_no_count',
#  't3_gazelle_count',
#  't3_gazelle_how_many_count',
#  't3_gazelle_howmany_a0_1_count',
#  't3_gazelle_howmany_a10_1150_count',
#  't3_gazelle_howmany_a11_51_count',
#  't3_gazelle_howmany_a1_2_count',
#  't3_gazelle_howmany_a2_3_count',
#  't3_gazelle_howmany_a3_4_count',
#  't3_gazelle_howmany_a4_5_count',
#  't3_gazelle_howmany_a5_6_count',
#  't3_gazelle_howmany_a6_7_count',
#  't3_gazelle_howmany_a7_8_count',
#  't3_gazelle_howmany_a8_9_count',
#  't3_gazelle_howmany_a9_10_count',
#  't3_gazelle_whatbehaviorsdoyousee_a0_resting_count',
#  't3_gazelle_whatbehaviorsdoyousee_a1_standing_count',
#  't3_gazelle_whatbehaviorsdoyousee_a2_moving_count',
#  't3_gazelle_whatbehaviorsdoyousee_a3_eating_count',
#  't3_gazelle_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_genet_are_there_any_young_present_count',
#  't3_genet_arethereanyyoungpresent_a0_yes_count',
#  't3_genet_arethereanyyoungpresent_a1_no_count',
#  't3_genet_count',
#  't3_genet_how_many_count',
#  't3_genet_howmany_a0_1_count',
#  't3_genet_howmany_a11_51_count',
#  't3_genet_howmany_a1_2_count',
#  't3_genet_howmany_a2_3_count',
#  't3_genet_howmany_a5_6_count',
#  't3_genet_howmany_a8_9_count',
#  't3_genet_whatbehaviorsdoyousee_a0_resting_count',
#  't3_genet_whatbehaviorsdoyousee_a1_standing_count',
#  't3_genet_whatbehaviorsdoyousee_a2_moving_count',
#  't3_genet_whatbehaviorsdoyousee_a3_eating_count',
#  't3_genet_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_gerenuk_are_there_any_young_present_count',
#  't3_gerenuk_arethereanyyoungpresent_a0_yes_count',
#  't3_gerenuk_arethereanyyoungpresent_a1_no_count',
#  't3_gerenuk_count',
#  't3_gerenuk_how_many_count',
#  't3_gerenuk_howmany_a0_1_count',
#  't3_gerenuk_howmany_a10_1150_count',
#  't3_gerenuk_howmany_a1_2_count',
#  't3_gerenuk_howmany_a2_3_count',
#  't3_gerenuk_howmany_a3_4_count',
#  't3_gerenuk_howmany_a4_5_count',
#  't3_gerenuk_howmany_a5_6_count',
#  't3_gerenuk_howmany_a6_7_count',
#  't3_gerenuk_howmany_a7_8_count',
#  't3_gerenuk_howmany_a8_9_count',
#  't3_gerenuk_howmany_a9_10_count',
#  't3_gerenuk_whatbehaviorsdoyousee_a0_resting_count',
#  't3_gerenuk_whatbehaviorsdoyousee_a1_standing_count',
#  't3_gerenuk_whatbehaviorsdoyousee_a2_moving_count',
#  't3_gerenuk_whatbehaviorsdoyousee_a3_eating_count',
#  't3_gerenuk_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_giraffe_are_there_any_young_present_count',
#  't3_giraffe_arethereanyyoungpresent_a0_yes_count',
#  't3_giraffe_arethereanyyoungpresent_a1_no_count',
#  't3_giraffe_count',
#  't3_giraffe_how_many_count',
#  't3_giraffe_howmany_a0_1_count',
#  't3_giraffe_howmany_a10_1150_count',
#  't3_giraffe_howmany_a11_51_count',
#  't3_giraffe_howmany_a1_2_count',
#  't3_giraffe_howmany_a2_3_count',
#  't3_giraffe_howmany_a3_4_count',
#  't3_giraffe_howmany_a4_5_count',
#  't3_giraffe_howmany_a5_6_count',
#  't3_giraffe_howmany_a6_7_count',
#  't3_giraffe_howmany_a7_8_count',
#  't3_giraffe_howmany_a8_9_count',
#  't3_giraffe_howmany_a9_10_count',
#  't3_giraffe_whatbehaviorsdoyousee_a0_resting_count',
#  't3_giraffe_whatbehaviorsdoyousee_a1_standing_count',
#  't3_giraffe_whatbehaviorsdoyousee_a2_moving_count',
#  't3_giraffe_whatbehaviorsdoyousee_a3_eating_count',
#  't3_giraffe_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_groundsquirrel_are_there_any_young_present_count',
#  't3_groundsquirrel_arethereanyyoungpresent_a0_yes_count',
#  't3_groundsquirrel_arethereanyyoungpresent_a1_no_count',
#  't3_groundsquirrel_count',
#  't3_groundsquirrel_how_many_count',
#  't3_groundsquirrel_howmany_a0_1_count',
#  't3_groundsquirrel_howmany_a10_1150_count',
#  't3_groundsquirrel_howmany_a11_51_count',
#  't3_groundsquirrel_howmany_a1_2_count',
#  't3_groundsquirrel_howmany_a2_3_count',
#  't3_groundsquirrel_howmany_a3_4_count',
#  't3_groundsquirrel_howmany_a4_5_count',
#  't3_groundsquirrel_howmany_a5_6_count',
#  't3_groundsquirrel_howmany_a6_7_count',
#  't3_groundsquirrel_howmany_a9_10_count',
#  't3_groundsquirrel_whatbehaviorsdoyousee_a0_resting_count',
#  't3_groundsquirrel_whatbehaviorsdoyousee_a1_standing_count',
#  't3_groundsquirrel_whatbehaviorsdoyousee_a2_moving_count',
#  't3_groundsquirrel_whatbehaviorsdoyousee_a3_eating_count',
#  't3_groundsquirrel_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_guineafowl_are_there_any_young_present_count',
#  't3_guineafowl_arethereanyyoungpresent_a0_yes_count',
#  't3_guineafowl_arethereanyyoungpresent_a1_no_count',
#  't3_guineafowl_count',
#  't3_guineafowl_how_many_count',
#  't3_guineafowl_howmany_a0_1_count',
#  't3_guineafowl_howmany_a10_1150_count',
#  't3_guineafowl_howmany_a11_51_count',
#  't3_guineafowl_howmany_a1_2_count',
#  't3_guineafowl_howmany_a2_3_count',
#  't3_guineafowl_howmany_a3_4_count',
#  't3_guineafowl_howmany_a4_5_count',
#  't3_guineafowl_howmany_a5_6_count',
#  't3_guineafowl_howmany_a6_7_count',
#  't3_guineafowl_howmany_a7_8_count',
#  't3_guineafowl_howmany_a8_9_count',
#  't3_guineafowl_howmany_a9_10_count',
#  't3_guineafowl_whatbehaviorsdoyousee_a0_resting_count',
#  't3_guineafowl_whatbehaviorsdoyousee_a1_standing_count',
#  't3_guineafowl_whatbehaviorsdoyousee_a2_moving_count',
#  't3_guineafowl_whatbehaviorsdoyousee_a3_eating_count',
#  't3_guineafowl_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_hare_are_there_any_young_present_count',
#  't3_hare_arethereanyyoungpresent_a0_yes_count',
#  't3_hare_arethereanyyoungpresent_a1_no_count',
#  't3_hare_count',
#  't3_hare_how_many_count',
#  't3_hare_howmany_a0_1_count',
#  't3_hare_howmany_a10_1150_count',
#  't3_hare_howmany_a1_2_count',
#  't3_hare_howmany_a2_3_count',
#  't3_hare_howmany_a5_6_count',
#  't3_hare_howmany_a8_9_count',
#  't3_hare_howmany_a9_10_count',
#  't3_hare_whatbehaviorsdoyousee_a0_resting_count',
#  't3_hare_whatbehaviorsdoyousee_a1_standing_count',
#  't3_hare_whatbehaviorsdoyousee_a2_moving_count',
#  't3_hare_whatbehaviorsdoyousee_a3_eating_count',
#  't3_hare_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_hartebeest_are_there_any_young_present_count',
#  't3_hartebeest_arethereanyyoungpresent_a0_yes_count',
#  't3_hartebeest_arethereanyyoungpresent_a1_no_count',
#  't3_hartebeest_count',
#  't3_hartebeest_how_many_count',
#  't3_hartebeest_howmany_a0_1_count',
#  't3_hartebeest_howmany_a10_1150_count',
#  't3_hartebeest_howmany_a11_51_count',
#  't3_hartebeest_howmany_a1_2_count',
#  't3_hartebeest_howmany_a2_3_count',
#  't3_hartebeest_howmany_a3_4_count',
#  't3_hartebeest_howmany_a4_5_count',
#  't3_hartebeest_howmany_a5_6_count',
#  't3_hartebeest_howmany_a6_7_count',
#  't3_hartebeest_howmany_a7_8_count',
#  't3_hartebeest_howmany_a8_9_count',
#  't3_hartebeest_howmany_a9_10_count',
#  't3_hartebeest_whatbehaviorsdoyousee_a0_resting_count',
#  't3_hartebeest_whatbehaviorsdoyousee_a1_standing_count',
#  't3_hartebeest_whatbehaviorsdoyousee_a2_moving_count',
#  't3_hartebeest_whatbehaviorsdoyousee_a3_eating_count',
#  't3_hartebeest_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_hippopotamus_are_there_any_young_present_count',
#  't3_hippopotamus_arethereanyyoungpresent_a0_yes_count',
#  't3_hippopotamus_arethereanyyoungpresent_a1_no_count',
#  't3_hippopotamus_count',
#  't3_hippopotamus_how_many_count',
#  't3_hippopotamus_howmany_a0_1_count',
#  't3_hippopotamus_howmany_a11_51_count',
#  't3_hippopotamus_howmany_a1_2_count',
#  't3_hippopotamus_howmany_a2_3_count',
#  't3_hippopotamus_howmany_a3_4_count',
#  't3_hippopotamus_howmany_a4_5_count',
#  't3_hippopotamus_whatbehaviorsdoyousee_a0_resting_count',
#  't3_hippopotamus_whatbehaviorsdoyousee_a1_standing_count',
#  't3_hippopotamus_whatbehaviorsdoyousee_a2_moving_count',
#  't3_hippopotamus_whatbehaviorsdoyousee_a3_eating_count',
#  't3_hippopotamus_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_honeybadger_are_there_any_young_present_count',
#  't3_honeybadger_arethereanyyoungpresent_a0_yes_count',
#  't3_honeybadger_arethereanyyoungpresent_a1_no_count',
#  't3_honeybadger_count',
#  't3_honeybadger_how_many_count',
#  't3_honeybadger_howmany_a0_1_count',
#  't3_honeybadger_howmany_a11_51_count',
#  't3_honeybadger_howmany_a1_2_count',
#  't3_honeybadger_howmany_a2_3_count',
#  't3_honeybadger_howmany_a3_4_count',
#  't3_honeybadger_howmany_a4_5_count',
#  't3_honeybadger_howmany_a6_7_count',
#  't3_honeybadger_whatbehaviorsdoyousee_a0_resting_count',
#  't3_honeybadger_whatbehaviorsdoyousee_a1_standing_count',
#  't3_honeybadger_whatbehaviorsdoyousee_a2_moving_count',
#  't3_honeybadger_whatbehaviorsdoyousee_a3_eating_count',
#  't3_honeybadger_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_humanvehicle_are_there_any_young_present_count',
#  't3_humanvehicle_arethereanyyoungpresent_a0_yes_count',
#  't3_humanvehicle_arethereanyyoungpresent_a1_no_count',
#  't3_humanvehicle_count',
#  't3_humanvehicle_how_many_count',
#  't3_humanvehicle_howmany_a0_1_count',
#  't3_humanvehicle_howmany_a10_1150_count',
#  't3_humanvehicle_howmany_a11_51_count',
#  't3_humanvehicle_howmany_a1_2_count',
#  't3_humanvehicle_howmany_a2_3_count',
#  't3_humanvehicle_howmany_a3_4_count',
#  't3_humanvehicle_howmany_a4_5_count',
#  't3_humanvehicle_howmany_a5_6_count',
#  't3_humanvehicle_howmany_a6_7_count',
#  't3_humanvehicle_howmany_a7_8_count',
#  't3_humanvehicle_howmany_a8_9_count',
#  't3_humanvehicle_howmany_a9_10_count',
#  't3_humanvehicle_whatbehaviorsdoyousee_a0_resting_count',
#  't3_humanvehicle_whatbehaviorsdoyousee_a1_standing_count',
#  't3_humanvehicle_whatbehaviorsdoyousee_a2_moving_count',
#  't3_humanvehicle_whatbehaviorsdoyousee_a3_eating_count',
#  't3_humanvehicle_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_hyena_are_there_any_young_present_count',
#  't3_hyena_arethereanyyoungpresent_a0_yes_count',
#  't3_hyena_arethereanyyoungpresent_a1_no_count',
#  't3_hyena_count',
#  't3_hyena_how_many_count',
#  't3_hyena_howmany_a0_1_count',
#  't3_hyena_howmany_a10_1150_count',
#  't3_hyena_howmany_a1_2_count',
#  't3_hyena_howmany_a2_3_count',
#  't3_hyena_howmany_a3_4_count',
#  't3_hyena_howmany_a4_5_count',
#  't3_hyena_howmany_a5_6_count',
#  't3_hyena_howmany_a6_7_count',
#  't3_hyena_howmany_a8_9_count',
#  't3_hyena_whatbehaviorsdoyousee_a0_resting_count',
#  't3_hyena_whatbehaviorsdoyousee_a1_standing_count',
#  't3_hyena_whatbehaviorsdoyousee_a2_moving_count',
#  't3_hyena_whatbehaviorsdoyousee_a3_eating_count',
#  't3_hyena_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_impala_are_there_any_young_present_count',
#  't3_impala_arethereanyyoungpresent_a0_yes_count',
#  't3_impala_arethereanyyoungpresent_a1_no_count',
#  't3_impala_count',
#  't3_impala_how_many_count',
#  't3_impala_howmany_a0_1_count',
#  't3_impala_howmany_a10_1150_count',
#  't3_impala_howmany_a11_51_count',
#  't3_impala_howmany_a1_2_count',
#  't3_impala_howmany_a2_3_count',
#  't3_impala_howmany_a3_4_count',
#  't3_impala_howmany_a4_5_count',
#  't3_impala_howmany_a5_6_count',
#  't3_impala_howmany_a6_7_count',
#  't3_impala_howmany_a7_8_count',
#  't3_impala_howmany_a8_9_count',
#  't3_impala_howmany_a9_10_count',
#  't3_impala_whatbehaviorsdoyousee_a0_resting_count',
#  't3_impala_whatbehaviorsdoyousee_a1_standing_count',
#  't3_impala_whatbehaviorsdoyousee_a2_moving_count',
#  't3_impala_whatbehaviorsdoyousee_a3_eating_count',
#  't3_impala_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_jackal_are_there_any_young_present_count',
#  't3_jackal_arethereanyyoungpresent_a0_yes_count',
#  't3_jackal_arethereanyyoungpresent_a1_no_count',
#  't3_jackal_count',
#  't3_jackal_how_many_count',
#  't3_jackal_howmany_a0_1_count',
#  't3_jackal_howmany_a11_51_count',
#  't3_jackal_howmany_a1_2_count',
#  't3_jackal_howmany_a3_4_count',
#  't3_jackal_howmany_a4_5_count',
#  't3_jackal_whatbehaviorsdoyousee_a0_resting_count',
#  't3_jackal_whatbehaviorsdoyousee_a1_standing_count',
#  't3_jackal_whatbehaviorsdoyousee_a2_moving_count',
#  't3_jackal_whatbehaviorsdoyousee_a3_eating_count',
#  't3_jackal_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_koribustard_are_there_any_young_present_count',
#  't3_koribustard_arethereanyyoungpresent_a0_yes_count',
#  't3_koribustard_arethereanyyoungpresent_a1_no_count',
#  't3_koribustard_count',
#  't3_koribustard_how_many_count',
#  't3_koribustard_howmany_a0_1_count',
#  't3_koribustard_howmany_a10_1150_count',
#  't3_koribustard_howmany_a11_51_count',
#  't3_koribustard_howmany_a1_2_count',
#  't3_koribustard_howmany_a2_3_count',
#  't3_koribustard_howmany_a3_4_count',
#  't3_koribustard_howmany_a4_5_count',
#  't3_koribustard_howmany_a5_6_count',
#  't3_koribustard_howmany_a6_7_count',
#  't3_koribustard_howmany_a7_8_count',
#  't3_koribustard_howmany_a8_9_count',
#  't3_koribustard_howmany_a9_10_count',
#  't3_koribustard_whatbehaviorsdoyousee_a0_resting_count',
#  't3_koribustard_whatbehaviorsdoyousee_a1_standing_count',
#  't3_koribustard_whatbehaviorsdoyousee_a2_moving_count',
#  't3_koribustard_whatbehaviorsdoyousee_a3_eating_count',
#  't3_koribustard_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_kudu_are_there_any_young_present_count',
#  't3_kudu_arethereanyyoungpresent_a0_yes_count',
#  't3_kudu_arethereanyyoungpresent_a1_no_count',
#  't3_kudu_count',
#  't3_kudu_how_many_count',
#  't3_kudu_howmany_a0_1_count',
#  't3_kudu_howmany_a10_1150_count',
#  't3_kudu_howmany_a1_2_count',
#  't3_kudu_howmany_a2_3_count',
#  't3_kudu_howmany_a3_4_count',
#  't3_kudu_howmany_a4_5_count',
#  't3_kudu_howmany_a5_6_count',
#  't3_kudu_howmany_a6_7_count',
#  't3_kudu_howmany_a7_8_count',
#  't3_kudu_howmany_a8_9_count',
#  't3_kudu_howmany_a9_10_count',
#  't3_kudu_whatbehaviorsdoyousee_a0_resting_count',
#  't3_kudu_whatbehaviorsdoyousee_a1_standing_count',
#  't3_kudu_whatbehaviorsdoyousee_a2_moving_count',
#  't3_kudu_whatbehaviorsdoyousee_a3_eating_count',
#  't3_kudu_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_leopard_are_there_any_young_present_count',
#  't3_leopard_arethereanyyoungpresent_a0_yes_count',
#  't3_leopard_arethereanyyoungpresent_a1_no_count',
#  't3_leopard_count',
#  't3_leopard_how_many_count',
#  't3_leopard_howmany_a0_1_count',
#  't3_leopard_howmany_a10_1150_count',
#  't3_leopard_howmany_a11_51_count',
#  't3_leopard_howmany_a1_2_count',
#  't3_leopard_howmany_a2_3_count',
#  't3_leopard_howmany_a5_6_count',
#  't3_leopard_whatbehaviorsdoyousee_a0_resting_count',
#  't3_leopard_whatbehaviorsdoyousee_a1_standing_count',
#  't3_leopard_whatbehaviorsdoyousee_a2_moving_count',
#  't3_leopard_whatbehaviorsdoyousee_a3_eating_count',
#  't3_leopard_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_lion_are_there_any_young_present_count',
#  't3_lion_arethereanyyoungpresent_a0_yes_count',
#  't3_lion_arethereanyyoungpresent_a1_no_count',
#  't3_lion_count',
#  't3_lion_how_many_count',
#  't3_lion_howmany_a0_1_count',
#  't3_lion_howmany_a10_1150_count',
#  't3_lion_howmany_a11_51_count',
#  't3_lion_howmany_a1_2_count',
#  't3_lion_howmany_a2_3_count',
#  't3_lion_howmany_a3_4_count',
#  't3_lion_howmany_a4_5_count',
#  't3_lion_howmany_a5_6_count',
#  't3_lion_whatbehaviorsdoyousee_a0_resting_count',
#  't3_lion_whatbehaviorsdoyousee_a1_standing_count',
#  't3_lion_whatbehaviorsdoyousee_a2_moving_count',
#  't3_lion_whatbehaviorsdoyousee_a3_eating_count',
#  't3_lion_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_livestock_are_there_any_young_present_count',
#  't3_livestock_arethereanyyoungpresent_a0_yes_count',
#  't3_livestock_arethereanyyoungpresent_a1_no_count',
#  't3_livestock_count',
#  't3_livestock_how_many_count',
#  't3_livestock_howmany_a0_1_count',
#  't3_livestock_howmany_a10_1150_count',
#  't3_livestock_howmany_a11_51_count',
#  't3_livestock_howmany_a1_2_count',
#  't3_livestock_howmany_a2_3_count',
#  't3_livestock_howmany_a3_4_count',
#  't3_livestock_howmany_a4_5_count',
#  't3_livestock_howmany_a5_6_count',
#  't3_livestock_howmany_a6_7_count',
#  't3_livestock_howmany_a7_8_count',
#  't3_livestock_howmany_a8_9_count',
#  't3_livestock_howmany_a9_10_count',
#  't3_livestock_whatbehaviorsdoyousee_a0_resting_count',
#  't3_livestock_whatbehaviorsdoyousee_a1_standing_count',
#  't3_livestock_whatbehaviorsdoyousee_a2_moving_count',
#  't3_livestock_whatbehaviorsdoyousee_a3_eating_count',
#  't3_livestock_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_oryx_are_there_any_young_present_count',
#  't3_oryx_arethereanyyoungpresent_a0_yes_count',
#  't3_oryx_arethereanyyoungpresent_a1_no_count',
#  't3_oryx_count',
#  't3_oryx_how_many_count',
#  't3_oryx_howmany_a0_1_count',
#  't3_oryx_howmany_a10_1150_count',
#  't3_oryx_howmany_a11_51_count',
#  't3_oryx_howmany_a1_2_count',
#  't3_oryx_howmany_a2_3_count',
#  't3_oryx_howmany_a3_4_count',
#  't3_oryx_howmany_a4_5_count',
#  't3_oryx_howmany_a5_6_count',
#  't3_oryx_howmany_a6_7_count',
#  't3_oryx_howmany_a7_8_count',
#  't3_oryx_howmany_a8_9_count',
#  't3_oryx_howmany_a9_10_count',
#  't3_oryx_whatbehaviorsdoyousee_a0_resting_count',
#  't3_oryx_whatbehaviorsdoyousee_a1_standing_count',
#  't3_oryx_whatbehaviorsdoyousee_a2_moving_count',
#  't3_oryx_whatbehaviorsdoyousee_a3_eating_count',
#  't3_oryx_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_porcupine_are_there_any_young_present_count',
#  't3_porcupine_arethereanyyoungpresent_a0_yes_count',
#  't3_porcupine_arethereanyyoungpresent_a1_no_count',
#  't3_porcupine_count',
#  't3_porcupine_how_many_count',
#  't3_porcupine_howmany_a0_1_count',
#  't3_porcupine_howmany_a11_51_count',
#  't3_porcupine_howmany_a1_2_count',
#  't3_porcupine_howmany_a6_7_count',
#  't3_porcupine_howmany_a7_8_count',
#  't3_porcupine_howmany_a8_9_count',
#  't3_porcupine_howmany_a9_10_count',
#  't3_porcupine_whatbehaviorsdoyousee_a0_resting_count',
#  't3_porcupine_whatbehaviorsdoyousee_a1_standing_count',
#  't3_porcupine_whatbehaviorsdoyousee_a2_moving_count',
#  't3_porcupine_whatbehaviorsdoyousee_a3_eating_count',
#  't3_porcupine_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_serval_are_there_any_young_present_count',
#  't3_serval_arethereanyyoungpresent_a0_yes_count',
#  't3_serval_arethereanyyoungpresent_a1_no_count',
#  't3_serval_count',
#  't3_serval_how_many_count',
#  't3_serval_howmany_a0_1_count',
#  't3_serval_howmany_a11_51_count',
#  't3_serval_howmany_a1_2_count',
#  't3_serval_howmany_a3_4_count',
#  't3_serval_howmany_a4_5_count',
#  't3_serval_howmany_a5_6_count',
#  't3_serval_whatbehaviorsdoyousee_a0_resting_count',
#  't3_serval_whatbehaviorsdoyousee_a1_standing_count',
#  't3_serval_whatbehaviorsdoyousee_a2_moving_count',
#  't3_serval_whatbehaviorsdoyousee_a3_eating_count',
#  't3_serval_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_vervetmonkey_are_there_any_young_present_count',
#  't3_vervetmonkey_arethereanyyoungpresent_a0_yes_count',
#  't3_vervetmonkey_arethereanyyoungpresent_a1_no_count',
#  't3_vervetmonkey_count',
#  't3_vervetmonkey_how_many_count',
#  't3_vervetmonkey_howmany_a0_1_count',
#  't3_vervetmonkey_howmany_a10_1150_count',
#  't3_vervetmonkey_howmany_a11_51_count',
#  't3_vervetmonkey_howmany_a1_2_count',
#  't3_vervetmonkey_howmany_a2_3_count',
#  't3_vervetmonkey_howmany_a3_4_count',
#  't3_vervetmonkey_howmany_a4_5_count',
#  't3_vervetmonkey_howmany_a5_6_count',
#  't3_vervetmonkey_howmany_a6_7_count',
#  't3_vervetmonkey_howmany_a7_8_count',
#  't3_vervetmonkey_howmany_a8_9_count',
#  't3_vervetmonkey_howmany_a9_10_count',
#  't3_vervetmonkey_whatbehaviorsdoyousee_a0_resting_count',
#  't3_vervetmonkey_whatbehaviorsdoyousee_a1_standing_count',
#  't3_vervetmonkey_whatbehaviorsdoyousee_a2_moving_count',
#  't3_vervetmonkey_whatbehaviorsdoyousee_a3_eating_count',
#  't3_vervetmonkey_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_warthog_are_there_any_young_present_count',
#  't3_warthog_arethereanyyoungpresent_a0_yes_count',
#  't3_warthog_arethereanyyoungpresent_a1_no_count',
#  't3_warthog_count',
#  't3_warthog_how_many_count',
#  't3_warthog_howmany_a0_1_count',
#  't3_warthog_howmany_a10_1150_count',
#  't3_warthog_howmany_a1_2_count',
#  't3_warthog_howmany_a2_3_count',
#  't3_warthog_howmany_a3_4_count',
#  't3_warthog_howmany_a4_5_count',
#  't3_warthog_howmany_a5_6_count',
#  't3_warthog_howmany_a6_7_count',
#  't3_warthog_howmany_a7_8_count',
#  't3_warthog_howmany_a8_9_count',
#  't3_warthog_howmany_a9_10_count',
#  't3_warthog_whatbehaviorsdoyousee_a0_resting_count',
#  't3_warthog_whatbehaviorsdoyousee_a1_standing_count',
#  't3_warthog_whatbehaviorsdoyousee_a2_moving_count',
#  't3_warthog_whatbehaviorsdoyousee_a3_eating_count',
#  't3_warthog_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_waterbuck_are_there_any_young_present_count',
#  't3_waterbuck_arethereanyyoungpresent_a0_yes_count',
#  't3_waterbuck_arethereanyyoungpresent_a1_no_count',
#  't3_waterbuck_count',
#  't3_waterbuck_how_many_count',
#  't3_waterbuck_howmany_a0_1_count',
#  't3_waterbuck_howmany_a10_1150_count',
#  't3_waterbuck_howmany_a11_51_count',
#  't3_waterbuck_howmany_a1_2_count',
#  't3_waterbuck_howmany_a2_3_count',
#  't3_waterbuck_howmany_a3_4_count',
#  't3_waterbuck_howmany_a4_5_count',
#  't3_waterbuck_howmany_a5_6_count',
#  't3_waterbuck_howmany_a6_7_count',
#  't3_waterbuck_howmany_a7_8_count',
#  't3_waterbuck_howmany_a9_10_count',
#  't3_waterbuck_whatbehaviorsdoyousee_a0_resting_count',
#  't3_waterbuck_whatbehaviorsdoyousee_a1_standing_count',
#  't3_waterbuck_whatbehaviorsdoyousee_a2_moving_count',
#  't3_waterbuck_whatbehaviorsdoyousee_a3_eating_count',
#  't3_waterbuck_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_wilddog_are_there_any_young_present_count',
#  't3_wilddog_arethereanyyoungpresent_a0_yes_count',
#  't3_wilddog_arethereanyyoungpresent_a1_no_count',
#  't3_wilddog_count',
#  't3_wilddog_how_many_count',
#  't3_wilddog_howmany_a0_1_count',
#  't3_wilddog_howmany_a10_1150_count',
#  't3_wilddog_howmany_a11_51_count',
#  't3_wilddog_howmany_a1_2_count',
#  't3_wilddog_howmany_a2_3_count',
#  't3_wilddog_howmany_a3_4_count',
#  't3_wilddog_howmany_a5_6_count',
#  't3_wilddog_howmany_a7_8_count',
#  't3_wilddog_howmany_a9_10_count',
#  't3_wilddog_whatbehaviorsdoyousee_a0_resting_count',
#  't3_wilddog_whatbehaviorsdoyousee_a1_standing_count',
#  't3_wilddog_whatbehaviorsdoyousee_a2_moving_count',
#  't3_wilddog_whatbehaviorsdoyousee_a3_eating_count',
#  't3_wilddog_whatbehaviorsdoyousee_a4_interacting_count',
#  't3_zebra_are_there_any_young_present_count',
#  't3_zebra_arethereanyyoungpresent_a0_yes_count',
#  't3_zebra_arethereanyyoungpresent_a1_no_count',
#  't3_zebra_count',
#  't3_zebra_how_many_count',
#  't3_zebra_howmany_a0_1_count',
#  't3_zebra_howmany_a10_1150_count',
#  't3_zebra_howmany_a11_51_count',
#  't3_zebra_howmany_a1_2_count',
#  't3_zebra_howmany_a2_3_count',
#  't3_zebra_howmany_a3_4_count',
#  't3_zebra_howmany_a4_5_count',
#  't3_zebra_howmany_a5_6_count',
#  't3_zebra_howmany_a6_7_count',
#  't3_zebra_howmany_a7_8_count',
#  't3_zebra_howmany_a9_10_count',
#  't3_zebra_whatbehaviorsdoyousee_a0_resting_count',
#  't3_zebra_whatbehaviorsdoyousee_a1_standing_count',
#  't3_zebra_whatbehaviorsdoyousee_a2_moving_count',
#  't3_zebra_whatbehaviorsdoyousee_a3_eating_count',
#  't3_zebra_whatbehaviorsdoyousee_a4_interacting_count',
#  't5_a0_nothing_here_count',
#  't5_a0_nothing_here_frac']



cols_basic = ['subject_ids', 'class_count', 't5_a0_nothing_here_count', 't5_a0_nothing_here_frac']

all_species = [q.lower() for q in workflow_info['T3']['choicesOrder']]

# make count, frac pairs list, in order
all_species_cols = []

for thespecies in all_species:
    thecount = "t3_%s_count" % thespecies
    thefrac  = "t3_%s_frac"  % thespecies
    all_species_cols.extend([thecount, thefrac])

    aggregations[thefrac] = aggregations[thecount].astype(float)/aggregations['class_count'].astype(float)




print_cols = cols_basic + all_species_cols

aggregations[print_cols].to_csv(aggfile_out)





#blah
