# -*- encoding: utf-8
# yapf: disable


checkname = 'mongodb_collections'


info = [[u'admin', u'system.version', u'avgObjSize', u'59'],
        [u'admin', u'system.version', u'totalIndexSize', u'16384'],
        [u'admin', u'system.version', u'storageSize', u'16384'],
        [u'admin', u'system.version', u'indexSizes', u"{u'_id_': 16384}"],
        [u'admin', u'system.version', u'size', u'59'],
        [u'local', u'startup_log', u'avgObjSize', u'1948'],
        [u'local', u'startup_log', u'indexSizes', u"{u'_id_': 36864}"],
        [u'local', u'startup_log', u'totalIndexSize', u'36864'],
        [u'local', u'startup_log', u'maxSize', u'10485760'],
        [u'local', u'startup_log', u'storageSize', u'36864'],
        [u'local', u'startup_log', u'size', u'5844'],
        [u'test', u'zips', u'avgObjSize', u'94'],
        [u'test', u'zips', u'totalIndexSize', u'315392'],
        [u'test', u'zips', u'storageSize', u'1462272'],
        [u'test', u'zips', u'indexSizes', u"{u'_id_': 315392}"],
        [u'test', u'zips', u'size', u'2774134'],
        [u'config', u'system.sessions', u'ns', u'config.system.sessions'],
        [u'config', u'system.sessions', u'ok', u'1.0'],
        [u'config', u'system.sessions', u'avgObjSize', u'99'],
        [u'config', u'system.sessions', u'totalIndexSize', u'49152'],
        [u'config', u'system.sessions', u'storageSize', u'24576'],
        [u'config',
         u'system.sessions',
         u'indexSizes',
         u"{u'_id_': 24576, u'lsidTTLIndex': 24576}"],
        [u'config', u'system.sessions', u'size', u'594']]


discovery = {'': [(u'admin system.version', {}),
                  (u'config system.sessions', {}),
                  (u'local startup_log', {}),
                  (u'test zips', {})]}


checks = {'': [(u'admin system.version',
                {},
                [(0,
                  'Uncompressed size in memory: 59.00 B',
                  [('mongodb_collection_size', 59, None, None, None, None)]),
                 (0,
                  'Allocated for document storage: 16.00 kB',
                  [('mongodb_collection_storage_size',
                    16384,
                    None,
                    None,
                    None,
                    None)]),
                 (0,
                  '\nCollection\n- Document Count: 0 (Number of documents in collection)\n- Object Size 59.00 B (Average object size)\n- Collection Size: 59.00 B (Uncompressed size in memory)\n- Storage Size: 16.00 kB (Allocated for document storage)',
                  [])]),
               (u'config system.sessions',
                {},
                [(0,
                  'Uncompressed size in memory: 594.00 B',
                  [('mongodb_collection_size', 594, None, None, None, None)]),
                 (0,
                  'Allocated for document storage: 24.00 kB',
                  [('mongodb_collection_storage_size',
                    24576,
                    None,
                    None,
                    None,
                    None)]),
                 (0,
                  '\nCollection\n- Document Count: 0 (Number of documents in collection)\n- Object Size 99.00 B (Average object size)\n- Collection Size: 594.00 B (Uncompressed size in memory)\n- Storage Size: 24.00 kB (Allocated for document storage)',
                  [])]),
               (u'local startup_log',
                {},
                [(0,
                  'Uncompressed size in memory: 5.71 kB',
                  [('mongodb_collection_size', 5844, None, None, None, None)]),
                 (0,
                  'Allocated for document storage: 36.00 kB',
                  [('mongodb_collection_storage_size',
                    36864,
                    None,
                    None,
                    None,
                    None)]),
                 (0,
                  '\nCollection\n- Document Count: 0 (Number of documents in collection)\n- Object Size 1.90 kB (Average object size)\n- Collection Size: 5.71 kB (Uncompressed size in memory)\n- Storage Size: 36.00 kB (Allocated for document storage)',
                  [])]),
               (u'test zips',
                {},
                [(0,
                  'Uncompressed size in memory: 2.65 MB',
                  [('mongodb_collection_size', 2774134, None, None, None, None)]),
                 (0,
                  'Allocated for document storage: 1.39 MB',
                  [('mongodb_collection_storage_size',
                    1462272,
                    None,
                    None,
                    None,
                    None)]),
                 (0,
                  '\nCollection\n- Document Count: 0 (Number of documents in collection)\n- Object Size 94.00 B (Average object size)\n- Collection Size: 2.65 MB (Uncompressed size in memory)\n- Storage Size: 1.39 MB (Allocated for document storage)',
                  [])])]}