ra_mapping = {
    "RA1001": "Practice",
    "RA1002": "Take trainings",
    "RA1003": "Raise personnel awareness",
    "RA1004": "Make personnel report suspicious activity",
    "RA1005": "Set up relevant data collection",
    "RA1006": "Set up a centralized long-term log storage",
    "RA1007": "Develop communication map",
    "RA1008": "Make sure there are backups",
    "RA1009": "Get network architecture map",
    "RA1010": "Get access control matrix",
    "RA1011": "Develop assets knowledge base",
    "RA1012": "Check analysis toolset",
    "RA1013": "Access vulnerability management system logs",
    "RA1014": "Connect with trusted communities",
    "RA1101": "Access external network flow logs",
    "RA1102": "Access internal network flow logs",
    "RA1103": "Access internal HTTP logs",
    "RA1104": "Access external HTTP logs",
    "RA1105": "Access internal DNS logs",
    "RA1106": "Access external DNS logs",
    "RA1107": "Access VPN logs",
    "RA1108": "Access DHCP logs",
    "RA1109": "Access internal packet capture data",
    "RA1110": "Access external packet capture data",
    "RA1111": "Get ability to block external IP address",
    "RA1112": "Get ability to block internal IP address",
    "RA1113": "Get ability to block external domain",
    "RA1114": "Get ability to block internal domain",
    "RA1115": "Get ability to block external URL",
    "RA1116": "Get ability to block internal URL",
    "RA1117": "Get ability to block port external communication",
    "RA1118": "Get ability to block port internal communication",
    "RA1119": "Get ability to block user external communication",
    "RA1120": "Get ability to block user internal communication",
    "RA1121": "Get ability to find data transferred by content pattern",
    "RA1122": "Get ability to block data transferring by content pattern",
    "RA1123": "Get ability to list data transferred",
    "RA1124": "Get ability to collect transferred data",
    "RA1125": "Get ability to identify transferred data",
    "RA1126": "Find data transferred by content pattern",
    "RA1201": "Get ability to list users opened email message",
    "RA1202": "Get ability to list email message receivers",
    "RA1203": "Get ability to block email domain",
    "RA1204": "Get ability to block email sender",
    "RA1205": "Get ability to delete email message",
    "RA1206": "Get ability to quarantine email message",
    "RA1207": "Get ability to collect email message",
    "RA1301": "Get ability to list files created",
    "RA1302": "Get ability to list files modified",
    "RA1303": "Get ability to list files deleted",
    "RA1304": "Get ability to list files downloaded",
    "RA1305": "Get ability to list files with tampered timestamps",
    "RA1306": "Get ability to find file by path",
    "RA1307": "Get ability to find file by metadata",
    "RA1308": "Get ability to find file by hash",
    "RA1309": "Get ability to find file by format",
    "RA1310": "Get ability to find file by content pattern",
    "RA1311": "Get ability to collect file",
    "RA1312": "Get ability to quarantine file by path",
    "RA1313": "Get ability to quarantine file by hash",
    "RA1314": "Get ability to quarantine file by format",
    "RA1315": "Get ability to quarantine file by content pattern",
    "RA1316": "Get ability to remove file",
    "RA1317": "Get ability to analyse file hash",
    "RA1318": "Get ability to analyse Windows PE",
    "RA1319": "Get ability to analyse macos macho",
    "RA1320": "Get ability to analyse Unix ELF",
    "RA1321": "Get ability to analyse MS office file",
    "RA1322": "Get ability to analyse PDF file",
    "RA1323": "Get ability to analyse script",
    "RA1401": "Get ability to list processes executed",
    "RA1402": "Get ability to find process by executable path",
    "RA1403": "Get ability to find process by executable metadata",
    "RA1404": "Get ability to find process by executable hash",
    "RA1405": "Get ability to find process by executable format",
    "RA1406": "Get ability to find process by executable content pattern",
    "RA1407": "Get ability to block process by executable path",
    "RA1408": "Get ability to block process by executable metadata",
    "RA1409": "Get ability to block process by executable hash",
    "RA1410": "Get ability to block process by executable format",
    "RA1411": "Get ability to block process by executable content pattern",
    "RA1501": "Manage remote computer management system policies",
    "RA1502": "Get ability to list registry keys modified",
    "RA1503": "Get ability to list registry keys deleted",
    "RA1504": "Get ability to list registry keys accessed",
    "RA1505": "Get ability to list registry keys created",
    "RA1506": "Get ability to list services created",
    "RA1507": "Get ability to list services modified",
    "RA1508": "Get ability to list services deleted",
    "RA1509": "Get ability to remove registry key",
    "RA1510": "Get ability to remove service",
    "RA1601": "Manage identity management system",
    "RA1602": "Get ability to lock user account",
    "RA1603": "Get ability to list users authenticated",
    "RA1604": "Get ability to revoke authentication credentials",
    "RA1605": "Get ability to remove user account",
    "RA2001": "List victims of security alert",
    "RA2002": "List host vulnerabilities",
    "RA2003": "Put compromised accounts on monitoring",
    "RA2101": "List hosts communicated with internal domain",
    "RA2102": "List hosts communicated with internal IP",
    "RA2103": "List hosts communicated with internal URL",
    "RA2104": "Analyse domain name",
    "RA2105": "Analyse IP",
    "RA2106": "Analyse uri",
    "RA2107": "List hosts communicated by port",
    "RA2108": "List hosts connected to VPN",
    "RA2109": "List hosts connected to intranet",
    "RA2110": "List data transferred",
    "RA2111": "Collect transferred data",
    "RA2112": "Identify transferred data",
    "RA2113": "List hosts communicated with external domain",
    "RA2114": "List hosts communicated with external IP",
    "RA2115": "List hosts communicated with external URL",
    "RA2116": "Find data transferred by content pattern",
    "RA2201": "List users opened email message",
    "RA2202": "Collect email message",
    "RA2203": "List email message receivers",
    "RA2204": "Make sure email message is phishing",
    "RA2205": "Extract observables from email message",
    "RA2301": "List files created",
    "RA2302": "List files modified",
    "RA2303": "List files deleted",
    "RA2304": "List files downloaded",
    "RA2305": "List files with tampered timestamps",
    "RA2306": "Find file by path",
    "RA2307": "Find file by metadata",
    "RA2308": "Find file by hash",
    "RA2309": "Find file by format",
    "RA2310": "Find file by content pattern",
    "RA2311": "Collect file",
    "RA2312": "Analyse file hash",
    "RA2313": "Analyse Windows PE",
    "RA2314": "Analyse macos macho",
    "RA2315": "Analyse Unix ELF",
    "RA2316": "Analyse MS office file",
    "RA2317": "Analyse PDF file",
    "RA2318": "Analyse script",
    "RA2401": "List processes executed",
    "RA2402": "Find process by executable path",
    "RA2403": "Find process by executable metadata",
    "RA2404": "Find process by executable hash",
    "RA2405": "Find process by executable format",
    "RA2406": "Find process by executable content pattern",
    "RA2501": "List registry keys modified",
    "RA2502": "List registry keys deleted",
    "RA2503": "List registry keys accessed",
    "RA2504": "List registry keys created",
    "RA2505": "List services created",
    "RA2506": "List services modified",
    "RA2507": "List services deleted",
    "RA2601": "List users authenticated",
    "RA3001": "Patch vulnerability",
    "RA3101": "Block external IP address",
    "RA3102": "Block internal IP address",
    "RA3103": "Block external domain",
    "RA3104": "Block internal domain",
    "RA3105": "Block external URL",
    "RA3106": "Block internal URL",
    "RA3107": "Block port external communication",
    "RA3108": "Block port internal communication",
    "RA3109": "Block user external communication",
    "RA3110": "Block user internal communication",
    "RA3111": "Block data transferring by content pattern",
    "RA3201": "Block domain on email",
    "RA3202": "Block sender on email",
    "RA3203": "Quarantine email message",
    "RA3301": "Quarantine file by format",
    "RA3302": "Quarantine file by hash",
    "RA3303": "Quarantine file by path",
    "RA3304": "Quarantine file by content pattern",
    "RA3401": "Block process by executable path",
    "RA3402": "Block process by executable metadata",
    "RA3403": "Block process by executable hash",
    "RA3404": "Block process by executable format",
    "RA3405": "Block process by executable content pattern",
    "RA3501": "Disable system service",
    "RA3601": "Lock user account",
    "RA4001": "Report incident to external companies",
    "RA4101": "Remove rogue network device",
    "RA4201": "Delete email message",
    "RA4301": "Remove file",
    "RA4501": "Remove registry key",
    "RA4502": "Remove service",
    "RA4601": "Revoke authentication credentials",
    "RA4602": "Remove user account",
    "RA5001": "Reinstall host from golden image",
    "RA5002": "Restore data from backup",
    "RA5101": "Unblock blocked IP",
    "RA5102": "Unblock blocked domain",
    "RA5103": "Unblock blocked URL",
    "RA5104": "Unblock blocked port",
    "RA5105": "Unblock blocked user",
    "RA5201": "Unblock domain on email",
    "RA5202": "Unblock sender on email",
    "RA5203": "Restore quarantined email message",
    "RA5301": "Restore quarantined file",
    "RA5401": "Unblock blocked process",
    "RA5501": "Enable disabled service",
    "RA5601": "Unlock locked user account",
    "RA6001": "Develop incident report",
    "RA6002": "Conduct lessons learned exercise"
}
rs_mapping = {
    "RS0001": "Preparation",
    "RS0002": "Identification",
    "RS0003": "Containment",
    "RS0004": "Eradication",
    "RS0005": "Recovery",
    "RS0006": "Lessons Learned"
}