# Copyright (c) 2017 FlashX, LLC
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
import pytest

import os
os.environ['GITLIB_FS_BACKEND'] = 'filesystem-shim'

from gtmcore.gitlib import GitFilesystemShimmed
from .git_interface_mixin import GitInterfaceMixin
from .git_interface_mixin import mock_config_filesystem as mock_config
from .git_interface_mixin import mock_initialized_filesystem as mock_initialized
from .git_interface_mixin import mock_initialized_filesystem_with_remote as mock_initialized_remote



@pytest.mark.usefixtures("mock_config")
class TestGitFilesystem(GitInterfaceMixin):
    """Class to test the GitFilesystem interface"""
    class_type = GitFilesystemShimmed

    def get_git_obj(self, config):
        print('----------------------')
        import pprint; pprint.pprint(config)
        return GitFilesystemShimmed(config)
