from django import template

register = template.Library()


@register.filter
def tv_lab_hours(hour):
    if hour:
        if hour.open.minute != 0 or hour.close.minute != 0:
            fmt = '{:%-I:%M%P}–{:%-I:%M%P}'
        else:
            fmt = '{:%-I%P}–{:%-I%P}'

        return fmt.format(hour.open, hour.close)


@register.filter
def tv_lab_hours_css(hours):
    # 9:30 = hours-small, 9:00 = hours-large
    return 'hours-small' if any(
        block.open.minute != 0 or
        block.close.minute != 0
        for block in hours
    ) else 'hours-large'
