# -*- coding: utf-8 -*-


from django.db import models, migrations
import akvo.rsr.fields
import akvo.rsr.models.organisation_document


class Migration(migrations.Migration):

    dependencies = [
        ('rsr', '0062_auto_20160311_1024'),
    ]

    operations = [
        migrations.CreateModel(
            name='OrganisationCountryBudget',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of budget that is set aside for this specific budget. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('period_start', models.DateField(help_text='Enter the start date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period start', blank=True)),
                ('period_end', models.DateField(help_text='Enter the end date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period end', blank=True)),
                ('status', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The status explains whether the budget being reported is indicative or has been formally committed.', max_length=1, verbose_name='status', choices=[('1', '1 - Indicative'), ('2', '2 - Committed')])),
                ('country', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the country which concerns the organisation budget.', max_length=2, verbose_name='recipient country', choices=[('AF', 'AF - Afghanistan'), ('AX', 'AX - \xc5land Islands'), ('AL', 'AL - Albania'), ('DZ', 'DZ - Algeria'), ('AS', 'AS - American Samoa'), ('AD', 'AD - Andorra'), ('AO', 'AO - Angola'), ('AI', 'AI - Anguilla'), ('AQ', 'AQ - Antarctica'), ('AG', 'AG - Antigua and Barbuda'), ('AR', 'AR - Argentina'), ('AM', 'AM - Armenia'), ('AW', 'AW - Aruba'), ('AU', 'AU - Australia'), ('AT', 'AT - Austria'), ('AZ', 'AZ - Azerbaijan'), ('BS', 'BS - Bahamas (The)'), ('BH', 'BH - Bahrain'), ('BD', 'BD - Bangladesh'), ('BB', 'BB - Barbados'), ('BY', 'BY - Belarus'), ('BE', 'BE - Belgium'), ('BZ', 'BZ - Belize'), ('BJ', 'BJ - Benin'), ('BM', 'BM - Bermuda'), ('BT', 'BT - Bhutan'), ('BO', 'BO - Bolivia (Plurinational State Of)'), ('BQ', 'BQ - Bonaire, Saint Eustatius and Saba'), ('BA', 'BA - Bosnia and Herzegovina'), ('BW', 'BW - Botswana'), ('BV', 'BV - Bouvet Island'), ('BR', 'BR - Brazil'), ('IO', 'IO - British Indian Ocean Territory (The)'), ('BN', 'BN - Brunei Darussalam'), ('BG', 'BG - Bulgaria'), ('BF', 'BF - Burkina Faso'), ('BI', 'BI - Burundi'), ('KH', 'KH - Cambodia'), ('CM', 'CM - Cameroon'), ('CA', 'CA - Canada'), ('CV', 'CV - Cape Verde'), ('KY', 'KY - Cayman Islands (The)'), ('CF', 'CF - Central African Republic (The)'), ('TD', 'TD - Chad'), ('CL', 'CL - Chile'), ('CN', 'CN - China'), ('CX', 'CX - Christmas Island'), ('CC', 'CC - Cocos (Keeling) Islands (The)'), ('CO', 'CO - Colombia'), ('KM', 'KM - Comoros (The)'), ('CG', 'CG - Congo (The)'), ('CD', 'CD - Congo, The Democratic Republic of the'), ('CK', 'CK - Cook Islands (The)'), ('CR', 'CR - Costa Rica'), ('CI', 'CI - C\xf4te Divoire'), ('HR', 'HR - Croatia'), ('CU', 'CU - Cuba'), ('CW', 'CW - Cura\xe7ao'), ('CY', 'CY - Cyprus'), ('CZ', 'CZ - Czech Republic (The)'), ('DK', 'DK - Denmark'), ('DJ', 'DJ - Djibouti'), ('DM', 'DM - Dominica'), ('DO', 'DO - Dominican Republic (The)'), ('EC', 'EC - Ecuador'), ('EG', 'EG - Egypt'), ('SV', 'SV - El Salvador'), ('GQ', 'GQ - Equatorial Guinea'), ('ER', 'ER - Eritrea'), ('EE', 'EE - Estonia'), ('ET', 'ET - Ethiopia'), ('FK', 'FK - Falkland Islands (The) [malvinas]'), ('FO', 'FO - Faroe Islands (The)'), ('FJ', 'FJ - Fiji'), ('FI', 'FI - Finland'), ('FR', 'FR - France'), ('GF', 'GF - French Guiana'), ('PF', 'PF - French Polynesia'), ('TF', 'TF - French Southern Territories (The)'), ('GA', 'GA - Gabon'), ('GM', 'GM - Gambia (The)'), ('GE', 'GE - Georgia'), ('DE', 'DE - Germany'), ('GH', 'GH - Ghana'), ('GI', 'GI - Gibraltar'), ('GR', 'GR - Greece'), ('GL', 'GL - Greenland'), ('GD', 'GD - Grenada'), ('GP', 'GP - Guadeloupe'), ('GU', 'GU - Guam'), ('GT', 'GT - Guatemala'), ('GG', 'GG - Guernsey'), ('GN', 'GN - Guinea'), ('GW', 'GW - Guinea-Bissau'), ('GY', 'GY - Guyana'), ('HT', 'HT - Haiti'), ('HM', 'HM - Heard Island and Mcdonald Islands'), ('VA', 'VA - Holy See (The)'), ('HN', 'HN - Honduras'), ('HK', 'HK - Hong Kong'), ('HU', 'HU - Hungary'), ('IS', 'IS - Iceland'), ('IN', 'IN - India'), ('ID', 'ID - Indonesia'), ('IR', 'IR - Iran (Islamic Republic Of)'), ('IQ', 'IQ - Iraq'), ('IE', 'IE - Ireland'), ('IM', 'IM - Isle of Man'), ('IL', 'IL - Israel'), ('IT', 'IT - Italy'), ('JM', 'JM - Jamaica'), ('JP', 'JP - Japan'), ('JE', 'JE - Jersey'), ('JO', 'JO - Jordan'), ('KZ', 'KZ - Kazakhstan'), ('KE', 'KE - Kenya'), ('KI', 'KI - Kiribati'), ('KP', 'KP - Korea (Democratic Peoples Republic Of)'), ('KR', 'KR - Korea (Republic Of)'), ('XK', 'XK - Kosovo'), ('KW', 'KW - Kuwait'), ('KG', 'KG - Kyrgyzstan'), ('LA', 'LA - Lao Peoples Democratic Republic (The)'), ('LV', 'LV - Latvia'), ('LB', 'LB - Lebanon'), ('LS', 'LS - Lesotho'), ('LR', 'LR - Liberia'), ('LY', 'LY - Libyan Arab Jamahiriya'), ('LI', 'LI - Liechtenstein'), ('LT', 'LT - Lithuania'), ('LU', 'LU - Luxembourg'), ('MO', 'MO - Macao'), ('MK', 'MK - Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'MG - Madagascar'), ('MW', 'MW - Malawi'), ('MY', 'MY - Malaysia'), ('MV', 'MV - Maldives'), ('ML', 'ML - Mali'), ('MT', 'MT - Malta'), ('MH', 'MH - Marshall Islands (The)'), ('MQ', 'MQ - Martinique'), ('MR', 'MR - Mauritania'), ('MU', 'MU - Mauritius'), ('YT', 'YT - Mayotte'), ('MX', 'MX - Mexico'), ('FM', 'FM - Micronesia (Federated States Of)'), ('MD', 'MD - Moldova (Republic Of)'), ('MC', 'MC - Monaco'), ('MN', 'MN - Mongolia'), ('ME', 'ME - Montenegro'), ('MS', 'MS - Montserrat'), ('MA', 'MA - Morocco'), ('MZ', 'MZ - Mozambique'), ('MM', 'MM - Myanmar'), ('NA', 'NA - Namibia'), ('NR', 'NR - Nauru'), ('NP', 'NP - Nepal'), ('NL', 'NL - Netherlands (The)'), ('AN', 'AN - Netherland Antilles'), ('NC', 'NC - New Caledonia'), ('NZ', 'NZ - New Zealand'), ('NI', 'NI - Nicaragua'), ('NE', 'NE - Niger (The)'), ('NG', 'NG - Nigeria'), ('NU', 'NU - Niue'), ('NF', 'NF - Norfolk Island'), ('MP', 'MP - Northern Mariana Islands (The)'), ('NO', 'NO - Norway'), ('OM', 'OM - Oman'), ('PK', 'PK - Pakistan'), ('PW', 'PW - Palau'), ('PS', 'PS - Palestinian Territory, Occupied'), ('PA', 'PA - Panama'), ('PG', 'PG - Papua New Guinea'), ('PY', 'PY - Paraguay'), ('PE', 'PE - Peru'), ('PH', 'PH - Philippines (The)'), ('PN', 'PN - Pitcairn'), ('PL', 'PL - Poland'), ('PT', 'PT - Portugal'), ('PR', 'PR - Puerto Rico'), ('QA', 'QA - Qatar'), ('RE', 'RE - Reunion'), ('RO', 'RO - Romania'), ('RU', 'RU - Russian Federation (The)'), ('RW', 'RW - Rwanda'), ('BL', 'BL - Saint Barth\xe9lemy'), ('SH', 'SH - Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'KN - Saint Kitts and Nevis'), ('LC', 'LC - Saint Lucia'), ('MF', 'MF - Saint Martin (French Part)'), ('PM', 'PM - Saint Pierre and Miquelon'), ('VC', 'VC - Saint Vincent and the Grenadines'), ('WS', 'WS - Samoa'), ('SM', 'SM - San Marino'), ('ST', 'ST - Sao Tome and Principe'), ('SA', 'SA - Saudi Arabia'), ('SN', 'SN - Senegal'), ('RS', 'RS - Serbia'), ('SC', 'SC - Seychelles'), ('SL', 'SL - Sierra Leone'), ('SG', 'SG - Singapore'), ('SX', 'SX - Sint Maarten (Dutch Part)'), ('SK', 'SK - Slovakia'), ('SI', 'SI - Slovenia'), ('SB', 'SB - Solomon Islands'), ('SO', 'SO - Somalia'), ('ZA', 'ZA - South Africa'), ('GS', 'GS - South Georgia and the South Sandwich Islands'), ('SS', 'SS - South Sudan'), ('ES', 'ES - Spain'), ('LK', 'LK - Sri Lanka'), ('SD', 'SD - Sudan (The)'), ('SR', 'SR - Suriname'), ('SJ', 'SJ - Svalbard and Jan Mayen'), ('SZ', 'SZ - Swaziland'), ('SE', 'SE - Sweden'), ('CH', 'CH - Switzerland'), ('SY', 'SY - Syrian Arab Republic'), ('TW', 'TW - Taiwan (Province of China)'), ('TJ', 'TJ - Tajikistan'), ('TZ', 'TZ - Tanzania, United Republic of'), ('TH', 'TH - Thailand'), ('TL', 'TL - Timor-Leste'), ('TG', 'TG - Togo'), ('TK', 'TK - Tokelau'), ('TO', 'TO - Tonga'), ('TT', 'TT - Trinidad and Tobago'), ('TN', 'TN - Tunisia'), ('TR', 'TR - Turkey'), ('TM', 'TM - Turkmenistan'), ('TC', 'TC - Turks and Caicos Islands (The)'), ('TV', 'TV - Tuvalu'), ('UG', 'UG - Uganda'), ('UA', 'UA - Ukraine'), ('AE', 'AE - United Arab Emirates (The)'), ('GB', 'GB - United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'US - United States of America (The)'), ('UM', 'UM - United States Minor Outlying Islands (The)'), ('UY', 'UY - Uruguay'), ('UZ', 'UZ - Uzbekistan'), ('VU', 'VU - Vanuatu'), ('VE', 'VE - Venezuela (Bolivarian Republic Of)'), ('VN', 'VN - Viet Nam'), ('VG', 'VG - Virgin Islands (British)'), ('VI', 'VI - Virgin Islands (U.s.)'), ('WF', 'WF - Wallis and Futuna'), ('EH', 'EH - Western Sahara'), ('YE', 'YE - Yemen'), ('ZM', 'ZM - Zambia'), ('ZW', 'ZW - Zimbabwe')])),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='Optionally enter a short description.', max_length=100, verbose_name='description', blank=True)),
                ('organisation', models.ForeignKey(related_name='recipient_country_budgets', verbose_name='organisation', to='rsr.Organisation')),
            ],
            options={
                'verbose_name': 'organisation recipient country budget',
                'verbose_name_plural': 'organisation recipient country budgets',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationCountryBudgetLine',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of this specific line. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('reference', akvo.rsr.fields.ValidXMLCharField(help_text="An internal reference that describes the line in the reporting organisation's own system", max_length=50, verbose_name='reference', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='The description for this line.', max_length=1000, verbose_name='description', blank=True)),
                ('budget', models.ForeignKey(related_name='budget_lines', verbose_name='organisation budget', to='rsr.OrganisationCountryBudget')),
            ],
            options={
                'verbose_name': 'country budget line',
                'verbose_name_plural': 'country budget lines',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationDocument',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('url', models.URLField(help_text="Enter the online location of your document. The URL should start with 'http://' or 'https://'.", verbose_name='document url', blank=True)),
                ('document', models.FileField(help_text='You can upload a document to your organisation. These documents will be stored on the RSR server and will be publicly available for users to download and view to gain further insight in the organisation.', upload_to=akvo.rsr.models.organisation_document.document_path, verbose_name='document', blank=True)),
                ('format', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This provides the code for the Internet Media Type ("MIME type") of the document, and includes pdf, msword, rtf, xml, csv, etc.', max_length=75, verbose_name='document format', choices=[('application/1d-interleaved-parityfec', 'application/1d-interleaved-parityfec'), ('application/3gpp-ims+xml', 'application/3gpp-ims+xml'), ('application/activemessage', 'application/activemessage'), ('application/alto-costmap+json', 'application/alto-costmap+json'), ('application/alto-costmapfilter+json', 'application/alto-costmapfilter+json'), ('application/alto-directory+json', 'application/alto-directory+json'), ('application/alto-endpointprop+json', 'application/alto-endpointprop+json'), ('application/alto-endpointpropparams+json', 'application/alto-endpointpropparams+json'), ('application/alto-endpointcost+json', 'application/alto-endpointcost+json'), ('application/alto-endpointcostparams+json', 'application/alto-endpointcostparams+json'), ('application/alto-error+json', 'application/alto-error+json'), ('application/alto-networkmapfilter+json', 'application/alto-networkmapfilter+json'), ('application/alto-networkmap+json', 'application/alto-networkmap+json'), ('application/andrew-inset', 'application/andrew-inset'), ('application/applefile', 'application/applefile'), ('application/atom+xml', 'application/atom+xml'), ('application/atomcat+xml', 'application/atomcat+xml'), ('application/atomdeleted+xml', 'application/atomdeleted+xml'), ('application/atomicmail', 'application/atomicmail'), ('application/atomsvc+xml', 'application/atomsvc+xml'), ('application/auth-policy+xml', 'application/auth-policy+xml'), ('application/bacnet-xdd+zip', 'application/bacnet-xdd+zip'), ('application/batch-SMTP', 'application/batch-SMTP'), ('application/beep+xml', 'application/beep+xml'), ('application/calendar+json', 'application/calendar+json'), ('application/calendar+xml', 'application/calendar+xml'), ('application/call-completion', 'application/call-completion'), ('application/cals-1840', 'application/cals-1840'), ('application/cbor', 'application/cbor'), ('application/ccmp+xml', 'application/ccmp+xml'), ('application/ccxml+xml', 'application/ccxml+xml'), ('application/cdmi-capability', 'application/cdmi-capability'), ('application/cdmi-container', 'application/cdmi-container'), ('application/cdmi-domain', 'application/cdmi-domain'), ('application/cdmi-object', 'application/cdmi-object'), ('application/cdmi-queue', 'application/cdmi-queue'), ('application/cea-2018+xml', 'application/cea-2018+xml'), ('application/cellml+xml', 'application/cellml+xml'), ('application/cfw', 'application/cfw'), ('application/cms', 'application/cms'), ('application/cnrp+xml', 'application/cnrp+xml'), ('application/commonground', 'application/commonground'), ('application/conference-info+xml', 'application/conference-info+xml'), ('application/cpl+xml', 'application/cpl+xml'), ('application/csrattrs', 'application/csrattrs'), ('application/csta+xml', 'application/csta+xml'), ('application/CSTAdata+xml', 'application/CSTAdata+xml'), ('application/cybercash', 'application/cybercash'), ('application/dash+xml', 'application/dash+xml'), ('application/dashdelta', 'application/dashdelta'), ('application/davmount+xml', 'application/davmount+xml'), ('application/dca-rft', 'application/dca-rft'), ('application/dec-dx', 'application/dec-dx'), ('application/dialog-info+xml', 'application/dialog-info+xml'), ('application/dicom', 'application/dicom'), ('application/dns', 'application/dns'), ('application/dskpp+xml', 'application/dskpp+xml'), ('application/dssc+der', 'application/dssc+der'), ('application/dssc+xml', 'application/dssc+xml'), ('application/dvcs', 'application/dvcs'), ('application/ecmascript', 'application/ecmascript'), ('application/EDI-consent', 'application/EDI-consent'), ('application/EDIFACT', 'application/EDIFACT'), ('application/EDI-X12', 'application/EDI-X12'), ('application/emma+xml', 'application/emma+xml'), ('application/emotionml+xml', 'application/emotionml+xml'), ('application/encaprtp', 'application/encaprtp'), ('application/epp+xml', 'application/epp+xml'), ('application/eshop', 'application/eshop'), ('application/example', 'application/example'), ('application/exi', 'application/exi'), ('application/fastinfoset', 'application/fastinfoset'), ('application/fastsoap', 'application/fastsoap'), ('application/fdt+xml', 'application/fdt+xml'), ('application/fits', 'application/fits'), ('application/font-sfnt', 'application/font-sfnt'), ('application/font-tdpfr', 'application/font-tdpfr'), ('application/font-woff', 'application/font-woff'), ('application/framework-attributes+xml', 'application/framework-attributes+xml'), ('application/gzip', 'application/gzip'), ('application/H224', 'application/H224'), ('application/held+xml', 'application/held+xml'), ('application/http', 'application/http'), ('application/hyperstudio', 'application/hyperstudio'), ('application/ibe-key-request+xml', 'application/ibe-key-request+xml'), ('application/ibe-pkg-reply+xml', 'application/ibe-pkg-reply+xml'), ('application/ibe-pp-data', 'application/ibe-pp-data'), ('application/iges', 'application/iges'), ('application/im-iscomposing+xml', 'application/im-iscomposing+xml'), ('application/index', 'application/index'), ('application/index.cmd', 'application/index.cmd'), ('application/index.obj', 'application/index.obj'), ('application/index.response', 'application/index.response'), ('application/index.vnd', 'application/index.vnd'), ('application/inkml+xml', 'application/inkml+xml'), ('application/iotp', 'application/iotp'), ('application/ipfix', 'application/ipfix'), ('application/ipp', 'application/ipp'), ('application/isup', 'application/isup'), ('application/its+xml', 'application/its+xml'), ('application/javascript', 'application/javascript'), ('application/jrd+json', 'application/jrd+json'), ('application/json', 'application/json'), ('application/json-patch+json', 'application/json-patch+json'), ('application/kpml-request+xml', 'application/kpml-request+xml'), ('application/kpml-response+xml', 'application/kpml-response+xml'), ('application/ld+json', 'application/ld+json'), ('application/link-format', 'application/link-format'), ('application/load-control+xml', 'application/load-control+xml'), ('application/lost+xml', 'application/lost+xml'), ('application/lostsync+xml', 'application/lostsync+xml'), ('application/mac-binhex40', 'application/mac-binhex40'), ('application/macwriteii', 'application/macwriteii'), ('application/mads+xml', 'application/mads+xml'), ('application/marc', 'application/marc'), ('application/marcxml+xml', 'application/marcxml+xml'), ('application/mathematica', 'application/mathematica'), ('application/mathml-content+xml', 'application/mathml-content+xml'), ('application/mathml-presentation+xml', 'application/mathml-presentation+xml'), ('application/mathml+xml', 'application/mathml+xml'), ('application/mbms-associated-procedure-description+xml', 'application/mbms-associated-procedure-description+xml'), ('application/mbms-deregister+xml', 'application/mbms-deregister+xml'), ('application/mbms-envelope+xml', 'application/mbms-envelope+xml'), ('application/mbms-msk-response+xml', 'application/mbms-msk-response+xml'), ('application/mbms-msk+xml', 'application/mbms-msk+xml'), ('application/mbms-protection-description+xml', 'application/mbms-protection-description+xml'), ('application/mbms-reception-report+xml', 'application/mbms-reception-report+xml'), ('application/mbms-register-response+xml', 'application/mbms-register-response+xml'), ('application/mbms-register+xml', 'application/mbms-register+xml'), ('application/mbms-schedule+xml', 'application/mbms-schedule+xml'), ('application/mbms-user-service-description+xml', 'application/mbms-user-service-description+xml'), ('application/mbox', 'application/mbox'), ('application/media_control+xml', 'application/media_control+xml'), ('application/media-policy-dataset+xml', 'application/media-policy-dataset+xml'), ('application/mediaservercontrol+xml', 'application/mediaservercontrol+xml'), ('application/metalink4+xml', 'application/metalink4+xml'), ('application/mets+xml', 'application/mets+xml'), ('application/mikey', 'application/mikey'), ('application/mods+xml', 'application/mods+xml'), ('application/moss-keys', 'application/moss-keys'), ('application/moss-signature', 'application/moss-signature'), ('application/mosskey-data', 'application/mosskey-data'), ('application/mosskey-request', 'application/mosskey-request'), ('application/mp21', 'application/mp21'), ('application/mp4', 'application/mp4'), ('application/mpeg4-generic', 'application/mpeg4-generic'), ('application/mpeg4-iod', 'application/mpeg4-iod'), ('application/mpeg4-iod-xmt', 'application/mpeg4-iod-xmt'), ('application/mrb-consumer+xml', 'application/mrb-consumer+xml'), ('application/mrb-publish+xml', 'application/mrb-publish+xml'), ('application/msc-ivr+xml', 'application/msc-ivr+xml'), ('application/msc-mixer+xml', 'application/msc-mixer+xml'), ('application/msword', 'application/msword'), ('application/mxf', 'application/mxf'), ('application/nasdata', 'application/nasdata'), ('application/news-checkgroups', 'application/news-checkgroups'), ('application/news-groupinfo', 'application/news-groupinfo'), ('application/news-transmission', 'application/news-transmission'), ('application/nlsml+xml', 'application/nlsml+xml'), ('application/nss', 'application/nss'), ('application/ocsp-request', 'application/ocsp-request'), ('application/ocsp-response', 'application/ocsp-response'), ('application/octet-stream', 'application/octet-stream'), ('application/oda', 'application/oda'), ('application/ODX', 'application/ODX'), ('application/oebps-package+xml', 'application/oebps-package+xml'), ('application/ogg', 'application/ogg'), ('application/oxps', 'application/oxps'), ('application/p2p-overlay+xml', 'application/p2p-overlay+xml'), ('application/parityfec', 'application/parityfec'), ('application/patch-ops-error+xml', 'application/patch-ops-error+xml'), ('application/pdf', 'application/pdf'), ('application/PDX', 'application/PDX'), ('application/pgp-encrypted', 'application/pgp-encrypted'), ('application/pgp-keys', 'application/pgp-keys'), ('application/pgp-signature', 'application/pgp-signature'), ('application/pidf-diff+xml', 'application/pidf-diff+xml'), ('application/pidf+xml', 'application/pidf+xml'), ('application/pkcs10', 'application/pkcs10'), ('application/pkcs7-mime', 'application/pkcs7-mime'), ('application/pkcs7-signature', 'application/pkcs7-signature'), ('application/pkcs8', 'application/pkcs8'), ('application/pkix-attr-cert', 'application/pkix-attr-cert'), ('application/pkix-cert', 'application/pkix-cert'), ('application/pkix-crl', 'application/pkix-crl'), ('application/pkix-pkipath', 'application/pkix-pkipath'), ('application/pkixcmp', 'application/pkixcmp'), ('application/pls+xml', 'application/pls+xml'), ('application/poc-settings+xml', 'application/poc-settings+xml'), ('application/postscript', 'application/postscript'), ('application/provenance+xml', 'application/provenance+xml'), ('application/prs.alvestrand.titrax-sheet', 'application/prs.alvestrand.titrax-sheet'), ('application/prs.cww', 'application/prs.cww'), ('application/prs.hpub+zip', 'application/prs.hpub+zip'), ('application/prs.nprend', 'application/prs.nprend'), ('application/prs.plucker', 'application/prs.plucker'), ('application/prs.rdf-xml-crypt', 'application/prs.rdf-xml-crypt'), ('application/prs.xsf+xml', 'application/prs.xsf+xml'), ('application/pskc+xml', 'application/pskc+xml'), ('application/rdf+xml', 'application/rdf+xml'), ('application/qsig', 'application/qsig'), ('application/raptorfec', 'application/raptorfec'), ('application/reginfo+xml', 'application/reginfo+xml'), ('application/relax-ng-compact-syntax', 'application/relax-ng-compact-syntax'), ('application/remote-printing', 'application/remote-printing'), ('application/reputon+json', 'application/reputon+json'), ('application/resource-lists-diff+xml', 'application/resource-lists-diff+xml'), ('application/resource-lists+xml', 'application/resource-lists+xml'), ('application/riscos', 'application/riscos'), ('application/rlmi+xml', 'application/rlmi+xml'), ('application/rls-services+xml', 'application/rls-services+xml'), ('application/rpki-ghostbusters', 'application/rpki-ghostbusters'), ('application/rpki-manifest', 'application/rpki-manifest'), ('application/rpki-roa', 'application/rpki-roa'), ('application/rpki-updown', 'application/rpki-updown'), ('application/rtf', 'application/rtf'), ('application/rtploopback', 'application/rtploopback'), ('application/rtx', 'application/rtx'), ('application/samlassertion+xml', 'application/samlassertion+xml'), ('application/samlmetadata+xml', 'application/samlmetadata+xml'), ('application/sbml+xml', 'application/sbml+xml'), ('application/scvp-cv-request', 'application/scvp-cv-request'), ('application/scvp-cv-response', 'application/scvp-cv-response'), ('application/scvp-vp-request', 'application/scvp-vp-request'), ('application/scvp-vp-response', 'application/scvp-vp-response'), ('application/sdp', 'application/sdp'), ('application/sep-exi', 'application/sep-exi'), ('application/sep+xml', 'application/sep+xml'), ('application/session-info', 'application/session-info'), ('application/set-payment', 'application/set-payment'), ('application/set-payment-initiation', 'application/set-payment-initiation'), ('application/set-registration', 'application/set-registration'), ('application/set-registration-initiation', 'application/set-registration-initiation'), ('application/sgml', 'application/sgml'), ('application/sgml-open-catalog', 'application/sgml-open-catalog'), ('application/shf+xml', 'application/shf+xml'), ('application/sieve', 'application/sieve'), ('application/simple-filter+xml', 'application/simple-filter+xml'), ('application/simple-message-summary', 'application/simple-message-summary'), ('application/simpleSymbolContainer', 'application/simpleSymbolContainer'), ('application/slate', 'application/slate'), ('application/smil', 'application/smil'), ('application/smil+xml', 'application/smil+xml'), ('application/smpte336m', 'application/smpte336m'), ('application/soap+fastinfoset', 'application/soap+fastinfoset'), ('application/soap+xml', 'application/soap+xml'), ('application/sparql-query', 'application/sparql-query'), ('application/sparql-results+xml', 'application/sparql-results+xml'), ('application/spirits-event+xml', 'application/spirits-event+xml'), ('application/sql', 'application/sql'), ('application/srgs', 'application/srgs'), ('application/srgs+xml', 'application/srgs+xml'), ('application/sru+xml', 'application/sru+xml'), ('application/ssml+xml', 'application/ssml+xml'), ('application/tamp-apex-update', 'application/tamp-apex-update'), ('application/tamp-apex-update-confirm', 'application/tamp-apex-update-confirm'), ('application/tamp-community-update', 'application/tamp-community-update'), ('application/tamp-community-update-confirm', 'application/tamp-community-update-confirm'), ('application/tamp-error', 'application/tamp-error'), ('application/tamp-sequence-adjust', 'application/tamp-sequence-adjust'), ('application/tamp-sequence-adjust-confirm', 'application/tamp-sequence-adjust-confirm'), ('application/tamp-status-query', 'application/tamp-status-query'), ('application/tamp-status-response', 'application/tamp-status-response'), ('application/tamp-update', 'application/tamp-update'), ('application/tamp-update-confirm', 'application/tamp-update-confirm'), ('application/tei+xml', 'application/tei+xml'), ('application/thraud+xml', 'application/thraud+xml'), ('application/timestamp-query', 'application/timestamp-query'), ('application/timestamp-reply', 'application/timestamp-reply'), ('application/timestamped-data', 'application/timestamped-data'), ('application/ttml+xml', 'application/ttml+xml'), ('application/tve-trigger', 'application/tve-trigger'), ('application/ulpfec', 'application/ulpfec'), ('application/urc-grpsheet+xml', 'application/urc-grpsheet+xml'), ('application/urc-ressheet+xml', 'application/urc-ressheet+xml'), ('application/urc-targetdesc+xml', 'application/urc-targetdesc+xml'), ('application/urc-uisocketdesc+xml', 'application/urc-uisocketdesc+xml'), ('application/vcard+json', 'application/vcard+json'), ('application/vcard+xml', 'application/vcard+xml'), ('application/vemmi', 'application/vemmi'), ('application/vnd.3gpp.bsf+xml', 'application/vnd.3gpp.bsf+xml'), ('application/vnd.3gpp.pic-bw-large', 'application/vnd.3gpp.pic-bw-large'), ('application/vnd.3gpp.pic-bw-small', 'application/vnd.3gpp.pic-bw-small'), ('application/vnd.3gpp.pic-bw-var', 'application/vnd.3gpp.pic-bw-var'), ('application/vnd.3gpp.sms', 'application/vnd.3gpp.sms'), ('application/vnd.3gpp2.bcmcsinfo+xml', 'application/vnd.3gpp2.bcmcsinfo+xml'), ('application/vnd.3gpp2.sms', 'application/vnd.3gpp2.sms'), ('application/vnd.3gpp2.tcap', 'application/vnd.3gpp2.tcap'), ('application/vnd.3M.Post-it-Notes', 'application/vnd.3M.Post-it-Notes'), ('application/vnd.accpac.simply.aso', 'application/vnd.accpac.simply.aso'), ('application/vnd.accpac.simply.imp', 'application/vnd.accpac.simply.imp'), ('application/vnd.acucobol', 'application/vnd.acucobol'), ('application/vnd.acucorp', 'application/vnd.acucorp'), ('application/vnd.adobe.flash.movie', 'application/vnd.adobe.flash.movie'), ('application/vnd.adobe.formscentral.fcdt', 'application/vnd.adobe.formscentral.fcdt'), ('application/vnd.adobe.fxp', 'application/vnd.adobe.fxp'), ('application/vnd.adobe.partial-upload', 'application/vnd.adobe.partial-upload'), ('application/vnd.adobe.xdp+xml', 'application/vnd.adobe.xdp+xml'), ('application/vnd.adobe.xfdf', 'application/vnd.adobe.xfdf'), ('application/vnd.aether.imp', 'application/vnd.aether.imp'), ('application/vnd.ah-barcode', 'application/vnd.ah-barcode'), ('application/vnd.ahead.space', 'application/vnd.ahead.space'), ('application/vnd.airzip.filesecure.azf', 'application/vnd.airzip.filesecure.azf'), ('application/vnd.airzip.filesecure.azs', 'application/vnd.airzip.filesecure.azs'), ('application/vnd.americandynamics.acc', 'application/vnd.americandynamics.acc'), ('application/vnd.amiga.ami', 'application/vnd.amiga.ami'), ('application/vnd.amundsen.maze+xml', 'application/vnd.amundsen.maze+xml'), ('application/vnd.anser-web-certificate-issue-initiation', 'application/vnd.anser-web-certificate-issue-initiation'), ('application/vnd.antix.game-component', 'application/vnd.antix.game-component'), ('application/vnd.api+json', 'application/vnd.api+json'), ('application/vnd.apple.mpegurl', 'application/vnd.apple.mpegurl'), ('application/vnd.apple.installer+xml', 'application/vnd.apple.installer+xml'), ('application/vnd.arastra.swi', 'application/vnd.arastra.swi'), ('application/vnd.aristanetworks.swi', 'application/vnd.aristanetworks.swi'), ('application/vnd.astraea-software.iota', 'application/vnd.astraea-software.iota'), ('application/vnd.audiograph', 'application/vnd.audiograph'), ('application/vnd.autopackage', 'application/vnd.autopackage'), ('application/vnd.avistar+xml', 'application/vnd.avistar+xml'), ('application/vnd.balsamiq.bmml+xml', 'application/vnd.balsamiq.bmml+xml'), ('application/vnd.bekitzur-stech+json', 'application/vnd.bekitzur-stech+json'), ('application/vnd.blueice.multipass', 'application/vnd.blueice.multipass'), ('application/vnd.bluetooth.ep.oob', 'application/vnd.bluetooth.ep.oob'), ('application/vnd.bluetooth.le.oob', 'application/vnd.bluetooth.le.oob'), ('application/vnd.bmi', 'application/vnd.bmi'), ('application/vnd.businessobjects', 'application/vnd.businessobjects'), ('application/vnd.cab-jscript', 'application/vnd.cab-jscript'), ('application/vnd.canon-cpdl', 'application/vnd.canon-cpdl'), ('application/vnd.canon-lips', 'application/vnd.canon-lips'), ('application/vnd.cendio.thinlinc.clientconf', 'application/vnd.cendio.thinlinc.clientconf'), ('application/vnd.century-systems.tcp_stream', 'application/vnd.century-systems.tcp_stream'), ('application/vnd.chemdraw+xml', 'application/vnd.chemdraw+xml'), ('application/vnd.chipnuts.karaoke-mmd', 'application/vnd.chipnuts.karaoke-mmd'), ('application/vnd.cinderella', 'application/vnd.cinderella'), ('application/vnd.cirpack.isdn-ext', 'application/vnd.cirpack.isdn-ext'), ('application/vnd.claymore', 'application/vnd.claymore'), ('application/vnd.cloanto.rp9', 'application/vnd.cloanto.rp9'), ('application/vnd.clonk.c4group', 'application/vnd.clonk.c4group'), ('application/vnd.cluetrust.cartomobile-config', 'application/vnd.cluetrust.cartomobile-config'), ('application/vnd.cluetrust.cartomobile-config-pkg', 'application/vnd.cluetrust.cartomobile-config-pkg'), ('application/vnd.collection.doc+json', 'application/vnd.collection.doc+json'), ('application/vnd.collection+json', 'application/vnd.collection+json'), ('application/vnd.collection.next+json', 'application/vnd.collection.next+json'), ('application/vnd.commerce-battelle', 'application/vnd.commerce-battelle'), ('application/vnd.commonspace', 'application/vnd.commonspace'), ('application/vnd.cosmocaller', 'application/vnd.cosmocaller'), ('application/vnd.contact.cmsg', 'application/vnd.contact.cmsg'), ('application/vnd.crick.clicker', 'application/vnd.crick.clicker'), ('application/vnd.crick.clicker.keyboard', 'application/vnd.crick.clicker.keyboard'), ('application/vnd.crick.clicker.palette', 'application/vnd.crick.clicker.palette'), ('application/vnd.crick.clicker.template', 'application/vnd.crick.clicker.template'), ('application/vnd.crick.clicker.wordbank', 'application/vnd.crick.clicker.wordbank'), ('application/vnd.criticaltools.wbs+xml', 'application/vnd.criticaltools.wbs+xml'), ('application/vnd.ctc-posml', 'application/vnd.ctc-posml'), ('application/vnd.ctct.ws+xml', 'application/vnd.ctct.ws+xml'), ('application/vnd.cups-pdf', 'application/vnd.cups-pdf'), ('application/vnd.cups-postscript', 'application/vnd.cups-postscript'), ('application/vnd.cups-ppd', 'application/vnd.cups-ppd'), ('application/vnd.cups-raster', 'application/vnd.cups-raster'), ('application/vnd.cups-raw', 'application/vnd.cups-raw'), ('application/vnd.curl', 'application/vnd.curl'), ('application/vnd.cyan.dean.root+xml', 'application/vnd.cyan.dean.root+xml'), ('application/vnd.cybank', 'application/vnd.cybank'), ('application/vnd.dart', 'application/vnd.dart'), ('application/vnd.data-vision.rdz', 'application/vnd.data-vision.rdz'), ('application/vnd.dece.data', 'application/vnd.dece.data'), ('application/vnd.dece.ttml+xml', 'application/vnd.dece.ttml+xml'), ('application/vnd.dece.unspecified', 'application/vnd.dece.unspecified'), ('application/vnd.dece.zip', 'application/vnd.dece.zip'), ('application/vnd.denovo.fcselayout-link', 'application/vnd.denovo.fcselayout-link'), ('application/vnd.desmume.movie', 'application/vnd.desmume.movie'), ('application/vnd.dir-bi.plate-dl-nosuffix', 'application/vnd.dir-bi.plate-dl-nosuffix'), ('application/vnd.dm.delegation+xml', 'application/vnd.dm.delegation+xml'), ('application/vnd.dna', 'application/vnd.dna'), ('application/vnd.document+json', 'application/vnd.document+json'), ('application/vnd.dolby.mobile.1', 'application/vnd.dolby.mobile.1'), ('application/vnd.dolby.mobile.2', 'application/vnd.dolby.mobile.2'), ('application/vnd.dpgraph', 'application/vnd.dpgraph'), ('application/vnd.dreamfactory', 'application/vnd.dreamfactory'), ('application/vnd.dtg.local', 'application/vnd.dtg.local'), ('application/vnd.dtg.local.flash', 'application/vnd.dtg.local.flash'), ('application/vnd.dtg.local.html', 'application/vnd.dtg.local.html'), ('application/vnd.dvb.ait', 'application/vnd.dvb.ait'), ('application/vnd.dvb.dvbj', 'application/vnd.dvb.dvbj'), ('application/vnd.dvb.esgcontainer', 'application/vnd.dvb.esgcontainer'), ('application/vnd.dvb.ipdcdftnotifaccess', 'application/vnd.dvb.ipdcdftnotifaccess'), ('application/vnd.dvb.ipdcesgaccess', 'application/vnd.dvb.ipdcesgaccess'), ('application/vnd.dvb.ipdcesgaccess2', 'application/vnd.dvb.ipdcesgaccess2'), ('application/vnd.dvb.ipdcesgpdd', 'application/vnd.dvb.ipdcesgpdd'), ('application/vnd.dvb.ipdcroaming', 'application/vnd.dvb.ipdcroaming'), ('application/vnd.dvb.iptv.alfec-base', 'application/vnd.dvb.iptv.alfec-base'), ('application/vnd.dvb.iptv.alfec-enhancement', 'application/vnd.dvb.iptv.alfec-enhancement'), ('application/vnd.dvb.notif-aggregate-root+xml', 'application/vnd.dvb.notif-aggregate-root+xml'), ('application/vnd.dvb.notif-container+xml', 'application/vnd.dvb.notif-container+xml'), ('application/vnd.dvb.notif-generic+xml', 'application/vnd.dvb.notif-generic+xml'), ('application/vnd.dvb.notif-ia-msglist+xml', 'application/vnd.dvb.notif-ia-msglist+xml'), ('application/vnd.dvb.notif-ia-registration-request+xml', 'application/vnd.dvb.notif-ia-registration-request+xml'), ('application/vnd.dvb.notif-ia-registration-response+xml', 'application/vnd.dvb.notif-ia-registration-response+xml'), ('application/vnd.dvb.notif-init+xml', 'application/vnd.dvb.notif-init+xml'), ('application/vnd.dvb.pfr', 'application/vnd.dvb.pfr'), ('application/vnd.dvb.service', 'application/vnd.dvb.service'), ('application/vnd.dxr', 'application/vnd.dxr'), ('application/vnd.dynageo', 'application/vnd.dynageo'), ('application/vnd.easykaraoke.cdgdownload', 'application/vnd.easykaraoke.cdgdownload'), ('application/vnd.ecdis-update', 'application/vnd.ecdis-update'), ('application/vnd.ecowin.chart', 'application/vnd.ecowin.chart'), ('application/vnd.ecowin.filerequest', 'application/vnd.ecowin.filerequest'), ('application/vnd.ecowin.fileupdate', 'application/vnd.ecowin.fileupdate'), ('application/vnd.ecowin.series', 'application/vnd.ecowin.series'), ('application/vnd.ecowin.seriesrequest', 'application/vnd.ecowin.seriesrequest'), ('application/vnd.ecowin.seriesupdate', 'application/vnd.ecowin.seriesupdate'), ('application/vnd.emclient.accessrequest+xml', 'application/vnd.emclient.accessrequest+xml'), ('application/vnd.enliven', 'application/vnd.enliven'), ('application/vnd.eprints.data+xml', 'application/vnd.eprints.data+xml'), ('application/vnd.epson.esf', 'application/vnd.epson.esf'), ('application/vnd.epson.msf', 'application/vnd.epson.msf'), ('application/vnd.epson.quickanime', 'application/vnd.epson.quickanime'), ('application/vnd.epson.salt', 'application/vnd.epson.salt'), ('application/vnd.epson.ssf', 'application/vnd.epson.ssf'), ('application/vnd.ericsson.quickcall', 'application/vnd.ericsson.quickcall'), ('application/vnd.eszigno3+xml', 'application/vnd.eszigno3+xml'), ('application/vnd.etsi.aoc+xml', 'application/vnd.etsi.aoc+xml'), ('application/vnd.etsi.asic-s+zip', 'application/vnd.etsi.asic-s+zip'), ('application/vnd.etsi.asic-e+zip', 'application/vnd.etsi.asic-e+zip'), ('application/vnd.etsi.cug+xml', 'application/vnd.etsi.cug+xml'), ('application/vnd.etsi.iptvcommand+xml', 'application/vnd.etsi.iptvcommand+xml'), ('application/vnd.etsi.iptvdiscovery+xml', 'application/vnd.etsi.iptvdiscovery+xml'), ('application/vnd.etsi.iptvprofile+xml', 'application/vnd.etsi.iptvprofile+xml'), ('application/vnd.etsi.iptvsad-bc+xml', 'application/vnd.etsi.iptvsad-bc+xml'), ('application/vnd.etsi.iptvsad-cod+xml', 'application/vnd.etsi.iptvsad-cod+xml'), ('application/vnd.etsi.iptvsad-npvr+xml', 'application/vnd.etsi.iptvsad-npvr+xml'), ('application/vnd.etsi.iptvservice+xml', 'application/vnd.etsi.iptvservice+xml'), ('application/vnd.etsi.iptvsync+xml', 'application/vnd.etsi.iptvsync+xml'), ('application/vnd.etsi.iptvueprofile+xml', 'application/vnd.etsi.iptvueprofile+xml'), ('application/vnd.etsi.mcid+xml', 'application/vnd.etsi.mcid+xml'), ('application/vnd.etsi.mheg5', 'application/vnd.etsi.mheg5'), ('application/vnd.etsi.overload-control-policy-dataset+xml', 'application/vnd.etsi.overload-control-policy-dataset+xml'), ('application/vnd.etsi.pstn+xml', 'application/vnd.etsi.pstn+xml'), ('application/vnd.etsi.sci+xml', 'application/vnd.etsi.sci+xml'), ('application/vnd.etsi.simservs+xml', 'application/vnd.etsi.simservs+xml'), ('application/vnd.etsi.timestamp-token', 'application/vnd.etsi.timestamp-token'), ('application/vnd.etsi.tsl+xml', 'application/vnd.etsi.tsl+xml'), ('application/vnd.etsi.tsl.der', 'application/vnd.etsi.tsl.der'), ('application/vnd.eudora.data', 'application/vnd.eudora.data'), ('application/vnd.ezpix-album', 'application/vnd.ezpix-album'), ('application/vnd.ezpix-package', 'application/vnd.ezpix-package'), ('application/vnd.f-secure.mobile', 'application/vnd.f-secure.mobile'), ('application/vnd.fdf', 'application/vnd.fdf'), ('application/vnd.fdsn.mseed', 'application/vnd.fdsn.mseed'), ('application/vnd.fdsn.seed', 'application/vnd.fdsn.seed'), ('application/vnd.ffsns', 'application/vnd.ffsns'), ('application/vnd.fints', 'application/vnd.fints'), ('application/vnd.FloGraphIt', 'application/vnd.FloGraphIt'), ('application/vnd.fluxtime.clip', 'application/vnd.fluxtime.clip'), ('application/vnd.font-fontforge-sfd', 'application/vnd.font-fontforge-sfd'), ('application/vnd.framemaker', 'application/vnd.framemaker'), ('application/vnd.frogans.fnc', 'application/vnd.frogans.fnc'), ('application/vnd.frogans.ltf', 'application/vnd.frogans.ltf'), ('application/vnd.fsc.weblaunch', 'application/vnd.fsc.weblaunch'), ('application/vnd.fujitsu.oasys', 'application/vnd.fujitsu.oasys'), ('application/vnd.fujitsu.oasys2', 'application/vnd.fujitsu.oasys2'), ('application/vnd.fujitsu.oasys3', 'application/vnd.fujitsu.oasys3'), ('application/vnd.fujitsu.oasysgp', 'application/vnd.fujitsu.oasysgp'), ('application/vnd.fujitsu.oasysprs', 'application/vnd.fujitsu.oasysprs'), ('application/vnd.fujixerox.ART4', 'application/vnd.fujixerox.ART4'), ('application/vnd.fujixerox.ART-EX', 'application/vnd.fujixerox.ART-EX'), ('application/vnd.fujixerox.ddd', 'application/vnd.fujixerox.ddd'), ('application/vnd.fujixerox.docuworks', 'application/vnd.fujixerox.docuworks'), ('application/vnd.fujixerox.docuworks.binder', 'application/vnd.fujixerox.docuworks.binder'), ('application/vnd.fujixerox.docuworks.container', 'application/vnd.fujixerox.docuworks.container'), ('application/vnd.fujixerox.HBPL', 'application/vnd.fujixerox.HBPL'), ('application/vnd.fut-misnet', 'application/vnd.fut-misnet'), ('application/vnd.fuzzysheet', 'application/vnd.fuzzysheet'), ('application/vnd.genomatix.tuxedo', 'application/vnd.genomatix.tuxedo'), ('application/vnd.geocube+xml', 'application/vnd.geocube+xml'), ('application/vnd.geogebra.file', 'application/vnd.geogebra.file'), ('application/vnd.geogebra.tool', 'application/vnd.geogebra.tool'), ('application/vnd.geometry-explorer', 'application/vnd.geometry-explorer'), ('application/vnd.geonext', 'application/vnd.geonext'), ('application/vnd.geoplan', 'application/vnd.geoplan'), ('application/vnd.geospace', 'application/vnd.geospace'), ('application/vnd.globalplatform.card-content-mgt', 'application/vnd.globalplatform.card-content-mgt'), ('application/vnd.globalplatform.card-content-mgt-response', 'application/vnd.globalplatform.card-content-mgt-response'), ('application/vnd.gmx', 'application/vnd.gmx'), ('application/vnd.google-earth.kml+xml', 'application/vnd.google-earth.kml+xml'), ('application/vnd.google-earth.kmz', 'application/vnd.google-earth.kmz'), ('application/vnd.grafeq', 'application/vnd.grafeq'), ('application/vnd.gridmp', 'application/vnd.gridmp'), ('application/vnd.groove-account', 'application/vnd.groove-account'), ('application/vnd.groove-help', 'application/vnd.groove-help'), ('application/vnd.groove-identity-message', 'application/vnd.groove-identity-message'), ('application/vnd.groove-injector', 'application/vnd.groove-injector'), ('application/vnd.groove-tool-message', 'application/vnd.groove-tool-message'), ('application/vnd.groove-tool-template', 'application/vnd.groove-tool-template'), ('application/vnd.groove-vcard', 'application/vnd.groove-vcard'), ('application/vnd.hal+json', 'application/vnd.hal+json'), ('application/vnd.hal+xml', 'application/vnd.hal+xml'), ('application/vnd.HandHeld-Entertainment+xml', 'application/vnd.HandHeld-Entertainment+xml'), ('application/vnd.hbci', 'application/vnd.hbci'), ('application/vnd.hcl-bireports', 'application/vnd.hcl-bireports'), ('application/vnd.heroku+json', 'application/vnd.heroku+json'), ('application/vnd.hhe.lesson-player', 'application/vnd.hhe.lesson-player'), ('application/vnd.hp-HPGL', 'application/vnd.hp-HPGL'), ('application/vnd.hp-hpid', 'application/vnd.hp-hpid'), ('application/vnd.hp-hps', 'application/vnd.hp-hps'), ('application/vnd.hp-jlyt', 'application/vnd.hp-jlyt'), ('application/vnd.hp-PCL', 'application/vnd.hp-PCL'), ('application/vnd.hp-PCLXL', 'application/vnd.hp-PCLXL'), ('application/vnd.httphone', 'application/vnd.httphone'), ('application/vnd.hydrostatix.sof-data', 'application/vnd.hydrostatix.sof-data'), ('application/vnd.hzn-3d-crossword', 'application/vnd.hzn-3d-crossword'), ('application/vnd.ibm.afplinedata', 'application/vnd.ibm.afplinedata'), ('application/vnd.ibm.electronic-media', 'application/vnd.ibm.electronic-media'), ('application/vnd.ibm.MiniPay', 'application/vnd.ibm.MiniPay'), ('application/vnd.ibm.modcap', 'application/vnd.ibm.modcap'), ('application/vnd.ibm.rights-management', 'application/vnd.ibm.rights-management'), ('application/vnd.ibm.secure-container', 'application/vnd.ibm.secure-container'), ('application/vnd.iccprofile', 'application/vnd.iccprofile'), ('application/vnd.ieee.1905', 'application/vnd.ieee.1905'), ('application/vnd.igloader', 'application/vnd.igloader'), ('application/vnd.immervision-ivp', 'application/vnd.immervision-ivp'), ('application/vnd.immervision-ivu', 'application/vnd.immervision-ivu'), ('application/vnd.informedcontrol.rms+xml', 'application/vnd.informedcontrol.rms+xml'), ('application/vnd.infotech.project', 'application/vnd.infotech.project'), ('application/vnd.infotech.project+xml', 'application/vnd.infotech.project+xml'), ('application/vnd.informix-visionary', 'application/vnd.informix-visionary'), ('application/vnd.innopath.wamp.notification', 'application/vnd.innopath.wamp.notification'), ('application/vnd.insors.igm', 'application/vnd.insors.igm'), ('application/vnd.intercon.formnet', 'application/vnd.intercon.formnet'), ('application/vnd.intergeo', 'application/vnd.intergeo'), ('application/vnd.intertrust.digibox', 'application/vnd.intertrust.digibox'), ('application/vnd.intertrust.nncp', 'application/vnd.intertrust.nncp'), ('application/vnd.intu.qbo', 'application/vnd.intu.qbo'), ('application/vnd.intu.qfx', 'application/vnd.intu.qfx'), ('application/vnd.iptc.g2.catalogitem+xml', 'application/vnd.iptc.g2.catalogitem+xml'), ('application/vnd.iptc.g2.conceptitem+xml', 'application/vnd.iptc.g2.conceptitem+xml'), ('application/vnd.iptc.g2.knowledgeitem+xml', 'application/vnd.iptc.g2.knowledgeitem+xml'), ('application/vnd.iptc.g2.newsitem+xml', 'application/vnd.iptc.g2.newsitem+xml'), ('application/vnd.iptc.g2.newsmessage+xml', 'application/vnd.iptc.g2.newsmessage+xml'), ('application/vnd.iptc.g2.packageitem+xml', 'application/vnd.iptc.g2.packageitem+xml'), ('application/vnd.iptc.g2.planningitem+xml', 'application/vnd.iptc.g2.planningitem+xml'), ('application/vnd.ipunplugged.rcprofile', 'application/vnd.ipunplugged.rcprofile'), ('application/vnd.irepository.package+xml', 'application/vnd.irepository.package+xml'), ('application/vnd.is-xpr', 'application/vnd.is-xpr'), ('application/vnd.isac.fcs', 'application/vnd.isac.fcs'), ('application/vnd.jam', 'application/vnd.jam'), ('application/vnd.japannet-directory-service', 'application/vnd.japannet-directory-service'), ('application/vnd.japannet-jpnstore-wakeup', 'application/vnd.japannet-jpnstore-wakeup'), ('application/vnd.japannet-payment-wakeup', 'application/vnd.japannet-payment-wakeup'), ('application/vnd.japannet-registration', 'application/vnd.japannet-registration'), ('application/vnd.japannet-registration-wakeup', 'application/vnd.japannet-registration-wakeup'), ('application/vnd.japannet-setstore-wakeup', 'application/vnd.japannet-setstore-wakeup'), ('application/vnd.japannet-verification', 'application/vnd.japannet-verification'), ('application/vnd.japannet-verification-wakeup', 'application/vnd.japannet-verification-wakeup'), ('application/vnd.jcp.javame.midlet-rms', 'application/vnd.jcp.javame.midlet-rms'), ('application/vnd.jisp', 'application/vnd.jisp'), ('application/vnd.joost.joda-archive', 'application/vnd.joost.joda-archive'), ('application/vnd.jsk.isdn-ngn', 'application/vnd.jsk.isdn-ngn'), ('application/vnd.kahootz', 'application/vnd.kahootz'), ('application/vnd.kde.karbon', 'application/vnd.kde.karbon'), ('application/vnd.kde.kchart', 'application/vnd.kde.kchart'), ('application/vnd.kde.kformula', 'application/vnd.kde.kformula'), ('application/vnd.kde.kivio', 'application/vnd.kde.kivio'), ('application/vnd.kde.kontour', 'application/vnd.kde.kontour'), ('application/vnd.kde.kpresenter', 'application/vnd.kde.kpresenter'), ('application/vnd.kde.kspread', 'application/vnd.kde.kspread'), ('application/vnd.kde.kword', 'application/vnd.kde.kword'), ('application/vnd.kenameaapp', 'application/vnd.kenameaapp'), ('application/vnd.kidspiration', 'application/vnd.kidspiration'), ('application/vnd.Kinar', 'application/vnd.Kinar'), ('application/vnd.koan', 'application/vnd.koan'), ('application/vnd.kodak-descriptor', 'application/vnd.kodak-descriptor'), ('application/vnd.las.las+xml', 'application/vnd.las.las+xml'), ('application/vnd.liberty-request+xml', 'application/vnd.liberty-request+xml'), ('application/vnd.llamagraphics.life-balance.desktop', 'application/vnd.llamagraphics.life-balance.desktop'), ('application/vnd.llamagraphics.life-balance.exchange+xml', 'application/vnd.llamagraphics.life-balance.exchange+xml'), ('application/vnd.lotus-1-2-3', 'application/vnd.lotus-1-2-3'), ('application/vnd.lotus-approach', 'application/vnd.lotus-approach'), ('application/vnd.lotus-freelance', 'application/vnd.lotus-freelance'), ('application/vnd.lotus-notes', 'application/vnd.lotus-notes'), ('application/vnd.lotus-organizer', 'application/vnd.lotus-organizer'), ('application/vnd.lotus-screencam', 'application/vnd.lotus-screencam'), ('application/vnd.lotus-wordpro', 'application/vnd.lotus-wordpro'), ('application/vnd.macports.portpkg', 'application/vnd.macports.portpkg'), ('application/vnd.marlin.drm.actiontoken+xml', 'application/vnd.marlin.drm.actiontoken+xml'), ('application/vnd.marlin.drm.conftoken+xml', 'application/vnd.marlin.drm.conftoken+xml'), ('application/vnd.marlin.drm.license+xml', 'application/vnd.marlin.drm.license+xml'), ('application/vnd.marlin.drm.mdcf', 'application/vnd.marlin.drm.mdcf'), ('application/vnd.mason+json', 'application/vnd.mason+json'), ('application/vnd.mcd', 'application/vnd.mcd'), ('application/vnd.medcalcdata', 'application/vnd.medcalcdata'), ('application/vnd.mediastation.cdkey', 'application/vnd.mediastation.cdkey'), ('application/vnd.meridian-slingshot', 'application/vnd.meridian-slingshot'), ('application/vnd.MFER', 'application/vnd.MFER'), ('application/vnd.mfmp', 'application/vnd.mfmp'), ('application/vnd.micrografx.flo', 'application/vnd.micrografx.flo'), ('application/vnd.micrografx.igx', 'application/vnd.micrografx.igx'), ('application/vnd.mif', 'application/vnd.mif'), ('application/vnd.minisoft-hp3000-save', 'application/vnd.minisoft-hp3000-save'), ('application/vnd.mitsubishi.misty-guard.trustweb', 'application/vnd.mitsubishi.misty-guard.trustweb'), ('application/vnd.Mobius.DAF', 'application/vnd.Mobius.DAF'), ('application/vnd.Mobius.DIS', 'application/vnd.Mobius.DIS'), ('application/vnd.Mobius.MBK', 'application/vnd.Mobius.MBK'), ('application/vnd.Mobius.MQY', 'application/vnd.Mobius.MQY'), ('application/vnd.Mobius.MSL', 'application/vnd.Mobius.MSL'), ('application/vnd.Mobius.PLC', 'application/vnd.Mobius.PLC'), ('application/vnd.Mobius.TXF', 'application/vnd.Mobius.TXF'), ('application/vnd.mophun.application', 'application/vnd.mophun.application'), ('application/vnd.mophun.certificate', 'application/vnd.mophun.certificate'), ('application/vnd.motorola.flexsuite', 'application/vnd.motorola.flexsuite'), ('application/vnd.motorola.flexsuite.adsi', 'application/vnd.motorola.flexsuite.adsi'), ('application/vnd.motorola.flexsuite.fis', 'application/vnd.motorola.flexsuite.fis'), ('application/vnd.motorola.flexsuite.gotap', 'application/vnd.motorola.flexsuite.gotap'), ('application/vnd.motorola.flexsuite.kmr', 'application/vnd.motorola.flexsuite.kmr'), ('application/vnd.motorola.flexsuite.ttc', 'application/vnd.motorola.flexsuite.ttc'), ('application/vnd.motorola.flexsuite.wem', 'application/vnd.motorola.flexsuite.wem'), ('application/vnd.motorola.iprm', 'application/vnd.motorola.iprm'), ('application/vnd.mozilla.xul+xml', 'application/vnd.mozilla.xul+xml'), ('application/vnd.ms-artgalry', 'application/vnd.ms-artgalry'), ('application/vnd.ms-asf', 'application/vnd.ms-asf'), ('application/vnd.ms-cab-compressed', 'application/vnd.ms-cab-compressed'), ('application/vnd.mseq', 'application/vnd.mseq'), ('application/vnd.ms-excel', 'application/vnd.ms-excel'), ('application/vnd.ms-excel.addin.macroEnabled.12', 'application/vnd.ms-excel.addin.macroEnabled.12'), ('application/vnd.ms-excel.sheet.binary.macroEnabled.12', 'application/vnd.ms-excel.sheet.binary.macroEnabled.12'), ('application/vnd.ms-excel.sheet.macroEnabled.12', 'application/vnd.ms-excel.sheet.macroEnabled.12'), ('application/vnd.ms-excel.template.macroEnabled.12', 'application/vnd.ms-excel.template.macroEnabled.12'), ('application/vnd.ms-fontobject', 'application/vnd.ms-fontobject'), ('application/vnd.ms-htmlhelp', 'application/vnd.ms-htmlhelp'), ('application/vnd.ms-ims', 'application/vnd.ms-ims'), ('application/vnd.ms-lrm', 'application/vnd.ms-lrm'), ('application/vnd.ms-office.activeX+xml', 'application/vnd.ms-office.activeX+xml'), ('application/vnd.ms-officetheme', 'application/vnd.ms-officetheme'), ('application/vnd.ms-playready.initiator+xml', 'application/vnd.ms-playready.initiator+xml'), ('application/vnd.ms-powerpoint', 'application/vnd.ms-powerpoint'), ('application/vnd.ms-powerpoint.addin.macroEnabled.12', 'application/vnd.ms-powerpoint.addin.macroEnabled.12'), ('application/vnd.ms-powerpoint.presentation.macroEnabled.12', 'application/vnd.ms-powerpoint.presentation.macroEnabled.12'), ('application/vnd.ms-powerpoint.slide.macroEnabled.12', 'application/vnd.ms-powerpoint.slide.macroEnabled.12'), ('application/vnd.ms-powerpoint.slideshow.macroEnabled.12', 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12'), ('application/vnd.ms-powerpoint.template.macroEnabled.12', 'application/vnd.ms-powerpoint.template.macroEnabled.12'), ('application/vnd.ms-project', 'application/vnd.ms-project'), ('application/vnd.ms-tnef', 'application/vnd.ms-tnef'), ('application/vnd.ms-windows.printerpairing', 'application/vnd.ms-windows.printerpairing'), ('application/vnd.ms-wmdrm.lic-chlg-req', 'application/vnd.ms-wmdrm.lic-chlg-req'), ('application/vnd.ms-wmdrm.lic-resp', 'application/vnd.ms-wmdrm.lic-resp'), ('application/vnd.ms-wmdrm.meter-chlg-req', 'application/vnd.ms-wmdrm.meter-chlg-req'), ('application/vnd.ms-wmdrm.meter-resp', 'application/vnd.ms-wmdrm.meter-resp'), ('application/vnd.ms-word.document.macroEnabled.12', 'application/vnd.ms-word.document.macroEnabled.12'), ('application/vnd.ms-word.template.macroEnabled.12', 'application/vnd.ms-word.template.macroEnabled.12'), ('application/vnd.ms-works', 'application/vnd.ms-works'), ('application/vnd.ms-wpl', 'application/vnd.ms-wpl'), ('application/vnd.ms-xpsdocument', 'application/vnd.ms-xpsdocument'), ('application/vnd.msign', 'application/vnd.msign'), ('application/vnd.multiad.creator', 'application/vnd.multiad.creator'), ('application/vnd.multiad.creator.cif', 'application/vnd.multiad.creator.cif'), ('application/vnd.musician', 'application/vnd.musician'), ('application/vnd.music-niff', 'application/vnd.music-niff'), ('application/vnd.muvee.style', 'application/vnd.muvee.style'), ('application/vnd.mynfc', 'application/vnd.mynfc'), ('application/vnd.ncd.control', 'application/vnd.ncd.control'), ('application/vnd.ncd.reference', 'application/vnd.ncd.reference'), ('application/vnd.nervana', 'application/vnd.nervana'), ('application/vnd.netfpx', 'application/vnd.netfpx'), ('application/vnd.neurolanguage.nlu', 'application/vnd.neurolanguage.nlu'), ('application/vnd.nintendo.snes.rom', 'application/vnd.nintendo.snes.rom'), ('application/vnd.nintendo.nitro.rom', 'application/vnd.nintendo.nitro.rom'), ('application/vnd.nitf', 'application/vnd.nitf'), ('application/vnd.noblenet-directory', 'application/vnd.noblenet-directory'), ('application/vnd.noblenet-sealer', 'application/vnd.noblenet-sealer'), ('application/vnd.noblenet-web', 'application/vnd.noblenet-web'), ('application/vnd.nokia.catalogs', 'application/vnd.nokia.catalogs'), ('application/vnd.nokia.conml+wbxml', 'application/vnd.nokia.conml+wbxml'), ('application/vnd.nokia.conml+xml', 'application/vnd.nokia.conml+xml'), ('application/vnd.nokia.iptv.config+xml', 'application/vnd.nokia.iptv.config+xml'), ('application/vnd.nokia.iSDS-radio-presets', 'application/vnd.nokia.iSDS-radio-presets'), ('application/vnd.nokia.landmark+wbxml', 'application/vnd.nokia.landmark+wbxml'), ('application/vnd.nokia.landmark+xml', 'application/vnd.nokia.landmark+xml'), ('application/vnd.nokia.landmarkcollection+xml', 'application/vnd.nokia.landmarkcollection+xml'), ('application/vnd.nokia.ncd', 'application/vnd.nokia.ncd'), ('application/vnd.nokia.n-gage.ac+xml', 'application/vnd.nokia.n-gage.ac+xml'), ('application/vnd.nokia.n-gage.data', 'application/vnd.nokia.n-gage.data'), ('application/vnd.nokia.n-gage.symbian.install', 'application/vnd.nokia.n-gage.symbian.install'), ('application/vnd.nokia.pcd+wbxml', 'application/vnd.nokia.pcd+wbxml'), ('application/vnd.nokia.pcd+xml', 'application/vnd.nokia.pcd+xml'), ('application/vnd.nokia.radio-preset', 'application/vnd.nokia.radio-preset'), ('application/vnd.nokia.radio-presets', 'application/vnd.nokia.radio-presets'), ('application/vnd.novadigm.EDM', 'application/vnd.novadigm.EDM'), ('application/vnd.novadigm.EDX', 'application/vnd.novadigm.EDX'), ('application/vnd.novadigm.EXT', 'application/vnd.novadigm.EXT'), ('application/vnd.ntt-local.content-share', 'application/vnd.ntt-local.content-share'), ('application/vnd.ntt-local.file-transfer', 'application/vnd.ntt-local.file-transfer'), ('application/vnd.ntt-local.sip-ta_remote', 'application/vnd.ntt-local.sip-ta_remote'), ('application/vnd.ntt-local.sip-ta_tcp_stream', 'application/vnd.ntt-local.sip-ta_tcp_stream'), ('application/vnd.oasis.opendocument.chart', 'application/vnd.oasis.opendocument.chart'), ('application/vnd.oasis.opendocument.chart-template', 'application/vnd.oasis.opendocument.chart-template'), ('application/vnd.oasis.opendocument.database', 'application/vnd.oasis.opendocument.database'), ('application/vnd.oasis.opendocument.formula', 'application/vnd.oasis.opendocument.formula'), ('application/vnd.oasis.opendocument.formula-template', 'application/vnd.oasis.opendocument.formula-template'), ('application/vnd.oasis.opendocument.graphics', 'application/vnd.oasis.opendocument.graphics'), ('application/vnd.oasis.opendocument.graphics-template', 'application/vnd.oasis.opendocument.graphics-template'), ('application/vnd.oasis.opendocument.image', 'application/vnd.oasis.opendocument.image'), ('application/vnd.oasis.opendocument.image-template', 'application/vnd.oasis.opendocument.image-template'), ('application/vnd.oasis.opendocument.presentation', 'application/vnd.oasis.opendocument.presentation'), ('application/vnd.oasis.opendocument.presentation-template', 'application/vnd.oasis.opendocument.presentation-template'), ('application/vnd.oasis.opendocument.spreadsheet', 'application/vnd.oasis.opendocument.spreadsheet'), ('application/vnd.oasis.opendocument.spreadsheet-template', 'application/vnd.oasis.opendocument.spreadsheet-template'), ('application/vnd.oasis.opendocument.text', 'application/vnd.oasis.opendocument.text'), ('application/vnd.oasis.opendocument.text-master', 'application/vnd.oasis.opendocument.text-master'), ('application/vnd.oasis.opendocument.text-template', 'application/vnd.oasis.opendocument.text-template'), ('application/vnd.oasis.opendocument.text-web', 'application/vnd.oasis.opendocument.text-web'), ('application/vnd.obn', 'application/vnd.obn'), ('application/vnd.oftn.l10n+json', 'application/vnd.oftn.l10n+json'), ('application/vnd.oipf.contentaccessdownload+xml', 'application/vnd.oipf.contentaccessdownload+xml'), ('application/vnd.oipf.contentaccessstreaming+xml', 'application/vnd.oipf.contentaccessstreaming+xml'), ('application/vnd.oipf.cspg-hexbinary', 'application/vnd.oipf.cspg-hexbinary'), ('application/vnd.oipf.dae.svg+xml', 'application/vnd.oipf.dae.svg+xml'), ('application/vnd.oipf.dae.xhtml+xml', 'application/vnd.oipf.dae.xhtml+xml'), ('application/vnd.oipf.mippvcontrolmessage+xml', 'application/vnd.oipf.mippvcontrolmessage+xml'), ('application/vnd.oipf.pae.gem', 'application/vnd.oipf.pae.gem'), ('application/vnd.oipf.spdiscovery+xml', 'application/vnd.oipf.spdiscovery+xml'), ('application/vnd.oipf.spdlist+xml', 'application/vnd.oipf.spdlist+xml'), ('application/vnd.oipf.ueprofile+xml', 'application/vnd.oipf.ueprofile+xml'), ('application/vnd.oipf.userprofile+xml', 'application/vnd.oipf.userprofile+xml'), ('application/vnd.olpc-sugar', 'application/vnd.olpc-sugar'), ('application/vnd.oma.bcast.associated-procedure-parameter+xml', 'application/vnd.oma.bcast.associated-procedure-parameter+xml'), ('application/vnd.oma.bcast.drm-trigger+xml', 'application/vnd.oma.bcast.drm-trigger+xml'), ('application/vnd.oma.bcast.imd+xml', 'application/vnd.oma.bcast.imd+xml'), ('application/vnd.oma.bcast.ltkm', 'application/vnd.oma.bcast.ltkm'), ('application/vnd.oma.bcast.notification+xml', 'application/vnd.oma.bcast.notification+xml'), ('application/vnd.oma.bcast.provisioningtrigger', 'application/vnd.oma.bcast.provisioningtrigger'), ('application/vnd.oma.bcast.sgboot', 'application/vnd.oma.bcast.sgboot'), ('application/vnd.oma.bcast.sgdd+xml', 'application/vnd.oma.bcast.sgdd+xml'), ('application/vnd.oma.bcast.sgdu', 'application/vnd.oma.bcast.sgdu'), ('application/vnd.oma.bcast.simple-symbol-container', 'application/vnd.oma.bcast.simple-symbol-container'), ('application/vnd.oma.bcast.smartcard-trigger+xml', 'application/vnd.oma.bcast.smartcard-trigger+xml'), ('application/vnd.oma.bcast.sprov+xml', 'application/vnd.oma.bcast.sprov+xml'), ('application/vnd.oma.bcast.stkm', 'application/vnd.oma.bcast.stkm'), ('application/vnd.oma.cab-address-book+xml', 'application/vnd.oma.cab-address-book+xml'), ('application/vnd.oma.cab-feature-handler+xml', 'application/vnd.oma.cab-feature-handler+xml'), ('application/vnd.oma.cab-pcc+xml', 'application/vnd.oma.cab-pcc+xml'), ('application/vnd.oma.cab-subs-invite+xml', 'application/vnd.oma.cab-subs-invite+xml'), ('application/vnd.oma.cab-user-prefs+xml', 'application/vnd.oma.cab-user-prefs+xml'), ('application/vnd.oma.dcd', 'application/vnd.oma.dcd'), ('application/vnd.oma.dcdc', 'application/vnd.oma.dcdc'), ('application/vnd.oma.dd2+xml', 'application/vnd.oma.dd2+xml'), ('application/vnd.oma.drm.risd+xml', 'application/vnd.oma.drm.risd+xml'), ('application/vnd.oma.group-usage-list+xml', 'application/vnd.oma.group-usage-list+xml'), ('application/vnd.oma.pal+xml', 'application/vnd.oma.pal+xml'), ('application/vnd.oma.poc.detailed-progress-report+xml', 'application/vnd.oma.poc.detailed-progress-report+xml'), ('application/vnd.oma.poc.final-report+xml', 'application/vnd.oma.poc.final-report+xml'), ('application/vnd.oma.poc.groups+xml', 'application/vnd.oma.poc.groups+xml'), ('application/vnd.oma.poc.invocation-descriptor+xml', 'application/vnd.oma.poc.invocation-descriptor+xml'), ('application/vnd.oma.poc.optimized-progress-report+xml', 'application/vnd.oma.poc.optimized-progress-report+xml'), ('application/vnd.oma.push', 'application/vnd.oma.push'), ('application/vnd.oma.scidm.messages+xml', 'application/vnd.oma.scidm.messages+xml'), ('application/vnd.oma.xcap-directory+xml', 'application/vnd.oma.xcap-directory+xml'), ('application/vnd.omads-email+xml', 'application/vnd.omads-email+xml'), ('application/vnd.omads-file+xml', 'application/vnd.omads-file+xml'), ('application/vnd.omads-folder+xml', 'application/vnd.omads-folder+xml'), ('application/vnd.omaloc-supl-init', 'application/vnd.omaloc-supl-init'), ('application/vnd.oma-scws-config', 'application/vnd.oma-scws-config'), ('application/vnd.oma-scws-http-request', 'application/vnd.oma-scws-http-request'), ('application/vnd.oma-scws-http-response', 'application/vnd.oma-scws-http-response'), ('application/vnd.openeye.oeb', 'application/vnd.openeye.oeb'), ('application/vnd.openxmlformats-officedocument.custom-properties+xml', 'application/vnd.openxmlformats-officedocument.custom-properties+xml'), ('application/vnd.openxmlformats-officedocument.customXmlProperties+xml', 'application/vnd.openxmlformats-officedocument.customXmlProperties+xml'), ('application/vnd.openxmlformats-officedocument.drawing+xml', 'application/vnd.openxmlformats-officedocument.drawing+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chart+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chart+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml'), ('application/vnd.openxmlformats-officedocument.extended-properties+xml', 'application/vnd.openxmlformats-officedocument.extended-properties+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml', 'application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.comments+xml', 'application/vnd.openxmlformats-officedocument.presentationml.comments+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation', 'application/vnd.openxmlformats-officedocument.presentationml.presentation'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presProps+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slide', 'application/vnd.openxmlformats-officedocument.presentationml.slide'), ('application/vnd.openxmlformats-officedocument.presentationml.slide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tags+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tags+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.template', 'application/vnd.openxmlformats-officedocument.presentationml.template'), ('application/vnd.openxmlformats-officedocument.presentationml.template.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml'), ('application/vnd.openxmlformats-officedocument.theme+xml', 'application/vnd.openxmlformats-officedocument.theme+xml'), ('application/vnd.openxmlformats-officedocument.themeOverride+xml', 'application/vnd.openxmlformats-officedocument.themeOverride+xml'), ('application/vnd.openxmlformats-officedocument.vmlDrawing', 'application/vnd.openxmlformats-officedocument.vmlDrawing'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml'), ('application/vnd.openxmlformats-package.core-properties+xml', 'application/vnd.openxmlformats-package.core-properties+xml'), ('application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml', 'application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml'), ('application/vnd.openxmlformats-package.relationships+xml', 'application/vnd.openxmlformats-package.relationships+xml'), ('application/vnd.orange.indata', 'application/vnd.orange.indata'), ('application/vnd.osa.netdeploy', 'application/vnd.osa.netdeploy'), ('application/vnd.osgeo.mapguide.package', 'application/vnd.osgeo.mapguide.package'), ('application/vnd.osgi.bundle', 'application/vnd.osgi.bundle'), ('application/vnd.osgi.dp', 'application/vnd.osgi.dp'), ('application/vnd.osgi.subsystem', 'application/vnd.osgi.subsystem'), ('application/vnd.otps.ct-kip+xml', 'application/vnd.otps.ct-kip+xml'), ('application/vnd.palm', 'application/vnd.palm'), ('application/vnd.paos.xml', 'application/vnd.paos.xml'), ('application/vnd.pawaafile', 'application/vnd.pawaafile'), ('application/vnd.pcos', 'application/vnd.pcos'), ('application/vnd.pg.format', 'application/vnd.pg.format'), ('application/vnd.pg.osasli', 'application/vnd.pg.osasli'), ('application/vnd.piaccess.application-licence', 'application/vnd.piaccess.application-licence'), ('application/vnd.picsel', 'application/vnd.picsel'), ('application/vnd.pmi.widget', 'application/vnd.pmi.widget'), ('application/vnd.poc.group-advertisement+xml', 'application/vnd.poc.group-advertisement+xml'), ('application/vnd.pocketlearn', 'application/vnd.pocketlearn'), ('application/vnd.powerbuilder6', 'application/vnd.powerbuilder6'), ('application/vnd.powerbuilder6-s', 'application/vnd.powerbuilder6-s'), ('application/vnd.powerbuilder7', 'application/vnd.powerbuilder7'), ('application/vnd.powerbuilder75', 'application/vnd.powerbuilder75'), ('application/vnd.powerbuilder75-s', 'application/vnd.powerbuilder75-s'), ('application/vnd.powerbuilder7-s', 'application/vnd.powerbuilder7-s'), ('application/vnd.preminet', 'application/vnd.preminet'), ('application/vnd.previewsystems.box', 'application/vnd.previewsystems.box'), ('application/vnd.proteus.magazine', 'application/vnd.proteus.magazine'), ('application/vnd.publishare-delta-tree', 'application/vnd.publishare-delta-tree'), ('application/vnd.pvi.ptid1', 'application/vnd.pvi.ptid1'), ('application/vnd.pwg-multiplexed', 'application/vnd.pwg-multiplexed'), ('application/vnd.pwg-xhtml-print+xml', 'application/vnd.pwg-xhtml-print+xml'), ('application/vnd.qualcomm.brew-app-res', 'application/vnd.qualcomm.brew-app-res'), ('application/vnd.Quark.QuarkXPress', 'application/vnd.Quark.QuarkXPress'), ('application/vnd.quobject-quoxdocument', 'application/vnd.quobject-quoxdocument'), ('application/vnd.radisys.moml+xml', 'application/vnd.radisys.moml+xml'), ('application/vnd.radisys.msml-audit-conf+xml', 'application/vnd.radisys.msml-audit-conf+xml'), ('application/vnd.radisys.msml-audit-conn+xml', 'application/vnd.radisys.msml-audit-conn+xml'), ('application/vnd.radisys.msml-audit-dialog+xml', 'application/vnd.radisys.msml-audit-dialog+xml'), ('application/vnd.radisys.msml-audit-stream+xml', 'application/vnd.radisys.msml-audit-stream+xml'), ('application/vnd.radisys.msml-audit+xml', 'application/vnd.radisys.msml-audit+xml'), ('application/vnd.radisys.msml-conf+xml', 'application/vnd.radisys.msml-conf+xml'), ('application/vnd.radisys.msml-dialog-base+xml', 'application/vnd.radisys.msml-dialog-base+xml'), ('application/vnd.radisys.msml-dialog-fax-detect+xml', 'application/vnd.radisys.msml-dialog-fax-detect+xml'), ('application/vnd.radisys.msml-dialog-fax-sendrecv+xml', 'application/vnd.radisys.msml-dialog-fax-sendrecv+xml'), ('application/vnd.radisys.msml-dialog-group+xml', 'application/vnd.radisys.msml-dialog-group+xml'), ('application/vnd.radisys.msml-dialog-speech+xml', 'application/vnd.radisys.msml-dialog-speech+xml'), ('application/vnd.radisys.msml-dialog-transform+xml', 'application/vnd.radisys.msml-dialog-transform+xml'), ('application/vnd.radisys.msml-dialog+xml', 'application/vnd.radisys.msml-dialog+xml'), ('application/vnd.radisys.msml+xml', 'application/vnd.radisys.msml+xml'), ('application/vnd.rainstor.data', 'application/vnd.rainstor.data'), ('application/vnd.rapid', 'application/vnd.rapid'), ('application/vnd.realvnc.bed', 'application/vnd.realvnc.bed'), ('application/vnd.recordare.musicxml', 'application/vnd.recordare.musicxml'), ('application/vnd.recordare.musicxml+xml', 'application/vnd.recordare.musicxml+xml'), ('application/vnd.RenLearn.rlprint', 'application/vnd.RenLearn.rlprint'), ('application/vnd.rig.cryptonote', 'application/vnd.rig.cryptonote'), ('application/vnd.route66.link66+xml', 'application/vnd.route66.link66+xml'), ('application/vnd.rs-274x', 'application/vnd.rs-274x'), ('application/vnd.ruckus.download', 'application/vnd.ruckus.download'), ('application/vnd.s3sms', 'application/vnd.s3sms'), ('application/vnd.sailingtracker.track', 'application/vnd.sailingtracker.track'), ('application/vnd.sbm.cid', 'application/vnd.sbm.cid'), ('application/vnd.sbm.mid2', 'application/vnd.sbm.mid2'), ('application/vnd.scribus', 'application/vnd.scribus'), ('application/vnd.sealed.3df', 'application/vnd.sealed.3df'), ('application/vnd.sealed.csf', 'application/vnd.sealed.csf'), ('application/vnd.sealed.doc', 'application/vnd.sealed.doc'), ('application/vnd.sealed.eml', 'application/vnd.sealed.eml'), ('application/vnd.sealed.mht', 'application/vnd.sealed.mht'), ('application/vnd.sealed.net', 'application/vnd.sealed.net'), ('application/vnd.sealed.ppt', 'application/vnd.sealed.ppt'), ('application/vnd.sealed.tiff', 'application/vnd.sealed.tiff'), ('application/vnd.sealed.xls', 'application/vnd.sealed.xls'), ('application/vnd.sealedmedia.softseal.html', 'application/vnd.sealedmedia.softseal.html'), ('application/vnd.sealedmedia.softseal.pdf', 'application/vnd.sealedmedia.softseal.pdf'), ('application/vnd.seemail', 'application/vnd.seemail'), ('application/vnd.sema', 'application/vnd.sema'), ('application/vnd.semd', 'application/vnd.semd'), ('application/vnd.semf', 'application/vnd.semf'), ('application/vnd.shana.informed.formdata', 'application/vnd.shana.informed.formdata'), ('application/vnd.shana.informed.formtemplate', 'application/vnd.shana.informed.formtemplate'), ('application/vnd.shana.informed.interchange', 'application/vnd.shana.informed.interchange'), ('application/vnd.shana.informed.package', 'application/vnd.shana.informed.package'), ('application/vnd.SimTech-MindMapper', 'application/vnd.SimTech-MindMapper'), ('application/vnd.siren+json', 'application/vnd.siren+json'), ('application/vnd.smaf', 'application/vnd.smaf'), ('application/vnd.smart.notebook', 'application/vnd.smart.notebook'), ('application/vnd.smart.teacher', 'application/vnd.smart.teacher'), ('application/vnd.software602.filler.form+xml', 'application/vnd.software602.filler.form+xml'), ('application/vnd.software602.filler.form-xml-zip', 'application/vnd.software602.filler.form-xml-zip'), ('application/vnd.solent.sdkm+xml', 'application/vnd.solent.sdkm+xml'), ('application/vnd.spotfire.dxp', 'application/vnd.spotfire.dxp'), ('application/vnd.spotfire.sfs', 'application/vnd.spotfire.sfs'), ('application/vnd.sss-cod', 'application/vnd.sss-cod'), ('application/vnd.sss-dtf', 'application/vnd.sss-dtf'), ('application/vnd.sss-ntf', 'application/vnd.sss-ntf'), ('application/vnd.stepmania.package', 'application/vnd.stepmania.package'), ('application/vnd.stepmania.stepchart', 'application/vnd.stepmania.stepchart'), ('application/vnd.street-stream', 'application/vnd.street-stream'), ('application/vnd.sun.wadl+xml', 'application/vnd.sun.wadl+xml'), ('application/vnd.sus-calendar', 'application/vnd.sus-calendar'), ('application/vnd.svd', 'application/vnd.svd'), ('application/vnd.swiftview-ics', 'application/vnd.swiftview-ics'), ('application/vnd.syncml.dm.notification', 'application/vnd.syncml.dm.notification'), ('application/vnd.syncml.dmddf+xml', 'application/vnd.syncml.dmddf+xml'), ('application/vnd.syncml.dmtnds+wbxml', 'application/vnd.syncml.dmtnds+wbxml'), ('application/vnd.syncml.dmtnds+xml', 'application/vnd.syncml.dmtnds+xml'), ('application/vnd.syncml.dmddf+wbxml', 'application/vnd.syncml.dmddf+wbxml'), ('application/vnd.syncml.dm+wbxml', 'application/vnd.syncml.dm+wbxml'), ('application/vnd.syncml.dm+xml', 'application/vnd.syncml.dm+xml'), ('application/vnd.syncml.ds.notification', 'application/vnd.syncml.ds.notification'), ('application/vnd.syncml+xml', 'application/vnd.syncml+xml'), ('application/vnd.tao.intent-module-archive', 'application/vnd.tao.intent-module-archive'), ('application/vnd.tcpdump.pcap', 'application/vnd.tcpdump.pcap'), ('application/vnd.tmobile-livetv', 'application/vnd.tmobile-livetv'), ('application/vnd.trid.tpt', 'application/vnd.trid.tpt'), ('application/vnd.triscape.mxs', 'application/vnd.triscape.mxs'), ('application/vnd.trueapp', 'application/vnd.trueapp'), ('application/vnd.truedoc', 'application/vnd.truedoc'), ('application/vnd.ubisoft.webplayer', 'application/vnd.ubisoft.webplayer'), ('application/vnd.ufdl', 'application/vnd.ufdl'), ('application/vnd.uiq.theme', 'application/vnd.uiq.theme'), ('application/vnd.umajin', 'application/vnd.umajin'), ('application/vnd.unity', 'application/vnd.unity'), ('application/vnd.uoml+xml', 'application/vnd.uoml+xml'), ('application/vnd.uplanet.alert', 'application/vnd.uplanet.alert'), ('application/vnd.uplanet.alert-wbxml', 'application/vnd.uplanet.alert-wbxml'), ('application/vnd.uplanet.bearer-choice', 'application/vnd.uplanet.bearer-choice'), ('application/vnd.uplanet.bearer-choice-wbxml', 'application/vnd.uplanet.bearer-choice-wbxml'), ('application/vnd.uplanet.cacheop', 'application/vnd.uplanet.cacheop'), ('application/vnd.uplanet.cacheop-wbxml', 'application/vnd.uplanet.cacheop-wbxml'), ('application/vnd.uplanet.channel', 'application/vnd.uplanet.channel'), ('application/vnd.uplanet.channel-wbxml', 'application/vnd.uplanet.channel-wbxml'), ('application/vnd.uplanet.list', 'application/vnd.uplanet.list'), ('application/vnd.uplanet.listcmd', 'application/vnd.uplanet.listcmd'), ('application/vnd.uplanet.listcmd-wbxml', 'application/vnd.uplanet.listcmd-wbxml'), ('application/vnd.uplanet.list-wbxml', 'application/vnd.uplanet.list-wbxml'), ('application/vnd.uplanet.signal', 'application/vnd.uplanet.signal'), ('application/vnd.vcx', 'application/vnd.vcx'), ('application/vnd.vd-study', 'application/vnd.vd-study'), ('application/vnd.vectorworks', 'application/vnd.vectorworks'), ('application/vnd.verimatrix.vcas', 'application/vnd.verimatrix.vcas'), ('application/vnd.vidsoft.vidconference', 'application/vnd.vidsoft.vidconference'), ('application/vnd.visio', 'application/vnd.visio'), ('application/vnd.visionary', 'application/vnd.visionary'), ('application/vnd.vividence.scriptfile', 'application/vnd.vividence.scriptfile'), ('application/vnd.vsf', 'application/vnd.vsf'), ('application/vnd.wap.sic', 'application/vnd.wap.sic'), ('application/vnd.wap.slc', 'application/vnd.wap.slc'), ('application/vnd.wap.wbxml', 'application/vnd.wap.wbxml'), ('application/vnd.wap.wmlc', 'application/vnd.wap.wmlc'), ('application/vnd.wap.wmlscriptc', 'application/vnd.wap.wmlscriptc'), ('application/vnd.webturbo', 'application/vnd.webturbo'), ('application/vnd.wfa.p2p', 'application/vnd.wfa.p2p'), ('application/vnd.wfa.wsc', 'application/vnd.wfa.wsc'), ('application/vnd.windows.devicepairing', 'application/vnd.windows.devicepairing'), ('application/vnd.wmc', 'application/vnd.wmc'), ('application/vnd.wmf.bootstrap', 'application/vnd.wmf.bootstrap'), ('application/vnd.wolfram.mathematica', 'application/vnd.wolfram.mathematica'), ('application/vnd.wolfram.mathematica.package', 'application/vnd.wolfram.mathematica.package'), ('application/vnd.wolfram.player', 'application/vnd.wolfram.player'), ('application/vnd.wordperfect', 'application/vnd.wordperfect'), ('application/vnd.wqd', 'application/vnd.wqd'), ('application/vnd.wrq-hp3000-labelled', 'application/vnd.wrq-hp3000-labelled'), ('application/vnd.wt.stf', 'application/vnd.wt.stf'), ('application/vnd.wv.csp+xml', 'application/vnd.wv.csp+xml'), ('application/vnd.wv.csp+wbxml', 'application/vnd.wv.csp+wbxml'), ('application/vnd.wv.ssp+xml', 'application/vnd.wv.ssp+xml'), ('application/vnd.xacml+json', 'application/vnd.xacml+json'), ('application/vnd.xara', 'application/vnd.xara'), ('application/vnd.xfdl', 'application/vnd.xfdl'), ('application/vnd.xfdl.webform', 'application/vnd.xfdl.webform'), ('application/vnd.xmi+xml', 'application/vnd.xmi+xml'), ('application/vnd.xmpie.cpkg', 'application/vnd.xmpie.cpkg'), ('application/vnd.xmpie.dpkg', 'application/vnd.xmpie.dpkg'), ('application/vnd.xmpie.plan', 'application/vnd.xmpie.plan'), ('application/vnd.xmpie.ppkg', 'application/vnd.xmpie.ppkg'), ('application/vnd.xmpie.xlim', 'application/vnd.xmpie.xlim'), ('application/vnd.yamaha.hv-dic', 'application/vnd.yamaha.hv-dic'), ('application/vnd.yamaha.hv-script', 'application/vnd.yamaha.hv-script'), ('application/vnd.yamaha.hv-voice', 'application/vnd.yamaha.hv-voice'), ('application/vnd.yamaha.openscoreformat.osfpvg+xml', 'application/vnd.yamaha.openscoreformat.osfpvg+xml'), ('application/vnd.yamaha.openscoreformat', 'application/vnd.yamaha.openscoreformat'), ('application/vnd.yamaha.remote-setup', 'application/vnd.yamaha.remote-setup'), ('application/vnd.yamaha.smaf-audio', 'application/vnd.yamaha.smaf-audio'), ('application/vnd.yamaha.smaf-phrase', 'application/vnd.yamaha.smaf-phrase'), ('application/vnd.yamaha.through-ngn', 'application/vnd.yamaha.through-ngn'), ('application/vnd.yamaha.tunnel-udpencap', 'application/vnd.yamaha.tunnel-udpencap'), ('application/vnd.yellowriver-custom-menu', 'application/vnd.yellowriver-custom-menu'), ('application/vnd.zul', 'application/vnd.zul'), ('application/vnd.zzazz.deck+xml', 'application/vnd.zzazz.deck+xml'), ('application/voicexml+xml', 'application/voicexml+xml'), ('application/vq-rtcpxr', 'application/vq-rtcpxr'), ('application/watcherinfo+xml', 'application/watcherinfo+xml'), ('application/whoispp-query', 'application/whoispp-query'), ('application/whoispp-response', 'application/whoispp-response'), ('application/widget', 'application/widget'), ('application/wita', 'application/wita'), ('application/wordperfect5.1', 'application/wordperfect5.1'), ('application/wsdl+xml', 'application/wsdl+xml'), ('application/wspolicy+xml', 'application/wspolicy+xml'), ('application/x400-bp', 'application/x400-bp'), ('application/xacml+xml', 'application/xacml+xml'), ('application/xcap-att+xml', 'application/xcap-att+xml'), ('application/xcap-caps+xml', 'application/xcap-caps+xml'), ('application/xcap-diff+xml', 'application/xcap-diff+xml'), ('application/xcap-el+xml', 'application/xcap-el+xml'), ('application/xcap-error+xml', 'application/xcap-error+xml'), ('application/xcap-ns+xml', 'application/xcap-ns+xml'), ('application/xcon-conference-info-diff+xml', 'application/xcon-conference-info-diff+xml'), ('application/xcon-conference-info+xml', 'application/xcon-conference-info+xml'), ('application/xenc+xml', 'application/xenc+xml'), ('application/xhtml-voice+xml', 'application/xhtml-voice+xml'), ('application/xhtml+xml', 'application/xhtml+xml'), ('application/xml', 'application/xml'), ('application/xml-dtd', 'application/xml-dtd'), ('application/xml-external-parsed-entity', 'application/xml-external-parsed-entity'), ('application/xmpp+xml', 'application/xmpp+xml'), ('application/xop+xml', 'application/xop+xml'), ('application/xslt+xml', 'application/xslt+xml'), ('application/xv+xml', 'application/xv+xml'), ('application/yang', 'application/yang'), ('application/yin+xml', 'application/yin+xml'), ('application/zip', 'application/zip'), ('application/zlib', 'application/zlib'), ('audio/1d-interleaved-parityfec', 'audio/1d-interleaved-parityfec'), ('audio/32kadpcm', 'audio/32kadpcm'), ('audio/3gpp', 'audio/3gpp'), ('audio/3gpp2', 'audio/3gpp2'), ('audio/ac3', 'audio/ac3'), ('audio/AMR', 'audio/AMR'), ('audio/AMR-WB', 'audio/AMR-WB'), ('audio/asc', 'audio/asc'), ('audio/ATRAC-ADVANCED-LOSSLESS', 'audio/ATRAC-ADVANCED-LOSSLESS'), ('audio/ATRAC-X', 'audio/ATRAC-X'), ('audio/ATRAC3', 'audio/ATRAC3'), ('audio/basic', 'audio/basic'), ('audio/BV16', 'audio/BV16'), ('audio/BV32', 'audio/BV32'), ('audio/clearmode', 'audio/clearmode'), ('audio/CN', 'audio/CN'), ('audio/DAT12', 'audio/DAT12'), ('audio/dls', 'audio/dls'), ('audio/dsr-es201108', 'audio/dsr-es201108'), ('audio/dsr-es202050', 'audio/dsr-es202050'), ('audio/dsr-es202211', 'audio/dsr-es202211'), ('audio/dsr-es202212', 'audio/dsr-es202212'), ('audio/DV', 'audio/DV'), ('audio/DVI4', 'audio/DVI4'), ('audio/eac3', 'audio/eac3'), ('audio/encaprtp', 'audio/encaprtp'), ('audio/EVRC', 'audio/EVRC'), ('audio/EVRC-QCP', 'audio/EVRC-QCP'), ('audio/EVRC0', 'audio/EVRC0'), ('audio/EVRC1', 'audio/EVRC1'), ('audio/EVRCB', 'audio/EVRCB'), ('audio/EVRCB0', 'audio/EVRCB0'), ('audio/EVRCB1', 'audio/EVRCB1'), ('audio/EVRCNW', 'audio/EVRCNW'), ('audio/EVRCNW0', 'audio/EVRCNW0'), ('audio/EVRCNW1', 'audio/EVRCNW1'), ('audio/EVRCWB', 'audio/EVRCWB'), ('audio/EVRCWB0', 'audio/EVRCWB0'), ('audio/EVRCWB1', 'audio/EVRCWB1'), ('audio/example', 'audio/example'), ('audio/fwdred', 'audio/fwdred'), ('audio/G719', 'audio/G719'), ('audio/G722', 'audio/G722'), ('audio/G7221', 'audio/G7221'), ('audio/G723', 'audio/G723'), ('audio/G726-16', 'audio/G726-16'), ('audio/G726-24', 'audio/G726-24'), ('audio/G726-32', 'audio/G726-32'), ('audio/G726-40', 'audio/G726-40'), ('audio/G728', 'audio/G728'), ('audio/G729', 'audio/G729'), ('audio/G7291', 'audio/G7291'), ('audio/G729D', 'audio/G729D'), ('audio/G729E', 'audio/G729E'), ('audio/GSM', 'audio/GSM'), ('audio/GSM-EFR', 'audio/GSM-EFR'), ('audio/GSM-HR-08', 'audio/GSM-HR-08'), ('audio/iLBC', 'audio/iLBC'), ('audio/ip-mr_v2.5', 'audio/ip-mr_v2.5'), ('audio/L8', 'audio/L8'), ('audio/L16', 'audio/L16'), ('audio/L20', 'audio/L20'), ('audio/L24', 'audio/L24'), ('audio/LPC', 'audio/LPC'), ('audio/mobile-xmf', 'audio/mobile-xmf'), ('audio/MPA', 'audio/MPA'), ('audio/mp4', 'audio/mp4'), ('audio/MP4A-LATM', 'audio/MP4A-LATM'), ('audio/mpa-robust', 'audio/mpa-robust'), ('audio/mpeg', 'audio/mpeg'), ('audio/mpeg4-generic', 'audio/mpeg4-generic'), ('audio/ogg', 'audio/ogg'), ('audio/parityfec', 'audio/parityfec'), ('audio/PCMA', 'audio/PCMA'), ('audio/PCMA-WB', 'audio/PCMA-WB'), ('audio/PCMU', 'audio/PCMU'), ('audio/PCMU-WB', 'audio/PCMU-WB'), ('audio/prs.sid', 'audio/prs.sid'), ('audio/QCELP', 'audio/QCELP'), ('audio/raptorfec', 'audio/raptorfec'), ('audio/RED', 'audio/RED'), ('audio/rtp-enc-aescm128', 'audio/rtp-enc-aescm128'), ('audio/rtploopback', 'audio/rtploopback'), ('audio/rtp-midi', 'audio/rtp-midi'), ('audio/rtx', 'audio/rtx'), ('audio/SMV', 'audio/SMV'), ('audio/SMV0', 'audio/SMV0'), ('audio/SMV-QCP', 'audio/SMV-QCP'), ('audio/sp-midi', 'audio/sp-midi'), ('audio/speex', 'audio/speex'), ('audio/t140c', 'audio/t140c'), ('audio/t38', 'audio/t38'), ('audio/telephone-event', 'audio/telephone-event'), ('audio/tone', 'audio/tone'), ('audio/UEMCLIP', 'audio/UEMCLIP'), ('audio/ulpfec', 'audio/ulpfec'), ('audio/VDVI', 'audio/VDVI'), ('audio/VMR-WB', 'audio/VMR-WB'), ('audio/vnd.3gpp.iufp', 'audio/vnd.3gpp.iufp'), ('audio/vnd.4SB', 'audio/vnd.4SB'), ('audio/vnd.audiokoz', 'audio/vnd.audiokoz'), ('audio/vnd.CELP', 'audio/vnd.CELP'), ('audio/vnd.cisco.nse', 'audio/vnd.cisco.nse'), ('audio/vnd.cmles.radio-events', 'audio/vnd.cmles.radio-events'), ('audio/vnd.cns.anp1', 'audio/vnd.cns.anp1'), ('audio/vnd.cns.inf1', 'audio/vnd.cns.inf1'), ('audio/vnd.dece.audio', 'audio/vnd.dece.audio'), ('audio/vnd.digital-winds', 'audio/vnd.digital-winds'), ('audio/vnd.dlna.adts', 'audio/vnd.dlna.adts'), ('audio/vnd.dolby.heaac.1', 'audio/vnd.dolby.heaac.1'), ('audio/vnd.dolby.heaac.2', 'audio/vnd.dolby.heaac.2'), ('audio/vnd.dolby.mlp', 'audio/vnd.dolby.mlp'), ('audio/vnd.dolby.mps', 'audio/vnd.dolby.mps'), ('audio/vnd.dolby.pl2', 'audio/vnd.dolby.pl2'), ('audio/vnd.dolby.pl2x', 'audio/vnd.dolby.pl2x'), ('audio/vnd.dolby.pl2z', 'audio/vnd.dolby.pl2z'), ('audio/vnd.dolby.pulse.1', 'audio/vnd.dolby.pulse.1'), ('audio/vnd.dra', 'audio/vnd.dra'), ('audio/vnd.dts', 'audio/vnd.dts'), ('audio/vnd.dts.hd', 'audio/vnd.dts.hd'), ('audio/vnd.dvb.file', 'audio/vnd.dvb.file'), ('audio/vnd.everad.plj', 'audio/vnd.everad.plj'), ('audio/vnd.hns.audio', 'audio/vnd.hns.audio'), ('audio/vnd.lucent.voice', 'audio/vnd.lucent.voice'), ('audio/vnd.ms-playready.media.pya', 'audio/vnd.ms-playready.media.pya'), ('audio/vnd.nokia.mobile-xmf', 'audio/vnd.nokia.mobile-xmf'), ('audio/vnd.nortel.vbk', 'audio/vnd.nortel.vbk'), ('audio/vnd.nuera.ecelp4800', 'audio/vnd.nuera.ecelp4800'), ('audio/vnd.nuera.ecelp7470', 'audio/vnd.nuera.ecelp7470'), ('audio/vnd.nuera.ecelp9600', 'audio/vnd.nuera.ecelp9600'), ('audio/vnd.octel.sbc', 'audio/vnd.octel.sbc'), ('audio/vnd.qcelp', 'audio/vnd.qcelp'), ('audio/vnd.rhetorex.32kadpcm', 'audio/vnd.rhetorex.32kadpcm'), ('audio/vnd.rip', 'audio/vnd.rip'), ('audio/vnd.sealedmedia.softseal.mpeg', 'audio/vnd.sealedmedia.softseal.mpeg'), ('audio/vnd.vmx.cvsd', 'audio/vnd.vmx.cvsd'), ('audio/vorbis', 'audio/vorbis'), ('audio/vorbis-config', 'audio/vorbis-config'), ('image/cgm', 'image/cgm'), ('image/example', 'image/example'), ('image/fits', 'image/fits'), ('image/g3fax', 'image/g3fax'), ('image/gif', 'image/gif'), ('image/ief', 'image/ief'), ('image/jp2', 'image/jp2'), ('image/jpeg', 'image/jpeg'), ('image/jpm', 'image/jpm'), ('image/jpx', 'image/jpx'), ('image/ktx', 'image/ktx'), ('image/naplps', 'image/naplps'), ('image/png', 'image/png'), ('image/prs.btif', 'image/prs.btif'), ('image/prs.pti', 'image/prs.pti'), ('image/pwg-raster', 'image/pwg-raster'), ('image/svg+xml', 'image/svg+xml'), ('image/t38', 'image/t38'), ('image/tiff', 'image/tiff'), ('image/tiff-fx', 'image/tiff-fx'), ('image/vnd.adobe.photoshop', 'image/vnd.adobe.photoshop'), ('image/vnd.airzip.accelerator.azv', 'image/vnd.airzip.accelerator.azv'), ('image/vnd.cns.inf2', 'image/vnd.cns.inf2'), ('image/vnd.dece.graphic', 'image/vnd.dece.graphic'), ('image/vnd.djvu', 'image/vnd.djvu'), ('image/vnd.dwg', 'image/vnd.dwg'), ('image/vnd.dxf', 'image/vnd.dxf'), ('image/vnd.dvb.subtitle', 'image/vnd.dvb.subtitle'), ('image/vnd.fastbidsheet', 'image/vnd.fastbidsheet'), ('image/vnd.fpx', 'image/vnd.fpx'), ('image/vnd.fst', 'image/vnd.fst'), ('image/vnd.fujixerox.edmics-mmr', 'image/vnd.fujixerox.edmics-mmr'), ('image/vnd.fujixerox.edmics-rlc', 'image/vnd.fujixerox.edmics-rlc'), ('image/vnd.globalgraphics.pgb', 'image/vnd.globalgraphics.pgb'), ('image/vnd.microsoft.icon', 'image/vnd.microsoft.icon'), ('image/vnd.mix', 'image/vnd.mix'), ('image/vnd.ms-modi', 'image/vnd.ms-modi'), ('image/vnd.net-fpx', 'image/vnd.net-fpx'), ('image/vnd.radiance', 'image/vnd.radiance'), ('image/vnd.sealed.png', 'image/vnd.sealed.png'), ('image/vnd.sealedmedia.softseal.gif', 'image/vnd.sealedmedia.softseal.gif'), ('image/vnd.sealedmedia.softseal.jpg', 'image/vnd.sealedmedia.softseal.jpg'), ('image/vnd.svf', 'image/vnd.svf'), ('image/vnd.valve.source.texture', 'image/vnd.valve.source.texture'), ('image/vnd.wap.wbmp', 'image/vnd.wap.wbmp'), ('image/vnd.xiff', 'image/vnd.xiff'), ('message/CPIM', 'message/CPIM'), ('message/delivery-status', 'message/delivery-status'), ('message/disposition-notification', 'message/disposition-notification'), ('message/example', 'message/example'), ('message/external-body', 'message/external-body'), ('message/feedback-report', 'message/feedback-report'), ('message/global', 'message/global'), ('message/global-delivery-status', 'message/global-delivery-status'), ('message/global-disposition-notification', 'message/global-disposition-notification'), ('message/global-headers', 'message/global-headers'), ('message/http', 'message/http'), ('message/imdn+xml', 'message/imdn+xml'), ('message/news', 'message/news'), ('message/partial', 'message/partial'), ('message/rfc822', 'message/rfc822'), ('message/s-http', 'message/s-http'), ('message/sip', 'message/sip'), ('message/sipfrag', 'message/sipfrag'), ('message/tracking-status', 'message/tracking-status'), ('message/vnd.si.simp', 'message/vnd.si.simp'), ('message/vnd.wfa.wsc', 'message/vnd.wfa.wsc'), ('model/example', 'model/example'), ('model/iges', 'model/iges'), ('model/mesh', 'model/mesh'), ('model/vnd.collada+xml', 'model/vnd.collada+xml'), ('model/vnd.dwf', 'model/vnd.dwf'), ('model/vnd.flatland.3dml', 'model/vnd.flatland.3dml'), ('model/vnd.gdl', 'model/vnd.gdl'), ('model/vnd.gs-gdl', 'model/vnd.gs-gdl'), ('model/vnd.gtw', 'model/vnd.gtw'), ('model/vnd.moml+xml', 'model/vnd.moml+xml'), ('model/vnd.mts', 'model/vnd.mts'), ('model/vnd.parasolid.transmit.binary', 'model/vnd.parasolid.transmit.binary'), ('model/vnd.parasolid.transmit.text', 'model/vnd.parasolid.transmit.text'), ('model/vnd.vtu', 'model/vnd.vtu'), ('model/vrml', 'model/vrml'), ('model/x3d-vrml', 'model/x3d-vrml'), ('model/x3d+fastinfoset', 'model/x3d+fastinfoset'), ('model/x3d+xml', 'model/x3d+xml'), ('multipart/alternative', 'multipart/alternative'), ('multipart/appledouble', 'multipart/appledouble'), ('multipart/byteranges', 'multipart/byteranges'), ('multipart/digest', 'multipart/digest'), ('multipart/encrypted', 'multipart/encrypted'), ('multipart/example', 'multipart/example'), ('multipart/form-data', 'multipart/form-data'), ('multipart/header-set', 'multipart/header-set'), ('multipart/mixed', 'multipart/mixed'), ('multipart/parallel', 'multipart/parallel'), ('multipart/related', 'multipart/related'), ('multipart/report', 'multipart/report'), ('multipart/signed', 'multipart/signed'), ('multipart/voice-message', 'multipart/voice-message'), ('text/1d-interleaved-parityfec', 'text/1d-interleaved-parityfec'), ('text/calendar', 'text/calendar'), ('text/css', 'text/css'), ('text/csv', 'text/csv'), ('text/directory', 'text/directory'), ('text/dns', 'text/dns'), ('text/ecmascript', 'text/ecmascript'), ('text/encaprtp', 'text/encaprtp'), ('text/enriched', 'text/enriched'), ('text/example', 'text/example'), ('text/fwdred', 'text/fwdred'), ('text/grammar-ref-list', 'text/grammar-ref-list'), ('text/html', 'text/html'), ('text/javascript', 'text/javascript'), ('text/jcr-cnd', 'text/jcr-cnd'), ('text/mizar', 'text/mizar'), ('text/n3', 'text/n3'), ('text/parameters', 'text/parameters'), ('text/parityfec', 'text/parityfec'), ('text/plain', 'text/plain'), ('text/provenance-notation', 'text/provenance-notation'), ('text/prs.fallenstein.rst', 'text/prs.fallenstein.rst'), ('text/prs.lines.tag', 'text/prs.lines.tag'), ('text/raptorfec', 'text/raptorfec'), ('text/RED', 'text/RED'), ('text/rfc822-headers', 'text/rfc822-headers'), ('text/richtext', 'text/richtext'), ('text/rtf', 'text/rtf'), ('text/rtp-enc-aescm128', 'text/rtp-enc-aescm128'), ('text/rtploopback', 'text/rtploopback'), ('text/rtx', 'text/rtx'), ('text/sgml', 'text/sgml'), ('text/t140', 'text/t140'), ('text/tab-separated-values', 'text/tab-separated-values'), ('text/troff', 'text/troff'), ('text/turtle', 'text/turtle'), ('text/ulpfec', 'text/ulpfec'), ('text/uri-list', 'text/uri-list'), ('text/vcard', 'text/vcard'), ('text/vnd.a', 'text/vnd.a'), ('text/vnd.abc', 'text/vnd.abc'), ('text/vnd.curl', 'text/vnd.curl'), ('text/vnd.debian.copyright', 'text/vnd.debian.copyright'), ('text/vnd.DMClientScript', 'text/vnd.DMClientScript'), ('text/vnd.dvb.subtitle', 'text/vnd.dvb.subtitle'), ('text/vnd.esmertec.theme-descriptor', 'text/vnd.esmertec.theme-descriptor'), ('text/vnd.fly', 'text/vnd.fly'), ('text/vnd.fmi.flexstor', 'text/vnd.fmi.flexstor'), ('text/vnd.graphviz', 'text/vnd.graphviz'), ('text/vnd.in3d.3dml', 'text/vnd.in3d.3dml'), ('text/vnd.in3d.spot', 'text/vnd.in3d.spot'), ('text/vnd.IPTC.NewsML', 'text/vnd.IPTC.NewsML'), ('text/vnd.IPTC.NITF', 'text/vnd.IPTC.NITF'), ('text/vnd.latex-z', 'text/vnd.latex-z'), ('text/vnd.motorola.reflex', 'text/vnd.motorola.reflex'), ('text/vnd.ms-mediapackage', 'text/vnd.ms-mediapackage'), ('text/vnd.net2phone.commcenter.command', 'text/vnd.net2phone.commcenter.command'), ('text/vnd.radisys.msml-basic-layout', 'text/vnd.radisys.msml-basic-layout'), ('text/vnd.si.uricatalogue', 'text/vnd.si.uricatalogue'), ('text/vnd.sun.j2me.app-descriptor', 'text/vnd.sun.j2me.app-descriptor'), ('text/vnd.trolltech.linguist', 'text/vnd.trolltech.linguist'), ('text/vnd.wap.si', 'text/vnd.wap.si'), ('text/vnd.wap.sl', 'text/vnd.wap.sl'), ('text/vnd.wap.wml', 'text/vnd.wap.wml'), ('text/vnd.wap.wmlscript', 'text/vnd.wap.wmlscript'), ('text/xml', 'text/xml'), ('text/xml-external-parsed-entity', 'text/xml-external-parsed-entity'), ('video/1d-interleaved-parityfec', 'video/1d-interleaved-parityfec'), ('video/3gpp', 'video/3gpp'), ('video/3gpp2', 'video/3gpp2'), ('video/3gpp-tt', 'video/3gpp-tt'), ('video/BMPEG', 'video/BMPEG'), ('video/BT656', 'video/BT656'), ('video/CelB', 'video/CelB'), ('video/DV', 'video/DV'), ('video/encaprtp', 'video/encaprtp'), ('video/example', 'video/example'), ('video/H261', 'video/H261'), ('video/H263', 'video/H263'), ('video/H263-1998', 'video/H263-1998'), ('video/H263-2000', 'video/H263-2000'), ('video/H264', 'video/H264'), ('video/H264-RCDO', 'video/H264-RCDO'), ('video/H264-SVC', 'video/H264-SVC'), ('video/iso.segment', 'video/iso.segment'), ('video/JPEG', 'video/JPEG'), ('video/jpeg2000', 'video/jpeg2000'), ('video/MJ2', 'video/MJ2'), ('video/MP1S', 'video/MP1S'), ('video/MP2P', 'video/MP2P'), ('video/MP2T', 'video/MP2T'), ('video/mp4', 'video/mp4'), ('video/MP4V-ES', 'video/MP4V-ES'), ('video/MPV', 'video/MPV'), ('video/mpeg', 'video/mpeg'), ('video/mpeg4-generic', 'video/mpeg4-generic'), ('video/nv', 'video/nv'), ('video/ogg', 'video/ogg'), ('video/parityfec', 'video/parityfec'), ('video/pointer', 'video/pointer'), ('video/quicktime', 'video/quicktime'), ('video/raptorfec', 'video/raptorfec'), ('video/raw', 'video/raw'), ('video/rtp-enc-aescm128', 'video/rtp-enc-aescm128'), ('video/rtploopback', 'video/rtploopback'), ('video/rtx', 'video/rtx'), ('video/SMPTE292M', 'video/SMPTE292M'), ('video/ulpfec', 'video/ulpfec'), ('video/vc1', 'video/vc1'), ('video/vnd.CCTV', 'video/vnd.CCTV'), ('video/vnd.dece.hd', 'video/vnd.dece.hd'), ('video/vnd.dece.mobile', 'video/vnd.dece.mobile'), ('video/vnd.dece.mp4', 'video/vnd.dece.mp4'), ('video/vnd.dece.pd', 'video/vnd.dece.pd'), ('video/vnd.dece.sd', 'video/vnd.dece.sd'), ('video/vnd.dece.video', 'video/vnd.dece.video'), ('video/vnd.directv.mpeg', 'video/vnd.directv.mpeg'), ('video/vnd.directv.mpeg-tts', 'video/vnd.directv.mpeg-tts'), ('video/vnd.dlna.mpeg-tts', 'video/vnd.dlna.mpeg-tts'), ('video/vnd.dvb.file', 'video/vnd.dvb.file'), ('video/vnd.fvt', 'video/vnd.fvt'), ('video/vnd.hns.video', 'video/vnd.hns.video'), ('video/vnd.iptvforum.1dparityfec-1010', 'video/vnd.iptvforum.1dparityfec-1010'), ('video/vnd.iptvforum.1dparityfec-2005', 'video/vnd.iptvforum.1dparityfec-2005'), ('video/vnd.iptvforum.2dparityfec-1010', 'video/vnd.iptvforum.2dparityfec-1010'), ('video/vnd.iptvforum.2dparityfec-2005', 'video/vnd.iptvforum.2dparityfec-2005'), ('video/vnd.iptvforum.ttsavc', 'video/vnd.iptvforum.ttsavc'), ('video/vnd.iptvforum.ttsmpeg2', 'video/vnd.iptvforum.ttsmpeg2'), ('video/vnd.motorola.video', 'video/vnd.motorola.video'), ('video/vnd.motorola.videop', 'video/vnd.motorola.videop'), ('video/vnd.mpegurl', 'video/vnd.mpegurl'), ('video/vnd.ms-playready.media.pyv', 'video/vnd.ms-playready.media.pyv'), ('video/vnd.nokia.interleaved-multimedia', 'video/vnd.nokia.interleaved-multimedia'), ('video/vnd.nokia.videovoip', 'video/vnd.nokia.videovoip'), ('video/vnd.objectvideo', 'video/vnd.objectvideo'), ('video/vnd.radgamettools.bink', 'video/vnd.radgamettools.bink'), ('video/vnd.radgamettools.smacker', 'video/vnd.radgamettools.smacker'), ('video/vnd.sealed.mpeg1', 'video/vnd.sealed.mpeg1'), ('video/vnd.sealed.mpeg4', 'video/vnd.sealed.mpeg4'), ('video/vnd.sealed.swf', 'video/vnd.sealed.swf'), ('video/vnd.sealedmedia.softseal.mov', 'video/vnd.sealedmedia.softseal.mov'), ('video/vnd.uvvu.mp4', 'video/vnd.uvvu.mp4'), ('video/vnd.vivo', 'video/vnd.vivo')])),
                ('title', akvo.rsr.fields.ValidXMLCharField(help_text='Enter the title of your document.', max_length=100, verbose_name='document title', blank=True)),
                ('title_language', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='Select the language of the document title.', max_length=2, verbose_name='title language', choices=[('aa', 'aa - Afar'), ('ab', 'ab - Abkhazian'), ('ae', 'ae - Avestan'), ('af', 'af - Afrikaans'), ('ak', 'ak - Akan'), ('am', 'am - Amharic'), ('an', 'an - Aragonese'), ('ar', 'ar - Arabic'), ('as', 'as - Assamese'), ('av', 'av - Avaric'), ('ay', 'ay - Aymara'), ('az', 'az - Azerbaijani'), ('ba', 'ba - Bashkir'), ('be', 'be - Belarusian'), ('bg', 'bg - Bulgarian'), ('bh', 'bh - Bihari languages'), ('bi', 'bi - Bislama'), ('bm', 'bm - Bambara'), ('bn', 'bn - Bengali'), ('bo', 'bo - Tibetan'), ('br', 'br - Breton'), ('bs', 'bs - Bosnian'), ('ca', 'ca - Catalan; Valencian'), ('ce', 'ce - Chechen'), ('ch', 'ch - Chamorro'), ('co', 'co - Corsican'), ('cr', 'cr - Cree'), ('cs', 'cs - Czech'), ('cv', 'cv - Chuvash'), ('cy', 'cy - Welsh'), ('da', 'da - Danish'), ('de', 'de - German'), ('dv', 'dv - Divehi; Dhivehi; Maldivian'), ('dz', 'dz - Dzongkha'), ('ee', 'ee - Ewe'), ('el', 'el - Greek'), ('en', 'en - English'), ('eo', 'eo - Esperanto'), ('es', 'es - Spanish; Castilian'), ('et', 'et - Estonian'), ('eu', 'eu - Basque'), ('fa', 'fa - Persian'), ('ff', 'ff - Fulah'), ('fi', 'fi - Finnish'), ('fj', 'fj - Fijian'), ('fo', 'fo - Faroese'), ('fr', 'fr - French'), ('fy', 'fy - Western Frisian'), ('ga', 'ga - Irish'), ('gd', 'gd - Gaelic; Scottish Gaelic'), ('gl', 'gl - Galician'), ('gn', 'gn - Guarani'), ('gu', 'gu - Gujarati'), ('gv', 'gv - Manx'), ('ha', 'ha - Hausa'), ('he', 'he - Hebrew'), ('hi', 'hi - Hindi'), ('ho', 'ho - Hiri Motu'), ('hr', 'hr - Croatian'), ('ht', 'ht - Haitian; Haitian Creole'), ('hu', 'hu - Hungarian'), ('hy', 'hy - Armenian'), ('hz', 'hz - Herero'), ('id', 'id - Indonesian'), ('ig', 'ig - Igbo'), ('ii', 'ii - Sichuan Yi; Nuosu'), ('ik', 'ik - Inupiaq'), ('io', 'io - Ido'), ('is', 'is - Icelandic'), ('it', 'it - Italian'), ('iu', 'iu - Inuktitut'), ('ja', 'ja - Japanese'), ('jv', 'jv - Javanese'), ('ka', 'ka - Georgian'), ('kg', 'kg - Kongo'), ('ki', 'ki - Kikuyu; Gikuyu'), ('kj', 'kj - Kuanyama; Kwanyama'), ('kk', 'kk - Kazakh'), ('kl', 'kl - Kalaallisut; Greenlandic'), ('km', 'km - Central Khmer'), ('kn', 'kn - Kannada'), ('ko', 'ko - Korean'), ('kr', 'kr - Kanuri'), ('ks', 'ks - Kashmiri'), ('ku', 'ku - Kurdish'), ('kv', 'kv - Komi'), ('kw', 'kw - Cornish'), ('ky', 'ky - Kirghiz; Kyrgyz'), ('la', 'la - Latin'), ('lb', 'lb - Luxembourgish; Letzeburgesch'), ('lg', 'lg - Ganda'), ('li', 'li - Limburgan; Limburger; Limburgish'), ('ln', 'ln - Lingala'), ('lo', 'lo - Lao'), ('lt', 'lt - Lithuanian'), ('lu', 'lu - Luba-Katanga'), ('lv', 'lv - Latvian'), ('mg', 'mg - Malagasy'), ('mh', 'mh - Marshallese'), ('mi', 'mi - Maori'), ('mk', 'mk - Macedonian'), ('ml', 'ml - Malayalam'), ('mn', 'mn - Mongolian'), ('mr', 'mr - Marathi'), ('ms', 'ms - Malay'), ('mt', 'mt - Maltese'), ('my', 'my - Burmese'), ('na', 'na - Nauru'), ('nb', 'nb - Bokm\u0102\u013dl, Norwegian; Norwegian Bokm\u0102\u013dl'), ('nd', 'nd - Ndebele, North; North Ndebele'), ('ne', 'ne - Nepali'), ('ng', 'ng - Ndonga'), ('nl', 'nl - Dutch; Flemish'), ('nn', 'nn - Norwegian Nynorsk; Nynorsk, Norwegian'), ('no', 'no - Norwegian'), ('nr', 'nr - Ndebele, South; South Ndebele'), ('nv', 'nv - Navajo; Navaho'), ('ny', 'ny - Chichewa; Chewa; Nyanja'), ('oc', 'oc - Occitan (post 1500)'), ('oj', 'oj - Ojibwa'), ('om', 'om - Oromo'), ('or', 'or - Oriya'), ('os', 'os - Ossetian; Ossetic'), ('pa', 'pa - Panjabi; Punjabi'), ('pi', 'pi - Pali'), ('pl', 'pl - Polish'), ('ps', 'ps - Pushto; Pashto'), ('pt', 'pt - Portuguese'), ('qu', 'qu - Quechua'), ('rm', 'rm - Romansh'), ('rn', 'rn - Rundi'), ('ro', 'ro - Romanian; Moldavian; Moldovan'), ('ru', 'ru - Russian'), ('rw', 'rw - Kinyarwanda'), ('sa', 'sa - Sanskrit'), ('sc', 'sc - Sardinian'), ('sd', 'sd - Sindhi'), ('se', 'se - Northern Sami'), ('sg', 'sg - Sango'), ('si', 'si - Sinhala; Sinhalese'), ('sk', 'sk - Slovak'), ('sl', 'sl - Slovenian'), ('sm', 'sm - Samoan'), ('sn', 'sn - Shona'), ('so', 'so - Somali'), ('sq', 'sq - Albanian'), ('sr', 'sr - Serbian'), ('ss', 'ss - Swati'), ('st', 'st - Sotho, Southern'), ('su', 'su - Sundanese'), ('sv', 'sv - Swedish'), ('sw', 'sw - Swahili'), ('ta', 'ta - Tamil'), ('te', 'te - Telugu'), ('tg', 'tg - Tajik'), ('th', 'th - Thai'), ('ti', 'ti - Tigrinya'), ('tk', 'tk - Turkmen'), ('tl', 'tl - Tagalog'), ('tn', 'tn - Tswana'), ('to', 'to - Tonga (Tonga Islands)'), ('tr', 'tr - Turkish'), ('ts', 'ts - Tsonga'), ('tt', 'tt - Tatar'), ('tw', 'tw - Twi'), ('ty', 'ty - Tahitian'), ('ug', 'ug - Uighur; Uyghur'), ('uk', 'uk - Ukrainian'), ('ur', 'ur - Urdu'), ('uz', 'uz - Uzbek'), ('ve', 've - Venda'), ('vi', 'vi - Vietnamese'), ('vo', 'vo - Volap\u0102\u017ak'), ('wa', 'wa - Walloon'), ('wo', 'wo - Wolof'), ('xh', 'xh - Xhosa'), ('yi', 'yi - Yiddish'), ('yo', 'yo - Yoruba'), ('za', 'za - Zhuang; Chuang'), ('zh', 'zh - Chinese'), ('zu', 'zu - Zulu')])),
                ('language', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='Select the language that the document is written in.', max_length=2, verbose_name='document language', choices=[('aa', 'aa - Afar'), ('ab', 'ab - Abkhazian'), ('ae', 'ae - Avestan'), ('af', 'af - Afrikaans'), ('ak', 'ak - Akan'), ('am', 'am - Amharic'), ('an', 'an - Aragonese'), ('ar', 'ar - Arabic'), ('as', 'as - Assamese'), ('av', 'av - Avaric'), ('ay', 'ay - Aymara'), ('az', 'az - Azerbaijani'), ('ba', 'ba - Bashkir'), ('be', 'be - Belarusian'), ('bg', 'bg - Bulgarian'), ('bh', 'bh - Bihari languages'), ('bi', 'bi - Bislama'), ('bm', 'bm - Bambara'), ('bn', 'bn - Bengali'), ('bo', 'bo - Tibetan'), ('br', 'br - Breton'), ('bs', 'bs - Bosnian'), ('ca', 'ca - Catalan; Valencian'), ('ce', 'ce - Chechen'), ('ch', 'ch - Chamorro'), ('co', 'co - Corsican'), ('cr', 'cr - Cree'), ('cs', 'cs - Czech'), ('cv', 'cv - Chuvash'), ('cy', 'cy - Welsh'), ('da', 'da - Danish'), ('de', 'de - German'), ('dv', 'dv - Divehi; Dhivehi; Maldivian'), ('dz', 'dz - Dzongkha'), ('ee', 'ee - Ewe'), ('el', 'el - Greek'), ('en', 'en - English'), ('eo', 'eo - Esperanto'), ('es', 'es - Spanish; Castilian'), ('et', 'et - Estonian'), ('eu', 'eu - Basque'), ('fa', 'fa - Persian'), ('ff', 'ff - Fulah'), ('fi', 'fi - Finnish'), ('fj', 'fj - Fijian'), ('fo', 'fo - Faroese'), ('fr', 'fr - French'), ('fy', 'fy - Western Frisian'), ('ga', 'ga - Irish'), ('gd', 'gd - Gaelic; Scottish Gaelic'), ('gl', 'gl - Galician'), ('gn', 'gn - Guarani'), ('gu', 'gu - Gujarati'), ('gv', 'gv - Manx'), ('ha', 'ha - Hausa'), ('he', 'he - Hebrew'), ('hi', 'hi - Hindi'), ('ho', 'ho - Hiri Motu'), ('hr', 'hr - Croatian'), ('ht', 'ht - Haitian; Haitian Creole'), ('hu', 'hu - Hungarian'), ('hy', 'hy - Armenian'), ('hz', 'hz - Herero'), ('id', 'id - Indonesian'), ('ig', 'ig - Igbo'), ('ii', 'ii - Sichuan Yi; Nuosu'), ('ik', 'ik - Inupiaq'), ('io', 'io - Ido'), ('is', 'is - Icelandic'), ('it', 'it - Italian'), ('iu', 'iu - Inuktitut'), ('ja', 'ja - Japanese'), ('jv', 'jv - Javanese'), ('ka', 'ka - Georgian'), ('kg', 'kg - Kongo'), ('ki', 'ki - Kikuyu; Gikuyu'), ('kj', 'kj - Kuanyama; Kwanyama'), ('kk', 'kk - Kazakh'), ('kl', 'kl - Kalaallisut; Greenlandic'), ('km', 'km - Central Khmer'), ('kn', 'kn - Kannada'), ('ko', 'ko - Korean'), ('kr', 'kr - Kanuri'), ('ks', 'ks - Kashmiri'), ('ku', 'ku - Kurdish'), ('kv', 'kv - Komi'), ('kw', 'kw - Cornish'), ('ky', 'ky - Kirghiz; Kyrgyz'), ('la', 'la - Latin'), ('lb', 'lb - Luxembourgish; Letzeburgesch'), ('lg', 'lg - Ganda'), ('li', 'li - Limburgan; Limburger; Limburgish'), ('ln', 'ln - Lingala'), ('lo', 'lo - Lao'), ('lt', 'lt - Lithuanian'), ('lu', 'lu - Luba-Katanga'), ('lv', 'lv - Latvian'), ('mg', 'mg - Malagasy'), ('mh', 'mh - Marshallese'), ('mi', 'mi - Maori'), ('mk', 'mk - Macedonian'), ('ml', 'ml - Malayalam'), ('mn', 'mn - Mongolian'), ('mr', 'mr - Marathi'), ('ms', 'ms - Malay'), ('mt', 'mt - Maltese'), ('my', 'my - Burmese'), ('na', 'na - Nauru'), ('nb', 'nb - Bokm\u0102\u013dl, Norwegian; Norwegian Bokm\u0102\u013dl'), ('nd', 'nd - Ndebele, North; North Ndebele'), ('ne', 'ne - Nepali'), ('ng', 'ng - Ndonga'), ('nl', 'nl - Dutch; Flemish'), ('nn', 'nn - Norwegian Nynorsk; Nynorsk, Norwegian'), ('no', 'no - Norwegian'), ('nr', 'nr - Ndebele, South; South Ndebele'), ('nv', 'nv - Navajo; Navaho'), ('ny', 'ny - Chichewa; Chewa; Nyanja'), ('oc', 'oc - Occitan (post 1500)'), ('oj', 'oj - Ojibwa'), ('om', 'om - Oromo'), ('or', 'or - Oriya'), ('os', 'os - Ossetian; Ossetic'), ('pa', 'pa - Panjabi; Punjabi'), ('pi', 'pi - Pali'), ('pl', 'pl - Polish'), ('ps', 'ps - Pushto; Pashto'), ('pt', 'pt - Portuguese'), ('qu', 'qu - Quechua'), ('rm', 'rm - Romansh'), ('rn', 'rn - Rundi'), ('ro', 'ro - Romanian; Moldavian; Moldovan'), ('ru', 'ru - Russian'), ('rw', 'rw - Kinyarwanda'), ('sa', 'sa - Sanskrit'), ('sc', 'sc - Sardinian'), ('sd', 'sd - Sindhi'), ('se', 'se - Northern Sami'), ('sg', 'sg - Sango'), ('si', 'si - Sinhala; Sinhalese'), ('sk', 'sk - Slovak'), ('sl', 'sl - Slovenian'), ('sm', 'sm - Samoan'), ('sn', 'sn - Shona'), ('so', 'so - Somali'), ('sq', 'sq - Albanian'), ('sr', 'sr - Serbian'), ('ss', 'ss - Swati'), ('st', 'st - Sotho, Southern'), ('su', 'su - Sundanese'), ('sv', 'sv - Swedish'), ('sw', 'sw - Swahili'), ('ta', 'ta - Tamil'), ('te', 'te - Telugu'), ('tg', 'tg - Tajik'), ('th', 'th - Thai'), ('ti', 'ti - Tigrinya'), ('tk', 'tk - Turkmen'), ('tl', 'tl - Tagalog'), ('tn', 'tn - Tswana'), ('to', 'to - Tonga (Tonga Islands)'), ('tr', 'tr - Turkish'), ('ts', 'ts - Tsonga'), ('tt', 'tt - Tatar'), ('tw', 'tw - Twi'), ('ty', 'ty - Tahitian'), ('ug', 'ug - Uighur; Uyghur'), ('uk', 'uk - Ukrainian'), ('ur', 'ur - Urdu'), ('uz', 'uz - Uzbek'), ('ve', 've - Venda'), ('vi', 'vi - Vietnamese'), ('vo', 'vo - Volap\u0102\u017ak'), ('wa', 'wa - Walloon'), ('wo', 'wo - Wolof'), ('xh', 'xh - Xhosa'), ('yi', 'yi - Yiddish'), ('yo', 'yo - Yoruba'), ('za', 'za - Zhuang; Chuang'), ('zh', 'zh - Chinese'), ('zu', 'zu - Zulu')])),
                ('document_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for the production or publishing date of the relevant document to identify the specific document version.', null=True, verbose_name='document date', blank=True)),
                ('organisation', models.ForeignKey(related_name='documents', verbose_name='organisation', to='rsr.Organisation')),
            ],
            options={
                'ordering': ['-id'],
                'verbose_name': 'organisation document',
                'verbose_name_plural': 'organisation documents',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationDocumentCategory',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('category', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The description of the type of content contained within the document.', max_length=3, verbose_name='document category', choices=[('A01', 'A01 - Pre- and post-project impact appraisal'), ('A02', 'A02 - Objectives / Purpose of activity'), ('A03', 'A03 - Intended ultimate beneficiaries'), ('A04', 'A04 - Conditions'), ('A05', 'A05 - Budget'), ('A06', 'A06 - Summary information about contract'), ('A07', 'A07 - Review of project performance and evaluation'), ('A08', 'A08 - Results, outcomes and outputs'), ('A09', 'A09 - Memorandum of understanding (If agreed by all parties)'), ('A10', 'A10 - Tender'), ('A11', 'A11 - Contract'), ('A12', 'A12 - Activity web page'), ('B01', 'B01 - Annual report'), ('B02', 'B02 - Institutional Strategy paper'), ('B03', 'B03 - Country strategy paper'), ('B04', 'B04 - Aid Allocation Policy'), ('B05', 'B05 - Procurement Policy and Procedure'), ('B06', 'B06 - Institutional Audit Report'), ('B07', 'B07 - Country Audit Report'), ('B08', 'B08 - Exclusions Policy'), ('B09', 'B09 - Institutional Evaluation Report'), ('B10', 'B10 - Country Evaluation Report'), ('B11', 'B11 - Sector strategy'), ('B12', 'B12 - Thematic strategy'), ('B13', 'B13 - Country-level Memorandum of Understanding'), ('B14', 'B14 - Evaluations policy'), ('B15', 'B15 - General Terms and Conditions'), ('B16', 'B16 - Organisation web page'), ('B17', 'B17 - Country/Region web page'), ('B18', 'B18 - Sector web page')])),
                ('document', models.ForeignKey(related_name='categories', verbose_name='document', to='rsr.OrganisationDocument')),
            ],
            options={
                'ordering': ['-id'],
                'verbose_name': 'document category',
                'verbose_name_plural': 'document categories',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationDocumentCountry',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('country', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the country which concerns the organisation document.', max_length=2, verbose_name='recipient country', choices=[('AF', 'AF - Afghanistan'), ('AX', 'AX - \xc5land Islands'), ('AL', 'AL - Albania'), ('DZ', 'DZ - Algeria'), ('AS', 'AS - American Samoa'), ('AD', 'AD - Andorra'), ('AO', 'AO - Angola'), ('AI', 'AI - Anguilla'), ('AQ', 'AQ - Antarctica'), ('AG', 'AG - Antigua and Barbuda'), ('AR', 'AR - Argentina'), ('AM', 'AM - Armenia'), ('AW', 'AW - Aruba'), ('AU', 'AU - Australia'), ('AT', 'AT - Austria'), ('AZ', 'AZ - Azerbaijan'), ('BS', 'BS - Bahamas (The)'), ('BH', 'BH - Bahrain'), ('BD', 'BD - Bangladesh'), ('BB', 'BB - Barbados'), ('BY', 'BY - Belarus'), ('BE', 'BE - Belgium'), ('BZ', 'BZ - Belize'), ('BJ', 'BJ - Benin'), ('BM', 'BM - Bermuda'), ('BT', 'BT - Bhutan'), ('BO', 'BO - Bolivia (Plurinational State Of)'), ('BQ', 'BQ - Bonaire, Saint Eustatius and Saba'), ('BA', 'BA - Bosnia and Herzegovina'), ('BW', 'BW - Botswana'), ('BV', 'BV - Bouvet Island'), ('BR', 'BR - Brazil'), ('IO', 'IO - British Indian Ocean Territory (The)'), ('BN', 'BN - Brunei Darussalam'), ('BG', 'BG - Bulgaria'), ('BF', 'BF - Burkina Faso'), ('BI', 'BI - Burundi'), ('KH', 'KH - Cambodia'), ('CM', 'CM - Cameroon'), ('CA', 'CA - Canada'), ('CV', 'CV - Cape Verde'), ('KY', 'KY - Cayman Islands (The)'), ('CF', 'CF - Central African Republic (The)'), ('TD', 'TD - Chad'), ('CL', 'CL - Chile'), ('CN', 'CN - China'), ('CX', 'CX - Christmas Island'), ('CC', 'CC - Cocos (Keeling) Islands (The)'), ('CO', 'CO - Colombia'), ('KM', 'KM - Comoros (The)'), ('CG', 'CG - Congo (The)'), ('CD', 'CD - Congo, The Democratic Republic of the'), ('CK', 'CK - Cook Islands (The)'), ('CR', 'CR - Costa Rica'), ('CI', 'CI - C\xf4te Divoire'), ('HR', 'HR - Croatia'), ('CU', 'CU - Cuba'), ('CW', 'CW - Cura\xe7ao'), ('CY', 'CY - Cyprus'), ('CZ', 'CZ - Czech Republic (The)'), ('DK', 'DK - Denmark'), ('DJ', 'DJ - Djibouti'), ('DM', 'DM - Dominica'), ('DO', 'DO - Dominican Republic (The)'), ('EC', 'EC - Ecuador'), ('EG', 'EG - Egypt'), ('SV', 'SV - El Salvador'), ('GQ', 'GQ - Equatorial Guinea'), ('ER', 'ER - Eritrea'), ('EE', 'EE - Estonia'), ('ET', 'ET - Ethiopia'), ('FK', 'FK - Falkland Islands (The) [malvinas]'), ('FO', 'FO - Faroe Islands (The)'), ('FJ', 'FJ - Fiji'), ('FI', 'FI - Finland'), ('FR', 'FR - France'), ('GF', 'GF - French Guiana'), ('PF', 'PF - French Polynesia'), ('TF', 'TF - French Southern Territories (The)'), ('GA', 'GA - Gabon'), ('GM', 'GM - Gambia (The)'), ('GE', 'GE - Georgia'), ('DE', 'DE - Germany'), ('GH', 'GH - Ghana'), ('GI', 'GI - Gibraltar'), ('GR', 'GR - Greece'), ('GL', 'GL - Greenland'), ('GD', 'GD - Grenada'), ('GP', 'GP - Guadeloupe'), ('GU', 'GU - Guam'), ('GT', 'GT - Guatemala'), ('GG', 'GG - Guernsey'), ('GN', 'GN - Guinea'), ('GW', 'GW - Guinea-Bissau'), ('GY', 'GY - Guyana'), ('HT', 'HT - Haiti'), ('HM', 'HM - Heard Island and Mcdonald Islands'), ('VA', 'VA - Holy See (The)'), ('HN', 'HN - Honduras'), ('HK', 'HK - Hong Kong'), ('HU', 'HU - Hungary'), ('IS', 'IS - Iceland'), ('IN', 'IN - India'), ('ID', 'ID - Indonesia'), ('IR', 'IR - Iran (Islamic Republic Of)'), ('IQ', 'IQ - Iraq'), ('IE', 'IE - Ireland'), ('IM', 'IM - Isle of Man'), ('IL', 'IL - Israel'), ('IT', 'IT - Italy'), ('JM', 'JM - Jamaica'), ('JP', 'JP - Japan'), ('JE', 'JE - Jersey'), ('JO', 'JO - Jordan'), ('KZ', 'KZ - Kazakhstan'), ('KE', 'KE - Kenya'), ('KI', 'KI - Kiribati'), ('KP', 'KP - Korea (Democratic Peoples Republic Of)'), ('KR', 'KR - Korea (Republic Of)'), ('XK', 'XK - Kosovo'), ('KW', 'KW - Kuwait'), ('KG', 'KG - Kyrgyzstan'), ('LA', 'LA - Lao Peoples Democratic Republic (The)'), ('LV', 'LV - Latvia'), ('LB', 'LB - Lebanon'), ('LS', 'LS - Lesotho'), ('LR', 'LR - Liberia'), ('LY', 'LY - Libyan Arab Jamahiriya'), ('LI', 'LI - Liechtenstein'), ('LT', 'LT - Lithuania'), ('LU', 'LU - Luxembourg'), ('MO', 'MO - Macao'), ('MK', 'MK - Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'MG - Madagascar'), ('MW', 'MW - Malawi'), ('MY', 'MY - Malaysia'), ('MV', 'MV - Maldives'), ('ML', 'ML - Mali'), ('MT', 'MT - Malta'), ('MH', 'MH - Marshall Islands (The)'), ('MQ', 'MQ - Martinique'), ('MR', 'MR - Mauritania'), ('MU', 'MU - Mauritius'), ('YT', 'YT - Mayotte'), ('MX', 'MX - Mexico'), ('FM', 'FM - Micronesia (Federated States Of)'), ('MD', 'MD - Moldova (Republic Of)'), ('MC', 'MC - Monaco'), ('MN', 'MN - Mongolia'), ('ME', 'ME - Montenegro'), ('MS', 'MS - Montserrat'), ('MA', 'MA - Morocco'), ('MZ', 'MZ - Mozambique'), ('MM', 'MM - Myanmar'), ('NA', 'NA - Namibia'), ('NR', 'NR - Nauru'), ('NP', 'NP - Nepal'), ('NL', 'NL - Netherlands (The)'), ('AN', 'AN - Netherland Antilles'), ('NC', 'NC - New Caledonia'), ('NZ', 'NZ - New Zealand'), ('NI', 'NI - Nicaragua'), ('NE', 'NE - Niger (The)'), ('NG', 'NG - Nigeria'), ('NU', 'NU - Niue'), ('NF', 'NF - Norfolk Island'), ('MP', 'MP - Northern Mariana Islands (The)'), ('NO', 'NO - Norway'), ('OM', 'OM - Oman'), ('PK', 'PK - Pakistan'), ('PW', 'PW - Palau'), ('PS', 'PS - Palestinian Territory, Occupied'), ('PA', 'PA - Panama'), ('PG', 'PG - Papua New Guinea'), ('PY', 'PY - Paraguay'), ('PE', 'PE - Peru'), ('PH', 'PH - Philippines (The)'), ('PN', 'PN - Pitcairn'), ('PL', 'PL - Poland'), ('PT', 'PT - Portugal'), ('PR', 'PR - Puerto Rico'), ('QA', 'QA - Qatar'), ('RE', 'RE - Reunion'), ('RO', 'RO - Romania'), ('RU', 'RU - Russian Federation (The)'), ('RW', 'RW - Rwanda'), ('BL', 'BL - Saint Barth\xe9lemy'), ('SH', 'SH - Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'KN - Saint Kitts and Nevis'), ('LC', 'LC - Saint Lucia'), ('MF', 'MF - Saint Martin (French Part)'), ('PM', 'PM - Saint Pierre and Miquelon'), ('VC', 'VC - Saint Vincent and the Grenadines'), ('WS', 'WS - Samoa'), ('SM', 'SM - San Marino'), ('ST', 'ST - Sao Tome and Principe'), ('SA', 'SA - Saudi Arabia'), ('SN', 'SN - Senegal'), ('RS', 'RS - Serbia'), ('SC', 'SC - Seychelles'), ('SL', 'SL - Sierra Leone'), ('SG', 'SG - Singapore'), ('SX', 'SX - Sint Maarten (Dutch Part)'), ('SK', 'SK - Slovakia'), ('SI', 'SI - Slovenia'), ('SB', 'SB - Solomon Islands'), ('SO', 'SO - Somalia'), ('ZA', 'ZA - South Africa'), ('GS', 'GS - South Georgia and the South Sandwich Islands'), ('SS', 'SS - South Sudan'), ('ES', 'ES - Spain'), ('LK', 'LK - Sri Lanka'), ('SD', 'SD - Sudan (The)'), ('SR', 'SR - Suriname'), ('SJ', 'SJ - Svalbard and Jan Mayen'), ('SZ', 'SZ - Swaziland'), ('SE', 'SE - Sweden'), ('CH', 'CH - Switzerland'), ('SY', 'SY - Syrian Arab Republic'), ('TW', 'TW - Taiwan (Province of China)'), ('TJ', 'TJ - Tajikistan'), ('TZ', 'TZ - Tanzania, United Republic of'), ('TH', 'TH - Thailand'), ('TL', 'TL - Timor-Leste'), ('TG', 'TG - Togo'), ('TK', 'TK - Tokelau'), ('TO', 'TO - Tonga'), ('TT', 'TT - Trinidad and Tobago'), ('TN', 'TN - Tunisia'), ('TR', 'TR - Turkey'), ('TM', 'TM - Turkmenistan'), ('TC', 'TC - Turks and Caicos Islands (The)'), ('TV', 'TV - Tuvalu'), ('UG', 'UG - Uganda'), ('UA', 'UA - Ukraine'), ('AE', 'AE - United Arab Emirates (The)'), ('GB', 'GB - United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'US - United States of America (The)'), ('UM', 'UM - United States Minor Outlying Islands (The)'), ('UY', 'UY - Uruguay'), ('UZ', 'UZ - Uzbekistan'), ('VU', 'VU - Vanuatu'), ('VE', 'VE - Venezuela (Bolivarian Republic Of)'), ('VN', 'VN - Viet Nam'), ('VG', 'VG - Virgin Islands (British)'), ('VI', 'VI - Virgin Islands (U.s.)'), ('WF', 'WF - Wallis and Futuna'), ('EH', 'EH - Western Sahara'), ('YE', 'YE - Yemen'), ('ZM', 'ZM - Zambia'), ('ZW', 'ZW - Zimbabwe')])),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='Optionally enter a short description.', max_length=100, verbose_name='description', blank=True)),
                ('document', models.ForeignKey(related_name='countries', verbose_name='document', to='rsr.OrganisationDocument')),
            ],
            options={
                'ordering': ['-id'],
                'verbose_name': 'document category',
                'verbose_name_plural': 'document categories',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationExpenseLine',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of this specific line. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('reference', akvo.rsr.fields.ValidXMLCharField(help_text="An internal reference that describes the line in the reporting organisation's own system", max_length=50, verbose_name='reference', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='The description for this line.', max_length=1000, verbose_name='description', blank=True)),
            ],
            options={
                'verbose_name': 'expense line',
                'verbose_name_plural': 'expense lines',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationRecipientOrgBudget',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of budget that is set aside for this specific budget. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('period_start', models.DateField(help_text='Enter the start date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period start', blank=True)),
                ('period_end', models.DateField(help_text='Enter the end date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period end', blank=True)),
                ('status', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The status explains whether the budget being reported is indicative or has been formally committed.', max_length=1, verbose_name='status', choices=[('1', '1 - Indicative'), ('2', '2 - Committed')])),
                ('organisation', models.ForeignKey(related_name='recipient_org_budgets', verbose_name='organisation', to='rsr.Organisation')),
                ('recipient_organisation', models.ForeignKey(related_name='receiver_org_budgets', verbose_name='recipient organisation', to='rsr.Organisation')),
            ],
            options={
                'verbose_name': 'recipient organisation budget',
                'verbose_name_plural': 'recipient organisation budgets',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationRecipientOrgBudgetLine',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of this specific line. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('reference', akvo.rsr.fields.ValidXMLCharField(help_text="An internal reference that describes the line in the reporting organisation's own system", max_length=50, verbose_name='reference', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='The description for this line.', max_length=1000, verbose_name='description', blank=True)),
                ('budget', models.ForeignKey(related_name='budget_lines', verbose_name='organisation budget', to='rsr.OrganisationRecipientOrgBudget')),
            ],
            options={
                'verbose_name': 'recipient organisation budget line',
                'verbose_name_plural': 'recipient organisation budget lines',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationRegionBudget',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of budget that is set aside for this specific budget. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('period_start', models.DateField(help_text='Enter the start date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period start', blank=True)),
                ('period_end', models.DateField(help_text='Enter the end date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period end', blank=True)),
                ('status', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The status explains whether the budget being reported is indicative or has been formally committed.', max_length=1, verbose_name='status', choices=[('1', '1 - Indicative'), ('2', '2 - Committed')])),
                ('region', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the region which concerns the organisation budget.', max_length=25, verbose_name='recipient region', choices=[('88', '88 - States Ex-Yugoslavia, unspecified'), ('89', '89 - Europe, regional'), ('189', '189 - North of Sahara, regional'), ('289', '289 - South of Sahara, regional'), ('298', '298 - Africa, regional'), ('380', '380 - West Indies, regional'), ('389', '389 - North and Central America, regional'), ('489', '489 - South America, regional'), ('498', '498 - America, regional'), ('589', '589 - Middle East, regional'), ('619', '619 - Central Asia, regional'), ('679', '679 - South Asia, regional'), ('689', '689 - South and Central Asia, regional'), ('789', '789 - Far East Asia, regional'), ('798', '798 - Asia, regional'), ('889', '889 - Oceania, regional'), ('998', '998 - Developing countries, unspecified')])),
                ('region_vocabulary', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text="The vocabulary from which the region code is drawn. If it is not present 1 \u2013 'OECD DAC' is assumed.", max_length=2, verbose_name='vocabulary', choices=[('1', '1 - OECD DAC'), ('2', '2 - UN'), ('99', '99 - Reporting Organisation')])),
                ('region_vocabulary_uri', akvo.rsr.fields.ValidXMLCharField(help_text='If the vocabulary is 99 (reporting organisation), the URI where this internal vocabulary is defined.', max_length=1000, verbose_name='vocabulary URI', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='Optionally enter a short description.', max_length=100, verbose_name='description', blank=True)),
                ('organisation', models.ForeignKey(related_name='recipient_region_budgets', verbose_name='organisation', to='rsr.Organisation')),
            ],
            options={
                'verbose_name': 'organisation recipient region budget',
                'verbose_name_plural': 'organisation recipient region budgets',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationRegionBudgetLine',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of this specific line. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('reference', akvo.rsr.fields.ValidXMLCharField(help_text="An internal reference that describes the line in the reporting organisation's own system", max_length=50, verbose_name='reference', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='The description for this line.', max_length=1000, verbose_name='description', blank=True)),
                ('budget', models.ForeignKey(related_name='budget_lines', verbose_name='organisation budget', to='rsr.OrganisationRegionBudget')),
            ],
            options={
                'verbose_name': 'region budget line',
                'verbose_name_plural': 'region budget lines',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationTotalBudget',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of budget that is set aside for this specific budget. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('period_start', models.DateField(help_text='Enter the start date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period start', blank=True)),
                ('period_end', models.DateField(help_text='Enter the end date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period end', blank=True)),
                ('status', akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The status explains whether the budget being reported is indicative or has been formally committed.', max_length=1, verbose_name='status', choices=[('1', '1 - Indicative'), ('2', '2 - Committed')])),
                ('organisation', models.ForeignKey(related_name='total_budgets', verbose_name='organisation', to='rsr.Organisation')),
            ],
            options={
                'verbose_name': 'organisation total budget',
                'verbose_name_plural': 'organisation total budgets',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationTotalBudgetLine',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of this specific line. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('reference', akvo.rsr.fields.ValidXMLCharField(help_text="An internal reference that describes the line in the reporting organisation's own system", max_length=50, verbose_name='reference', blank=True)),
                ('text', akvo.rsr.fields.ValidXMLCharField(help_text='The description for this line.', max_length=1000, verbose_name='description', blank=True)),
                ('budget', models.ForeignKey(related_name='budget_lines', verbose_name='organisation budget', to='rsr.OrganisationTotalBudget')),
            ],
            options={
                'verbose_name': 'total budget line',
                'verbose_name_plural': 'total budget lines',
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OrganisationTotalExpenditure',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('currency', akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')])),
                ('value', models.DecimalField(decimal_places=2, max_digits=20, blank=True, help_text='Enter the amount of budget that is set aside for this specific budget. Use a period to denote decimals.', null=True, verbose_name='value')),
                ('value_date', models.DateField(help_text='Enter the date (DD/MM/YYYY) to be used for determining the exchange rate for currency conversions.', null=True, verbose_name='value date', blank=True)),
                ('period_start', models.DateField(help_text='Enter the start date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period start', blank=True)),
                ('period_end', models.DateField(help_text='Enter the end date (DD/MM/YYYY) for the budget period.', null=True, verbose_name='period end', blank=True)),
                ('organisation', models.ForeignKey(related_name='total_expenditures', verbose_name='organisation', to='rsr.Organisation')),
            ],
            options={
                'verbose_name': 'organisation total expenditure',
                'verbose_name_plural': 'organisation total expenditures',
            },
            bases=(models.Model,),
        ),
        migrations.AddField(
            model_name='organisationexpenseline',
            name='expenditure',
            field=models.ForeignKey(related_name='expense_lines', verbose_name='organisation expenditure', to='rsr.OrganisationTotalExpenditure'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='organisation',
            name='currency',
            field=akvo.rsr.fields.ValidXMLCharField(default=b'EUR', help_text='The default currency for this organisation. Used in all financial aspects of the organisation.', max_length=3, verbose_name='currency', choices=[('AED', 'AED - UAE Dirham'), ('AFN', 'AFN - Afghani'), ('ALL', 'ALL - Lek'), ('AMD', 'AMD - Armenian Dram'), ('ANG', 'ANG - Netherlands Antillian Guilder'), ('AOA', 'AOA - Kwanza'), ('ARS', 'ARS - Argentine Peso'), ('AUD', 'AUD - Australian Dollar'), ('AWG', 'AWG - Aruban Guilder'), ('AZN', 'AZN - Azerbaijanian Manat'), ('BAM', 'BAM - Convertible Marks'), ('BBD', 'BBD - Barbados Dollar'), ('BDT', 'BDT - Taka'), ('BGN', 'BGN - Bulgarian Lev'), ('BHD', 'BHD - Bahraini Dinar'), ('BIF', 'BIF - Burundi Franc'), ('BMD', 'BMD - Bermudian Dollar'), ('BND', 'BND - Brunei Dollar'), ('BOB', 'BOB - Boliviano'), ('BOV', 'BOV - Mvdol'), ('BRL', 'BRL - Brazilian Real'), ('BSD', 'BSD - Bahamian Dollar'), ('BTN', 'BTN - Ngultrum'), ('BWP', 'BWP - Pula'), ('BYR', 'BYR - Belarussian Ruble'), ('BZD', 'BZD - Belize Dollar'), ('CAD', 'CAD - Canadian Dollar'), ('CDF', 'CDF - Congolese Franc'), ('CHF', 'CHF - Swiss Franc'), ('CLF', 'CLF - Unidades de fomento'), ('CLP', 'CLP - Chilean Peso'), ('CNY', 'CNY - Yuan Renminbi'), ('COP', 'COP - Colombian Peso'), ('COU', 'COU - Unidad de Valor Real'), ('CRC', 'CRC - Costa Rican Colon'), ('CUC', 'CUC - Peso Convertible'), ('CUP', 'CUP - Cuban Peso'), ('CVE', 'CVE - Cape Verde Escudo'), ('CZK', 'CZK - Czech Koruna'), ('DJF', 'DJF - Djibouti Franc'), ('DKK', 'DKK - Danish Krone'), ('DOP', 'DOP - Dominican Peso'), ('DZD', 'DZD - Algerian Dinar'), ('EEK', 'EEK - Kroon'), ('EGP', 'EGP - Egyptian Pound'), ('ERN', 'ERN - Nakfa'), ('ETB', 'ETB - Ethiopian Birr'), ('EUR', 'EUR - Euro'), ('FJD', 'FJD - Fiji Dollar'), ('FKP', 'FKP - Falkland Islands Pound'), ('GBP', 'GBP - Pound Sterling'), ('GEL', 'GEL - Lari'), ('GHS', 'GHS - Cedi'), ('GIP', 'GIP - Gibraltar Pound'), ('GMD', 'GMD - Dalasi'), ('GNF', 'GNF - Guinea Franc'), ('GTQ', 'GTQ - Quetzal'), ('GYD', 'GYD - Guyana Dollar'), ('HKD', 'HKD - Hong Kong Dollar'), ('HNL', 'HNL - Lempira'), ('HRK', 'HRK - Kuna'), ('HTG', 'HTG - Gourde'), ('HUF', 'HUF - Forint'), ('IDR', 'IDR - Rupiah'), ('ILS', 'ILS - New Israeli Sheqel'), ('INR', 'INR - Indian Rupee'), ('IQD', 'IQD - Iraqi Dinar'), ('IRR', 'IRR - Iranian Rial'), ('ISK', 'ISK - Iceland Krona'), ('JMD', 'JMD - Jamaican Dollar'), ('JOD', 'JOD - Jordanian Dinar'), ('JPY', 'JPY - Yen'), ('KES', 'KES - Kenyan Shilling'), ('KGS', 'KGS - Som'), ('KHR', 'KHR - Riel'), ('KMF', 'KMF - Comoro Franc'), ('KPW', 'KPW - North Korean Won'), ('KRW', 'KRW - Won'), ('KWD', 'KWD - Kuwaiti Dinar'), ('KYD', 'KYD - Cayman Islands Dollar'), ('KZT', 'KZT - Tenge'), ('LAK', 'LAK - Kip'), ('LBP', 'LBP - Lebanese Pound'), ('LKR', 'LKR - Sri Lanka Rupee'), ('LRD', 'LRD - Liberian Dollar'), ('LSL', 'LSL - Loti'), ('LTL', 'LTL - Lithuanian Litas'), ('LVL', 'LVL - Latvian Lats'), ('LYD', 'LYD - Libyan Dinar'), ('MAD', 'MAD - Moroccan Dirham'), ('MDL', 'MDL - Moldovan Leu'), ('MGA', 'MGA - Malagasy Ariary'), ('MKD', 'MKD - Denar'), ('MMK', 'MMK - Kyat'), ('MNT', 'MNT - Tugrik'), ('MOP', 'MOP - Pataca'), ('MRO', 'MRO - Ouguiya'), ('MUR', 'MUR - Mauritius Rupee'), ('MVR', 'MVR - Rufiyaa'), ('MWK', 'MWK - Malawi Kwacha'), ('MXN', 'MXN - Mexican Peso'), ('MXV', 'MXV - Mexican Unidad de Inversion (UDI)'), ('MYR', 'MYR - Malaysian Ringgit'), ('MZN', 'MZN - Metical'), ('NAD', 'NAD - Namibia Dollar'), ('NGN', 'NGN - Naira'), ('NIO', 'NIO - Cordoba Oro'), ('NOK', 'NOK - Norwegian Krone'), ('NPR', 'NPR - Nepalese Rupee'), ('NZD', 'NZD - New Zealand Dollar'), ('OMR', 'OMR - Rial Omani'), ('PAB', 'PAB - Balboa'), ('PEN', 'PEN - Nuevo Sol'), ('PGK', 'PGK - Kina'), ('PHP', 'PHP - Philippine Peso'), ('PKR', 'PKR - Pakistan Rupee'), ('PLN', 'PLN - Zloty'), ('PYG', 'PYG - Guarani'), ('QAR', 'QAR - Qatari Rial'), ('RON', 'RON - Romanian Leu'), ('RSD', 'RSD - Serbian Dinar'), ('RUB', 'RUB - Russian Ruble'), ('RWF', 'RWF - Rwanda Franc'), ('SAR', 'SAR - Saudi Riyal'), ('SBD', 'SBD - Solomon Islands Dollar'), ('SCR', 'SCR - Seychelles Rupee'), ('SDG', 'SDG - Sudanese Pound'), ('SEK', 'SEK - Swedish Krona'), ('SGD', 'SGD - Singapore Dollar'), ('SHP', 'SHP - Saint Helena Pound'), ('SLL', 'SLL - Leone'), ('SOS', 'SOS - Somali Shilling'), ('SSP', 'SSP - South Sudanese Pound'), ('SRD', 'SRD - Surinam Dollar'), ('STD', 'STD - Dobra'), ('SVC', 'SVC - El Salvador Colon'), ('SYP', 'SYP - Syrian Pound'), ('SZL', 'SZL - Lilangeni'), ('THB', 'THB - Baht'), ('TJS', 'TJS - Somoni'), ('TMT', 'TMT - Manat'), ('TND', 'TND - Tunisian Dinar'), ('TOP', 'TOP - Paanga'), ('TRY', 'TRY - Turkish Lira'), ('TTD', 'TTD - Trinidad and Tobago Dollar'), ('TWD', 'TWD - New Taiwan Dollar'), ('TZS', 'TZS - Tanzanian Shilling'), ('UAH', 'UAH - Hryvnia'), ('UGX', 'UGX - Uganda Shilling'), ('USD', 'USD - US Dollar'), ('USN', 'USN - US Dollar (Next day)'), ('USS', 'USS - US Dollar (Same day)'), ('UYI', 'UYI - Uruguay Peso en Unidades Indexadas'), ('UYU', 'UYU - Peso Uruguayo'), ('UZS', 'UZS - Uzbekistan Sum'), ('VEF', 'VEF - Bolivar'), ('VND', 'VND - Dong'), ('VUV', 'VUV - Vatu'), ('WST', 'WST - Tala'), ('XAF', 'XAF - CFA Franc BEAC'), ('XBT', 'XBT - Bitcoin'), ('XCD', 'XCD - East Caribbean Dollar'), ('XDR', 'XDR - International Monetary Fund (IMF) Special Drawing Right (SDR)'), ('XOF', 'XOF - CFA Franc BCEAO'), ('XPF', 'XPF - CFP Franc'), ('YER', 'YER - Yemeni Rial'), ('ZAR', 'ZAR - Rand'), ('ZMK', 'ZMK - Zambian Kwacha'), ('ZWL', 'ZWL - Zimbabwe Dollar')]),
            preserve_default=True,
        ),
    ]
