# -*- coding: utf-8 -*-


from django.db import models, migrations
import akvo.rsr.fields


class Migration(migrations.Migration):

    dependencies = [
        ('rsr', '0112_auto_20170927_1520'),
    ]

    operations = [
        migrations.AlterField(
            model_name='crsadd',
            name='channel_code',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The CRS channel code for this activity. The codelist contains both organisation types and names of organisations. For non-CRS purposes these should be reported using participating organisations. See the <a href="http://iatistandard.org/202/codelists/CRSChannelCode/" target="_blank">IATI codelist</a>.', max_length=5, verbose_name='channel code', choices=[('10000', '10000 - PUBLIC SECTOR INSTITUTIONS'), ('11000', '11000 - Donor Government'), ('11001', '11001 - Central Government'), ('11002', '11002 - Local Government'), ('11003', '11003 - Public corporations'), ('11004', '11004 - Other public entities in donor country'), ('12000', '12000 - Recipient Government'), ('12001', '12001 - Central Government'), ('12002', '12002 - Local Government'), ('12003', '12003 - Public corporations'), ('12004', '12004 - Other public entities in recipient country'), ('13000', '13000 - Third Country Government (Delegated co-operation)'), ('20000', '20000 - NON-GOVERNMENTAL ORGANISATIONS (NGOs) AND CIVIL SOCIETY'), ('21000', '21000 - INTERNATIONAL NGO'), ('21045', '21045 - African Medical and Research Foundation'), ('21046', '21046 - Agency for Cooperation and Research in Development'), ('21001', '21001 - Association of Geoscientists for International Development'), ('21063', '21063 - Conservation International'), ('21005', '21005 - Consumer Unity and Trust Society International'), ('21029', '21029 - Doctors Without Borders'), ('47035', '47035 - Environmental Development Action in the Third World'), ('21007', '21007 - Environmental Liaison Centre International'), ('21503', '21503 - Family Health International 360'), ('21011', '21011 - Global Campaign for Education'), ('21013', '21013 - Health Action International'), ('21024', '21024 - Inter Press Service, International Association'), ('21038', '21038 - International Alert'), ('21057', '21057 - International Centre for Transitional Justice'), ('21016', '21016 - International Committee of the Red Cross'), ('21044', '21044 - International Council for the Control of Iodine Deficiency Disorders'), ('21018', '21018 - International Federation of Red Cross and Red Crescent Societies'), ('21020', '21020 - International HIV/AIDS Alliance'), ('21022', '21022 - International Network for Alternative Financial Institutions'), ('21042', '21042 - International Peacebuilding Alliance'), ('21023', '21023 - International Planned Parenthood Federation'), ('21061', '21061 - International Rehabilitation Council for Torture Victims'), ('21504', '21504 - International Relief and Development'), ('21506', '21506 - International Rescue Committee'), ('21034', '21034 - International Union Against Tuberculosis and Lung Disease'), ('21053', '21053 - IPAS-Protecting Women\u2019s Health, Advancing Women\u2019s Reproductive Rights'), ('21054', '21054 - Life and Peace Institute'), ('21501', '21501 - OXFAM International'), ('21507', '21507 - Pact World'), ('21031', '21031 - PANOS Institute'), ('21032', '21032 - Population Services International'), ('21505', '21505 - Save the Children'), ('21041', '21041 - Society for International Development'), ('21062', '21062 - The Nature Conservancy'), ('21036', '21036 - World University Service'), ('21502', '21502 - World Vision'), ('22000', '22000 - Donor country-based NGO'), ('21047', '21047 - AgriCord'), ('21060', '21060 - Association for the Prevention of Torture'), ('21006', '21006 - Development Gateway Foundation'), ('21049', '21049 - European Centre for Development Policy Management'), ('21008', '21008 - Eurostep'), ('47042', '47042 - Foundation for International Training'), ('21050', '21050 - Geneva Call'), ('21014', '21014 - Human Rights Information and Documentation Systems'), ('21015', '21015 - International Catholic Rural Association'), ('21058', '21058 - International Crisis Group'), ('21019', '21019 - International Federation of Settlements and Neighbourhood Centres'), ('21025', '21025 - International Seismological Centre'), ('21026', '21026 - International Service for Human Rights'), ('21027', '21027 - ITF Enhancing Human Security'), ('21040', "21040 - International Women's Tribune Centre"), ('22501', '22501 - OXFAM - provider country office'), ('22502', '22502 - Save the Children - donor country office'), ('21033', '21033 - Transparency International'), ('21037', "21037 - Women's World Banking"), ('21035', '21035 - World Organisation Against Torture'), ('23000', '23000 - Developing country-based NGO'), ('21059', '21059 - Africa Solidarity Fund'), ('21048', '21048 - Association of African Universities'), ('21010', '21010 - Forum for African Women Educationalists'), ('21051', '21051 - Institut Sup\xe9rieur Panafricaine d\u2019Economie Coop\xe9rative'), ('21028', '21028 - International University Exchange Fund - IUEF Stip. in Africa and Latin America'), ('21003', '21003 - Latin American Council for Social Sciences'), ('23501', '23501 - National Red Cross and Red Crescent Societies'), ('21030', '21030 - Pan African Institute for Development'), ('21055', '21055 - Regional AIDS Training Network'), ('30000', '30000 - PUBLIC-PRIVATE PARTNERSHIPS (PPPs) and NETWORKS'), ('31000', '31000 - Public-Private Partnership (PPP)'), ('30008', '30008 - Cities Alliance'), ('30016', '30016 - European Fund for Southeast Europe'), ('30007', '30007 - Global Alliance for ICT and Development'), ('30001', '30001 - Global Alliance for Improved Nutrition'), ('30012', '30012 - Global Climate Partnership Fund'), ('47043', '47043 - Global Crop Diversity Trust'), ('30015', '30015 - Global Energy Efficiency and Renewable Energy Fund'), ('30003', '30003 - Global e-Schools and Communities Initiative'), ('30004', '30004 - Global Water Partnership'), ('30005', '30005 - International AIDS Vaccine Initiative'), ('30006', '30006 - International Partnership on Microbicides'), ('30011', '30011 - International Union for the Conservation of Nature'), ('30013', '30013 - Microfinance Enhancement Facility'), ('30014', '30014 - Regional Micro, Small and Medium Enterprise Investment Fund for Sub-Saharan Africa'), ('21056', '21056 - Renewable Energy and Energy Efficiency Partnership'), ('30017', '30017 - SANAD Fund for Micro, Small and Medium Enterprises'), ('30009', '30009 - Small Arms Survey'), ('32000', '32000 - Network'), ('47010', '47010 - Commonwealth Agency for Public Administration and Management'), ('47028', '47028 - Commonwealth Partnership for Technical Management'), ('21043', '21043 - European Parliamentarians for Africa'), ('31004', '31004 - Extractive Industries Transparency Initiative International Secretariat'), ('31001', '31001 - Global Development Network'), ('31002', '31002 - Global Knowledge Partnership'), ('21017', '21017 - International Centre for Trade and Sustainable Development'), ('31003', '31003 - International Land Coalition'), ('31005', '31005 - Parliamentary Network on the World Bank'), ('40000', '40000 - MULTILATERAL ORGANISATIONS'), ('41000', '41000 - United Nations agency, fund or commission (UN)'), ('41147', '41147 - Central Emergency Response Fund'), ('41101', '41101 - Convention to Combat Desertification'), ('41102', '41102 - Desert Locust Control Organisation for Eastern Africa'), ('41106', '41106 - Economic and Social Commission for Asia and the Pacific'), ('41105', '41105 - Economic and Social Commission for Western Asia'), ('41103', '41103 - Economic Commission for Africa'), ('41104', '41104 - Economic Commission for Latin America and the Caribbean'), ('41301', '41301 - Food and Agricultural Organisation'), ('41318', '41318 - Global Mechanism'), ('41317', '41317 - Green Climate Fund'), ('41312', '41312 - International Atomic Energy Agency - assessed contributions'), ('41107', '41107 - International Atomic Energy Agency (Contributions to Technical Cooperation Fund Only)'), ('41108', '41108 - International Fund for Agricultural Development'), ('41302', '41302 - International Labour Organisation - Assessed Contributions'), ('41144', '41144 - International Labour Organisation - Regular Budget Supplementary Account'), ('41145', '41145 - International Maritime Organization - Technical Co-operation Fund'), ('41303', '41303 - International Telecommunications Union'), ('41110', '41110 - Joint United Nations Programme on HIV/AIDS'), ('41305', '41305 - United Nations'), ('41111', '41111 - United Nations Capital Development Fund'), ('41122', '41122 - United Nations Children\u2019s Fund'), ('41112', '41112 - United Nations Conference on Trade and Development'), ('41142', '41142 - United Nations Democracy Fund'), ('41310', '41310 - United Nations Department of Peacekeeping Operations [only MINURSO, MINUSCA, MINUSMA, MINUSTAH, MONUSCO, UNAMID, UNIFIL, UNISFA, UNMIK, UNMIL, UNMISS, UNOCI]. Report contributions mission by mission in CRS++.'), ('41148', '41148 - United Nations Department of Political Affairs, Trust Fund in Support of Political Affairs'), ('41114', '41114 - United Nations Development Programme'), ('41314', '41314 - United Nations Economic Commission for Europe (extrabudgetary contributions only)'), ('41304', '41304 - United Nations Educational, Scientific and Cultural Organisation'), ('41146', '41146 - United Nations Entity for Gender Equality and the Empowerment of Women'), ('41116', '41116 - United Nations Environment Programme'), ('41316', '41316 - United Nations Framework Convention on Climate Change'), ('41313', '41313 - United Nations High Commissioner for Human Rights (extrabudgetary contributions only)'), ('41120', '41120 - United Nations Human Settlement Programme'), ('41123', '41123 - United Nations Industrial Development Organisation'), ('41125', '41125 - United Nations Institute for Training and Research'), ('41315', '41315 - United Nations International Strategy for Disaster Reduction'), ('41126', '41126 - United Nations Mine Action Service'), ('41502', '41502 - United Nations Office for Project Services'), ('41127', '41127 - United Nations Office of Co-ordination of Humanitarian Affairs'), ('41121', '41121 - United Nations Office of the United Nations High Commissioner for Refugees'), ('41128', '41128 - United Nations Office on Drugs and Crime'), ('41311', '41311 - United Nations Peacebuilding Fund (Window One:  Flexible Contributions Only)'), ('41141', '41141 - United Nations Peacebuilding Fund (Window Two:  Restricted Contributions Only)'), ('41119', '41119 - United Nations Population Fund'), ('41501', '41501 - United Nations Reducing Emissions from Deforestation and Forest Degradation'), ('41130', '41130 - United Nations Relief and Works Agency for Palestine Refugees in the Near East'), ('41129', '41129 - United Nations Research Institute for Social Development'), ('41133', '41133 - United Nations Special Initiative on Africa'), ('41131', '41131 - United Nations System Staff College'), ('41132', '41132 - United Nations System Standing Committee on Nutrition'), ('41134', '41134 - United Nations University (including Endowment Fund)'), ('41137', '41137 - United Nations Voluntary Fund for Technical Co-operation in the Field of Human Rights'), ('41138', '41138 - United Nations Voluntary Fund for Victims of Torture'), ('41136', '41136 - United Nations Voluntary Fund on Disability'), ('41135', '41135 - United Nations Volunteers'), ('41306', '41306 - Universal Postal Union'), ('41503', '41503 - UN-led Country-based Pooled Funds'), ('41140', '41140 - World Food Programme'), ('41307', '41307 - World Health Organisation - assessed contributions'), ('41143', '41143 - World Health Organisation - core voluntary contributions account'), ('41308', '41308 - World Intellectual Property Organisation'), ('41309', '41309 - World Meteorological Organisation'), ('41319', '41319 - World Tourism Organization'), ('42000', '42000 - European Union Institution (EU)'), ('42001', '42001 - European Commission - Development Share of Budget'), ('42003', '42003 - European Commission - European Development Fund'), ('42004', '42004 - European Investment Bank'), ('43000', '43000 - International Monetary Fund (IMF)'), ('43005', '43005 - International Monetary Fund - Post-Catastrophe Debt Relief Trust'), ('43002', '43002 - International Monetary Fund - Poverty Reduction and Growth - Heavily Indebted Poor Countries Debt Relief Initiative Trust Fund [includes HIPC, Extended Credit Facility (ECF), and ECF-HIPC sub-accounts]'), ('43004', '43004 - International Monetary Fund - Poverty Reduction and Growth - Multilateral Debt Relief Initiative Trust'), ('43001', '43001 - International Monetary Fund - Poverty Reduction and Growth Trust'), ('43003', '43003 - International Monetary Fund - Subsidization of Emergency Post Conflict Assistance/Emergency Assistance for Natural Disasters for PRGT-eligible members'), ('43006', '43006 - Catastrophe Containment and Relief Trust'), ('44000', '44000 - World Bank Group (WB)'), ('44006', '44006 - Advance Market Commitments'), ('44001', '44001 - International Bank for Reconstruction and Development'), ('44002', '44002 - International Development Association'), ('44003', '44003 - International Development Association - Heavily Indebted Poor Countries Debt Initiative Trust Fund'), ('44007', '44007 - International Development Association - Multilateral Debt Relief Initiative'), ('44004', '44004 - International Finance Corporation'), ('44005', '44005 - Multilateral Investment Guarantee Agency'), ('45000', '45000 - World Trade Organisation'), ('45002', '45002 - World Trade Organisation - Advisory Centre on WTO Law'), ('45003', '45003 - World Trade Organisation - Doha Development Agenda Global Trust Fund'), ('45001', '45001 - World Trade Organisation - International Trade Centre'), ('46000', '46000 - Regional Development Bank'), ('46002', '46002 - African Development Bank'), ('46003', '46003 - African Development Fund'), ('46022', '46022 - African Export Import Bank'), ('46008', '46008 - Andean Development Corporation'), ('46004', '46004 - Asian Development Bank'), ('46005', '46005 - Asian Development Fund'), ('46026', '46026 - Asian Infrastructure Investment Bank'), ('46006', '46006 - Black Sea Trade and Development Bank'), ('46009', '46009 - Caribbean Development Bank'), ('46020', '46020 - Central African States Development Bank'), ('46007', '46007 - Central American Bank for Economic Integration'), ('46024', '46024 - Council of Europe Development Bank'), ('46023', '46023 - Eastern and Southern African Trade and Development Bank'), ('46015', '46015 - European Bank for Reconstruction and Development'), ('46018', '46018 - European Bank for Reconstruction and Development - Early Transition Countries Fund'), ('46017', '46017 - European Bank for Reconstruction and Development \u2013 technical co-operation and special funds (all EBRD countries of operations)'), ('46016', '46016 - European Bank for Reconstruction and Development \u2013 technical co-operation and special funds (ODA-eligible countries only)'), ('46019', '46019 - European Bank for Reconstruction and Development - Western Balkans Joint Trust Fund'), ('46013', '46013 - Inter-American Development Bank, Fund for Special Operations'), ('46012', '46012 - Inter-American Development Bank, Inter-American Investment Corporation and Multilateral Investment Fund'), ('46025', '46025 - Islamic Development Bank'), ('46021', '46021 - West African Development Bank'), ('47000', '47000 - Other multilateral institution'), ('47111', '47111 - Adaptation Fund'), ('47009', '47009 - African and Malagasy Council for Higher Education'), ('47001', '47001 - African Capacity Building Foundation'), ('47137', '47137 - African Risk Capacity Group'), ('47141', '47141 - African Tax Administration Forum'), ('47005', '47005 - African Union (excluding peacekeeping facilities)'), ('21002', '21002 - Agency for International Trade Information and Co-operation'), ('47002', '47002 - Asian Productivity Organisation'), ('47109', '47109 - Asia-Pacific Economic Cooperation Support Fund (except contributions tied to counter-terrorism activities)'), ('47068', '47068 - Asia-Pacific Fishery Commission'), ('47003', '47003 - Association of South East Asian Nations: Economic Co-operation'), ('47011', '47011 - Caribbean Community Secretariat'), ('47012', '47012 - Caribbean Epidemiology Centre'), ('47145', '47145 - Center of Excellence in Finance'), ('47112', '47112 - Central European Initiative - Special Fund for Climate and Environmental Protection'), ('47015', '47015 - CGIAR Fund'), ('47134', '47134 - Clean Technology Fund'), ('47027', '47027 - Colombo Plan'), ('47105', '47105 - Common Fund for Commodities'), ('47013', '47013 - Commonwealth Foundation'), ('47025', '47025 - Commonwealth of Learning'), ('47132', '47132 - Commonwealth Secretariat (ODA-eligible contributions only)'), ('47026', '47026 - Community of Portuguese Speaking Countries'), ('47022', '47022 - Convention on International Trade in Endangered Species of Wild Flora and Fauna'), ('47138', '47138 - Council of Europe'), ('47037', '47037 - Eastern-Regional Organisation of Public Administration'), ('47113', '47113 - Economic and Monetary Community of Central Africa'), ('47034', '47034 - Economic Community of West African States'), ('47036', '47036 - European and Mediterranean Plant Protection Organisation'), ('47504', '47504 - Forest Carbon Partnership Facility'), ('47040', '47040 - Forum Fisheries Agency'), ('47106', '47106 - Geneva Centre for the Democratic Control of Armed Forces'), ('47123', '47123 - Geneva International Centre for Humanitarian Demining'), ('47503', '47503 - Global Agriculture and Food Security Program'), ('47122', '47122 - Global Alliance for Vaccines and Immunization'), ('47129', '47129 - Global Environment Facility - Least Developed Countries Fund'), ('47130', '47130 - Global Environment Facility - Special Climate Change Fund'), ('47044', '47044 - Global Environment Facility Trust Fund'), ('47502', '47502 - Global Fund for Disaster Risk Reduction'), ('47045', '47045 - Global Fund to Fight AIDS, Tuberculosis and Malaria'), ('47136', '47136 - Global Green Growth Institute'), ('47501', '47501 - Global Partnership for Education'), ('47116', '47116 - Integrated Framework for Trade-Related Technical Assistance to Least Developed Countries'), ('47061', '47061 - Inter-American Institute for Co-operation on Agriculture'), ('47065', '47065 - Intergovernmental Oceanographic Commission'), ('47067', '47067 - Intergovernmental Panel on Climate Change'), ('47019', '47019 - International Centre for Advanced Mediterranean Agronomic Studies'), ('47050', '47050 - International Cotton Advisory Committee'), ('47059', '47059 - International Development Law Organisation'), ('30010', '30010 - International drug purchase facility'), ('47107', '47107 - International Finance Facility for Immunisation'), ('47058', '47058 - International Institute for Democracy and Electoral Assistance'), ('47064', '47064 - International Network for Bamboo and Rattan'), ('47066', '47066 - International Organisation for Migration'), ('47046', '47046 - International Organisation of the Francophonie'), ('47073', '47073 - International Tropical Timber Organisation'), ('47074', '47074 - International Vaccine Institute'), ('47076', '47076 - Justice Studies Centre of the Americas'), ('47127', '47127 - Latin-American Energy Organisation'), ('47077', '47077 - Mekong River Commission'), ('47078', '47078 - Multilateral Fund for the Implementation of the Montreal Protocol'), ('47117', "47117 - New Partnership for Africa's Development"), ('47128', '47128 - Nordic Development Fund'), ('47081', '47081 - OECD Development Centre'), ('47142', '47142 - OPEC Fund for International Development'), ('47080', '47080 - Organisation for Economic Co-operation and Development (Contributions to special funds for Technical Co-operation Activities Only)'), ('47079', '47079 - Organisation of American States'), ('47082', '47082 - Organisation of Eastern Caribbean States'), ('47140', '47140 - Organisation of Ibero-American States for Education, Science and Culture'), ('47110', '47110 - Organisation of the Black Sea Economic Cooperation'), ('47131', '47131 - Organization for Security and Co-operation in Europe'), ('47087', '47087 - Pacific Islands Forum Secretariat'), ('47097', '47097 - Pacific Regional Environment Programme'), ('47083', '47083 - Pan-American Health Organisation'), ('47084', '47084 - Pan-American Institute of Geography and History'), ('47086', '47086 - Private Infrastructure Development Group'), ('47118', '47118 - Regional Organisation for the Strengthening of Supreme Audit Institutions of Francophone Sub-Saharan Countries'), ('47119', '47119 - Sahara and Sahel Observatory'), ('47029', '47029 - Sahel and West Africa Club'), ('47096', '47096 - Secretariat of the Pacific Community'), ('47120', '47120 - South Asian Association for Regional Cooperation'), ('47092', '47092 - South East Asian Fisheries Development Centre'), ('47093', '47093 - South East Asian Ministers of Education'), ('47095', '47095 - South Pacific Board for Educational Assessment'), ('47089', '47089 - Southern African Development Community'), ('47135', '47135 - Strategic Climate Fund'), ('47121', '47121 - United Cities and Local Governments of Africa'), ('47098', '47098 - Unrepresented Nations and Peoples\u2019 Organisation'), ('47100', '47100 - West African Monetary Union'), ('47139', '47139 - World Customs Organization Customs Co-operation Fund'), ('47143', '47143 - Global Community Engagement and Resilience Fund'), ('47144', '47144 - International Renewable Energy Agency'), ('50000', '50000 - Other'), ('51000', '51000 - University, college or other teaching institution, research institute or think\u2011tank'), ('47101', '47101 - Africa Rice Centre'), ('47069', '47069 - Bioversity International'), ('47018', '47018 - Centre for International Forestry Research'), ('21004', '21004 - Council for the Development of Economic and Social Research in Africa'), ('47041', '47041 - Food and Fertilizer Technology Centre'), ('21009', '21009 - Forum for Agricultural Research in Africa'), ('47047', '47047 - International African Institute'), ('47051', '47051 - International Centre for Agricultural Research in Dry Areas'), ('47055', '47055 - International Centre for Development Oriented Research in Agriculture'), ('47053', '47053 - International Centre for Diarrhoeal Disease Research, Bangladesh'), ('47017', '47017 - International Centre for Tropical Agriculture'), ('47054', '47054 - International Centre of Insect Physiology and Ecology'), ('47057', '47057 - International Crop Research for Semi-Arid Tropics'), ('51001', '51001 - International Food Policy Research Institute'), ('21021', '21021 - International Institute for Environment and Development'), ('21039', '21039 - International Institute for Sustainable Development'), ('47062', '47062 - International Institute of Tropical Agriculture'), ('47063', '47063 - International Livestock Research Institute'), ('47020', '47020 - International Maize and Wheat Improvement Centre'), ('47021', '47021 - International Potato Centre'), ('47070', '47070 - International Rice Research Institute'), ('47071', '47071 - International Seed Testing Association'), ('47075', '47075 - International Water Management Institute'), ('47099', '47099 - University of the South Pacific'), ('47056', '47056 - World AgroForestry Centre'), ('47103', '47103 - World Maritime University'), ('47008', '47008 - World Vegetable Centre'), ('47104', '47104 - WorldFish Centre'), ('52000', '52000 - Other'), ('60000', '60000 - Private sector institution'), ('61000', '61000 - Private sector in provider country'), ('61001', '61001 - Private bank in provider country'), ('61002', '61002 - Private exporter in provider country'), ('61003', '61003 - Private investor in provider country'), ('61004', '61004 - Other non-bank entity in provider country'), ('62000', '62000 - Private sector in recipient country'), ('62001', '62001 - Private bank in recipient country'), ('62002', '62002 - Joint-venture in recipient country'), ('62003', '62003 - Other non-bank in recipient country'), ('63000', '63000 - Private sector in third country'), ('63001', '63001 - Private bank in third country'), ('63002', '63002 - Private non-bank in third country'), ('90000', '90000 - Other')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='employment',
            name='country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, max_length=2, verbose_name='country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='humanitarianscope',
            name='vocabulary',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='A recognised vocabulary of terms classifying the event or action. See the <a href="http://iatistandard.org/202/codelists/HumanitarianScopeVocabulary/" target="_blank">IATI codelist</a>.', max_length=3, verbose_name='humanitarian scope vocabulary', choices=[('1-2', '1-2 - Glide'), ('2-1', '2-1 - Humanitarian Plan'), ('99', '99 - Reporting Organisation')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='organisationcountrybudget',
            name='country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the country which concerns the organisation budget.', max_length=2, verbose_name='recipient country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='organisationdocument',
            name='format',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This provides the code for the Internet Media Type ("MIME type") of the document, and includes pdf, msword, rtf, xml, csv, etc.', max_length=75, verbose_name='document format', choices=[('application/1d-interleaved-parityfec', 'application/1d-interleaved-parityfec'), ('application/3gpdash-qoe-report+xml', 'application/3gpdash-qoe-report+xml'), ('application/3gpp-ims+xml', 'application/3gpp-ims+xml'), ('application/A2L', 'application/A2L'), ('application/activemessage', 'application/activemessage'), ('application/activemessage', 'application/activemessage'), ('application/alto-costmap+json', 'application/alto-costmap+json'), ('application/alto-costmapfilter+json', 'application/alto-costmapfilter+json'), ('application/alto-directory+json', 'application/alto-directory+json'), ('application/alto-endpointprop+json', 'application/alto-endpointprop+json'), ('application/alto-endpointpropparams+json', 'application/alto-endpointpropparams+json'), ('application/alto-endpointcost+json', 'application/alto-endpointcost+json'), ('application/alto-endpointcostparams+json', 'application/alto-endpointcostparams+json'), ('application/alto-error+json', 'application/alto-error+json'), ('application/alto-networkmapfilter+json', 'application/alto-networkmapfilter+json'), ('application/alto-networkmap+json', 'application/alto-networkmap+json'), ('application/AML', 'application/AML'), ('application/andrew-inset', 'application/andrew-inset'), ('application/applefile', 'application/applefile'), ('application/ATF', 'application/ATF'), ('application/ATFX', 'application/ATFX'), ('application/atom+xml', 'application/atom+xml'), ('application/atomcat+xml', 'application/atomcat+xml'), ('application/atomdeleted+xml', 'application/atomdeleted+xml'), ('application/atomicmail', 'application/atomicmail'), ('application/atomsvc+xml', 'application/atomsvc+xml'), ('application/ATXML', 'application/ATXML'), ('application/auth-policy+xml', 'application/auth-policy+xml'), ('application/bacnet-xdd+zip', 'application/bacnet-xdd+zip'), ('application/batch-SMTP', 'application/batch-SMTP'), ('application/beep+xml', 'application/beep+xml'), ('application/calendar+json', 'application/calendar+json'), ('application/calendar+xml', 'application/calendar+xml'), ('application/call-completion', 'application/call-completion'), ('application/CALS-1840', 'application/CALS-1840'), ('application/cbor', 'application/cbor'), ('application/ccmp+xml', 'application/ccmp+xml'), ('application/ccxml+xml', 'application/ccxml+xml'), ('application/CDFX+XML', 'application/CDFX+XML'), ('application/cdmi-capability', 'application/cdmi-capability'), ('application/cdmi-container', 'application/cdmi-container'), ('application/cdmi-domain', 'application/cdmi-domain'), ('application/cdmi-object', 'application/cdmi-object'), ('application/cdmi-queue', 'application/cdmi-queue'), ('application/cdni', 'application/cdni'), ('application/CEA', 'application/CEA'), ('application/cea-2018+xml', 'application/cea-2018+xml'), ('application/cellml+xml', 'application/cellml+xml'), ('application/cfw', 'application/cfw'), ('application/clue_info+xml', 'application/clue_info+xml'), ('application/cms', 'application/cms'), ('application/cnrp+xml', 'application/cnrp+xml'), ('application/coap-group+json', 'application/coap-group+json'), ('application/coap-payload', 'application/coap-payload'), ('application/commonground', 'application/commonground'), ('application/conference-info+xml', 'application/conference-info+xml'), ('application/cpl+xml', 'application/cpl+xml'), ('application/cose', 'application/cose'), ('application/cose-key', 'application/cose-key'), ('application/cose-key-set', 'application/cose-key-set'), ('application/csrattrs', 'application/csrattrs'), ('application/csta+xml', 'application/csta+xml'), ('application/CSTAdata+xml', 'application/CSTAdata+xml'), ('application/csvm+json', 'application/csvm+json'), ('application/cybercash', 'application/cybercash'), ('application/dash+xml', 'application/dash+xml'), ('application/dashdelta', 'application/dashdelta'), ('application/davmount+xml', 'application/davmount+xml'), ('application/dca-rft', 'application/dca-rft'), ('application/DCD', 'application/DCD'), ('application/dec-dx', 'application/dec-dx'), ('application/dialog-info+xml', 'application/dialog-info+xml'), ('application/dicom', 'application/dicom'), ('application/dicom+json', 'application/dicom+json'), ('application/dicom+xml', 'application/dicom+xml'), ('application/DII', 'application/DII'), ('application/DIT', 'application/DIT'), ('application/dns', 'application/dns'), ('application/dskpp+xml', 'application/dskpp+xml'), ('application/dssc+der', 'application/dssc+der'), ('application/dssc+xml', 'application/dssc+xml'), ('application/dvcs', 'application/dvcs'), ('application/ecmascript', 'application/ecmascript'), ('application/EDI-consent', 'application/EDI-consent'), ('application/EDIFACT', 'application/EDIFACT'), ('application/EDI-X12', 'application/EDI-X12'), ('application/efi', 'application/efi'), ('application/EmergencyCallData.Comment+xml', 'application/EmergencyCallData.Comment+xml'), ('application/EmergencyCallData.Control+xml', 'application/EmergencyCallData.Control+xml'), ('application/EmergencyCallData.DeviceInfo+xml', 'application/EmergencyCallData.DeviceInfo+xml'), ('application/EmergencyCallData.eCall.MSD', 'application/EmergencyCallData.eCall.MSD'), ('application/EmergencyCallData.ProviderInfo+xml', 'application/EmergencyCallData.ProviderInfo+xml'), ('application/EmergencyCallData.ServiceInfo+xml', 'application/EmergencyCallData.ServiceInfo+xml'), ('application/EmergencyCallData.SubscriberInfo+xml', 'application/EmergencyCallData.SubscriberInfo+xml'), ('application/EmergencyCallData.VEDS+xml', 'application/EmergencyCallData.VEDS+xml'), ('application/emma+xml', 'application/emma+xml'), ('application/emotionml+xml', 'application/emotionml+xml'), ('application/encaprtp', 'application/encaprtp'), ('application/epp+xml', 'application/epp+xml'), ('application/epub+zip', 'application/epub+zip'), ('application/eshop', 'application/eshop'), ('application/example', 'application/example'), ('application/exi', 'application/exi'), ('application/fastinfoset', 'application/fastinfoset'), ('application/fastsoap', 'application/fastsoap'), ('application/fdt+xml', 'application/fdt+xml'), ('application/fits', 'application/fits'), ('application/font-sfnt', 'application/font-sfnt'), ('application/font-tdpfr', 'application/font-tdpfr'), ('application/font-woff', 'application/font-woff'), ('application/framework-attributes+xml', 'application/framework-attributes+xml'), ('application/geo+json', 'application/geo+json'), ('application/geo+json-seq', 'application/geo+json-seq'), ('application/gml+xml', 'application/gml+xml'), ('application/gzip', 'application/gzip'), ('application/H224', 'application/H224'), ('application/held+xml', 'application/held+xml'), ('application/http', 'application/http'), ('application/hyperstudio', 'application/hyperstudio'), ('application/ibe-key-request+xml', 'application/ibe-key-request+xml'), ('application/ibe-pkg-reply+xml', 'application/ibe-pkg-reply+xml'), ('application/ibe-pp-data', 'application/ibe-pp-data'), ('application/iges', 'application/iges'), ('application/im-iscomposing+xml', 'application/im-iscomposing+xml'), ('application/index', 'application/index'), ('application/index.cmd', 'application/index.cmd'), ('application/index.obj', 'application/index.obj'), ('application/index.response', 'application/index.response'), ('application/index.vnd', 'application/index.vnd'), ('application/inkml+xml', 'application/inkml+xml'), ('application/iotp', 'application/iotp'), ('application/ipfix', 'application/ipfix'), ('application/ipp', 'application/ipp'), ('application/isup', 'application/isup'), ('application/its+xml', 'application/its+xml'), ('application/javascript', 'application/javascript'), ('application/jose', 'application/jose'), ('application/jose+json', 'application/jose+json'), ('application/jrd+json', 'application/jrd+json'), ('application/json', 'application/json'), ('application/json-patch+json', 'application/json-patch+json'), ('application/json-seq', 'application/json-seq'), ('application/jwk+json', 'application/jwk+json'), ('application/jwk-set+json', 'application/jwk-set+json'), ('application/jwt', 'application/jwt'), ('application/kpml-request+xml', 'application/kpml-request+xml'), ('application/kpml-response+xml', 'application/kpml-response+xml'), ('application/ld+json', 'application/ld+json'), ('application/lgr+xml', 'application/lgr+xml'), ('application/link-format', 'application/link-format'), ('application/load-control+xml', 'application/load-control+xml'), ('application/lost+xml', 'application/lost+xml'), ('application/lostsync+xml', 'application/lostsync+xml'), ('application/LXF', 'application/LXF'), ('application/mac-binhex40', 'application/mac-binhex40'), ('application/macwriteii', 'application/macwriteii'), ('application/mads+xml', 'application/mads+xml'), ('application/marc', 'application/marc'), ('application/marcxml+xml', 'application/marcxml+xml'), ('application/mathematica', 'application/mathematica'), ('application/mathml-content+xml', 'application/mathml-content+xml'), ('application/mathml-presentation+xml', 'application/mathml-presentation+xml'), ('application/mathml+xml', 'application/mathml+xml'), ('application/mbms-associated-procedure-description+xml', 'application/mbms-associated-procedure-description+xml'), ('application/mbms-deregister+xml', 'application/mbms-deregister+xml'), ('application/mbms-envelope+xml', 'application/mbms-envelope+xml'), ('application/mbms-msk-response+xml', 'application/mbms-msk-response+xml'), ('application/mbms-msk+xml', 'application/mbms-msk+xml'), ('application/mbms-protection-description+xml', 'application/mbms-protection-description+xml'), ('application/mbms-reception-report+xml', 'application/mbms-reception-report+xml'), ('application/mbms-register-response+xml', 'application/mbms-register-response+xml'), ('application/mbms-register+xml', 'application/mbms-register+xml'), ('application/mbms-schedule+xml', 'application/mbms-schedule+xml'), ('application/mbms-user-service-description+xml', 'application/mbms-user-service-description+xml'), ('application/mbox', 'application/mbox'), ('application/media_control+xml', 'application/media_control+xml'), ('application/media-policy-dataset+xml', 'application/media-policy-dataset+xml'), ('application/mediaservercontrol+xml', 'application/mediaservercontrol+xml'), ('application/merge-patch+json', 'application/merge-patch+json'), ('application/metalink4+xml', 'application/metalink4+xml'), ('application/mets+xml', 'application/mets+xml'), ('application/MF4', 'application/MF4'), ('application/mikey', 'application/mikey'), ('application/mods+xml', 'application/mods+xml'), ('application/moss-keys', 'application/moss-keys'), ('application/moss-signature', 'application/moss-signature'), ('application/mosskey-data', 'application/mosskey-data'), ('application/mosskey-request', 'application/mosskey-request'), ('application/mp21', 'application/mp21'), ('application/mp4', 'application/mp4'), ('application/mpeg4-generic', 'application/mpeg4-generic'), ('application/mpeg4-iod', 'application/mpeg4-iod'), ('application/mpeg4-iod-xmt', 'application/mpeg4-iod-xmt'), ('application/mrb-consumer+xml', 'application/mrb-consumer+xml'), ('application/mrb-publish+xml', 'application/mrb-publish+xml'), ('application/msc-ivr+xml', 'application/msc-ivr+xml'), ('application/msc-mixer+xml', 'application/msc-mixer+xml'), ('application/msword', 'application/msword'), ('application/mud+json', 'application/mud+json'), ('application/mxf', 'application/mxf'), ('application/n-quads', 'application/n-quads'), ('application/n-triples', 'application/n-triples'), ('application/nasdata', 'application/nasdata'), ('application/news-checkgroups', 'application/news-checkgroups'), ('application/news-groupinfo', 'application/news-groupinfo'), ('application/news-transmission', 'application/news-transmission'), ('application/nlsml+xml', 'application/nlsml+xml'), ('application/nss', 'application/nss'), ('application/ocsp-request', 'application/ocsp-request'), ('application/ocsp-response', 'application/ocsp-response'), ('application/octet-stream', 'application/octet-stream'), ('application/oda', 'application/oda'), ('application/ODX', 'application/ODX'), ('application/oebps-package+xml', 'application/oebps-package+xml'), ('application/ogg', 'application/ogg'), ('application/oxps', 'application/oxps'), ('application/p2p-overlay+xml', 'application/p2p-overlay+xml'), ('application/parityfec', 'application/parityfec'), ('application/patch-ops-error+xml', 'application/patch-ops-error+xml'), ('application/pdf', 'application/pdf'), ('application/PDX', 'application/PDX'), ('application/pgp-encrypted', 'application/pgp-encrypted'), ('application/pgp-keys', 'application/pgp-keys'), ('application/pgp-signature', 'application/pgp-signature'), ('application/pidf-diff+xml', 'application/pidf-diff+xml'), ('application/pidf+xml', 'application/pidf+xml'), ('application/pkcs10', 'application/pkcs10'), ('application/pkcs7-mime', 'application/pkcs7-mime'), ('application/pkcs7-signature', 'application/pkcs7-signature'), ('application/pkcs8', 'application/pkcs8'), ('application/pkcs12', 'application/pkcs12'), ('application/pkix-attr-cert', 'application/pkix-attr-cert'), ('application/pkix-cert', 'application/pkix-cert'), ('application/pkix-crl', 'application/pkix-crl'), ('application/pkix-pkipath', 'application/pkix-pkipath'), ('application/pkixcmp', 'application/pkixcmp'), ('application/pls+xml', 'application/pls+xml'), ('application/poc-settings+xml', 'application/poc-settings+xml'), ('application/postscript', 'application/postscript'), ('application/ppsp-tracker+json', 'application/ppsp-tracker+json'), ('application/problem+json', 'application/problem+json'), ('application/problem+xml', 'application/problem+xml'), ('application/provenance+xml', 'application/provenance+xml'), ('application/prs.alvestrand.titrax-sheet', 'application/prs.alvestrand.titrax-sheet'), ('application/prs.cww', 'application/prs.cww'), ('application/prs.hpub+zip', 'application/prs.hpub+zip'), ('application/prs.nprend', 'application/prs.nprend'), ('application/prs.plucker', 'application/prs.plucker'), ('application/prs.rdf-xml-crypt', 'application/prs.rdf-xml-crypt'), ('application/prs.xsf+xml', 'application/prs.xsf+xml'), ('application/pskc+xml', 'application/pskc+xml'), ('application/rdf+xml', 'application/rdf+xml'), ('application/qsig', 'application/qsig'), ('application/raptorfec', 'application/raptorfec'), ('application/rdap+json', 'application/rdap+json'), ('application/reginfo+xml', 'application/reginfo+xml'), ('application/relax-ng-compact-syntax', 'application/relax-ng-compact-syntax'), ('application/remote-printing', 'application/remote-printing'), ('application/reputon+json', 'application/reputon+json'), ('application/resource-lists-diff+xml', 'application/resource-lists-diff+xml'), ('application/resource-lists+xml', 'application/resource-lists+xml'), ('application/rfc+xml', 'application/rfc+xml'), ('application/riscos', 'application/riscos'), ('application/rlmi+xml', 'application/rlmi+xml'), ('application/rls-services+xml', 'application/rls-services+xml'), ('application/rpki-ghostbusters', 'application/rpki-ghostbusters'), ('application/rpki-manifest', 'application/rpki-manifest'), ('application/rpki-publication', 'application/rpki-publication'), ('application/rpki-roa', 'application/rpki-roa'), ('application/rpki-updown', 'application/rpki-updown'), ('application/rtf', 'application/rtf'), ('application/rtploopback', 'application/rtploopback'), ('application/rtx', 'application/rtx'), ('application/samlassertion+xml', 'application/samlassertion+xml'), ('application/samlmetadata+xml', 'application/samlmetadata+xml'), ('application/sbml+xml', 'application/sbml+xml'), ('application/scaip+xml', 'application/scaip+xml'), ('application/scim+json', 'application/scim+json'), ('application/scvp-cv-request', 'application/scvp-cv-request'), ('application/scvp-cv-response', 'application/scvp-cv-response'), ('application/scvp-vp-request', 'application/scvp-vp-request'), ('application/scvp-vp-response', 'application/scvp-vp-response'), ('application/sdp', 'application/sdp'), ('application/sep-exi', 'application/sep-exi'), ('application/sep+xml', 'application/sep+xml'), ('application/session-info', 'application/session-info'), ('application/set-payment', 'application/set-payment'), ('application/set-payment-initiation', 'application/set-payment-initiation'), ('application/set-registration', 'application/set-registration'), ('application/set-registration-initiation', 'application/set-registration-initiation'), ('application/sgml', 'application/sgml'), ('application/sgml-open-catalog', 'application/sgml-open-catalog'), ('application/shf+xml', 'application/shf+xml'), ('application/sieve', 'application/sieve'), ('application/simple-filter+xml', 'application/simple-filter+xml'), ('application/simple-message-summary', 'application/simple-message-summary'), ('application/simpleSymbolContainer', 'application/simpleSymbolContainer'), ('application/slate', 'application/slate'), ('application/smil', 'application/smil'), ('application/smil+xml', 'application/smil+xml'), ('application/smpte336m', 'application/smpte336m'), ('application/soap+fastinfoset', 'application/soap+fastinfoset'), ('application/soap+xml', 'application/soap+xml'), ('application/sparql-query', 'application/sparql-query'), ('application/sparql-results+xml', 'application/sparql-results+xml'), ('application/spirits-event+xml', 'application/spirits-event+xml'), ('application/sql', 'application/sql'), ('application/srgs', 'application/srgs'), ('application/srgs+xml', 'application/srgs+xml'), ('application/sru+xml', 'application/sru+xml'), ('application/ssml+xml', 'application/ssml+xml'), ('application/tamp-apex-update', 'application/tamp-apex-update'), ('application/tamp-apex-update-confirm', 'application/tamp-apex-update-confirm'), ('application/tamp-community-update', 'application/tamp-community-update'), ('application/tamp-community-update-confirm', 'application/tamp-community-update-confirm'), ('application/tamp-error', 'application/tamp-error'), ('application/tamp-sequence-adjust', 'application/tamp-sequence-adjust'), ('application/tamp-sequence-adjust-confirm', 'application/tamp-sequence-adjust-confirm'), ('application/tamp-status-query', 'application/tamp-status-query'), ('application/tamp-status-response', 'application/tamp-status-response'), ('application/tamp-update', 'application/tamp-update'), ('application/tamp-update-confirm', 'application/tamp-update-confirm'), ('application/tei+xml', 'application/tei+xml'), ('application/thraud+xml', 'application/thraud+xml'), ('application/timestamp-query', 'application/timestamp-query'), ('application/timestamp-reply', 'application/timestamp-reply'), ('application/timestamped-data', 'application/timestamped-data'), ('application/trig', 'application/trig'), ('application/ttml+xml', 'application/ttml+xml'), ('application/tve-trigger', 'application/tve-trigger'), ('application/ulpfec', 'application/ulpfec'), ('application/urc-grpsheet+xml', 'application/urc-grpsheet+xml'), ('application/urc-ressheet+xml', 'application/urc-ressheet+xml'), ('application/urc-targetdesc+xml', 'application/urc-targetdesc+xml'), ('application/urc-uisocketdesc+xml', 'application/urc-uisocketdesc+xml'), ('application/vcard+json', 'application/vcard+json'), ('application/vcard+xml', 'application/vcard+xml'), ('application/vemmi', 'application/vemmi'), ('application/vnd.1000minds.decision-model+xml', 'application/vnd.1000minds.decision-model+xml'), ('application/vnd.3gpp.access-transfer-events+xml', 'application/vnd.3gpp.access-transfer-events+xml'), ('application/vnd.3gpp.bsf+xml', 'application/vnd.3gpp.bsf+xml'), ('application/vnd.3gpp.mid-call+xml', 'application/vnd.3gpp.mid-call+xml'), ('application/vnd.3gpp.pic-bw-large', 'application/vnd.3gpp.pic-bw-large'), ('application/vnd.3gpp.pic-bw-small', 'application/vnd.3gpp.pic-bw-small'), ('application/vnd.3gpp.pic-bw-var', 'application/vnd.3gpp.pic-bw-var'), ('application/vnd.3gpp-prose-pc3ch+xml', 'application/vnd.3gpp-prose-pc3ch+xml'), ('application/vnd.3gpp-prose+xml', 'application/vnd.3gpp-prose+xml'), ('application/vnd.3gpp.sms', 'application/vnd.3gpp.sms'), ('application/vnd.3gpp.sms+xml', 'application/vnd.3gpp.sms+xml'), ('application/vnd.3gpp.srvcc-ext+xml', 'application/vnd.3gpp.srvcc-ext+xml'), ('application/vnd.3gpp.SRVCC-info+xml', 'application/vnd.3gpp.SRVCC-info+xml'), ('application/vnd.3gpp.state-and-event-info+xml', 'application/vnd.3gpp.state-and-event-info+xml'), ('application/vnd.3gpp.ussd+xml', 'application/vnd.3gpp.ussd+xml'), ('application/vnd.3gpp2.bcmcsinfo+xml', 'application/vnd.3gpp2.bcmcsinfo+xml'), ('application/vnd.3gpp2.sms', 'application/vnd.3gpp2.sms'), ('application/vnd.3gpp2.tcap', 'application/vnd.3gpp2.tcap'), ('application/vnd.3lightssoftware.imagescal', 'application/vnd.3lightssoftware.imagescal'), ('application/vnd.3M.Post-it-Notes', 'application/vnd.3M.Post-it-Notes'), ('application/vnd.accpac.simply.aso', 'application/vnd.accpac.simply.aso'), ('application/vnd.accpac.simply.imp', 'application/vnd.accpac.simply.imp'), ('application/vnd.acucobol', 'application/vnd.acucobol'), ('application/vnd.acucorp', 'application/vnd.acucorp'), ('application/vnd.adobe.flash.movie', 'application/vnd.adobe.flash.movie'), ('application/vnd.adobe.formscentral.fcdt', 'application/vnd.adobe.formscentral.fcdt'), ('application/vnd.adobe.fxp', 'application/vnd.adobe.fxp'), ('application/vnd.adobe.partial-upload', 'application/vnd.adobe.partial-upload'), ('application/vnd.adobe.xdp+xml', 'application/vnd.adobe.xdp+xml'), ('application/vnd.adobe.xfdf', 'application/vnd.adobe.xfdf'), ('application/vnd.aether.imp', 'application/vnd.aether.imp'), ('application/vnd.ah-barcode', 'application/vnd.ah-barcode'), ('application/vnd.ahead.space', 'application/vnd.ahead.space'), ('application/vnd.airzip.filesecure.azf', 'application/vnd.airzip.filesecure.azf'), ('application/vnd.airzip.filesecure.azs', 'application/vnd.airzip.filesecure.azs'), ('application/vnd.amazon.mobi8-ebook', 'application/vnd.amazon.mobi8-ebook'), ('application/vnd.americandynamics.acc', 'application/vnd.americandynamics.acc'), ('application/vnd.amiga.ami', 'application/vnd.amiga.ami'), ('application/vnd.amundsen.maze+xml', 'application/vnd.amundsen.maze+xml'), ('application/vnd.anki', 'application/vnd.anki'), ('application/vnd.anser-web-certificate-issue-initiation', 'application/vnd.anser-web-certificate-issue-initiation'), ('application/vnd.antix.game-component', 'application/vnd.antix.game-component'), ('application/vnd.apache.thrift.binary', 'application/vnd.apache.thrift.binary'), ('application/vnd.apache.thrift.compact', 'application/vnd.apache.thrift.compact'), ('application/vnd.apache.thrift.json', 'application/vnd.apache.thrift.json'), ('application/vnd.api+json', 'application/vnd.api+json'), ('application/vnd.apothekende.reservation+json', 'application/vnd.apothekende.reservation+json'), ('application/vnd.apple.mpegurl', 'application/vnd.apple.mpegurl'), ('application/vnd.apple.installer+xml', 'application/vnd.apple.installer+xml'), ('application/vnd.arastra.swi', 'application/vnd.arastra.swi'), ('application/vnd.aristanetworks.swi', 'application/vnd.aristanetworks.swi'), ('application/vnd.artsquare', 'application/vnd.artsquare'), ('application/vnd.astraea-software.iota', 'application/vnd.astraea-software.iota'), ('application/vnd.audiograph', 'application/vnd.audiograph'), ('application/vnd.autopackage', 'application/vnd.autopackage'), ('application/vnd.avistar+xml', 'application/vnd.avistar+xml'), ('application/vnd.balsamiq.bmml+xml', 'application/vnd.balsamiq.bmml+xml'), ('application/vnd.balsamiq.bmpr', 'application/vnd.balsamiq.bmpr'), ('application/vnd.bekitzur-stech+json', 'application/vnd.bekitzur-stech+json'), ('application/vnd.bint.med-content', 'application/vnd.bint.med-content'), ('application/vnd.biopax.rdf+xml', 'application/vnd.biopax.rdf+xml'), ('application/vnd.blueice.multipass', 'application/vnd.blueice.multipass'), ('application/vnd.bluetooth.ep.oob', 'application/vnd.bluetooth.ep.oob'), ('application/vnd.bluetooth.le.oob', 'application/vnd.bluetooth.le.oob'), ('application/vnd.bmi', 'application/vnd.bmi'), ('application/vnd.businessobjects', 'application/vnd.businessobjects'), ('application/vnd.cab-jscript', 'application/vnd.cab-jscript'), ('application/vnd.canon-cpdl', 'application/vnd.canon-cpdl'), ('application/vnd.canon-lips', 'application/vnd.canon-lips'), ('application/vnd.capasystems-pg+json', 'application/vnd.capasystems-pg+json'), ('application/vnd.cendio.thinlinc.clientconf', 'application/vnd.cendio.thinlinc.clientconf'), ('application/vnd.century-systems.tcp_stream', 'application/vnd.century-systems.tcp_stream'), ('application/vnd.chemdraw+xml', 'application/vnd.chemdraw+xml'), ('application/vnd.chess-pgn', 'application/vnd.chess-pgn'), ('application/vnd.chipnuts.karaoke-mmd', 'application/vnd.chipnuts.karaoke-mmd'), ('application/vnd.cinderella', 'application/vnd.cinderella'), ('application/vnd.cirpack.isdn-ext', 'application/vnd.cirpack.isdn-ext'), ('application/vnd.citationstyles.style+xml', 'application/vnd.citationstyles.style+xml'), ('application/vnd.claymore', 'application/vnd.claymore'), ('application/vnd.cloanto.rp9', 'application/vnd.cloanto.rp9'), ('application/vnd.clonk.c4group', 'application/vnd.clonk.c4group'), ('application/vnd.cluetrust.cartomobile-config', 'application/vnd.cluetrust.cartomobile-config'), ('application/vnd.cluetrust.cartomobile-config-pkg', 'application/vnd.cluetrust.cartomobile-config-pkg'), ('application/vnd.coffeescript', 'application/vnd.coffeescript'), ('application/vnd.collection.doc+json', 'application/vnd.collection.doc+json'), ('application/vnd.collection+json', 'application/vnd.collection+json'), ('application/vnd.collection.next+json', 'application/vnd.collection.next+json'), ('application/vnd.comicbook+zip', 'application/vnd.comicbook+zip'), ('application/vnd.commerce-battelle', 'application/vnd.commerce-battelle'), ('application/vnd.commonspace', 'application/vnd.commonspace'), ('application/vnd.coreos.ignition+json', 'application/vnd.coreos.ignition+json'), ('application/vnd.cosmocaller', 'application/vnd.cosmocaller'), ('application/vnd.contact.cmsg', 'application/vnd.contact.cmsg'), ('application/vnd.crick.clicker', 'application/vnd.crick.clicker'), ('application/vnd.crick.clicker.keyboard', 'application/vnd.crick.clicker.keyboard'), ('application/vnd.crick.clicker.palette', 'application/vnd.crick.clicker.palette'), ('application/vnd.crick.clicker.template', 'application/vnd.crick.clicker.template'), ('application/vnd.crick.clicker.wordbank', 'application/vnd.crick.clicker.wordbank'), ('application/vnd.criticaltools.wbs+xml', 'application/vnd.criticaltools.wbs+xml'), ('application/vnd.ctc-posml', 'application/vnd.ctc-posml'), ('application/vnd.ctct.ws+xml', 'application/vnd.ctct.ws+xml'), ('application/vnd.cups-pdf', 'application/vnd.cups-pdf'), ('application/vnd.cups-postscript', 'application/vnd.cups-postscript'), ('application/vnd.cups-ppd', 'application/vnd.cups-ppd'), ('application/vnd.cups-raster', 'application/vnd.cups-raster'), ('application/vnd.cups-raw', 'application/vnd.cups-raw'), ('application/vnd.curl', 'application/vnd.curl'), ('application/vnd.cyan.dean.root+xml', 'application/vnd.cyan.dean.root+xml'), ('application/vnd.cybank', 'application/vnd.cybank'), ('application/vnd.d2l.coursepackage1p0+zip', 'application/vnd.d2l.coursepackage1p0+zip'), ('application/vnd.dart', 'application/vnd.dart'), ('application/vnd.data-vision.rdz', 'application/vnd.data-vision.rdz'), ('application/vnd.datapackage+json', 'application/vnd.datapackage+json'), ('application/vnd.dataresource+json', 'application/vnd.dataresource+json'), ('application/vnd.debian.binary-package', 'application/vnd.debian.binary-package'), ('application/vnd.dece.data', 'application/vnd.dece.data'), ('application/vnd.dece.ttml+xml', 'application/vnd.dece.ttml+xml'), ('application/vnd.dece.unspecified', 'application/vnd.dece.unspecified'), ('application/vnd.dece.zip', 'application/vnd.dece.zip'), ('application/vnd.denovo.fcselayout-link', 'application/vnd.denovo.fcselayout-link'), ('application/vnd.desmume.movie', 'application/vnd.desmume.movie'), ('application/vnd.dir-bi.plate-dl-nosuffix', 'application/vnd.dir-bi.plate-dl-nosuffix'), ('application/vnd.dm.delegation+xml', 'application/vnd.dm.delegation+xml'), ('application/vnd.dna', 'application/vnd.dna'), ('application/vnd.document+json', 'application/vnd.document+json'), ('application/vnd.dolby.mobile.1', 'application/vnd.dolby.mobile.1'), ('application/vnd.dolby.mobile.2', 'application/vnd.dolby.mobile.2'), ('application/vnd.doremir.scorecloud-binary-document', 'application/vnd.doremir.scorecloud-binary-document'), ('application/vnd.dpgraph', 'application/vnd.dpgraph'), ('application/vnd.dreamfactory', 'application/vnd.dreamfactory'), ('application/vnd.drive+json', 'application/vnd.drive+json'), ('application/vnd.dtg.local', 'application/vnd.dtg.local'), ('application/vnd.dtg.local.flash', 'application/vnd.dtg.local.flash'), ('application/vnd.dtg.local.html', 'application/vnd.dtg.local.html'), ('application/vnd.dvb.ait', 'application/vnd.dvb.ait'), ('application/vnd.dvb.dvbj', 'application/vnd.dvb.dvbj'), ('application/vnd.dvb.esgcontainer', 'application/vnd.dvb.esgcontainer'), ('application/vnd.dvb.ipdcdftnotifaccess', 'application/vnd.dvb.ipdcdftnotifaccess'), ('application/vnd.dvb.ipdcesgaccess', 'application/vnd.dvb.ipdcesgaccess'), ('application/vnd.dvb.ipdcesgaccess2', 'application/vnd.dvb.ipdcesgaccess2'), ('application/vnd.dvb.ipdcesgpdd', 'application/vnd.dvb.ipdcesgpdd'), ('application/vnd.dvb.ipdcroaming', 'application/vnd.dvb.ipdcroaming'), ('application/vnd.dvb.iptv.alfec-base', 'application/vnd.dvb.iptv.alfec-base'), ('application/vnd.dvb.iptv.alfec-enhancement', 'application/vnd.dvb.iptv.alfec-enhancement'), ('application/vnd.dvb.notif-aggregate-root+xml', 'application/vnd.dvb.notif-aggregate-root+xml'), ('application/vnd.dvb.notif-container+xml', 'application/vnd.dvb.notif-container+xml'), ('application/vnd.dvb.notif-generic+xml', 'application/vnd.dvb.notif-generic+xml'), ('application/vnd.dvb.notif-ia-msglist+xml', 'application/vnd.dvb.notif-ia-msglist+xml'), ('application/vnd.dvb.notif-ia-registration-request+xml', 'application/vnd.dvb.notif-ia-registration-request+xml'), ('application/vnd.dvb.notif-ia-registration-response+xml', 'application/vnd.dvb.notif-ia-registration-response+xml'), ('application/vnd.dvb.notif-init+xml', 'application/vnd.dvb.notif-init+xml'), ('application/vnd.dvb.pfr', 'application/vnd.dvb.pfr'), ('application/vnd.dvb.service', 'application/vnd.dvb.service'), ('application/vnd.dxr', 'application/vnd.dxr'), ('application/vnd.dynageo', 'application/vnd.dynageo'), ('application/vnd.dzr', 'application/vnd.dzr'), ('application/vnd.easykaraoke.cdgdownload', 'application/vnd.easykaraoke.cdgdownload'), ('application/vnd.ecdis-update', 'application/vnd.ecdis-update'), ('application/vnd.ecowin.chart', 'application/vnd.ecowin.chart'), ('application/vnd.ecowin.filerequest', 'application/vnd.ecowin.filerequest'), ('application/vnd.ecowin.fileupdate', 'application/vnd.ecowin.fileupdate'), ('application/vnd.ecowin.series', 'application/vnd.ecowin.series'), ('application/vnd.ecowin.seriesrequest', 'application/vnd.ecowin.seriesrequest'), ('application/vnd.ecowin.seriesupdate', 'application/vnd.ecowin.seriesupdate'), ('application/vnd.efi.img', 'application/vnd.efi.img'), ('application/vnd.efi.iso', 'application/vnd.efi.iso'), ('application/vnd.emclient.accessrequest+xml', 'application/vnd.emclient.accessrequest+xml'), ('application/vnd.enliven', 'application/vnd.enliven'), ('application/vnd.enphase.envoy', 'application/vnd.enphase.envoy'), ('application/vnd.eprints.data+xml', 'application/vnd.eprints.data+xml'), ('application/vnd.epson.esf', 'application/vnd.epson.esf'), ('application/vnd.epson.msf', 'application/vnd.epson.msf'), ('application/vnd.epson.quickanime', 'application/vnd.epson.quickanime'), ('application/vnd.epson.salt', 'application/vnd.epson.salt'), ('application/vnd.epson.ssf', 'application/vnd.epson.ssf'), ('application/vnd.ericsson.quickcall', 'application/vnd.ericsson.quickcall'), ('application/vnd.espass-espass+zip', 'application/vnd.espass-espass+zip'), ('application/vnd.eszigno3+xml', 'application/vnd.eszigno3+xml'), ('application/vnd.etsi.aoc+xml', 'application/vnd.etsi.aoc+xml'), ('application/vnd.etsi.asic-s+zip', 'application/vnd.etsi.asic-s+zip'), ('application/vnd.etsi.asic-e+zip', 'application/vnd.etsi.asic-e+zip'), ('application/vnd.etsi.cug+xml', 'application/vnd.etsi.cug+xml'), ('application/vnd.etsi.iptvcommand+xml', 'application/vnd.etsi.iptvcommand+xml'), ('application/vnd.etsi.iptvdiscovery+xml', 'application/vnd.etsi.iptvdiscovery+xml'), ('application/vnd.etsi.iptvprofile+xml', 'application/vnd.etsi.iptvprofile+xml'), ('application/vnd.etsi.iptvsad-bc+xml', 'application/vnd.etsi.iptvsad-bc+xml'), ('application/vnd.etsi.iptvsad-cod+xml', 'application/vnd.etsi.iptvsad-cod+xml'), ('application/vnd.etsi.iptvsad-npvr+xml', 'application/vnd.etsi.iptvsad-npvr+xml'), ('application/vnd.etsi.iptvservice+xml', 'application/vnd.etsi.iptvservice+xml'), ('application/vnd.etsi.iptvsync+xml', 'application/vnd.etsi.iptvsync+xml'), ('application/vnd.etsi.iptvueprofile+xml', 'application/vnd.etsi.iptvueprofile+xml'), ('application/vnd.etsi.mcid+xml', 'application/vnd.etsi.mcid+xml'), ('application/vnd.etsi.mheg5', 'application/vnd.etsi.mheg5'), ('application/vnd.etsi.overload-control-policy-dataset+xml', 'application/vnd.etsi.overload-control-policy-dataset+xml'), ('application/vnd.etsi.pstn+xml', 'application/vnd.etsi.pstn+xml'), ('application/vnd.etsi.sci+xml', 'application/vnd.etsi.sci+xml'), ('application/vnd.etsi.simservs+xml', 'application/vnd.etsi.simservs+xml'), ('application/vnd.etsi.timestamp-token', 'application/vnd.etsi.timestamp-token'), ('application/vnd.etsi.tsl+xml', 'application/vnd.etsi.tsl+xml'), ('application/vnd.etsi.tsl.der', 'application/vnd.etsi.tsl.der'), ('application/vnd.evolv.ecig.theme', 'application/vnd.evolv.ecig.theme'), ('application/vnd.eudora.data', 'application/vnd.eudora.data'), ('application/vnd.ezpix-album', 'application/vnd.ezpix-album'), ('application/vnd.ezpix-package', 'application/vnd.ezpix-package'), ('application/vnd.f-secure.mobile', 'application/vnd.f-secure.mobile'), ('application/vnd.fastcopy-disk-image', 'application/vnd.fastcopy-disk-image'), ('application/vnd.fdf', 'application/vnd.fdf'), ('application/vnd.fdsn.mseed', 'application/vnd.fdsn.mseed'), ('application/vnd.fdsn.seed', 'application/vnd.fdsn.seed'), ('application/vnd.ffsns', 'application/vnd.ffsns'), ('application/vnd.filmit.zfc', 'application/vnd.filmit.zfc'), ('application/vnd.fints', 'application/vnd.fints'), ('application/vnd.firemonkeys.cloudcell', 'application/vnd.firemonkeys.cloudcell'), ('application/vnd.FloGraphIt', 'application/vnd.FloGraphIt'), ('application/vnd.fluxtime.clip', 'application/vnd.fluxtime.clip'), ('application/vnd.font-fontforge-sfd', 'application/vnd.font-fontforge-sfd'), ('application/vnd.framemaker', 'application/vnd.framemaker'), ('application/vnd.frogans.fnc', 'application/vnd.frogans.fnc'), ('application/vnd.frogans.ltf', 'application/vnd.frogans.ltf'), ('application/vnd.fsc.weblaunch', 'application/vnd.fsc.weblaunch'), ('application/vnd.fujitsu.oasys', 'application/vnd.fujitsu.oasys'), ('application/vnd.fujitsu.oasys2', 'application/vnd.fujitsu.oasys2'), ('application/vnd.fujitsu.oasys3', 'application/vnd.fujitsu.oasys3'), ('application/vnd.fujitsu.oasysgp', 'application/vnd.fujitsu.oasysgp'), ('application/vnd.fujitsu.oasysprs', 'application/vnd.fujitsu.oasysprs'), ('application/vnd.fujixerox.ART4', 'application/vnd.fujixerox.ART4'), ('application/vnd.fujixerox.ART-EX', 'application/vnd.fujixerox.ART-EX'), ('application/vnd.fujixerox.ddd', 'application/vnd.fujixerox.ddd'), ('application/vnd.fujixerox.docuworks', 'application/vnd.fujixerox.docuworks'), ('application/vnd.fujixerox.docuworks.binder', 'application/vnd.fujixerox.docuworks.binder'), ('application/vnd.fujixerox.docuworks.container', 'application/vnd.fujixerox.docuworks.container'), ('application/vnd.fujixerox.HBPL', 'application/vnd.fujixerox.HBPL'), ('application/vnd.fut-misnet', 'application/vnd.fut-misnet'), ('application/vnd.fuzzysheet', 'application/vnd.fuzzysheet'), ('application/vnd.genomatix.tuxedo', 'application/vnd.genomatix.tuxedo'), ('application/vnd.geo+json', 'application/vnd.geo+json'), ('application/vnd.geocube+xml', 'application/vnd.geocube+xml'), ('application/vnd.geogebra.file', 'application/vnd.geogebra.file'), ('application/vnd.geogebra.tool', 'application/vnd.geogebra.tool'), ('application/vnd.geometry-explorer', 'application/vnd.geometry-explorer'), ('application/vnd.geonext', 'application/vnd.geonext'), ('application/vnd.geoplan', 'application/vnd.geoplan'), ('application/vnd.geospace', 'application/vnd.geospace'), ('application/vnd.gerber', 'application/vnd.gerber'), ('application/vnd.globalplatform.card-content-mgt', 'application/vnd.globalplatform.card-content-mgt'), ('application/vnd.globalplatform.card-content-mgt-response', 'application/vnd.globalplatform.card-content-mgt-response'), ('application/vnd.gmx', 'application/vnd.gmx'), ('application/vnd.google-earth.kml+xml', 'application/vnd.google-earth.kml+xml'), ('application/vnd.google-earth.kmz', 'application/vnd.google-earth.kmz'), ('application/vnd.gov.sk.e-form+xml', 'application/vnd.gov.sk.e-form+xml'), ('application/vnd.gov.sk.e-form+zip', 'application/vnd.gov.sk.e-form+zip'), ('application/vnd.gov.sk.xmldatacontainer+xml', 'application/vnd.gov.sk.xmldatacontainer+xml'), ('application/vnd.grafeq', 'application/vnd.grafeq'), ('application/vnd.gridmp', 'application/vnd.gridmp'), ('application/vnd.groove-account', 'application/vnd.groove-account'), ('application/vnd.groove-help', 'application/vnd.groove-help'), ('application/vnd.groove-identity-message', 'application/vnd.groove-identity-message'), ('application/vnd.groove-injector', 'application/vnd.groove-injector'), ('application/vnd.groove-tool-message', 'application/vnd.groove-tool-message'), ('application/vnd.groove-tool-template', 'application/vnd.groove-tool-template'), ('application/vnd.groove-vcard', 'application/vnd.groove-vcard'), ('application/vnd.hal+json', 'application/vnd.hal+json'), ('application/vnd.hal+xml', 'application/vnd.hal+xml'), ('application/vnd.HandHeld-Entertainment+xml', 'application/vnd.HandHeld-Entertainment+xml'), ('application/vnd.hbci', 'application/vnd.hbci'), ('application/vnd.hc+json', 'application/vnd.hc+json'), ('application/vnd.hcl-bireports', 'application/vnd.hcl-bireports'), ('application/vnd.hdt', 'application/vnd.hdt'), ('application/vnd.heroku+json', 'application/vnd.heroku+json'), ('application/vnd.hhe.lesson-player', 'application/vnd.hhe.lesson-player'), ('application/vnd.hp-HPGL', 'application/vnd.hp-HPGL'), ('application/vnd.hp-hpid', 'application/vnd.hp-hpid'), ('application/vnd.hp-hps', 'application/vnd.hp-hps'), ('application/vnd.hp-jlyt', 'application/vnd.hp-jlyt'), ('application/vnd.hp-PCL', 'application/vnd.hp-PCL'), ('application/vnd.hp-PCLXL', 'application/vnd.hp-PCLXL'), ('application/vnd.httphone', 'application/vnd.httphone'), ('application/vnd.hydrostatix.sof-data', 'application/vnd.hydrostatix.sof-data'), ('application/vnd.hyper-item+json', 'application/vnd.hyper-item+json'), ('application/vnd.hyperdrive+json', 'application/vnd.hyperdrive+json'), ('application/vnd.hzn-3d-crossword', 'application/vnd.hzn-3d-crossword'), ('application/vnd.ibm.afplinedata', 'application/vnd.ibm.afplinedata'), ('application/vnd.ibm.electronic-media', 'application/vnd.ibm.electronic-media'), ('application/vnd.ibm.MiniPay', 'application/vnd.ibm.MiniPay'), ('application/vnd.ibm.modcap', 'application/vnd.ibm.modcap'), ('application/vnd.ibm.rights-management', 'application/vnd.ibm.rights-management'), ('application/vnd.ibm.secure-container', 'application/vnd.ibm.secure-container'), ('application/vnd.iccprofile', 'application/vnd.iccprofile'), ('application/vnd.ieee.1905', 'application/vnd.ieee.1905'), ('application/vnd.igloader', 'application/vnd.igloader'), ('application/vnd.imagemeter.folder+zip', 'application/vnd.imagemeter.folder+zip'), ('application/vnd.imagemeter.image+zip', 'application/vnd.imagemeter.image+zip'), ('application/vnd.immervision-ivp', 'application/vnd.immervision-ivp'), ('application/vnd.immervision-ivu', 'application/vnd.immervision-ivu'), ('application/vnd.ims.imsccv1p1', 'application/vnd.ims.imsccv1p1'), ('application/vnd.ims.imsccv1p2', 'application/vnd.ims.imsccv1p2'), ('application/vnd.ims.imsccv1p3', 'application/vnd.ims.imsccv1p3'), ('application/vnd.ims.lis.v2.result+json', 'application/vnd.ims.lis.v2.result+json'), ('application/vnd.ims.lti.v2.toolconsumerprofile+json', 'application/vnd.ims.lti.v2.toolconsumerprofile+json'), ('application/vnd.ims.lti.v2.toolproxy.id+json', 'application/vnd.ims.lti.v2.toolproxy.id+json'), ('application/vnd.ims.lti.v2.toolproxy+json', 'application/vnd.ims.lti.v2.toolproxy+json'), ('application/vnd.ims.lti.v2.toolsettings+json', 'application/vnd.ims.lti.v2.toolsettings+json'), ('application/vnd.ims.lti.v2.toolsettings.simple+json', 'application/vnd.ims.lti.v2.toolsettings.simple+json'), ('application/vnd.informedcontrol.rms+xml', 'application/vnd.informedcontrol.rms+xml'), ('application/vnd.infotech.project', 'application/vnd.infotech.project'), ('application/vnd.infotech.project+xml', 'application/vnd.infotech.project+xml'), ('application/vnd.informix-visionary', 'application/vnd.informix-visionary'), ('application/vnd.innopath.wamp.notification', 'application/vnd.innopath.wamp.notification'), ('application/vnd.insors.igm', 'application/vnd.insors.igm'), ('application/vnd.intercon.formnet', 'application/vnd.intercon.formnet'), ('application/vnd.intergeo', 'application/vnd.intergeo'), ('application/vnd.intertrust.digibox', 'application/vnd.intertrust.digibox'), ('application/vnd.intertrust.nncp', 'application/vnd.intertrust.nncp'), ('application/vnd.intu.qbo', 'application/vnd.intu.qbo'), ('application/vnd.intu.qfx', 'application/vnd.intu.qfx'), ('application/vnd.iptc.g2.catalogitem+xml', 'application/vnd.iptc.g2.catalogitem+xml'), ('application/vnd.iptc.g2.conceptitem+xml', 'application/vnd.iptc.g2.conceptitem+xml'), ('application/vnd.iptc.g2.knowledgeitem+xml', 'application/vnd.iptc.g2.knowledgeitem+xml'), ('application/vnd.iptc.g2.newsitem+xml', 'application/vnd.iptc.g2.newsitem+xml'), ('application/vnd.iptc.g2.newsmessage+xml', 'application/vnd.iptc.g2.newsmessage+xml'), ('application/vnd.iptc.g2.packageitem+xml', 'application/vnd.iptc.g2.packageitem+xml'), ('application/vnd.iptc.g2.planningitem+xml', 'application/vnd.iptc.g2.planningitem+xml'), ('application/vnd.ipunplugged.rcprofile', 'application/vnd.ipunplugged.rcprofile'), ('application/vnd.irepository.package+xml', 'application/vnd.irepository.package+xml'), ('application/vnd.is-xpr', 'application/vnd.is-xpr'), ('application/vnd.isac.fcs', 'application/vnd.isac.fcs'), ('application/vnd.jam', 'application/vnd.jam'), ('application/vnd.japannet-directory-service', 'application/vnd.japannet-directory-service'), ('application/vnd.japannet-jpnstore-wakeup', 'application/vnd.japannet-jpnstore-wakeup'), ('application/vnd.japannet-payment-wakeup', 'application/vnd.japannet-payment-wakeup'), ('application/vnd.japannet-registration', 'application/vnd.japannet-registration'), ('application/vnd.japannet-registration-wakeup', 'application/vnd.japannet-registration-wakeup'), ('application/vnd.japannet-setstore-wakeup', 'application/vnd.japannet-setstore-wakeup'), ('application/vnd.japannet-verification', 'application/vnd.japannet-verification'), ('application/vnd.japannet-verification-wakeup', 'application/vnd.japannet-verification-wakeup'), ('application/vnd.jcp.javame.midlet-rms', 'application/vnd.jcp.javame.midlet-rms'), ('application/vnd.jisp', 'application/vnd.jisp'), ('application/vnd.joost.joda-archive', 'application/vnd.joost.joda-archive'), ('application/vnd.jsk.isdn-ngn', 'application/vnd.jsk.isdn-ngn'), ('application/vnd.kahootz', 'application/vnd.kahootz'), ('application/vnd.kde.karbon', 'application/vnd.kde.karbon'), ('application/vnd.kde.kchart', 'application/vnd.kde.kchart'), ('application/vnd.kde.kformula', 'application/vnd.kde.kformula'), ('application/vnd.kde.kivio', 'application/vnd.kde.kivio'), ('application/vnd.kde.kontour', 'application/vnd.kde.kontour'), ('application/vnd.kde.kpresenter', 'application/vnd.kde.kpresenter'), ('application/vnd.kde.kspread', 'application/vnd.kde.kspread'), ('application/vnd.kde.kword', 'application/vnd.kde.kword'), ('application/vnd.kenameaapp', 'application/vnd.kenameaapp'), ('application/vnd.kidspiration', 'application/vnd.kidspiration'), ('application/vnd.Kinar', 'application/vnd.Kinar'), ('application/vnd.koan', 'application/vnd.koan'), ('application/vnd.kodak-descriptor', 'application/vnd.kodak-descriptor'), ('application/vnd.las.las+json', 'application/vnd.las.las+json'), ('application/vnd.las.las+xml', 'application/vnd.las.las+xml'), ('application/vnd.liberty-request+xml', 'application/vnd.liberty-request+xml'), ('application/vnd.llamagraphics.life-balance.desktop', 'application/vnd.llamagraphics.life-balance.desktop'), ('application/vnd.llamagraphics.life-balance.exchange+xml', 'application/vnd.llamagraphics.life-balance.exchange+xml'), ('application/vnd.lotus-1-2-3', 'application/vnd.lotus-1-2-3'), ('application/vnd.lotus-approach', 'application/vnd.lotus-approach'), ('application/vnd.lotus-freelance', 'application/vnd.lotus-freelance'), ('application/vnd.lotus-notes', 'application/vnd.lotus-notes'), ('application/vnd.lotus-organizer', 'application/vnd.lotus-organizer'), ('application/vnd.lotus-screencam', 'application/vnd.lotus-screencam'), ('application/vnd.lotus-wordpro', 'application/vnd.lotus-wordpro'), ('application/vnd.macports.portpkg', 'application/vnd.macports.portpkg'), ('application/vnd.macports.portpkg', 'application/vnd.macports.portpkg'), ('application/vnd.mapbox-vector-tile', 'application/vnd.mapbox-vector-tile'), ('application/vnd.marlin.drm.actiontoken+xml', 'application/vnd.marlin.drm.actiontoken+xml'), ('application/vnd.marlin.drm.conftoken+xml', 'application/vnd.marlin.drm.conftoken+xml'), ('application/vnd.marlin.drm.license+xml', 'application/vnd.marlin.drm.license+xml'), ('application/vnd.marlin.drm.mdcf', 'application/vnd.marlin.drm.mdcf'), ('application/vnd.mason+json', 'application/vnd.mason+json'), ('application/vnd.maxmind.maxmind-db', 'application/vnd.maxmind.maxmind-db'), ('application/vnd.mcd', 'application/vnd.mcd'), ('application/vnd.medcalcdata', 'application/vnd.medcalcdata'), ('application/vnd.mediastation.cdkey', 'application/vnd.mediastation.cdkey'), ('application/vnd.meridian-slingshot', 'application/vnd.meridian-slingshot'), ('application/vnd.MFER', 'application/vnd.MFER'), ('application/vnd.mfmp', 'application/vnd.mfmp'), ('application/vnd.micro+json', 'application/vnd.micro+json'), ('application/vnd.micrografx.flo', 'application/vnd.micrografx.flo'), ('application/vnd.micrografx.igx', 'application/vnd.micrografx.igx'), ('application/vnd.microsoft.portable-executable', 'application/vnd.microsoft.portable-executable'), ('application/vnd.microsoft.windows.thumbnail-cache', 'application/vnd.microsoft.windows.thumbnail-cache'), ('application/vnd.miele+json', 'application/vnd.miele+json'), ('application/vnd.mif', 'application/vnd.mif'), ('application/vnd.minisoft-hp3000-save', 'application/vnd.minisoft-hp3000-save'), ('application/vnd.mitsubishi.misty-guard.trustweb', 'application/vnd.mitsubishi.misty-guard.trustweb'), ('application/vnd.Mobius.DAF', 'application/vnd.Mobius.DAF'), ('application/vnd.Mobius.DIS', 'application/vnd.Mobius.DIS'), ('application/vnd.Mobius.MBK', 'application/vnd.Mobius.MBK'), ('application/vnd.Mobius.MQY', 'application/vnd.Mobius.MQY'), ('application/vnd.Mobius.MSL', 'application/vnd.Mobius.MSL'), ('application/vnd.Mobius.PLC', 'application/vnd.Mobius.PLC'), ('application/vnd.Mobius.TXF', 'application/vnd.Mobius.TXF'), ('application/vnd.mophun.application', 'application/vnd.mophun.application'), ('application/vnd.mophun.certificate', 'application/vnd.mophun.certificate'), ('application/vnd.motorola.flexsuite', 'application/vnd.motorola.flexsuite'), ('application/vnd.motorola.flexsuite.adsi', 'application/vnd.motorola.flexsuite.adsi'), ('application/vnd.motorola.flexsuite.fis', 'application/vnd.motorola.flexsuite.fis'), ('application/vnd.motorola.flexsuite.gotap', 'application/vnd.motorola.flexsuite.gotap'), ('application/vnd.motorola.flexsuite.kmr', 'application/vnd.motorola.flexsuite.kmr'), ('application/vnd.motorola.flexsuite.ttc', 'application/vnd.motorola.flexsuite.ttc'), ('application/vnd.motorola.flexsuite.wem', 'application/vnd.motorola.flexsuite.wem'), ('application/vnd.motorola.iprm', 'application/vnd.motorola.iprm'), ('application/vnd.mozilla.xul+xml', 'application/vnd.mozilla.xul+xml'), ('application/vnd.ms-artgalry', 'application/vnd.ms-artgalry'), ('application/vnd.ms-asf', 'application/vnd.ms-asf'), ('application/vnd.ms-cab-compressed', 'application/vnd.ms-cab-compressed'), ('application/vnd.ms-3mfdocument', 'application/vnd.ms-3mfdocument'), ('application/vnd.ms-excel', 'application/vnd.ms-excel'), ('application/vnd.ms-excel.addin.macroEnabled.12', 'application/vnd.ms-excel.addin.macroEnabled.12'), ('application/vnd.ms-excel.sheet.binary.macroEnabled.12', 'application/vnd.ms-excel.sheet.binary.macroEnabled.12'), ('application/vnd.ms-excel.sheet.macroEnabled.12', 'application/vnd.ms-excel.sheet.macroEnabled.12'), ('application/vnd.ms-excel.template.macroEnabled.12', 'application/vnd.ms-excel.template.macroEnabled.12'), ('application/vnd.ms-fontobject', 'application/vnd.ms-fontobject'), ('application/vnd.ms-htmlhelp', 'application/vnd.ms-htmlhelp'), ('application/vnd.ms-ims', 'application/vnd.ms-ims'), ('application/vnd.ms-lrm', 'application/vnd.ms-lrm'), ('application/vnd.ms-office.activeX+xml', 'application/vnd.ms-office.activeX+xml'), ('application/vnd.ms-officetheme', 'application/vnd.ms-officetheme'), ('application/vnd.ms-playready.initiator+xml', 'application/vnd.ms-playready.initiator+xml'), ('application/vnd.ms-powerpoint', 'application/vnd.ms-powerpoint'), ('application/vnd.ms-powerpoint.addin.macroEnabled.12', 'application/vnd.ms-powerpoint.addin.macroEnabled.12'), ('application/vnd.ms-powerpoint.presentation.macroEnabled.12', 'application/vnd.ms-powerpoint.presentation.macroEnabled.12'), ('application/vnd.ms-powerpoint.slide.macroEnabled.12', 'application/vnd.ms-powerpoint.slide.macroEnabled.12'), ('application/vnd.ms-powerpoint.slideshow.macroEnabled.12', 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12'), ('application/vnd.ms-powerpoint.template.macroEnabled.12', 'application/vnd.ms-powerpoint.template.macroEnabled.12'), ('application/vnd.ms-PrintDeviceCapabilities+xml', 'application/vnd.ms-PrintDeviceCapabilities+xml'), ('application/vnd.ms-PrintSchemaTicket+xml', 'application/vnd.ms-PrintSchemaTicket+xml'), ('application/vnd.ms-project', 'application/vnd.ms-project'), ('application/vnd.ms-tnef', 'application/vnd.ms-tnef'), ('application/vnd.ms-windows.devicepairing', 'application/vnd.ms-windows.devicepairing'), ('application/vnd.ms-windows.nwprinting.oob', 'application/vnd.ms-windows.nwprinting.oob'), ('application/vnd.ms-windows.printerpairing', 'application/vnd.ms-windows.printerpairing'), ('application/vnd.ms-windows.wsd.oob', 'application/vnd.ms-windows.wsd.oob'), ('application/vnd.ms-wmdrm.lic-chlg-req', 'application/vnd.ms-wmdrm.lic-chlg-req'), ('application/vnd.ms-wmdrm.lic-resp', 'application/vnd.ms-wmdrm.lic-resp'), ('application/vnd.ms-wmdrm.meter-chlg-req', 'application/vnd.ms-wmdrm.meter-chlg-req'), ('application/vnd.ms-wmdrm.meter-resp', 'application/vnd.ms-wmdrm.meter-resp'), ('application/vnd.ms-word.document.macroEnabled.12', 'application/vnd.ms-word.document.macroEnabled.12'), ('application/vnd.ms-word.template.macroEnabled.12', 'application/vnd.ms-word.template.macroEnabled.12'), ('application/vnd.ms-works', 'application/vnd.ms-works'), ('application/vnd.ms-wpl', 'application/vnd.ms-wpl'), ('application/vnd.ms-xpsdocument', 'application/vnd.ms-xpsdocument'), ('application/vnd.msa-disk-image', 'application/vnd.msa-disk-image'), ('application/vnd.mseq', 'application/vnd.mseq'), ('application/vnd.msign', 'application/vnd.msign'), ('application/vnd.multiad.creator', 'application/vnd.multiad.creator'), ('application/vnd.multiad.creator.cif', 'application/vnd.multiad.creator.cif'), ('application/vnd.musician', 'application/vnd.musician'), ('application/vnd.music-niff', 'application/vnd.music-niff'), ('application/vnd.muvee.style', 'application/vnd.muvee.style'), ('application/vnd.mynfc', 'application/vnd.mynfc'), ('application/vnd.ncd.control', 'application/vnd.ncd.control'), ('application/vnd.ncd.reference', 'application/vnd.ncd.reference'), ('application/vnd.nearst.inv+json', 'application/vnd.nearst.inv+json'), ('application/vnd.nervana', 'application/vnd.nervana'), ('application/vnd.netfpx', 'application/vnd.netfpx'), ('application/vnd.neurolanguage.nlu', 'application/vnd.neurolanguage.nlu'), ('application/vnd.nintendo.snes.rom', 'application/vnd.nintendo.snes.rom'), ('application/vnd.nintendo.nitro.rom', 'application/vnd.nintendo.nitro.rom'), ('application/vnd.nitf', 'application/vnd.nitf'), ('application/vnd.noblenet-directory', 'application/vnd.noblenet-directory'), ('application/vnd.noblenet-sealer', 'application/vnd.noblenet-sealer'), ('application/vnd.noblenet-web', 'application/vnd.noblenet-web'), ('application/vnd.nokia.catalogs', 'application/vnd.nokia.catalogs'), ('application/vnd.nokia.conml+wbxml', 'application/vnd.nokia.conml+wbxml'), ('application/vnd.nokia.conml+xml', 'application/vnd.nokia.conml+xml'), ('application/vnd.nokia.iptv.config+xml', 'application/vnd.nokia.iptv.config+xml'), ('application/vnd.nokia.iSDS-radio-presets', 'application/vnd.nokia.iSDS-radio-presets'), ('application/vnd.nokia.landmark+wbxml', 'application/vnd.nokia.landmark+wbxml'), ('application/vnd.nokia.landmark+xml', 'application/vnd.nokia.landmark+xml'), ('application/vnd.nokia.landmarkcollection+xml', 'application/vnd.nokia.landmarkcollection+xml'), ('application/vnd.nokia.ncd', 'application/vnd.nokia.ncd'), ('application/vnd.nokia.n-gage.ac+xml', 'application/vnd.nokia.n-gage.ac+xml'), ('application/vnd.nokia.n-gage.data', 'application/vnd.nokia.n-gage.data'), ('application/vnd.nokia.n-gage.symbian.install', 'application/vnd.nokia.n-gage.symbian.install'), ('application/vnd.nokia.pcd+wbxml', 'application/vnd.nokia.pcd+wbxml'), ('application/vnd.nokia.pcd+xml', 'application/vnd.nokia.pcd+xml'), ('application/vnd.nokia.radio-preset', 'application/vnd.nokia.radio-preset'), ('application/vnd.nokia.radio-presets', 'application/vnd.nokia.radio-presets'), ('application/vnd.novadigm.EDM', 'application/vnd.novadigm.EDM'), ('application/vnd.novadigm.EDX', 'application/vnd.novadigm.EDX'), ('application/vnd.novadigm.EXT', 'application/vnd.novadigm.EXT'), ('application/vnd.ntt-local.content-share', 'application/vnd.ntt-local.content-share'), ('application/vnd.ntt-local.file-transfer', 'application/vnd.ntt-local.file-transfer'), ('application/vnd.ntt-local.ogw_remote-access', 'application/vnd.ntt-local.ogw_remote-access'), ('application/vnd.ntt-local.sip-ta_remote', 'application/vnd.ntt-local.sip-ta_remote'), ('application/vnd.ntt-local.sip-ta_tcp_stream', 'application/vnd.ntt-local.sip-ta_tcp_stream'), ('application/vnd.oasis.opendocument.chart', 'application/vnd.oasis.opendocument.chart'), ('application/vnd.oasis.opendocument.chart-template', 'application/vnd.oasis.opendocument.chart-template'), ('application/vnd.oasis.opendocument.database', 'application/vnd.oasis.opendocument.database'), ('application/vnd.oasis.opendocument.formula', 'application/vnd.oasis.opendocument.formula'), ('application/vnd.oasis.opendocument.formula-template', 'application/vnd.oasis.opendocument.formula-template'), ('application/vnd.oasis.opendocument.graphics', 'application/vnd.oasis.opendocument.graphics'), ('application/vnd.oasis.opendocument.graphics-template', 'application/vnd.oasis.opendocument.graphics-template'), ('application/vnd.oasis.opendocument.image', 'application/vnd.oasis.opendocument.image'), ('application/vnd.oasis.opendocument.image-template', 'application/vnd.oasis.opendocument.image-template'), ('application/vnd.oasis.opendocument.presentation', 'application/vnd.oasis.opendocument.presentation'), ('application/vnd.oasis.opendocument.presentation-template', 'application/vnd.oasis.opendocument.presentation-template'), ('application/vnd.oasis.opendocument.spreadsheet', 'application/vnd.oasis.opendocument.spreadsheet'), ('application/vnd.oasis.opendocument.spreadsheet-template', 'application/vnd.oasis.opendocument.spreadsheet-template'), ('application/vnd.oasis.opendocument.text', 'application/vnd.oasis.opendocument.text'), ('application/vnd.oasis.opendocument.text-master', 'application/vnd.oasis.opendocument.text-master'), ('application/vnd.oasis.opendocument.text-template', 'application/vnd.oasis.opendocument.text-template'), ('application/vnd.oasis.opendocument.text-web', 'application/vnd.oasis.opendocument.text-web'), ('application/vnd.obn', 'application/vnd.obn'), ('application/vnd.ocf+cbor', 'application/vnd.ocf+cbor'), ('application/vnd.oftn.l10n+json', 'application/vnd.oftn.l10n+json'), ('application/vnd.oipf.contentaccessdownload+xml', 'application/vnd.oipf.contentaccessdownload+xml'), ('application/vnd.oipf.contentaccessstreaming+xml', 'application/vnd.oipf.contentaccessstreaming+xml'), ('application/vnd.oipf.cspg-hexbinary', 'application/vnd.oipf.cspg-hexbinary'), ('application/vnd.oipf.dae.svg+xml', 'application/vnd.oipf.dae.svg+xml'), ('application/vnd.oipf.dae.xhtml+xml', 'application/vnd.oipf.dae.xhtml+xml'), ('application/vnd.oipf.mippvcontrolmessage+xml', 'application/vnd.oipf.mippvcontrolmessage+xml'), ('application/vnd.oipf.pae.gem', 'application/vnd.oipf.pae.gem'), ('application/vnd.oipf.spdiscovery+xml', 'application/vnd.oipf.spdiscovery+xml'), ('application/vnd.oipf.spdlist+xml', 'application/vnd.oipf.spdlist+xml'), ('application/vnd.oipf.ueprofile+xml', 'application/vnd.oipf.ueprofile+xml'), ('application/vnd.oipf.userprofile+xml', 'application/vnd.oipf.userprofile+xml'), ('application/vnd.olpc-sugar', 'application/vnd.olpc-sugar'), ('application/vnd.oma.bcast.associated-procedure-parameter+xml', 'application/vnd.oma.bcast.associated-procedure-parameter+xml'), ('application/vnd.oma.bcast.drm-trigger+xml', 'application/vnd.oma.bcast.drm-trigger+xml'), ('application/vnd.oma.bcast.imd+xml', 'application/vnd.oma.bcast.imd+xml'), ('application/vnd.oma.bcast.ltkm', 'application/vnd.oma.bcast.ltkm'), ('application/vnd.oma.bcast.notification+xml', 'application/vnd.oma.bcast.notification+xml'), ('application/vnd.oma.bcast.provisioningtrigger', 'application/vnd.oma.bcast.provisioningtrigger'), ('application/vnd.oma.bcast.sgboot', 'application/vnd.oma.bcast.sgboot'), ('application/vnd.oma.bcast.sgdd+xml', 'application/vnd.oma.bcast.sgdd+xml'), ('application/vnd.oma.bcast.sgdu', 'application/vnd.oma.bcast.sgdu'), ('application/vnd.oma.bcast.simple-symbol-container', 'application/vnd.oma.bcast.simple-symbol-container'), ('application/vnd.oma.bcast.smartcard-trigger+xml', 'application/vnd.oma.bcast.smartcard-trigger+xml'), ('application/vnd.oma.bcast.sprov+xml', 'application/vnd.oma.bcast.sprov+xml'), ('application/vnd.oma.bcast.stkm', 'application/vnd.oma.bcast.stkm'), ('application/vnd.oma.cab-address-book+xml', 'application/vnd.oma.cab-address-book+xml'), ('application/vnd.oma.cab-feature-handler+xml', 'application/vnd.oma.cab-feature-handler+xml'), ('application/vnd.oma.cab-pcc+xml', 'application/vnd.oma.cab-pcc+xml'), ('application/vnd.oma.cab-subs-invite+xml', 'application/vnd.oma.cab-subs-invite+xml'), ('application/vnd.oma.cab-user-prefs+xml', 'application/vnd.oma.cab-user-prefs+xml'), ('application/vnd.oma.dcd', 'application/vnd.oma.dcd'), ('application/vnd.oma.dcdc', 'application/vnd.oma.dcdc'), ('application/vnd.oma.dd2+xml', 'application/vnd.oma.dd2+xml'), ('application/vnd.oma.drm.risd+xml', 'application/vnd.oma.drm.risd+xml'), ('application/vnd.oma.group-usage-list+xml', 'application/vnd.oma.group-usage-list+xml'), ('application/vnd.oma.lwm2m+json', 'application/vnd.oma.lwm2m+json'), ('application/vnd.oma.lwm2m+tlv', 'application/vnd.oma.lwm2m+tlv'), ('application/vnd.oma.pal+xml', 'application/vnd.oma.pal+xml'), ('application/vnd.oma.poc.detailed-progress-report+xml', 'application/vnd.oma.poc.detailed-progress-report+xml'), ('application/vnd.oma.poc.final-report+xml', 'application/vnd.oma.poc.final-report+xml'), ('application/vnd.oma.poc.groups+xml', 'application/vnd.oma.poc.groups+xml'), ('application/vnd.oma.poc.invocation-descriptor+xml', 'application/vnd.oma.poc.invocation-descriptor+xml'), ('application/vnd.oma.poc.optimized-progress-report+xml', 'application/vnd.oma.poc.optimized-progress-report+xml'), ('application/vnd.oma.push', 'application/vnd.oma.push'), ('application/vnd.oma.scidm.messages+xml', 'application/vnd.oma.scidm.messages+xml'), ('application/vnd.oma.xcap-directory+xml', 'application/vnd.oma.xcap-directory+xml'), ('application/vnd.omads-email+xml', 'application/vnd.omads-email+xml'), ('application/vnd.omads-file+xml', 'application/vnd.omads-file+xml'), ('application/vnd.omads-folder+xml', 'application/vnd.omads-folder+xml'), ('application/vnd.omaloc-supl-init', 'application/vnd.omaloc-supl-init'), ('application/vnd.oma-scws-config', 'application/vnd.oma-scws-config'), ('application/vnd.oma-scws-http-request', 'application/vnd.oma-scws-http-request'), ('application/vnd.oma-scws-http-response', 'application/vnd.oma-scws-http-response'), ('application/vnd.onepager', 'application/vnd.onepager'), ('application/vnd.onepagertamp', 'application/vnd.onepagertamp'), ('application/vnd.onepagertamx', 'application/vnd.onepagertamx'), ('application/vnd.onepagertat', 'application/vnd.onepagertat'), ('application/vnd.onepagertatp', 'application/vnd.onepagertatp'), ('application/vnd.onepagertatx', 'application/vnd.onepagertatx'), ('application/vnd.openblox.game-binary', 'application/vnd.openblox.game-binary'), ('application/vnd.openblox.game+xml', 'application/vnd.openblox.game+xml'), ('application/vnd.openeye.oeb', 'application/vnd.openeye.oeb'), ('application/vnd.openstreetmap.data+xml', 'application/vnd.openstreetmap.data+xml'), ('application/vnd.openxmlformats-officedocument.custom-properties+xml', 'application/vnd.openxmlformats-officedocument.custom-properties+xml'), ('application/vnd.openxmlformats-officedocument.customXmlProperties+xml', 'application/vnd.openxmlformats-officedocument.customXmlProperties+xml'), ('application/vnd.openxmlformats-officedocument.drawing+xml', 'application/vnd.openxmlformats-officedocument.drawing+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chart+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chart+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml'), ('application/vnd.openxmlformats-officedocument.extended-properties+xml', 'application/vnd.openxmlformats-officedocument.extended-properties+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml', 'application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.comments+xml', 'application/vnd.openxmlformats-officedocument.presentationml.comments+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation', 'application/vnd.openxmlformats-officedocument.presentationml.presentation'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presProps+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slide', 'application/vnd.openxmlformats-officedocument.presentationml.slide'), ('application/vnd.openxmlformats-officedocument.presentationml.slide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tags+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tags+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.template', 'application/vnd.openxmlformats-officedocument.presentationml.template'), ('application/vnd.openxmlformats-officedocument.presentationml.template.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml'), ('application/vnd.openxmlformats-officedocument.theme+xml', 'application/vnd.openxmlformats-officedocument.theme+xml'), ('application/vnd.openxmlformats-officedocument.themeOverride+xml', 'application/vnd.openxmlformats-officedocument.themeOverride+xml'), ('application/vnd.openxmlformats-officedocument.vmlDrawing', 'application/vnd.openxmlformats-officedocument.vmlDrawing'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml'), ('application/vnd.openxmlformats-package.core-properties+xml', 'application/vnd.openxmlformats-package.core-properties+xml'), ('application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml', 'application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml'), ('application/vnd.openxmlformats-package.relationships+xml', 'application/vnd.openxmlformats-package.relationships+xml'), ('application/vnd.oracle.resource+json', 'application/vnd.oracle.resource+json'), ('application/vnd.orange.indata', 'application/vnd.orange.indata'), ('application/vnd.osa.netdeploy', 'application/vnd.osa.netdeploy'), ('application/vnd.osgeo.mapguide.package', 'application/vnd.osgeo.mapguide.package'), ('application/vnd.osgi.bundle', 'application/vnd.osgi.bundle'), ('application/vnd.osgi.dp', 'application/vnd.osgi.dp'), ('application/vnd.osgi.subsystem', 'application/vnd.osgi.subsystem'), ('application/vnd.otps.ct-kip+xml', 'application/vnd.otps.ct-kip+xml'), ('application/vnd.oxli.countgraph', 'application/vnd.oxli.countgraph'), ('application/vnd.pagerduty+json', 'application/vnd.pagerduty+json'), ('application/vnd.palm', 'application/vnd.palm'), ('application/vnd.panoply', 'application/vnd.panoply'), ('application/vnd.paos.xml', 'application/vnd.paos.xml'), ('application/vnd.pawaafile', 'application/vnd.pawaafile'), ('application/vnd.pcos', 'application/vnd.pcos'), ('application/vnd.pg.format', 'application/vnd.pg.format'), ('application/vnd.pg.osasli', 'application/vnd.pg.osasli'), ('application/vnd.piaccess.application-licence', 'application/vnd.piaccess.application-licence'), ('application/vnd.picsel', 'application/vnd.picsel'), ('application/vnd.pmi.widget', 'application/vnd.pmi.widget'), ('application/vnd.poc.group-advertisement+xml', 'application/vnd.poc.group-advertisement+xml'), ('application/vnd.pocketlearn', 'application/vnd.pocketlearn'), ('application/vnd.powerbuilder6', 'application/vnd.powerbuilder6'), ('application/vnd.powerbuilder6-s', 'application/vnd.powerbuilder6-s'), ('application/vnd.powerbuilder7', 'application/vnd.powerbuilder7'), ('application/vnd.powerbuilder75', 'application/vnd.powerbuilder75'), ('application/vnd.powerbuilder75-s', 'application/vnd.powerbuilder75-s'), ('application/vnd.powerbuilder7-s', 'application/vnd.powerbuilder7-s'), ('application/vnd.preminet', 'application/vnd.preminet'), ('application/vnd.previewsystems.box', 'application/vnd.previewsystems.box'), ('application/vnd.proteus.magazine', 'application/vnd.proteus.magazine'), ('application/vnd.publishare-delta-tree', 'application/vnd.publishare-delta-tree'), ('application/vnd.pvi.ptid1', 'application/vnd.pvi.ptid1'), ('application/vnd.pwg-multiplexed', 'application/vnd.pwg-multiplexed'), ('application/vnd.pwg-xhtml-print+xml', 'application/vnd.pwg-xhtml-print+xml'), ('application/vnd.qualcomm.brew-app-res', 'application/vnd.qualcomm.brew-app-res'), ('application/vnd.quarantainenet', 'application/vnd.quarantainenet'), ('application/vnd.Quark.QuarkXPress', 'application/vnd.Quark.QuarkXPress'), ('application/vnd.quobject-quoxdocument', 'application/vnd.quobject-quoxdocument'), ('application/vnd.radisys.moml+xml', 'application/vnd.radisys.moml+xml'), ('application/vnd.radisys.msml-audit-conf+xml', 'application/vnd.radisys.msml-audit-conf+xml'), ('application/vnd.radisys.msml-audit-conn+xml', 'application/vnd.radisys.msml-audit-conn+xml'), ('application/vnd.radisys.msml-audit-dialog+xml', 'application/vnd.radisys.msml-audit-dialog+xml'), ('application/vnd.radisys.msml-audit-stream+xml', 'application/vnd.radisys.msml-audit-stream+xml'), ('application/vnd.radisys.msml-audit+xml', 'application/vnd.radisys.msml-audit+xml'), ('application/vnd.radisys.msml-conf+xml', 'application/vnd.radisys.msml-conf+xml'), ('application/vnd.radisys.msml-dialog-base+xml', 'application/vnd.radisys.msml-dialog-base+xml'), ('application/vnd.radisys.msml-dialog-fax-detect+xml', 'application/vnd.radisys.msml-dialog-fax-detect+xml'), ('application/vnd.radisys.msml-dialog-fax-sendrecv+xml', 'application/vnd.radisys.msml-dialog-fax-sendrecv+xml'), ('application/vnd.radisys.msml-dialog-group+xml', 'application/vnd.radisys.msml-dialog-group+xml'), ('application/vnd.radisys.msml-dialog-speech+xml', 'application/vnd.radisys.msml-dialog-speech+xml'), ('application/vnd.radisys.msml-dialog-transform+xml', 'application/vnd.radisys.msml-dialog-transform+xml'), ('application/vnd.radisys.msml-dialog+xml', 'application/vnd.radisys.msml-dialog+xml'), ('application/vnd.radisys.msml+xml', 'application/vnd.radisys.msml+xml'), ('application/vnd.rainstor.data', 'application/vnd.rainstor.data'), ('application/vnd.rapid', 'application/vnd.rapid'), ('application/vnd.rar', 'application/vnd.rar'), ('application/vnd.realvnc.bed', 'application/vnd.realvnc.bed'), ('application/vnd.recordare.musicxml', 'application/vnd.recordare.musicxml'), ('application/vnd.recordare.musicxml+xml', 'application/vnd.recordare.musicxml+xml'), ('application/vnd.RenLearn.rlprint', 'application/vnd.RenLearn.rlprint'), ('application/vnd.rig.cryptonote', 'application/vnd.rig.cryptonote'), ('application/vnd.route66.link66+xml', 'application/vnd.route66.link66+xml'), ('application/vnd.rs-274x', 'application/vnd.rs-274x'), ('application/vnd.ruckus.download', 'application/vnd.ruckus.download'), ('application/vnd.s3sms', 'application/vnd.s3sms'), ('application/vnd.sailingtracker.track', 'application/vnd.sailingtracker.track'), ('application/vnd.sbm.cid', 'application/vnd.sbm.cid'), ('application/vnd.sbm.mid2', 'application/vnd.sbm.mid2'), ('application/vnd.scribus', 'application/vnd.scribus'), ('application/vnd.sealed.3df', 'application/vnd.sealed.3df'), ('application/vnd.sealed.csf', 'application/vnd.sealed.csf'), ('application/vnd.sealed.doc', 'application/vnd.sealed.doc'), ('application/vnd.sealed.eml', 'application/vnd.sealed.eml'), ('application/vnd.sealed.mht', 'application/vnd.sealed.mht'), ('application/vnd.sealed.net', 'application/vnd.sealed.net'), ('application/vnd.sealed.ppt', 'application/vnd.sealed.ppt'), ('application/vnd.sealed.tiff', 'application/vnd.sealed.tiff'), ('application/vnd.sealed.xls', 'application/vnd.sealed.xls'), ('application/vnd.sealedmedia.softseal.html', 'application/vnd.sealedmedia.softseal.html'), ('application/vnd.sealedmedia.softseal.pdf', 'application/vnd.sealedmedia.softseal.pdf'), ('application/vnd.seemail', 'application/vnd.seemail'), ('application/vnd.sema', 'application/vnd.sema'), ('application/vnd.semd', 'application/vnd.semd'), ('application/vnd.semf', 'application/vnd.semf'), ('application/vnd.shana.informed.formdata', 'application/vnd.shana.informed.formdata'), ('application/vnd.shana.informed.formtemplate', 'application/vnd.shana.informed.formtemplate'), ('application/vnd.shana.informed.interchange', 'application/vnd.shana.informed.interchange'), ('application/vnd.shana.informed.package', 'application/vnd.shana.informed.package'), ('application/vnd.sigrok.session', 'application/vnd.sigrok.session'), ('application/vnd.SimTech-MindMapper', 'application/vnd.SimTech-MindMapper'), ('application/vnd.siren+json', 'application/vnd.siren+json'), ('application/vnd.smaf', 'application/vnd.smaf'), ('application/vnd.smart.notebook', 'application/vnd.smart.notebook'), ('application/vnd.smart.teacher', 'application/vnd.smart.teacher'), ('application/vnd.software602.filler.form+xml', 'application/vnd.software602.filler.form+xml'), ('application/vnd.software602.filler.form-xml-zip', 'application/vnd.software602.filler.form-xml-zip'), ('application/vnd.solent.sdkm+xml', 'application/vnd.solent.sdkm+xml'), ('application/vnd.spotfire.dxp', 'application/vnd.spotfire.dxp'), ('application/vnd.spotfire.sfs', 'application/vnd.spotfire.sfs'), ('application/vnd.sss-cod', 'application/vnd.sss-cod'), ('application/vnd.sss-dtf', 'application/vnd.sss-dtf'), ('application/vnd.sss-ntf', 'application/vnd.sss-ntf'), ('application/vnd.stepmania.package', 'application/vnd.stepmania.package'), ('application/vnd.stepmania.stepchart', 'application/vnd.stepmania.stepchart'), ('application/vnd.street-stream', 'application/vnd.street-stream'), ('application/vnd.sun.wadl+xml', 'application/vnd.sun.wadl+xml'), ('application/vnd.sus-calendar', 'application/vnd.sus-calendar'), ('application/vnd.svd', 'application/vnd.svd'), ('application/vnd.swiftview-ics', 'application/vnd.swiftview-ics'), ('application/vnd.syncml.dm.notification', 'application/vnd.syncml.dm.notification'), ('application/vnd.syncml.dmddf+xml', 'application/vnd.syncml.dmddf+xml'), ('application/vnd.syncml.dmtnds+wbxml', 'application/vnd.syncml.dmtnds+wbxml'), ('application/vnd.syncml.dmtnds+xml', 'application/vnd.syncml.dmtnds+xml'), ('application/vnd.syncml.dmddf+wbxml', 'application/vnd.syncml.dmddf+wbxml'), ('application/vnd.syncml.dm+wbxml', 'application/vnd.syncml.dm+wbxml'), ('application/vnd.syncml.dm+xml', 'application/vnd.syncml.dm+xml'), ('application/vnd.syncml.ds.notification', 'application/vnd.syncml.ds.notification'), ('application/vnd.syncml+xml', 'application/vnd.syncml+xml'), ('application/vnd.tableschema+json', 'application/vnd.tableschema+json'), ('application/vnd.tao.intent-module-archive', 'application/vnd.tao.intent-module-archive'), ('application/vnd.tcpdump.pcap', 'application/vnd.tcpdump.pcap'), ('application/vnd.tml', 'application/vnd.tml'), ('application/vnd.tmd.mediaflex.api+xml', 'application/vnd.tmd.mediaflex.api+xml'), ('application/vnd.tmobile-livetv', 'application/vnd.tmobile-livetv'), ('application/vnd.tri.onesource', 'application/vnd.tri.onesource'), ('application/vnd.trid.tpt', 'application/vnd.trid.tpt'), ('application/vnd.triscape.mxs', 'application/vnd.triscape.mxs'), ('application/vnd.trueapp', 'application/vnd.trueapp'), ('application/vnd.truedoc', 'application/vnd.truedoc'), ('application/vnd.ubisoft.webplayer', 'application/vnd.ubisoft.webplayer'), ('application/vnd.ufdl', 'application/vnd.ufdl'), ('application/vnd.uiq.theme', 'application/vnd.uiq.theme'), ('application/vnd.umajin', 'application/vnd.umajin'), ('application/vnd.unity', 'application/vnd.unity'), ('application/vnd.uoml+xml', 'application/vnd.uoml+xml'), ('application/vnd.uplanet.alert', 'application/vnd.uplanet.alert'), ('application/vnd.uplanet.alert-wbxml', 'application/vnd.uplanet.alert-wbxml'), ('application/vnd.uplanet.bearer-choice', 'application/vnd.uplanet.bearer-choice'), ('application/vnd.uplanet.bearer-choice-wbxml', 'application/vnd.uplanet.bearer-choice-wbxml'), ('application/vnd.uplanet.cacheop', 'application/vnd.uplanet.cacheop'), ('application/vnd.uplanet.cacheop-wbxml', 'application/vnd.uplanet.cacheop-wbxml'), ('application/vnd.uplanet.channel', 'application/vnd.uplanet.channel'), ('application/vnd.uplanet.channel-wbxml', 'application/vnd.uplanet.channel-wbxml'), ('application/vnd.uplanet.list', 'application/vnd.uplanet.list'), ('application/vnd.uplanet.listcmd', 'application/vnd.uplanet.listcmd'), ('application/vnd.uplanet.listcmd-wbxml', 'application/vnd.uplanet.listcmd-wbxml'), ('application/vnd.uplanet.list-wbxml', 'application/vnd.uplanet.list-wbxml'), ('application/vnd.uri-map', 'application/vnd.uri-map'), ('application/vnd.uplanet.signal', 'application/vnd.uplanet.signal'), ('application/vnd.valve.source.material', 'application/vnd.valve.source.material'), ('application/vnd.vcx', 'application/vnd.vcx'), ('application/vnd.vd-study', 'application/vnd.vd-study'), ('application/vnd.vectorworks', 'application/vnd.vectorworks'), ('application/vnd.vel+json', 'application/vnd.vel+json'), ('application/vnd.verimatrix.vcas', 'application/vnd.verimatrix.vcas'), ('application/vnd.vidsoft.vidconference', 'application/vnd.vidsoft.vidconference'), ('application/vnd.visio', 'application/vnd.visio'), ('application/vnd.visionary', 'application/vnd.visionary'), ('application/vnd.vividence.scriptfile', 'application/vnd.vividence.scriptfile'), ('application/vnd.vsf', 'application/vnd.vsf'), ('application/vnd.wap.sic', 'application/vnd.wap.sic'), ('application/vnd.wap.slc', 'application/vnd.wap.slc'), ('application/vnd.wap.wbxml', 'application/vnd.wap.wbxml'), ('application/vnd.wap.wmlc', 'application/vnd.wap.wmlc'), ('application/vnd.wap.wmlscriptc', 'application/vnd.wap.wmlscriptc'), ('application/vnd.webturbo', 'application/vnd.webturbo'), ('application/vnd.wfa.p2p', 'application/vnd.wfa.p2p'), ('application/vnd.wfa.wsc', 'application/vnd.wfa.wsc'), ('application/vnd.windows.devicepairing', 'application/vnd.windows.devicepairing'), ('application/vnd.wmc', 'application/vnd.wmc'), ('application/vnd.wmf.bootstrap', 'application/vnd.wmf.bootstrap'), ('application/vnd.wolfram.mathematica', 'application/vnd.wolfram.mathematica'), ('application/vnd.wolfram.mathematica.package', 'application/vnd.wolfram.mathematica.package'), ('application/vnd.wolfram.player', 'application/vnd.wolfram.player'), ('application/vnd.wordperfect', 'application/vnd.wordperfect'), ('application/vnd.wqd', 'application/vnd.wqd'), ('application/vnd.wrq-hp3000-labelled', 'application/vnd.wrq-hp3000-labelled'), ('application/vnd.wt.stf', 'application/vnd.wt.stf'), ('application/vnd.wv.csp+xml', 'application/vnd.wv.csp+xml'), ('application/vnd.wv.csp+wbxml', 'application/vnd.wv.csp+wbxml'), ('application/vnd.wv.ssp+xml', 'application/vnd.wv.ssp+xml'), ('application/vnd.xacml+json', 'application/vnd.xacml+json'), ('application/vnd.xara', 'application/vnd.xara'), ('application/vnd.xfdl', 'application/vnd.xfdl'), ('application/vnd.xfdl.webform', 'application/vnd.xfdl.webform'), ('application/vnd.xmi+xml', 'application/vnd.xmi+xml'), ('application/vnd.xmpie.cpkg', 'application/vnd.xmpie.cpkg'), ('application/vnd.xmpie.dpkg', 'application/vnd.xmpie.dpkg'), ('application/vnd.xmpie.plan', 'application/vnd.xmpie.plan'), ('application/vnd.xmpie.ppkg', 'application/vnd.xmpie.ppkg'), ('application/vnd.xmpie.xlim', 'application/vnd.xmpie.xlim'), ('application/vnd.yamaha.hv-dic', 'application/vnd.yamaha.hv-dic'), ('application/vnd.yamaha.hv-script', 'application/vnd.yamaha.hv-script'), ('application/vnd.yamaha.hv-voice', 'application/vnd.yamaha.hv-voice'), ('application/vnd.yamaha.openscoreformat.osfpvg+xml', 'application/vnd.yamaha.openscoreformat.osfpvg+xml'), ('application/vnd.yamaha.openscoreformat', 'application/vnd.yamaha.openscoreformat'), ('application/vnd.yamaha.remote-setup', 'application/vnd.yamaha.remote-setup'), ('application/vnd.yamaha.smaf-audio', 'application/vnd.yamaha.smaf-audio'), ('application/vnd.yamaha.smaf-phrase', 'application/vnd.yamaha.smaf-phrase'), ('application/vnd.yamaha.through-ngn', 'application/vnd.yamaha.through-ngn'), ('application/vnd.yamaha.tunnel-udpencap', 'application/vnd.yamaha.tunnel-udpencap'), ('application/vnd.yaoweme', 'application/vnd.yaoweme'), ('application/vnd.yellowriver-custom-menu', 'application/vnd.yellowriver-custom-menu'), ('application/vnd.zul', 'application/vnd.zul'), ('application/vnd.zzazz.deck+xml', 'application/vnd.zzazz.deck+xml'), ('application/voicexml+xml', 'application/voicexml+xml'), ('application/vq-rtcpxr', 'application/vq-rtcpxr'), ('application/watcherinfo+xml', 'application/watcherinfo+xml'), ('application/whoispp-query', 'application/whoispp-query'), ('application/whoispp-response', 'application/whoispp-response'), ('application/widget', 'application/widget'), ('application/wita', 'application/wita'), ('application/wordperfect5.1', 'application/wordperfect5.1'), ('application/wsdl+xml', 'application/wsdl+xml'), ('application/wspolicy+xml', 'application/wspolicy+xml'), ('application/x-www-form-urlencoded', 'application/x-www-form-urlencoded'), ('application/x400-bp', 'application/x400-bp'), ('application/xacml+xml', 'application/xacml+xml'), ('application/xcap-att+xml', 'application/xcap-att+xml'), ('application/xcap-caps+xml', 'application/xcap-caps+xml'), ('application/xcap-diff+xml', 'application/xcap-diff+xml'), ('application/xcap-el+xml', 'application/xcap-el+xml'), ('application/xcap-error+xml', 'application/xcap-error+xml'), ('application/xcap-ns+xml', 'application/xcap-ns+xml'), ('application/xcon-conference-info-diff+xml', 'application/xcon-conference-info-diff+xml'), ('application/xcon-conference-info+xml', 'application/xcon-conference-info+xml'), ('application/xenc+xml', 'application/xenc+xml'), ('application/xhtml-voice+xml', 'application/xhtml-voice+xml'), ('application/xhtml+xml', 'application/xhtml+xml'), ('application/xml', 'application/xml'), ('application/xml-dtd', 'application/xml-dtd'), ('application/xml-external-parsed-entity', 'application/xml-external-parsed-entity'), ('application/xml-patch+xml', 'application/xml-patch+xml'), ('application/xmpp+xml', 'application/xmpp+xml'), ('application/xop+xml', 'application/xop+xml'), ('application/xslt+xml', 'application/xslt+xml'), ('application/xv+xml', 'application/xv+xml'), ('application/yang', 'application/yang'), ('application/yang-data+json', 'application/yang-data+json'), ('application/yang-data+xml', 'application/yang-data+xml'), ('application/yang-patch+json', 'application/yang-patch+json'), ('application/yang-patch+xml', 'application/yang-patch+xml'), ('application/yin+xml', 'application/yin+xml'), ('application/zip', 'application/zip'), ('application/zlib', 'application/zlib'), ('audio/1d-interleaved-parityfec', 'audio/1d-interleaved-parityfec'), ('audio/32kadpcm', 'audio/32kadpcm'), ('audio/3gpp', 'audio/3gpp'), ('audio/3gpp2', 'audio/3gpp2'), ('audio/ac3', 'audio/ac3'), ('audio/AMR', 'audio/AMR'), ('audio/AMR-WB', 'audio/AMR-WB'), ('audio/amr-wb+', 'audio/amr-wb+'), ('audio/aptx', 'audio/aptx'), ('audio/asc', 'audio/asc'), ('audio/ATRAC-ADVANCED-LOSSLESS', 'audio/ATRAC-ADVANCED-LOSSLESS'), ('audio/ATRAC-X', 'audio/ATRAC-X'), ('audio/ATRAC3', 'audio/ATRAC3'), ('audio/basic', 'audio/basic'), ('audio/BV16', 'audio/BV16'), ('audio/BV32', 'audio/BV32'), ('audio/clearmode', 'audio/clearmode'), ('audio/CN', 'audio/CN'), ('audio/DAT12', 'audio/DAT12'), ('audio/dls', 'audio/dls'), ('audio/dsr-es201108', 'audio/dsr-es201108'), ('audio/dsr-es202050', 'audio/dsr-es202050'), ('audio/dsr-es202211', 'audio/dsr-es202211'), ('audio/dsr-es202212', 'audio/dsr-es202212'), ('audio/DV', 'audio/DV'), ('audio/DVI4', 'audio/DVI4'), ('audio/eac3', 'audio/eac3'), ('audio/encaprtp', 'audio/encaprtp'), ('audio/EVRC', 'audio/EVRC'), ('audio/EVRC-QCP', 'audio/EVRC-QCP'), ('audio/EVRC0', 'audio/EVRC0'), ('audio/EVRC1', 'audio/EVRC1'), ('audio/EVRCB', 'audio/EVRCB'), ('audio/EVRCB0', 'audio/EVRCB0'), ('audio/EVRCB1', 'audio/EVRCB1'), ('audio/EVRCNW', 'audio/EVRCNW'), ('audio/EVRCNW0', 'audio/EVRCNW0'), ('audio/EVRCNW1', 'audio/EVRCNW1'), ('audio/EVRCWB', 'audio/EVRCWB'), ('audio/EVRCWB0', 'audio/EVRCWB0'), ('audio/EVRCWB1', 'audio/EVRCWB1'), ('audio/EVS', 'audio/EVS'), ('audio/example', 'audio/example'), ('audio/fwdred', 'audio/fwdred'), ('audio/G711-0', 'audio/G711-0'), ('audio/G719', 'audio/G719'), ('audio/G7221', 'audio/G7221'), ('audio/G722', 'audio/G722'), ('audio/G723', 'audio/G723'), ('audio/G726-16', 'audio/G726-16'), ('audio/G726-24', 'audio/G726-24'), ('audio/G726-32', 'audio/G726-32'), ('audio/G726-40', 'audio/G726-40'), ('audio/G728', 'audio/G728'), ('audio/G729', 'audio/G729'), ('audio/G7291', 'audio/G7291'), ('audio/G729D', 'audio/G729D'), ('audio/G729E', 'audio/G729E'), ('audio/GSM', 'audio/GSM'), ('audio/GSM-EFR', 'audio/GSM-EFR'), ('audio/GSM-HR-08', 'audio/GSM-HR-08'), ('audio/iLBC', 'audio/iLBC'), ('audio/ip-mr_v2.5', 'audio/ip-mr_v2.5'), ('audio/L8', 'audio/L8'), ('audio/L16', 'audio/L16'), ('audio/L20', 'audio/L20'), ('audio/L24', 'audio/L24'), ('audio/LPC', 'audio/LPC'), ('audio/MELP', 'audio/MELP'), ('audio/MELP600', 'audio/MELP600'), ('audio/MELP1200', 'audio/MELP1200'), ('audio/MELP2400', 'audio/MELP2400'), ('audio/mobile-xmf', 'audio/mobile-xmf'), ('audio/MPA', 'audio/MPA'), ('audio/mp4', 'audio/mp4'), ('audio/MP4A-LATM', 'audio/MP4A-LATM'), ('audio/mpa-robust', 'audio/mpa-robust'), ('audio/mpeg', 'audio/mpeg'), ('audio/mpeg4-generic', 'audio/mpeg4-generic'), ('audio/ogg', 'audio/ogg'), ('audio/opus', 'audio/opus'), ('audio/parityfec', 'audio/parityfec'), ('audio/PCMA', 'audio/PCMA'), ('audio/PCMA-WB', 'audio/PCMA-WB'), ('audio/PCMU', 'audio/PCMU'), ('audio/PCMU-WB', 'audio/PCMU-WB'), ('audio/prs.sid', 'audio/prs.sid'), ('audio/QCELP', 'audio/QCELP'), ('audio/raptorfec', 'audio/raptorfec'), ('audio/RED', 'audio/RED'), ('audio/rtp-enc-aescm128', 'audio/rtp-enc-aescm128'), ('audio/rtploopback', 'audio/rtploopback'), ('audio/rtp-midi', 'audio/rtp-midi'), ('audio/rtx', 'audio/rtx'), ('audio/SMV', 'audio/SMV'), ('audio/SMV0', 'audio/SMV0'), ('audio/SMV-QCP', 'audio/SMV-QCP'), ('audio/sp-midi', 'audio/sp-midi'), ('audio/speex', 'audio/speex'), ('audio/t140c', 'audio/t140c'), ('audio/t38', 'audio/t38'), ('audio/telephone-event', 'audio/telephone-event'), ('audio/tone', 'audio/tone'), ('audio/UEMCLIP', 'audio/UEMCLIP'), ('audio/ulpfec', 'audio/ulpfec'), ('audio/VDVI', 'audio/VDVI'), ('audio/VMR-WB', 'audio/VMR-WB'), ('audio/vnd.3gpp.iufp', 'audio/vnd.3gpp.iufp'), ('audio/vnd.4SB', 'audio/vnd.4SB'), ('audio/vnd.audiokoz', 'audio/vnd.audiokoz'), ('audio/vnd.CELP', 'audio/vnd.CELP'), ('audio/vnd.cisco.nse', 'audio/vnd.cisco.nse'), ('audio/vnd.cmles.radio-events', 'audio/vnd.cmles.radio-events'), ('audio/vnd.cns.anp1', 'audio/vnd.cns.anp1'), ('audio/vnd.cns.inf1', 'audio/vnd.cns.inf1'), ('audio/vnd.dece.audio', 'audio/vnd.dece.audio'), ('audio/vnd.digital-winds', 'audio/vnd.digital-winds'), ('audio/vnd.dlna.adts', 'audio/vnd.dlna.adts'), ('audio/vnd.dolby.heaac.1', 'audio/vnd.dolby.heaac.1'), ('audio/vnd.dolby.heaac.2', 'audio/vnd.dolby.heaac.2'), ('audio/vnd.dolby.mlp', 'audio/vnd.dolby.mlp'), ('audio/vnd.dolby.mps', 'audio/vnd.dolby.mps'), ('audio/vnd.dolby.pl2', 'audio/vnd.dolby.pl2'), ('audio/vnd.dolby.pl2x', 'audio/vnd.dolby.pl2x'), ('audio/vnd.dolby.pl2z', 'audio/vnd.dolby.pl2z'), ('audio/vnd.dolby.pulse.1', 'audio/vnd.dolby.pulse.1'), ('audio/vnd.dra', 'audio/vnd.dra'), ('audio/vnd.dts', 'audio/vnd.dts'), ('audio/vnd.dts.hd', 'audio/vnd.dts.hd'), ('audio/vnd.dvb.file', 'audio/vnd.dvb.file'), ('audio/vnd.everad.plj', 'audio/vnd.everad.plj'), ('audio/vnd.hns.audio', 'audio/vnd.hns.audio'), ('audio/vnd.lucent.voice', 'audio/vnd.lucent.voice'), ('audio/vnd.ms-playready.media.pya', 'audio/vnd.ms-playready.media.pya'), ('audio/vnd.nokia.mobile-xmf', 'audio/vnd.nokia.mobile-xmf'), ('audio/vnd.nortel.vbk', 'audio/vnd.nortel.vbk'), ('audio/vnd.nuera.ecelp4800', 'audio/vnd.nuera.ecelp4800'), ('audio/vnd.nuera.ecelp7470', 'audio/vnd.nuera.ecelp7470'), ('audio/vnd.nuera.ecelp9600', 'audio/vnd.nuera.ecelp9600'), ('audio/vnd.octel.sbc', 'audio/vnd.octel.sbc'), ('audio/vnd.qcelp', 'audio/vnd.qcelp'), ('audio/vnd.rhetorex.32kadpcm', 'audio/vnd.rhetorex.32kadpcm'), ('audio/vnd.rip', 'audio/vnd.rip'), ('audio/vnd.sealedmedia.softseal.mpeg', 'audio/vnd.sealedmedia.softseal.mpeg'), ('audio/vnd.vmx.cvsd', 'audio/vnd.vmx.cvsd'), ('audio/vorbis', 'audio/vorbis'), ('audio/vorbis-config', 'audio/vorbis-config'), ('font/collection', 'font/collection'), ('font/otf', 'font/otf'), ('font/sfnt', 'font/sfnt'), ('font/ttf', 'font/ttf'), ('font/woff', 'font/woff'), ('font/woff2', 'font/woff2'), ('image/bmp', 'image/bmp'), ('image/cgm', 'image/cgm'), ('image/dicom-rle', 'image/dicom-rle'), ('image/emf', 'image/emf'), ('image/example', 'image/example'), ('image/fits', 'image/fits'), ('image/g3fax', 'image/g3fax'), ('image/gif', 'image/gif'), ('image/ief', 'image/ief'), ('image/jls', 'image/jls'), ('image/jp2', 'image/jp2'), ('image/jpeg', 'image/jpeg'), ('image/jpm', 'image/jpm'), ('image/jpx', 'image/jpx'), ('image/ktx', 'image/ktx'), ('image/naplps', 'image/naplps'), ('image/png', 'image/png'), ('image/prs.btif', 'image/prs.btif'), ('image/prs.pti', 'image/prs.pti'), ('image/pwg-raster', 'image/pwg-raster'), ('image/svg+xml', 'image/svg+xml'), ('image/t38', 'image/t38'), ('image/tiff', 'image/tiff'), ('image/tiff-fx', 'image/tiff-fx'), ('image/vnd.adobe.photoshop', 'image/vnd.adobe.photoshop'), ('image/vnd.airzip.accelerator.azv', 'image/vnd.airzip.accelerator.azv'), ('image/vnd.cns.inf2', 'image/vnd.cns.inf2'), ('image/vnd.dece.graphic', 'image/vnd.dece.graphic'), ('image/vnd.djvu', 'image/vnd.djvu'), ('image/vnd.dwg', 'image/vnd.dwg'), ('image/vnd.dxf', 'image/vnd.dxf'), ('image/vnd.dvb.subtitle', 'image/vnd.dvb.subtitle'), ('image/vnd.fastbidsheet', 'image/vnd.fastbidsheet'), ('image/vnd.fpx', 'image/vnd.fpx'), ('image/vnd.fst', 'image/vnd.fst'), ('image/vnd.fujixerox.edmics-mmr', 'image/vnd.fujixerox.edmics-mmr'), ('image/vnd.fujixerox.edmics-rlc', 'image/vnd.fujixerox.edmics-rlc'), ('image/vnd.globalgraphics.pgb', 'image/vnd.globalgraphics.pgb'), ('image/vnd.microsoft.icon', 'image/vnd.microsoft.icon'), ('image/vnd.mix', 'image/vnd.mix'), ('image/vnd.ms-modi', 'image/vnd.ms-modi'), ('image/vnd.mozilla.apng', 'image/vnd.mozilla.apng'), ('image/vnd.net-fpx', 'image/vnd.net-fpx'), ('image/vnd.radiance', 'image/vnd.radiance'), ('image/vnd.sealed.png', 'image/vnd.sealed.png'), ('image/vnd.sealedmedia.softseal.gif', 'image/vnd.sealedmedia.softseal.gif'), ('image/vnd.sealedmedia.softseal.jpg', 'image/vnd.sealedmedia.softseal.jpg'), ('image/vnd.svf', 'image/vnd.svf'), ('image/vnd.tencent.tap', 'image/vnd.tencent.tap'), ('image/vnd.valve.source.texture', 'image/vnd.valve.source.texture'), ('image/vnd.wap.wbmp', 'image/vnd.wap.wbmp'), ('image/vnd.xiff', 'image/vnd.xiff'), ('image/vnd.zbrush.pcx', 'image/vnd.zbrush.pcx'), ('image/wmf', 'image/wmf'), ('image/x-emf', 'image/x-emf'), ('image/x-wmf', 'image/x-wmf'), ('message/CPIM', 'message/CPIM'), ('message/delivery-status', 'message/delivery-status'), ('message/disposition-notification', 'message/disposition-notification'), ('message/example', 'message/example'), ('message/external-body', 'message/external-body'), ('message/feedback-report', 'message/feedback-report'), ('message/global', 'message/global'), ('message/global-delivery-status', 'message/global-delivery-status'), ('message/global-disposition-notification', 'message/global-disposition-notification'), ('message/global-headers', 'message/global-headers'), ('message/http', 'message/http'), ('message/imdn+xml', 'message/imdn+xml'), ('message/news', 'message/news'), ('message/partial', 'message/partial'), ('message/rfc822', 'message/rfc822'), ('message/s-http', 'message/s-http'), ('message/sip', 'message/sip'), ('message/sipfrag', 'message/sipfrag'), ('message/tracking-status', 'message/tracking-status'), ('message/vnd.si.simp', 'message/vnd.si.simp'), ('message/vnd.wfa.wsc', 'message/vnd.wfa.wsc'), ('model/3mf', 'model/3mf'), ('model/example', 'model/example'), ('model/gltf+json', 'model/gltf+json'), ('model/iges', 'model/iges'), ('model/mesh', 'model/mesh'), ('model/vnd.collada+xml', 'model/vnd.collada+xml'), ('model/vnd.dwf', 'model/vnd.dwf'), ('model/vnd.flatland.3dml', 'model/vnd.flatland.3dml'), ('model/vnd.gdl', 'model/vnd.gdl'), ('model/vnd.gs-gdl', 'model/vnd.gs-gdl'), ('model/vnd.gtw', 'model/vnd.gtw'), ('model/vnd.moml+xml', 'model/vnd.moml+xml'), ('model/vnd.mts', 'model/vnd.mts'), ('model/vnd.opengex', 'model/vnd.opengex'), ('model/vnd.parasolid.transmit.binary', 'model/vnd.parasolid.transmit.binary'), ('model/vnd.parasolid.transmit.text', 'model/vnd.parasolid.transmit.text'), ('model/vnd.rosette.annotated-data-model', 'model/vnd.rosette.annotated-data-model'), ('model/vnd.valve.source.compiled-map', 'model/vnd.valve.source.compiled-map'), ('model/vnd.vtu', 'model/vnd.vtu'), ('model/vrml', 'model/vrml'), ('model/x3d-vrml', 'model/x3d-vrml'), ('model/x3d+fastinfoset', 'model/x3d+fastinfoset'), ('model/x3d+xml', 'model/x3d+xml'), ('multipart/alternative', 'multipart/alternative'), ('multipart/appledouble', 'multipart/appledouble'), ('multipart/byteranges', 'multipart/byteranges'), ('multipart/digest', 'multipart/digest'), ('multipart/encrypted', 'multipart/encrypted'), ('multipart/example', 'multipart/example'), ('multipart/form-data', 'multipart/form-data'), ('multipart/header-set', 'multipart/header-set'), ('multipart/mixed', 'multipart/mixed'), ('multipart/parallel', 'multipart/parallel'), ('multipart/related', 'multipart/related'), ('multipart/report', 'multipart/report'), ('multipart/signed', 'multipart/signed'), ('multipart/vnd.bint.med-plus', 'multipart/vnd.bint.med-plus'), ('multipart/voice-message', 'multipart/voice-message'), ('multipart/x-mixed-replace', 'multipart/x-mixed-replace'), ('text/1d-interleaved-parityfec', 'text/1d-interleaved-parityfec'), ('text/cache-manifest', 'text/cache-manifest'), ('text/calendar', 'text/calendar'), ('text/css', 'text/css'), ('text/csv', 'text/csv'), ('text/csv-schema', 'text/csv-schema'), ('text/directory', 'text/directory'), ('text/dns', 'text/dns'), ('text/ecmascript', 'text/ecmascript'), ('text/encaprtp', 'text/encaprtp'), ('text/enriched', 'text/enriched'), ('text/example', 'text/example'), ('text/fwdred', 'text/fwdred'), ('text/grammar-ref-list', 'text/grammar-ref-list'), ('text/html', 'text/html'), ('text/javascript', 'text/javascript'), ('text/jcr-cnd', 'text/jcr-cnd'), ('text/markdown', 'text/markdown'), ('text/mizar', 'text/mizar'), ('text/n3', 'text/n3'), ('text/parameters', 'text/parameters'), ('text/parityfec', 'text/parityfec'), ('text/plain', 'text/plain'), ('text/provenance-notation', 'text/provenance-notation'), ('text/prs.fallenstein.rst', 'text/prs.fallenstein.rst'), ('text/prs.lines.tag', 'text/prs.lines.tag'), ('text/prs.prop.logic', 'text/prs.prop.logic'), ('text/raptorfec', 'text/raptorfec'), ('text/RED', 'text/RED'), ('text/rfc822-headers', 'text/rfc822-headers'), ('text/richtext', 'text/richtext'), ('text/rtf', 'text/rtf'), ('text/rtp-enc-aescm128', 'text/rtp-enc-aescm128'), ('text/rtploopback', 'text/rtploopback'), ('text/rtx', 'text/rtx'), ('text/sgml', 'text/sgml'), ('text/strings', 'text/strings'), ('text/t140', 'text/t140'), ('text/tab-separated-values', 'text/tab-separated-values'), ('text/troff', 'text/troff'), ('text/turtle', 'text/turtle'), ('text/ulpfec', 'text/ulpfec'), ('text/uri-list', 'text/uri-list'), ('text/vcard', 'text/vcard'), ('text/vnd.a', 'text/vnd.a'), ('text/vnd.abc', 'text/vnd.abc'), ('text/vnd.ascii-art', 'text/vnd.ascii-art'), ('text/vnd.curl', 'text/vnd.curl'), ('text/vnd.debian.copyright', 'text/vnd.debian.copyright'), ('text/vnd.DMClientScript', 'text/vnd.DMClientScript'), ('text/vnd.dvb.subtitle', 'text/vnd.dvb.subtitle'), ('text/vnd.esmertec.theme-descriptor', 'text/vnd.esmertec.theme-descriptor'), ('text/vnd.fly', 'text/vnd.fly'), ('text/vnd.fmi.flexstor', 'text/vnd.fmi.flexstor'), ('text/vnd.graphviz', 'text/vnd.graphviz'), ('text/vnd.in3d.3dml', 'text/vnd.in3d.3dml'), ('text/vnd.in3d.spot', 'text/vnd.in3d.spot'), ('text/vnd.IPTC.NewsML', 'text/vnd.IPTC.NewsML'), ('text/vnd.IPTC.NITF', 'text/vnd.IPTC.NITF'), ('text/vnd.latex-z', 'text/vnd.latex-z'), ('text/vnd.motorola.reflex', 'text/vnd.motorola.reflex'), ('text/vnd.ms-mediapackage', 'text/vnd.ms-mediapackage'), ('text/vnd.net2phone.commcenter.command', 'text/vnd.net2phone.commcenter.command'), ('text/vnd.radisys.msml-basic-layout', 'text/vnd.radisys.msml-basic-layout'), ('text/vnd.si.uricatalogue', 'text/vnd.si.uricatalogue'), ('text/vnd.sun.j2me.app-descriptor', 'text/vnd.sun.j2me.app-descriptor'), ('text/vnd.trolltech.linguist', 'text/vnd.trolltech.linguist'), ('text/vnd.wap.si', 'text/vnd.wap.si'), ('text/vnd.wap.sl', 'text/vnd.wap.sl'), ('text/vnd.wap.wml', 'text/vnd.wap.wml'), ('text/vnd.wap.wmlscript', 'text/vnd.wap.wmlscript'), ('text/xml', 'text/xml'), ('text/xml-external-parsed-entity', 'text/xml-external-parsed-entity'), ('video/1d-interleaved-parityfec', 'video/1d-interleaved-parityfec'), ('video/3gpp', 'video/3gpp'), ('video/3gpp2', 'video/3gpp2'), ('video/3gpp-tt', 'video/3gpp-tt'), ('video/BMPEG', 'video/BMPEG'), ('video/BT656', 'video/BT656'), ('video/CelB', 'video/CelB'), ('video/DV', 'video/DV'), ('video/encaprtp', 'video/encaprtp'), ('video/example', 'video/example'), ('video/H261', 'video/H261'), ('video/H263', 'video/H263'), ('video/H263-1998', 'video/H263-1998'), ('video/H263-2000', 'video/H263-2000'), ('video/H264', 'video/H264'), ('video/H264-RCDO', 'video/H264-RCDO'), ('video/H264-SVC', 'video/H264-SVC'), ('video/H265', 'video/H265'), ('video/iso.segment', 'video/iso.segment'), ('video/JPEG', 'video/JPEG'), ('video/jpeg2000', 'video/jpeg2000'), ('video/mj2', 'video/mj2'), ('video/MP1S', 'video/MP1S'), ('video/MP2P', 'video/MP2P'), ('video/MP2T', 'video/MP2T'), ('video/mp4', 'video/mp4'), ('video/MP4V-ES', 'video/MP4V-ES'), ('video/MPV', 'video/MPV'), ('video/mpeg', 'video/mpeg'), ('video/mpeg4-generic', 'video/mpeg4-generic'), ('video/nv', 'video/nv'), ('video/ogg', 'video/ogg'), ('video/parityfec', 'video/parityfec'), ('video/pointer', 'video/pointer'), ('video/quicktime', 'video/quicktime'), ('video/raptorfec', 'video/raptorfec'), ('video/raw', 'video/raw'), ('video/rtp-enc-aescm128', 'video/rtp-enc-aescm128'), ('video/rtploopback', 'video/rtploopback'), ('video/rtx', 'video/rtx'), ('video/SMPTE292M', 'video/SMPTE292M'), ('video/ulpfec', 'video/ulpfec'), ('video/vc1', 'video/vc1'), ('video/vnd.CCTV', 'video/vnd.CCTV'), ('video/vnd.dece.hd', 'video/vnd.dece.hd'), ('video/vnd.dece.mobile', 'video/vnd.dece.mobile'), ('video/vnd.dece.mp4', 'video/vnd.dece.mp4'), ('video/vnd.dece.pd', 'video/vnd.dece.pd'), ('video/vnd.dece.sd', 'video/vnd.dece.sd'), ('video/vnd.dece.video', 'video/vnd.dece.video'), ('video/vnd.directv.mpeg', 'video/vnd.directv.mpeg'), ('video/vnd.directv.mpeg-tts', 'video/vnd.directv.mpeg-tts'), ('video/vnd.dlna.mpeg-tts', 'video/vnd.dlna.mpeg-tts'), ('video/vnd.dvb.file', 'video/vnd.dvb.file'), ('video/vnd.fvt', 'video/vnd.fvt'), ('video/vnd.hns.video', 'video/vnd.hns.video'), ('video/vnd.iptvforum.1dparityfec-1010', 'video/vnd.iptvforum.1dparityfec-1010'), ('video/vnd.iptvforum.1dparityfec-2005', 'video/vnd.iptvforum.1dparityfec-2005'), ('video/vnd.iptvforum.2dparityfec-1010', 'video/vnd.iptvforum.2dparityfec-1010'), ('video/vnd.iptvforum.2dparityfec-2005', 'video/vnd.iptvforum.2dparityfec-2005'), ('video/vnd.iptvforum.ttsavc', 'video/vnd.iptvforum.ttsavc'), ('video/vnd.iptvforum.ttsmpeg2', 'video/vnd.iptvforum.ttsmpeg2'), ('video/vnd.motorola.video', 'video/vnd.motorola.video'), ('video/vnd.motorola.videop', 'video/vnd.motorola.videop'), ('video/vnd.mpegurl', 'video/vnd.mpegurl'), ('video/vnd.ms-playready.media.pyv', 'video/vnd.ms-playready.media.pyv'), ('video/vnd.nokia.interleaved-multimedia', 'video/vnd.nokia.interleaved-multimedia'), ('video/vnd.nokia.videovoip', 'video/vnd.nokia.videovoip'), ('video/vnd.objectvideo', 'video/vnd.objectvideo'), ('video/vnd.radgamettools.bink', 'video/vnd.radgamettools.bink'), ('video/vnd.radgamettools.smacker', 'video/vnd.radgamettools.smacker'), ('video/vnd.sealed.mpeg1', 'video/vnd.sealed.mpeg1'), ('video/vnd.sealed.mpeg4', 'video/vnd.sealed.mpeg4'), ('video/vnd.sealed.swf', 'video/vnd.sealed.swf'), ('video/vnd.sealedmedia.softseal.mov', 'video/vnd.sealedmedia.softseal.mov'), ('video/vnd.uvvu.mp4', 'video/vnd.uvvu.mp4'), ('video/vnd.vivo', 'video/vnd.vivo'), ('video/VP8', 'video/VP8')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='organisationdocumentcountry',
            name='country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the country which concerns the organisation document.', max_length=2, verbose_name='recipient country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='organisationlocation',
            name='iati_country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The country in which the organisation is located.', max_length=2, verbose_name='country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='organisationregionbudget',
            name='region',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the region which concerns the organisation budget.', max_length=25, verbose_name='recipient region', choices=[('88', '88 - States Ex-Yugoslavia unspecified'), ('89', '89 - Europe, regional'), ('189', '189 - North of Sahara, regional'), ('289', '289 - South of Sahara, regional'), ('298', '298 - Africa, regional'), ('380', '380 - West Indies, regional'), ('389', '389 - North & Central America, regional'), ('489', '489 - South America, regional'), ('498', '498 - America, regional'), ('589', '589 - Middle East, regional'), ('619', '619 - Central Asia, regional'), ('679', '679 - South Asia, regional'), ('689', '689 - South & Central Asia, regional'), ('789', '789 - Far East Asia, regional'), ('798', '798 - Asia, regional'), ('889', '889 - Oceania, regional'), ('998', '998 - Developing countries, unspecified')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='project',
            name='collaboration_type',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This is the IATI identifier for the type of collaboration involved. For reference, please visit: <a href="http://iatistandard.org/202/codelists/CollaborationType/" target="_blank">http://iatistandard.org/202/codelists/CollaborationType/</a>.', max_length=1, verbose_name='collaboration type', choices=[('1', '1 - Bilateral'), ('2', '2 - Multilateral (inflows)'), ('3', '3 - Bilateral, core contributions to NGOs and other private bodies / PPPs'), ('4', '4 - Multilateral outflows'), ('6', '6 - Private sector outflows'), ('7', '7 - Bilateral, ex-post reporting on NGOs\u2019 activities funded through core contributions'), ('8', '8 - bilateral, triangular co-operation: activities where one or more bilateral providers of development co-operation or international organisations support South-South co-operation, joining forces with developing countries to facilitate a sharing of knowledge and experience among all partners involved.')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='project',
            name='default_finance_type',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This is the IATI identifier for the type of finance. This element specifies a default for all the transactions in the project\u2019s activity report; it can be overridden at the individual transaction level. For reference visit: <a href="http://iatistandard.org/202/codelists/FinanceType/" target="_blank">http://iatistandard.org/202/codelists/FinanceType/</a>.', max_length=3, verbose_name='default finance type', choices=[('110', '110 - Standard grant'), ('111', '111 - Subsidies to national private investors'), ('210', '210 - Interest subsidy'), ('211', '211 - Interest subsidy to national private exporters'), ('310', '310 - Capital subscription on deposit basis'), ('311', '311 - Capital subscription on encashment basis'), ('410', '410 - Aid loan excluding debt reorganisation'), ('411', '411 - Investment-related loan to developing countries'), ('412', '412 - Loan in a joint venture with the recipient'), ('413', '413 - Loan to national private investor'), ('414', '414 - Loan to national private exporter'), ('421', '421 - Standard loan'), ('422', '422 - Reimbursable grant'), ('423', '423 - Bonds'), ('424', '424 - Asset-backed securities'), ('425', '425 - Other debt securities'), ('431', '431 - Subordinated loan'), ('432', '432 - Preferred equity'), ('433', '433 - Other hybrid instruments'), ('451', '451 - Non-banks guaranteed export credits'), ('452', '452 - Non-banks non-guaranteed portions of guaranteed export credits'), ('453', '453 - Bank export credits'), ('510', '510 - Common equity'), ('511', '511 - Acquisition of equity not part of joint venture in developing countries'), ('512', '512 - Other acquisition of equity'), ('520', '520 - Shares in collective investment vehicles'), ('530', '530 - Reinvested earnings'), ('610', '610 - Debt forgiveness/conversion: ODA claims (P)'), ('611', '611 - Debt forgiveness/conversion: ODA claims (I)'), ('612', '612 - Debt forgiveness/conversion: OOF claims (P)'), ('613', '613 - Debt forgiveness/conversion: OOF claims (I)'), ('614', '614 - Debt forgiveness/conversion: Private claims (P)'), ('615', '615 - Debt forgiveness/conversion: Private claims (I)'), ('616', '616 - Debt forgiveness: OOF claims (DSR)'), ('617', '617 - Debt forgiveness: Private claims (DSR)'), ('618', '618 - Debt forgiveness: Other'), ('620', '620 - Debt rescheduling: ODA claims (P)'), ('621', '621 - Debt rescheduling: ODA claims (I)'), ('622', '622 - Debt rescheduling: OOF claims (P)'), ('623', '623 - Debt rescheduling: OOF claims (I)'), ('624', '624 - Debt rescheduling: Private claims (P)'), ('625', '625 - Debt rescheduling: Private claims (I)'), ('626', '626 - Debt rescheduling: OOF claims (DSR)'), ('627', '627 - Debt rescheduling: Private claims (DSR)'), ('630', '630 - Debt rescheduling: OOF claim (DSR \u2013 original loan principal)'), ('631', '631 - Debt rescheduling: OOF claim (DSR \u2013 original loan interest)'), ('632', '632 - Debt rescheduling: Private claim (DSR \u2013 original loan principal)'), ('633', '633 - Debt forgiveness/conversion: export credit claims (P)'), ('634', '634 - Debt forgiveness/conversion: export credit claims (I)'), ('635', '635 - Debt forgiveness: export credit claims (DSR)'), ('636', '636 - Debt rescheduling: export credit claims (P)'), ('637', '637 - Debt rescheduling: export credit claims (I)'), ('638', '638 - Debt rescheduling: export credit claims (DSR)'), ('639', '639 - Debt rescheduling: export credit claim (DSR \u2013 original loan principal)'), ('710', '710 - Foreign direct investment'), ('711', '711 - Other foreign direct investment, including reinvested earnings'), ('810', '810 - Bank bonds'), ('811', '811 - Non-bank bonds'), ('910', '910 - Other bank securities/claims'), ('911', '911 - Other non-bank securities/claims'), ('912', '912 - Securities and other instruments issued by multilateral agencies')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='project',
            name='default_flow_type',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This is the IATI identifier for how the activity (project) is funded. For reference, please visit: <a href="http://iatistandard.org/202/codelists/FlowType/" target="_blank">http://iatistandard.org/202/codelists/FlowType/</a>.', max_length=2, verbose_name='default flow type', choices=[('10', '10 - ODA'), ('20', '20 - OOF'), ('21', '21 - Non-export credit OOF'), ('22', '22 - Officially supported export credits'), ('30', '30 - Private grants'), ('35', '35 - Private market'), ('36', '36 - Private Foreign Direct Investment'), ('37', '37 - Other Private flows at market terms'), ('40', '40 - Non flow'), ('50', '50 - Other flows')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='projectdocument',
            name='format',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This provides the code for the Internet Media Type ("MIME type") of the document, and includes pdf, msword, rtf, xml, csv, etc. For a list of commonly used MIME types, visit this link: <a href="http://www.sitepoint.com/web-foundations/mime-types-summary-list/" target="_blank">http://www.sitepoint.com/web-foundations/mime-types-summary-list/</a>.', max_length=75, verbose_name='document format', choices=[('application/1d-interleaved-parityfec', 'application/1d-interleaved-parityfec'), ('application/3gpdash-qoe-report+xml', 'application/3gpdash-qoe-report+xml'), ('application/3gpp-ims+xml', 'application/3gpp-ims+xml'), ('application/A2L', 'application/A2L'), ('application/activemessage', 'application/activemessage'), ('application/activemessage', 'application/activemessage'), ('application/alto-costmap+json', 'application/alto-costmap+json'), ('application/alto-costmapfilter+json', 'application/alto-costmapfilter+json'), ('application/alto-directory+json', 'application/alto-directory+json'), ('application/alto-endpointprop+json', 'application/alto-endpointprop+json'), ('application/alto-endpointpropparams+json', 'application/alto-endpointpropparams+json'), ('application/alto-endpointcost+json', 'application/alto-endpointcost+json'), ('application/alto-endpointcostparams+json', 'application/alto-endpointcostparams+json'), ('application/alto-error+json', 'application/alto-error+json'), ('application/alto-networkmapfilter+json', 'application/alto-networkmapfilter+json'), ('application/alto-networkmap+json', 'application/alto-networkmap+json'), ('application/AML', 'application/AML'), ('application/andrew-inset', 'application/andrew-inset'), ('application/applefile', 'application/applefile'), ('application/ATF', 'application/ATF'), ('application/ATFX', 'application/ATFX'), ('application/atom+xml', 'application/atom+xml'), ('application/atomcat+xml', 'application/atomcat+xml'), ('application/atomdeleted+xml', 'application/atomdeleted+xml'), ('application/atomicmail', 'application/atomicmail'), ('application/atomsvc+xml', 'application/atomsvc+xml'), ('application/ATXML', 'application/ATXML'), ('application/auth-policy+xml', 'application/auth-policy+xml'), ('application/bacnet-xdd+zip', 'application/bacnet-xdd+zip'), ('application/batch-SMTP', 'application/batch-SMTP'), ('application/beep+xml', 'application/beep+xml'), ('application/calendar+json', 'application/calendar+json'), ('application/calendar+xml', 'application/calendar+xml'), ('application/call-completion', 'application/call-completion'), ('application/CALS-1840', 'application/CALS-1840'), ('application/cbor', 'application/cbor'), ('application/ccmp+xml', 'application/ccmp+xml'), ('application/ccxml+xml', 'application/ccxml+xml'), ('application/CDFX+XML', 'application/CDFX+XML'), ('application/cdmi-capability', 'application/cdmi-capability'), ('application/cdmi-container', 'application/cdmi-container'), ('application/cdmi-domain', 'application/cdmi-domain'), ('application/cdmi-object', 'application/cdmi-object'), ('application/cdmi-queue', 'application/cdmi-queue'), ('application/cdni', 'application/cdni'), ('application/CEA', 'application/CEA'), ('application/cea-2018+xml', 'application/cea-2018+xml'), ('application/cellml+xml', 'application/cellml+xml'), ('application/cfw', 'application/cfw'), ('application/clue_info+xml', 'application/clue_info+xml'), ('application/cms', 'application/cms'), ('application/cnrp+xml', 'application/cnrp+xml'), ('application/coap-group+json', 'application/coap-group+json'), ('application/coap-payload', 'application/coap-payload'), ('application/commonground', 'application/commonground'), ('application/conference-info+xml', 'application/conference-info+xml'), ('application/cpl+xml', 'application/cpl+xml'), ('application/cose', 'application/cose'), ('application/cose-key', 'application/cose-key'), ('application/cose-key-set', 'application/cose-key-set'), ('application/csrattrs', 'application/csrattrs'), ('application/csta+xml', 'application/csta+xml'), ('application/CSTAdata+xml', 'application/CSTAdata+xml'), ('application/csvm+json', 'application/csvm+json'), ('application/cybercash', 'application/cybercash'), ('application/dash+xml', 'application/dash+xml'), ('application/dashdelta', 'application/dashdelta'), ('application/davmount+xml', 'application/davmount+xml'), ('application/dca-rft', 'application/dca-rft'), ('application/DCD', 'application/DCD'), ('application/dec-dx', 'application/dec-dx'), ('application/dialog-info+xml', 'application/dialog-info+xml'), ('application/dicom', 'application/dicom'), ('application/dicom+json', 'application/dicom+json'), ('application/dicom+xml', 'application/dicom+xml'), ('application/DII', 'application/DII'), ('application/DIT', 'application/DIT'), ('application/dns', 'application/dns'), ('application/dskpp+xml', 'application/dskpp+xml'), ('application/dssc+der', 'application/dssc+der'), ('application/dssc+xml', 'application/dssc+xml'), ('application/dvcs', 'application/dvcs'), ('application/ecmascript', 'application/ecmascript'), ('application/EDI-consent', 'application/EDI-consent'), ('application/EDIFACT', 'application/EDIFACT'), ('application/EDI-X12', 'application/EDI-X12'), ('application/efi', 'application/efi'), ('application/EmergencyCallData.Comment+xml', 'application/EmergencyCallData.Comment+xml'), ('application/EmergencyCallData.Control+xml', 'application/EmergencyCallData.Control+xml'), ('application/EmergencyCallData.DeviceInfo+xml', 'application/EmergencyCallData.DeviceInfo+xml'), ('application/EmergencyCallData.eCall.MSD', 'application/EmergencyCallData.eCall.MSD'), ('application/EmergencyCallData.ProviderInfo+xml', 'application/EmergencyCallData.ProviderInfo+xml'), ('application/EmergencyCallData.ServiceInfo+xml', 'application/EmergencyCallData.ServiceInfo+xml'), ('application/EmergencyCallData.SubscriberInfo+xml', 'application/EmergencyCallData.SubscriberInfo+xml'), ('application/EmergencyCallData.VEDS+xml', 'application/EmergencyCallData.VEDS+xml'), ('application/emma+xml', 'application/emma+xml'), ('application/emotionml+xml', 'application/emotionml+xml'), ('application/encaprtp', 'application/encaprtp'), ('application/epp+xml', 'application/epp+xml'), ('application/epub+zip', 'application/epub+zip'), ('application/eshop', 'application/eshop'), ('application/example', 'application/example'), ('application/exi', 'application/exi'), ('application/fastinfoset', 'application/fastinfoset'), ('application/fastsoap', 'application/fastsoap'), ('application/fdt+xml', 'application/fdt+xml'), ('application/fits', 'application/fits'), ('application/font-sfnt', 'application/font-sfnt'), ('application/font-tdpfr', 'application/font-tdpfr'), ('application/font-woff', 'application/font-woff'), ('application/framework-attributes+xml', 'application/framework-attributes+xml'), ('application/geo+json', 'application/geo+json'), ('application/geo+json-seq', 'application/geo+json-seq'), ('application/gml+xml', 'application/gml+xml'), ('application/gzip', 'application/gzip'), ('application/H224', 'application/H224'), ('application/held+xml', 'application/held+xml'), ('application/http', 'application/http'), ('application/hyperstudio', 'application/hyperstudio'), ('application/ibe-key-request+xml', 'application/ibe-key-request+xml'), ('application/ibe-pkg-reply+xml', 'application/ibe-pkg-reply+xml'), ('application/ibe-pp-data', 'application/ibe-pp-data'), ('application/iges', 'application/iges'), ('application/im-iscomposing+xml', 'application/im-iscomposing+xml'), ('application/index', 'application/index'), ('application/index.cmd', 'application/index.cmd'), ('application/index.obj', 'application/index.obj'), ('application/index.response', 'application/index.response'), ('application/index.vnd', 'application/index.vnd'), ('application/inkml+xml', 'application/inkml+xml'), ('application/iotp', 'application/iotp'), ('application/ipfix', 'application/ipfix'), ('application/ipp', 'application/ipp'), ('application/isup', 'application/isup'), ('application/its+xml', 'application/its+xml'), ('application/javascript', 'application/javascript'), ('application/jose', 'application/jose'), ('application/jose+json', 'application/jose+json'), ('application/jrd+json', 'application/jrd+json'), ('application/json', 'application/json'), ('application/json-patch+json', 'application/json-patch+json'), ('application/json-seq', 'application/json-seq'), ('application/jwk+json', 'application/jwk+json'), ('application/jwk-set+json', 'application/jwk-set+json'), ('application/jwt', 'application/jwt'), ('application/kpml-request+xml', 'application/kpml-request+xml'), ('application/kpml-response+xml', 'application/kpml-response+xml'), ('application/ld+json', 'application/ld+json'), ('application/lgr+xml', 'application/lgr+xml'), ('application/link-format', 'application/link-format'), ('application/load-control+xml', 'application/load-control+xml'), ('application/lost+xml', 'application/lost+xml'), ('application/lostsync+xml', 'application/lostsync+xml'), ('application/LXF', 'application/LXF'), ('application/mac-binhex40', 'application/mac-binhex40'), ('application/macwriteii', 'application/macwriteii'), ('application/mads+xml', 'application/mads+xml'), ('application/marc', 'application/marc'), ('application/marcxml+xml', 'application/marcxml+xml'), ('application/mathematica', 'application/mathematica'), ('application/mathml-content+xml', 'application/mathml-content+xml'), ('application/mathml-presentation+xml', 'application/mathml-presentation+xml'), ('application/mathml+xml', 'application/mathml+xml'), ('application/mbms-associated-procedure-description+xml', 'application/mbms-associated-procedure-description+xml'), ('application/mbms-deregister+xml', 'application/mbms-deregister+xml'), ('application/mbms-envelope+xml', 'application/mbms-envelope+xml'), ('application/mbms-msk-response+xml', 'application/mbms-msk-response+xml'), ('application/mbms-msk+xml', 'application/mbms-msk+xml'), ('application/mbms-protection-description+xml', 'application/mbms-protection-description+xml'), ('application/mbms-reception-report+xml', 'application/mbms-reception-report+xml'), ('application/mbms-register-response+xml', 'application/mbms-register-response+xml'), ('application/mbms-register+xml', 'application/mbms-register+xml'), ('application/mbms-schedule+xml', 'application/mbms-schedule+xml'), ('application/mbms-user-service-description+xml', 'application/mbms-user-service-description+xml'), ('application/mbox', 'application/mbox'), ('application/media_control+xml', 'application/media_control+xml'), ('application/media-policy-dataset+xml', 'application/media-policy-dataset+xml'), ('application/mediaservercontrol+xml', 'application/mediaservercontrol+xml'), ('application/merge-patch+json', 'application/merge-patch+json'), ('application/metalink4+xml', 'application/metalink4+xml'), ('application/mets+xml', 'application/mets+xml'), ('application/MF4', 'application/MF4'), ('application/mikey', 'application/mikey'), ('application/mods+xml', 'application/mods+xml'), ('application/moss-keys', 'application/moss-keys'), ('application/moss-signature', 'application/moss-signature'), ('application/mosskey-data', 'application/mosskey-data'), ('application/mosskey-request', 'application/mosskey-request'), ('application/mp21', 'application/mp21'), ('application/mp4', 'application/mp4'), ('application/mpeg4-generic', 'application/mpeg4-generic'), ('application/mpeg4-iod', 'application/mpeg4-iod'), ('application/mpeg4-iod-xmt', 'application/mpeg4-iod-xmt'), ('application/mrb-consumer+xml', 'application/mrb-consumer+xml'), ('application/mrb-publish+xml', 'application/mrb-publish+xml'), ('application/msc-ivr+xml', 'application/msc-ivr+xml'), ('application/msc-mixer+xml', 'application/msc-mixer+xml'), ('application/msword', 'application/msword'), ('application/mud+json', 'application/mud+json'), ('application/mxf', 'application/mxf'), ('application/n-quads', 'application/n-quads'), ('application/n-triples', 'application/n-triples'), ('application/nasdata', 'application/nasdata'), ('application/news-checkgroups', 'application/news-checkgroups'), ('application/news-groupinfo', 'application/news-groupinfo'), ('application/news-transmission', 'application/news-transmission'), ('application/nlsml+xml', 'application/nlsml+xml'), ('application/nss', 'application/nss'), ('application/ocsp-request', 'application/ocsp-request'), ('application/ocsp-response', 'application/ocsp-response'), ('application/octet-stream', 'application/octet-stream'), ('application/oda', 'application/oda'), ('application/ODX', 'application/ODX'), ('application/oebps-package+xml', 'application/oebps-package+xml'), ('application/ogg', 'application/ogg'), ('application/oxps', 'application/oxps'), ('application/p2p-overlay+xml', 'application/p2p-overlay+xml'), ('application/parityfec', 'application/parityfec'), ('application/patch-ops-error+xml', 'application/patch-ops-error+xml'), ('application/pdf', 'application/pdf'), ('application/PDX', 'application/PDX'), ('application/pgp-encrypted', 'application/pgp-encrypted'), ('application/pgp-keys', 'application/pgp-keys'), ('application/pgp-signature', 'application/pgp-signature'), ('application/pidf-diff+xml', 'application/pidf-diff+xml'), ('application/pidf+xml', 'application/pidf+xml'), ('application/pkcs10', 'application/pkcs10'), ('application/pkcs7-mime', 'application/pkcs7-mime'), ('application/pkcs7-signature', 'application/pkcs7-signature'), ('application/pkcs8', 'application/pkcs8'), ('application/pkcs12', 'application/pkcs12'), ('application/pkix-attr-cert', 'application/pkix-attr-cert'), ('application/pkix-cert', 'application/pkix-cert'), ('application/pkix-crl', 'application/pkix-crl'), ('application/pkix-pkipath', 'application/pkix-pkipath'), ('application/pkixcmp', 'application/pkixcmp'), ('application/pls+xml', 'application/pls+xml'), ('application/poc-settings+xml', 'application/poc-settings+xml'), ('application/postscript', 'application/postscript'), ('application/ppsp-tracker+json', 'application/ppsp-tracker+json'), ('application/problem+json', 'application/problem+json'), ('application/problem+xml', 'application/problem+xml'), ('application/provenance+xml', 'application/provenance+xml'), ('application/prs.alvestrand.titrax-sheet', 'application/prs.alvestrand.titrax-sheet'), ('application/prs.cww', 'application/prs.cww'), ('application/prs.hpub+zip', 'application/prs.hpub+zip'), ('application/prs.nprend', 'application/prs.nprend'), ('application/prs.plucker', 'application/prs.plucker'), ('application/prs.rdf-xml-crypt', 'application/prs.rdf-xml-crypt'), ('application/prs.xsf+xml', 'application/prs.xsf+xml'), ('application/pskc+xml', 'application/pskc+xml'), ('application/rdf+xml', 'application/rdf+xml'), ('application/qsig', 'application/qsig'), ('application/raptorfec', 'application/raptorfec'), ('application/rdap+json', 'application/rdap+json'), ('application/reginfo+xml', 'application/reginfo+xml'), ('application/relax-ng-compact-syntax', 'application/relax-ng-compact-syntax'), ('application/remote-printing', 'application/remote-printing'), ('application/reputon+json', 'application/reputon+json'), ('application/resource-lists-diff+xml', 'application/resource-lists-diff+xml'), ('application/resource-lists+xml', 'application/resource-lists+xml'), ('application/rfc+xml', 'application/rfc+xml'), ('application/riscos', 'application/riscos'), ('application/rlmi+xml', 'application/rlmi+xml'), ('application/rls-services+xml', 'application/rls-services+xml'), ('application/rpki-ghostbusters', 'application/rpki-ghostbusters'), ('application/rpki-manifest', 'application/rpki-manifest'), ('application/rpki-publication', 'application/rpki-publication'), ('application/rpki-roa', 'application/rpki-roa'), ('application/rpki-updown', 'application/rpki-updown'), ('application/rtf', 'application/rtf'), ('application/rtploopback', 'application/rtploopback'), ('application/rtx', 'application/rtx'), ('application/samlassertion+xml', 'application/samlassertion+xml'), ('application/samlmetadata+xml', 'application/samlmetadata+xml'), ('application/sbml+xml', 'application/sbml+xml'), ('application/scaip+xml', 'application/scaip+xml'), ('application/scim+json', 'application/scim+json'), ('application/scvp-cv-request', 'application/scvp-cv-request'), ('application/scvp-cv-response', 'application/scvp-cv-response'), ('application/scvp-vp-request', 'application/scvp-vp-request'), ('application/scvp-vp-response', 'application/scvp-vp-response'), ('application/sdp', 'application/sdp'), ('application/sep-exi', 'application/sep-exi'), ('application/sep+xml', 'application/sep+xml'), ('application/session-info', 'application/session-info'), ('application/set-payment', 'application/set-payment'), ('application/set-payment-initiation', 'application/set-payment-initiation'), ('application/set-registration', 'application/set-registration'), ('application/set-registration-initiation', 'application/set-registration-initiation'), ('application/sgml', 'application/sgml'), ('application/sgml-open-catalog', 'application/sgml-open-catalog'), ('application/shf+xml', 'application/shf+xml'), ('application/sieve', 'application/sieve'), ('application/simple-filter+xml', 'application/simple-filter+xml'), ('application/simple-message-summary', 'application/simple-message-summary'), ('application/simpleSymbolContainer', 'application/simpleSymbolContainer'), ('application/slate', 'application/slate'), ('application/smil', 'application/smil'), ('application/smil+xml', 'application/smil+xml'), ('application/smpte336m', 'application/smpte336m'), ('application/soap+fastinfoset', 'application/soap+fastinfoset'), ('application/soap+xml', 'application/soap+xml'), ('application/sparql-query', 'application/sparql-query'), ('application/sparql-results+xml', 'application/sparql-results+xml'), ('application/spirits-event+xml', 'application/spirits-event+xml'), ('application/sql', 'application/sql'), ('application/srgs', 'application/srgs'), ('application/srgs+xml', 'application/srgs+xml'), ('application/sru+xml', 'application/sru+xml'), ('application/ssml+xml', 'application/ssml+xml'), ('application/tamp-apex-update', 'application/tamp-apex-update'), ('application/tamp-apex-update-confirm', 'application/tamp-apex-update-confirm'), ('application/tamp-community-update', 'application/tamp-community-update'), ('application/tamp-community-update-confirm', 'application/tamp-community-update-confirm'), ('application/tamp-error', 'application/tamp-error'), ('application/tamp-sequence-adjust', 'application/tamp-sequence-adjust'), ('application/tamp-sequence-adjust-confirm', 'application/tamp-sequence-adjust-confirm'), ('application/tamp-status-query', 'application/tamp-status-query'), ('application/tamp-status-response', 'application/tamp-status-response'), ('application/tamp-update', 'application/tamp-update'), ('application/tamp-update-confirm', 'application/tamp-update-confirm'), ('application/tei+xml', 'application/tei+xml'), ('application/thraud+xml', 'application/thraud+xml'), ('application/timestamp-query', 'application/timestamp-query'), ('application/timestamp-reply', 'application/timestamp-reply'), ('application/timestamped-data', 'application/timestamped-data'), ('application/trig', 'application/trig'), ('application/ttml+xml', 'application/ttml+xml'), ('application/tve-trigger', 'application/tve-trigger'), ('application/ulpfec', 'application/ulpfec'), ('application/urc-grpsheet+xml', 'application/urc-grpsheet+xml'), ('application/urc-ressheet+xml', 'application/urc-ressheet+xml'), ('application/urc-targetdesc+xml', 'application/urc-targetdesc+xml'), ('application/urc-uisocketdesc+xml', 'application/urc-uisocketdesc+xml'), ('application/vcard+json', 'application/vcard+json'), ('application/vcard+xml', 'application/vcard+xml'), ('application/vemmi', 'application/vemmi'), ('application/vnd.1000minds.decision-model+xml', 'application/vnd.1000minds.decision-model+xml'), ('application/vnd.3gpp.access-transfer-events+xml', 'application/vnd.3gpp.access-transfer-events+xml'), ('application/vnd.3gpp.bsf+xml', 'application/vnd.3gpp.bsf+xml'), ('application/vnd.3gpp.mid-call+xml', 'application/vnd.3gpp.mid-call+xml'), ('application/vnd.3gpp.pic-bw-large', 'application/vnd.3gpp.pic-bw-large'), ('application/vnd.3gpp.pic-bw-small', 'application/vnd.3gpp.pic-bw-small'), ('application/vnd.3gpp.pic-bw-var', 'application/vnd.3gpp.pic-bw-var'), ('application/vnd.3gpp-prose-pc3ch+xml', 'application/vnd.3gpp-prose-pc3ch+xml'), ('application/vnd.3gpp-prose+xml', 'application/vnd.3gpp-prose+xml'), ('application/vnd.3gpp.sms', 'application/vnd.3gpp.sms'), ('application/vnd.3gpp.sms+xml', 'application/vnd.3gpp.sms+xml'), ('application/vnd.3gpp.srvcc-ext+xml', 'application/vnd.3gpp.srvcc-ext+xml'), ('application/vnd.3gpp.SRVCC-info+xml', 'application/vnd.3gpp.SRVCC-info+xml'), ('application/vnd.3gpp.state-and-event-info+xml', 'application/vnd.3gpp.state-and-event-info+xml'), ('application/vnd.3gpp.ussd+xml', 'application/vnd.3gpp.ussd+xml'), ('application/vnd.3gpp2.bcmcsinfo+xml', 'application/vnd.3gpp2.bcmcsinfo+xml'), ('application/vnd.3gpp2.sms', 'application/vnd.3gpp2.sms'), ('application/vnd.3gpp2.tcap', 'application/vnd.3gpp2.tcap'), ('application/vnd.3lightssoftware.imagescal', 'application/vnd.3lightssoftware.imagescal'), ('application/vnd.3M.Post-it-Notes', 'application/vnd.3M.Post-it-Notes'), ('application/vnd.accpac.simply.aso', 'application/vnd.accpac.simply.aso'), ('application/vnd.accpac.simply.imp', 'application/vnd.accpac.simply.imp'), ('application/vnd.acucobol', 'application/vnd.acucobol'), ('application/vnd.acucorp', 'application/vnd.acucorp'), ('application/vnd.adobe.flash.movie', 'application/vnd.adobe.flash.movie'), ('application/vnd.adobe.formscentral.fcdt', 'application/vnd.adobe.formscentral.fcdt'), ('application/vnd.adobe.fxp', 'application/vnd.adobe.fxp'), ('application/vnd.adobe.partial-upload', 'application/vnd.adobe.partial-upload'), ('application/vnd.adobe.xdp+xml', 'application/vnd.adobe.xdp+xml'), ('application/vnd.adobe.xfdf', 'application/vnd.adobe.xfdf'), ('application/vnd.aether.imp', 'application/vnd.aether.imp'), ('application/vnd.ah-barcode', 'application/vnd.ah-barcode'), ('application/vnd.ahead.space', 'application/vnd.ahead.space'), ('application/vnd.airzip.filesecure.azf', 'application/vnd.airzip.filesecure.azf'), ('application/vnd.airzip.filesecure.azs', 'application/vnd.airzip.filesecure.azs'), ('application/vnd.amazon.mobi8-ebook', 'application/vnd.amazon.mobi8-ebook'), ('application/vnd.americandynamics.acc', 'application/vnd.americandynamics.acc'), ('application/vnd.amiga.ami', 'application/vnd.amiga.ami'), ('application/vnd.amundsen.maze+xml', 'application/vnd.amundsen.maze+xml'), ('application/vnd.anki', 'application/vnd.anki'), ('application/vnd.anser-web-certificate-issue-initiation', 'application/vnd.anser-web-certificate-issue-initiation'), ('application/vnd.antix.game-component', 'application/vnd.antix.game-component'), ('application/vnd.apache.thrift.binary', 'application/vnd.apache.thrift.binary'), ('application/vnd.apache.thrift.compact', 'application/vnd.apache.thrift.compact'), ('application/vnd.apache.thrift.json', 'application/vnd.apache.thrift.json'), ('application/vnd.api+json', 'application/vnd.api+json'), ('application/vnd.apothekende.reservation+json', 'application/vnd.apothekende.reservation+json'), ('application/vnd.apple.mpegurl', 'application/vnd.apple.mpegurl'), ('application/vnd.apple.installer+xml', 'application/vnd.apple.installer+xml'), ('application/vnd.arastra.swi', 'application/vnd.arastra.swi'), ('application/vnd.aristanetworks.swi', 'application/vnd.aristanetworks.swi'), ('application/vnd.artsquare', 'application/vnd.artsquare'), ('application/vnd.astraea-software.iota', 'application/vnd.astraea-software.iota'), ('application/vnd.audiograph', 'application/vnd.audiograph'), ('application/vnd.autopackage', 'application/vnd.autopackage'), ('application/vnd.avistar+xml', 'application/vnd.avistar+xml'), ('application/vnd.balsamiq.bmml+xml', 'application/vnd.balsamiq.bmml+xml'), ('application/vnd.balsamiq.bmpr', 'application/vnd.balsamiq.bmpr'), ('application/vnd.bekitzur-stech+json', 'application/vnd.bekitzur-stech+json'), ('application/vnd.bint.med-content', 'application/vnd.bint.med-content'), ('application/vnd.biopax.rdf+xml', 'application/vnd.biopax.rdf+xml'), ('application/vnd.blueice.multipass', 'application/vnd.blueice.multipass'), ('application/vnd.bluetooth.ep.oob', 'application/vnd.bluetooth.ep.oob'), ('application/vnd.bluetooth.le.oob', 'application/vnd.bluetooth.le.oob'), ('application/vnd.bmi', 'application/vnd.bmi'), ('application/vnd.businessobjects', 'application/vnd.businessobjects'), ('application/vnd.cab-jscript', 'application/vnd.cab-jscript'), ('application/vnd.canon-cpdl', 'application/vnd.canon-cpdl'), ('application/vnd.canon-lips', 'application/vnd.canon-lips'), ('application/vnd.capasystems-pg+json', 'application/vnd.capasystems-pg+json'), ('application/vnd.cendio.thinlinc.clientconf', 'application/vnd.cendio.thinlinc.clientconf'), ('application/vnd.century-systems.tcp_stream', 'application/vnd.century-systems.tcp_stream'), ('application/vnd.chemdraw+xml', 'application/vnd.chemdraw+xml'), ('application/vnd.chess-pgn', 'application/vnd.chess-pgn'), ('application/vnd.chipnuts.karaoke-mmd', 'application/vnd.chipnuts.karaoke-mmd'), ('application/vnd.cinderella', 'application/vnd.cinderella'), ('application/vnd.cirpack.isdn-ext', 'application/vnd.cirpack.isdn-ext'), ('application/vnd.citationstyles.style+xml', 'application/vnd.citationstyles.style+xml'), ('application/vnd.claymore', 'application/vnd.claymore'), ('application/vnd.cloanto.rp9', 'application/vnd.cloanto.rp9'), ('application/vnd.clonk.c4group', 'application/vnd.clonk.c4group'), ('application/vnd.cluetrust.cartomobile-config', 'application/vnd.cluetrust.cartomobile-config'), ('application/vnd.cluetrust.cartomobile-config-pkg', 'application/vnd.cluetrust.cartomobile-config-pkg'), ('application/vnd.coffeescript', 'application/vnd.coffeescript'), ('application/vnd.collection.doc+json', 'application/vnd.collection.doc+json'), ('application/vnd.collection+json', 'application/vnd.collection+json'), ('application/vnd.collection.next+json', 'application/vnd.collection.next+json'), ('application/vnd.comicbook+zip', 'application/vnd.comicbook+zip'), ('application/vnd.commerce-battelle', 'application/vnd.commerce-battelle'), ('application/vnd.commonspace', 'application/vnd.commonspace'), ('application/vnd.coreos.ignition+json', 'application/vnd.coreos.ignition+json'), ('application/vnd.cosmocaller', 'application/vnd.cosmocaller'), ('application/vnd.contact.cmsg', 'application/vnd.contact.cmsg'), ('application/vnd.crick.clicker', 'application/vnd.crick.clicker'), ('application/vnd.crick.clicker.keyboard', 'application/vnd.crick.clicker.keyboard'), ('application/vnd.crick.clicker.palette', 'application/vnd.crick.clicker.palette'), ('application/vnd.crick.clicker.template', 'application/vnd.crick.clicker.template'), ('application/vnd.crick.clicker.wordbank', 'application/vnd.crick.clicker.wordbank'), ('application/vnd.criticaltools.wbs+xml', 'application/vnd.criticaltools.wbs+xml'), ('application/vnd.ctc-posml', 'application/vnd.ctc-posml'), ('application/vnd.ctct.ws+xml', 'application/vnd.ctct.ws+xml'), ('application/vnd.cups-pdf', 'application/vnd.cups-pdf'), ('application/vnd.cups-postscript', 'application/vnd.cups-postscript'), ('application/vnd.cups-ppd', 'application/vnd.cups-ppd'), ('application/vnd.cups-raster', 'application/vnd.cups-raster'), ('application/vnd.cups-raw', 'application/vnd.cups-raw'), ('application/vnd.curl', 'application/vnd.curl'), ('application/vnd.cyan.dean.root+xml', 'application/vnd.cyan.dean.root+xml'), ('application/vnd.cybank', 'application/vnd.cybank'), ('application/vnd.d2l.coursepackage1p0+zip', 'application/vnd.d2l.coursepackage1p0+zip'), ('application/vnd.dart', 'application/vnd.dart'), ('application/vnd.data-vision.rdz', 'application/vnd.data-vision.rdz'), ('application/vnd.datapackage+json', 'application/vnd.datapackage+json'), ('application/vnd.dataresource+json', 'application/vnd.dataresource+json'), ('application/vnd.debian.binary-package', 'application/vnd.debian.binary-package'), ('application/vnd.dece.data', 'application/vnd.dece.data'), ('application/vnd.dece.ttml+xml', 'application/vnd.dece.ttml+xml'), ('application/vnd.dece.unspecified', 'application/vnd.dece.unspecified'), ('application/vnd.dece.zip', 'application/vnd.dece.zip'), ('application/vnd.denovo.fcselayout-link', 'application/vnd.denovo.fcselayout-link'), ('application/vnd.desmume.movie', 'application/vnd.desmume.movie'), ('application/vnd.dir-bi.plate-dl-nosuffix', 'application/vnd.dir-bi.plate-dl-nosuffix'), ('application/vnd.dm.delegation+xml', 'application/vnd.dm.delegation+xml'), ('application/vnd.dna', 'application/vnd.dna'), ('application/vnd.document+json', 'application/vnd.document+json'), ('application/vnd.dolby.mobile.1', 'application/vnd.dolby.mobile.1'), ('application/vnd.dolby.mobile.2', 'application/vnd.dolby.mobile.2'), ('application/vnd.doremir.scorecloud-binary-document', 'application/vnd.doremir.scorecloud-binary-document'), ('application/vnd.dpgraph', 'application/vnd.dpgraph'), ('application/vnd.dreamfactory', 'application/vnd.dreamfactory'), ('application/vnd.drive+json', 'application/vnd.drive+json'), ('application/vnd.dtg.local', 'application/vnd.dtg.local'), ('application/vnd.dtg.local.flash', 'application/vnd.dtg.local.flash'), ('application/vnd.dtg.local.html', 'application/vnd.dtg.local.html'), ('application/vnd.dvb.ait', 'application/vnd.dvb.ait'), ('application/vnd.dvb.dvbj', 'application/vnd.dvb.dvbj'), ('application/vnd.dvb.esgcontainer', 'application/vnd.dvb.esgcontainer'), ('application/vnd.dvb.ipdcdftnotifaccess', 'application/vnd.dvb.ipdcdftnotifaccess'), ('application/vnd.dvb.ipdcesgaccess', 'application/vnd.dvb.ipdcesgaccess'), ('application/vnd.dvb.ipdcesgaccess2', 'application/vnd.dvb.ipdcesgaccess2'), ('application/vnd.dvb.ipdcesgpdd', 'application/vnd.dvb.ipdcesgpdd'), ('application/vnd.dvb.ipdcroaming', 'application/vnd.dvb.ipdcroaming'), ('application/vnd.dvb.iptv.alfec-base', 'application/vnd.dvb.iptv.alfec-base'), ('application/vnd.dvb.iptv.alfec-enhancement', 'application/vnd.dvb.iptv.alfec-enhancement'), ('application/vnd.dvb.notif-aggregate-root+xml', 'application/vnd.dvb.notif-aggregate-root+xml'), ('application/vnd.dvb.notif-container+xml', 'application/vnd.dvb.notif-container+xml'), ('application/vnd.dvb.notif-generic+xml', 'application/vnd.dvb.notif-generic+xml'), ('application/vnd.dvb.notif-ia-msglist+xml', 'application/vnd.dvb.notif-ia-msglist+xml'), ('application/vnd.dvb.notif-ia-registration-request+xml', 'application/vnd.dvb.notif-ia-registration-request+xml'), ('application/vnd.dvb.notif-ia-registration-response+xml', 'application/vnd.dvb.notif-ia-registration-response+xml'), ('application/vnd.dvb.notif-init+xml', 'application/vnd.dvb.notif-init+xml'), ('application/vnd.dvb.pfr', 'application/vnd.dvb.pfr'), ('application/vnd.dvb.service', 'application/vnd.dvb.service'), ('application/vnd.dxr', 'application/vnd.dxr'), ('application/vnd.dynageo', 'application/vnd.dynageo'), ('application/vnd.dzr', 'application/vnd.dzr'), ('application/vnd.easykaraoke.cdgdownload', 'application/vnd.easykaraoke.cdgdownload'), ('application/vnd.ecdis-update', 'application/vnd.ecdis-update'), ('application/vnd.ecowin.chart', 'application/vnd.ecowin.chart'), ('application/vnd.ecowin.filerequest', 'application/vnd.ecowin.filerequest'), ('application/vnd.ecowin.fileupdate', 'application/vnd.ecowin.fileupdate'), ('application/vnd.ecowin.series', 'application/vnd.ecowin.series'), ('application/vnd.ecowin.seriesrequest', 'application/vnd.ecowin.seriesrequest'), ('application/vnd.ecowin.seriesupdate', 'application/vnd.ecowin.seriesupdate'), ('application/vnd.efi.img', 'application/vnd.efi.img'), ('application/vnd.efi.iso', 'application/vnd.efi.iso'), ('application/vnd.emclient.accessrequest+xml', 'application/vnd.emclient.accessrequest+xml'), ('application/vnd.enliven', 'application/vnd.enliven'), ('application/vnd.enphase.envoy', 'application/vnd.enphase.envoy'), ('application/vnd.eprints.data+xml', 'application/vnd.eprints.data+xml'), ('application/vnd.epson.esf', 'application/vnd.epson.esf'), ('application/vnd.epson.msf', 'application/vnd.epson.msf'), ('application/vnd.epson.quickanime', 'application/vnd.epson.quickanime'), ('application/vnd.epson.salt', 'application/vnd.epson.salt'), ('application/vnd.epson.ssf', 'application/vnd.epson.ssf'), ('application/vnd.ericsson.quickcall', 'application/vnd.ericsson.quickcall'), ('application/vnd.espass-espass+zip', 'application/vnd.espass-espass+zip'), ('application/vnd.eszigno3+xml', 'application/vnd.eszigno3+xml'), ('application/vnd.etsi.aoc+xml', 'application/vnd.etsi.aoc+xml'), ('application/vnd.etsi.asic-s+zip', 'application/vnd.etsi.asic-s+zip'), ('application/vnd.etsi.asic-e+zip', 'application/vnd.etsi.asic-e+zip'), ('application/vnd.etsi.cug+xml', 'application/vnd.etsi.cug+xml'), ('application/vnd.etsi.iptvcommand+xml', 'application/vnd.etsi.iptvcommand+xml'), ('application/vnd.etsi.iptvdiscovery+xml', 'application/vnd.etsi.iptvdiscovery+xml'), ('application/vnd.etsi.iptvprofile+xml', 'application/vnd.etsi.iptvprofile+xml'), ('application/vnd.etsi.iptvsad-bc+xml', 'application/vnd.etsi.iptvsad-bc+xml'), ('application/vnd.etsi.iptvsad-cod+xml', 'application/vnd.etsi.iptvsad-cod+xml'), ('application/vnd.etsi.iptvsad-npvr+xml', 'application/vnd.etsi.iptvsad-npvr+xml'), ('application/vnd.etsi.iptvservice+xml', 'application/vnd.etsi.iptvservice+xml'), ('application/vnd.etsi.iptvsync+xml', 'application/vnd.etsi.iptvsync+xml'), ('application/vnd.etsi.iptvueprofile+xml', 'application/vnd.etsi.iptvueprofile+xml'), ('application/vnd.etsi.mcid+xml', 'application/vnd.etsi.mcid+xml'), ('application/vnd.etsi.mheg5', 'application/vnd.etsi.mheg5'), ('application/vnd.etsi.overload-control-policy-dataset+xml', 'application/vnd.etsi.overload-control-policy-dataset+xml'), ('application/vnd.etsi.pstn+xml', 'application/vnd.etsi.pstn+xml'), ('application/vnd.etsi.sci+xml', 'application/vnd.etsi.sci+xml'), ('application/vnd.etsi.simservs+xml', 'application/vnd.etsi.simservs+xml'), ('application/vnd.etsi.timestamp-token', 'application/vnd.etsi.timestamp-token'), ('application/vnd.etsi.tsl+xml', 'application/vnd.etsi.tsl+xml'), ('application/vnd.etsi.tsl.der', 'application/vnd.etsi.tsl.der'), ('application/vnd.evolv.ecig.theme', 'application/vnd.evolv.ecig.theme'), ('application/vnd.eudora.data', 'application/vnd.eudora.data'), ('application/vnd.ezpix-album', 'application/vnd.ezpix-album'), ('application/vnd.ezpix-package', 'application/vnd.ezpix-package'), ('application/vnd.f-secure.mobile', 'application/vnd.f-secure.mobile'), ('application/vnd.fastcopy-disk-image', 'application/vnd.fastcopy-disk-image'), ('application/vnd.fdf', 'application/vnd.fdf'), ('application/vnd.fdsn.mseed', 'application/vnd.fdsn.mseed'), ('application/vnd.fdsn.seed', 'application/vnd.fdsn.seed'), ('application/vnd.ffsns', 'application/vnd.ffsns'), ('application/vnd.filmit.zfc', 'application/vnd.filmit.zfc'), ('application/vnd.fints', 'application/vnd.fints'), ('application/vnd.firemonkeys.cloudcell', 'application/vnd.firemonkeys.cloudcell'), ('application/vnd.FloGraphIt', 'application/vnd.FloGraphIt'), ('application/vnd.fluxtime.clip', 'application/vnd.fluxtime.clip'), ('application/vnd.font-fontforge-sfd', 'application/vnd.font-fontforge-sfd'), ('application/vnd.framemaker', 'application/vnd.framemaker'), ('application/vnd.frogans.fnc', 'application/vnd.frogans.fnc'), ('application/vnd.frogans.ltf', 'application/vnd.frogans.ltf'), ('application/vnd.fsc.weblaunch', 'application/vnd.fsc.weblaunch'), ('application/vnd.fujitsu.oasys', 'application/vnd.fujitsu.oasys'), ('application/vnd.fujitsu.oasys2', 'application/vnd.fujitsu.oasys2'), ('application/vnd.fujitsu.oasys3', 'application/vnd.fujitsu.oasys3'), ('application/vnd.fujitsu.oasysgp', 'application/vnd.fujitsu.oasysgp'), ('application/vnd.fujitsu.oasysprs', 'application/vnd.fujitsu.oasysprs'), ('application/vnd.fujixerox.ART4', 'application/vnd.fujixerox.ART4'), ('application/vnd.fujixerox.ART-EX', 'application/vnd.fujixerox.ART-EX'), ('application/vnd.fujixerox.ddd', 'application/vnd.fujixerox.ddd'), ('application/vnd.fujixerox.docuworks', 'application/vnd.fujixerox.docuworks'), ('application/vnd.fujixerox.docuworks.binder', 'application/vnd.fujixerox.docuworks.binder'), ('application/vnd.fujixerox.docuworks.container', 'application/vnd.fujixerox.docuworks.container'), ('application/vnd.fujixerox.HBPL', 'application/vnd.fujixerox.HBPL'), ('application/vnd.fut-misnet', 'application/vnd.fut-misnet'), ('application/vnd.fuzzysheet', 'application/vnd.fuzzysheet'), ('application/vnd.genomatix.tuxedo', 'application/vnd.genomatix.tuxedo'), ('application/vnd.geo+json', 'application/vnd.geo+json'), ('application/vnd.geocube+xml', 'application/vnd.geocube+xml'), ('application/vnd.geogebra.file', 'application/vnd.geogebra.file'), ('application/vnd.geogebra.tool', 'application/vnd.geogebra.tool'), ('application/vnd.geometry-explorer', 'application/vnd.geometry-explorer'), ('application/vnd.geonext', 'application/vnd.geonext'), ('application/vnd.geoplan', 'application/vnd.geoplan'), ('application/vnd.geospace', 'application/vnd.geospace'), ('application/vnd.gerber', 'application/vnd.gerber'), ('application/vnd.globalplatform.card-content-mgt', 'application/vnd.globalplatform.card-content-mgt'), ('application/vnd.globalplatform.card-content-mgt-response', 'application/vnd.globalplatform.card-content-mgt-response'), ('application/vnd.gmx', 'application/vnd.gmx'), ('application/vnd.google-earth.kml+xml', 'application/vnd.google-earth.kml+xml'), ('application/vnd.google-earth.kmz', 'application/vnd.google-earth.kmz'), ('application/vnd.gov.sk.e-form+xml', 'application/vnd.gov.sk.e-form+xml'), ('application/vnd.gov.sk.e-form+zip', 'application/vnd.gov.sk.e-form+zip'), ('application/vnd.gov.sk.xmldatacontainer+xml', 'application/vnd.gov.sk.xmldatacontainer+xml'), ('application/vnd.grafeq', 'application/vnd.grafeq'), ('application/vnd.gridmp', 'application/vnd.gridmp'), ('application/vnd.groove-account', 'application/vnd.groove-account'), ('application/vnd.groove-help', 'application/vnd.groove-help'), ('application/vnd.groove-identity-message', 'application/vnd.groove-identity-message'), ('application/vnd.groove-injector', 'application/vnd.groove-injector'), ('application/vnd.groove-tool-message', 'application/vnd.groove-tool-message'), ('application/vnd.groove-tool-template', 'application/vnd.groove-tool-template'), ('application/vnd.groove-vcard', 'application/vnd.groove-vcard'), ('application/vnd.hal+json', 'application/vnd.hal+json'), ('application/vnd.hal+xml', 'application/vnd.hal+xml'), ('application/vnd.HandHeld-Entertainment+xml', 'application/vnd.HandHeld-Entertainment+xml'), ('application/vnd.hbci', 'application/vnd.hbci'), ('application/vnd.hc+json', 'application/vnd.hc+json'), ('application/vnd.hcl-bireports', 'application/vnd.hcl-bireports'), ('application/vnd.hdt', 'application/vnd.hdt'), ('application/vnd.heroku+json', 'application/vnd.heroku+json'), ('application/vnd.hhe.lesson-player', 'application/vnd.hhe.lesson-player'), ('application/vnd.hp-HPGL', 'application/vnd.hp-HPGL'), ('application/vnd.hp-hpid', 'application/vnd.hp-hpid'), ('application/vnd.hp-hps', 'application/vnd.hp-hps'), ('application/vnd.hp-jlyt', 'application/vnd.hp-jlyt'), ('application/vnd.hp-PCL', 'application/vnd.hp-PCL'), ('application/vnd.hp-PCLXL', 'application/vnd.hp-PCLXL'), ('application/vnd.httphone', 'application/vnd.httphone'), ('application/vnd.hydrostatix.sof-data', 'application/vnd.hydrostatix.sof-data'), ('application/vnd.hyper-item+json', 'application/vnd.hyper-item+json'), ('application/vnd.hyperdrive+json', 'application/vnd.hyperdrive+json'), ('application/vnd.hzn-3d-crossword', 'application/vnd.hzn-3d-crossword'), ('application/vnd.ibm.afplinedata', 'application/vnd.ibm.afplinedata'), ('application/vnd.ibm.electronic-media', 'application/vnd.ibm.electronic-media'), ('application/vnd.ibm.MiniPay', 'application/vnd.ibm.MiniPay'), ('application/vnd.ibm.modcap', 'application/vnd.ibm.modcap'), ('application/vnd.ibm.rights-management', 'application/vnd.ibm.rights-management'), ('application/vnd.ibm.secure-container', 'application/vnd.ibm.secure-container'), ('application/vnd.iccprofile', 'application/vnd.iccprofile'), ('application/vnd.ieee.1905', 'application/vnd.ieee.1905'), ('application/vnd.igloader', 'application/vnd.igloader'), ('application/vnd.imagemeter.folder+zip', 'application/vnd.imagemeter.folder+zip'), ('application/vnd.imagemeter.image+zip', 'application/vnd.imagemeter.image+zip'), ('application/vnd.immervision-ivp', 'application/vnd.immervision-ivp'), ('application/vnd.immervision-ivu', 'application/vnd.immervision-ivu'), ('application/vnd.ims.imsccv1p1', 'application/vnd.ims.imsccv1p1'), ('application/vnd.ims.imsccv1p2', 'application/vnd.ims.imsccv1p2'), ('application/vnd.ims.imsccv1p3', 'application/vnd.ims.imsccv1p3'), ('application/vnd.ims.lis.v2.result+json', 'application/vnd.ims.lis.v2.result+json'), ('application/vnd.ims.lti.v2.toolconsumerprofile+json', 'application/vnd.ims.lti.v2.toolconsumerprofile+json'), ('application/vnd.ims.lti.v2.toolproxy.id+json', 'application/vnd.ims.lti.v2.toolproxy.id+json'), ('application/vnd.ims.lti.v2.toolproxy+json', 'application/vnd.ims.lti.v2.toolproxy+json'), ('application/vnd.ims.lti.v2.toolsettings+json', 'application/vnd.ims.lti.v2.toolsettings+json'), ('application/vnd.ims.lti.v2.toolsettings.simple+json', 'application/vnd.ims.lti.v2.toolsettings.simple+json'), ('application/vnd.informedcontrol.rms+xml', 'application/vnd.informedcontrol.rms+xml'), ('application/vnd.infotech.project', 'application/vnd.infotech.project'), ('application/vnd.infotech.project+xml', 'application/vnd.infotech.project+xml'), ('application/vnd.informix-visionary', 'application/vnd.informix-visionary'), ('application/vnd.innopath.wamp.notification', 'application/vnd.innopath.wamp.notification'), ('application/vnd.insors.igm', 'application/vnd.insors.igm'), ('application/vnd.intercon.formnet', 'application/vnd.intercon.formnet'), ('application/vnd.intergeo', 'application/vnd.intergeo'), ('application/vnd.intertrust.digibox', 'application/vnd.intertrust.digibox'), ('application/vnd.intertrust.nncp', 'application/vnd.intertrust.nncp'), ('application/vnd.intu.qbo', 'application/vnd.intu.qbo'), ('application/vnd.intu.qfx', 'application/vnd.intu.qfx'), ('application/vnd.iptc.g2.catalogitem+xml', 'application/vnd.iptc.g2.catalogitem+xml'), ('application/vnd.iptc.g2.conceptitem+xml', 'application/vnd.iptc.g2.conceptitem+xml'), ('application/vnd.iptc.g2.knowledgeitem+xml', 'application/vnd.iptc.g2.knowledgeitem+xml'), ('application/vnd.iptc.g2.newsitem+xml', 'application/vnd.iptc.g2.newsitem+xml'), ('application/vnd.iptc.g2.newsmessage+xml', 'application/vnd.iptc.g2.newsmessage+xml'), ('application/vnd.iptc.g2.packageitem+xml', 'application/vnd.iptc.g2.packageitem+xml'), ('application/vnd.iptc.g2.planningitem+xml', 'application/vnd.iptc.g2.planningitem+xml'), ('application/vnd.ipunplugged.rcprofile', 'application/vnd.ipunplugged.rcprofile'), ('application/vnd.irepository.package+xml', 'application/vnd.irepository.package+xml'), ('application/vnd.is-xpr', 'application/vnd.is-xpr'), ('application/vnd.isac.fcs', 'application/vnd.isac.fcs'), ('application/vnd.jam', 'application/vnd.jam'), ('application/vnd.japannet-directory-service', 'application/vnd.japannet-directory-service'), ('application/vnd.japannet-jpnstore-wakeup', 'application/vnd.japannet-jpnstore-wakeup'), ('application/vnd.japannet-payment-wakeup', 'application/vnd.japannet-payment-wakeup'), ('application/vnd.japannet-registration', 'application/vnd.japannet-registration'), ('application/vnd.japannet-registration-wakeup', 'application/vnd.japannet-registration-wakeup'), ('application/vnd.japannet-setstore-wakeup', 'application/vnd.japannet-setstore-wakeup'), ('application/vnd.japannet-verification', 'application/vnd.japannet-verification'), ('application/vnd.japannet-verification-wakeup', 'application/vnd.japannet-verification-wakeup'), ('application/vnd.jcp.javame.midlet-rms', 'application/vnd.jcp.javame.midlet-rms'), ('application/vnd.jisp', 'application/vnd.jisp'), ('application/vnd.joost.joda-archive', 'application/vnd.joost.joda-archive'), ('application/vnd.jsk.isdn-ngn', 'application/vnd.jsk.isdn-ngn'), ('application/vnd.kahootz', 'application/vnd.kahootz'), ('application/vnd.kde.karbon', 'application/vnd.kde.karbon'), ('application/vnd.kde.kchart', 'application/vnd.kde.kchart'), ('application/vnd.kde.kformula', 'application/vnd.kde.kformula'), ('application/vnd.kde.kivio', 'application/vnd.kde.kivio'), ('application/vnd.kde.kontour', 'application/vnd.kde.kontour'), ('application/vnd.kde.kpresenter', 'application/vnd.kde.kpresenter'), ('application/vnd.kde.kspread', 'application/vnd.kde.kspread'), ('application/vnd.kde.kword', 'application/vnd.kde.kword'), ('application/vnd.kenameaapp', 'application/vnd.kenameaapp'), ('application/vnd.kidspiration', 'application/vnd.kidspiration'), ('application/vnd.Kinar', 'application/vnd.Kinar'), ('application/vnd.koan', 'application/vnd.koan'), ('application/vnd.kodak-descriptor', 'application/vnd.kodak-descriptor'), ('application/vnd.las.las+json', 'application/vnd.las.las+json'), ('application/vnd.las.las+xml', 'application/vnd.las.las+xml'), ('application/vnd.liberty-request+xml', 'application/vnd.liberty-request+xml'), ('application/vnd.llamagraphics.life-balance.desktop', 'application/vnd.llamagraphics.life-balance.desktop'), ('application/vnd.llamagraphics.life-balance.exchange+xml', 'application/vnd.llamagraphics.life-balance.exchange+xml'), ('application/vnd.lotus-1-2-3', 'application/vnd.lotus-1-2-3'), ('application/vnd.lotus-approach', 'application/vnd.lotus-approach'), ('application/vnd.lotus-freelance', 'application/vnd.lotus-freelance'), ('application/vnd.lotus-notes', 'application/vnd.lotus-notes'), ('application/vnd.lotus-organizer', 'application/vnd.lotus-organizer'), ('application/vnd.lotus-screencam', 'application/vnd.lotus-screencam'), ('application/vnd.lotus-wordpro', 'application/vnd.lotus-wordpro'), ('application/vnd.macports.portpkg', 'application/vnd.macports.portpkg'), ('application/vnd.macports.portpkg', 'application/vnd.macports.portpkg'), ('application/vnd.mapbox-vector-tile', 'application/vnd.mapbox-vector-tile'), ('application/vnd.marlin.drm.actiontoken+xml', 'application/vnd.marlin.drm.actiontoken+xml'), ('application/vnd.marlin.drm.conftoken+xml', 'application/vnd.marlin.drm.conftoken+xml'), ('application/vnd.marlin.drm.license+xml', 'application/vnd.marlin.drm.license+xml'), ('application/vnd.marlin.drm.mdcf', 'application/vnd.marlin.drm.mdcf'), ('application/vnd.mason+json', 'application/vnd.mason+json'), ('application/vnd.maxmind.maxmind-db', 'application/vnd.maxmind.maxmind-db'), ('application/vnd.mcd', 'application/vnd.mcd'), ('application/vnd.medcalcdata', 'application/vnd.medcalcdata'), ('application/vnd.mediastation.cdkey', 'application/vnd.mediastation.cdkey'), ('application/vnd.meridian-slingshot', 'application/vnd.meridian-slingshot'), ('application/vnd.MFER', 'application/vnd.MFER'), ('application/vnd.mfmp', 'application/vnd.mfmp'), ('application/vnd.micro+json', 'application/vnd.micro+json'), ('application/vnd.micrografx.flo', 'application/vnd.micrografx.flo'), ('application/vnd.micrografx.igx', 'application/vnd.micrografx.igx'), ('application/vnd.microsoft.portable-executable', 'application/vnd.microsoft.portable-executable'), ('application/vnd.microsoft.windows.thumbnail-cache', 'application/vnd.microsoft.windows.thumbnail-cache'), ('application/vnd.miele+json', 'application/vnd.miele+json'), ('application/vnd.mif', 'application/vnd.mif'), ('application/vnd.minisoft-hp3000-save', 'application/vnd.minisoft-hp3000-save'), ('application/vnd.mitsubishi.misty-guard.trustweb', 'application/vnd.mitsubishi.misty-guard.trustweb'), ('application/vnd.Mobius.DAF', 'application/vnd.Mobius.DAF'), ('application/vnd.Mobius.DIS', 'application/vnd.Mobius.DIS'), ('application/vnd.Mobius.MBK', 'application/vnd.Mobius.MBK'), ('application/vnd.Mobius.MQY', 'application/vnd.Mobius.MQY'), ('application/vnd.Mobius.MSL', 'application/vnd.Mobius.MSL'), ('application/vnd.Mobius.PLC', 'application/vnd.Mobius.PLC'), ('application/vnd.Mobius.TXF', 'application/vnd.Mobius.TXF'), ('application/vnd.mophun.application', 'application/vnd.mophun.application'), ('application/vnd.mophun.certificate', 'application/vnd.mophun.certificate'), ('application/vnd.motorola.flexsuite', 'application/vnd.motorola.flexsuite'), ('application/vnd.motorola.flexsuite.adsi', 'application/vnd.motorola.flexsuite.adsi'), ('application/vnd.motorola.flexsuite.fis', 'application/vnd.motorola.flexsuite.fis'), ('application/vnd.motorola.flexsuite.gotap', 'application/vnd.motorola.flexsuite.gotap'), ('application/vnd.motorola.flexsuite.kmr', 'application/vnd.motorola.flexsuite.kmr'), ('application/vnd.motorola.flexsuite.ttc', 'application/vnd.motorola.flexsuite.ttc'), ('application/vnd.motorola.flexsuite.wem', 'application/vnd.motorola.flexsuite.wem'), ('application/vnd.motorola.iprm', 'application/vnd.motorola.iprm'), ('application/vnd.mozilla.xul+xml', 'application/vnd.mozilla.xul+xml'), ('application/vnd.ms-artgalry', 'application/vnd.ms-artgalry'), ('application/vnd.ms-asf', 'application/vnd.ms-asf'), ('application/vnd.ms-cab-compressed', 'application/vnd.ms-cab-compressed'), ('application/vnd.ms-3mfdocument', 'application/vnd.ms-3mfdocument'), ('application/vnd.ms-excel', 'application/vnd.ms-excel'), ('application/vnd.ms-excel.addin.macroEnabled.12', 'application/vnd.ms-excel.addin.macroEnabled.12'), ('application/vnd.ms-excel.sheet.binary.macroEnabled.12', 'application/vnd.ms-excel.sheet.binary.macroEnabled.12'), ('application/vnd.ms-excel.sheet.macroEnabled.12', 'application/vnd.ms-excel.sheet.macroEnabled.12'), ('application/vnd.ms-excel.template.macroEnabled.12', 'application/vnd.ms-excel.template.macroEnabled.12'), ('application/vnd.ms-fontobject', 'application/vnd.ms-fontobject'), ('application/vnd.ms-htmlhelp', 'application/vnd.ms-htmlhelp'), ('application/vnd.ms-ims', 'application/vnd.ms-ims'), ('application/vnd.ms-lrm', 'application/vnd.ms-lrm'), ('application/vnd.ms-office.activeX+xml', 'application/vnd.ms-office.activeX+xml'), ('application/vnd.ms-officetheme', 'application/vnd.ms-officetheme'), ('application/vnd.ms-playready.initiator+xml', 'application/vnd.ms-playready.initiator+xml'), ('application/vnd.ms-powerpoint', 'application/vnd.ms-powerpoint'), ('application/vnd.ms-powerpoint.addin.macroEnabled.12', 'application/vnd.ms-powerpoint.addin.macroEnabled.12'), ('application/vnd.ms-powerpoint.presentation.macroEnabled.12', 'application/vnd.ms-powerpoint.presentation.macroEnabled.12'), ('application/vnd.ms-powerpoint.slide.macroEnabled.12', 'application/vnd.ms-powerpoint.slide.macroEnabled.12'), ('application/vnd.ms-powerpoint.slideshow.macroEnabled.12', 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12'), ('application/vnd.ms-powerpoint.template.macroEnabled.12', 'application/vnd.ms-powerpoint.template.macroEnabled.12'), ('application/vnd.ms-PrintDeviceCapabilities+xml', 'application/vnd.ms-PrintDeviceCapabilities+xml'), ('application/vnd.ms-PrintSchemaTicket+xml', 'application/vnd.ms-PrintSchemaTicket+xml'), ('application/vnd.ms-project', 'application/vnd.ms-project'), ('application/vnd.ms-tnef', 'application/vnd.ms-tnef'), ('application/vnd.ms-windows.devicepairing', 'application/vnd.ms-windows.devicepairing'), ('application/vnd.ms-windows.nwprinting.oob', 'application/vnd.ms-windows.nwprinting.oob'), ('application/vnd.ms-windows.printerpairing', 'application/vnd.ms-windows.printerpairing'), ('application/vnd.ms-windows.wsd.oob', 'application/vnd.ms-windows.wsd.oob'), ('application/vnd.ms-wmdrm.lic-chlg-req', 'application/vnd.ms-wmdrm.lic-chlg-req'), ('application/vnd.ms-wmdrm.lic-resp', 'application/vnd.ms-wmdrm.lic-resp'), ('application/vnd.ms-wmdrm.meter-chlg-req', 'application/vnd.ms-wmdrm.meter-chlg-req'), ('application/vnd.ms-wmdrm.meter-resp', 'application/vnd.ms-wmdrm.meter-resp'), ('application/vnd.ms-word.document.macroEnabled.12', 'application/vnd.ms-word.document.macroEnabled.12'), ('application/vnd.ms-word.template.macroEnabled.12', 'application/vnd.ms-word.template.macroEnabled.12'), ('application/vnd.ms-works', 'application/vnd.ms-works'), ('application/vnd.ms-wpl', 'application/vnd.ms-wpl'), ('application/vnd.ms-xpsdocument', 'application/vnd.ms-xpsdocument'), ('application/vnd.msa-disk-image', 'application/vnd.msa-disk-image'), ('application/vnd.mseq', 'application/vnd.mseq'), ('application/vnd.msign', 'application/vnd.msign'), ('application/vnd.multiad.creator', 'application/vnd.multiad.creator'), ('application/vnd.multiad.creator.cif', 'application/vnd.multiad.creator.cif'), ('application/vnd.musician', 'application/vnd.musician'), ('application/vnd.music-niff', 'application/vnd.music-niff'), ('application/vnd.muvee.style', 'application/vnd.muvee.style'), ('application/vnd.mynfc', 'application/vnd.mynfc'), ('application/vnd.ncd.control', 'application/vnd.ncd.control'), ('application/vnd.ncd.reference', 'application/vnd.ncd.reference'), ('application/vnd.nearst.inv+json', 'application/vnd.nearst.inv+json'), ('application/vnd.nervana', 'application/vnd.nervana'), ('application/vnd.netfpx', 'application/vnd.netfpx'), ('application/vnd.neurolanguage.nlu', 'application/vnd.neurolanguage.nlu'), ('application/vnd.nintendo.snes.rom', 'application/vnd.nintendo.snes.rom'), ('application/vnd.nintendo.nitro.rom', 'application/vnd.nintendo.nitro.rom'), ('application/vnd.nitf', 'application/vnd.nitf'), ('application/vnd.noblenet-directory', 'application/vnd.noblenet-directory'), ('application/vnd.noblenet-sealer', 'application/vnd.noblenet-sealer'), ('application/vnd.noblenet-web', 'application/vnd.noblenet-web'), ('application/vnd.nokia.catalogs', 'application/vnd.nokia.catalogs'), ('application/vnd.nokia.conml+wbxml', 'application/vnd.nokia.conml+wbxml'), ('application/vnd.nokia.conml+xml', 'application/vnd.nokia.conml+xml'), ('application/vnd.nokia.iptv.config+xml', 'application/vnd.nokia.iptv.config+xml'), ('application/vnd.nokia.iSDS-radio-presets', 'application/vnd.nokia.iSDS-radio-presets'), ('application/vnd.nokia.landmark+wbxml', 'application/vnd.nokia.landmark+wbxml'), ('application/vnd.nokia.landmark+xml', 'application/vnd.nokia.landmark+xml'), ('application/vnd.nokia.landmarkcollection+xml', 'application/vnd.nokia.landmarkcollection+xml'), ('application/vnd.nokia.ncd', 'application/vnd.nokia.ncd'), ('application/vnd.nokia.n-gage.ac+xml', 'application/vnd.nokia.n-gage.ac+xml'), ('application/vnd.nokia.n-gage.data', 'application/vnd.nokia.n-gage.data'), ('application/vnd.nokia.n-gage.symbian.install', 'application/vnd.nokia.n-gage.symbian.install'), ('application/vnd.nokia.pcd+wbxml', 'application/vnd.nokia.pcd+wbxml'), ('application/vnd.nokia.pcd+xml', 'application/vnd.nokia.pcd+xml'), ('application/vnd.nokia.radio-preset', 'application/vnd.nokia.radio-preset'), ('application/vnd.nokia.radio-presets', 'application/vnd.nokia.radio-presets'), ('application/vnd.novadigm.EDM', 'application/vnd.novadigm.EDM'), ('application/vnd.novadigm.EDX', 'application/vnd.novadigm.EDX'), ('application/vnd.novadigm.EXT', 'application/vnd.novadigm.EXT'), ('application/vnd.ntt-local.content-share', 'application/vnd.ntt-local.content-share'), ('application/vnd.ntt-local.file-transfer', 'application/vnd.ntt-local.file-transfer'), ('application/vnd.ntt-local.ogw_remote-access', 'application/vnd.ntt-local.ogw_remote-access'), ('application/vnd.ntt-local.sip-ta_remote', 'application/vnd.ntt-local.sip-ta_remote'), ('application/vnd.ntt-local.sip-ta_tcp_stream', 'application/vnd.ntt-local.sip-ta_tcp_stream'), ('application/vnd.oasis.opendocument.chart', 'application/vnd.oasis.opendocument.chart'), ('application/vnd.oasis.opendocument.chart-template', 'application/vnd.oasis.opendocument.chart-template'), ('application/vnd.oasis.opendocument.database', 'application/vnd.oasis.opendocument.database'), ('application/vnd.oasis.opendocument.formula', 'application/vnd.oasis.opendocument.formula'), ('application/vnd.oasis.opendocument.formula-template', 'application/vnd.oasis.opendocument.formula-template'), ('application/vnd.oasis.opendocument.graphics', 'application/vnd.oasis.opendocument.graphics'), ('application/vnd.oasis.opendocument.graphics-template', 'application/vnd.oasis.opendocument.graphics-template'), ('application/vnd.oasis.opendocument.image', 'application/vnd.oasis.opendocument.image'), ('application/vnd.oasis.opendocument.image-template', 'application/vnd.oasis.opendocument.image-template'), ('application/vnd.oasis.opendocument.presentation', 'application/vnd.oasis.opendocument.presentation'), ('application/vnd.oasis.opendocument.presentation-template', 'application/vnd.oasis.opendocument.presentation-template'), ('application/vnd.oasis.opendocument.spreadsheet', 'application/vnd.oasis.opendocument.spreadsheet'), ('application/vnd.oasis.opendocument.spreadsheet-template', 'application/vnd.oasis.opendocument.spreadsheet-template'), ('application/vnd.oasis.opendocument.text', 'application/vnd.oasis.opendocument.text'), ('application/vnd.oasis.opendocument.text-master', 'application/vnd.oasis.opendocument.text-master'), ('application/vnd.oasis.opendocument.text-template', 'application/vnd.oasis.opendocument.text-template'), ('application/vnd.oasis.opendocument.text-web', 'application/vnd.oasis.opendocument.text-web'), ('application/vnd.obn', 'application/vnd.obn'), ('application/vnd.ocf+cbor', 'application/vnd.ocf+cbor'), ('application/vnd.oftn.l10n+json', 'application/vnd.oftn.l10n+json'), ('application/vnd.oipf.contentaccessdownload+xml', 'application/vnd.oipf.contentaccessdownload+xml'), ('application/vnd.oipf.contentaccessstreaming+xml', 'application/vnd.oipf.contentaccessstreaming+xml'), ('application/vnd.oipf.cspg-hexbinary', 'application/vnd.oipf.cspg-hexbinary'), ('application/vnd.oipf.dae.svg+xml', 'application/vnd.oipf.dae.svg+xml'), ('application/vnd.oipf.dae.xhtml+xml', 'application/vnd.oipf.dae.xhtml+xml'), ('application/vnd.oipf.mippvcontrolmessage+xml', 'application/vnd.oipf.mippvcontrolmessage+xml'), ('application/vnd.oipf.pae.gem', 'application/vnd.oipf.pae.gem'), ('application/vnd.oipf.spdiscovery+xml', 'application/vnd.oipf.spdiscovery+xml'), ('application/vnd.oipf.spdlist+xml', 'application/vnd.oipf.spdlist+xml'), ('application/vnd.oipf.ueprofile+xml', 'application/vnd.oipf.ueprofile+xml'), ('application/vnd.oipf.userprofile+xml', 'application/vnd.oipf.userprofile+xml'), ('application/vnd.olpc-sugar', 'application/vnd.olpc-sugar'), ('application/vnd.oma.bcast.associated-procedure-parameter+xml', 'application/vnd.oma.bcast.associated-procedure-parameter+xml'), ('application/vnd.oma.bcast.drm-trigger+xml', 'application/vnd.oma.bcast.drm-trigger+xml'), ('application/vnd.oma.bcast.imd+xml', 'application/vnd.oma.bcast.imd+xml'), ('application/vnd.oma.bcast.ltkm', 'application/vnd.oma.bcast.ltkm'), ('application/vnd.oma.bcast.notification+xml', 'application/vnd.oma.bcast.notification+xml'), ('application/vnd.oma.bcast.provisioningtrigger', 'application/vnd.oma.bcast.provisioningtrigger'), ('application/vnd.oma.bcast.sgboot', 'application/vnd.oma.bcast.sgboot'), ('application/vnd.oma.bcast.sgdd+xml', 'application/vnd.oma.bcast.sgdd+xml'), ('application/vnd.oma.bcast.sgdu', 'application/vnd.oma.bcast.sgdu'), ('application/vnd.oma.bcast.simple-symbol-container', 'application/vnd.oma.bcast.simple-symbol-container'), ('application/vnd.oma.bcast.smartcard-trigger+xml', 'application/vnd.oma.bcast.smartcard-trigger+xml'), ('application/vnd.oma.bcast.sprov+xml', 'application/vnd.oma.bcast.sprov+xml'), ('application/vnd.oma.bcast.stkm', 'application/vnd.oma.bcast.stkm'), ('application/vnd.oma.cab-address-book+xml', 'application/vnd.oma.cab-address-book+xml'), ('application/vnd.oma.cab-feature-handler+xml', 'application/vnd.oma.cab-feature-handler+xml'), ('application/vnd.oma.cab-pcc+xml', 'application/vnd.oma.cab-pcc+xml'), ('application/vnd.oma.cab-subs-invite+xml', 'application/vnd.oma.cab-subs-invite+xml'), ('application/vnd.oma.cab-user-prefs+xml', 'application/vnd.oma.cab-user-prefs+xml'), ('application/vnd.oma.dcd', 'application/vnd.oma.dcd'), ('application/vnd.oma.dcdc', 'application/vnd.oma.dcdc'), ('application/vnd.oma.dd2+xml', 'application/vnd.oma.dd2+xml'), ('application/vnd.oma.drm.risd+xml', 'application/vnd.oma.drm.risd+xml'), ('application/vnd.oma.group-usage-list+xml', 'application/vnd.oma.group-usage-list+xml'), ('application/vnd.oma.lwm2m+json', 'application/vnd.oma.lwm2m+json'), ('application/vnd.oma.lwm2m+tlv', 'application/vnd.oma.lwm2m+tlv'), ('application/vnd.oma.pal+xml', 'application/vnd.oma.pal+xml'), ('application/vnd.oma.poc.detailed-progress-report+xml', 'application/vnd.oma.poc.detailed-progress-report+xml'), ('application/vnd.oma.poc.final-report+xml', 'application/vnd.oma.poc.final-report+xml'), ('application/vnd.oma.poc.groups+xml', 'application/vnd.oma.poc.groups+xml'), ('application/vnd.oma.poc.invocation-descriptor+xml', 'application/vnd.oma.poc.invocation-descriptor+xml'), ('application/vnd.oma.poc.optimized-progress-report+xml', 'application/vnd.oma.poc.optimized-progress-report+xml'), ('application/vnd.oma.push', 'application/vnd.oma.push'), ('application/vnd.oma.scidm.messages+xml', 'application/vnd.oma.scidm.messages+xml'), ('application/vnd.oma.xcap-directory+xml', 'application/vnd.oma.xcap-directory+xml'), ('application/vnd.omads-email+xml', 'application/vnd.omads-email+xml'), ('application/vnd.omads-file+xml', 'application/vnd.omads-file+xml'), ('application/vnd.omads-folder+xml', 'application/vnd.omads-folder+xml'), ('application/vnd.omaloc-supl-init', 'application/vnd.omaloc-supl-init'), ('application/vnd.oma-scws-config', 'application/vnd.oma-scws-config'), ('application/vnd.oma-scws-http-request', 'application/vnd.oma-scws-http-request'), ('application/vnd.oma-scws-http-response', 'application/vnd.oma-scws-http-response'), ('application/vnd.onepager', 'application/vnd.onepager'), ('application/vnd.onepagertamp', 'application/vnd.onepagertamp'), ('application/vnd.onepagertamx', 'application/vnd.onepagertamx'), ('application/vnd.onepagertat', 'application/vnd.onepagertat'), ('application/vnd.onepagertatp', 'application/vnd.onepagertatp'), ('application/vnd.onepagertatx', 'application/vnd.onepagertatx'), ('application/vnd.openblox.game-binary', 'application/vnd.openblox.game-binary'), ('application/vnd.openblox.game+xml', 'application/vnd.openblox.game+xml'), ('application/vnd.openeye.oeb', 'application/vnd.openeye.oeb'), ('application/vnd.openstreetmap.data+xml', 'application/vnd.openstreetmap.data+xml'), ('application/vnd.openxmlformats-officedocument.custom-properties+xml', 'application/vnd.openxmlformats-officedocument.custom-properties+xml'), ('application/vnd.openxmlformats-officedocument.customXmlProperties+xml', 'application/vnd.openxmlformats-officedocument.customXmlProperties+xml'), ('application/vnd.openxmlformats-officedocument.drawing+xml', 'application/vnd.openxmlformats-officedocument.drawing+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chart+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chart+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml', 'application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml'), ('application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml', 'application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml'), ('application/vnd.openxmlformats-officedocument.extended-properties+xml', 'application/vnd.openxmlformats-officedocument.extended-properties+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml', 'application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.comments+xml', 'application/vnd.openxmlformats-officedocument.presentationml.comments+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation', 'application/vnd.openxmlformats-officedocument.presentationml.presentation'), ('application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.presProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.presProps+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slide', 'application/vnd.openxmlformats-officedocument.presentationml.slide'), ('application/vnd.openxmlformats-officedocument.presentationml.slide+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slide+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow'), ('application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml', 'application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.tags+xml', 'application/vnd.openxmlformats-officedocument.presentationml.tags+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.template', 'application/vnd.openxmlformats-officedocument.presentationml.template'), ('application/vnd.openxmlformats-officedocument.presentationml.template.main+xml', 'application/vnd.openxmlformats-officedocument.presentationml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml', 'application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml'), ('application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml', 'application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml'), ('application/vnd.openxmlformats-officedocument.theme+xml', 'application/vnd.openxmlformats-officedocument.theme+xml'), ('application/vnd.openxmlformats-officedocument.themeOverride+xml', 'application/vnd.openxmlformats-officedocument.themeOverride+xml'), ('application/vnd.openxmlformats-officedocument.vmlDrawing', 'application/vnd.openxmlformats-officedocument.vmlDrawing'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml'), ('application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml', 'application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml'), ('application/vnd.openxmlformats-package.core-properties+xml', 'application/vnd.openxmlformats-package.core-properties+xml'), ('application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml', 'application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml'), ('application/vnd.openxmlformats-package.relationships+xml', 'application/vnd.openxmlformats-package.relationships+xml'), ('application/vnd.oracle.resource+json', 'application/vnd.oracle.resource+json'), ('application/vnd.orange.indata', 'application/vnd.orange.indata'), ('application/vnd.osa.netdeploy', 'application/vnd.osa.netdeploy'), ('application/vnd.osgeo.mapguide.package', 'application/vnd.osgeo.mapguide.package'), ('application/vnd.osgi.bundle', 'application/vnd.osgi.bundle'), ('application/vnd.osgi.dp', 'application/vnd.osgi.dp'), ('application/vnd.osgi.subsystem', 'application/vnd.osgi.subsystem'), ('application/vnd.otps.ct-kip+xml', 'application/vnd.otps.ct-kip+xml'), ('application/vnd.oxli.countgraph', 'application/vnd.oxli.countgraph'), ('application/vnd.pagerduty+json', 'application/vnd.pagerduty+json'), ('application/vnd.palm', 'application/vnd.palm'), ('application/vnd.panoply', 'application/vnd.panoply'), ('application/vnd.paos.xml', 'application/vnd.paos.xml'), ('application/vnd.pawaafile', 'application/vnd.pawaafile'), ('application/vnd.pcos', 'application/vnd.pcos'), ('application/vnd.pg.format', 'application/vnd.pg.format'), ('application/vnd.pg.osasli', 'application/vnd.pg.osasli'), ('application/vnd.piaccess.application-licence', 'application/vnd.piaccess.application-licence'), ('application/vnd.picsel', 'application/vnd.picsel'), ('application/vnd.pmi.widget', 'application/vnd.pmi.widget'), ('application/vnd.poc.group-advertisement+xml', 'application/vnd.poc.group-advertisement+xml'), ('application/vnd.pocketlearn', 'application/vnd.pocketlearn'), ('application/vnd.powerbuilder6', 'application/vnd.powerbuilder6'), ('application/vnd.powerbuilder6-s', 'application/vnd.powerbuilder6-s'), ('application/vnd.powerbuilder7', 'application/vnd.powerbuilder7'), ('application/vnd.powerbuilder75', 'application/vnd.powerbuilder75'), ('application/vnd.powerbuilder75-s', 'application/vnd.powerbuilder75-s'), ('application/vnd.powerbuilder7-s', 'application/vnd.powerbuilder7-s'), ('application/vnd.preminet', 'application/vnd.preminet'), ('application/vnd.previewsystems.box', 'application/vnd.previewsystems.box'), ('application/vnd.proteus.magazine', 'application/vnd.proteus.magazine'), ('application/vnd.publishare-delta-tree', 'application/vnd.publishare-delta-tree'), ('application/vnd.pvi.ptid1', 'application/vnd.pvi.ptid1'), ('application/vnd.pwg-multiplexed', 'application/vnd.pwg-multiplexed'), ('application/vnd.pwg-xhtml-print+xml', 'application/vnd.pwg-xhtml-print+xml'), ('application/vnd.qualcomm.brew-app-res', 'application/vnd.qualcomm.brew-app-res'), ('application/vnd.quarantainenet', 'application/vnd.quarantainenet'), ('application/vnd.Quark.QuarkXPress', 'application/vnd.Quark.QuarkXPress'), ('application/vnd.quobject-quoxdocument', 'application/vnd.quobject-quoxdocument'), ('application/vnd.radisys.moml+xml', 'application/vnd.radisys.moml+xml'), ('application/vnd.radisys.msml-audit-conf+xml', 'application/vnd.radisys.msml-audit-conf+xml'), ('application/vnd.radisys.msml-audit-conn+xml', 'application/vnd.radisys.msml-audit-conn+xml'), ('application/vnd.radisys.msml-audit-dialog+xml', 'application/vnd.radisys.msml-audit-dialog+xml'), ('application/vnd.radisys.msml-audit-stream+xml', 'application/vnd.radisys.msml-audit-stream+xml'), ('application/vnd.radisys.msml-audit+xml', 'application/vnd.radisys.msml-audit+xml'), ('application/vnd.radisys.msml-conf+xml', 'application/vnd.radisys.msml-conf+xml'), ('application/vnd.radisys.msml-dialog-base+xml', 'application/vnd.radisys.msml-dialog-base+xml'), ('application/vnd.radisys.msml-dialog-fax-detect+xml', 'application/vnd.radisys.msml-dialog-fax-detect+xml'), ('application/vnd.radisys.msml-dialog-fax-sendrecv+xml', 'application/vnd.radisys.msml-dialog-fax-sendrecv+xml'), ('application/vnd.radisys.msml-dialog-group+xml', 'application/vnd.radisys.msml-dialog-group+xml'), ('application/vnd.radisys.msml-dialog-speech+xml', 'application/vnd.radisys.msml-dialog-speech+xml'), ('application/vnd.radisys.msml-dialog-transform+xml', 'application/vnd.radisys.msml-dialog-transform+xml'), ('application/vnd.radisys.msml-dialog+xml', 'application/vnd.radisys.msml-dialog+xml'), ('application/vnd.radisys.msml+xml', 'application/vnd.radisys.msml+xml'), ('application/vnd.rainstor.data', 'application/vnd.rainstor.data'), ('application/vnd.rapid', 'application/vnd.rapid'), ('application/vnd.rar', 'application/vnd.rar'), ('application/vnd.realvnc.bed', 'application/vnd.realvnc.bed'), ('application/vnd.recordare.musicxml', 'application/vnd.recordare.musicxml'), ('application/vnd.recordare.musicxml+xml', 'application/vnd.recordare.musicxml+xml'), ('application/vnd.RenLearn.rlprint', 'application/vnd.RenLearn.rlprint'), ('application/vnd.rig.cryptonote', 'application/vnd.rig.cryptonote'), ('application/vnd.route66.link66+xml', 'application/vnd.route66.link66+xml'), ('application/vnd.rs-274x', 'application/vnd.rs-274x'), ('application/vnd.ruckus.download', 'application/vnd.ruckus.download'), ('application/vnd.s3sms', 'application/vnd.s3sms'), ('application/vnd.sailingtracker.track', 'application/vnd.sailingtracker.track'), ('application/vnd.sbm.cid', 'application/vnd.sbm.cid'), ('application/vnd.sbm.mid2', 'application/vnd.sbm.mid2'), ('application/vnd.scribus', 'application/vnd.scribus'), ('application/vnd.sealed.3df', 'application/vnd.sealed.3df'), ('application/vnd.sealed.csf', 'application/vnd.sealed.csf'), ('application/vnd.sealed.doc', 'application/vnd.sealed.doc'), ('application/vnd.sealed.eml', 'application/vnd.sealed.eml'), ('application/vnd.sealed.mht', 'application/vnd.sealed.mht'), ('application/vnd.sealed.net', 'application/vnd.sealed.net'), ('application/vnd.sealed.ppt', 'application/vnd.sealed.ppt'), ('application/vnd.sealed.tiff', 'application/vnd.sealed.tiff'), ('application/vnd.sealed.xls', 'application/vnd.sealed.xls'), ('application/vnd.sealedmedia.softseal.html', 'application/vnd.sealedmedia.softseal.html'), ('application/vnd.sealedmedia.softseal.pdf', 'application/vnd.sealedmedia.softseal.pdf'), ('application/vnd.seemail', 'application/vnd.seemail'), ('application/vnd.sema', 'application/vnd.sema'), ('application/vnd.semd', 'application/vnd.semd'), ('application/vnd.semf', 'application/vnd.semf'), ('application/vnd.shana.informed.formdata', 'application/vnd.shana.informed.formdata'), ('application/vnd.shana.informed.formtemplate', 'application/vnd.shana.informed.formtemplate'), ('application/vnd.shana.informed.interchange', 'application/vnd.shana.informed.interchange'), ('application/vnd.shana.informed.package', 'application/vnd.shana.informed.package'), ('application/vnd.sigrok.session', 'application/vnd.sigrok.session'), ('application/vnd.SimTech-MindMapper', 'application/vnd.SimTech-MindMapper'), ('application/vnd.siren+json', 'application/vnd.siren+json'), ('application/vnd.smaf', 'application/vnd.smaf'), ('application/vnd.smart.notebook', 'application/vnd.smart.notebook'), ('application/vnd.smart.teacher', 'application/vnd.smart.teacher'), ('application/vnd.software602.filler.form+xml', 'application/vnd.software602.filler.form+xml'), ('application/vnd.software602.filler.form-xml-zip', 'application/vnd.software602.filler.form-xml-zip'), ('application/vnd.solent.sdkm+xml', 'application/vnd.solent.sdkm+xml'), ('application/vnd.spotfire.dxp', 'application/vnd.spotfire.dxp'), ('application/vnd.spotfire.sfs', 'application/vnd.spotfire.sfs'), ('application/vnd.sss-cod', 'application/vnd.sss-cod'), ('application/vnd.sss-dtf', 'application/vnd.sss-dtf'), ('application/vnd.sss-ntf', 'application/vnd.sss-ntf'), ('application/vnd.stepmania.package', 'application/vnd.stepmania.package'), ('application/vnd.stepmania.stepchart', 'application/vnd.stepmania.stepchart'), ('application/vnd.street-stream', 'application/vnd.street-stream'), ('application/vnd.sun.wadl+xml', 'application/vnd.sun.wadl+xml'), ('application/vnd.sus-calendar', 'application/vnd.sus-calendar'), ('application/vnd.svd', 'application/vnd.svd'), ('application/vnd.swiftview-ics', 'application/vnd.swiftview-ics'), ('application/vnd.syncml.dm.notification', 'application/vnd.syncml.dm.notification'), ('application/vnd.syncml.dmddf+xml', 'application/vnd.syncml.dmddf+xml'), ('application/vnd.syncml.dmtnds+wbxml', 'application/vnd.syncml.dmtnds+wbxml'), ('application/vnd.syncml.dmtnds+xml', 'application/vnd.syncml.dmtnds+xml'), ('application/vnd.syncml.dmddf+wbxml', 'application/vnd.syncml.dmddf+wbxml'), ('application/vnd.syncml.dm+wbxml', 'application/vnd.syncml.dm+wbxml'), ('application/vnd.syncml.dm+xml', 'application/vnd.syncml.dm+xml'), ('application/vnd.syncml.ds.notification', 'application/vnd.syncml.ds.notification'), ('application/vnd.syncml+xml', 'application/vnd.syncml+xml'), ('application/vnd.tableschema+json', 'application/vnd.tableschema+json'), ('application/vnd.tao.intent-module-archive', 'application/vnd.tao.intent-module-archive'), ('application/vnd.tcpdump.pcap', 'application/vnd.tcpdump.pcap'), ('application/vnd.tml', 'application/vnd.tml'), ('application/vnd.tmd.mediaflex.api+xml', 'application/vnd.tmd.mediaflex.api+xml'), ('application/vnd.tmobile-livetv', 'application/vnd.tmobile-livetv'), ('application/vnd.tri.onesource', 'application/vnd.tri.onesource'), ('application/vnd.trid.tpt', 'application/vnd.trid.tpt'), ('application/vnd.triscape.mxs', 'application/vnd.triscape.mxs'), ('application/vnd.trueapp', 'application/vnd.trueapp'), ('application/vnd.truedoc', 'application/vnd.truedoc'), ('application/vnd.ubisoft.webplayer', 'application/vnd.ubisoft.webplayer'), ('application/vnd.ufdl', 'application/vnd.ufdl'), ('application/vnd.uiq.theme', 'application/vnd.uiq.theme'), ('application/vnd.umajin', 'application/vnd.umajin'), ('application/vnd.unity', 'application/vnd.unity'), ('application/vnd.uoml+xml', 'application/vnd.uoml+xml'), ('application/vnd.uplanet.alert', 'application/vnd.uplanet.alert'), ('application/vnd.uplanet.alert-wbxml', 'application/vnd.uplanet.alert-wbxml'), ('application/vnd.uplanet.bearer-choice', 'application/vnd.uplanet.bearer-choice'), ('application/vnd.uplanet.bearer-choice-wbxml', 'application/vnd.uplanet.bearer-choice-wbxml'), ('application/vnd.uplanet.cacheop', 'application/vnd.uplanet.cacheop'), ('application/vnd.uplanet.cacheop-wbxml', 'application/vnd.uplanet.cacheop-wbxml'), ('application/vnd.uplanet.channel', 'application/vnd.uplanet.channel'), ('application/vnd.uplanet.channel-wbxml', 'application/vnd.uplanet.channel-wbxml'), ('application/vnd.uplanet.list', 'application/vnd.uplanet.list'), ('application/vnd.uplanet.listcmd', 'application/vnd.uplanet.listcmd'), ('application/vnd.uplanet.listcmd-wbxml', 'application/vnd.uplanet.listcmd-wbxml'), ('application/vnd.uplanet.list-wbxml', 'application/vnd.uplanet.list-wbxml'), ('application/vnd.uri-map', 'application/vnd.uri-map'), ('application/vnd.uplanet.signal', 'application/vnd.uplanet.signal'), ('application/vnd.valve.source.material', 'application/vnd.valve.source.material'), ('application/vnd.vcx', 'application/vnd.vcx'), ('application/vnd.vd-study', 'application/vnd.vd-study'), ('application/vnd.vectorworks', 'application/vnd.vectorworks'), ('application/vnd.vel+json', 'application/vnd.vel+json'), ('application/vnd.verimatrix.vcas', 'application/vnd.verimatrix.vcas'), ('application/vnd.vidsoft.vidconference', 'application/vnd.vidsoft.vidconference'), ('application/vnd.visio', 'application/vnd.visio'), ('application/vnd.visionary', 'application/vnd.visionary'), ('application/vnd.vividence.scriptfile', 'application/vnd.vividence.scriptfile'), ('application/vnd.vsf', 'application/vnd.vsf'), ('application/vnd.wap.sic', 'application/vnd.wap.sic'), ('application/vnd.wap.slc', 'application/vnd.wap.slc'), ('application/vnd.wap.wbxml', 'application/vnd.wap.wbxml'), ('application/vnd.wap.wmlc', 'application/vnd.wap.wmlc'), ('application/vnd.wap.wmlscriptc', 'application/vnd.wap.wmlscriptc'), ('application/vnd.webturbo', 'application/vnd.webturbo'), ('application/vnd.wfa.p2p', 'application/vnd.wfa.p2p'), ('application/vnd.wfa.wsc', 'application/vnd.wfa.wsc'), ('application/vnd.windows.devicepairing', 'application/vnd.windows.devicepairing'), ('application/vnd.wmc', 'application/vnd.wmc'), ('application/vnd.wmf.bootstrap', 'application/vnd.wmf.bootstrap'), ('application/vnd.wolfram.mathematica', 'application/vnd.wolfram.mathematica'), ('application/vnd.wolfram.mathematica.package', 'application/vnd.wolfram.mathematica.package'), ('application/vnd.wolfram.player', 'application/vnd.wolfram.player'), ('application/vnd.wordperfect', 'application/vnd.wordperfect'), ('application/vnd.wqd', 'application/vnd.wqd'), ('application/vnd.wrq-hp3000-labelled', 'application/vnd.wrq-hp3000-labelled'), ('application/vnd.wt.stf', 'application/vnd.wt.stf'), ('application/vnd.wv.csp+xml', 'application/vnd.wv.csp+xml'), ('application/vnd.wv.csp+wbxml', 'application/vnd.wv.csp+wbxml'), ('application/vnd.wv.ssp+xml', 'application/vnd.wv.ssp+xml'), ('application/vnd.xacml+json', 'application/vnd.xacml+json'), ('application/vnd.xara', 'application/vnd.xara'), ('application/vnd.xfdl', 'application/vnd.xfdl'), ('application/vnd.xfdl.webform', 'application/vnd.xfdl.webform'), ('application/vnd.xmi+xml', 'application/vnd.xmi+xml'), ('application/vnd.xmpie.cpkg', 'application/vnd.xmpie.cpkg'), ('application/vnd.xmpie.dpkg', 'application/vnd.xmpie.dpkg'), ('application/vnd.xmpie.plan', 'application/vnd.xmpie.plan'), ('application/vnd.xmpie.ppkg', 'application/vnd.xmpie.ppkg'), ('application/vnd.xmpie.xlim', 'application/vnd.xmpie.xlim'), ('application/vnd.yamaha.hv-dic', 'application/vnd.yamaha.hv-dic'), ('application/vnd.yamaha.hv-script', 'application/vnd.yamaha.hv-script'), ('application/vnd.yamaha.hv-voice', 'application/vnd.yamaha.hv-voice'), ('application/vnd.yamaha.openscoreformat.osfpvg+xml', 'application/vnd.yamaha.openscoreformat.osfpvg+xml'), ('application/vnd.yamaha.openscoreformat', 'application/vnd.yamaha.openscoreformat'), ('application/vnd.yamaha.remote-setup', 'application/vnd.yamaha.remote-setup'), ('application/vnd.yamaha.smaf-audio', 'application/vnd.yamaha.smaf-audio'), ('application/vnd.yamaha.smaf-phrase', 'application/vnd.yamaha.smaf-phrase'), ('application/vnd.yamaha.through-ngn', 'application/vnd.yamaha.through-ngn'), ('application/vnd.yamaha.tunnel-udpencap', 'application/vnd.yamaha.tunnel-udpencap'), ('application/vnd.yaoweme', 'application/vnd.yaoweme'), ('application/vnd.yellowriver-custom-menu', 'application/vnd.yellowriver-custom-menu'), ('application/vnd.zul', 'application/vnd.zul'), ('application/vnd.zzazz.deck+xml', 'application/vnd.zzazz.deck+xml'), ('application/voicexml+xml', 'application/voicexml+xml'), ('application/vq-rtcpxr', 'application/vq-rtcpxr'), ('application/watcherinfo+xml', 'application/watcherinfo+xml'), ('application/whoispp-query', 'application/whoispp-query'), ('application/whoispp-response', 'application/whoispp-response'), ('application/widget', 'application/widget'), ('application/wita', 'application/wita'), ('application/wordperfect5.1', 'application/wordperfect5.1'), ('application/wsdl+xml', 'application/wsdl+xml'), ('application/wspolicy+xml', 'application/wspolicy+xml'), ('application/x-www-form-urlencoded', 'application/x-www-form-urlencoded'), ('application/x400-bp', 'application/x400-bp'), ('application/xacml+xml', 'application/xacml+xml'), ('application/xcap-att+xml', 'application/xcap-att+xml'), ('application/xcap-caps+xml', 'application/xcap-caps+xml'), ('application/xcap-diff+xml', 'application/xcap-diff+xml'), ('application/xcap-el+xml', 'application/xcap-el+xml'), ('application/xcap-error+xml', 'application/xcap-error+xml'), ('application/xcap-ns+xml', 'application/xcap-ns+xml'), ('application/xcon-conference-info-diff+xml', 'application/xcon-conference-info-diff+xml'), ('application/xcon-conference-info+xml', 'application/xcon-conference-info+xml'), ('application/xenc+xml', 'application/xenc+xml'), ('application/xhtml-voice+xml', 'application/xhtml-voice+xml'), ('application/xhtml+xml', 'application/xhtml+xml'), ('application/xml', 'application/xml'), ('application/xml-dtd', 'application/xml-dtd'), ('application/xml-external-parsed-entity', 'application/xml-external-parsed-entity'), ('application/xml-patch+xml', 'application/xml-patch+xml'), ('application/xmpp+xml', 'application/xmpp+xml'), ('application/xop+xml', 'application/xop+xml'), ('application/xslt+xml', 'application/xslt+xml'), ('application/xv+xml', 'application/xv+xml'), ('application/yang', 'application/yang'), ('application/yang-data+json', 'application/yang-data+json'), ('application/yang-data+xml', 'application/yang-data+xml'), ('application/yang-patch+json', 'application/yang-patch+json'), ('application/yang-patch+xml', 'application/yang-patch+xml'), ('application/yin+xml', 'application/yin+xml'), ('application/zip', 'application/zip'), ('application/zlib', 'application/zlib'), ('audio/1d-interleaved-parityfec', 'audio/1d-interleaved-parityfec'), ('audio/32kadpcm', 'audio/32kadpcm'), ('audio/3gpp', 'audio/3gpp'), ('audio/3gpp2', 'audio/3gpp2'), ('audio/ac3', 'audio/ac3'), ('audio/AMR', 'audio/AMR'), ('audio/AMR-WB', 'audio/AMR-WB'), ('audio/amr-wb+', 'audio/amr-wb+'), ('audio/aptx', 'audio/aptx'), ('audio/asc', 'audio/asc'), ('audio/ATRAC-ADVANCED-LOSSLESS', 'audio/ATRAC-ADVANCED-LOSSLESS'), ('audio/ATRAC-X', 'audio/ATRAC-X'), ('audio/ATRAC3', 'audio/ATRAC3'), ('audio/basic', 'audio/basic'), ('audio/BV16', 'audio/BV16'), ('audio/BV32', 'audio/BV32'), ('audio/clearmode', 'audio/clearmode'), ('audio/CN', 'audio/CN'), ('audio/DAT12', 'audio/DAT12'), ('audio/dls', 'audio/dls'), ('audio/dsr-es201108', 'audio/dsr-es201108'), ('audio/dsr-es202050', 'audio/dsr-es202050'), ('audio/dsr-es202211', 'audio/dsr-es202211'), ('audio/dsr-es202212', 'audio/dsr-es202212'), ('audio/DV', 'audio/DV'), ('audio/DVI4', 'audio/DVI4'), ('audio/eac3', 'audio/eac3'), ('audio/encaprtp', 'audio/encaprtp'), ('audio/EVRC', 'audio/EVRC'), ('audio/EVRC-QCP', 'audio/EVRC-QCP'), ('audio/EVRC0', 'audio/EVRC0'), ('audio/EVRC1', 'audio/EVRC1'), ('audio/EVRCB', 'audio/EVRCB'), ('audio/EVRCB0', 'audio/EVRCB0'), ('audio/EVRCB1', 'audio/EVRCB1'), ('audio/EVRCNW', 'audio/EVRCNW'), ('audio/EVRCNW0', 'audio/EVRCNW0'), ('audio/EVRCNW1', 'audio/EVRCNW1'), ('audio/EVRCWB', 'audio/EVRCWB'), ('audio/EVRCWB0', 'audio/EVRCWB0'), ('audio/EVRCWB1', 'audio/EVRCWB1'), ('audio/EVS', 'audio/EVS'), ('audio/example', 'audio/example'), ('audio/fwdred', 'audio/fwdred'), ('audio/G711-0', 'audio/G711-0'), ('audio/G719', 'audio/G719'), ('audio/G7221', 'audio/G7221'), ('audio/G722', 'audio/G722'), ('audio/G723', 'audio/G723'), ('audio/G726-16', 'audio/G726-16'), ('audio/G726-24', 'audio/G726-24'), ('audio/G726-32', 'audio/G726-32'), ('audio/G726-40', 'audio/G726-40'), ('audio/G728', 'audio/G728'), ('audio/G729', 'audio/G729'), ('audio/G7291', 'audio/G7291'), ('audio/G729D', 'audio/G729D'), ('audio/G729E', 'audio/G729E'), ('audio/GSM', 'audio/GSM'), ('audio/GSM-EFR', 'audio/GSM-EFR'), ('audio/GSM-HR-08', 'audio/GSM-HR-08'), ('audio/iLBC', 'audio/iLBC'), ('audio/ip-mr_v2.5', 'audio/ip-mr_v2.5'), ('audio/L8', 'audio/L8'), ('audio/L16', 'audio/L16'), ('audio/L20', 'audio/L20'), ('audio/L24', 'audio/L24'), ('audio/LPC', 'audio/LPC'), ('audio/MELP', 'audio/MELP'), ('audio/MELP600', 'audio/MELP600'), ('audio/MELP1200', 'audio/MELP1200'), ('audio/MELP2400', 'audio/MELP2400'), ('audio/mobile-xmf', 'audio/mobile-xmf'), ('audio/MPA', 'audio/MPA'), ('audio/mp4', 'audio/mp4'), ('audio/MP4A-LATM', 'audio/MP4A-LATM'), ('audio/mpa-robust', 'audio/mpa-robust'), ('audio/mpeg', 'audio/mpeg'), ('audio/mpeg4-generic', 'audio/mpeg4-generic'), ('audio/ogg', 'audio/ogg'), ('audio/opus', 'audio/opus'), ('audio/parityfec', 'audio/parityfec'), ('audio/PCMA', 'audio/PCMA'), ('audio/PCMA-WB', 'audio/PCMA-WB'), ('audio/PCMU', 'audio/PCMU'), ('audio/PCMU-WB', 'audio/PCMU-WB'), ('audio/prs.sid', 'audio/prs.sid'), ('audio/QCELP', 'audio/QCELP'), ('audio/raptorfec', 'audio/raptorfec'), ('audio/RED', 'audio/RED'), ('audio/rtp-enc-aescm128', 'audio/rtp-enc-aescm128'), ('audio/rtploopback', 'audio/rtploopback'), ('audio/rtp-midi', 'audio/rtp-midi'), ('audio/rtx', 'audio/rtx'), ('audio/SMV', 'audio/SMV'), ('audio/SMV0', 'audio/SMV0'), ('audio/SMV-QCP', 'audio/SMV-QCP'), ('audio/sp-midi', 'audio/sp-midi'), ('audio/speex', 'audio/speex'), ('audio/t140c', 'audio/t140c'), ('audio/t38', 'audio/t38'), ('audio/telephone-event', 'audio/telephone-event'), ('audio/tone', 'audio/tone'), ('audio/UEMCLIP', 'audio/UEMCLIP'), ('audio/ulpfec', 'audio/ulpfec'), ('audio/VDVI', 'audio/VDVI'), ('audio/VMR-WB', 'audio/VMR-WB'), ('audio/vnd.3gpp.iufp', 'audio/vnd.3gpp.iufp'), ('audio/vnd.4SB', 'audio/vnd.4SB'), ('audio/vnd.audiokoz', 'audio/vnd.audiokoz'), ('audio/vnd.CELP', 'audio/vnd.CELP'), ('audio/vnd.cisco.nse', 'audio/vnd.cisco.nse'), ('audio/vnd.cmles.radio-events', 'audio/vnd.cmles.radio-events'), ('audio/vnd.cns.anp1', 'audio/vnd.cns.anp1'), ('audio/vnd.cns.inf1', 'audio/vnd.cns.inf1'), ('audio/vnd.dece.audio', 'audio/vnd.dece.audio'), ('audio/vnd.digital-winds', 'audio/vnd.digital-winds'), ('audio/vnd.dlna.adts', 'audio/vnd.dlna.adts'), ('audio/vnd.dolby.heaac.1', 'audio/vnd.dolby.heaac.1'), ('audio/vnd.dolby.heaac.2', 'audio/vnd.dolby.heaac.2'), ('audio/vnd.dolby.mlp', 'audio/vnd.dolby.mlp'), ('audio/vnd.dolby.mps', 'audio/vnd.dolby.mps'), ('audio/vnd.dolby.pl2', 'audio/vnd.dolby.pl2'), ('audio/vnd.dolby.pl2x', 'audio/vnd.dolby.pl2x'), ('audio/vnd.dolby.pl2z', 'audio/vnd.dolby.pl2z'), ('audio/vnd.dolby.pulse.1', 'audio/vnd.dolby.pulse.1'), ('audio/vnd.dra', 'audio/vnd.dra'), ('audio/vnd.dts', 'audio/vnd.dts'), ('audio/vnd.dts.hd', 'audio/vnd.dts.hd'), ('audio/vnd.dvb.file', 'audio/vnd.dvb.file'), ('audio/vnd.everad.plj', 'audio/vnd.everad.plj'), ('audio/vnd.hns.audio', 'audio/vnd.hns.audio'), ('audio/vnd.lucent.voice', 'audio/vnd.lucent.voice'), ('audio/vnd.ms-playready.media.pya', 'audio/vnd.ms-playready.media.pya'), ('audio/vnd.nokia.mobile-xmf', 'audio/vnd.nokia.mobile-xmf'), ('audio/vnd.nortel.vbk', 'audio/vnd.nortel.vbk'), ('audio/vnd.nuera.ecelp4800', 'audio/vnd.nuera.ecelp4800'), ('audio/vnd.nuera.ecelp7470', 'audio/vnd.nuera.ecelp7470'), ('audio/vnd.nuera.ecelp9600', 'audio/vnd.nuera.ecelp9600'), ('audio/vnd.octel.sbc', 'audio/vnd.octel.sbc'), ('audio/vnd.qcelp', 'audio/vnd.qcelp'), ('audio/vnd.rhetorex.32kadpcm', 'audio/vnd.rhetorex.32kadpcm'), ('audio/vnd.rip', 'audio/vnd.rip'), ('audio/vnd.sealedmedia.softseal.mpeg', 'audio/vnd.sealedmedia.softseal.mpeg'), ('audio/vnd.vmx.cvsd', 'audio/vnd.vmx.cvsd'), ('audio/vorbis', 'audio/vorbis'), ('audio/vorbis-config', 'audio/vorbis-config'), ('font/collection', 'font/collection'), ('font/otf', 'font/otf'), ('font/sfnt', 'font/sfnt'), ('font/ttf', 'font/ttf'), ('font/woff', 'font/woff'), ('font/woff2', 'font/woff2'), ('image/bmp', 'image/bmp'), ('image/cgm', 'image/cgm'), ('image/dicom-rle', 'image/dicom-rle'), ('image/emf', 'image/emf'), ('image/example', 'image/example'), ('image/fits', 'image/fits'), ('image/g3fax', 'image/g3fax'), ('image/gif', 'image/gif'), ('image/ief', 'image/ief'), ('image/jls', 'image/jls'), ('image/jp2', 'image/jp2'), ('image/jpeg', 'image/jpeg'), ('image/jpm', 'image/jpm'), ('image/jpx', 'image/jpx'), ('image/ktx', 'image/ktx'), ('image/naplps', 'image/naplps'), ('image/png', 'image/png'), ('image/prs.btif', 'image/prs.btif'), ('image/prs.pti', 'image/prs.pti'), ('image/pwg-raster', 'image/pwg-raster'), ('image/svg+xml', 'image/svg+xml'), ('image/t38', 'image/t38'), ('image/tiff', 'image/tiff'), ('image/tiff-fx', 'image/tiff-fx'), ('image/vnd.adobe.photoshop', 'image/vnd.adobe.photoshop'), ('image/vnd.airzip.accelerator.azv', 'image/vnd.airzip.accelerator.azv'), ('image/vnd.cns.inf2', 'image/vnd.cns.inf2'), ('image/vnd.dece.graphic', 'image/vnd.dece.graphic'), ('image/vnd.djvu', 'image/vnd.djvu'), ('image/vnd.dwg', 'image/vnd.dwg'), ('image/vnd.dxf', 'image/vnd.dxf'), ('image/vnd.dvb.subtitle', 'image/vnd.dvb.subtitle'), ('image/vnd.fastbidsheet', 'image/vnd.fastbidsheet'), ('image/vnd.fpx', 'image/vnd.fpx'), ('image/vnd.fst', 'image/vnd.fst'), ('image/vnd.fujixerox.edmics-mmr', 'image/vnd.fujixerox.edmics-mmr'), ('image/vnd.fujixerox.edmics-rlc', 'image/vnd.fujixerox.edmics-rlc'), ('image/vnd.globalgraphics.pgb', 'image/vnd.globalgraphics.pgb'), ('image/vnd.microsoft.icon', 'image/vnd.microsoft.icon'), ('image/vnd.mix', 'image/vnd.mix'), ('image/vnd.ms-modi', 'image/vnd.ms-modi'), ('image/vnd.mozilla.apng', 'image/vnd.mozilla.apng'), ('image/vnd.net-fpx', 'image/vnd.net-fpx'), ('image/vnd.radiance', 'image/vnd.radiance'), ('image/vnd.sealed.png', 'image/vnd.sealed.png'), ('image/vnd.sealedmedia.softseal.gif', 'image/vnd.sealedmedia.softseal.gif'), ('image/vnd.sealedmedia.softseal.jpg', 'image/vnd.sealedmedia.softseal.jpg'), ('image/vnd.svf', 'image/vnd.svf'), ('image/vnd.tencent.tap', 'image/vnd.tencent.tap'), ('image/vnd.valve.source.texture', 'image/vnd.valve.source.texture'), ('image/vnd.wap.wbmp', 'image/vnd.wap.wbmp'), ('image/vnd.xiff', 'image/vnd.xiff'), ('image/vnd.zbrush.pcx', 'image/vnd.zbrush.pcx'), ('image/wmf', 'image/wmf'), ('image/x-emf', 'image/x-emf'), ('image/x-wmf', 'image/x-wmf'), ('message/CPIM', 'message/CPIM'), ('message/delivery-status', 'message/delivery-status'), ('message/disposition-notification', 'message/disposition-notification'), ('message/example', 'message/example'), ('message/external-body', 'message/external-body'), ('message/feedback-report', 'message/feedback-report'), ('message/global', 'message/global'), ('message/global-delivery-status', 'message/global-delivery-status'), ('message/global-disposition-notification', 'message/global-disposition-notification'), ('message/global-headers', 'message/global-headers'), ('message/http', 'message/http'), ('message/imdn+xml', 'message/imdn+xml'), ('message/news', 'message/news'), ('message/partial', 'message/partial'), ('message/rfc822', 'message/rfc822'), ('message/s-http', 'message/s-http'), ('message/sip', 'message/sip'), ('message/sipfrag', 'message/sipfrag'), ('message/tracking-status', 'message/tracking-status'), ('message/vnd.si.simp', 'message/vnd.si.simp'), ('message/vnd.wfa.wsc', 'message/vnd.wfa.wsc'), ('model/3mf', 'model/3mf'), ('model/example', 'model/example'), ('model/gltf+json', 'model/gltf+json'), ('model/iges', 'model/iges'), ('model/mesh', 'model/mesh'), ('model/vnd.collada+xml', 'model/vnd.collada+xml'), ('model/vnd.dwf', 'model/vnd.dwf'), ('model/vnd.flatland.3dml', 'model/vnd.flatland.3dml'), ('model/vnd.gdl', 'model/vnd.gdl'), ('model/vnd.gs-gdl', 'model/vnd.gs-gdl'), ('model/vnd.gtw', 'model/vnd.gtw'), ('model/vnd.moml+xml', 'model/vnd.moml+xml'), ('model/vnd.mts', 'model/vnd.mts'), ('model/vnd.opengex', 'model/vnd.opengex'), ('model/vnd.parasolid.transmit.binary', 'model/vnd.parasolid.transmit.binary'), ('model/vnd.parasolid.transmit.text', 'model/vnd.parasolid.transmit.text'), ('model/vnd.rosette.annotated-data-model', 'model/vnd.rosette.annotated-data-model'), ('model/vnd.valve.source.compiled-map', 'model/vnd.valve.source.compiled-map'), ('model/vnd.vtu', 'model/vnd.vtu'), ('model/vrml', 'model/vrml'), ('model/x3d-vrml', 'model/x3d-vrml'), ('model/x3d+fastinfoset', 'model/x3d+fastinfoset'), ('model/x3d+xml', 'model/x3d+xml'), ('multipart/alternative', 'multipart/alternative'), ('multipart/appledouble', 'multipart/appledouble'), ('multipart/byteranges', 'multipart/byteranges'), ('multipart/digest', 'multipart/digest'), ('multipart/encrypted', 'multipart/encrypted'), ('multipart/example', 'multipart/example'), ('multipart/form-data', 'multipart/form-data'), ('multipart/header-set', 'multipart/header-set'), ('multipart/mixed', 'multipart/mixed'), ('multipart/parallel', 'multipart/parallel'), ('multipart/related', 'multipart/related'), ('multipart/report', 'multipart/report'), ('multipart/signed', 'multipart/signed'), ('multipart/vnd.bint.med-plus', 'multipart/vnd.bint.med-plus'), ('multipart/voice-message', 'multipart/voice-message'), ('multipart/x-mixed-replace', 'multipart/x-mixed-replace'), ('text/1d-interleaved-parityfec', 'text/1d-interleaved-parityfec'), ('text/cache-manifest', 'text/cache-manifest'), ('text/calendar', 'text/calendar'), ('text/css', 'text/css'), ('text/csv', 'text/csv'), ('text/csv-schema', 'text/csv-schema'), ('text/directory', 'text/directory'), ('text/dns', 'text/dns'), ('text/ecmascript', 'text/ecmascript'), ('text/encaprtp', 'text/encaprtp'), ('text/enriched', 'text/enriched'), ('text/example', 'text/example'), ('text/fwdred', 'text/fwdred'), ('text/grammar-ref-list', 'text/grammar-ref-list'), ('text/html', 'text/html'), ('text/javascript', 'text/javascript'), ('text/jcr-cnd', 'text/jcr-cnd'), ('text/markdown', 'text/markdown'), ('text/mizar', 'text/mizar'), ('text/n3', 'text/n3'), ('text/parameters', 'text/parameters'), ('text/parityfec', 'text/parityfec'), ('text/plain', 'text/plain'), ('text/provenance-notation', 'text/provenance-notation'), ('text/prs.fallenstein.rst', 'text/prs.fallenstein.rst'), ('text/prs.lines.tag', 'text/prs.lines.tag'), ('text/prs.prop.logic', 'text/prs.prop.logic'), ('text/raptorfec', 'text/raptorfec'), ('text/RED', 'text/RED'), ('text/rfc822-headers', 'text/rfc822-headers'), ('text/richtext', 'text/richtext'), ('text/rtf', 'text/rtf'), ('text/rtp-enc-aescm128', 'text/rtp-enc-aescm128'), ('text/rtploopback', 'text/rtploopback'), ('text/rtx', 'text/rtx'), ('text/sgml', 'text/sgml'), ('text/strings', 'text/strings'), ('text/t140', 'text/t140'), ('text/tab-separated-values', 'text/tab-separated-values'), ('text/troff', 'text/troff'), ('text/turtle', 'text/turtle'), ('text/ulpfec', 'text/ulpfec'), ('text/uri-list', 'text/uri-list'), ('text/vcard', 'text/vcard'), ('text/vnd.a', 'text/vnd.a'), ('text/vnd.abc', 'text/vnd.abc'), ('text/vnd.ascii-art', 'text/vnd.ascii-art'), ('text/vnd.curl', 'text/vnd.curl'), ('text/vnd.debian.copyright', 'text/vnd.debian.copyright'), ('text/vnd.DMClientScript', 'text/vnd.DMClientScript'), ('text/vnd.dvb.subtitle', 'text/vnd.dvb.subtitle'), ('text/vnd.esmertec.theme-descriptor', 'text/vnd.esmertec.theme-descriptor'), ('text/vnd.fly', 'text/vnd.fly'), ('text/vnd.fmi.flexstor', 'text/vnd.fmi.flexstor'), ('text/vnd.graphviz', 'text/vnd.graphviz'), ('text/vnd.in3d.3dml', 'text/vnd.in3d.3dml'), ('text/vnd.in3d.spot', 'text/vnd.in3d.spot'), ('text/vnd.IPTC.NewsML', 'text/vnd.IPTC.NewsML'), ('text/vnd.IPTC.NITF', 'text/vnd.IPTC.NITF'), ('text/vnd.latex-z', 'text/vnd.latex-z'), ('text/vnd.motorola.reflex', 'text/vnd.motorola.reflex'), ('text/vnd.ms-mediapackage', 'text/vnd.ms-mediapackage'), ('text/vnd.net2phone.commcenter.command', 'text/vnd.net2phone.commcenter.command'), ('text/vnd.radisys.msml-basic-layout', 'text/vnd.radisys.msml-basic-layout'), ('text/vnd.si.uricatalogue', 'text/vnd.si.uricatalogue'), ('text/vnd.sun.j2me.app-descriptor', 'text/vnd.sun.j2me.app-descriptor'), ('text/vnd.trolltech.linguist', 'text/vnd.trolltech.linguist'), ('text/vnd.wap.si', 'text/vnd.wap.si'), ('text/vnd.wap.sl', 'text/vnd.wap.sl'), ('text/vnd.wap.wml', 'text/vnd.wap.wml'), ('text/vnd.wap.wmlscript', 'text/vnd.wap.wmlscript'), ('text/xml', 'text/xml'), ('text/xml-external-parsed-entity', 'text/xml-external-parsed-entity'), ('video/1d-interleaved-parityfec', 'video/1d-interleaved-parityfec'), ('video/3gpp', 'video/3gpp'), ('video/3gpp2', 'video/3gpp2'), ('video/3gpp-tt', 'video/3gpp-tt'), ('video/BMPEG', 'video/BMPEG'), ('video/BT656', 'video/BT656'), ('video/CelB', 'video/CelB'), ('video/DV', 'video/DV'), ('video/encaprtp', 'video/encaprtp'), ('video/example', 'video/example'), ('video/H261', 'video/H261'), ('video/H263', 'video/H263'), ('video/H263-1998', 'video/H263-1998'), ('video/H263-2000', 'video/H263-2000'), ('video/H264', 'video/H264'), ('video/H264-RCDO', 'video/H264-RCDO'), ('video/H264-SVC', 'video/H264-SVC'), ('video/H265', 'video/H265'), ('video/iso.segment', 'video/iso.segment'), ('video/JPEG', 'video/JPEG'), ('video/jpeg2000', 'video/jpeg2000'), ('video/mj2', 'video/mj2'), ('video/MP1S', 'video/MP1S'), ('video/MP2P', 'video/MP2P'), ('video/MP2T', 'video/MP2T'), ('video/mp4', 'video/mp4'), ('video/MP4V-ES', 'video/MP4V-ES'), ('video/MPV', 'video/MPV'), ('video/mpeg', 'video/mpeg'), ('video/mpeg4-generic', 'video/mpeg4-generic'), ('video/nv', 'video/nv'), ('video/ogg', 'video/ogg'), ('video/parityfec', 'video/parityfec'), ('video/pointer', 'video/pointer'), ('video/quicktime', 'video/quicktime'), ('video/raptorfec', 'video/raptorfec'), ('video/raw', 'video/raw'), ('video/rtp-enc-aescm128', 'video/rtp-enc-aescm128'), ('video/rtploopback', 'video/rtploopback'), ('video/rtx', 'video/rtx'), ('video/SMPTE292M', 'video/SMPTE292M'), ('video/ulpfec', 'video/ulpfec'), ('video/vc1', 'video/vc1'), ('video/vnd.CCTV', 'video/vnd.CCTV'), ('video/vnd.dece.hd', 'video/vnd.dece.hd'), ('video/vnd.dece.mobile', 'video/vnd.dece.mobile'), ('video/vnd.dece.mp4', 'video/vnd.dece.mp4'), ('video/vnd.dece.pd', 'video/vnd.dece.pd'), ('video/vnd.dece.sd', 'video/vnd.dece.sd'), ('video/vnd.dece.video', 'video/vnd.dece.video'), ('video/vnd.directv.mpeg', 'video/vnd.directv.mpeg'), ('video/vnd.directv.mpeg-tts', 'video/vnd.directv.mpeg-tts'), ('video/vnd.dlna.mpeg-tts', 'video/vnd.dlna.mpeg-tts'), ('video/vnd.dvb.file', 'video/vnd.dvb.file'), ('video/vnd.fvt', 'video/vnd.fvt'), ('video/vnd.hns.video', 'video/vnd.hns.video'), ('video/vnd.iptvforum.1dparityfec-1010', 'video/vnd.iptvforum.1dparityfec-1010'), ('video/vnd.iptvforum.1dparityfec-2005', 'video/vnd.iptvforum.1dparityfec-2005'), ('video/vnd.iptvforum.2dparityfec-1010', 'video/vnd.iptvforum.2dparityfec-1010'), ('video/vnd.iptvforum.2dparityfec-2005', 'video/vnd.iptvforum.2dparityfec-2005'), ('video/vnd.iptvforum.ttsavc', 'video/vnd.iptvforum.ttsavc'), ('video/vnd.iptvforum.ttsmpeg2', 'video/vnd.iptvforum.ttsmpeg2'), ('video/vnd.motorola.video', 'video/vnd.motorola.video'), ('video/vnd.motorola.videop', 'video/vnd.motorola.videop'), ('video/vnd.mpegurl', 'video/vnd.mpegurl'), ('video/vnd.ms-playready.media.pyv', 'video/vnd.ms-playready.media.pyv'), ('video/vnd.nokia.interleaved-multimedia', 'video/vnd.nokia.interleaved-multimedia'), ('video/vnd.nokia.videovoip', 'video/vnd.nokia.videovoip'), ('video/vnd.objectvideo', 'video/vnd.objectvideo'), ('video/vnd.radgamettools.bink', 'video/vnd.radgamettools.bink'), ('video/vnd.radgamettools.smacker', 'video/vnd.radgamettools.smacker'), ('video/vnd.sealed.mpeg1', 'video/vnd.sealed.mpeg1'), ('video/vnd.sealed.mpeg4', 'video/vnd.sealed.mpeg4'), ('video/vnd.sealed.swf', 'video/vnd.sealed.swf'), ('video/vnd.sealedmedia.softseal.mov', 'video/vnd.sealedmedia.softseal.mov'), ('video/vnd.uvvu.mp4', 'video/vnd.uvvu.mp4'), ('video/vnd.vivo', 'video/vnd.vivo'), ('video/VP8', 'video/VP8')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='recipientcountry',
            name='country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='The country that benefits from the project.', max_length=2, verbose_name='recipient country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='recipientregion',
            name='region',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='This identifies the region in which the activity takes place. Regions can be supra-national (a geographical or administrative grouping of countries into a region - e.g. Sub-Saharan Africa, Mekong Delta) or \'global\' (activities benefiting substantially all developing countries). For the codes to use, please see <a href="http://iatistandard.org/202/codelists/Region/" target="_blank">http://iatistandard.org/202/codelists/Region/</a>.', max_length=25, verbose_name='recipient region', choices=[('88', '88 - States Ex-Yugoslavia unspecified'), ('89', '89 - Europe, regional'), ('189', '189 - North of Sahara, regional'), ('289', '289 - South of Sahara, regional'), ('298', '298 - Africa, regional'), ('380', '380 - West Indies, regional'), ('389', '389 - North & Central America, regional'), ('489', '489 - South America, regional'), ('498', '498 - America, regional'), ('589', '589 - Middle East, regional'), ('619', '619 - Central Asia, regional'), ('679', '679 - South Asia, regional'), ('689', '689 - South & Central Asia, regional'), ('789', '789 - Far East Asia, regional'), ('798', '798 - Asia, regional'), ('889', '889 - Oceania, regional'), ('998', '998 - Developing countries, unspecified')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='transaction',
            name='finance_type',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='For reference, please visit: <a href="http://iatistandard.org/202/codelists/FinanceType/" target="_blank">http://iatistandard.org/202/codelists/FinanceType/</a>.', max_length=3, verbose_name='transaction finance type', choices=[('110', '110 - Standard grant'), ('111', '111 - Subsidies to national private investors'), ('210', '210 - Interest subsidy'), ('211', '211 - Interest subsidy to national private exporters'), ('310', '310 - Capital subscription on deposit basis'), ('311', '311 - Capital subscription on encashment basis'), ('410', '410 - Aid loan excluding debt reorganisation'), ('411', '411 - Investment-related loan to developing countries'), ('412', '412 - Loan in a joint venture with the recipient'), ('413', '413 - Loan to national private investor'), ('414', '414 - Loan to national private exporter'), ('421', '421 - Standard loan'), ('422', '422 - Reimbursable grant'), ('423', '423 - Bonds'), ('424', '424 - Asset-backed securities'), ('425', '425 - Other debt securities'), ('431', '431 - Subordinated loan'), ('432', '432 - Preferred equity'), ('433', '433 - Other hybrid instruments'), ('451', '451 - Non-banks guaranteed export credits'), ('452', '452 - Non-banks non-guaranteed portions of guaranteed export credits'), ('453', '453 - Bank export credits'), ('510', '510 - Common equity'), ('511', '511 - Acquisition of equity not part of joint venture in developing countries'), ('512', '512 - Other acquisition of equity'), ('520', '520 - Shares in collective investment vehicles'), ('530', '530 - Reinvested earnings'), ('610', '610 - Debt forgiveness/conversion: ODA claims (P)'), ('611', '611 - Debt forgiveness/conversion: ODA claims (I)'), ('612', '612 - Debt forgiveness/conversion: OOF claims (P)'), ('613', '613 - Debt forgiveness/conversion: OOF claims (I)'), ('614', '614 - Debt forgiveness/conversion: Private claims (P)'), ('615', '615 - Debt forgiveness/conversion: Private claims (I)'), ('616', '616 - Debt forgiveness: OOF claims (DSR)'), ('617', '617 - Debt forgiveness: Private claims (DSR)'), ('618', '618 - Debt forgiveness: Other'), ('620', '620 - Debt rescheduling: ODA claims (P)'), ('621', '621 - Debt rescheduling: ODA claims (I)'), ('622', '622 - Debt rescheduling: OOF claims (P)'), ('623', '623 - Debt rescheduling: OOF claims (I)'), ('624', '624 - Debt rescheduling: Private claims (P)'), ('625', '625 - Debt rescheduling: Private claims (I)'), ('626', '626 - Debt rescheduling: OOF claims (DSR)'), ('627', '627 - Debt rescheduling: Private claims (DSR)'), ('630', '630 - Debt rescheduling: OOF claim (DSR \u2013 original loan principal)'), ('631', '631 - Debt rescheduling: OOF claim (DSR \u2013 original loan interest)'), ('632', '632 - Debt rescheduling: Private claim (DSR \u2013 original loan principal)'), ('633', '633 - Debt forgiveness/conversion: export credit claims (P)'), ('634', '634 - Debt forgiveness/conversion: export credit claims (I)'), ('635', '635 - Debt forgiveness: export credit claims (DSR)'), ('636', '636 - Debt rescheduling: export credit claims (P)'), ('637', '637 - Debt rescheduling: export credit claims (I)'), ('638', '638 - Debt rescheduling: export credit claims (DSR)'), ('639', '639 - Debt rescheduling: export credit claim (DSR \u2013 original loan principal)'), ('710', '710 - Foreign direct investment'), ('711', '711 - Other foreign direct investment, including reinvested earnings'), ('810', '810 - Bank bonds'), ('811', '811 - Non-bank bonds'), ('910', '910 - Other bank securities/claims'), ('911', '911 - Other non-bank securities/claims'), ('912', '912 - Securities and other instruments issued by multilateral agencies')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='transaction',
            name='flow_type',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='For reference, please visit: <a href="http://iatistandard.org/202/codelists/FlowType/" target="_blank">http://iatistandard.org/202/codelists/FlowType/</a>.', max_length=2, verbose_name='transaction flow type', choices=[('10', '10 - ODA'), ('20', '20 - OOF'), ('21', '21 - Non-export credit OOF'), ('22', '22 - Officially supported export credits'), ('30', '30 - Private grants'), ('35', '35 - Private market'), ('36', '36 - Private Foreign Direct Investment'), ('37', '37 - Other Private flows at market terms'), ('40', '40 - Non flow'), ('50', '50 - Other flows')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='transaction',
            name='recipient_country',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='Enter the country that will benefit from this transaction. It can only be one country per transaction. For reference, please visit: <a href="http://iatistandard.org/202/codelists/Country/" target="_blank">http://iatistandard.org/202/codelists/Country/</a>.', max_length=2, verbose_name='transaction recipient country', choices=[('AF', 'Afghanistan'), ('AX', '\xc5land Islands'), ('AL', 'Albania'), ('DZ', 'Algeria'), ('AS', 'American Samoa'), ('AD', 'Andorra'), ('AO', 'Angola'), ('AI', 'Anguilla'), ('AQ', 'Antarctica'), ('AG', 'Antigua and Barbuda'), ('AR', 'Argentina'), ('AM', 'Armenia'), ('AW', 'Aruba'), ('AU', 'Australia'), ('AT', 'Austria'), ('AZ', 'Azerbaijan'), ('BS', 'Bahamas (The)'), ('BH', 'Bahrain'), ('BD', 'Bangladesh'), ('BB', 'Barbados'), ('BY', 'Belarus'), ('BE', 'Belgium'), ('BZ', 'Belize'), ('BJ', 'Benin'), ('BM', 'Bermuda'), ('BT', 'Bhutan'), ('BO', 'Bolivia (Plurinational State Of)'), ('BQ', 'Bonaire, Saint Eustatius and Saba'), ('BA', 'Bosnia and Herzegovina'), ('BW', 'Botswana'), ('BV', 'Bouvet Island'), ('BR', 'Brazil'), ('IO', 'British Indian Ocean Territory (The)'), ('BN', 'Brunei Darussalam'), ('BG', 'Bulgaria'), ('BF', 'Burkina Faso'), ('BI', 'Burundi'), ('KH', 'Cambodia'), ('CM', 'Cameroon'), ('CA', 'Canada'), ('CV', 'Cape Verde'), ('KY', 'Cayman Islands (The)'), ('CF', 'Central African Republic (The)'), ('TD', 'Chad'), ('CL', 'Chile'), ('CN', 'China'), ('CX', 'Christmas Island'), ('CC', 'Cocos (Keeling) Islands (The)'), ('CO', 'Colombia'), ('KM', 'Comoros (The)'), ('CG', 'Congo (The)'), ('CD', 'Congo, The Democratic Republic of the'), ('CK', 'Cook Islands (The)'), ('CR', 'Costa Rica'), ('CI', "C\xf4te D'ivoire"), ('HR', 'Croatia'), ('CU', 'Cuba'), ('CW', 'Cura\xe7ao'), ('CY', 'Cyprus'), ('CZ', 'Czech Republic (The)'), ('DK', 'Denmark'), ('DJ', 'Djibouti'), ('DM', 'Dominica'), ('DO', 'Dominican Republic (The)'), ('EC', 'Ecuador'), ('EG', 'Egypt'), ('SV', 'El Salvador'), ('GQ', 'Equatorial Guinea'), ('ER', 'Eritrea'), ('EE', 'Estonia'), ('ET', 'Ethiopia'), ('FK', 'Falkland Islands (The) [malvinas]'), ('FO', 'Faroe Islands (The)'), ('FJ', 'Fiji'), ('FI', 'Finland'), ('FR', 'France'), ('GF', 'French Guiana'), ('PF', 'French Polynesia'), ('TF', 'French Southern Territories (The)'), ('GA', 'Gabon'), ('GM', 'Gambia (The)'), ('GE', 'Georgia'), ('DE', 'Germany'), ('GH', 'Ghana'), ('GI', 'Gibraltar'), ('GR', 'Greece'), ('GL', 'Greenland'), ('GD', 'Grenada'), ('GP', 'Guadeloupe'), ('GU', 'Guam'), ('GT', 'Guatemala'), ('GG', 'Guernsey'), ('GN', 'Guinea'), ('GW', 'Guinea-Bissau'), ('GY', 'Guyana'), ('HT', 'Haiti'), ('HM', 'Heard Island and Mcdonald Islands'), ('VA', 'Holy See (The)'), ('HN', 'Honduras'), ('HK', 'Hong Kong'), ('HU', 'Hungary'), ('IS', 'Iceland'), ('IN', 'India'), ('ID', 'Indonesia'), ('IR', 'Iran (Islamic Republic Of)'), ('IQ', 'Iraq'), ('IE', 'Ireland'), ('IM', 'Isle of Man'), ('IL', 'Israel'), ('IT', 'Italy'), ('JM', 'Jamaica'), ('JP', 'Japan'), ('JE', 'Jersey'), ('JO', 'Jordan'), ('KZ', 'Kazakhstan'), ('KE', 'Kenya'), ('KI', 'Kiribati'), ('KP', "Korea (Democratic People's Republic Of)"), ('KR', 'Korea (Republic Of)'), ('XK', 'Kosovo'), ('KW', 'Kuwait'), ('KG', 'Kyrgyzstan'), ('LA', "Lao People's Democratic Republic (The)"), ('LV', 'Latvia'), ('LB', 'Lebanon'), ('LS', 'Lesotho'), ('LR', 'Liberia'), ('LY', 'Libyan Arab Jamahiriya'), ('LI', 'Liechtenstein'), ('LT', 'Lithuania'), ('LU', 'Luxembourg'), ('MO', 'Macao'), ('MK', 'Macedonia (The Former Yugoslav Republic Of)'), ('MG', 'Madagascar'), ('MW', 'Malawi'), ('MY', 'Malaysia'), ('MV', 'Maldives'), ('ML', 'Mali'), ('MT', 'Malta'), ('MH', 'Marshall Islands (The)'), ('MQ', 'Martinique'), ('MR', 'Mauritania'), ('MU', 'Mauritius'), ('YT', 'Mayotte'), ('MX', 'Mexico'), ('FM', 'Micronesia (Federated States Of)'), ('MD', 'Moldova (Republic Of)'), ('MC', 'Monaco'), ('MN', 'Mongolia'), ('ME', 'Montenegro'), ('MS', 'Montserrat'), ('MA', 'Morocco'), ('MZ', 'Mozambique'), ('MM', 'Myanmar'), ('NA', 'Namibia'), ('NR', 'Nauru'), ('NP', 'Nepal'), ('NL', 'Netherlands (The)'), ('AN', 'Netherland Antilles'), ('NC', 'New Caledonia'), ('NZ', 'New Zealand'), ('NI', 'Nicaragua'), ('NE', 'Niger (The)'), ('NG', 'Nigeria'), ('NU', 'Niue'), ('NF', 'Norfolk Island'), ('MP', 'Northern Mariana Islands (The)'), ('NO', 'Norway'), ('OM', 'Oman'), ('PK', 'Pakistan'), ('PW', 'Palau'), ('PS', 'Palestinian Territory, Occupied'), ('PA', 'Panama'), ('PG', 'Papua New Guinea'), ('PY', 'Paraguay'), ('PE', 'Peru'), ('PH', 'Philippines (The)'), ('PN', 'Pitcairn'), ('PL', 'Poland'), ('PT', 'Portugal'), ('PR', 'Puerto Rico'), ('QA', 'Qatar'), ('RE', 'Reunion'), ('RO', 'Romania'), ('RU', 'Russian Federation (The)'), ('RW', 'Rwanda'), ('BL', 'Saint Barth\xe9lemy'), ('SH', 'Saint Helena, Ascension and Tristan da Cunha'), ('KN', 'Saint Kitts and Nevis'), ('LC', 'Saint Lucia'), ('MF', 'Saint Martin (French Part)'), ('PM', 'Saint Pierre and Miquelon'), ('VC', 'Saint Vincent and the Grenadines'), ('WS', 'Samoa'), ('SM', 'San Marino'), ('ST', 'Sao Tome and Principe'), ('SA', 'Saudi Arabia'), ('SN', 'Senegal'), ('RS', 'Serbia'), ('SC', 'Seychelles'), ('SL', 'Sierra Leone'), ('SG', 'Singapore'), ('SX', 'Sint Maarten (Dutch Part)'), ('SK', 'Slovakia'), ('SI', 'Slovenia'), ('SB', 'Solomon Islands'), ('SO', 'Somalia'), ('ZA', 'South Africa'), ('GS', 'South Georgia and the South Sandwich Islands'), ('SS', 'South Sudan'), ('ES', 'Spain'), ('LK', 'Sri Lanka'), ('SD', 'Sudan (The)'), ('SR', 'Suriname'), ('SJ', 'Svalbard and Jan Mayen'), ('SZ', 'Swaziland'), ('SE', 'Sweden'), ('CH', 'Switzerland'), ('SY', 'Syrian Arab Republic'), ('TW', 'Taiwan (Province of China)'), ('TJ', 'Tajikistan'), ('TZ', 'Tanzania, United Republic of'), ('TH', 'Thailand'), ('TL', 'Timor-Leste'), ('TG', 'Togo'), ('TK', 'Tokelau'), ('TO', 'Tonga'), ('TT', 'Trinidad and Tobago'), ('TN', 'Tunisia'), ('TR', 'Turkey'), ('TM', 'Turkmenistan'), ('TC', 'Turks and Caicos Islands (The)'), ('TV', 'Tuvalu'), ('UG', 'Uganda'), ('UA', 'Ukraine'), ('AE', 'United Arab Emirates (The)'), ('GB', 'United Kingdom of Great Britain and Northern Ireland (The)'), ('US', 'United States of America (The)'), ('UM', 'United States Minor Outlying Islands (The)'), ('UY', 'Uruguay'), ('UZ', 'Uzbekistan'), ('VU', 'Vanuatu'), ('VE', 'Venezuela (Bolivarian Republic Of)'), ('VN', 'Viet Nam'), ('VG', 'Virgin Islands (British)'), ('VI', 'Virgin Islands (U.s.)'), ('WF', 'Wallis and Futuna'), ('EH', 'Western Sahara'), ('YE', 'Yemen'), ('ZM', 'Zambia'), ('ZW', 'Zimbabwe')]),
            preserve_default=True,
        ),
        migrations.AlterField(
            model_name='transaction',
            name='recipient_region',
            field=akvo.rsr.fields.ValidXMLCharField(blank=True, help_text='Enter the supranational geopolitical region (a geographical or administrative grouping of countries into a region - e.g. Sub-Saharan Africa, Mekong Delta) that will benefit from this transaction. For reference, please visit: <a href="http://iatistandard.org/202/codelists/Region/" target="_blank">http://iatistandard.org/202/codelists/Region/</a>.', max_length=25, verbose_name='transaction recipient region', choices=[('88', '88 - States Ex-Yugoslavia unspecified'), ('89', '89 - Europe, regional'), ('189', '189 - North of Sahara, regional'), ('289', '289 - South of Sahara, regional'), ('298', '298 - Africa, regional'), ('380', '380 - West Indies, regional'), ('389', '389 - North & Central America, regional'), ('489', '489 - South America, regional'), ('498', '498 - America, regional'), ('589', '589 - Middle East, regional'), ('619', '619 - Central Asia, regional'), ('679', '679 - South Asia, regional'), ('689', '689 - South & Central Asia, regional'), ('789', '789 - Far East Asia, regional'), ('798', '798 - Asia, regional'), ('889', '889 - Oceania, regional'), ('998', '998 - Developing countries, unspecified')]),
            preserve_default=True,
        ),
    ]
