# -*- coding: utf-8 -*-

from django.utils.translation import ugettext_lazy as _

codelist_list = [
    "BUDGET_IDENTIFIER",
    "POLICY_MARKER",
    "TIED_STATUS",
    "AID_TYPE",
    "INDICATOR_MEASURE",
    "CONTACT_TYPE",
    "GEOGRAPHIC_EXACTNESS",
    "TRANSACTION_TYPE",
    "FINANCE_TYPE",
    "POLICY_SIGNIFICANCE",
    "LOCATION_TYPE",
    "ACTIVITY_SCOPE",
    "GEOGRAPHIC_LOCATION_REACH",
    "REGION",
    "LOAN_REPAYMENT_PERIOD",
    "ACTIVITY_STATUS",
    "SECTOR",
    "VERSION",
    "ORGANISATION_ROLE",
    "OTHER_IDENTIFIER_TYPE",
    "DOCUMENT_CATEGORY",
    "PUBLISHER_TYPE",
    "HUMANITARIAN_SCOPE_TYPE",
    "C_R_S_CHANNEL_CODE",
    "BUDGET_IDENTIFIER_SECTOR_CATEGORY",
    "GEOGRAPHICAL_PRECISION",
    "ORGANISATION_REGISTRATION_AGENCY",
    "RESULT_TYPE",
    "ORGANISATION_TYPE",
    "AID_TYPE_CATEGORY",
    "ACTIVITY_DATE_TYPE",
    "SECTOR_CATEGORY",
    "SECTOR_VOCABULARY",
    "FINANCE_TYPE_CATEGORY",
    "DOCUMENT_CATEGORY_CATEGORY",
    "REGION_VOCABULARY",
    "LANGUAGE",
    "LOAN_REPAYMENT_TYPE",
    "HUMANITARIAN_SCOPE_VOCABULARY",
    "INDICATOR_VOCABULARY",
    "DISBURSEMENT_CHANNEL",
    "GAZETTEER_AGENCY",
    "GEOGRAPHIC_LOCATION_CLASS",
    "CONDITION_TYPE",
    "BUDGET_IDENTIFIER_VOCABULARY",
    "DESCRIPTION_TYPE",
    "CURRENCY",
    "FLOW_TYPE",
    "VERIFICATION_STATUS",
    "LOCATION_TYPE_CATEGORY",
    "POLICY_MARKER_VOCABULARY",
    "BUDGET_IDENTIFIER_SECTOR",
    "COUNTRY",
    "GEOGRAPHIC_VOCABULARY",
    "BUDGET_TYPE",
    "C_R_S_ADD_OTHER_FLAGS",
    "COLLABORATION_TYPE",
    "BUDGET_STATUS",
    "ORGANISATION_IDENTIFIER",
    "RELATED_ACTIVITY_TYPE",
    "FILE_FORMAT"
]

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetIdentifier.xml
BUDGET_IDENTIFIER = (
    ("category", "code", "name"),
    ("1.1", "1.1.1", "Executive - executive"),
    ("1.2", "1.2.1", "Legislative - legislative"),
    ("1.3", "1.3.1", "Accountability - macroeconomic policy"),
    ("1.3", "1.3.2", "Accountability - budgeting"),
    ("1.3", "1.3.3", "Accountability - planning"),
    ("1.3", "1.3.4", "Accountability - Treasury/Accounts"),
    ("1.3", "1.3.5", "Accountability - debt and aid management"),
    ("1.3", "1.3.6", "Accountability - tax policy"),
    ("1.3", "1.3.7", "Accountability - tax collection"),
    ("1.3", "1.3.8", "Accountability - local government finance"),
    ("1.3", "1.3.9", "Accountability - other central transfers to institutions "),
    ("1.3", "1.3.10", "Accountability - national audit"),
    ("1.3", "1.3.11", "Accountability - national monitoring and evaluation"),
    ("1.3", "1.3.12", "Accountability - monetary institutions"),
    ("1.3", "1.3.13", "Accountability - financial sector policy and regulation"),
    ("1.4", "1.4.1", "External Affairs - foreign affairs "),
    ("1.4", "1.4.2", "External Affairs - diplomatic missions"),
    ("1.4", "1.4.3", "External Affairs - official development assistance"),
    ("1.5", "1.5.1", "General Personnel Services - general personnel services"),
    ("1.6", "1.6.1", "Statistics - statistics"),
    ("1.7", "1.7.1", "Other General Services - support to civil society "),
    ("1.7", "1.7.2", "Other General Services - central procurement"),
    ("1.7", "1.7.3", "Other General Services - Local Government Administration"),
    ("1.7", "1.7.4", "Other General Services - other general services"),
    ("1.8", "1.8.1", "Elections - elections"),
    ("2.1", "2.1.1", "Justice, Law and Order - policy, planning and administration"),
    ("2.1", "2.1.2", "Justice, Law and Order - police"),
    ("2.1", "2.1.2", "Justice, Law and Order - fire"),
    ("2.1", "2.1.3", "Justice, Law and Order - judicial affairs"),
    ("2.1", "2.1.4", "Justice, Law and Order - Ombudsman"),
    ("2.1", "2.1.5", "Justice, Law and Order - human rights affairs"),
    ("2.1", "2.1.6", "Justice, Law and Order - immigration"),
    ("2.1", "2.1.7", "Justice, Law and Order - anti corruption"),
    ("2.1", "2.1.8", "Justice, Law and Order - prisons"),
    ("2.1", "2.1.9", "Justice, Law and Order - peace building"),
    ("2.1", "2.1.10", "Justice, Law and Order - demobilisation"),
    ("2.2", "2.2.1", "Defence - policy, planning and administration"),
    ("2.2", "2.2.2", "Defence - military"),
    ("2.2", "2.2.3", "Defence - civil defence"),
    ("2.2", "2.2.4", "Defence - foreign military aid"),
    ("3.1", "3.1.1", "General Economic, Commercial and Labour Affairs - policy, planning and administration"),
    ("3.1", "3.1.2", "General Economic, Commercial and Labour Affairs - general economic affairs"),
    ("3.1", "3.1.3", "General Economic, Commercial and Labour Affairs - investment promotion"),
    ("3.1", "3.1.4", "General Economic, Commercial and Labour Affairs - privatisation"),
    ("3.1", "3.1.5", "General Economic, Commercial and Labour Affairs - trade"),
    ("3.1", "3.1.6", "General Economic, Commercial and Labour Affairs - labour"),
    ("3.1", "3.1.7", "General Economic, Commercial and Labour Affairs - national standards development"),
    ("3.2", "3.2.1", "Public Works - policy, planning and administration"),
    ("3.2", "3.2.2", "Public Works - construction regulation"),
    ("3.2", "3.2.3", "Public Works - mechanical services"),
    ("3.3", "3.3.1", "Agriculture - policy, planning and administration"),
    ("3.3", "3.3.2", "Agriculture - irrigation"),
    ("3.3", "3.3.3", "Agriculture - inputs"),
    ("3.3", "3.3.4", "Agriculture - food crop"),
    ("3.3", "3.3.5", "Agriculture - industrial crop"),
    ("3.3", "3.3.6", "Agriculture - livestock"),
    ("3.3", "3.3.7", "Agriculture - agricultural training and extension"),
    ("3.3", "3.3.8", "Agriculture - research"),
    ("3.3", "3.3.9", "Agriculture - other services"),
    ("3.4", "3.4.1", "Forestry - policy, planning and administration"),
    ("3.4", "3.4.2", "Forestry - development and services"),
    ("3.4", "3.4.3", "Forestry - education/training"),
    ("3.4", "3.4.4", "Forestry - research"),
    ("3.5", "3.5.1", "Fishing and Hunting - policy, planning and administration"),
    ("3.5", "3.5.2", "Fishing and Hunting - development and services"),
    ("3.5", "3.5.3", "Fishing and Hunting - education and training"),
    ("3.5", "3.5.4", "Fishing and Hunting - research"),
    ("3.6", "3.6.1", "Energy - policy, planning and administration"),
    ("3.6", "3.6.2", "Energy - education and training"),
    ("3.6", "3.6.3", "Energy - energy regulation"),
    ("3.6", "3.6.4", "Energy - electricity transmission"),
    ("3.6", "3.6.5", "Energy - nuclear"),
    ("3.6", "3.6.6", "Energy - power generation"),
    ("3.6", "3.6.7", "Energy - gas "),
    ("3.7", "3.7.1", "Mining and Mineral Development - policy, planning and administration"),
    ("3.7", "3.7.2", "Mining and Mineral Development - prospection and exploration"),
    ("3.7", "3.7.3", "Mining and Mineral Development - coal and other solid mineral fuels"),
    ("3.7", "3.7.4", "Mining and Mineral Development - petroleum and gas"),
    ("3.7", "3.7.6", "Mining and Mineral Development - other fuel"),
    ("3.7", "3.7.7", "Mining and Mineral Development - non fuel minerals"),
    ("3.8", "3.8.1", "Transport - policy, planning and administration"),
    ("3.8", "3.8.2", "Transport - transport regulation"),
    ("3.8", "3.8.3", "Transport - feeder road construction"),
    ("3.8", "3.8.4", "Transport - feeder road maintenance"),
    ("3.8", "3.8.5", "Transport - national road construction"),
    ("3.8", "3.8.6", "Transport - national road maintenance"),
    ("3.8", "3.8.7", "Transport - rail"),
    ("3.8", "3.8.8", "Transport - water"),
    ("3.8", "3.8.9", "Transport - air"),
    ("3.8", "3.8.10", "Transport - pipeline"),
    ("3.8", "3.8.11", "Transport - storage and distribution"),
    ("3.8", "3.8.12", "Transport - public transport services"),
    ("3.8", "3.8.13", "Transport - meteorological services"),
    ("3.8", "3.8.14", "Transport - education and training"),
    ("3.9", "3.9.1", "Industry - policy, planning and administration"),
    ("3.9", "3.9.2", "Industry - development and services"),
    ("3.9", "3.9.3", "Industry - industrial research"),
    ("3.9", "3.9.4", "Industry - (investment in industry)"),
    ("3.10", "3.10.1", "Communications - policy, planning and administration"),
    ("3.10", "3.10.2", "Communications - ICT Infrastructure"),
    ("3.10", "3.10.3", "Communications - telecoms and postal services"),
    ("3.10", "3.10.4", "Communications - information services"),
    ("3.11", "3.11.1", "Tourism - policy, planning and administration"),
    ("3.11", "3.11.2", "Tourism - services"),
    ("3.12", "3.12.1", "Microfinance and financial services - Microfinance and financial services"),
    ("4.1", "4.1.1", "Water supply and Sanitation - policy, planning and administration"),
    ("4.1", "4.1.2", "Water supply and Sanitation - education/training"),
    ("4.1", "4.1.3", "Water supply and Sanitation - rural water supply and sanitation"),
    ("4.1", "4.1.4", "Water supply and Sanitation - urban water supply and sanitation"),
    ("4.1", "4.1.5", "Water supply and Sanitation - rural water supply"),
    ("4.1", "4.1.6", "Water supply and Sanitation - urban water supply"),
    ("4.1", "4.1.7", "Water supply and Sanitation - rural sanitation"),
    ("4.1", "4.1.8", "Water supply and Sanitation - urban sanitation"),
    ("4.1", "4.1.9", "Water supply and Sanitation - sewage and waste management"),
    ("4.2", "4.2.1", "Environment - policy, planning and administration"),
    ("4.2", "4.2.2", "Environment - research/ education and training"),
    ("4.2", "4.2.3", "Environment - natural resource management"),
    ("4.2", "4.2.4", "Environment - water resources management"),
    ("4.2", "4.2.5", "Environment - wildlife protection, parks and site preservation"),
    ("5.1", "5.1.1", "Health - policy, planning and administration"),
    ("5.2", "5.2.1", "Recreation, Culture and Religion - recreation and sport"),
    ("5.2", "5.2.2", "Recreation, Culture and Religion - culture"),
    ("5.2", "5.2.3", "Recreation, Culture and Religion - broadcasting and publishing"),
    ("5.2", "5.2.4", "Recreation, Culture and Religion - religion"),
    ("5.3", "5.3.1", "Education - administration, policy and planning"),
    ("5.3", "5.3.2", "Education - research"),
    ("5.3", "5.3.3", "Education - pre-primary"),
    ("5.3", "5.3.4", "Education - primary"),
    ("5.3", "5.3.5", "Education - lower secondary"),
    ("5.3", "5.3.6", "Education - upper secondary"),
    ("5.3", "5.3.7", "Education - post secondary non tertiary "),
    ("5.3", "5.3.8", "Education - tertiary"),
    ("5.3", "5.3.9", "Education - vocational training"),
    ("5.3", "5.3.10", "Education - advanced technical and managerial training"),
    ("5.3", "5.3.11", "Education - basic adult education"),
    ("5.3", "5.3.12", "Education - teacher training"),
    ("5.3", "5.3.13", "Education - subsidiary services"),
    ("5.4", "5.4.1", "Social Protection, Land Housing and Community Amenities - policy, planning and administration"),
    ("5.4", "5.4.2", "Social Protection, Land Housing and Community Amenities - social security (excl pensions)"),
    ("5.4", "5.4.3", "Social Protection, Land Housing and Community Amenities - general pensions"),
    ("5.4", "5.4.4", "Social Protection, Land Housing and Community Amenities - civil service and military pensions"),
    ("5.4", "5.4.5", "Social Protection, Land Housing and Community Amenities - social services (incl youth development and women+ children)"),
    ("5.4", "5.4.6", "Social Protection, Land Housing and Community Amenities - land policy and management"),
    ("5.4", "5.4.7", "Social Protection, Land Housing and Community Amenities - rural devt"),
    ("5.4", "5.4.8", "Social Protection, Land Housing and Community Amenities - urban devt"),
    ("5.4", "5.4.9", "Social Protection, Land Housing and Community Amenities - housing and community amenities"),
    ("5.4", "5.4.10", "Social Protection, Land Housing and Community Amenities - emergency relief"),
    ("5.4", "5.4.11", "Social Protection, Land Housing and Community Amenities - disaster prevention and preparedness"),
    ("5.4", "5.4.12", "Social Protection, Land Housing and Community Amenities - support to refugees and internally displaced persons"),
    ("6.1", "6.1.1", "Development Partner affairs - policy planning and administration"),
    ("6.1", "6.1.2", "Development Partner affairs - Technical staff services"),
    ("7.1", "7.1.1", "External to government sector - External to general government sector"),
    ("7.2", "7.2.1", "General Budget Support - General Budget Support"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/PolicyMarker.xml
POLICY_MARKER = (
    ("code", "name"),
    ("1", "Gender Equality"),
    ("2", "Aid to Environment"),
    ("3", "Participatory Development/Good Governance"),
    ("4", "Trade Development"),
    ("5", "Aid Targeting the Objectives of the Convention on Biological Diversity"),
    ("6", "Aid Targeting the Objectives of the Framework Convention on Climate Change - Mitigation"),
    ("7", "Aid Targeting the Objectives of the Framework Convention on Climate Change - Adaptation"),
    ("8", "Aid Targeting the Objectives of the Convention to Combat Desertification"),
    ("9", "Reproductive, Maternal, Newborn and Child Health (RMNCH)"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/TiedStatus.xml
TIED_STATUS = (
    ("code", "name", "description"),
    ("3", "Partially tied", "Official Development Assistance for which the associated goods and services must be procured from a restricted number of countries, which must however include substantially all aid recipient countries and can include the donor country."),
    ("4", "Tied", "Official grants or loans where procurement of the goods or services involved is limited to the donor country or to a group of countries which does not include substantially all aid recipient countries."),
    ("5", "Untied", "Untied aid is defined as loans and grants whose proceeds are fully and freely available to finance procurement from all OECD countries and substantially all developing countries."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/AidType.xml
AID_TYPE = (
    ("category", "code", "name", "description"),
    ("A", "A01", "General budget support", "Unearmarked contributions to the government budget including funding to support the implementation of macroeconomic reforms (structural adjustment programmes, poverty reduction strategies).                Budget support is a method of financing a recipient country’s budget through a transfer of resources from an external financing agency to the recipient government’s national treasury. The funds thus transferred are managed in accordance with the recipient’s budgetary procedures. Funds transferred to the national treasury for financing programmes or projects managed according to different budgetary procedures from those of the recipient country, with the intention of earmarking the resources for specific uses, are therefore excluded."),
    ("A", "A02", "Sector budget support", "Sector budget support, like general budget support, is a financial contribution to a recipient government’s budget. However, in sector budget support, the dialogue between donors and partner governments focuses on sector-specific concerns, rather than on overall policy and budget priorities."),
    ("B", "B01", "Core support to NGOs, other private bodies, PPPs and research institutes", "Funds are paid over to NGOs (local, national and international) for use at the latter’s discretion, and contribute to programmes and activities which NGOs have developed themselves, and which they implement on their own authority and responsibility. Core contributions to PPPs, funds paid over to foundations (e.g. philanthropic foundations), and contributions to research institutes (public and private) are also recorded here. Annex 2 of the DAC Directives provides a list of INGOs, PPPs and networks core contributions to which may be reported under B01. This list is not exclusive."),
    ("B", "B02", "Core contributions to multilateral institutions", "These funds are classified as multilateral ODA (all other categories fall under bilateral ODA). The recipient multilateral institution pools contributions so that they lose their identity and become an integral part of its financial assets. See Annex 2 of the DAC Directives for a comprehensive list of agencies core contributions to which may be reported under B02 (Section I. Multilateral institutions)."),
    ("B", "B03", "Contributions to specific-purpose programmes and funds managed by international organisations (multilateral, INGO)", "In addition to their core-funded operations, international organisations set up and raise funds for specific programmes and funds with clearly identified sectoral, thematic or geographical focus. Donors’ bilateral contributions to such programmes and funds are recorded here, e.g. “UNICEF girls’ education”, “Education For All Fast Track Initiative”, various trust funds, including for reconstruction (e.g. Afghanistan Reconstruction Trust Fund)."),
    ("B", "B04", "Basket funds/pooled funding", "The donor contributes funds to an autonomous account, managed jointly with other donors and/or the recipient. The account will have specific purposes, modes of disbursement and accountability mechanisms, and a limited time frame. Basket funds are characterised by common project documents, common funding contracts and common reporting/audit procedures with all donors. Donors’ contributions to funds managed autonomously by international organisations are recorded under B03."),
    ("C", "C01", "Project-type interventions", "A project is a set of inputs, activities and outputs, agreed with the partner country*, to reach specific objectives/outcomes within a defined time frame, with a defined budget and a defined geographical area. Projects can vary significantly in terms of objectives, complexity, amounts involved and duration. There are smaller projects that might involve modest financial resources and last only a few months, whereas large projects might involve more significant amounts, entail successive phases and last for many years. A large project with a number of different components is sometimes referred to as a programme, but should nevertheless be recorded here. Feasibility studies, appraisals and evaluations are included (whether designed as part of projects/programmes or dedicated funding arrangements). Aid channelled through NGOs or multilaterals is also recorded here. This includes payments for NGOs and multilaterals to implement donors’ projects and programmes, and funding of specified NGOs projects. By contrast, core funding of NGOs and multilaterals as well as contributions to specific-purpose funds managed by international organisations are recorded under B. * In the cases of equity investments, humanitarian aid or aid channelled through NGOs, projects are recorded here even if there was no direct agreement between the donor and the partner country."),
    ("D", "D01", "Donor country personnel", "Experts, consultants, teachers, academics, researchers, volunteers and contributions to public and private bodies for sending experts to developing countries."),
    ("D", "D02", "Other technical assistance", "Provision, outside projects as described in category C01, of technical assistance in recipient countries (excluding technical assistance performed by donor experts reported under D01, and scholarships/training in donor country reported under E01). This includes training and research; language training; south-south studies; research studies; collaborative research between donor and recipient universities and organisations); local scholarships; development-oriented social and cultural programmes. This category also covers ad hoc contributions such as conferences, seminars and workshops, exchange visits, publications, etc."),
    ("E", "E01", "Scholarships/training in donor country", "Financial aid awards for individual students and contributions to trainees."),
    ("E", "E02", "Imputed student costs", "Indirect (“imputed”) costs of tuition in donor countries."),
    ("F", "F01", "Debt relief", "Groups all actions relating to debt (forgiveness, conversions, swaps, buy-backs, rescheduling, refinancing)."),
    ("G", "G01", "Administrative costs not included elsewhere", "Administrative costs of development assistance programmes not already included under other ODA items as an integral part of the costs of delivering or implementing the aid provided. This category covers situation analyses and auditing activities. As regards the salaries component of administrative costs, it relates to in-house agency staff and contractors only; costs associated with donor experts/consultants are to be reported under category C or D01."),
    ("H", "H01", "Development awareness", "Funding of activities designed to increase public support, i.e. awareness in the donor country of development co-operation efforts, needs and issues."),
    ("H", "H02", "Refugees in donor countries", "Official sector expenditures for the sustenance of refugees in donor countries during the first twelve months of their stay."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/IndicatorMeasure.xml
INDICATOR_MEASURE = (
    ("code", "name", "description"),
    ("1", _("Unit"), _("The indicator is measured in units.")),
    ("2", _("Percentage"), _("The indicator is measured in percentages")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ContactType.xml
CONTACT_TYPE = (
    ("code", "name", "description"),
    ("1", _("General Enquiries"), _("General Enquiries")),
    ("2", _("Project Management"), _("Project Management")),
    ("3", _("Financial Management"), _("Financial Management")),
    ("4", _("Communications"), _("Communications")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GeographicExactness.xml
GEOGRAPHIC_EXACTNESS = (
    ("code", "name", "description"),
    ("1", "Exact", "The designated geographic location is exact"),
    ("2", "Approximate", "The designated geographic location is approximate"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/TransactionType.xml
TRANSACTION_TYPE = (
    ("code", "name", "description"),
    ("1", "Incoming Funds", "Funds recieved for use on the activity, which can be from an external or internal source. "),
    ("2", "Commitment", "A firm, written obligation from a donor or provider to provide a specified amount of funds, under particular terms and conditions, for specific purposes, for the benefit of the recipient. "),
    ("3", "Disbursement", "Outgoing funds that are placed at the disposal of a recipient government or organisation, or funds transferred between two separately reported activities.Under IATI traceability standards the recipient of a disbursement should also be required to report their activities to IATI."),
    ("4", "Expenditure", "Outgoing funds that are spent on goods and services for the activity. The recipients of expenditures fall outside of IATI traceability standards."),
    ("5", "Interest Repayment", "The actual amount of interest paid on a loan or line of credit, including fees."),
    ("6", "Loan Repayment", "The actual amount of principal (amortisation) repaid, including any arrears. "),
    ("7", "Reimbursement", "A type of disbursement that covers funds that have already been spent by the recipient, as agreed in the terms of the grant or loan"),
    ("8", "Purchase of Equity", "Outgoing funds that are used to purchase equity in a business"),
    ("9", "Sale of Equity", "Incoming funds from the sale of equity. "),
    ("10", "Credit Guarantee", "A commitment made by a funding organisation to underwrite a loan or line of credit entered into by a third party. "),
    ("11", "Incoming Commitment", "A firm, written obligation from a donor or provider to provide a specified amount of funds, under particular terms and conditions, reported by a recipient for this activity."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/FinanceType.xml
FINANCE_TYPE = (
    ("category", "code", "name"),
    ("100", "110", "Standard grant"),
    ("100", "111", "Subsidies to national private investors"),
    ("100", "210", "Interest subsidy"),
    ("200", "211", "Interest subsidy to national private exporters"),
    ("100", "310", "Capital subscription on deposit basis"),
    ("100", "311", "Capital subscription on encashment basis"),
    ("400", "410", "Aid loan excluding debt reorganisation"),
    ("400", "411", "Investment-related loan to developing countries"),
    ("400", "412", "Loan in a joint venture with the recipient"),
    ("400", "413", "Loan to national private investor"),
    ("400", "414", "Loan to national private exporter"),
    ("420", "421", "Standard loan"),
    ("420", "422", "Reimbursable grant"),
    ("420", "423", "Bonds"),
    ("420", "424", "Asset-backed securities"),
    ("420", "425", "Other debt securities"),
    ("430", "431", "Subordinated loan"),
    ("430", "432", "Preferred equity"),
    ("430", "433", "Other hybrid instruments"),
    ("450", "451", "Non-banks guaranteed export credits"),
    ("450", "452", "Non-banks non-guaranteed portions of guaranteed export credits"),
    ("450", "453", "Bank export credits"),
    ("500", "510", "Common equity"),
    ("500", "511", "Acquisition of equity not part of joint venture in developing countries"),
    ("500", "512", "Other acquisition of equity"),
    ("500", "520", "Shares in collective investment vehicles"),
    ("500", "530", "Reinvested earnings"),
    ("600", "610", "Debt forgiveness/conversion: ODA claims (P)"),
    ("600", "611", "Debt forgiveness/conversion: ODA claims (I)"),
    ("600", "612", "Debt forgiveness/conversion: OOF claims (P)"),
    ("600", "613", "Debt forgiveness/conversion: OOF claims (I)"),
    ("600", "614", "Debt forgiveness/conversion: Private claims (P)"),
    ("600", "615", "Debt forgiveness/conversion: Private claims (I)"),
    ("600", "616", "Debt forgiveness: OOF claims (DSR)"),
    ("600", "617", "Debt forgiveness: Private claims (DSR)"),
    ("600", "618", "Debt forgiveness: Other"),
    ("600", "620", "Debt rescheduling: ODA claims (P)"),
    ("600", "621", "Debt rescheduling: ODA claims (I)"),
    ("600", "622", "Debt rescheduling: OOF claims (P)"),
    ("600", "623", "Debt rescheduling: OOF claims (I)"),
    ("600", "624", "Debt rescheduling: Private claims (P)"),
    ("600", "625", "Debt rescheduling: Private claims (I)"),
    ("600", "626", "Debt rescheduling: OOF claims (DSR)"),
    ("600", "627", "Debt rescheduling: Private claims (DSR)"),
    ("600", "630", "Debt rescheduling: OOF claim (DSR – original loan principal)"),
    ("600", "631", "Debt rescheduling: OOF claim (DSR – original loan interest)"),
    ("600", "632", "Debt rescheduling: Private claim (DSR – original loan principal)"),
    ("600", "633", "Debt forgiveness/conversion: export credit claims (P)"),
    ("600", "634", "Debt forgiveness/conversion: export credit claims (I)"),
    ("600", "635", "Debt forgiveness: export credit claims (DSR)"),
    ("600", "636", "Debt rescheduling: export credit claims (P)"),
    ("600", "637", "Debt rescheduling: export credit claims (I)"),
    ("600", "638", "Debt rescheduling: export credit claims (DSR)"),
    ("600", "639", "Debt rescheduling: export credit claim (DSR – original loan principal)"),
    ("700", "710", "Foreign direct investment"),
    ("700", "711", "Other foreign direct investment, including reinvested earnings"),
    ("800", "810", "Bank bonds"),
    ("800", "811", "Non-bank bonds"),
    ("900", "910", "Other bank securities/claims"),
    ("900", "911", "Other non-bank securities/claims"),
    ("900", "912", "Securities and other instruments issued by multilateral agencies"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/PolicySignificance.xml
POLICY_SIGNIFICANCE = (
    ("code", "name"),
    ("0", "not targeted"),
    ("1", "significant objective"),
    ("2", "principal objective"),
    ("3", "principal objective AND in support of an action programme"),
    ("4", "Explicit primary objective"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/LocationType.xml
LOCATION_TYPE = (
    ("category", "code", "name", "description"),
    ("S", "AIRQ", "abandoned airfield", "abandoned airfield"),
    ("S", "CMPQ", "abandoned camp", "abandoned camp"),
    ("H", "CNLQ", "abandoned canal", "abandoned canal"),
    ("S", "MFGQ", "abandoned factory", "abandoned factory"),
    ("S", "FRMQ", "abandoned farm", "abandoned farm"),
    ("S", "MNQ", "abandoned mine", "abandoned mine"),
    ("S", "MSSNQ", "abandoned mission", "abandoned mission"),
    ("S", "OILQ", "abandoned oil well", "abandoned oil well"),
    ("S", "PPQ", "abandoned police post", "abandoned police post"),
    ("P", "PPLQ", "abandoned populated place", "abandoned populated place"),
    ("S", "PRNQ", "abandoned prison", "abandoned prison"),
    ("R", "RRQ", "abandoned railroad", "abandoned railroad"),
    ("S", "RSTNQ", "abandoned railroad station", "abandoned railroad station"),
    ("S", "RSTPQ", "abandoned railroad stop", "abandoned railroad stop"),
    ("H", "STMQ", "abandoned watercourse", "a former stream or distributary no longer carrying flowing water, but still evident due to lakes, wetland, topographic or vegetation patterns"),
    ("H", "WLLQ", "abandoned well", "abandoned well"),
    ("A", "ADMD", "administrative division", "an administrative division of a political entity, undifferentiated as to administrative level"),
    ("S", "ADMF", "administrative facility", "a government building"),
    ("L", "AGRC", "agricultural colony", "a tract of land set aside for agricultural settlement"),
    ("S", "AGRF", "agricultural facility", "a building and/or tract of land used for improving agriculture"),
    ("L", "RESA", "agricultural reserve", "a tract of land reserved for agricultural reclamation and/or development"),
    ("S", "SCHA", "agricultural school", "a school with a curriculum focused on agriculture"),
    ("S", "AIRB", "airbase", "an area used to store supplies, provide barracks for air force personnel, hangars and runways for aircraft, and from which operations are initiated"),
    ("S", "AIRF", "airfield", "a place on land where aircraft land and take off; no facilities provided for the commercial handling of passengers and cargo"),
    ("S", "AIRP", "airport", "a place where aircraft regularly land and take off, with runways, navigational aids, and major facilities for the commercial handling of passengers and cargo"),
    ("S", "AMTH", "amphitheater", "an oval or circular structure with rising tiers of seats about a stage or open space"),
    ("H", "STMA", "anabranch", "a diverging branch flowing out of a main stream and rejoining it downstream"),
    ("H", "ANCH", "anchorage", "an area where vessels may anchor"),
    ("R", "RDA", "ancient road", "the remains of a road used by ancient cultures"),
    ("S", "ANS", "ancient site", "a place where archeological remains, old structures, or cultural artifacts are located"),
    ("S", "WALLA", "ancient wall", "the remains of a linear defensive stone structure"),
    ("S", "BLDA", "apartment building", "a building containing several individual apartments"),
    ("S", "AQC", "aquaculture facility", "facility or area for the cultivation of aquatic animals and plants, especially fish, shellfish, and seaweed, in natural or controlled marine or freshwater environments; underwater agriculture"),
    ("H", "CNLA", "aqueduct", "a conduit used to carry water"),
    ("S", "ARCH", "arch", "a natural or man-made structure in the form of an arch"),
    ("L", "LAND", "Arctic land", "a tract of land in the Arctic"),
    ("L", "AREA", "area", "a tract of land without homogeneous character or boundaries"),
    ("T", "ISLF", "artificial island", "an island created by landfill or diking and filling in a wetland, bay, or lagoon"),
    ("L", "RNGA", "artillery range", "a tract of land used for artillery firing practice"),
    ("T", "ASPH", "asphalt lake", "a small basin containing naturally occurring asphalt"),
    ("S", "ASTR", "astronomical station", "a point on the earth whose position has been determined by observations of celestial bodies"),
    ("S", "ASYL", "asylum", "a facility where the insane are cared for and protected"),
    ("S", "ATHF", "athletic field", "a tract of land used for playing team sports, and athletic track and field events"),
    ("T", "ATOL", "atoll(s)", "a ring-shaped coral reef which has closely spaced islands on it encircling a lagoon"),
    ("S", "CTRA", "atomic center", "a facility where atomic research is carried out"),
    ("T", "BDLD", "badlands", "an area characterized by a maze of very closely spaced, deep, narrow, steep-sided ravines, and sharp crests and pinnacles"),
    ("S", "BSTN", "baling station", "a facility for baling agricultural products"),
    ("S", "ESTB", "banana plantation", "an estate that specializes in the growing of bananas"),
    ("S", "BAN", "bank", "an establishment for the custody, loan, exchange or issue of money, for the extension of credit, and for facilitating the transmission of funds"),
    ("H", "BNK", "bank(s)", "an elevation, typically located on a shelf, over which the depth of water is relatively shallow but sufficient for most surface navigation"),
    ("T", "BAR", "bar", "a shallow ridge or mound of coarse unconsolidated material in a stream channel, at the mouth of a stream, estuary, or lagoon and in the wave-break zone along coasts"),
    ("S", "BRKS", "barracks", "a building for lodging military personnel"),
    ("L", "BTL", "battlefield", "a site of a land battle of historical importance"),
    ("H", "BAY", "bay", "a coastal indentation between two capes or headlands, larger than a cove but smaller than a gulf"),
    ("H", "BAYS", "bays", "coastal indentations between two capes or headlands, larger than a cove but smaller than a gulf"),
    ("T", "BCH", "beach", "a shore zone of coarse unconsolidated sediment that extends from the low-water line to the highest reach of storm waves"),
    ("T", "RDGB", "beach ridge", "a ridge of sand just inland and parallel to the beach, usually in series"),
    ("T", "BCHS", "beaches", "a shore zone of coarse unconsolidated sediment that extends from the low-water line to the highest reach of storm waves"),
    ("S", "BCN", "beacon", "a fixed artificial navigation mark"),
    ("T", "BNCH", "bench", "a long, narrow bedrock platform bounded by steeper slopes above and below, usually overlooking a waterbody"),
    ("H", "BGHT", "bight(s)", "an open body of water forming a slight recession in a coastline"),
    ("T", "BLHL", "blowhole(s)", "a hole in coastal rock through which sea water is forced by a rising tide or waves and spurted through an outlet into the air"),
    ("T", "BLOW", "blowout(s)", "a small depression in sandy terrain, caused by wind erosion"),
    ("S", "BTYD", "boatyard", "a waterside facility for servicing, repairing, and building small vessels"),
    ("H", "BOG", "bog(s)", "a wetland characterized by peat forming sphagnum moss, sedge, and other acid-water plants"),
    ("S", "PSTB", "border post", "a post or station at an international boundary for the regulation of movement of people and goods"),
    ("T", "BLDR", "boulder field", "a high altitude or high latitude bare, flat area covered with large angular rocks"),
    ("S", "BP", "boundary marker", "a fixture marking a point along a boundary"),
    ("S", "BRKW", "breakwater", "a structure erected to break the force of waves at the entrance to a harbor or port"),
    ("S", "MFGB", "brewery", "one or more buildings where beer is brewed"),
    ("S", "BDG", "bridge", "a structure erected across an obstacle such as a stream, road, etc., in order to carry roads, railroads, and pedestrians across"),
    ("A", "ZNB", "buffer zone", "a zone recognized as a buffer between two nations in which military presence is minimal or absent"),
    ("S", "BLDG", "building(s)", "a structure built for permanent use, as a house, factory, etc."),
    ("S", "BUR", "burial cave(s)", "a cave used for human burials"),
    ("V", "BUSH", "bush(es)", "a small clump of conspicuous bushes in an otherwise bare area"),
    ("L", "CTRB", "business center", "a place where a number of businesses are located"),
    ("T", "BUTE", "butte(s)", "a small, isolated, usually flat-topped hill with steep sides"),
    ("S", "CARN", "cairn", "a heap of stones erected as a landmark or for other purposes"),
    ("T", "CLDA", "caldera", "a depression measuring kilometers across formed by the collapse of a volcanic mountain"),
    ("S", "CMP", "camp(s)", "a site occupied by tents, huts, or other shelters for temporary use"),
    ("H", "CNL", "canal", "an artificial watercourse"),
    ("H", "CNLB", "canal bend", "a conspicuously curved or bent section of a canal"),
    ("H", "TNLC", "canal tunnel", "a tunnel through which a canal passes"),
    ("H", "STMC", "canalized stream", "a stream that has been substantially ditched, diked, or straightened"),
    ("S", "MFGC", "cannery", "a building where food items are canned"),
    ("T", "CNYN", "canyon", "a deep, narrow valley with steep sides cutting into a plateau or mountainous area"),
    ("T", "CAPE", "cape", "a land area, more prominent than a point, projecting into the sea and marking a notable change in coastal direction"),
    ("P", "PPLC", "capital of a political entity", "capital of a political entity"),
    ("R", "RTE", "caravan route", "the route taken by caravans"),
    ("S", "CSNO", "casino", "a building used for entertainment, especially gambling"),
    ("S", "CSTL", "castle", "a large fortified building or set of buildings"),
    ("S", "TNKD", "cattle dipping tank", "a small artificial pond used for immersing cattle in chemically treated water for disease control"),
    ("R", "CSWY", "causeway", "a raised roadway across wet ground or shallow water"),
    ("S", "CAVE", "cave(s)", "an underground passageway or chamber, or cavity on the side of a cliff"),
    ("S", "CMTY", "cemetery", "a burial place or ground"),
    ("H", "CHN", "channel", "the deepest part of a stream, bay, lagoon, or strait, through which the main current flows"),
    ("S", "MNCR", "chrome mine(s)", "a mine where chrome ore is extracted"),
    ("S", "CH", "church", "a building for public Christian worship"),
    ("T", "CRQ", "cirque", "a bowl-like hollow partially surrounded by cliffs or steep slopes at the head of a glaciated valley"),
    ("T", "CRQS", "cirques", "bowl-like hollows partially surrounded by cliffs or steep slopes at the head of a glaciated valley"),
    ("L", "CLG", "clearing", "an area in a forest with trees removed"),
    ("T", "CFT", "cleft(s)", "a deep narrow slot, notch, or groove in a coastal cliff"),
    ("T", "CLF", "cliff(s)", "a high, steep to perpendicular slope overlooking a waterbody or lower area"),
    ("S", "HSPC", "clinic", "a medical facility associated with a hospital for outpatients"),
    ("S", "MNC", "coal mine(s)", "a mine where coal is extracted"),
    ("L", "COLF", "coalfield", "a region in which coal deposits of possible economic value occur"),
    ("L", "CST", "coast", "a zone of variable width straddling the shoreline"),
    ("S", "STNC", "coast guard station", "a facility from which the coast is guarded by armed vessels"),
    ("V", "GRVC", "coconut grove", "a planting of coconut trees"),
    ("S", "SCHC", "college", "the grounds and buildings of an institution of higher learning"),
    ("L", "CMN", "common", "a park or pasture for community use"),
    ("S", "COMC", "communication center", "a facility, including buildings, antennae, towers and electronic equipment for receiving and transmitting information"),
    ("S", "CTRCM", "community center", "a facility for community recreation and other activities"),
    ("L", "CNS", "concession area", "a lease of land by a government for economic development, e.g., mining, forestry"),
    ("T", "CONE", "cone(s)", "a conical landform composed of mud or volcanic material"),
    ("H", "CNFL", "confluence", "a place where two or more streams or intermittent streams flow together"),
    ("U", "CRSU", "continental rise", "a gentle slope rising from oceanic depths towards the foot of a continental slope"),
    ("S", "CVNT", "convent", "a building where a community of nuns lives in seclusion"),
    ("S", "MNCU", "copper mine(s)", "a mine where copper ore is extracted"),
    ("S", "MFGCU", "copper works", "a facility for processing copper ore"),
    ("H", "RFC", "coral reef(s)", "a surface-navigation hazard composed of coral"),
    ("S", "CRRL", "corral(s)", "a pen or enclosure for confining or capturing animals"),
    ("T", "CRDR", "corridor", "a strip or area of land having significance as an access way"),
    ("S", "ESTC", "cotton plantation", "an estate specializing in the cultivation of cotton"),
    ("S", "HSEC", "country house", "a large house, mansion, or chateau, on a large estate"),
    ("S", "CTHSE", "courthouse", "a building in which courts of law are held"),
    ("H", "COVE", "cove(s)", "a small coastal indentation, smaller than a bay"),
    ("H", "LKC", "crater lake", "a lake in a crater or caldera"),
    ("H", "LKSC", "crater lakes", "lakes in a crater or caldera"),
    ("T", "CRTR", "crater(s)", "a generally circular saucer or bowl-shaped depression caused by volcanic or meteorite explosive action"),
    ("T", "CUET", "cuesta(s)", "an asymmetric ridge formed on tilted strata"),
    ("V", "CULT", "cultivated area", "an area under cultivation"),
    ("H", "CRNT", "current", "a horizontal flow of water in a given direction with uniform velocity"),
    ("S", "CSTM", "customs house", "a building in a port where customs and duties are paid, and where vessels are entered and cleared"),
    ("S", "PSTC", "customs post", "a building at an international boundary where customs and duties are paid on goods"),
    ("H", "CUTF", "cutoff", "a channel formed as a result of a stream cutting through a meander neck"),
    ("S", "DARY", "dairy", "a facility for the processing, sale and distribution of milk or milk products"),
    ("S", "DAM", "dam", "a barrier constructed across a stream to impound water"),
    ("U", "DEPU", "deep", "a localized deep area within the confines of a larger feature, such as a trough, basin or trench"),
    ("T", "DLTA", "delta", "a flat plain formed by alluvial deposits at the mouth of a stream"),
    ("A", "PCLD", "dependent political entity", "dependent political entity"),
    ("T", "DPR", "depression(s)", "a low area surrounded by higher land and usually characterized by interior drainage"),
    ("T", "DSRT", "desert", "a large area with little or no vegetation due to extreme environmental conditions"),
    ("P", "PPLW", "destroyed populated place", "a village, town or city destroyed by a natural disaster, or by war"),
    ("S", "MNDT", "diatomite mine(s)", "a place where diatomaceous earth is extracted"),
    ("S", "DIKE", "dike", "an earth or stone embankment usually constructed for flood or stream control"),
    ("S", "DIP", "diplomatic facility", "office, residence, or facility of a foreign government, which may include an embassy, consulate, chancery, office of charge dâaffaires, or other diplomatic, economic, military, or cultural mission"),
    ("S", "HSPD", "dispensary", "a building where medical or dental aid is dispensed"),
    ("H", "STMD", "distributary(-ies)", "a branch which flows away from the main stream, as in a delta or irrigation canal"),
    ("H", "DTCH", "ditch", "a small artificial watercourse dug for draining or irrigating the land"),
    ("H", "DTCHM", "ditch mouth(s)", "an area where a drainage ditch enters a lagoon, lake or bay"),
    ("T", "DVD", "divide", "a line separating adjacent drainage basins"),
    ("H", "DCK", "dock(s)", "a waterway between two piers, or cut into the land for the berthing of ships"),
    ("H", "DCKB", "docking basin", "a part of a harbor where ships dock"),
    ("S", "DCKY", "dockyard", "a facility for servicing, building, or repairing ships"),
    ("L", "BSND", "drainage basin", "an area drained by a stream"),
    ("H", "CNLD", "drainage canal", "an artificial waterway carrying water away from a wetland or from drainage ditches"),
    ("H", "DTCHD", "drainage ditch", "a ditch which serves to drain the land"),
    ("S", "DCKD", "dry dock", "a dock providing support for a vessel, and means for removing the water so that the bottom of the vessel can be exposed"),
    ("T", "SBED", "dry stream bed", "a channel formerly containing the water of a stream"),
    ("T", "DUNE", "dune(s)", "a wave form, ridge or star shape feature composed of sand"),
    ("L", "RGNE", "economic region", "a region of a country established for economic development or for statistical purposes"),
    ("T", "SCRP", "escarpment", "a long line of cliffs or steep slopes separating level surfaces above and below"),
    ("S", "EST", "estate(s)", "a large commercialized agricultural landholding with associated buildings and other facilities"),
    ("H", "ESTY", "estuary", "a funnel-shaped stream mouth or embayment where fresh water mixes with sea water under tidal influences"),
    ("S", "STNE", "experiment station", "a facility for carrying out experiments"),
    ("S", "FCL", "facility", "a building or buildings housing a center, institute, foundation, hospital, prison, mission, courthouse, etc."),
    ("S", "CTRF", "facility center", "a place where more than one facility is situated"),
    ("S", "MFG", "factory", "one or more buildings where goods are manufactured, processed or fabricated"),
    ("T", "FAN", "fan(s)", "a fan-shaped wedge of coarse alluvium with apex merging with a mountain stream bed and the fan spreading out at a low angle slope onto an adjacent plain"),
    ("S", "FRM", "farm", "a tract of land with associated buildings devoted to agriculture"),
    ("P", "PPLF", "farm village", "a populated place where the population is largely engaged in agricultural activities"),
    ("S", "FRMS", "farms", "tracts of land with associated buildings devoted to agriculture"),
    ("S", "FRMT", "farmstead", "the buildings and adjacent service areas of a farm"),
    ("S", "FY", "ferry", "a boat or other floating conveyance and terminal facilities regularly used to transport people and vehicles across a waterbody"),
    ("S", "FYT", "ferry terminal", "a place where ferries pick-up and discharge passengers, vehicles and or cargo"),
    ("L", "FLD", "field(s)", "an open as opposed to wooded area"),
    ("S", "FIRE", "fire station", "building housing firefighters and/or fire fighting equipment"),
    ("A", "ADM1", "first-order administrative division", "a primary administrative division of a country, such as a state in the United States"),
    ("H", "FISH", "fishing area", "a fishing ground, bank or area where fishermen go to catch fish"),
    ("H", "PNDSF", "fishponds", "ponds or enclosures in which fish are kept or raised"),
    ("T", "FSR", "fissure", "a crack associated with volcanism"),
    ("H", "FJD", "fjord", "a long, narrow, steep-walled, deep-water arm of the sea at high latitudes, usually along mountainous coasts"),
    ("H", "FJDS", "fjords", "long, narrow, steep-walled, deep-water arms of the sea at high latitudes, usually along mountainous coasts"),
    ("T", "FORD", "ford", "a shallow part of a stream which can be crossed on foot or by land vehicle"),
    ("L", "RESF", "forest reserve", "a forested area set aside for preservation or controlled use"),
    ("S", "STNF", "forest station", "a collection of buildings and facilities for carrying out forest management"),
    ("V", "FRST", "forest(s)", "an area dominated by tree vegetation"),
    ("H", "INLTQ", "former inlet", "an inlet which has been filled in, or blocked by deposits"),
    ("S", "MLSGQ", "former sugar mill", "a sugar mill no longer used as a sugar mill"),
    ("S", "FT", "fort", "a defensive structure or earthworks"),
    ("V", "FRSTF", "fossilized forest", "a forest fossilized by geologic processes and now exposed at the earth's surface"),
    ("S", "FNDY", "foundry", "a building or works where metal casting is carried out"),
    ("A", "ADM4", "fourth-order administrative division", "a subdivision of a third-order administrative division"),
    ("S", "ZNF", "free trade zone", "an area, usually a section of a port, where goods may be received and shipped free of customs duty and of most customs regulations"),
    ("A", "PCLF", "freely associated state", "freely associated state"),
    ("S", "DPOF", "fuel depot", "an area where fuel is stored"),
    ("T", "GAP", "gap", "a low place in a ridge, not used for transportation"),
    ("S", "GDN", "garden(s)", "an enclosure for displaying selected plant or animal life"),
    ("S", "GOSP", "gas-oil separator plant", "a facility for separating gas from oil"),
    ("L", "GASF", "gasfield", "an area containing a subterranean store of natural gas of economic value"),
    ("S", "GATE", "gate", "a controlled access entrance or exit"),
    ("H", "GYSR", "geyser", "a type of hot spring with intermittent eruptions of jets of hot water and steam"),
    ("S", "GHAT", "ghÄt", "a set of steps leading to a river, which are of religious significance, and at their base is usually a platform for bathing"),
    ("H", "GLCR", "glacier(s)", "a mass of ice, usually at high latitudes or high elevations, with sufficient thickness to flow away from the source area in lobes, tongues, or masses"),
    ("S", "MNAU", "gold mine(s)", "a mine where gold ore, or alluvial gold is extracted"),
    ("S", "RECG", "golf course", "a recreation field where golf is played"),
    ("T", "GRGE", "gorge(s)", "a short, narrow, steep-sided section of a stream valley"),
    ("V", "GRSLD", "grassland", "an area dominated by grass vegetation"),
    ("S", "GRVE", "grave", "a burial site"),
    ("L", "GVL", "gravel area", "an area covered with gravel"),
    ("L", "GRAZ", "grazing area", "an area of grasses and shrubs used for grazing"),
    ("S", "GHSE", "guest house", "a house used to provide lodging for paying guests"),
    ("H", "GULF", "gulf", "a large recess in the coastline, larger than a bay"),
    ("S", "HLT", "halting place", "a place where caravans stop for rest"),
    ("T", "HMCK", "hammock(s)", "a patch of ground, distinct from and slightly above the surrounding plain or wetland. Often occurs in groups"),
    ("S", "AIRG", "hangar", "a covered and usually enclosed area for housing and repairing aircraft"),
    ("T", "VALG", "hanging valley", "a valley the floor of which is notably higher than the valley or shore to which it leads; most common in areas that have been glaciated"),
    ("H", "HBR", "harbor(s)", "a haven or space of deep water so sheltered by the adjacent land as to afford a safe anchorage for ships"),
    ("T", "HDLD", "headland", "a high projection of land extending into a large body of water beyond the line of the coast"),
    ("H", "STMH", "headwaters", "the source and upper part of a stream, including the upper drainage basin"),
    ("V", "HTH", "heath", "an upland moor or sandy area dominated by low shrubby vegetation including heather"),
    ("S", "AIRH", "heliport", "a place where helicopters land and take off"),
    ("S", "HERM", "hermitage", "a secluded residence, usually for religious sects"),
    ("T", "HLL", "hill", "a rounded elevation of limited extent rising above the surrounding land with local relief of less than 300m"),
    ("T", "HLLS", "hills", "rounded elevations of limited extent rising above the surrounding land with local relief of less than 300m"),
    ("A", "ADMDH", "historical administrative division", "a former administrative division of a political entity, undifferentiated as to administrative level"),
    ("A", "ADM1H", "historical first-order administrative division", "a former first-order administrative division"),
    ("A", "ADM4H", "historical fourth-order administrative division", "a former fourth-order administrative division"),
    ("A", "PCLH", "historical political entity", "a former political entity"),
    ("P", "PPLH", "historical populated place", "a populated place that no longer exists"),
    ("R", "RRH", "historical railroad", "a former permanent twin steel-rail track on which freight and passenger cars move long distances"),
    ("S", "RSTNH", "historical railroad station", "a former facility comprising ticket office, platforms, etc. for loading and unloading train passengers and freight"),
    ("L", "RGNH", "historical region", "a former area distinguished by one or more observable physical or cultural characteristics"),
    ("A", "ADM2H", "historical second-order administrative division", "a former second-order administrative division"),
    ("S", "HSTS", "historical site", "a place of historical importance"),
    ("A", "ADM3H", "historical third-order administrative division", "a former third-order administrative division"),
    ("U", "UFHU", "historical undersea feature", "an undersea feature whose existence has been subsequently disproved"),
    ("S", "HMSD", "homestead", "a residence, owner's or manager's, on a sheep or cattle station, woolshed, outcamp, or Aboriginal outstation, specific to Australia and New Zealand"),
    ("S", "HSP", "hospital", "a building in which sick or injured, especially those confined to bed, are medically treated"),
    ("H", "SPNT", "hot spring(s)", "a place where hot ground water flows naturally out of the ground"),
    ("S", "HTL", "hotel", "a building providing lodging and/or meals for the public"),
    ("S", "HSE", "house(s)", "a building used as a human habitation"),
    ("L", "DEVH", "housing development", "a tract of land on which many houses of similar design are built according to a development plan"),
    ("L", "RESH", "hunting reserve", "a tract of land used primarily for hunting"),
    ("S", "HUT", "hut", "a small primitive house"),
    ("S", "HUTS", "huts", "small primitive houses"),
    ("S", "PSH", "hydroelectric power station", "a building where electricity is generated from water power"),
    ("H", "CAPG", "icecap", "a dome-shaped mass of glacial ice covering an area of mountain summits or other high lands; smaller than an ice sheet"),
    ("H", "DPRG", "icecap depression", "a comparatively depressed area on an icecap"),
    ("H", "DOMG", "icecap dome", "a comparatively elevated area on an icecap"),
    ("H", "RDGG", "icecap ridge", "a linear elevation on an icecap"),
    ("A", "PCLI", "independent political entity", "independent political entity"),
    ("L", "INDS", "industrial area", "an area characterized by industrial activity"),
    ("H", "INLT", "inlet", "a narrow waterway extending into the land, or connecting a bay or lagoon with a larger body of water"),
    ("S", "STNI", "inspection station", "a station at which vehicles, goods, and people are inspected"),
    ("T", "TRGD", "interdune trough(s)", "a long wind-swept trough between parallel longitudinal dunes"),
    ("T", "INTF", "interfluve", "a relatively undissected upland between adjacent stream valleys"),
    ("H", "LKI", "intermittent lake", "intermittent lake"),
    ("H", "LKSI", "intermittent lakes", "intermittent lakes"),
    ("H", "LKOI", "intermittent oxbow lake", "intermittent oxbow lake"),
    ("H", "PNDI", "intermittent pond", "intermittent pond"),
    ("H", "PNDSI", "intermittent ponds", "intermittent ponds"),
    ("H", "POOLI", "intermittent pool", "intermittent pool"),
    ("H", "RSVI", "intermittent reservoir", "intermittent reservoir"),
    ("H", "LKNI", "intermittent salt lake", "intermittent salt lake"),
    ("H", "LKSNI", "intermittent salt lakes", "intermittent salt lakes"),
    ("H", "PNDNI", "intermittent salt pond(s)", "intermittent salt pond(s)"),
    ("H", "STMI", "intermittent stream", "intermittent stream"),
    ("H", "WTLDI", "intermittent wetland", "intermittent wetland"),
    ("S", "RDIN", "intersection", "a junction of two or more highways by a system of separate levels that permit traffic to pass from one to another without the crossing of traffic streams"),
    ("S", "MNFE", "iron mine(s)", "a mine where iron ore is extracted"),
    ("L", "FLDI", "irrigated field(s)", "a tract of level or terraced land which is irrigated"),
    ("H", "CNLI", "irrigation canal", "a canal which serves as a main conduit for irrigation water"),
    ("H", "DTCHI", "irrigation ditch", "a ditch which serves to distribute irrigation water"),
    ("H", "SYSI", "irrigation system", "a network of ditches and one or more of the following elements: water supply, reservoir, canal, pump, well, drain, etc."),
    ("T", "ISL", "island", "a tract of land, smaller than a continent, surrounded by water at high water"),
    ("T", "ISLS", "islands", "tracts of land, smaller than a continent, surrounded by water at high water"),
    ("P", "STLMT", "Israeli settlement", "Israeli settlement"),
    ("T", "ISTH", "isthmus", "a narrow strip of land connecting two larger land masses and bordered by water"),
    ("S", "JTY", "jetty", "a structure built out into the water at a river mouth or harbor entrance to regulate currents and silting"),
    ("T", "KRST", "karst area", "a distinctive landscape developed on soluble rock such as limestone characterized by sinkholes, caves, disappearing streams, and underground drainage"),
    ("S", "CMPLA", "labor camp", "a camp used by migrant or temporary laborers"),
    ("H", "LGN", "lagoon", "a shallow coastal waterbody, completely or partly separated from a larger body of water by a barrier island, coral reef or other depositional feature"),
    ("H", "LGNS", "lagoons", "shallow coastal waterbodies, completely or partly separated from a larger body of water by a barrier island, coral reef or other depositional feature"),
    ("H", "LK", "lake", "a large inland body of standing water"),
    ("H", "LBED", "lake bed(s)", "a dried up or drained area of a former lake"),
    ("H", "CHNL", "lake channel(s)", "that part of a lake having water deep enough for navigation between islands, shoals, etc."),
    ("L", "RGNL", "lake region", "a tract of land distinguished by numerous lakes"),
    ("H", "LKS", "lakes", "large inland bodies of standing water"),
    ("T", "ISLT", "land-tied island", "a coastal island connected to the mainland by barrier beaches, levees or dikes"),
    ("S", "LNDF", "landfill", "a place for trash and garbage disposal in which the waste is buried between layers of earth to build up low-lying land"),
    ("S", "LDNG", "landing", "a place where boats receive or discharge passengers and freight, but lacking most port facilities"),
    ("T", "LAVA", "lava area", "an area of solidified lava"),
    ("S", "MNPB", "lead mine(s)", "a mine where lead ore is extracted"),
    ("A", "LTER", "leased area", "a tract of land leased by the United Kingdom from the People's Republic of China to form part of Hong Kong"),
    ("S", "LEPC", "leper colony", "a settled area inhabited by lepers in relative isolation"),
    ("S", "HSPL", "leprosarium", "an asylum or hospital for lepers"),
    ("T", "LEV", "levee", "a natural low embankment bordering a distributary or meandering stream; often built up artificially to control floods"),
    ("S", "LTHSE", "lighthouse", "a distinctive structure exhibiting a major navigation light"),
    ("S", "MFGLM", "limekiln", "a furnace in which limestone is reduced to lime"),
    ("S", "GOVL", "local government office", "a facility housing local governmental offices, usually a city, town, or village hall"),
    ("L", "LCTY", "locality", "a minor area or place of unspecified or mixed character and indefinite boundaries"),
    ("S", "LOCK", "lock(s)", "a basin in a waterway with gates at each end by means of which vessels are passed from one water level to another"),
    ("S", "CMPL", "logging camp", "a camp used by loggers"),
    ("H", "STMSB", "lost river", "a surface stream that disappears into an underground channel, or dries up in an arid area"),
    ("L", "MVA", "maneuver area", "a tract of land where military field exercises are carried out"),
    ("T", "ISLM", "mangrove island", "a mangrove swamp surrounded by a waterbody"),
    ("H", "MGV", "mangrove swamp", "a tropical tidal mud flat characterized by mangrove vegetation"),
    ("S", "MAR", "marina", "a harbor facility for small boats, yachts, etc."),
    ("H", "CHNM", "marine channel", "that part of a body of water deep enough for navigation through an area otherwise not suitable"),
    ("S", "SCHN", "maritime school", "a school at which maritime sciences form the core of the curriculum"),
    ("S", "MKT", "market", "a place where goods are bought and sold at regular intervals"),
    ("H", "MRSH", "marsh(es)", "a wetland dominated by grass-like vegetation"),
    ("V", "MDW", "meadow", "a small, poorly drained area dominated by grassy vegetation"),
    ("T", "NKM", "meander neck", "a narrow strip of land between the two limbs of a meander loop at its narrowest point"),
    ("S", "CTRM", "medical center", "a complex of health care buildings including two or more of the following: hospital, medical school, clinic, pharmacy, doctor's offices, etc."),
    ("T", "MESA", "mesa(s)", "a flat-topped, isolated elevation with steep slopes on all sides, less extensive than a plateau"),
    ("S", "STNM", "meteorological station", "a station at which weather elements are recorded"),
    ("L", "MILB", "military base", "a place used by an army or other armed service for storing arms and supplies, and for accommodating and training troops, a base from which operations can be initiated"),
    ("S", "INSM", "military installation", "a facility for use of and control by armed forces"),
    ("S", "SCHM", "military school", "a school at which military science forms the core of the curriculum"),
    ("S", "ML", "mill(s)", "a building housing machines for transforming, shaping, finishing, grinding, or extracting products"),
    ("S", "MN", "mine(s)", "a site where mineral ores are extracted from the ground by excavating surface pits and subterranean passages"),
    ("L", "MNA", "mining area", "an area of mine sites where minerals and ores are extracted"),
    ("S", "CMPMN", "mining camp", "a camp used by miners"),
    ("S", "MSSN", "mission", "a place characterized by dwellings, school, church, hospital and other facilities operated by a religious group for the purpose of providing charitable services and to propagate religion"),
    ("S", "MOLE", "mole", "a massive structure of masonry or large stones serving as a pier or breakwater"),
    ("S", "MSTY", "monastery", "a building and grounds where a community of monks lives in seclusion"),
    ("S", "MNMT", "monument", "a commemorative structure or statue"),
    ("H", "MOOR", "moor(s)", "an area of open ground overlaid with wet peaty soils"),
    ("T", "MRN", "moraine", "a mound, ridge, or other accumulation of glacial till"),
    ("S", "MSQE", "mosque", "a building for public Islamic worship"),
    ("T", "MND", "mound(s)", "a low, isolated, rounded hill"),
    ("T", "MT", "mountain", "an elevation standing high above the surrounding area with small summit area, steep slopes and local relief of 300m or more"),
    ("T", "MTS", "mountains", "a mountain range or a group of mountains or high ridges"),
    ("H", "FLTM", "mud flat(s)", "a relatively level area of mud either between high and low tide lines, or subject to flooding"),
    ("S", "MFGM", "munitions plant", "a factory where ammunition is made"),
    ("S", "MUS", "museum", "a building where objects of permanent interest in one or more of the arts and sciences are preserved and exhibited"),
    ("H", "NRWS", "narrows", "a navigable narrow part of a bay, strait, river, etc."),
    ("R", "TNLN", "natural tunnel", "a cave that is open at both ends"),
    ("L", "RESN", "nature reserve", "an area reserved for the maintenance of a natural habitat"),
    ("L", "NVB", "naval base", "an area used to store supplies, provide barracks for troops and naval personnel, a port for naval vessels, and from which operations are initiated"),
    ("H", "CNLN", "navigation canal(s)", "a watercourse constructed for navigation of vessels"),
    ("H", "CHNN", "navigation channel", "a buoyed channel of sufficient depth for the safe navigation of vessels"),
    ("S", "MNNI", "nickel mine(s)", "a mine where nickel ore is extracted"),
    ("S", "NOV", "novitiate", "a religious house or school where novices are trained"),
    ("S", "PSN", "nuclear power station", "nuclear power station"),
    ("T", "NTK", "nunatak", "a rock or mountain peak protruding through glacial ice"),
    ("T", "NTKS", "nunataks", "rocks or mountain peaks protruding through glacial ice"),
    ("S", "NSY", "nursery(-ies)", "a place where plants are propagated for transplanting or grafting"),
    ("L", "OAS", "oasis(-es)", "an area in a desert made productive by the availability of water"),
    ("S", "OBPT", "observation point", "a wildlife or scenic observation point"),
    ("S", "OBS", "observatory", "a facility equipped for observation of atmospheric or space phenomena"),
    ("H", "OCN", "ocean", "one of the major divisions of the vast expanse of salt water covering part of the earth"),
    ("S", "BLDO", "office building", "commercial building where business and/or services are conducted"),
    ("S", "CMPO", "oil camp", "a camp used by oilfield workers"),
    ("S", "ESTO", "oil palm plantation", "an estate specializing in the cultivation of oil palm trees"),
    ("R", "OILP", "oil pipeline", "a pipeline used for transporting oil"),
    ("S", "OILJ", "oil pipeline junction", "a section of an oil pipeline where two or more pipes join together"),
    ("S", "TRMO", "oil pipeline terminal", "a tank farm or loading facility at the end of an oil pipeline"),
    ("S", "PMPO", "oil pumping station", "a facility for pumping oil through a pipeline"),
    ("S", "OILR", "oil refinery", "a facility for converting crude oil into refined petroleum products"),
    ("S", "OILW", "oil well", "a well from which oil may be pumped"),
    ("L", "OILF", "oilfield", "an area containing a subterranean store of petroleum of economic value"),
    ("V", "GRVO", "olive grove", "a planting of olive trees"),
    ("S", "MLO", "olive oil mill", "a mill where oil is extracted from olives"),
    ("V", "OCH", "orchard(s)", "a planting of fruit or nut trees"),
    ("S", "MLM", "ore treatment plant", "a facility for improving the metal content of ore by concentration"),
    ("H", "OVF", "overfalls", "an area of breaking waves caused by the meeting of currents or by waves moving against the current"),
    ("H", "LKO", "oxbow lake", "a crescent-shaped lake commonly found adjacent to meandering streams"),
    ("S", "PGDA", "pagoda", "a tower-like storied structure, usually a Buddhist shrine"),
    ("S", "PAL", "palace", "a large stately house, often a royal or presidential residence"),
    ("V", "GRVP", "palm grove", "a planting of palm trees"),
    ("L", "RESP", "palm tree reserve", "an area of palm trees where use is controlled"),
    ("T", "PAN", "pan", "a near-level shallow, natural depression or basin, usually containing an intermittent lake, pond, or pool"),
    ("T", "PANS", "pans", "a near-level shallow, natural depression or basin, usually containing an intermittent lake, pond, or pool"),
    ("A", "PRSH", "parish", "an ecclesiastical district"),
    ("L", "PRK", "park", "an area, often of forested land, maintained as a place of beauty, or for recreation"),
    ("S", "PRKGT", "park gate", "a controlled access to a park"),
    ("S", "PRKHQ", "park headquarters", "a park administrative facility"),
    ("S", "GARG", "parking garage", "a building or underground facility used exclusively for parking vehicles"),
    ("S", "PKLT", "parking lot", "an area used for parking vehicles"),
    ("T", "PASS", "pass", "a break in a mountain range or other high obstruction, used for transportation from one side to the other [See also gap]"),
    ("S", "PSTP", "patrol post", "a post from which patrols are sent out"),
    ("T", "PK", "peak", "a pointed elevation atop a mountain, ridge, or other hypsographic feature"),
    ("T", "PKS", "peaks", "pointed elevations atop a mountain, ridge, or other hypsographic features"),
    ("L", "PEAT", "peat cutting area", "an area where peat is harvested"),
    ("T", "PEN", "peninsula", "an elongate area of land projecting into a body of water and nearly surrounded by water"),
    ("L", "BSNP", "petroleum basin", "an area underlain by an oil-rich structural basin"),
    ("S", "MFGPH", "phosphate works", "a facility for producing fertilizer"),
    ("S", "PIER", "pier", "a structure built out into navigable water on piles providing berthing for ships and recreation"),
    ("V", "GRVPN", "pine grove", "a planting of pine trees"),
    ("S", "MNPL", "placer mine(s)", "a place where heavy metals are concentrated and running water is used to extract them from unconsolidated sediments"),
    ("T", "PLN", "plain(s)", "an extensive area of comparatively level to gently undulating land, lacking surface irregularities, and usually adjacent to a higher area"),
    ("T", "PLAT", "plateau", "an elevated plain with steep slopes on one or more sides, and often with incised streams"),
    ("T", "PT", "point", "a tapering piece of land projecting into a body of water, less prominent than a cape"),
    ("T", "PTS", "points", "tapering pieces of land projecting into a body of water, less prominent than a cape"),
    ("T", "PLDR", "polder", "an area reclaimed from the sea by diking and draining"),
    ("S", "PP", "police post", "a building in which police are stationed"),
    ("A", "PCL", "political entity", "political entity"),
    ("H", "PND", "pond", "a small standing waterbody"),
    ("H", "PNDS", "ponds", "small standing waterbodies"),
    ("H", "POOL", "pool(s)", "a small and comparatively still, deep part of a larger body of water such as a stream or harbor; or a small body of standing water"),
    ("P", "PPLL", "populated locality", "an area similar to a locality but with a small group of dwellings or other buildings"),
    ("P", "PPL", "populated place", "a city, town, village, or other agglomeration of buildings where people live and work"),
    ("P", "PPLS", "populated places", "cities, towns, villages, or other agglomerations of buildings where people live and work"),
    ("L", "PRT", "port", "a place provided with terminal and transfer facilities for loading and discharging waterborne cargo or passengers, usually located in a harbor"),
    ("R", "PTGE", "portage", "a place where boats, goods, etc., are carried overland between navigable waters"),
    ("S", "PO", "post office", "a public building in which mail is received, sorted and distributed"),
    ("S", "PS", "power station", "a facility for generating electric power"),
    ("S", "PRN", "prison", "a facility for confining prisoners"),
    ("R", "PRMN", "promenade", "a place for public walking, usually along a beach front"),
    ("T", "PROM", "promontory(-ies)", "a bluff or prominent hill overlooking or projecting into a lowland"),
    ("S", "PYR", "pyramid", "an ancient massive structure of square ground plan with four triangular faces meeting at a point and used for enclosing tombs"),
    ("S", "PYRS", "pyramids", "ancient massive structures of square ground plan with four triangular faces meeting at a point and used for enclosing tombs"),
    ("S", "MNQR", "quarry(-ies)", "a surface mine where building stone or gravel and sand, etc. are extracted"),
    ("S", "QUAY", "quay", "a structure of solid construction along a shore or bank which provides berthing for ships and which generally provides cargo handling facilities"),
    ("L", "QCKS", "quicksand", "an area where loose sand with water moving through it may become unstable when heavy objects are placed at the surface, causing them to sink"),
    ("S", "RECR", "racetrack", "a track where races are held"),
    ("S", "OBSR", "radio observatory", "a facility equipped with an array of antennae for receiving radio waves from space"),
    ("S", "STNR", "radio station", "a facility for producing and transmitting information by radio waves"),
    ("R", "RR", "railroad", "a permanent twin steel-rail track on which freight and passenger cars move long distances"),
    ("R", "RJCT", "railroad junction", "a place where two or more railroad tracks join"),
    ("S", "RSD", "railroad siding", "a short track parallel to and joining the main track"),
    ("S", "RSGNL", "railroad signal", "a signal at the entrance of a particular section of track governing the movement of trains"),
    ("S", "RSTN", "railroad station", "a facility comprising ticket office, platforms, etc. for loading and unloading train passengers and freight"),
    ("S", "RSTP", "railroad stop", "a place lacking station facilities where trains stop to pick up and unload passengers and freight"),
    ("R", "TNLRR", "railroad tunnel", "a tunnel through which a railroad passes"),
    ("R", "RYD", "railroad yard", "a system of tracks used for the making up of trains, and switching and storing freight cars"),
    ("S", "RNCH", "ranch(es)", "a large farm specializing in extensive grazing of livestock"),
    ("H", "RPDS", "rapids", "a turbulent section of a stream associated with a steep, irregular stream bed"),
    ("H", "RVN", "ravine(s)", "a small, narrow, deep, steep-sided stream channel, smaller than a gorge"),
    ("H", "RCH", "reach", "a straight section of a navigable stream or channel between two bends"),
    ("H", "RF", "reef(s)", "a surface-navigation hazard composed of consolidated material"),
    ("S", "PRNJ", "reformatory", "a facility for confining, training, and reforming young law offenders"),
    ("S", "CMPRF", "refugee camp", "a camp used by refugees"),
    ("L", "RGN", "region", "an area distinguished by one or more observable physical or cultural characteristics"),
    ("S", "CTRR", "religious center", "a facility where more than one religious activity is carried out, e.g., retreat, school, monastery, worship"),
    ("P", "PPLR", "religious populated place", "a populated place whose population is largely engaged in religious occupations"),
    ("S", "RLG", "religious site", "an ancient site of significant religious importance"),
    ("S", "ITTR", "research institute", "a facility where research is carried out"),
    ("L", "RESV", "reservation", "a tract of land set aside for aboriginal, tribal, or native populations"),
    ("L", "RES", "reserve", "a tract of public land reserved for future use or restricted as to use"),
    ("H", "RSV", "reservoir(s)", "an artificial pond or lake"),
    ("S", "RSRT", "resort", "a specialized facility for vacation, health, or participation sports activities"),
    ("S", "RHSE", "resthouse", "a structure maintained for the rest and shelter of travelers"),
    ("S", "RLGR", "retreat", "a place of temporary seclusion, especially for religious groups"),
    ("T", "RDGE", "ridge(s)", "a long narrow elevation with steep sides, and a more or less continuous crest"),
    ("R", "RD", "road", "an open way with improved surface for transportation of animals, people and vehicles"),
    ("R", "RDB", "road bend", "a conspicuously curved or bent section of a road"),
    ("R", "RDCUT", "road cut", "an excavation cut through a hill or ridge for a road"),
    ("R", "RDJCT", "road junction", "a place where two or more roads join"),
    ("R", "TNLRD", "road tunnel", "a tunnel through which a road passes"),
    ("H", "RDST", "roadstead", "an open anchorage affording less protection than a harbor"),
    ("T", "RK", "rock", "a conspicuous, isolated rocky mass"),
    ("T", "HMDA", "rock desert", "a relatively sand-free, high bedrock plateau in a hot desert, with or without a gravel veneer"),
    ("T", "RKFL", "rockfall", "an irregular mass of fallen rock at the base of a cliff or steep slope"),
    ("T", "RKS", "rocks", "conspicuous, isolated rocky masses"),
    ("S", "RKRY", "rookery", "a breeding place of a colony of birds or seals"),
    ("S", "ESTR", "rubber plantation", "an estate which specializes in growing and tapping rubber trees"),
    ("S", "RUIN", "ruin(s)", "a destroyed or decayed structure which is no longer functional"),
    ("S", "BDGQ", "ruined bridge", "a destroyed or decayed bridge which is no longer functional"),
    ("S", "DAMQ", "ruined dam", "a destroyed or decayed dam which is no longer functional"),
    ("H", "SBKH", "sabkha(s)", "a salt flat or salt encrusted plain subject to periodic inundation from flooding or high tides"),
    ("T", "SDL", "saddle", "a broad, open pass crossing a ridge or between hills or mountains"),
    ("L", "SALT", "salt area", "a shallow basin or flat where salt accumulates after periodic inundation"),
    ("H", "MFGN", "salt evaporation ponds", "diked salt ponds used in the production of solar evaporated salt"),
    ("H", "LKN", "salt lake", "an inland body of salt water with no outlet"),
    ("H", "LKSN", "salt lakes", "inland bodies of salt water with no outlet"),
    ("H", "MRSHN", "salt marsh", "a flat area, subject to periodic salt water inundation, dominated by grassy salt-tolerant plants"),
    ("S", "MNN", "salt mine(s)", "a mine from which salt is extracted"),
    ("H", "PNDN", "salt pond", "a small standing body of salt water often in a marsh or swamp, usually along a seacoast"),
    ("H", "PNDSN", "salt ponds", "small standing bodies of salt water often in a marsh or swamp, usually along a seacoast"),
    ("S", "SNTR", "sanatorium", "a facility where victims of physical or mental disorders are treated"),
    ("T", "SAND", "sand area", "a tract of land covered with sand"),
    ("T", "ERG", "sandy desert", "an extensive tract of shifting sand and sand dunes"),
    ("S", "STNS", "satellite station", "a facility for tracking and communicating with orbiting satellites"),
    ("S", "MLSW", "sawmill", "a mill where logs or lumber are sawn to specified shapes and sizes"),
    ("S", "SCH", "school", "building(s) where instruction in one or more branches of knowledge takes place"),
    ("A", "ADMS", "school district", "school district"),
    ("S", "STNB", "scientific research base", "a scientific facility used as a base from which research is carried out or monitored"),
    ("V", "SCRB", "scrubland", "an area of low trees, bushes, and shrubs stunted by some environmental limitation"),
    ("H", "SEA", "sea", "a large body of salt water more or less confined by continuous land or chains of islands forming a subdivision of an ocean"),
    ("U", "SCNU", "seachannel", "a continuously sloping, elongated depression commonly found in fans or plains and customarily bordered by levees on one or two sides"),
    ("U", "SCSU", "seachannels", "continuously sloping, elongated depressions commonly found in fans or plains and customarily bordered by levees on one or two sides"),
    ("U", "SMU", "seamount", "an elevation rising generally more than 1,000 meters and of limited extent across the summit"),
    ("U", "SMSU", "seamounts", "elevations rising generally more than 1,000 meters and of limited extent across the summit"),
    ("H", "AIRS", "seaplane landing area", "a place on a waterbody where floatplanes land and take off"),
    ("P", "PPLA", "seat of a first-order administrative division", "seat of a first-order administrative division (PPLC takes precedence over PPLA)"),
    ("P", "PPLA4", "seat of a fourth-order administrative division", "seat of a fourth-order administrative division"),
    ("P", "PPLA2", "seat of a second-order administrative division", "seat of a second-order administrative division"),
    ("P", "PPLA3", "seat of a third-order administrative division", "seat of a third-order administrative division"),
    ("A", "ADM2", "second-order administrative division", "a subdivision of a first-order administrative division"),
    ("H", "BNKX", "section of bank", "section of bank"),
    ("H", "CNLX", "section of canal", "section of canal"),
    ("S", "ESTX", "section of estate", "section of estate"),
    ("H", "HBRX", "section of harbor", "section of harbor"),
    ("A", "PCLIX", "section of independent political entity", "section of independent political entity"),
    ("H", "STMIX", "section of intermittent stream", "section of intermittent stream"),
    ("T", "ISLX", "section of island", "section of island"),
    ("H", "LGNX", "section of lagoon", "section of lagoon"),
    ("H", "LKX", "section of lake", "section of lake"),
    ("T", "PENX", "section of peninsula", "section of peninsula"),
    ("T", "PLNX", "section of plain", "section of plain"),
    ("T", "PLATX", "section of plateau", "section of plateau"),
    ("P", "PPLX", "section of populated place", "section of populated place"),
    ("H", "RFX", "section of reef", "section of reef"),
    ("H", "STMX", "section of stream", "section of stream"),
    ("T", "VALX", "section of valley", "section of valley"),
    ("H", "WADX", "section of wadi", "section of wadi"),
    ("H", "FLLSX", "section of waterfall(s)", "section of waterfall(s)"),
    ("A", "PCLS", "semi-independent political entity", "semi-independent political entity"),
    ("S", "SWT", "sewage treatment plant", "facility for the processing of sewage and/or wastewater"),
    ("S", "SHPF", "sheepfold", "a fence or wall enclosure for sheep and other small herd animals"),
    ("H", "SHOL", "shoal(s)", "a surface-navigation hazard composed of unconsolidated material"),
    ("S", "SHOPC", "shopping center or mall", "an urban shopping area featuring a variety of shops surrounding a usually open-air concourse reserved for pedestrian traffic; or a large suburban building or group of buildings containing various shops with associated passageways"),
    ("T", "SHOR", "shore", "a narrow zone bordering a waterbody which covers and uncovers at high and low water, respectively"),
    ("S", "SHRN", "shrine", "a structure or place memorializing a person or religious concept"),
    ("H", "SILL", "sill", "the low part of a gap or saddle separating basins"),
    ("T", "SINK", "sinkhole", "a small crater-shape depression in a karst area"),
    ("S", "ESTSL", "sisal plantation", "an estate that specializes in growing sisal"),
    ("T", "SLID", "slide", "a mound of earth material, at the base of a slope and the associated scoured area"),
    ("T", "SLP", "slope(s)", "a surface with a relatively uniform slope angle"),
    ("S", "SLCE", "sluice", "a conduit or passage for carrying off surplus water from a waterbody, usually regulated by means of a sluice gate"),
    ("L", "SNOW", "snowfield", "an area of permanent snow and ice forming the accumulation area of a glacier"),
    ("H", "SD", "sound", "a long arm of the sea forming a channel between the mainland and an island or islands; or connecting two larger bodies of water"),
    ("S", "SPA", "spa", "a resort area usually developed around a medicinal spring"),
    ("S", "CTRS", "space center", "a facility for launching, tracking, or controlling satellites and space vehicles"),
    ("S", "SPLY", "spillway", "a passage or outlet through which surplus water flows over, around or through a dam"),
    ("T", "SPIT", "spit", "a narrow, straight or curved continuation of a beach into a waterbody"),
    ("H", "SPNG", "spring(s)", "a place where ground water flows naturally out of the ground"),
    ("T", "SPUR", "spur(s)", "a subordinate ridge projecting outward from a hill, mountain or other elevation"),
    ("S", "SQR", "square", "a broad, open, public area near the center of a town or city"),
    ("S", "STBL", "stable", "a building for the shelter and feeding of farm animals, especially horses"),
    ("S", "STDM", "stadium", "a structure with an enclosure for athletic games with tiers of seats for spectators"),
    ("S", "STPS", "steps", "stones or slabs placed for ease in ascending or descending a steep slope"),
    ("R", "STKR", "stock route", "a route taken by livestock herds"),
    ("T", "REG", "stony desert", "a desert plain characterized by a surface veneer of gravel and stones"),
    ("S", "RET", "store", "a building where goods and/or services are offered for sale"),
    ("S", "SHSE", "storehouse", "a building for storing goods, especially provisions"),
    ("H", "STRT", "strait", "a relatively narrow waterway, usually narrower and less extensive than a sound, connecting two larger bodies of water"),
    ("H", "STM", "stream", "a body of running water moving to a lower level in a channel on land"),
    ("H", "BNKR", "stream bank", "a sloping margin of a stream channel which normally confines the stream to its channel on land"),
    ("H", "STMB", "stream bend", "a conspicuously curved or bent segment of a stream"),
    ("S", "STMGS", "stream gauging station", "named place where a measuring station for a watercourse, reservoir or other water body exists"),
    ("H", "STMM", "stream mouth(s)", "a place where a stream discharges into a lagoon, lake, or the sea"),
    ("H", "STMS", "streams", "bodies of running water moving to a lower level in a channel on land"),
    ("R", "ST", "street", "a paved urban thoroughfare"),
    ("S", "DAMSB", "sub-surface dam", "a dam put down to bedrock in a sand river"),
    ("S", "SUBW", "subway", "a railroad used for mass public transportation primarily in urban areas, all or part of the system may be located below, above, or at ground level"),
    ("S", "SUBS", "subway station", "a facility comprising ticket office, platforms, etc. for loading and unloading subway passengers"),
    ("S", "MLSG", "sugar mill", "a facility where sugar cane is processed into raw sugar"),
    ("S", "ESTSG", "sugar plantation", "an estate that specializes in growing sugar cane"),
    ("S", "MFGSG", "sugar refinery", "a facility for converting raw sugar into refined sugar"),
    ("H", "SPNS", "sulphur spring(s)", "a place where sulphur ground water flows naturally out of the ground"),
    ("H", "SWMP", "swamp", "a wetland dominated by tree vegetation"),
    ("S", "SYG", "synagogue", "a place for Jewish worship and religious instruction"),
    ("U", "TMTU", "tablemount (or guyot)", "a seamount having a comparatively smooth, flat top"),
    ("U", "TMSU", "tablemounts (or guyots)", "seamounts having a comparatively smooth, flat top"),
    ("T", "TAL", "talus slope", "a steep concave slope formed by an accumulation of loose rock fragments at the base of a cliff or steep slope"),
    ("S", "OILT", "tank farm", "a tract of land occupied by large, cylindrical, metal tanks in which oil or liquid petrochemicals are stored"),
    ("S", "ESTT", "tea plantation", "an estate which specializes in growing tea bushes"),
    ("S", "SCHT", "technical school", "post-secondary school with a specifically technical or vocational curriculum"),
    ("S", "TMPL", "temple(s)", "an edifice dedicated to religious worship"),
    ("S", "AIRT", "terminal", "airport facilities for the handling of freight and passengers"),
    ("T", "TRR", "terrace", "a long, narrow alluvial platform bounded by steeper slopes above and below, usually overlooking a waterbody"),
    ("A", "TERR", "territory", "territory"),
    ("A", "ADM3", "third-order administrative division", "a subdivision of a second-order administrative division"),
    ("H", "CRKT", "tidal creek(s)", "a meandering channel in a coastal wetland subject to bi-directional tidal currents"),
    ("H", "FLTT", "tidal flat(s)", "a large flat area of mud or sand attached to the shore and alternately covered and uncovered by the tide"),
    ("S", "MNSN", "tin mine(s)", "a mine where tin ore is extracted"),
    ("S", "TOLL", "toll gate/barrier", "highway toll collection station"),
    ("S", "TMB", "tomb(s)", "a structure for interring bodies"),
    ("S", "TOWR", "tower", "a high conspicuous structure, typically much higher than its diameter"),
    ("S", "RDCR", "traffic circle", "a road junction formed around a central circle about which traffic moves in one direction only"),
    ("R", "TRL", "trail", "a path, track, or route used by pedestrians, animals, or off-road vehicles"),
    ("S", "TRANT", "transit terminal", "facilities for the handling of vehicular freight and passengers"),
    ("V", "TREE", "tree(s)", "a conspicuous tree used as a landmark"),
    ("S", "TRIG", "triangulation station", "a point on the earth whose position has been determined by triangulation"),
    ("L", "TRB", "tribal area", "a tract of land used by nomadic or other tribes"),
    ("V", "TUND", "tundra", "a marshy, treeless, high latitude plain, dominated by mosses, lichens, and low shrub vegetation under permafrost conditions"),
    ("R", "TNL", "tunnel", "a subterranean passageway for transportation"),
    ("R", "TNLS", "tunnels", "subterranean passageways for transportation"),
    ("H", "CNLSB", "underground irrigation canal(s)", "a gently inclined underground tunnel bringing water for irrigation from aquifers"),
    ("H", "LKSB", "underground lake", "a standing body of water in a cave"),
    ("U", "APNU", "undersea apron", "a gentle slope, with a generally smooth surface, particularly found around groups of islands and seamounts"),
    ("U", "ARCU", "undersea arch", "a low bulge around the southeastern end of the island of Hawaii"),
    ("U", "ARRU", "undersea arrugado", "an area of subdued corrugations off Baja California"),
    ("U", "BNKU", "undersea bank", "an elevation, typically located on a shelf, over which the depth of water is relatively shallow but sufficient for safe surface navigation"),
    ("U", "BKSU", "undersea banks", "elevations, typically located on a shelf, over which the depth of water is relatively shallow but sufficient for safe surface navigation"),
    ("U", "BSNU", "undersea basin", "a depression more or less equidimensional in plan and of variable extent"),
    ("U", "BNCU", "undersea bench", "a small terrace"),
    ("U", "BDLU", "undersea borderland", "a region adjacent to a continent, normally occupied by or bordering a shelf, that is highly irregular with depths well in excess of those typical of a shelf"),
    ("U", "CNYU", "undersea canyon", "a relatively narrow, deep depression with steep sides, the bottom of which generally has a continuous slope"),
    ("U", "CNSU", "undersea canyons", "relatively narrow, deep depressions with steep sides, the bottom of which generally has a continuous slope"),
    ("U", "CDAU", "undersea cordillera", "an entire mountain system including the subordinate ranges, interior plateaus, and basins"),
    ("U", "ESCU", "undersea escarpment (or scarp)", "an elongated and comparatively steep slope separating flat or gently sloping areas"),
    ("U", "FANU", "undersea fan", "a relatively smooth feature normally sloping away from the lower termination of a canyon or canyon system"),
    ("U", "FLTU", "undersea flat", "a small level or nearly level area"),
    ("U", "FRKU", "undersea fork", "a branch of a canyon or valley"),
    ("U", "FRSU", "undersea forks", "a branch of a canyon or valley"),
    ("U", "FRZU", "undersea fracture zone", "an extensive linear zone of irregular topography of the sea floor, characterized by steep-sided or asymmetrical ridges, troughs, or escarpments"),
    ("U", "FURU", "undersea furrow", "a closed, linear, narrow, shallow depression"),
    ("U", "GAPU", "undersea gap", "a narrow break in a ridge or rise"),
    ("U", "GLYU", "undersea gully", "a small valley-like feature"),
    ("U", "HLLU", "undersea hill", "an elevation rising generally less than 500 meters"),
    ("U", "HLSU", "undersea hills", "elevations rising generally less than 500 meters"),
    ("U", "HOLU", "undersea hole", "a small depression of the sea floor"),
    ("U", "KNLU", "undersea knoll", "an elevation rising generally more than 500 meters and less than 1,000 meters and of limited extent across the summit"),
    ("U", "KNSU", "undersea knolls", "elevations rising generally more than 500 meters and less than 1,000 meters and of limited extent across the summits"),
    ("U", "LDGU", "undersea ledge", "a rocky projection or outcrop, commonly linear and near shore"),
    ("U", "LEVU", "undersea levee", "an embankment bordering a canyon, valley, or seachannel"),
    ("U", "MDVU", "undersea median valley", "the axial depression of the mid-oceanic ridge system"),
    ("U", "MESU", "undersea mesa", "an isolated, extensive, flat-topped elevation on the shelf, with relatively steep sides"),
    ("U", "MOTU", "undersea moat", "an annular depression that may not be continuous, located at the base of many seamounts, islands, and other isolated elevations"),
    ("U", "MNDU", "undersea mound", "a low, isolated, rounded hill"),
    ("U", "MTU", "undersea mountain", "a well-delineated subdivision of a large and complex positive feature"),
    ("U", "MTSU", "undersea mountains", "well-delineated subdivisions of a large and complex positive feature"),
    ("U", "PKU", "undersea peak", "a prominent elevation, part of a larger feature, either pointed or of very limited extent across the summit"),
    ("U", "PKSU", "undersea peaks", "prominent elevations, part of a larger feature, either pointed or of very limited extent across the summit"),
    ("U", "PNLU", "undersea pinnacle", "a high tower or spire-shaped pillar of rock or coral, alone or cresting a summit"),
    ("U", "PLNU", "undersea plain", "a flat, gently sloping or nearly level region"),
    ("U", "PLTU", "undersea plateau", "a comparatively flat-topped feature of considerable extent, dropping off abruptly on one or more sides"),
    ("U", "PLFU", "undersea platform", "a flat or gently sloping underwater surface extending seaward from the shore"),
    ("U", "PRVU", "undersea province", "a region identifiable by a group of similar physiographic features whose characteristics are markedly in contrast with surrounding areas"),
    ("U", "RMPU", "undersea ramp", "a gentle slope connecting areas of different elevations"),
    ("U", "RNGU", "undersea range", "a series of associated ridges or seamounts"),
    ("U", "RAVU", "undersea ravine", "a small canyon"),
    ("U", "RFU", "undersea reef", "a surface-navigation hazard composed of consolidated material"),
    ("U", "RFSU", "undersea reefs", "surface-navigation hazards composed of consolidated material"),
    ("U", "RDGU", "undersea ridge", "a long narrow elevation with steep sides"),
    ("U", "RDSU", "undersea ridges", "long narrow elevations with steep sides"),
    ("U", "RISU", "undersea rise", "a broad elevation that rises gently, and generally smoothly, from the sea floor"),
    ("U", "SDLU", "undersea saddle", "a low part, resembling in shape a saddle, in a ridge or between contiguous seamounts"),
    ("U", "SHFU", "undersea shelf", "a zone adjacent to a continent (or around an island) that extends from the low water line to a depth at which there is usually a marked increase of slope towards oceanic depths"),
    ("U", "EDGU", "undersea shelf edge", "a line along which there is a marked increase of slope at the outer margin of a continental shelf or island shelf"),
    ("U", "SHVU", "undersea shelf valley", "a valley on the shelf, generally the shoreward extension of a canyon"),
    ("U", "SHLU", "undersea shoal", "a surface-navigation hazard composed of unconsolidated material"),
    ("U", "SHSU", "undersea shoals", "hazards to surface navigation composed of unconsolidated material"),
    ("U", "SILU", "undersea sill", "the low part of an underwater gap or saddle separating basins, including a similar feature at the mouth of a fjord"),
    ("U", "SLPU", "undersea slope", "the slope seaward from the shelf edge to the beginning of a continental rise or the point where there is a general reduction in slope"),
    ("U", "SPRU", "undersea spur", "a subordinate elevation, ridge, or rise projecting outward from a larger feature"),
    ("U", "TERU", "undersea terrace", "a relatively flat horizontal or gently inclined surface, sometimes long and narrow, which is bounded by a steeper ascending slope on one side and by a steep descending slope on the opposite side"),
    ("U", "TNGU", "undersea tongue", "an elongate (tongue-like) extension of a flat sea floor into an adjacent higher feature"),
    ("U", "TRNU", "undersea trench", "a long, narrow, characteristically very deep and asymmetrical depression of the sea floor, with relatively steep sides"),
    ("U", "TRGU", "undersea trough", "a long depression of the sea floor characteristically flat bottomed and steep sided, and normally shallower than a trench"),
    ("U", "VALU", "undersea valley", "a relatively shallow, wide depression, the bottom of which usually has a continuous gradient"),
    ("U", "VLSU", "undersea valleys", "a relatively shallow, wide depression, the bottom of which usually has a continuous gradient"),
    ("S", "USGE", "United States Government Establishment", "a facility operated by the United States Government in Panama"),
    ("T", "UPLD", "upland", "an extensive interior region of high land with low to moderate surface relief"),
    ("T", "VAL", "valley", "an elongated depression usually traversed by a stream"),
    ("T", "VALS", "valleys", "elongated depressions usually traversed by a stream"),
    ("S", "VETF", "veterinary facility", "a building or camp at which veterinary services are available"),
    ("V", "VIN", "vineyard", "a planting of grapevines"),
    ("V", "VINS", "vineyards", "plantings of grapevines"),
    ("T", "VLC", "volcano", "a conical elevation composed of volcanic materials with a crater at the top"),
    ("H", "WAD", "wadi", "a valley or ravine, bounded by relatively steep banks, which in the rainy season becomes a watercourse; found primarily in North Africa and the Middle East"),
    ("H", "WADB", "wadi bend", "a conspicuously curved or bent segment of a wadi"),
    ("H", "WADJ", "wadi junction", "a place where two or more wadies join"),
    ("H", "WADM", "wadi mouth", "the lower terminus of a wadi where it widens into an adjoining floodplain, depression, or waterbody"),
    ("H", "WADS", "wadies", "valleys or ravines, bounded by relatively steep banks, which in the rainy season become watercourses; found primarily in North Africa and the Middle East"),
    ("S", "WALL", "wall", "a thick masonry structure, usually enclosing a field or building, or forming the side of a structure"),
    ("S", "MLWTR", "water mill", "a mill powered by running water"),
    ("S", "PMPW", "water pumping station", "a facility for pumping water from a major well or through a pipeline"),
    ("H", "RSVT", "water tank", "a contained pool or tank of water at, below, or above ground level"),
    ("H", "WTRC", "watercourse", "a natural, well-defined channel produced by flowing water, or an artificial channel designed to carry flowing water"),
    ("H", "FLLS", "waterfall(s)", "a perpendicular or very steep descent of the water of a stream"),
    ("H", "WTRH", "waterhole(s)", "a natural hole, hollow, or small depression that contains water, used by man and animals, especially in arid areas"),
    ("S", "WTRW", "waterworks", "a facility for supplying potable water through a water source and a system of pumps and filtration beds"),
    ("S", "WEIR", "weir(s)", "a small dam in a stream, designed to raise the water level or to divert stream flow through a desired channel"),
    ("H", "WLL", "well", "a cylindrical hole, pit, or tunnel drilled or dug down to a depth from which water, oil, or gas can be pumped or brought to the surface"),
    ("H", "WLLS", "wells", "cylindrical holes, pits, or tunnels drilled or dug down to a depth from which water, oil, or gas can be pumped or brought to the surface"),
    ("H", "WTLD", "wetland", "an area subject to inundation, usually characterized by bog, marsh, or swamp vegetation"),
    ("S", "STNW", "whaling station", "a facility for butchering whales and processing train oil"),
    ("S", "WHRF", "wharf(-ves)", "a structure of open rather than solid construction along a shore or a bank which provides berthing for ships and cargo-handling facilities"),
    ("H", "WHRL", "whirlpool", "a turbulent, rotating movement of water in a stream"),
    ("L", "RESW", "wildlife reserve", "a tract of public land reserved for the preservation of wildlife"),
    ("S", "MLWND", "windmill", "a mill or water pump powered by wind"),
    ("S", "WRCK", "wreck", "the site of the remains of a wrecked vessel"),
    ("A", "ZN", "zone", "zone"),
    ("S", "ZOO", "zoo", "a zoological garden or park where wild animals are kept for exhibition"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ActivityScope.xml
ACTIVITY_SCOPE = (
    ("code", "name", "description"),
    ("1", "Global", "The activity scope is global"),
    ("2", "Regional", "The activity scope is a supranational region"),
    ("3", "Multi-national", "The activity scope covers multiple countries, that don't constitute a region"),
    ("4", "National", "The activity scope covers one country"),
    ("5", "Sub-national: Multi-first-level administrative areas", "The activity scope covers more than one first-level subnational administrative areas (e.g. counties, provinces, states)"),
    ("6", "Sub-national: Single first-level administrative area", "The activity scope covers one first-level subnational administrative area (e.g. country, province, state)"),
    ("7", "Sub-national: Single second-level administrative area", "The activity scope covers one second-level subnational administrative area (e.g. municipality or district)"),
    ("8", "Single location", "The activity scope covers one single location (e.g. town, village, farm)"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GeographicLocationReach.xml
GEOGRAPHIC_LOCATION_REACH = (
    ("code", "name", "description"),
    ("1", "Activity", "The location specifies where the activity is carried out"),
    ("2", "Intended Beneficiaries", "The location specifies where the intended beneficiaries of the activity live"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Region.xml
REGION = (
    ("code", "name"),
    ("88", "States Ex-Yugoslavia unspecified"),
    ("89", "Europe, regional"),
    ("189", "North of Sahara, regional"),
    ("289", "South of Sahara, regional"),
    ("298", "Africa, regional"),
    ("380", "West Indies, regional"),
    ("389", "North & Central America, regional"),
    ("489", "South America, regional"),
    ("498", "America, regional"),
    ("589", "Middle East, regional"),
    ("619", "Central Asia, regional"),
    ("679", "South Asia, regional"),
    ("689", "South & Central Asia, regional"),
    ("789", "Far East Asia, regional"),
    ("798", "Asia, regional"),
    ("889", "Oceania, regional"),
    ("998", "Developing countries, unspecified"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/LoanRepaymentPeriod.xml
LOAN_REPAYMENT_PERIOD = (
    ("code", "name", "description"),
    ("1", "Annual", "The loan has 1 repayment per year"),
    ("2", "Semi-annual", "The loan has 2 repayments per year"),
    ("4", "Quarterly", "The loan has 4 repayments per year "),
    ("12", "Monthly", "The loan has 12, monthly repayments per year"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ActivityStatus.xml
ACTIVITY_STATUS = (
    ("code", "name", "description"),
    ("1", _("Pipeline/identification"), _("The activity is being scoped or planned ")),
    ("2", _("Implementation"), _("The activity is currently being implemented")),
    ("3", _("Completion"), _("Physical activity is complete or the final disbursement has been made.")),
    ("4", _("Post-completion"), _("Physical activity is complete or the final disbursement has been made, but the activity remains open pending financial sign off or M&E")),
    ("5", _("Cancelled"), _("The activity has been cancelled")),
    ("6", _("Suspended"), _("The activity has been temporarily suspended")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Sector.xml
SECTOR = (
    ("category", "code", "name", "description"),
    ("111", "11110", "Education policy and administrative management", "Education sector policy, planning and programmes; aid to education ministries, administration and management systems; institution capacity building and advice; school management and governance; curriculum and materials development; unspecified education activities."),
    ("111", "11120", "Education facilities and training", "Educational buildings, equipment, materials; subsidiary services to education (boarding facilities, staff housing); language training; colloquia, seminars, lectures, etc."),
    ("111", "11130", "Teacher training", "Teacher education (where the level of education is unspecified); in-service and pre-service training; materials development."),
    ("111", "11182", "Educational research", "Research and studies on education effectiveness, relevance and quality; systematic evaluation and monitoring."),
    ("112", "11220", "Primary education", "Formal and non-formal primary education for children; all elementary and first cycle systematic instruction; provision of learning materials."),
    ("112", "11230", "Basic life skills for youth and adults", "Formal and non-formal education for basic life skills for young people and adults (adults education); literacy and numeracy training."),
    ("112", "11231", "Basic life skills for youth", "Formal and non-formal education for basic life skills for young people."),
    ("112", "11232", "Primary education equivalent for adults", "Formal primary education for adults."),
    ("112", "11240", "Early childhood education", "Formal and non-formal pre-school education."),
    ("113", "11320", "Secondary education", "Second cycle systematic instruction at both junior and senior levels."),
    ("113", "11321", "Lower secondary education", "Second cycle systematic instruction at junior level."),
    ("113", "11322", "Upper secondary education", "Second cycle systematic instruction at senior level."),
    ("113", "11330", "Vocational training", "Elementary vocational training and secondary level technical education; on-the job training; apprenticeships; including informal vocational training."),
    ("114", "11420", "Higher education", "Degree and diploma programmes at universities, colleges and polytechnics; scholarships."),
    ("114", "11430", "Advanced technical and managerial training", "Professional-level vocational training programmes and in-service training."),
    ("121", "12110", "Health policy and administrative management", "Health sector policy, planning and programmes; aid to health ministries, public health administration; institution capacity building and advice; medical insurance programmes; unspecified health activities."),
    ("121", "12181", "Medical education/training", "Medical education and training for tertiary level services."),
    ("121", "12182", "Medical research", "General medical research (excluding basic health research)."),
    ("121", "12191", "Medical services", "Laboratories, specialised clinics and hospitals (including equipment and supplies); ambulances; dental services; mental health care; medical rehabilitation; control of non-infectious diseases; drug and substance abuse control [excluding narcotics traffic control (16063)]."),
    ("122", "12220", "Basic health care", "Basic and primary health care programmes; paramedical and nursing care programmes; supply of drugs, medicines and vaccines related to basic health care."),
    ("122", "12230", "Basic health infrastructure", "District-level hospitals, clinics and dispensaries and related medical equipment; excluding specialised hospitals and clinics (12191)."),
    ("122", "12240", "Basic nutrition", "Direct feeding programmes (maternal feeding, breastfeeding and weaning foods, child feeding, school feeding); determination of micro-nutrient deficiencies; provision of vitamin A, iodine, iron etc.; monitoring of nutritional status; nutrition and food hygiene education; household food security."),
    ("122", "12250", "Infectious disease control", "Immunisation; prevention and control of infectious and parasite diseases, except malaria (12262), tuberculosis (12263), HIV/AIDS and other STDs (13040). It includes diarrheal diseases, vector-borne diseases (e.g. river blindness and guinea worm), viral diseases, mycosis, helminthiasis, zoonosis, diseases by other bacteria and viruses, pediculosis, etc."),
    ("122", "12261", "Health education", "Information, education and training of the population for improving health knowledge and practices; public health and awareness campaigns; promotion of improved personal hygiene practices, including use of sanitation facilities and handwashing with soap."),
    ("122", "12262", "Malaria control", "Prevention and control of malaria."),
    ("122", "12263", "Tuberculosis control", "Immunisation, prevention and control of tuberculosis."),
    ("122", "12281", "Health personnel development", "Training of health staff for basic health care services."),
    ("130", "13010", "Population policy and administrative management", "Population/development policies; census work, vital registration; migration data; demographic research/analysis; reproductive health research; unspecified population activities."),
    ("130", "13020", "Reproductive health care", "Promotion of reproductive health; prenatal and postnatal care including delivery; prevention and treatment of infertility; prevention and management of consequences of abortion; safe motherhood activities."),
    ("130", "13030", "Family planning", "Family planning services including counselling; information, education and communication (IEC) activities; delivery of contraceptives; capacity building and training."),
    ("130", "13040", "STD control including HIV/AIDS", "All activities related to sexually transmitted diseases and HIV/AIDS control e.g. information, education and communication; testing; prevention; treatment, care."),
    ("130", "13081", "Personnel development for population and reproductive health", "Education and training of health staff for population and reproductive health care services."),
    ("140", "14010", "Water sector policy and administrative management", "Water sector policy and governance, including legislation, regulation, planning and management as well as transboundary management of water; institutional capacity development; activities supporting the Integrated Water Resource Management approach (IWRM: see box below)."),
    ("140", "14015", "Water resources conservation (including data collection)", "Collection and usage of quantitative and qualitative data on water resources; creation and sharing of water knowledge; conservation and rehabilitation of inland surface waters (rivers, lakes etc.), ground water and coastal waters; prevention of water contamination."),
    ("140", "14020", "Water supply and sanitation - large systems", "Programmes where components according to 14021 and 14022 cannot be identified. When components are known, they should individually be reported under their respective purpose codes: water supply (14021), sanitation (14022), and hygiene (12261)."),
    ("140", "14021", "Water supply - large systems", "Potable water treatment plants; intake works; storage; water supply pumping stations; large scale transmission / conveyance and distribution systems."),
    ("140", "14022", "Sanitation - large systems", "Large scale sewerage including trunk sewers and sewage pumping stations; domestic and industrial waste water treatment plants."),
    ("140", "14030", "Basic drinking water supply and basic sanitation", "Programmes where components according to 14031 and 14032 cannot be identified. When components are known, they should individually be reported under their respective purpose codes: water supply (14031), sanitation (14032), and hygiene (12261)."),
    ("140", "14031", "Basic drinking water supply", "Rural water supply schemes using handpumps, spring catchments, gravity-fed systems, rainwater collection and fog harvesting, storage tanks, small distribution systems typically with shared connections/points of use. Urban schemes using handpumps and local neighbourhood networks including those with shared connections."),
    ("140", "14032", "Basic sanitation", "Latrines, on-site disposal and alternative sanitation systems, including the promotion of household and community investments in the construction of these facilities. (Use code 12261 for activities promoting improved personal hygiene practices.)"),
    ("140", "14040", "River basins’ development", "Infrastructure-focused integrated river basin projects and related institutional activities; river flow control; dams and reservoirs [excluding dams primarily for irrigation (31140) and hydropower (23220) and activities related to river transport (21040)]."),
    ("140", "14050", "Waste management / disposal", "Municipal and industrial solid waste management, including hazardous and toxic waste; collection, disposal and treatment; landfill areas; composting and reuse."),
    ("140", "14081", "Education and training in water supply and sanitation", "Education and training for sector professionals and service providers."),
    ("151", "15110", "Public sector policy and administrative management", "Institution-building assistance to strengthen core public sector management systems and capacities. This includes macro-economic and other policy management, co-ordination, planning and reform; human resource management; organisational development; civil service reform; e-government; development planning, monitoring and evaluation; support to ministries involved in aid co-ordination; other ministries and government departments when sector cannot be specified. (Use specific sector codes for development of systems and capacities in sector ministries.)"),
    ("151", "15111", "Public Finance Management (PFM)", "Fiscal policy and planning; support to ministries of finance; strengthening financial and managerial accountability; public expenditure management; improving financial management systems; budget drafting; inter-governmental fiscal relations, public audit, public debt. (Use code 15114 for domestic revenue mobilisation and code 33120 for customs)."),
    ("151", "15112", "Decentralisation and support to subnational government", "Decentralisation processes (including political, administrative and fiscal dimensions); intergovernmental relations and federalism; strengthening departments of regional and local government, regional and local authorities and their national associations. (Use specific sector codes for decentralisation of sector management and services.)"),
    ("151", "15113", "Anti-corruption organisations and institutions", "Specialised organisations, institutions and frameworks for the prevention of and combat against corruption, bribery, money- laundering and other aspects of organised crime, with or without law enforcement powers, e.g. anti-corruption commissions and monitoring bodies, special investigation services, institutions and initiatives of integrity and ethics oversight, specialised NGOs, other civil society and citizens’ organisations directly concerned with corruption."),
    ("151", "15114", "Domestic Revenue Mobilisation", "Support to domestic revenue mobilisation/tax policy, analysis and administration as well as non-tax public revenue, which includes work with ministries of finance, line ministries, revenue authorities or other local, regional or national public bodies. (Use code 16010 for social security and other social protection.)"),
    ("151", "15116", "Tax collection", "Operation of the inland revenue authority."),
    ("151", "15117", "Budget planning", "Operation of the budget office and planning as part of the budget process."),
    ("151", "15118", "National audit", "Operation of the accounting and audit services."),
    ("151", "15119", "Debt and aid management", "Management of public debt and foreign aid received (in the partner country). For reporting on debt reorganisation, use codes 600xx."),
    ("151", "15120", "Public sector financial management", "Strengthening financial and managerial accountability; public expenditure management; improving financial management systems; tax assessment procedures; budget drafting; field auditing; measures against waste, fraud and corruption."),
    ("151", "15121", "Foreign affairs", "Administration of external affairs and services."),
    ("151", "15122", "Diplomatic missions", "Operation of diplomatic and consular missions stationed abroad or at offices of international organisations."),
    ("151", "15123", "Administration of developing countries' foreign aid", "Support to administration of developing countries' foreign aid (including triangular and south-south cooperation)."),
    ("151", "15124", "General personnel services", "Administration and operation of the civil service including policies, procedures and regulations."),
    ("151", "15125", "Central procurement", "Administration and operation of centralised supply and purchasing services."),
    ("151", "15126", "Other general public services", "Maintenance and storage of government records and archives, operation of government-owned or occupied buildings, central motor vehicle pools, government-operated printing offices, centralised computer and data processing services, etc."),
    ("151", "15127", "National monitoring and evaluation", "Operation or support of institutions providing national monitoring and evaluation."),
    ("151", "15128", "Local government finance", "Financial transfers to local government; support to institutions managing such transfers. (Use specific sector codes for sector-related transfers.)"),
    ("151", "15129", "Other central transfers to institutions", "Transfers to non sector-specific autonomous bodies or state-owned enterprises outside of local government finance; support to institutions managing such transfers. (Use specific sector codes for sector-related transfers.)"),
    ("151", "15130", "Legal and judicial development", "Support to institutions, systems and procedures of the justice sector, both formal and informal; support to ministries of justice, the interior and home affairs; judges and courts; legal drafting services; bar and lawyers associations; professional legal education; maintenance of law and order and public safety; border management; law enforcement agencies, police, prisons and their supervision; ombudsmen; alternative dispute resolution, arbitration and mediation; legal aid and counsel; traditional, indigenous and paralegal practices that fall outside the formal legal system. Measures that support the improvement of legal frameworks, constitutions, laws and regulations; legislative and constitutional drafting and review; legal reform; integration of formal and informal systems of law. Public legal education; dissemination of information on entitlements and remedies for injustice; awareness campaigns. (Use codes 152xx for activities that are primarily aimed at supporting security system reform or undertaken in connection with post-conflict and peace building activities.)"),
    ("151", "15131", "Justice, law and order policy, planning and administration", "Judicial law and order sectors; policy development within ministries of justice or equivalents."),
    ("151", "15132", "Police", "Police affairs and services."),
    ("151", "15133", "Fire and rescue services", "Fire-prevention and fire-fighting affairs and services."),
    ("151", "15134", "Judicial affairs", "Civil and criminal law courts and the judicial system, including enforcement of fines and legal settlements imposed by the courts and operation of parole and probation systems."),
    ("151", "15135", "Ombudsman", "Independent service representing the interests of the public by investigating and addressing complaints of unfair treatment or maladministration."),
    ("151", "15136", "Immigration", "Immigration affairs and services, including alien registration, issuing work and travel documents to immigrants."),
    ("151", "15137", "Prisons", ""),
    ("151", "15140", "Government administration", "Systems of government including parliament, local government, decentralisation; civil service and civil service reform. Including general services by government (or commissioned by government) not elsewhere specified e.g. police, fire protection; cartography, meteorology, legal metrology, aerial surveys and remote sensing; administrative buildings."),
    ("151", "15142", "Macroeconomic policy", "Macroeconomic policy development and implementation."),
    ("151", "15143", "Meteorological services", "Operation or support of institutions dealing with weather forecasting."),
    ("151", "15144", "National standards development", "Operation or support of institutions dealing with national standards development. (Use code 16062 for statistical capacity-building.)"),
    ("151", "15150", "Democratic participation and civil society", "Support to the exercise of democracy and diverse forms of participation of citizens beyond elections (15151); direct democracy instruments such as referenda and citizens’ initiatives; support to organisations to represent and advocate for their members, to monitor, engage and hold governments to account, and to help citizens learn to act in the public sphere; curricula and teaching for civic education at various levels. (This purpose code is restricted to activities targeting governance issues. When assistance to civil society is for non-governance purposes use other appropriate purpose codes.)"),
    ("151", "15151", "Elections", "Electoral management bodies and processes, election observation, voters' education. (Use code 15230 when in the context of an international peacekeeping operation)."),
    ("151", "15152", "Legislatures and political parties", "Assistance to strengthen key functions of legislatures/ parliaments including subnational assemblies and councils (representation; oversight; legislation), such as improving the capacity of legislative bodies, improving legislatures’ committees and administrative procedures,; research and information management systems; providing training programmes for legislators and support personnel. Assistance to political parties and strengthening of party systems."),
    ("151", "15153", "Media and free flow of information", "Activities that support free and uncensored flow of information on public issues; activities that increase the editorial and technical skills and the integrity of the print and broadcast media, e.g. training of journalists. (Use codes 22010-22040 for provision of equipment and capital assistance to media.)"),
    ("151", "15154", "Executive office", "Administration, operation or support of executive office. Includes office of the chief executive at all levels of government (monarch, governor-general, president, prime minister, governor, mayor, etc.)."),
    ("151", "15155", "Tax policy and administration support", ""),
    ("151", "15156", "Other non-tax revenue mobilisation", "Non-tax public revenue, which includes line ministries, revenue authorities or other local, regional or national public bodies."),
    ("151", "15160", "Human rights", "Measures to support specialised official human rights institutions and mechanisms at universal, regional, national and local levels in their statutory roles to promote and protect civil and political, economic, social and cultural rights as defined in international conventions and covenants; translation of international human rights commitments into national legislation; reporting and follow-up; human rights dialogue. Human rights defenders and human rights NGOs; human rights advocacy, activism, mobilisation; awareness raising and public human rights education. Human rights programming targeting specific groups, e.g. children, persons with disabilities, migrants, ethnic, religious, linguistic and sexual minorities, indigenous people and those suffering from caste discrimination, victims of trafficking, victims of torture. (Use code 15230 when in the context of a peacekeeping operation and code 15180 for ending violence against women and girls.)"),
    ("151", "15161", "Elections", "Electoral assistance and monitoring, voters' education [other than in connection with UN peace building (15230)]."),
    ("151", "15162", "Human rights", "Monitoring of human rights performance; support for national and regional human rights bodies; protection of ethnic, religious and cultural minorities [other than in connection with un peace building (15230)]."),
    ("151", "15163", "Free flow of information", "Uncensored flow of information on public issues, including activities that increase the professionalism, skills and integrity of the print and broadcast media (e.g. training of journalists)."),
    ("151", "15164", "Women's equality organisations and institutions", "Support for institutions and organisations (governmental and non-governmental) working for gender equality and women's empowerment."),
    ("151", "15170", "Women’s equality organisations and institutions", "Support for institutions and organisations (governmental and non-governmental) working for gender equality and women’s empowerment."),
    ("151", "15180", "Ending violence against women and girls", "Support to programmes designed to prevent and eliminate all forms of violence against women and girls/gender-based violence. This encompasses a broad range of forms of physical, sexual and psychological violence including but not limited to: intimate partner violence (domestic violence); sexual violence; female genital mutilation/cutting (FGM/C); child, early and forced marriage; acid throwing; honour killings; and trafficking of women and girls. Prevention activities may include efforts to empower women and girls; change attitudes, norms and behaviour; adopt and enact legal reforms; and strengthen implementation of laws and policies on ending violence against women and girls, including through strengthening institutional capacity. Interventions to respond to violence against women and girls/gender-based violence may include expanding access to services including legal assistance, psychosocial counselling and health care; training personnel to respond more effectively to the needs of survivors; and ensuring investigation, prosecution and punishment of perpetrators of violence."),
    ("151", "15185", "Local government administration", "Decentralisation processes (including political, administrative and fiscal dimensions); intergovernmental relations and federalism; strengthening local authorities."),
    ("152", "15210", "Security system management and reform", "Technical co-operation provided to parliament, government ministries, law enforcement agencies and the judiciary to assist review and reform of the security system to improve democratic governance and civilian control; technical co-operation provided to government to improve civilian oversight and democratic control of budgeting, management, accountability and auditing of security expenditure, including military budgets, as part of a public expenditure management programme; assistance to civil society to enhance its competence and capacity to scrutinise the security system so that it is managed in accordance with democratic norms and principles of accountability, transparency and good governance. [Other than in the context of an international peacekeeping operation (15230).]"),
    ("152", "15220", "Civilian peace-building, conflict prevention and resolution", "Support for civilian activities related to peace building, conflict prevention and resolution, including capacity building, monitoring, dialogue and information exchange. Bilateral participation in international civilian peace missions such as those conducted by the UN Department of Political Affairs (UNDPA) or the European Union (European Security and Defence Policy), and contributions to civilian peace funds or commissions (e.g. Peacebuilding Commission, Peacebuilding thematic window of the MDG achievement fund etc.). The contributions can take the form of financing or provision of equipment or civilian or military personnel (e.g. for training civilians). (Use code 15230 for bilateral participation in international peacekeeping operations)."),
    ("152", "15230", "Participation in international peacekeeping operations", "Bilateral participation in peacekeeping operations mandated or authorised by the United Nations (UN) through Security Council resolutions, and conducted by international organisations, e.g. UN, NATO, the European Union (Security and Defence Policy security-related operations), or regional groupings of developing countries. Direct contributions to the UN Department for Peacekeeping Operations (UNDPKO) budget are excluded from bilateral ODA (they are reportable in part as multilateral ODA, see Annex 9). The activities that can be reported as bilateral ODA under this code are limited to: human rights and election monitoring; reintegration of demobilised soldiers; rehabilitation of basic national infrastructure; monitoring or retraining of civil administrators and police forces; security sector reform and other rule of law-related activities; training in customs and border control procedures; advice or training in fiscal or macroeconomic stabilisation policy; repatriation and demobilisation of armed factions, and disposal of their weapons; explosive mine removal. The enforcement aspects of international peacekeeping operations are not reportable as ODA. ODA-eligible bilateral participation in peacekeeping operations can take the form of financing or provision of equipment or military or civilian personnel (e.g. police officers). The reportable cost is calculated as the excess over what the personnel and equipment would have cost to maintain had they not been assigned to take part in a peace operation. Costs for military contingents participating in UNDPKO peacekeeping operations are not reportable as ODA. International peacekeeping operations may include humanitarian-type activities (contributions to the form of equipment or personnel), as described in codes 7xxxx. These should be included under code 15230 if they are an integrated part of the activities above, otherwise they should be reported as humanitarian aid.NB: When using this code, indicate the name of the operation in the short description of the activity reported."),
    ("152", "15240", "Reintegration and SALW control", "Reintegration of demobilised military personnel into the economy; conversion of production facilities from military to civilian outputs; technical co-operation to control, prevent and/or reduce the proliferation of small arms and light weapons (SALW) – see para. 80 of the Directives for definition of SALW activities covered. [Other than in the context of an international peacekeeping operation (15230) or child soldiers (15261)]."),
    ("152", "15250", "Removal of land mines and explosive remnants of war", "All activities related to land mines and explosive remnants of war which have benefits to developing countries as their main objective, including removal of land mines and explosive remnants of war, and stockpile destruction for developmental purposes [other than in the context of an international peacekeeping operation (15230)]; risk education and awareness raising; rehabilitation, reintegration and assistance to victims, and research and development on demining and clearance. Only activities for civilian purposes are ODA-eligible."),
    ("152", "15261", "Child soldiers (Prevention and demobilisation)", "Technical co-operation provided to government – and assistance to civil society organisations – to support and apply legislation designed to prevent the recruitment of child soldiers, and to demobilise, disarm, reintegrate, repatriate and resettle (DDR) child soldiers."),
    ("160", "16010", "Social/ welfare services", "Social legislation and administration; institution capacity building and advice; social security and other social schemes; special programmes for the elderly, orphans, the disabled, street children; social dimensions of structural adjustment; unspecified social infrastructure and services, including consumer protection."),
    ("160", "16011", "Social protection and welfare services policy, planning and administration", "Administration of overall social protection policies, plans, programmes and budgets including legislation, standards and statistics on social protection."),
    ("160", "16012", "Social security (excl pensions)", "Social protection shemes in the form of cash or in-kind benefits to people unable to work due to sickness or injury."),
    ("160", "16013", "General pensions", "Social protection schemes in the form of cash or in-kind benefits, including pensions, against the risks linked to old age."),
    ("160", "16014", "Civil service pensions", "Pension schemes for government personnel."),
    ("160", "16015", "Social services (incl youth development and women+ children)", "Social protection schemes in the form of cash or in-kind benefits to households with dependent children, including parental leave benefits."),
    ("160", "16020", "Employment policy and administrative management", "Employment policy and planning; labour law; labour unions; institution capacity building and advice; support programmes for unemployed; employment creation and income generation programmes; occupational safety and health; combating child labour."),
    ("160", "16030", "Housing policy and administrative management", "Housing sector policy, planning and programmes; excluding low-cost housing and slum clearance (16040)."),
    ("160", "16040", "Low-cost housing", "Including slum clearance."),
    ("160", "16050", "Multisector aid for basic social services", "Basic social services are defined to include basic education, basic health, basic nutrition, population/reproductive health and basic drinking water supply and basic sanitation."),
    ("160", "16061", "Culture and recreation", "Including libraries and museums."),
    ("160", "16062", "Statistical capacity building", "Both in national statistical offices and any other government ministries."),
    ("160", "16063", "Narcotics control", "In-country and customs controls including training of the police; educational programmes and awareness campaigns to restrict narcotics traffic and in-country distribution."),
    ("160", "16064", "Social mitigation of HIV/AIDS", "Special programmes to address the consequences of HIV/AIDS, e.g. social, legal and economic assistance to people living with HIV/AIDS including food security and employment; support to vulnerable groups and children orphaned by HIV/AIDS; human rights of HIV/AIDS affected people."),
    ("160", "16065", "Recreation and sport", ""),
    ("160", "16066", "Culture", ""),
    ("210", "21010", "Transport policy and administrative management", "Transport sector policy, planning and programmes; aid to transport ministries; institution capacity building and advice; unspecified transport; activities that combine road, rail, water and/or air transport. Whenever possible, report transport of goods under the sector of the good being transported."),
    ("210", "21011", "Transport policy, planning and administration", "Administration of affairs and services concerning transport systems."),
    ("210", "21012", "Public transport services", "Administration of affairs and services concerning public transport."),
    ("210", "21013", "Transport regulation", "Supervision and regulation of users, operations, construction and maintenance of transport systems (registration, licensing, inspection of equipment, operator skills and training; safety standards, franchises, tarriffs, levels of service, etc.)."),
    ("210", "21020", "Road transport", "Road infrastructure, road vehicles; passenger road transport, motor passenger cars."),
    ("210", "21021", "Feeder road construction", "Construction or operation of feeder road transport systems and facilities."),
    ("210", "21022", "Feeder road maintenance", "Maintenance of feeder road transport systems and facilities."),
    ("210", "21023", "National road construction", "Construction or operation of national road transport systems and facilities."),
    ("210", "21024", "National road maintenance", "Maintenance of national road transport systems and facilities."),
    ("210", "21030", "Rail transport", "Rail infrastructure, rail equipment, locomotives, other rolling stock; including light rail (tram) and underground systems."),
    ("210", "21040", "Water transport", "Harbours and docks, harbour guidance systems, ships and boats; river and other inland water transport, inland barges and vessels."),
    ("210", "21050", "Air transport", "Airports, airport guidance systems, aeroplanes, aeroplane maintenance equipment."),
    ("210", "21061", "Storage", "Whether or not related to transportation. Whenever possible, report storage projects under the sector of the resource being stored."),
    ("210", "21081", "Education and training in transport and storage", ""),
    ("220", "22010", "Communications policy and administrative management", "Communications sector policy, planning and programmes; institution capacity building and advice; including postal services development; unspecified communications activities."),
    ("220", "22011", "Communications policy, planning and administration", ""),
    ("220", "22012", "Postal services", "Development and operation of postal services."),
    ("220", "22013", "Information services", "Provision of information services."),
    ("220", "22020", "Telecommunications", "Telephone networks, telecommunication satellites, earth stations."),
    ("220", "22030", "Radio/television/print media", "Radio and TV links, equipment; newspapers; printing and publishing."),
    ("220", "22040", "Information and communication technology (ICT)", "Computer hardware and software; internet access; IT training. When sector cannot be specified."),
    ("230", "23010", "Energy policy and administrative management", "Energy sector policy, planning and programmes; aid to energy ministries; institution capacity building and advice; unspecified energy activities including energy conservation."),
    ("230", "23020", "Power generation/non-renewable sources", "Thermal power plants including when heat source cannot be determined; combined gas-coal power plants."),
    ("230", "23030", "Power generation/renewable sources", "Including policy, planning, development programmes, surveys and incentives. Fuelwood/ charcoal production should be included under forestry (31261)."),
    ("230", "23040", "Electrical transmission/ distribution", "Distribution from power source to end user; transmission lines."),
    ("230", "23050", "Gas distribution", "Delivery for use by ultimate consumer."),
    ("230", "23061", "Oil-fired power plants", "Including diesel power plants."),
    ("230", "23062", "Gas-fired power plants", ""),
    ("230", "23063", "Coal-fired power plants", ""),
    ("230", "23064", "Nuclear power plants", "Including nuclear safety."),
    ("230", "23065", "Hydro-electric power plants", "Including power-generating river barges."),
    ("230", "23066", "Geothermal energy", ""),
    ("230", "23067", "Solar energy", "Including photo-voltaic cells, solar thermal applications and solar heating."),
    ("230", "23068", "Wind power", "Wind energy for water lifting and electric power generation."),
    ("230", "23069", "Ocean power", "Including ocean thermal energy conversion, tidal and wave power."),
    ("230", "23070", "Biomass", "Densification technologies and use of biomass for direct power generation including biogas, gas obtained from sugar cane and other plant residues, anaerobic digesters."),
    ("230", "23081", "Energy education/training", "Applies to all energy sub-sectors; all levels of training."),
    ("230", "23082", "Energy research", "Including general inventories, surveys."),
    ("231", "23110", "Energy policy and administrative management", "Energy sector policy, planning; aid to energy ministries; institution capacity building and advice; unspecified energy activities."),
    ("231", "23111", "Energy sector policy, planning and administration", ""),
    ("231", "23112", "Energy regulation", "Regulation of the energy sector, including wholesale and retail electricity provision."),
    ("231", "23181", "Energy education/training", "All levels of training not included elsewhere."),
    ("231", "23182", "Energy research", "Including general inventories, surveys."),
    ("231", "23183", "Energy conservation and demand-side efficiency", "All projects in support of energy demand reduction, e.g. building and industry upgrades, smart grids, metering and tariffs. Also includes efficient cook-stoves and biogas projects."),
    ("232", "23210", "Energy generation, renewable sources – multiple technologies", "Renewable energy generation programmes that cannot be attributed to one single technology (codes 23220 through 23280 below). Fuelwood/charcoal production should be included under forestry 31261."),
    ("232", "23220", "Hydro-electric power plants", "Including energy generating river barges."),
    ("232", "23230", "Solar energy", "Including photo-voltaic cells, solar thermal applications and solar heating."),
    ("232", "23240", "Wind energy", "Wind energy for water lifting and electric power generation."),
    ("232", "23250", "Marine energy", "Including ocean thermal energy conversion, tidal and wave power."),
    ("232", "23260", "Geothermal energy", "Use of geothermal energy for generating electric power or directly as heat for agriculture, etc."),
    ("232", "23270", "Biofuel-fired power plants", "Use of solids and liquids produced from biomass for direct power generation. Also includes biogases from anaerobic fermentation (e.g. landfill gas, sewage sludge gas, fermentation of energy crops and manure) and thermal processes (also known as syngas); waste-fired power plants making use of biodegradable municipal waste (household waste and waste from companies and public services that resembles household waste, collected at installations specifically designed for their disposal with recovery of combustible liquids, gases or heat). See code 23360 for non- renewable waste-fired power plants."),
    ("233", "23310", "Energy generation, non-renewable sources – unspecified", "Thermal power plants including when energy source cannot be determined; combined gas-coal power plants."),
    ("233", "23320", "Coal-fired electric power plants", "Thermal electric power plants that use coal as the energy source."),
    ("233", "23330", "Oil-fired electric power plants", "Thermal electric power plants that use fuel oil or diesel fuel as the energy source."),
    ("233", "23340", "Natural gas-fired electric power plants", "Electric power plants that are fuelled by natural gas."),
    ("233", "23350", "Fossil fuel electric power plants with carbon capture and storage (CCS)", "Fossil fuel electric power plants employing technologies to capture carbon dioxide emissions. CCS not related to power plants should be included under 41020. CCS activities are not reportable as ODA."),
    ("233", "23360", "Non-renewable waste-fired electric power plants", "Electric power plants that use non-biodegradable industrial and municipal waste as the energy source."),
    ("234", "23410", "Hybrid energy electric power plants", "Electric power plants that make use of both non-renewable and renewable energy sources."),
    ("235", "23510", "Nuclear energy electric power plants", "Including nuclear safety."),
    ("236", "23610", "Heat plants", "Power plants which are designed to produce heat only."),
    ("236", "23620", "District heating and cooling", "Distribution of heat generated in a centralised location, or delivery of chilled water, for residential and commercial heating or cooling purposes."),
    ("236", "23630", "Electric power transmission and distribution", "Grid distribution from power source to end user; transmission lines. Also includes storage of energy to generate power (e.g. pumped hydro, batteries) and the extension of grid access, often to rural areas."),
    ("236", "23640", "Gas distribution", "Delivery for use by ultimate consumer."),
    ("240", "24010", "Financial policy and administrative management", "Finance sector policy, planning and programmes; institution capacity building and advice; financial markets and systems."),
    ("240", "24020", "Monetary institutions", "Central banks."),
    ("240", "24030", "Formal sector financial intermediaries", "All formal sector financial intermediaries; credit lines; insurance, leasing, venture capital, etc. (except when focused on only one sector)."),
    ("240", "24040", "Informal/semi-formal financial intermediaries", "Micro credit, savings and credit co-operatives etc."),
    ("240", "24081", "Education/training in banking and financial services", ""),
    ("250", "25010", "Business support services and institutions", "Support to trade and business associations, chambers of commerce; legal and regulatory reform aimed at improving business and investment climate; private sector institution capacity building and advice; trade information; public-private sector networking including trade fairs; e-commerce. Where sector cannot be specified: general support to private sector enterprises (in particular, use code 32130 for enterprises in the industrial sector)."),
    ("250", "25020", "Privatisation", "When sector cannot be specified. Including general state enterprise restructuring or demonopolisation programmes; planning, programming, advice."),
    ("311", "31110", "Agricultural policy and administrative management", "Agricultural sector policy, planning and programmes; aid to agricultural ministries; institution capacity building and advice; unspecified agriculture."),
    ("311", "31120", "Agricultural development", "Integrated projects; farm development."),
    ("311", "31130", "Agricultural land resources", "Including soil degradation control; soil improvement; drainage of water logged areas; soil desalination; agricultural land surveys; land reclamation; erosion control, desertification control."),
    ("311", "31140", "Agricultural water resources", "Irrigation, reservoirs, hydraulic structures, ground water exploitation for agricultural use."),
    ("311", "31150", "Agricultural inputs", "Supply of seeds, fertilizers, agricultural machinery/equipment."),
    ("311", "31161", "Food crop production", "Including grains (wheat, rice, barley, maize, rye, oats, millet, sorghum); horticulture; vegetables; fruit and berries; other annual and perennial crops. [Use code 32161 for agro-industries.]"),
    ("311", "31162", "Industrial crops/export crops", "Including sugar; coffee, cocoa, tea; oil seeds, nuts, kernels; fibre crops; tobacco; rubber. [Use code 32161 for agro-industries.]"),
    ("311", "31163", "Livestock", "Animal husbandry; animal feed aid."),
    ("311", "31164", "Agrarian reform", "Including agricultural sector adjustment."),
    ("311", "31165", "Agricultural alternative development", "Projects to reduce illicit drug cultivation through other agricultural marketing and production opportunities (see code 43050 for non-agricultural alternative development)."),
    ("311", "31166", "Agricultural extension", "Non-formal training in agriculture."),
    ("311", "31181", "Agricultural education/training", ""),
    ("311", "31182", "Agricultural research", "Plant breeding, physiology, genetic resources, ecology, taxonomy, disease control, agricultural bio-technology; including livestock research (animal health, breeding and genetics, nutrition, physiology)."),
    ("311", "31191", "Agricultural services", "Marketing policies & organisation; storage and transportation, creation of strategic reserves."),
    ("311", "31192", "Plant and post-harvest protection and pest control", "Including integrated plant protection, biological plant protection activities, supply and management of agrochemicals, supply of pesticides, plant protection policy and legislation."),
    ("311", "31193", "Agricultural financial services", "Financial intermediaries for the agricultural sector including credit schemes; crop insurance."),
    ("311", "31194", "Agricultural co-operatives", "Including farmers’ organisations."),
    ("311", "31195", "Livestock/veterinary services", "Animal health and management, genetic resources, feed resources."),
    ("312", "31210", "Forestry policy and administrative management", "Forestry sector policy, planning and programmes; institution capacity building and advice; forest surveys; unspecified forestry and agro-forestry activities."),
    ("312", "31220", "Forestry development", "Afforestation for industrial and rural consumption; exploitation and utilisation; erosion control, desertification control; integrated forestry projects."),
    ("312", "31261", "Fuelwood/charcoal", "Forestry development whose primary purpose is production of fuelwood and charcoal."),
    ("312", "31281", "Forestry education/training", ""),
    ("312", "31282", "Forestry research", "Including artificial regeneration, genetic improvement, production methods, fertilizer, harvesting."),
    ("312", "31291", "Forestry services", ""),
    ("313", "31310", "Fishing policy and administrative management", "Fishing sector policy, planning and programmes; institution capacity building and advice; ocean and coastal fishing; marine and freshwater fish surveys and prospecting; fishing boats/equipment; unspecified fishing activities."),
    ("313", "31320", "Fishery development", "Exploitation and utilisation of fisheries; fish stock protection; aquaculture; integrated fishery projects."),
    ("313", "31381", "Fishery education/training", ""),
    ("313", "31382", "Fishery research", "Pilot fish culture; marine/freshwater biological research."),
    ("313", "31391", "Fishery services", "Fishing harbours; fish markets; fishery transport and cold storage."),
    ("321", "32110", "Industrial policy and administrative management", "Industrial sector policy, planning and programmes; institution capacity building and advice; unspecified industrial activities; manufacturing of goods not specified below."),
    ("321", "32120", "Industrial development", ""),
    ("321", "32130", "Small and medium-sized enterprises (SME) development", "Direct support to the development of small and medium-sized enterprises in the industrial sector, including accounting, auditing and advisory services."),
    ("321", "32140", "Cottage industries and handicraft", ""),
    ("321", "32161", "Agro-industries", "Staple food processing, dairy products, slaughter houses and equipment, meat and fish processing and preserving, oils/fats, sugar refineries, beverages/tobacco, animal feeds production."),
    ("321", "32162", "Forest industries", "Wood production, pulp/paper production."),
    ("321", "32163", "Textiles, leather and substitutes", "Including knitting factories."),
    ("321", "32164", "Chemicals", "Industrial and non-industrial production facilities; includes pesticides production."),
    ("321", "32165", "Fertilizer plants", ""),
    ("321", "32166", "Cement/lime/plaster", ""),
    ("321", "32167", "Energy manufacturing", "Including gas liquefaction; petroleum refineries."),
    ("321", "32168", "Pharmaceutical production", "Medical equipment/supplies; drugs, medicines, vaccines; hygienic products."),
    ("321", "32169", "Basic metal industries", "Iron and steel, structural metal production."),
    ("321", "32170", "Non-ferrous metal industries", ""),
    ("321", "32171", "Engineering", "Manufacturing of electrical and non-electrical machinery, engines/turbines."),
    ("321", "32172", "Transport equipment industry", "Shipbuilding, fishing boats building; railroad equipment; motor vehicles and motor passenger cars; aircraft; navigation/guidance systems."),
    ("321", "32182", "Technological research and development", "Including industrial standards; quality management; metrology; testing; accreditation; certification."),
    ("322", "32210", "Mineral/mining policy and administrative management", "Mineral and mining sector policy, planning and programmes; mining legislation, mining cadastre, mineral resources inventory, information systems, institution capacity building and advice; unspecified mineral resources exploitation."),
    ("322", "32220", "Mineral prospection and exploration", "Geology, geophysics, geochemistry; excluding hydrogeology (14010) and environmental geology (41010), mineral extraction and processing, infrastructure, technology, economics, safety and environment management."),
    ("322", "32261", "Coal", "Including lignite and peat."),
    ("322", "32262", "Oil and gas", "Petroleum, natural gas, condensates, liquefied petroleum gas (LPG), liquefied natural gas (LNG); including drilling and production, and oil and gas pipelines."),
    ("322", "32263", "Ferrous metals", "Iron and ferro-alloy metals."),
    ("322", "32264", "Nonferrous metals", "Aluminium, copper, lead, nickel, tin, zinc."),
    ("322", "32265", "Precious metals/materials", "Gold, silver, platinum, diamonds, gemstones."),
    ("322", "32266", "Industrial minerals", "Baryte, limestone, feldspar, kaolin, sand, gypsym, gravel, ornamental stones."),
    ("322", "32267", "Fertilizer minerals", "Phosphates, potash."),
    ("322", "32268", "Offshore minerals", "Polymetallic nodules, phosphorites, marine placer deposits."),
    ("323", "32310", "Construction policy and administrative management", "Construction sector policy and planning; excluding construction activities within specific sectors (e.g., hospital or school construction)."),
    ("331", "33110", "Trade policy and administrative Management", "Trade policy and planning; support to ministries and departments responsible for trade policy; trade-related legislation and regulatory reforms; policy analysis and implementation of multilateral trade agreements e.g. technical barriers to trade and sanitary and phytosanitary measures (TBT/SPS) except at regional level (see 33130); mainstreaming trade in national development strategies (e.g. poverty reduction strategy papers); wholesale/retail trade; unspecified trade and trade promotion activities."),
    ("331", "33120", "Trade facilitation", "Simplification and harmonisation of international import and export procedures (e.g. customs valuation, licensing procedures, transport formalities, payments, insurance); support to customs departments and other border agencies, including in particular implementation of the provisions of the WTO Trade Facilitation Agreement; tariff reforms."),
    ("331", "33130", "Regional trade agreements (RTAs)", "Support to regional trade arrangements [e.g. Southern African Development Community (SADC), Association of Southeast Asian Nations (ASEAN), Free Trade Area of the Americas (FTAA), African Caribbean Pacific/European Union (ACP/EU)], including work on technical barriers to trade and sanitary and phytosanitary measures (TBT/SPS) at regional level; elaboration of rules of origin and introduction of special and differential treatment in RTAs."),
    ("331", "33140", "Multilateral trade negotiations", "Support developing countries’ effective participation in multilateral trade negotiations, including training of negotiators, assessing impacts of negotiations; accession to the World Trade Organisation (WTO) and other multilateral trade-related organisations."),
    ("331", "33150", "Trade-related adjustment", "Contributions to the government budget to assist the implementation of recipients’ own trade reforms and adjustments to trade policy measures by other countries; assistance to manage shortfalls in the balance of payments due to changes in the world trading environment."),
    ("331", "33181", "Trade education/training", "Human resources development in trade not included under any of the above codes. Includes university programmes in trade."),
    ("332", "33210", "Tourism policy and administrative management", ""),
    ("410", "41010", "Environmental policy and administrative management", "Environmental policy, laws, regulations and economic instruments; administrational institutions and practices; environmental and land use planning and decision-making procedures; seminars, meetings; miscellaneous conservation and protection measures not specified below."),
    ("410", "41020", "Biosphere protection", "Air pollution control, ozone layer preservation; marine pollution control."),
    ("410", "41030", "Bio-diversity", "Including natural reserves and actions in the surrounding areas; other measures to protect endangered or vulnerable species and their habitats (e.g. wetlands preservation)."),
    ("410", "41040", "Site preservation", "Applies to unique cultural landscape; including sites/objects of historical, archeological, aesthetic, scientific or educational value."),
    ("410", "41050", "Flood prevention/control", "Floods from rivers or the sea; including sea water intrusion control and sea level rise related activities."),
    ("410", "41081", "Environmental education/ training", ""),
    ("410", "41082", "Environmental research", "Including establishment of databases, inventories/accounts of physical and natural resources; environmental profiles and impact studies if not sector specific."),
    ("430", "43010", "Multisector aid", ""),
    ("430", "43030", "Urban development and management", "Integrated urban development projects; local development and urban management; urban infrastructure and services; municipal finances; urban environmental management; urban development and planning; urban renewal and urban housing; land information systems."),
    ("430", "43031", "Urban land policy and management", "Urban development and planning; urban management, land information systems."),
    ("430", "43032", "Urban development", "Integrated urban development projects; local development; urban infrastructure and services; municipal finances; urban environment systems; urban renewal and urban housing."),
    ("430", "43040", "Rural development", "Integrated rural development projects; e.g. regional development planning; promotion of decentralised and multi-sectoral competence for planning, co-ordination and management; implementation of regional development and measures (including natural reserve management); land management; land use planning; land settlement and resettlement activities [excluding resettlement of refugees and internally displaced persons (72010)]; functional integration of rural and urban areas; geographical information systems."),
    ("430", "43041", "Rural land policy and management", "Regional development planning; promotion of decentralised and multi-sectoral competence for planning, co-ordination and management; land management; land use planning; geographical information systems."),
    ("430", "43042", "Rural development", "Integrated rural development projects; implementation of regional development and measures (including natural reserve management); land settlement and resettlement activities [excluding resettlement of refugees and internally displaced persons (72010)]; functional integration of rural and urban areas."),
    ("430", "43050", "Non-agricultural alternative development", "Projects to reduce illicit drug cultivation through, for example, non-agricultural income opportunities, social and physical infrastructure (see code 31165 for agricultural alternative development)."),
    ("430", "43081", "Multisector education/training", "Including scholarships."),
    ("430", "43082", "Research/scientific institutions", "When sector cannot be identified."),
    ("510", "51010", "General budget support-related aid", "Unearmarked contributions to the government budget; support for the implementation of macroeconomic reforms (structural adjustment programmes, poverty reduction strategies); general programme assistance (when not allocable by sector)."),
    ("520", "52010", "Food aid/Food security programmes", "Supply of edible human food under national or international programmes including transport costs; cash payments made for food supplies; project food aid and food aid for market sales when benefiting sector not specified; excluding emergency food aid. Report as multilateral: i) food aid by the EU financed out of its budget and allocated pro rata to EU member countries; and ii) core contributions to the World Food Programme."),
    ("530", "53030", "Import support (capital goods)", "Capital goods and services; lines of credit."),
    ("530", "53040", "Import support (commodities)", "Commodities, general goods and services, oil imports."),
    ("600", "60010", "Action relating to debt", "Actions falling outside the code headings below."),
    ("600", "60020", "Debt forgiveness", ""),
    ("600", "60030", "Relief of multilateral debt", "Grants or credits to cover debt owed to multilateral financial institutions; including contributions to Heavily Indebted Poor Countries (HIPC) Trust Fund."),
    ("600", "60040", "Rescheduling and refinancing", ""),
    ("600", "60061", "Debt for development swap", "Allocation of debt claims to use for development (e.g., debt for education, debt for environment)."),
    ("600", "60062", "Other debt swap", "Where the debt swap benefits an external agent i.e. is not specifically for development purposes."),
    ("600", "60063", "Debt buy-back", "Purchase of debt for the purpose of cancellation."),
    ("720", "72010", "Material relief assistance and services", "Shelter, water, sanitation and health services, supply of medicines and other non-food relief items for the benefit of affected people and to facilitate the return to normal lives and livelihoods; assistance to refugees and internally displaced people in developing countries other than for food (72040) or protection (72050)."),
    ("720", "72040", "Emergency food aid", "Food aid normally for general free distribution or special supplementary feeding programmes; short-term relief to targeted population groups affected by emergency situations. Excludes non-emergency food security assistance programmes/food aid (52010)."),
    ("720", "72050", "Relief co-ordination; protection and support services", "Measures to co-ordinate delivery of humanitarian aid, including logistics and communications systems; measures to promote and protect the safety, well- being, dignity and integrity of civilians and those no longer taking part in hostilities. (Activities designed to protect the security of persons or property through the use or display of force are not reportable as ODA.)"),
    ("730", "73010", "Reconstruction relief and rehabilitation", "Short-term reconstruction work after emergency or conflict limited to restoring pre-existing infrastructure (e.g. repair or construction of roads, bridges and ports, restoration of essential facilities, such as water and sanitation, shelter, health care services); social and economic rehabilitation in the aftermath of emergencies to facilitate transition and enable populations to return to their previous livelihood or develop a new livelihood in the wake of an emergency situation (e.g. trauma counselling and treatment, employment programmes)."),
    ("740", "74010", "Disaster prevention and preparedness", "Disaster risk reduction activities (e.g. developing knowledge, natural risks cartography, legal norms for construction); early warning systems; emergency contingency stocks and contingency planning including preparations for forced displacement."),
    ("910", "91010", "Administrative costs (non-sector allocable)", ""),
    ("920", "92010", "Support to national NGOs", "In the donor country."),
    ("920", "92020", "Support to international NGOs", ""),
    ("920", "92030", "Support to local and regional NGOs", "In the recipient country or region."),
    ("930", "93010", "Refugees in donor countries (non-sector allocable)", ""),
    ("998", "99810", "Sectors not specified", "Contributions to general development of the recipient should be included under programme assistance (51010)."),
    ("998", "99820", "Promotion of development awareness (non-sector allocable)", "Spending in donor country for heightened awareness/interest in development co-operation (brochures, lectures, special research projects, etc.)."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Version.xml
VERSION = (
    ("url", "code"),
    ("http://iatistandard.org/101/", "1.01"),
    ("http://iatistandard.org/102/", "1.02"),
    ("http://iatistandard.org/103/", "1.03"),
    ("http://iatistandard.org/104/", "1.04"),
    ("http://iatistandard.org/105/", "1.05"),
    ("http://iatistandard.org/201/", "2.01"),
    ("http://iatistandard.org/202/", "2.02"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/OrganisationRole.xml
ORGANISATION_ROLE = (
    ("code", "name", "description"),
    ("1", "Funding", "The government or organisation which provides funds to the activity. "),
    ("2", "Accountable", "An organisation responsible for oversight of the activity and its outcomes"),
    ("3", "Extending", "An organisation that manages the budget and direction of an activity on behalf of the funding organisation"),
    ("4", "Implementing", "The organisation that physically carries out the activity or intervention. "),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/OtherIdentifierType.xml
OTHER_IDENTIFIER_TYPE = (
    ("code", "name"),
    ("A1", "Reporting Organisation's internal activity identifier"),
    ("A2", "CRS Activity identifier"),
    ("A3", "Previous Activity Identifier"),
    ("A9", "Other Activity Identifier"),
    ("B1", "Previous Reporting Organisation Identifier"),
    ("B9", "Other Organisation Identifier"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/DocumentCategory.xml
DOCUMENT_CATEGORY = (
    ("category", "code", "name", "description"),
    ("A", "A01", "Pre- and post-project impact appraisal", ""),
    ("A", "A02", "Objectives / Purpose of activity", ""),
    ("A", "A03", "Intended ultimate beneficiaries", ""),
    ("A", "A04", "Conditions", ""),
    ("A", "A05", "Budget", ""),
    ("A", "A06", "Summary information about contract", ""),
    ("A", "A07", "Review of project performance and evaluation", ""),
    ("A", "A08", "Results, outcomes and outputs", ""),
    ("A", "A09", "Memorandum of understanding (If agreed by all parties)", ""),
    ("A", "A10", "Tender", ""),
    ("A", "A11", "Contract", ""),
    ("A", "A12", "Activity web page", ""),
    ("B", "B01", "Annual report", ""),
    ("B", "B02", "Institutional Strategy paper", ""),
    ("B", "B03", "Country strategy paper", ""),
    ("B", "B04", "Aid Allocation Policy", ""),
    ("B", "B05", "Procurement Policy and Procedure", ""),
    ("B", "B06", "Institutional Audit Report", ""),
    ("B", "B07", "Country Audit Report", ""),
    ("B", "B08", "Exclusions Policy", ""),
    ("B", "B09", "Institutional Evaluation Report", ""),
    ("B", "B10", "Country Evaluation Report", ""),
    ("B", "B11", "Sector strategy", ""),
    ("B", "B12", "Thematic strategy", ""),
    ("B", "B13", "Country-level Memorandum of Understanding", ""),
    ("B", "B14", "Evaluations policy", ""),
    ("B", "B15", "General Terms and Conditions", ""),
    ("B", "B16", "Organisation web page", ""),
    ("B", "B17", "Country/Region web page", ""),
    ("B", "B18", "Sector web page", ""),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/PublisherType.xml
PUBLISHER_TYPE = (
    ("code", "name", "description"),
    ("1", "Aid Provider", "A government, organisation, agency or institution that provides aid funds."),
    ("2", "Aid Recipient", "A government, organisation, agency or institution that recieves aid funds."),
    ("3", "Aggregator", "An organisation that collects and reproduces information from other providers or recipients"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/HumanitarianScopeType.xml
HUMANITARIAN_SCOPE_TYPE = (
    ("code", "name"),
    ("1", "Emergency"),
    ("2", "Appeal"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/CRSChannelCode.xml
C_R_S_CHANNEL_CODE = (
    ("code", "name"),
    ("10000", "PUBLIC SECTOR INSTITUTIONS"),
    ("11000", "Donor Government"),
    ("11001", "Central Government"),
    ("11002", "Local Government"),
    ("11003", "Public corporations"),
    ("11004", "Other public entities in donor country"),
    ("12000", "Recipient Government"),
    ("12001", "Central Government"),
    ("12002", "Local Government"),
    ("12003", "Public corporations"),
    ("12004", "Other public entities in recipient country"),
    ("13000", "Third Country Government (Delegated co-operation)"),
    ("20000", "NON-GOVERNMENTAL ORGANISATIONS (NGOs) AND CIVIL SOCIETY"),
    ("21000", "INTERNATIONAL NGO"),
    ("21045", "African Medical and Research Foundation"),
    ("21046", "Agency for Cooperation and Research in Development"),
    ("21001", "Association of Geoscientists for International Development"),
    ("21063", "Conservation International"),
    ("21005", "Consumer Unity and Trust Society International"),
    ("21029", "Doctors Without Borders"),
    ("47035", "Environmental Development Action in the Third World"),
    ("21007", "Environmental Liaison Centre International"),
    ("21503", "Family Health International 360"),
    ("21011", "Global Campaign for Education"),
    ("21013", "Health Action International"),
    ("21024", "Inter Press Service, International Association"),
    ("21038", "International Alert"),
    ("21057", "International Centre for Transitional Justice"),
    ("21016", "International Committee of the Red Cross"),
    ("21044", "International Council for the Control of Iodine Deficiency Disorders"),
    ("21018", "International Federation of Red Cross and Red Crescent Societies"),
    ("21020", "International HIV/AIDS Alliance"),
    ("21022", "International Network for Alternative Financial Institutions"),
    ("21042", "International Peacebuilding Alliance"),
    ("21023", "International Planned Parenthood Federation"),
    ("21061", "International Rehabilitation Council for Torture Victims"),
    ("21504", "International Relief and Development"),
    ("21506", "International Rescue Committee"),
    ("21034", "International Union Against Tuberculosis and Lung Disease"),
    ("21053", "IPAS-Protecting Women’s Health, Advancing Women’s Reproductive Rights"),
    ("21054", "Life and Peace Institute"),
    ("21501", "OXFAM International"),
    ("21507", "Pact World"),
    ("21031", "PANOS Institute"),
    ("21032", "Population Services International"),
    ("21505", "Save the Children"),
    ("21041", "Society for International Development"),
    ("21062", "The Nature Conservancy"),
    ("21036", "World University Service"),
    ("21502", "World Vision"),
    ("22000", "Donor country-based NGO"),
    ("21047", "AgriCord"),
    ("21060", "Association for the Prevention of Torture"),
    ("21006", "Development Gateway Foundation"),
    ("21049", "European Centre for Development Policy Management"),
    ("21008", "Eurostep"),
    ("47042", "Foundation for International Training"),
    ("21050", "Geneva Call"),
    ("21014", "Human Rights Information and Documentation Systems"),
    ("21015", "International Catholic Rural Association"),
    ("21058", "International Crisis Group"),
    ("21019", "International Federation of Settlements and Neighbourhood Centres"),
    ("21025", "International Seismological Centre"),
    ("21026", "International Service for Human Rights"),
    ("21027", "ITF Enhancing Human Security"),
    ("21040", "International Women's Tribune Centre"),
    ("22501", "OXFAM - provider country office"),
    ("22502", "Save the Children - donor country office"),
    ("21033", "Transparency International"),
    ("21037", "Women's World Banking"),
    ("21035", "World Organisation Against Torture"),
    ("23000", "Developing country-based NGO"),
    ("21059", "Africa Solidarity Fund"),
    ("21048", "Association of African Universities"),
    ("21010", "Forum for African Women Educationalists"),
    ("21051", "Institut Supérieur Panafricaine d’Economie Coopérative"),
    ("21028", "International University Exchange Fund - IUEF Stip. in Africa and Latin America"),
    ("21003", "Latin American Council for Social Sciences"),
    ("23501", "National Red Cross and Red Crescent Societies"),
    ("21030", "Pan African Institute for Development"),
    ("21055", "Regional AIDS Training Network"),
    ("30000", "PUBLIC-PRIVATE PARTNERSHIPS (PPPs) and NETWORKS"),
    ("31000", "Public-Private Partnership (PPP)"),
    ("30008", "Cities Alliance"),
    ("30016", "European Fund for Southeast Europe"),
    ("30007", "Global Alliance for ICT and Development"),
    ("30001", "Global Alliance for Improved Nutrition"),
    ("30012", "Global Climate Partnership Fund"),
    ("47043", "Global Crop Diversity Trust"),
    ("30015", "Global Energy Efficiency and Renewable Energy Fund"),
    ("30003", "Global e-Schools and Communities Initiative"),
    ("30004", "Global Water Partnership"),
    ("30005", "International AIDS Vaccine Initiative"),
    ("30006", "International Partnership on Microbicides"),
    ("30011", "International Union for the Conservation of Nature"),
    ("30013", "Microfinance Enhancement Facility"),
    ("30014", "Regional Micro, Small and Medium Enterprise Investment Fund for Sub-Saharan Africa"),
    ("21056", "Renewable Energy and Energy Efficiency Partnership"),
    ("30017", "SANAD Fund for Micro, Small and Medium Enterprises"),
    ("30009", "Small Arms Survey"),
    ("32000", "Network"),
    ("47010", "Commonwealth Agency for Public Administration and Management"),
    ("47028", "Commonwealth Partnership for Technical Management"),
    ("21043", "European Parliamentarians for Africa"),
    ("31004", "Extractive Industries Transparency Initiative International Secretariat"),
    ("31001", "Global Development Network"),
    ("31002", "Global Knowledge Partnership"),
    ("21017", "International Centre for Trade and Sustainable Development"),
    ("31003", "International Land Coalition"),
    ("31005", "Parliamentary Network on the World Bank"),
    ("40000", "MULTILATERAL ORGANISATIONS"),
    ("41000", "United Nations agency, fund or commission (UN)"),
    ("41147", "Central Emergency Response Fund"),
    ("41101", "Convention to Combat Desertification"),
    ("41102", "Desert Locust Control Organisation for Eastern Africa"),
    ("41106", "Economic and Social Commission for Asia and the Pacific"),
    ("41105", "Economic and Social Commission for Western Asia"),
    ("41103", "Economic Commission for Africa"),
    ("41104", "Economic Commission for Latin America and the Caribbean"),
    ("41301", "Food and Agricultural Organisation"),
    ("41318", "Global Mechanism"),
    ("41317", "Green Climate Fund"),
    ("41312", "International Atomic Energy Agency - assessed contributions"),
    ("41107", "International Atomic Energy Agency (Contributions to Technical Cooperation Fund Only)"),
    ("41108", "International Fund for Agricultural Development"),
    ("41302", "International Labour Organisation - Assessed Contributions"),
    ("41144", "International Labour Organisation - Regular Budget Supplementary Account"),
    ("41145", "International Maritime Organization - Technical Co-operation Fund"),
    ("41303", "International Telecommunications Union"),
    ("41110", "Joint United Nations Programme on HIV/AIDS"),
    ("41305", "United Nations"),
    ("41111", "United Nations Capital Development Fund"),
    ("41122", "United Nations Children’s Fund"),
    ("41112", "United Nations Conference on Trade and Development"),
    ("41142", "United Nations Democracy Fund"),
    ("41310", "United Nations Department of Peacekeeping Operations [only MINURSO, MINUSCA, MINUSMA, MINUSTAH, MONUSCO, UNAMID, UNIFIL, UNISFA, UNMIK, UNMIL, UNMISS, UNOCI]. Report contributions mission by mission in CRS++."),
    ("41148", "United Nations Department of Political Affairs, Trust Fund in Support of Political Affairs"),
    ("41114", "United Nations Development Programme"),
    ("41314", "United Nations Economic Commission for Europe (extrabudgetary contributions only)"),
    ("41304", "United Nations Educational, Scientific and Cultural Organisation"),
    ("41146", "United Nations Entity for Gender Equality and the Empowerment of Women"),
    ("41116", "United Nations Environment Programme"),
    ("41316", "United Nations Framework Convention on Climate Change"),
    ("41313", "United Nations High Commissioner for Human Rights (extrabudgetary contributions only)"),
    ("41120", "United Nations Human Settlement Programme"),
    ("41123", "United Nations Industrial Development Organisation"),
    ("41125", "United Nations Institute for Training and Research"),
    ("41315", "United Nations International Strategy for Disaster Reduction"),
    ("41126", "United Nations Mine Action Service"),
    ("41502", "United Nations Office for Project Services"),
    ("41127", "United Nations Office of Co-ordination of Humanitarian Affairs"),
    ("41121", "United Nations Office of the United Nations High Commissioner for Refugees"),
    ("41128", "United Nations Office on Drugs and Crime"),
    ("41311", "United Nations Peacebuilding Fund (Window One:  Flexible Contributions Only)"),
    ("41141", "United Nations Peacebuilding Fund (Window Two:  Restricted Contributions Only)"),
    ("41119", "United Nations Population Fund"),
    ("41501", "United Nations Reducing Emissions from Deforestation and Forest Degradation"),
    ("41130", "United Nations Relief and Works Agency for Palestine Refugees in the Near East"),
    ("41129", "United Nations Research Institute for Social Development"),
    ("41133", "United Nations Special Initiative on Africa"),
    ("41131", "United Nations System Staff College"),
    ("41132", "United Nations System Standing Committee on Nutrition"),
    ("41134", "United Nations University (including Endowment Fund)"),
    ("41137", "United Nations Voluntary Fund for Technical Co-operation in the Field of Human Rights"),
    ("41138", "United Nations Voluntary Fund for Victims of Torture"),
    ("41136", "United Nations Voluntary Fund on Disability"),
    ("41135", "United Nations Volunteers"),
    ("41306", "Universal Postal Union"),
    ("41503", "UN-led Country-based Pooled Funds"),
    ("41140", "World Food Programme"),
    ("41307", "World Health Organisation - assessed contributions"),
    ("41143", "World Health Organisation - core voluntary contributions account"),
    ("41308", "World Intellectual Property Organisation"),
    ("41309", "World Meteorological Organisation"),
    ("41319", "World Tourism Organization"),
    ("42000", "European Union Institution (EU)"),
    ("42001", "European Commission - Development Share of Budget"),
    ("42003", "European Commission - European Development Fund"),
    ("42004", "European Investment Bank"),
    ("43000", "International Monetary Fund (IMF)"),
    ("43005", "International Monetary Fund - Post-Catastrophe Debt Relief Trust"),
    ("43002", "International Monetary Fund - Poverty Reduction and Growth - Heavily Indebted Poor Countries Debt Relief Initiative Trust Fund [includes HIPC, Extended Credit Facility (ECF), and ECF-HIPC sub-accounts]"),
    ("43004", "International Monetary Fund - Poverty Reduction and Growth - Multilateral Debt Relief Initiative Trust"),
    ("43001", "International Monetary Fund - Poverty Reduction and Growth Trust"),
    ("43003", "International Monetary Fund - Subsidization of Emergency Post Conflict Assistance/Emergency Assistance for Natural Disasters for PRGT-eligible members"),
    ("43006", "Catastrophe Containment and Relief Trust"),
    ("44000", "World Bank Group (WB)"),
    ("44006", "Advance Market Commitments"),
    ("44001", "International Bank for Reconstruction and Development"),
    ("44002", "International Development Association"),
    ("44003", "International Development Association - Heavily Indebted Poor Countries Debt Initiative Trust Fund"),
    ("44007", "International Development Association - Multilateral Debt Relief Initiative"),
    ("44004", "International Finance Corporation"),
    ("44005", "Multilateral Investment Guarantee Agency"),
    ("45000", "World Trade Organisation"),
    ("45002", "World Trade Organisation - Advisory Centre on WTO Law"),
    ("45003", "World Trade Organisation - Doha Development Agenda Global Trust Fund"),
    ("45001", "World Trade Organisation - International Trade Centre"),
    ("46000", "Regional Development Bank"),
    ("46002", "African Development Bank"),
    ("46003", "African Development Fund"),
    ("46022", "African Export Import Bank"),
    ("46008", "Andean Development Corporation"),
    ("46004", "Asian Development Bank"),
    ("46005", "Asian Development Fund"),
    ("46026", "Asian Infrastructure Investment Bank"),
    ("46006", "Black Sea Trade and Development Bank"),
    ("46009", "Caribbean Development Bank"),
    ("46020", "Central African States Development Bank"),
    ("46007", "Central American Bank for Economic Integration"),
    ("46024", "Council of Europe Development Bank"),
    ("46023", "Eastern and Southern African Trade and Development Bank"),
    ("46015", "European Bank for Reconstruction and Development"),
    ("46018", "European Bank for Reconstruction and Development - Early Transition Countries Fund"),
    ("46017", "European Bank for Reconstruction and Development – technical co-operation and special funds (all EBRD countries of operations)"),
    ("46016", "European Bank for Reconstruction and Development – technical co-operation and special funds (ODA-eligible countries only)"),
    ("46019", "European Bank for Reconstruction and Development - Western Balkans Joint Trust Fund"),
    ("46013", "Inter-American Development Bank, Fund for Special Operations"),
    ("46012", "Inter-American Development Bank, Inter-American Investment Corporation and Multilateral Investment Fund"),
    ("46025", "Islamic Development Bank"),
    ("46021", "West African Development Bank"),
    ("47000", "Other multilateral institution"),
    ("47111", "Adaptation Fund"),
    ("47009", "African and Malagasy Council for Higher Education"),
    ("47001", "African Capacity Building Foundation"),
    ("47137", "African Risk Capacity Group"),
    ("47141", "African Tax Administration Forum"),
    ("47005", "African Union (excluding peacekeeping facilities)"),
    ("21002", "Agency for International Trade Information and Co-operation"),
    ("47002", "Asian Productivity Organisation"),
    ("47109", "Asia-Pacific Economic Cooperation Support Fund (except contributions tied to counter-terrorism activities)"),
    ("47068", "Asia-Pacific Fishery Commission"),
    ("47003", "Association of South East Asian Nations: Economic Co-operation"),
    ("47011", "Caribbean Community Secretariat"),
    ("47012", "Caribbean Epidemiology Centre"),
    ("47145", "Center of Excellence in Finance"),
    ("47112", "Central European Initiative - Special Fund for Climate and Environmental Protection"),
    ("47015", "CGIAR Fund"),
    ("47134", "Clean Technology Fund"),
    ("47027", "Colombo Plan"),
    ("47105", "Common Fund for Commodities"),
    ("47013", "Commonwealth Foundation"),
    ("47025", "Commonwealth of Learning"),
    ("47132", "Commonwealth Secretariat (ODA-eligible contributions only)"),
    ("47026", "Community of Portuguese Speaking Countries"),
    ("47022", "Convention on International Trade in Endangered Species of Wild Flora and Fauna"),
    ("47138", "Council of Europe"),
    ("47037", "Eastern-Regional Organisation of Public Administration"),
    ("47113", "Economic and Monetary Community of Central Africa"),
    ("47034", "Economic Community of West African States"),
    ("47036", "European and Mediterranean Plant Protection Organisation"),
    ("47504", "Forest Carbon Partnership Facility"),
    ("47040", "Forum Fisheries Agency"),
    ("47106", "Geneva Centre for the Democratic Control of Armed Forces"),
    ("47123", "Geneva International Centre for Humanitarian Demining"),
    ("47503", "Global Agriculture and Food Security Program"),
    ("47122", "Global Alliance for Vaccines and Immunization"),
    ("47129", "Global Environment Facility - Least Developed Countries Fund"),
    ("47130", "Global Environment Facility - Special Climate Change Fund"),
    ("47044", "Global Environment Facility Trust Fund"),
    ("47502", "Global Fund for Disaster Risk Reduction"),
    ("47045", "Global Fund to Fight AIDS, Tuberculosis and Malaria"),
    ("47136", "Global Green Growth Institute"),
    ("47501", "Global Partnership for Education"),
    ("47116", "Integrated Framework for Trade-Related Technical Assistance to Least Developed Countries"),
    ("47061", "Inter-American Institute for Co-operation on Agriculture"),
    ("47065", "Intergovernmental Oceanographic Commission"),
    ("47067", "Intergovernmental Panel on Climate Change"),
    ("47019", "International Centre for Advanced Mediterranean Agronomic Studies"),
    ("47050", "International Cotton Advisory Committee"),
    ("47059", "International Development Law Organisation"),
    ("30010", "International drug purchase facility"),
    ("47107", "International Finance Facility for Immunisation"),
    ("47058", "International Institute for Democracy and Electoral Assistance"),
    ("47064", "International Network for Bamboo and Rattan"),
    ("47066", "International Organisation for Migration"),
    ("47046", "International Organisation of the Francophonie"),
    ("47073", "International Tropical Timber Organisation"),
    ("47074", "International Vaccine Institute"),
    ("47076", "Justice Studies Centre of the Americas"),
    ("47127", "Latin-American Energy Organisation"),
    ("47077", "Mekong River Commission"),
    ("47078", "Multilateral Fund for the Implementation of the Montreal Protocol"),
    ("47117", "New Partnership for Africa's Development"),
    ("47128", "Nordic Development Fund"),
    ("47081", "OECD Development Centre"),
    ("47142", "OPEC Fund for International Development"),
    ("47080", "Organisation for Economic Co-operation and Development (Contributions to special funds for Technical Co-operation Activities Only)"),
    ("47079", "Organisation of American States"),
    ("47082", "Organisation of Eastern Caribbean States"),
    ("47140", "Organisation of Ibero-American States for Education, Science and Culture"),
    ("47110", "Organisation of the Black Sea Economic Cooperation"),
    ("47131", "Organization for Security and Co-operation in Europe"),
    ("47087", "Pacific Islands Forum Secretariat"),
    ("47097", "Pacific Regional Environment Programme"),
    ("47083", "Pan-American Health Organisation"),
    ("47084", "Pan-American Institute of Geography and History"),
    ("47086", "Private Infrastructure Development Group"),
    ("47118", "Regional Organisation for the Strengthening of Supreme Audit Institutions of Francophone Sub-Saharan Countries"),
    ("47119", "Sahara and Sahel Observatory"),
    ("47029", "Sahel and West Africa Club"),
    ("47096", "Secretariat of the Pacific Community"),
    ("47120", "South Asian Association for Regional Cooperation"),
    ("47092", "South East Asian Fisheries Development Centre"),
    ("47093", "South East Asian Ministers of Education"),
    ("47095", "South Pacific Board for Educational Assessment"),
    ("47089", "Southern African Development Community"),
    ("47135", "Strategic Climate Fund"),
    ("47121", "United Cities and Local Governments of Africa"),
    ("47098", "Unrepresented Nations and Peoples’ Organisation"),
    ("47100", "West African Monetary Union"),
    ("47139", "World Customs Organization Customs Co-operation Fund"),
    ("47143", "Global Community Engagement and Resilience Fund"),
    ("47144", "International Renewable Energy Agency"),
    ("50000", "Other"),
    ("51000", "University, college or other teaching institution, research institute or think‑tank"),
    ("47101", "Africa Rice Centre"),
    ("47069", "Bioversity International"),
    ("47018", "Centre for International Forestry Research"),
    ("21004", "Council for the Development of Economic and Social Research in Africa"),
    ("47041", "Food and Fertilizer Technology Centre"),
    ("21009", "Forum for Agricultural Research in Africa"),
    ("47047", "International African Institute"),
    ("47051", "International Centre for Agricultural Research in Dry Areas"),
    ("47055", "International Centre for Development Oriented Research in Agriculture"),
    ("47053", "International Centre for Diarrhoeal Disease Research, Bangladesh"),
    ("47017", "International Centre for Tropical Agriculture"),
    ("47054", "International Centre of Insect Physiology and Ecology"),
    ("47057", "International Crop Research for Semi-Arid Tropics"),
    ("51001", "International Food Policy Research Institute"),
    ("21021", "International Institute for Environment and Development"),
    ("21039", "International Institute for Sustainable Development"),
    ("47062", "International Institute of Tropical Agriculture"),
    ("47063", "International Livestock Research Institute"),
    ("47020", "International Maize and Wheat Improvement Centre"),
    ("47021", "International Potato Centre"),
    ("47070", "International Rice Research Institute"),
    ("47071", "International Seed Testing Association"),
    ("47075", "International Water Management Institute"),
    ("47099", "University of the South Pacific"),
    ("47056", "World AgroForestry Centre"),
    ("47103", "World Maritime University"),
    ("47008", "World Vegetable Centre"),
    ("47104", "WorldFish Centre"),
    ("52000", "Other"),
    ("60000", "Private sector institution"),
    ("61000", "Private sector in provider country"),
    ("61001", "Private bank in provider country"),
    ("61002", "Private exporter in provider country"),
    ("61003", "Private investor in provider country"),
    ("61004", "Other non-bank entity in provider country"),
    ("62000", "Private sector in recipient country"),
    ("62001", "Private bank in recipient country"),
    ("62002", "Joint-venture in recipient country"),
    ("62003", "Other non-bank in recipient country"),
    ("63000", "Private sector in third country"),
    ("63001", "Private bank in third country"),
    ("63002", "Private non-bank in third country"),
    ("90000", "Other"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetIdentifierSector-category.xml
BUDGET_IDENTIFIER_SECTOR_CATEGORY = (
    ("code", "name"),
    ("1", "General Public Service"),
    ("2", "Justice, Law, Order and Security"),
    ("3", "Economic Affairs"),
    ("4", "Water, Natural Resource Management and Environment"),
    ("5", "Social Affairs"),
    ("6", "Development Partner Affairs"),
    ("7", "General Budget Support and Aid support external to General Government Sector"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GeographicalPrecision.xml
GEOGRAPHICAL_PRECISION = (
    ("code", "name", "description"),
    ("1", "Exact location", "The coordinates corresponds to an exact location, such as a populated place or a hill. The code is also used for locations that join a location which is a line (such as a road or railroad). Lines are not coded only the points that connect lines. All points that are mentioned in the source are coded."),
    ("2", "Near exact location", "The location is mentioned in the source as being \"near\", in the \"area\" of, or up to 25 km away from an exact location. The coordinates refer to that adjacent, exact, location."),
    ("3", "Second order administrative division", "The location is, or lies in, a second order administrative division (ADM2), such as a district, municipality or commune"),
    ("4", "First order administrative division", "The location is, or lies in, a first order administrative division (ADM1), such as a province, state or governorate."),
    ("5", "Estimated coordinates", "The location can only be related to estimated coordinates, such as when a location lies between populated places; along rivers, roads and borders; more than 25 km away from a specific location; or when sources refer to parts of a country greater than ADM1 (e.g. \"northern Uganda\")."),
    ("6", "Independent political entity", "The location can only be related to an independent political entity, meaning the pair of coordinates that represent a country."),
    ("7", "Unclear - capital", "Unclear. The capital is assumed to be one of two possible locations. (The other option is the country level, with precision 9.)"),
    ("8", "Local or national capital", "The location is estimated to be a seat of an administrative division (local capital) or the national capital. If aid goes to Luanda without further specification on the location, and there is an ADM1 and a capital called Luanda, then code the coordinates of the capital with precision 8. If it is not spelled out that aid goes to the capital; but if it is clear that it goes to a government ministry or to government financial institutions; and if those institutions are most likely located in the capital; then the coordinates of the capital are coded with precision 8. (However, if it can be verified that the recipient institution is located in the capital then precision 1 is used.)"),
    ("9", "Unclear - country", "Unclear. The locations is estimated to be the country level (often paired with the capital, with precision 7)"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/OrganisationRegistrationAgency.xml
ORGANISATION_REGISTRATION_AGENCY = (
    ("category", "url", "code", "name", "description"),
    ("AF", "http://acbr.gov.af/", "AF-CBR", "Afghanistan Central Business Registry", "Website not yet searchable "),
    ("AF", "http://moec.gov.af/en", "AF-MOE", "Ministry of Economy", ""),
    ("AF", "http://www.cenoc.gob.ar/", "AR-CENOC", "The National Centre of Community Organisations (CENOC)", "The National Centre of Community Organisations oversees and manages the accreditation and categorization of Civil Society Organizations in Argentian."),
    ("AU", "http://abr.business.gov.au/", "AU-ABN", "Australian Business Register", ""),
    ("AU", "http://www.acnc.gov.au/ACNC/", "AU-ACNC", "Australian Charities and Not-for-profits Commission", ""),
    ("BD", "http://114.129.9.31/welcome/ngo_profile", "BD-NAB", "Bangladesh NGO Affairs Bureau", ""),
    ("BE", "economie.fgov.be/fr/entreprises/BCE", "BE-BCE_KBO", "Banque Carrefour des entreprises / Kruispuntbank van ondernemingen", ""),
    ("BE", "http://www.juridat.be/tribunal_commerce/bruxelles/index.htm", "BE-GTCF", "Au Greffe du Tribunal de Commerce Francophone de Bruxelles", "The Registry of the Francophone Brussels Commercial Court"),
    ("BW", "http://www.mtinamesearch.gov.bw/search", "BW-CIPA", "The Companies and Intellectual Property Authority (CIPA)", "The Companies and Intellectual Property Authority (CIPA) of the Ministry of Trade and Industry in Botswana is mandated to register businesses and protect intellectual property rights through the administration of four pieces of legislation."),
    ("CA", "http://www.cra-arc.gc.ca/", "CA-CRA_ACR", "Canadian Revenue Agency / Agence du revenu du Canada", "CRA_ACR is legal requirement for bilingual use"),
    ("CH", "http://www.zefix.ch/", "CH-FDJP", "Commercial Registry, Federal Office of Justice, Switzerland", "The Swiss Commercial Register is administered by the cantons under the supervision of the Swiss Confederation. All the commercial register entries made by the cantonal register offices are published in the Swiss Official Gazette of Commerce (SOGC) after having been checked and approved by the Federal Commercial Registry Office."),
    ("CN", "http://gsxt.saic.gov.cn/", "CN-SAIC", "State Administration for Industry and Commerce (SAIC)", "The database is only available in Chinese language"),
    ("CO", "http://www.ccb.org.co/", "CO-CCB", "Bogota Chamber of Commerce", "The Bogota Chamber of Commerce is a private, non-for-profit organization whose goal is to foster a sustainable Bogota-Region in the long term, by promoting its residents' prosperity, through services which enhance and strengthen the enterprise capabilities present in the region, and which improve the business environment with an impact over public policies."),
    ("CZ", "http://wwwinfo.mfcr.cz/ares/ares_es.html.en", "CZ-ICO", "Access to Registers of Economic Subjects / Entities (ARES)", "Public registers comprising: the Commercial Register, the Federal Register, the Register of Foundations, the Register’s Institute, and the Register of Public Service Companies. Information on companies is searchable in English and is free-of-charge."),
    ("DK", "https://datacvr.virk.dk/data/", "DK-CVR", "Danish Central Business Register", "The Central Business Register at Virk is available with English headings and categories. It can be used to search for information on all Danish businesses."),
    ("EE", "http://www.rik.ee/en/e-business-register", "EE-RIK", "Centre of Registers and Information Systems (RIK)", "You can view the data related to you free-of-charge by logging in with your ID-card."),
    ("EG", "http://www.moss.gov.eg/misa/ar-eg/", "EG-MOSS", "Ministry of Social Solidarity and Justice", "The Ministry of Social Solidarity and Justice is the main registration body for associations and foundations in Egypt."),
    ("ES", "http://administracionelectronica.gob.es/ctt/dir3/descargas", "ES-DIR3", "Common Directory of Organizational Units and Offices - DIR3", "EXCEL Tables: http://administracionelectronica.gob.es/ctt/resources/Soluciones/238/Area%20descargas/Listado%20Oficinas%20AGE.xlsx?idIniciativa=238&idElemento=2745"),
    ("ET", "http://www.mfa.gov.et/", "ET-MFA", "Ministry of Foreign Affairs", "Charities are registered but no openly searchable database yet available. "),
    ("ET", "http://www.mot.gov.et", "ET-MOT", "Ministry of Trade (MOT)", "The Ministry of Trade is the official ministry to register a business in Ethiopia."),
    ("FI", "http://www.prh.fi/en/index.html", "FI-PRO", "Finnish Patent and Registration office", ""),
    ("FR", "http://www.insee.fr/fr/service/default.asp?page=entreprises/entreprise.htm", "FR-INSEE", "The National Institute of Statistics and Economic Studies / Institute National de la Statistique et des etudes economiques", "The National Institute of Statistics and Economic Studies provide a registration service for companies and associations with details being held on the SIRENE database"),
    ("FR", "http://www.infogreffe.fr", "FR-RCS", "Registre de Commerce et des Societies /Trade and Companies Register - Commercial Court Registry", ""),
    ("GB", "http://www.charity-commission.gov.uk/", "GB-CHC", "Charity Commission", ""),
    ("GB", "http://www.companieshouse.gov.uk/", "GB-COH", "Companies House", ""),
    ("GB", "http://www.education.gov.uk/edubase/home.xhtml", "GB-EDU", "Edubase, by the Department of Education", "Edubase is provided by the Department of Education and provides a URN for each school, university and other educational establishment in England and Wales"),
    ("GB", "http://government-organisation.alpha.openregister.org", "GB-GOR", "UK Government Organisation Register", "The Government Organisation Register is an authoritative source of government organisations who have a presence on GOV.UK. This register includes ministerial departments and executive agencies but does not include classifications (e.g. arms length bodies) or any form of organisational hierarchy."),
    ("GB", "http://data.gov.uk/dataset/iati-organisation-identifier-for-uk-government-bodies", "GB-GOV", "UK Government Departments Reference Numbers", "Codes for use by IATI for UK Government Departments."),
    ("GB", "https://www.gov.uk/government/organisations", "GB-GOVUK", "UK Government Departments, Agencies & Public Bodies", "Use the final segment of the url (below /organisations) as the \"registration number\", converting all \"-\" to \"_\". Keep \"registration number\" portion all lowercase. "),
    ("GB", "http://www.charitycommissionni.org.uk/", "GB-NIC", "The Charity Commission for Northern Ireland", ""),
    ("GB", "http://www.hmrc.gov.uk/", "GB-REV", "HM Revenue and Customs", ""),
    ("GB", "http://www.oscr.org.uk/", "GB-SC", "Scottish Charity Register", ""),
    ("GB", "https://www.ukrlp.co.uk/", "GB-UKPRN", "UK Register of Learning Providers", ""),
    ("GG", "http://www.guernseyregistry.com/charities", "GG-RCE", "The Guernsey Registry at the Department of Commerce and Employment", ""),
    ("GH", "", "GH-DSW", "Department of Social Welfare", ""),
    ("HK", "http://www.cr.gov.hk/en/home", "HK-CR", "Hong Kong Companies Registry", "Hong Kong Companies Registry registers local and non-Hong Kong companies and statutory returns, de-registers defunct solvent companies and provides the public with services and facilities for inspecting and obtaining company information kept by the Registry."),
    ("ID", "http://www.kemendagri.go.id/media/filemanager/2011/02/22/d/a/daf.ormas___lsm_2010.pdf", "ID-KDN", "Ministry Home affairs/ Kementerian Dalam Negeri", "NGO registration can also be done through Ministry Home affairs/ Kementerian Dalam Negeri"),
    ("ID", "http://www.kemenkumham.go.id/", "ID-KHH", "Ministry of Justice & Human Rights/ Kementerian Hukum Dan Hak", "Company registration is done through Ministry of Justice & Human Rights/ Kementerian Hukum Dan Hak"),
    ("ID", "http://www.kemlu.go.id/", "ID-KLN", "Ministry of Foreign affairs/ Kementerian Luar Negeri", "International NGO registration is done through Ministry of Foreign affairs/ Kementerian Luar Negeri"),
    ("ID", "http://www.satulayanan.net/layanan/pendaftaran-lsm-atau-ormas/perizinan-lsm-atau-ormas-baru", "ID-PRO", "NGOs registered at Provinicial Level", "Registration for NGO in Indonesia can be done at the provincial level. Because there is regional autonomy, each provincial has different requirements. Website is just one example"),
    ("IE", "", "IE-CHY", "Irish Register of Charities", ""),
    ("IE", "http://www.cro.ie/", "IE-CRO", "Irish CompaniesRegistration Office", ""),
    ("IM", "http://www.gov.im/ded/companies/companiesregistry.xml?menuid=21615", "IM-CR", "Isle of Man Companies Registry", ""),
    ("IM", "http://www.gov.im/registries/courts/charities/", "IM-GR", "Isle of Man Index of Registered Charities", ""),
    ("IN", "http://www.mca.gov.in/", "IN-MCA", "Government of India, Minstry of Corporate Affairs", "MCA regulates corporate affairs in India through the Companies Act, 1956, 2013 and other allied Acts, Bills and Rules."),
    ("IN", "https://fcraonline.nic.in/home/index.aspx", "IN-MHA", "Ministry of Home Affairs, Government of India", "Government of India Ministry of Home Affairs Foreigners Division provides registration under the Foreign Contribution (Regulation) Act (FCRA)."),
    ("JE", "http://www.jerseyfsc.org/registry/", "JE-CR", "Jersey Companies Registry", ""),
    ("JE", "http://www.jerseyoverseasaid.org.je/", "JE-OAC", "Jersey Overseas Aid Commission", ""),
    ("KE", "http://www.ngobureau.or.ke/", "KE-NCB", "NGO's Coordination Board", ""),
    ("KE", "http://www.attorney-general.go.ke/", "KE-RCO", "Registar of Companies", ""),
    ("KE", "http://www.attorney-general.go.ke/", "KE-RSO", "Registrar of Societies", ""),
    ("LB", "http://www.interior.gov.lb/", "LB-MOI", "Ministry of Interior", "The Ministry of Interior is the main registration body in Lebanon. All NGOs are required to register with the Ministry of Interior."),
    ("LS", "http://www.lcn.org.ls/", "LS-LCN", "Lesotho Council of Non Governmental Organisations", ""),
    ("LV", "http://www.ur.gov.lv/", "LV-RE", "Register of Enterprises of the Republic of Latvia", "Free of charge information includes type of legal entity; registered office; new or current name or trade name and previously registered or historical name or trade name; registration number; Single Euro Payment Area beneficiary identification code (if allocated); registration date; date of deletion of the legal entity from the register (or the date of reorganisation if the reason for the deletion is a reorganisation); deadline for registration of religious organisations that are subject to re-registration."),
    ("ML", "http://www.cci.ml/", "ML-CCIM", "Chambre de Commerce et d'Industrie du Mali (CCIM)", "The Chamber of Commerce and Industry of Mali (CCIM) is responsible for the organization and professional representation of organisations and legal persons working in the various branches of commercial, industrial and service activities in Mali."),
    ("ML", "http://demarchesadministratives.gouv.ml/demarches/afficher/Numero-d-Identification-Fiscale-NIF", "ML-NIF", "Numero d’Identification Fiscale ", "Malian organisations use Numero-d-Identification-Fiscale (NIF) to identify taxpayers and facilitate the administration of the Malian tax affairs."),
    ("MM", "No url for the ministry (as at 2/10/2013)", "MM-MHA", "Ministry of Home Affairs - Central Committee for the Registration and Supervision of Organisations", "The MHA assigns a registration number to each NGO - this number is time limited, for example 4 years, after which the registration is reviewed."),
    ("MW", "http://www.congoma.mw/index.html", "MW-CNM", "The Council for Non Governmental Organisations in Malawi", ""),
    ("MW", "http://www.mra.mw/", "MW-MRA", "Malawi Revenue Authority", ""),
    ("MW", "http://ngoboardmalawi.mw/directory.php", "MW-NBM", "NGO Board of Malawi", "There is a pdf file with a list of registered NGOs, but these do not appear to be registration numbers. New database is planned"),
    ("MW", "", "MW-RG", "Registrar General, Department of Justice", ""),
    ("MZ", "", "MZ-MOJ", "Mozambique Ministry of Justice", ""),
    ("NG", "http://new.cac.gov.ng/home/", "NG-CAC", "Nigerian Corporate Affairs Commission", ""),
    ("NL", "http://www.kvk.nl/", "NL-KVK", "Kamer van Koophandel", ""),
    ("NO", "http://www.brreg.no/", "NO-BRC", "Brønnøysundregistrene", ""),
    ("NP", "http://www.cro.gov.np/", "NP-CRO", "Company Registrar Office", ""),
    ("NP", "http://www.swc.org.np/", "NP-SWC", "NGO registration", ""),
    ("PH", "http://www.sec.gov.ph/online-services/search-registered-companies/", "PH-SEC", "Securities and Exchange Commission Philippines", "The Securities and Exchange Commission in the Philippines provides licenses so that corporations, partnerships or associations can transact business in the Philippines."),
    ("PK", "https://drive.google.com/file/d/0B67B7u-xqLazZFhHTkUtUVVRWXc/view", "PK-PCP", "Pakistan Centre for Philanthropy", "The PCP Certification Programme seeks to bring transparency, accountability and good governance in the nonprofit sector in Pakistan. The first initiative of its kind in South Asia; it involves the evaluation of a nonprofit organisation on standardised parameters of internal governance, financial management and programme delivery."),
    ("PK", "No Website available", "PK-VSWA", "Pakistan Voluntary Social Welfare Agency", "All NGOs are required to register with their local Voluntary Social Welfare department"),
    ("PL", "http://www.stat.gov.pl/regon/, http://bip.stat.gov.pl/en/regon/", "PL-REGON", "National Official Business Register", "Every business entry in Poland is assigned an ID in 3 different registries: business, court, and tax. This is the business register."),
    ("PL", "https://ems.ms.gov.pl/krs/wyszukiwaniepodmiotu, https://wyszukiwarkaregon.stat.gov.pl/appBIR/index.aspx", "PL-NIP", "Tax Identification Number", "Every business entry in Poland is assigned an ID in 3 different registries: business, court, and tax. This is the tax register."),
    ("PL", "https://ems.ms.gov.pl/krs/wyszukiwaniepodmiotu", "PL-KRS", "The National Court Register", "Every business entry in Poland is assigned an ID in 3 different registries: business, court, and tax. This is the court register."),
    ("PS", "http://www.moi.pna.ps/NGOs/List", "PS-MOI", "Ministry of Interior (MOI)", "It’s the official body to register Non-governmental organization in Palestine."),
    ("RS", "http://www.apr.gov.rs/eng/Home.aspx", "RS-APR", "Serbian Business Registrations Agency (APR)", "The SBRA runs business registers as single, centralized, public electronic databases."),
    ("SE", "http://www.bolagsverket.se/", "SE-BLV", "Bolagsverket / Swedish Companies Registration Office", ""),
    ("SE", "http://www.kammarkollegiet.se/en", "SE-KK", "Legal, Financial and Administrative Services Agency (Kammarkollegiet)", "A Swedish administrative authority under the Ministry of Finance, which is responsible for the registration of religious communities and organisational units of religious communities."),
    ("SG", "http://www.acra.gov.sg/", "SG-ACRA", "Accounting and Corporate Regulatory Authority (ACRA)", "The Accounting and Corporate Regulatory Authority (ACRA) is the national regulator of business entities, public accountants and corporate service providers in Singapore"),
    ("SK", "http://www.zrsr.sk/default.aspx?LANG=en", "SK-ZRSR", "Slovakia Ministry Of Interior Trade Register", "Most organisations (including NGOs) have to be registered with the Ministry of Interior for the Trade Register Of The Slovak Republic (Živnostensky Register Slovenskej Republiky) and are allocated a unique registration number"),
    ("SS", "http://www.goss-online.org/", "SS-RRC", "South Sudan Relief and Rehabilitation Commission", "The South Sudan Relief and Rehabilitation Commission (SSRRC) is an agency of the Government of South Sudan. It is the operational arm of the Ministry of Humanitarian Affairs and Disaster Management. The NGO Act 2016 added additional powers to the agency to register any NGO interested in operating in South Sudan."),
    ("TZ", "http://www.brela.go.tz/", "TZ-BRLA", "Tanzania Business Registrations and Licensing Agency", ""),
    ("UA", "http://irc.gov.ua/ua/Poshuk-v-YeDR.html", "UA-EDR", "United State Register, Ukraine", ""),
    ("UG", "http://www.mia.go.ug/?page_id=62", "UG-NGB", "NGO Board, Ministry of Internal Affairs", ""),
    ("UG", "http://www.ursb.go.ug/", "UG-RSB", "Registration Services Bureau", ""),
    ("US", "http://www.companieshouse.gov.uk/links/usaLink.shtml", "US-DOS", "Corporation registration is the responsibility of each state (see link)", ""),
    ("US", "http://www.irs.gov/businesses/small/article/0,,id=98350,00.html", "US-EIN", "Internal Revenue Service / Employer Identification Number", ""),
    ("US", "http://www.usa.gov/directory/federal/index.shtml", "US-USAGOV", "Index of U.S. Government Departments and Agencies", "Use the final segment of the url (below /federal and excluding the extension) as the \"registration number\", converting all \"-\" to \"_\". Keep \"registration number\" portion all lowercase. "),
    ("XI", "http://iatistandard.org/codelists/IATIOrganisationIdentifier/", "XI-IATI", "International Aid Transparency Initiative Organisation Identifier", "XI-IATI is a list of organisation identifiers that is maintained by the IATI Secretariat. Any publisher may apply to the IATI Technical Team for an identifier to be generated."),
    ("XI", "http://publicbodies.org/", "XI-PB", "Public Bodies", "Public Bodies aims to provide a unique ID for every part of every government."),
    ("XM", "http://www.oecd.org/dac/stats/dacandcrscodelists.htm", "XM-DAC", "OECD Development Assistance Committee", "See Donor, Agency, and Delivery Channel codes"),
    ("XM", "http://www.unocha.org", "XM-OCHA", "United Nations Office for the Coordination of Humanitarian Affairs", "OCHA is the part of the United Nations Secretariat responsible for bringing together humanitarian actors to ensure a coherent response to emergencies."),
    ("ZA", "http://www.cipro.gov.za/", "ZA-CIP", "Companies and Intellectual Property Commission (CIPC)", ""),
    ("ZA", "http://www.npo.gov.za/", "ZA-NPO", "Association for Non-Profit Organisations", ""),
    ("ZA", "http://www.sars.gov.za/home.asp?pid=170", "ZA-PBO", "SA Revenue Service Tax Exemption Unit / Public Benefit Organisations", ""),
    ("ZM", "", "ZM-NRB", "Non Governmental Organisation Registration Board", ""),
    ("ZM", "http://www.pacra.org.zm/", "ZM-PCR", "Patents and Companies Registration Agency", ""),
    ("ZW", "", "ZW-PVO", "Private Voluntary Organisations Council", ""),
    ("ZW", "", "ZW-ROD", "Registrar of Deeds", ""),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ResultType.xml
RESULT_TYPE = (
    ("code", "name", "description"),
    ("1", _("Output"), _("Results of the activity that came about as a direct effect of your work and specific, what is done, and what communities are reached. For example, X number of individuals.")),
    ("2", _("Outcome"), _("Results of the activity that produce an effect on the overall communities or issues you serve. For example lower rate of infection after a vaccination programme.")),
    ("3", _("Impact"), _("The long term effects of the outcomes, that lead to larger, over arching results, such as improved life-expectancy.")),
    ("9", _("Other"), _("Another type of result, not specified above.")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/OrganisationType.xml
ORGANISATION_TYPE = (
    ("code", "name"),
    ("10", "Government"),
    ("15", "Other Public Sector"),
    ("21", "International NGO"),
    ("22", "National NGO"),
    ("23", "Regional NGO"),
    ("30", "Public Private Partnership"),
    ("40", "Multilateral"),
    ("60", "Foundation"),
    ("70", "Private Sector"),
    ("80", "Academic, Training and Research"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/AidType-category.xml
AID_TYPE_CATEGORY = (
    ("code", "name", "description"),
    ("A", "Budget support", "For contributions under this category, the donor relinquishes the exclusive control of its funds by sharing the responsibility with the recipient."),
    ("B", "Core contributions and pooled programmes and funds", "For contributions under this category, the donor relinquishes the exclusive control of its funds by sharing the responsibility with other stakeholders (other donors, NGOs, multilateral institutions, Public Private Partnerships). The category covers both core contributions (B01 and B02), and pooled contributions with a specific earmarking (B03 and B04)."),
    ("C", "Project-type interventions", "N.B. Within this category, members able to do so are requested to report the aggregate amount used for financing donor experts/consultants on Table DAC1. Where the activity consists solely of experts’ costs, report under category D."),
    ("D", "Experts and other technical assistance", "This category covers the provision, outside projects as described in category C, of know-how in the form of personnel, training and research."),
    ("E", "Scholarships and student costs in donor countries", ""),
    ("F", "Debt relief", ""),
    ("G", "Administrative costs not included elsewhere", ""),
    ("H", "Other in-donor expenditures", "Groups a number of contributions that do not give rise to a cross-border flow."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ActivityDateType.xml
ACTIVITY_DATE_TYPE = (
    ("code", "name", "description"),
    ("1", "Planned start", "The date on which the activity is planned to start, for example the date of the first planned disbursement or when physical activity starts."),
    ("2", "Actual start", "The actual date the activity starts, for example the date of the first disbursement or when physical activity starts."),
    ("3", "Planned End", "The date on which the activity is planned to end, for example the date of the last planned disbursement or when physical activity is complete."),
    ("4", "Actual end", "The actual date the activity ends, for example the date of the last disbursement or when physical activity is complete."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/SectorCategory.xml
SECTOR_CATEGORY = (
    ("code", "name", "description"),
    ("111", "Education, level unspecified", "Education sector policy, planning and programmes; aid to education ministries, administration and management systems; institution capacity building and advice; school management and governance; curriculum and materials development; unspecified education activities."),
    ("112", "Basic education", "Formal and non-formal primary education for children; all elementary and first cycle systematic instruction; provision of learning materials."),
    ("113", "Secondary education", "Second cycle systematic instruction at both junior and senior levels."),
    ("114", "Post-secondary education", "Degree and diploma programmes at universities, colleges and polytechnics; scholarships."),
    ("121", "Health, general", "Health sector policy, planning and programmes; aid to health ministries, public health administration; institution capacity building and advice; medical insurance programmes; unspecified health activities."),
    ("122", "Basic health", "Basic and primary health care programmes; paramedical and nursing care programmes; supply of drugs, medicines and vaccines related to basic health care."),
    ("130", "POPULATION POLICIES/ PROGRAMMES AND REPRODUCTIVE HEALTH", "Population/development policies; census work, vital registration; migration data; demographic research/analysis; reproductive health research; unspecified population activities."),
    ("140", "WATER AND SANITATION", "Water sector policy and governance, including legislation, regulation, planning and management as well as transboundary management of water; institutional capacity development; activities supporting the Integrated Water Resource Management approach (IWRM: see box below)."),
    ("151", "Government and civil society, general", "Institution-building assistance to strengthen core public sector management systems and capacities. This includes macro-economic and other policy management, co-ordination, planning and reform; human resource management; organisational development; civil service reform; e-government; development planning, monitoring and evaluation; support to ministries involved in aid co-ordination; other ministries and government departments when sector cannot be specified. (Use specific sector codes for development of systems and capacities in sector ministries.)"),
    ("152", "Conflict prevention and resolution, peace and security", "Technical co-operation provided to parliament, government ministries, law enforcement agencies and the judiciary to assist review and reform of the security system to improve democratic governance and civilian control; technical co-operation provided to government to improve civilian oversight and democratic control of budgeting, management, accountability and auditing of security expenditure, including military budgets, as part of a public expenditure management programme; assistance to civil society to enhance its competence and capacity to scrutinise the security system so that it is managed in accordance with democratic norms and principles of accountability, transparency and good governance. [Other than in the context of an international peacekeeping operation (15230).]"),
    ("160", "OTHER SOCIAL INFRASTRUCTURE AND SERVICES", "Social legislation and administration; institution capacity building and advice; social security and other social schemes; special programmes for the elderly, orphans, the disabled, street children; social dimensions of structural adjustment; unspecified social infrastructure and services, including consumer protection."),
    ("210", "TRANSPORT AND STORAGE", "Transport sector policy, planning and programmes; aid to transport ministries; institution capacity building and advice; unspecified transport; activities that combine road, rail, water and/or air transport. Whenever possible, report transport of goods under the sector of the good being transported."),
    ("220", "COMMUNICATIONS", "Communications sector policy, planning and programmes; institution capacity building and advice; including postal services development; unspecified communications activities."),
    ("230", "ENERGY GENERATION AND SUPPLY", "Energy sector policy, planning and programmes; aid to energy ministries; institution capacity building and advice; unspecified energy activities including energy conservation."),
    ("231", "Energy generation, distribution and efficiency – general", "Energy sector policy, planning; aid to energy ministries; institution capacity building and advice; unspecified energy activities."),
    ("232", "Energy generation, renewable sources", "Renewable energy generation programmes that cannot be attributed to one single technology (codes 23220 through 23280 below). Fuelwood/charcoal production should be included under forestry 31261."),
    ("233", "Energy generation, non-renewable sources", "Thermal power plants including when energy source cannot be determined; combined gas-coal power plants."),
    ("234", "Hybrid energy electric power plants", "Electric power plants that make use of both non-renewable and renewable energy sources."),
    ("235", "Nuclear energy electric power plants", "Including nuclear safety."),
    ("236", "Heating, cooling and energy distribution", "Power plants which are designed to produce heat only."),
    ("240", "BANKING AND FINANCIAL SERVICES", "Finance sector policy, planning and programmes; institution capacity building and advice; financial markets and systems."),
    ("250", "BUSINESS AND OTHER SERVICES", "Support to trade and business associations, chambers of commerce; legal and regulatory reform aimed at improving business and investment climate; private sector institution capacity building and advice; trade information; public-private sector networking including trade fairs; e-commerce. Where sector cannot be specified: general support to private sector enterprises (in particular, use code 32130 for enterprises in the industrial sector)."),
    ("311", "AGRICULTURE", "Agricultural sector policy, planning and programmes; aid to agricultural ministries; institution capacity building and advice; unspecified agriculture."),
    ("312", "FORESTRY", "Forestry sector policy, planning and programmes; institution capacity building and advice; forest surveys; unspecified forestry and agro-forestry activities."),
    ("313", "FISHING", "Fishing sector policy, planning and programmes; institution capacity building and advice; ocean and coastal fishing; marine and freshwater fish surveys and prospecting; fishing boats/equipment; unspecified fishing activities."),
    ("321", "INDUSTRY", "Industrial sector policy, planning and programmes; institution capacity building and advice; unspecified industrial activities; manufacturing of goods not specified below."),
    ("322", "MINERAL RESOURCES AND MINING", "Mineral and mining sector policy, planning and programmes; mining legislation, mining cadastre, mineral resources inventory, information systems, institution capacity building and advice; unspecified mineral resources exploitation."),
    ("323", "CONSTRUCTION", "Construction sector policy and planning; excluding construction activities within specific sectors (e.g., hospital or school construction)."),
    ("331", "TRADE POLICY AND REGULATIONS AND TRADE- RELATED ADJUSTMENT", "Trade policy and planning; support to ministries and departments responsible for trade policy; trade-related legislation and regulatory reforms; policy analysis and implementation of multilateral trade agreements e.g. technical barriers to trade and sanitary and phytosanitary measures (TBT/SPS) except at regional level (see 33130); mainstreaming trade in national development strategies (e.g. poverty reduction strategy papers); wholesale/retail trade; unspecified trade and trade promotion activities."),
    ("332", "TOURISM", ""),
    ("410", "General environmental protection", "Environmental policy, laws, regulations and economic instruments; administrational institutions and practices; environmental and land use planning and decision-making procedures; seminars, meetings; miscellaneous conservation and protection measures not specified below."),
    ("430", "Other multisector", ""),
    ("510", "General budget support", "Unearmarked contributions to the government budget; support for the implementation of macroeconomic reforms (structural adjustment programmes, poverty reduction strategies); general programme assistance (when not allocable by sector)."),
    ("520", "Developmental food aid/Food security assistance", "Supply of edible human food under national or international programmes including transport costs; cash payments made for food supplies; project food aid and food aid for market sales when benefiting sector not specified; excluding emergency food aid. Report as multilateral: i) food aid by the EU financed out of its budget and allocated pro rata to EU member countries; and ii) core contributions to the World Food Programme."),
    ("530", "Other commodity assistance", "Capital goods and services; lines of credit."),
    ("600", "Debt relief", "Actions falling outside the code headings below."),
    ("720", "Emergency Response", "Shelter, water, sanitation and health services, supply of medicines and other non-food relief items for the benefit of affected people and to facilitate the return to normal lives and livelihoods; assistance to refugees and internally displaced people in developing countries other than for food (72040) or protection (72050)."),
    ("730", "Reconstruction relief and rehabilitation", "Short-term reconstruction work after emergency or conflict limited to restoring pre-existing infrastructure (e.g. repair or construction of roads, bridges and ports, restoration of essential facilities, such as water and sanitation, shelter, health care services); social and economic rehabilitation in the aftermath of emergencies to facilitate transition and enable populations to return to their previous livelihood or develop a new livelihood in the wake of an emergency situation (e.g. trauma counselling and treatment, employment programmes)."),
    ("740", "Disaster prevention and preparedness", "Disaster risk reduction activities (e.g. developing knowledge, natural risks cartography, legal norms for construction); early warning systems; emergency contingency stocks and contingency planning including preparations for forced displacement."),
    ("910", "ADMINISTRATIVE COSTS OF DONORS", ""),
    ("920", "SUPPORT TO NON- GOVERNMENTAL ORGANISATIONS (NGOs)", "In the donor country."),
    ("930", "REFUGEES IN DONOR COUNTRIES", ""),
    ("998", "UNALLOCATED/ UNSPECIFIED", "Contributions to general development of the recipient should be included under programme assistance (51010)."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/SectorVocabulary.xml
SECTOR_VOCABULARY = (
    ("code", "name", "description"),
    ("1", _("OECD DAC CRS Purpose Codes (5 digit)"), _("The sector reported corresponds to an OECD DAC CRS 5-digit purpose code")),
    ("2", _("OECD DAC CRS Purpose Codes (3 digit)"), _("The sector reported corresponds to an OECD DAC CRS 3-digit purpose code")),
    ("3", _("Classification of the Functions of Government (UN)"), _("The sector reported corresponds to the UN Classification of the Functions of Government (CoFoG)")),
    ("4", _("Statistical classification of economic activities in the European Community"), _("The sector reported corresponds to the statistical classifications of economic activities in the European Community")),
    ("5", _("National Taxonomy for Exempt Entities (USA)"), _("The sector reported corresponds to the National Taxonomy for Exempt Entities (NTEE) - USA")),
    ("6", _("AidData"), _("The sector reported corresponds to AidData classifications")),
    ("7", _("SDG Goal"), _("A value from the top-level list of UN sustainable development goals (SDGs) (e.g. ‘1’)")),
    ("8", _("SDG Target"), _("A value from the second-level list of UN sustainable development goals (SDGs) (e.g. ‘1.1’)")),
    ("9", _("SDG Indicator"), _("A value from the second-level list of UN sustainable development (SDG) indicators")),
    ("10", _("Humanitarian Global Clusters (Inter-Agency Standing Committee)"), _("The sector reported corresponds to an Inter-Agency Standard Committee Humanitarian Global Cluster code")),
    ("99", _("Reporting Organisation"), _("The sector reported corresponds to a sector vocabulary maintained by the reporting organisation for this activity")),
    ("98", _("Reporting Organisation 2"), _("The sector reported corresponds to a sector vocabulary maintained by the reporting organisation for this activity (if they are referencing more than one)")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/FinanceType-category.xml
FINANCE_TYPE_CATEGORY = (
    ("code", "name", "description"),
    ("100", "GRANTS", "Transfers in cash or in kind for which no legal debt is incurred by the recipient."),
    ("200", "INTEREST SUBSIDY", "Subsidies to soften the terms of private export credits, or loans or credits by the banking sector."),
    ("300", "CAPITAL SUBSCRIPTION", "Payments to multilateral agencies in the form of notes and similar instruments, unconditionally cashable at sight by the recipient institutions."),
    ("400", "LOAN", "Transfers in cash or in kind for which the recipient incurs legal debt."),
    ("420", "DEBT INSTRUMENTS", ""),
    ("430", "MEZZANINE FINANCE INSTRUMENTS", ""),
    ("450", "EXPORT CREDIT", "Official or private loans which are primarily export-facilitating in purpose. They are usually tied to a specific export from the extending country and not represented by a negotiable instrument."),
    ("500", "EQUITY AND SHARES IN COLLECTIVE INVESTMENT VEHICLES", "Investment in a country on the DAC List of ODA Recipients that is not made to acquire a lasting interest in an enterprise."),
    ("600", "DEBT RELIEF", "Debt cancellations, debt conversions, debt rescheduling within or outside the framework of the Paris Club."),
    ("700", "INVESTMENT", "Investment made by a private entity resident in a reporting country to acquire or add to a lasting interest(1) in an enterprise in a country on the DAC List of ODA Recipients."),
    ("800", "BONDS", "Acquisition of bonds issued by developing countries."),
    ("900", "OTHER SECURITIES/CLAIMS", ""),
    ("1000", "GUARANTEES AND OTHER UNFUNDED CONTINGENT LIABILITIES", ""),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/DocumentCategory-category.xml
DOCUMENT_CATEGORY_CATEGORY = (
    ("code", "name", "description"),
    ("A", "Activity Level", "The document is relevant to a specific activity"),
    ("B", "Organisation Level", "The document is relevant to the organisation as a whole"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/RegionVocabulary.xml
REGION_VOCABULARY = (
    ("code", "name", "description"),
    ("1", "OECD DAC", "Supra-national regions according to OECD DAC CRS recipient codes"),
    ("2", "UN", "Supra-national regions maintained by UN Statistics Division"),
    ("99", "Reporting Organisation", "The region reported corresponds to a region vocabulary maintained by the reporting organisation for this activity."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Language.xml
LANGUAGE = (
    ("code", "name"),
    ("aa", "Afar"),
    ("ab", "Abkhazian"),
    ("ae", "Avestan"),
    ("af", "Afrikaans"),
    ("ak", "Akan"),
    ("am", "Amharic"),
    ("an", "Aragonese"),
    ("ar", "Arabic"),
    ("as", "Assamese"),
    ("av", "Avaric"),
    ("ay", "Aymara"),
    ("az", "Azerbaijani"),
    ("ba", "Bashkir"),
    ("be", "Belarusian"),
    ("bg", "Bulgarian"),
    ("bh", "Bihari languages"),
    ("bi", "Bislama"),
    ("bm", "Bambara"),
    ("bn", "Bengali"),
    ("bo", "Tibetan"),
    ("br", "Breton"),
    ("bs", "Bosnian"),
    ("ca", "Catalan; Valencian"),
    ("ce", "Chechen"),
    ("ch", "Chamorro"),
    ("co", "Corsican"),
    ("cr", "Cree"),
    ("cs", "Czech"),
    ("cv", "Chuvash"),
    ("cy", "Welsh"),
    ("da", "Danish"),
    ("de", "German"),
    ("dv", "Divehi; Dhivehi; Maldivian"),
    ("dz", "Dzongkha"),
    ("ee", "Ewe"),
    ("el", "Greek"),
    ("en", "English"),
    ("eo", "Esperanto"),
    ("es", "Spanish; Castilian"),
    ("et", "Estonian"),
    ("eu", "Basque"),
    ("fa", "Persian"),
    ("ff", "Fulah"),
    ("fi", "Finnish"),
    ("fj", "Fijian"),
    ("fo", "Faroese"),
    ("fr", "French"),
    ("fy", "Western Frisian"),
    ("ga", "Irish"),
    ("gd", "Gaelic; Scottish Gaelic"),
    ("gl", "Galician"),
    ("gn", "Guarani"),
    ("gu", "Gujarati"),
    ("gv", "Manx"),
    ("ha", "Hausa"),
    ("he", "Hebrew"),
    ("hi", "Hindi"),
    ("ho", "Hiri Motu"),
    ("hr", "Croatian"),
    ("ht", "Haitian; Haitian Creole"),
    ("hu", "Hungarian"),
    ("hy", "Armenian"),
    ("hz", "Herero"),
    ("id", "Indonesian"),
    ("ig", "Igbo"),
    ("ii", "Sichuan Yi; Nuosu"),
    ("ik", "Inupiaq"),
    ("io", "Ido"),
    ("is", "Icelandic"),
    ("it", "Italian"),
    ("iu", "Inuktitut"),
    ("ja", "Japanese"),
    ("jv", "Javanese"),
    ("ka", "Georgian"),
    ("kg", "Kongo"),
    ("ki", "Kikuyu; Gikuyu"),
    ("kj", "Kuanyama; Kwanyama"),
    ("kk", "Kazakh"),
    ("kl", "Kalaallisut; Greenlandic"),
    ("km", "Central Khmer"),
    ("kn", "Kannada"),
    ("ko", "Korean"),
    ("kr", "Kanuri"),
    ("ks", "Kashmiri"),
    ("ku", "Kurdish"),
    ("kv", "Komi"),
    ("kw", "Cornish"),
    ("ky", "Kirghiz; Kyrgyz"),
    ("la", "Latin"),
    ("lb", "Luxembourgish; Letzeburgesch"),
    ("lg", "Ganda"),
    ("li", "Limburgan; Limburger; Limburgish"),
    ("ln", "Lingala"),
    ("lo", "Lao"),
    ("lt", "Lithuanian"),
    ("lu", "Luba-Katanga"),
    ("lv", "Latvian"),
    ("mg", "Malagasy"),
    ("mh", "Marshallese"),
    ("mi", "Maori"),
    ("mk", "Macedonian"),
    ("ml", "Malayalam"),
    ("mn", "Mongolian"),
    ("mr", "Marathi"),
    ("ms", "Malay"),
    ("mt", "Maltese"),
    ("my", "Burmese"),
    ("na", "Nauru"),
    ("nb", "BokmĂĽl, Norwegian; Norwegian BokmĂĽl"),
    ("nd", "Ndebele, North; North Ndebele"),
    ("ne", "Nepali"),
    ("ng", "Ndonga"),
    ("nl", "Dutch; Flemish"),
    ("nn", "Norwegian Nynorsk; Nynorsk, Norwegian"),
    ("no", "Norwegian"),
    ("nr", "Ndebele, South; South Ndebele"),
    ("nv", "Navajo; Navaho"),
    ("ny", "Chichewa; Chewa; Nyanja"),
    ("oc", "Occitan (post 1500)"),
    ("oj", "Ojibwa"),
    ("om", "Oromo"),
    ("or", "Oriya"),
    ("os", "Ossetian; Ossetic"),
    ("pa", "Panjabi; Punjabi"),
    ("pi", "Pali"),
    ("pl", "Polish"),
    ("ps", "Pushto; Pashto"),
    ("pt", "Portuguese"),
    ("qu", "Quechua"),
    ("rm", "Romansh"),
    ("rn", "Rundi"),
    ("ro", "Romanian; Moldavian; Moldovan"),
    ("ru", "Russian"),
    ("rw", "Kinyarwanda"),
    ("sa", "Sanskrit"),
    ("sc", "Sardinian"),
    ("sd", "Sindhi"),
    ("se", "Northern Sami"),
    ("sg", "Sango"),
    ("si", "Sinhala; Sinhalese"),
    ("sk", "Slovak"),
    ("sl", "Slovenian"),
    ("sm", "Samoan"),
    ("sn", "Shona"),
    ("so", "Somali"),
    ("sq", "Albanian"),
    ("sr", "Serbian"),
    ("ss", "Swati"),
    ("st", "Sotho, Southern"),
    ("su", "Sundanese"),
    ("sv", "Swedish"),
    ("sw", "Swahili"),
    ("ta", "Tamil"),
    ("te", "Telugu"),
    ("tg", "Tajik"),
    ("th", "Thai"),
    ("ti", "Tigrinya"),
    ("tk", "Turkmen"),
    ("tl", "Tagalog"),
    ("tn", "Tswana"),
    ("to", "Tonga (Tonga Islands)"),
    ("tr", "Turkish"),
    ("ts", "Tsonga"),
    ("tt", "Tatar"),
    ("tw", "Twi"),
    ("ty", "Tahitian"),
    ("ug", "Uighur; Uyghur"),
    ("uk", "Ukrainian"),
    ("ur", "Urdu"),
    ("uz", "Uzbek"),
    ("ve", "Venda"),
    ("vi", "Vietnamese"),
    ("vo", "VolapĂźk"),
    ("wa", "Walloon"),
    ("wo", "Wolof"),
    ("xh", "Xhosa"),
    ("yi", "Yiddish"),
    ("yo", "Yoruba"),
    ("za", "Zhuang; Chuang"),
    ("zh", "Chinese"),
    ("zu", "Zulu"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/LoanRepaymentType.xml
LOAN_REPAYMENT_TYPE = (
    ("code", "name", "description"),
    ("1", "Equal Principal Payments (EPP)", "As required and defined by CRS++ reporting format Column 44"),
    ("2", "Annuity", "As required and defined by CRS++ reporting format Column 44"),
    ("3", "Lump sum", "As required and defined by CRS++ reporting format Column 44"),
    ("5", "Other", "As required and defined by CRS++ reporting format Column 44"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/HumanitarianScopeVocabulary.xml
HUMANITARIAN_SCOPE_VOCABULARY = (
    ("code", "name"),
    ("1-2", "Glide"),
    ("2-1", "Humanitarian Plan"),
    ("99", "Reporting Organisation"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/IndicatorVocabulary.xml
INDICATOR_VOCABULARY = (
    ("code", "name"),
    ("1", "WHO Registry"),
    ("2", "Sphere Handbook"),
    ("3", "US Foreign Assistance Framework"),
    ("4", "World Bank World Development Indicators"),
    ("5", "UN Millennium Development Goals Indicators"),
    ("6", "UNOCHA Humanitarian Response Indicators"),
    ("7", "HIV/AIDS Indicator Registry"),
    ("99", "Reporting Organisation"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/DisbursementChannel.xml
DISBURSEMENT_CHANNEL = (
    ("code", "name", "description"),
    ("1", "Money is disbursed through central Ministry of Finance or Treasury", "Money is disbursed through central Ministry of Finance or Treasury"),
    ("2", "Money is disbursed directly to the implementing institution and managed through a separate bank account", "Money is disbursed directly to the implementing institution and managed through a separate bank account"),
    ("3", "Aid in kind: Donors utilise third party agencies, e.g. NGOs or management companies", "Aid in kind: Donors utilise third party agencies, e.g. NGOs or management companies"),
    ("4", "Aid in kind: Donors manage funds themselves", "Aid in kind: Donors manage funds themselves"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GazetteerAgency.xml
GAZETTEER_AGENCY = (
    ("code", "name"),
    ("1", "Geonames.org"),
    ("2", "National Geospatial-Intelligence Agency"),
    ("3", "Open Street Map"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GeographicLocationClass.xml
GEOGRAPHIC_LOCATION_CLASS = (
    ("code", "name", "description"),
    ("1", "Administrative Region", "The designated geographic location is an administrative region (state, county, province, district, municipality etc.)"),
    ("2", "Populated Place", "The designated geographic location is a populated place (town, village, farm etc.)"),
    ("3", "Structure", "The designated geopgraphic location is a structure (such as a school or a clinic)"),
    ("4", "Other Topographical Feature", "The designated geographic location is a topographical feature, such as a mountain, a river, a forest"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/ConditionType.xml
CONDITION_TYPE = (
    ("code", "name", "description"),
    ("1", "Policy", "The condition attached requires a particular policy to be implemented by the recipient"),
    ("2", "Performance", "The condition attached requires certain outputs or outcomes to be achieved by the recipient"),
    ("3", "Fiduciary", "The condition attached requires use of certain public financial management or public accountability measures by the recipient"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetIdentifierVocabulary.xml
BUDGET_IDENTIFIER_VOCABULARY = (
    ("code", "name", "description"),
    ("1", "IATI", "The budget identifier reported uses IATI budget identifier categories"),
    ("2", "Country Chart of Accounts", "The budget identifier reported corresponds to the recipient country chart of accounts"),
    ("3", "Other Country System", "The budget identifier reported corresponds to a recipient country system other than the chart of accounts"),
    ("4", "Reporting Organisation", "The budget identifier reported corresponds to categories that are specific to the reporting organisation"),
    ("5", "Other", "The budget identifier reported uses a different vocabulary, not specified in the codelist "),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/DescriptionType.xml
DESCRIPTION_TYPE = (
    ("code", "name", "description"),
    ("1", "General", "Unstructured, long description of the activity "),
    ("2", "Objectives", "Specific objectives for the activity, e.g. taken from logical framework"),
    ("3", "Target Groups", "Details of groups that are intended to benefit from the activity"),
    ("4", "Other", "For miscellaneous use. A further classification or breakdown may be included in the narrative"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Currency.xml
CURRENCY = (
    ("code", "name"),
    ("AED", "UAE Dirham"),
    ("AFN", "Afghani"),
    ("ALL", "Lek"),
    ("AMD", "Armenian Dram"),
    ("ANG", "Netherlands Antillian Guilder"),
    ("AOA", "Kwanza"),
    ("ARS", "Argentine Peso"),
    ("AUD", "Australian Dollar"),
    ("AWG", "Aruban Guilder"),
    ("AZN", "Azerbaijanian Manat"),
    ("BAM", "Convertible Marks"),
    ("BBD", "Barbados Dollar"),
    ("BDT", "Taka"),
    ("BGN", "Bulgarian Lev"),
    ("BHD", "Bahraini Dinar"),
    ("BIF", "Burundi Franc"),
    ("BMD", "Bermudian Dollar"),
    ("BND", "Brunei Dollar"),
    ("BOB", "Boliviano"),
    ("BOV", "Mvdol"),
    ("BRL", "Brazilian Real"),
    ("BSD", "Bahamian Dollar"),
    ("BTN", "Ngultrum"),
    ("BWP", "Pula"),
    ("BYR", "Belarussian Ruble"),
    ("BZD", "Belize Dollar"),
    ("CAD", "Canadian Dollar"),
    ("CDF", "Congolese Franc"),
    ("CHF", "Swiss Franc"),
    ("CLF", "Unidades de fomento"),
    ("CLP", "Chilean Peso"),
    ("CNY", "Yuan Renminbi"),
    ("COP", "Colombian Peso"),
    ("COU", "Unidad de Valor Real"),
    ("CRC", "Costa Rican Colon"),
    ("CUC", "Peso Convertible"),
    ("CUP", "Cuban Peso"),
    ("CVE", "Cape Verde Escudo"),
    ("CZK", "Czech Koruna"),
    ("DJF", "Djibouti Franc"),
    ("DKK", "Danish Krone"),
    ("DOP", "Dominican Peso"),
    ("DZD", "Algerian Dinar"),
    ("EEK", "Kroon"),
    ("EGP", "Egyptian Pound"),
    ("ERN", "Nakfa"),
    ("ETB", "Ethiopian Birr"),
    ("EUR", "Euro"),
    ("FJD", "Fiji Dollar"),
    ("FKP", "Falkland Islands Pound"),
    ("GBP", "Pound Sterling"),
    ("GEL", "Lari"),
    ("GHS", "Cedi"),
    ("GIP", "Gibraltar Pound"),
    ("GMD", "Dalasi"),
    ("GNF", "Guinea Franc"),
    ("GTQ", "Quetzal"),
    ("GYD", "Guyana Dollar"),
    ("HKD", "Hong Kong Dollar"),
    ("HNL", "Lempira"),
    ("HRK", "Kuna"),
    ("HTG", "Gourde"),
    ("HUF", "Forint"),
    ("IDR", "Rupiah"),
    ("ILS", "New Israeli Sheqel"),
    ("INR", "Indian Rupee"),
    ("IQD", "Iraqi Dinar"),
    ("IRR", "Iranian Rial"),
    ("ISK", "Iceland Krona"),
    ("JMD", "Jamaican Dollar"),
    ("JOD", "Jordanian Dinar"),
    ("JPY", "Yen"),
    ("KES", "Kenyan Shilling"),
    ("KGS", "Som"),
    ("KHR", "Riel"),
    ("KMF", "Comoro Franc"),
    ("KPW", "North Korean Won"),
    ("KRW", "Won"),
    ("KWD", "Kuwaiti Dinar"),
    ("KYD", "Cayman Islands Dollar"),
    ("KZT", "Tenge"),
    ("LAK", "Kip"),
    ("LBP", "Lebanese Pound"),
    ("LKR", "Sri Lanka Rupee"),
    ("LRD", "Liberian Dollar"),
    ("LSL", "Loti"),
    ("LTL", "Lithuanian Litas"),
    ("LVL", "Latvian Lats"),
    ("LYD", "Libyan Dinar"),
    ("MAD", "Moroccan Dirham"),
    ("MDL", "Moldovan Leu"),
    ("MGA", "Malagasy Ariary"),
    ("MKD", "Denar"),
    ("MMK", "Kyat"),
    ("MNT", "Tugrik"),
    ("MOP", "Pataca"),
    ("MRO", "Ouguiya"),
    ("MUR", "Mauritius Rupee"),
    ("MVR", "Rufiyaa"),
    ("MWK", "Malawi Kwacha"),
    ("MXN", "Mexican Peso"),
    ("MXV", "Mexican Unidad de Inversion (UDI)"),
    ("MYR", "Malaysian Ringgit"),
    ("MZN", "Metical"),
    ("NAD", "Namibia Dollar"),
    ("NGN", "Naira"),
    ("NIO", "Cordoba Oro"),
    ("NOK", "Norwegian Krone"),
    ("NPR", "Nepalese Rupee"),
    ("NZD", "New Zealand Dollar"),
    ("OMR", "Rial Omani"),
    ("PAB", "Balboa"),
    ("PEN", "Nuevo Sol"),
    ("PGK", "Kina"),
    ("PHP", "Philippine Peso"),
    ("PKR", "Pakistan Rupee"),
    ("PLN", "Zloty"),
    ("PYG", "Guarani"),
    ("QAR", "Qatari Rial"),
    ("RON", "Romanian Leu"),
    ("RSD", "Serbian Dinar"),
    ("RUB", "Russian Ruble"),
    ("RWF", "Rwanda Franc"),
    ("SAR", "Saudi Riyal"),
    ("SBD", "Solomon Islands Dollar"),
    ("SCR", "Seychelles Rupee"),
    ("SDG", "Sudanese Pound"),
    ("SEK", "Swedish Krona"),
    ("SGD", "Singapore Dollar"),
    ("SHP", "Saint Helena Pound"),
    ("SLL", "Leone"),
    ("SOS", "Somali Shilling"),
    ("SSP", "South Sudanese Pound"),
    ("SRD", "Surinam Dollar"),
    ("STD", "Dobra"),
    ("SVC", "El Salvador Colon"),
    ("SYP", "Syrian Pound"),
    ("SZL", "Lilangeni"),
    ("THB", "Baht"),
    ("TJS", "Somoni"),
    ("TMT", "Manat"),
    ("TND", "Tunisian Dinar"),
    ("TOP", "Paanga"),
    ("TRY", "Turkish Lira"),
    ("TTD", "Trinidad and Tobago Dollar"),
    ("TWD", "New Taiwan Dollar"),
    ("TZS", "Tanzanian Shilling"),
    ("UAH", "Hryvnia"),
    ("UGX", "Uganda Shilling"),
    ("USD", "US Dollar"),
    ("USN", "US Dollar (Next day)"),
    ("USS", "US Dollar (Same day)"),
    ("UYI", "Uruguay Peso en Unidades Indexadas"),
    ("UYU", "Peso Uruguayo"),
    ("UZS", "Uzbekistan Sum"),
    ("VEF", "Bolivar"),
    ("VND", "Dong"),
    ("VUV", "Vatu"),
    ("WST", "Tala"),
    ("XAF", "CFA Franc BEAC"),
    ("XBT", "Bitcoin"),
    ("XCD", "East Caribbean Dollar"),
    ("XDR", "International Monetary Fund (IMF) Special Drawing Right (SDR)"),
    ("XOF", "CFA Franc BCEAO"),
    ("XPF", "CFP Franc"),
    ("YER", "Yemeni Rial"),
    ("ZAR", "Rand"),
    ("ZMK", "Zambian Kwacha"),
    ("ZWL", "Zimbabwe Dollar"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/FlowType.xml
FLOW_TYPE = (
    ("code", "name", "description"),
    ("10", "ODA", "Official Development Assistance"),
    ("20", "OOF", "Other Official Flows"),
    ("21", "Non-export credit OOF", "Other Official Flows, excl. export credits."),
    ("22", "Officially supported export credits", "Officially supported export credits. Covers both official direct export credits and private export credits under official guarantee or insurance."),
    ("30", "Private grants", "made by NGOs and other civil society organisations (e.e. philantropic foundations) based in the reporting DAC country"),
    ("35", "Private market", "Private market"),
    ("36", "Private Foreign Direct Investment", "Private Foreign Direct Investment."),
    ("37", "Other Private flows at market terms", "Private long-term (i.e. over one-year maturity) capital transactions made by residents of DAC countries."),
    ("40", "Non flow", "e.g. GNI"),
    ("50", "Other flows", "e.g. non-ODA component of peacebuilding operations)"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/VerificationStatus.xml
VERIFICATION_STATUS = (
    ("code", "name", "description"),
    ("0", "Not verified", "The data published for the activity has not been verified"),
    ("1", "Verified", "The data published for the activity has been verified. "),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/LocationType-category.xml
LOCATION_TYPE_CATEGORY = (
    ("code", "name"),
    ("A", "Administrative Region"),
    ("H", "Hydrographic"),
    ("L", "Area"),
    ("P", "Populated Place"),
    ("R", "Streets/Highways/Roads"),
    ("S", "Spot Features"),
    ("T", "Hypsographic"),
    ("U", "Undersea"),
    ("V", "Vegetation"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/PolicyMarkerVocabulary.xml
POLICY_MARKER_VOCABULARY = (
    ("code", "name", "description"),
    ("1", "OECD DAC CRS", "The policy marker is an OECD DAC CRS policy marker, Reported in columns 20-23, 28-31 and 54 of CRS++ reporting format."),
    ("99", "Reporting Organisation", "The policy marker is one that is defined and tracked by the reporting organisation"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetIdentifierSector.xml
BUDGET_IDENTIFIER_SECTOR = (
    ("category", "code", "name"),
    ("1", "1.1", "Executive"),
    ("1", "1.2", "Legislative"),
    ("1", "1.3", "Accountability"),
    ("1", "1.3", "Accountability"),
    ("1", "1.4", "External Affairs"),
    ("1", "1.5", "General Personnel Services"),
    ("1", "1.6", "Statistics"),
    ("1", "1.7", "Other General Services"),
    ("1", "1.8", "Elections"),
    ("2", "2.1", "Justice, Law and Order"),
    ("2", "2.2", "Defence"),
    ("3", "3.1", "General Economic, Commercial and Labour Affairs"),
    ("3", "3.2", "Public Works"),
    ("3", "3.3", "Agriculture"),
    ("3", "3.4", "Forestry"),
    ("3", "3.5", "Fishing and Hunting"),
    ("3", "3.6", "Energy"),
    ("3", "3.7", "Mining and Mineral Development"),
    ("3", "3.8", "Transport"),
    ("3", "3.9", "Industry"),
    ("3", "3.10", "Communications"),
    ("3", "3.11", "Tourism"),
    ("3", "3.12", "Microfinance and financial services"),
    ("4", "4.1", "Water supply and Sanitation"),
    ("4", "4.2", "Environment"),
    ("5", "5.1", "Health"),
    ("5", "5.2", "Recreation, Culture and Religion"),
    ("5", "5.3", "Education"),
    ("5", "5.4", "Social Protection, Land Housing and Community Amenities"),
    ("6", "6.1", "Development Partner affairs"),
    ("7", "7.1", "External to government sector"),
    ("7", "7.2", "General Budget Support"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/Country.xml
COUNTRY = (
    ("code", "name"),
    ("AF", "Afghanistan"),
    ("AX", "Åland Islands"),
    ("AL", "Albania"),
    ("DZ", "Algeria"),
    ("AS", "American Samoa"),
    ("AD", "Andorra"),
    ("AO", "Angola"),
    ("AI", "Anguilla"),
    ("AQ", "Antarctica"),
    ("AG", "Antigua and Barbuda"),
    ("AR", "Argentina"),
    ("AM", "Armenia"),
    ("AW", "Aruba"),
    ("AU", "Australia"),
    ("AT", "Austria"),
    ("AZ", "Azerbaijan"),
    ("BS", "Bahamas (The)"),
    ("BH", "Bahrain"),
    ("BD", "Bangladesh"),
    ("BB", "Barbados"),
    ("BY", "Belarus"),
    ("BE", "Belgium"),
    ("BZ", "Belize"),
    ("BJ", "Benin"),
    ("BM", "Bermuda"),
    ("BT", "Bhutan"),
    ("BO", "Bolivia (Plurinational State Of)"),
    ("BQ", "Bonaire, Saint Eustatius and Saba"),
    ("BA", "Bosnia and Herzegovina"),
    ("BW", "Botswana"),
    ("BV", "Bouvet Island"),
    ("BR", "Brazil"),
    ("IO", "British Indian Ocean Territory (The)"),
    ("BN", "Brunei Darussalam"),
    ("BG", "Bulgaria"),
    ("BF", "Burkina Faso"),
    ("BI", "Burundi"),
    ("KH", "Cambodia"),
    ("CM", "Cameroon"),
    ("CA", "Canada"),
    ("CV", "Cape Verde"),
    ("KY", "Cayman Islands (The)"),
    ("CF", "Central African Republic (The)"),
    ("TD", "Chad"),
    ("CL", "Chile"),
    ("CN", "China"),
    ("CX", "Christmas Island"),
    ("CC", "Cocos (Keeling) Islands (The)"),
    ("CO", "Colombia"),
    ("KM", "Comoros (The)"),
    ("CG", "Congo (The)"),
    ("CD", "Congo, The Democratic Republic of the"),
    ("CK", "Cook Islands (The)"),
    ("CR", "Costa Rica"),
    ("CI", "Côte D'ivoire"),
    ("HR", "Croatia"),
    ("CU", "Cuba"),
    ("CW", "Curaçao"),
    ("CY", "Cyprus"),
    ("CZ", "Czech Republic (The)"),
    ("DK", "Denmark"),
    ("DJ", "Djibouti"),
    ("DM", "Dominica"),
    ("DO", "Dominican Republic (The)"),
    ("EC", "Ecuador"),
    ("EG", "Egypt"),
    ("SV", "El Salvador"),
    ("GQ", "Equatorial Guinea"),
    ("ER", "Eritrea"),
    ("EE", "Estonia"),
    ("ET", "Ethiopia"),
    ("FK", "Falkland Islands (The) [malvinas]"),
    ("FO", "Faroe Islands (The)"),
    ("FJ", "Fiji"),
    ("FI", "Finland"),
    ("FR", "France"),
    ("GF", "French Guiana"),
    ("PF", "French Polynesia"),
    ("TF", "French Southern Territories (The)"),
    ("GA", "Gabon"),
    ("GM", "Gambia (The)"),
    ("GE", "Georgia"),
    ("DE", "Germany"),
    ("GH", "Ghana"),
    ("GI", "Gibraltar"),
    ("GR", "Greece"),
    ("GL", "Greenland"),
    ("GD", "Grenada"),
    ("GP", "Guadeloupe"),
    ("GU", "Guam"),
    ("GT", "Guatemala"),
    ("GG", "Guernsey"),
    ("GN", "Guinea"),
    ("GW", "Guinea-Bissau"),
    ("GY", "Guyana"),
    ("HT", "Haiti"),
    ("HM", "Heard Island and Mcdonald Islands"),
    ("VA", "Holy See (The)"),
    ("HN", "Honduras"),
    ("HK", "Hong Kong"),
    ("HU", "Hungary"),
    ("IS", "Iceland"),
    ("IN", "India"),
    ("ID", "Indonesia"),
    ("IR", "Iran (Islamic Republic Of)"),
    ("IQ", "Iraq"),
    ("IE", "Ireland"),
    ("IM", "Isle of Man"),
    ("IL", "Israel"),
    ("IT", "Italy"),
    ("JM", "Jamaica"),
    ("JP", "Japan"),
    ("JE", "Jersey"),
    ("JO", "Jordan"),
    ("KZ", "Kazakhstan"),
    ("KE", "Kenya"),
    ("KI", "Kiribati"),
    ("KP", "Korea (Democratic People's Republic Of)"),
    ("KR", "Korea (Republic Of)"),
    ("XK", "Kosovo"),
    ("KW", "Kuwait"),
    ("KG", "Kyrgyzstan"),
    ("LA", "Lao People's Democratic Republic (The)"),
    ("LV", "Latvia"),
    ("LB", "Lebanon"),
    ("LS", "Lesotho"),
    ("LR", "Liberia"),
    ("LY", "Libyan Arab Jamahiriya"),
    ("LI", "Liechtenstein"),
    ("LT", "Lithuania"),
    ("LU", "Luxembourg"),
    ("MO", "Macao"),
    ("MK", "Macedonia (The Former Yugoslav Republic Of)"),
    ("MG", "Madagascar"),
    ("MW", "Malawi"),
    ("MY", "Malaysia"),
    ("MV", "Maldives"),
    ("ML", "Mali"),
    ("MT", "Malta"),
    ("MH", "Marshall Islands (The)"),
    ("MQ", "Martinique"),
    ("MR", "Mauritania"),
    ("MU", "Mauritius"),
    ("YT", "Mayotte"),
    ("MX", "Mexico"),
    ("FM", "Micronesia (Federated States Of)"),
    ("MD", "Moldova (Republic Of)"),
    ("MC", "Monaco"),
    ("MN", "Mongolia"),
    ("ME", "Montenegro"),
    ("MS", "Montserrat"),
    ("MA", "Morocco"),
    ("MZ", "Mozambique"),
    ("MM", "Myanmar"),
    ("NA", "Namibia"),
    ("NR", "Nauru"),
    ("NP", "Nepal"),
    ("NL", "Netherlands (The)"),
    ("AN", "Netherland Antilles"),
    ("NC", "New Caledonia"),
    ("NZ", "New Zealand"),
    ("NI", "Nicaragua"),
    ("NE", "Niger (The)"),
    ("NG", "Nigeria"),
    ("NU", "Niue"),
    ("NF", "Norfolk Island"),
    ("MP", "Northern Mariana Islands (The)"),
    ("NO", "Norway"),
    ("OM", "Oman"),
    ("PK", "Pakistan"),
    ("PW", "Palau"),
    ("PS", "Palestinian Territory, Occupied"),
    ("PA", "Panama"),
    ("PG", "Papua New Guinea"),
    ("PY", "Paraguay"),
    ("PE", "Peru"),
    ("PH", "Philippines (The)"),
    ("PN", "Pitcairn"),
    ("PL", "Poland"),
    ("PT", "Portugal"),
    ("PR", "Puerto Rico"),
    ("QA", "Qatar"),
    ("RE", "Reunion"),
    ("RO", "Romania"),
    ("RU", "Russian Federation (The)"),
    ("RW", "Rwanda"),
    ("BL", "Saint Barthélemy"),
    ("SH", "Saint Helena, Ascension and Tristan da Cunha"),
    ("KN", "Saint Kitts and Nevis"),
    ("LC", "Saint Lucia"),
    ("MF", "Saint Martin (French Part)"),
    ("PM", "Saint Pierre and Miquelon"),
    ("VC", "Saint Vincent and the Grenadines"),
    ("WS", "Samoa"),
    ("SM", "San Marino"),
    ("ST", "Sao Tome and Principe"),
    ("SA", "Saudi Arabia"),
    ("SN", "Senegal"),
    ("RS", "Serbia"),
    ("SC", "Seychelles"),
    ("SL", "Sierra Leone"),
    ("SG", "Singapore"),
    ("SX", "Sint Maarten (Dutch Part)"),
    ("SK", "Slovakia"),
    ("SI", "Slovenia"),
    ("SB", "Solomon Islands"),
    ("SO", "Somalia"),
    ("ZA", "South Africa"),
    ("GS", "South Georgia and the South Sandwich Islands"),
    ("SS", "South Sudan"),
    ("ES", "Spain"),
    ("LK", "Sri Lanka"),
    ("SD", "Sudan (The)"),
    ("SR", "Suriname"),
    ("SJ", "Svalbard and Jan Mayen"),
    ("SZ", "Swaziland"),
    ("SE", "Sweden"),
    ("CH", "Switzerland"),
    ("SY", "Syrian Arab Republic"),
    ("TW", "Taiwan (Province of China)"),
    ("TJ", "Tajikistan"),
    ("TZ", "Tanzania, United Republic of"),
    ("TH", "Thailand"),
    ("TL", "Timor-Leste"),
    ("TG", "Togo"),
    ("TK", "Tokelau"),
    ("TO", "Tonga"),
    ("TT", "Trinidad and Tobago"),
    ("TN", "Tunisia"),
    ("TR", "Turkey"),
    ("TM", "Turkmenistan"),
    ("TC", "Turks and Caicos Islands (The)"),
    ("TV", "Tuvalu"),
    ("UG", "Uganda"),
    ("UA", "Ukraine"),
    ("AE", "United Arab Emirates (The)"),
    ("GB", "United Kingdom of Great Britain and Northern Ireland (The)"),
    ("US", "United States of America (The)"),
    ("UM", "United States Minor Outlying Islands (The)"),
    ("UY", "Uruguay"),
    ("UZ", "Uzbekistan"),
    ("VU", "Vanuatu"),
    ("VE", "Venezuela (Bolivarian Republic Of)"),
    ("VN", "Viet Nam"),
    ("VG", "Virgin Islands (British)"),
    ("VI", "Virgin Islands (U.s.)"),
    ("WF", "Wallis and Futuna"),
    ("EH", "Western Sahara"),
    ("YE", "Yemen"),
    ("ZM", "Zambia"),
    ("ZW", "Zimbabwe"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/GeographicVocabulary.xml
GEOGRAPHIC_VOCABULARY = (
    ("url", "code", "name", "description"),
    ("http://www.fao.org/geonetwork/srv/en/metadata.show?id=12691", "A1", "Global Admininistrative Unit Layers", ""),
    ("http://www.unsalb.org/", "A2", "UN Second Administrative Level Boundary Project", "Note: the unsalb.org website is no longer accessible, and public access to the boundaries resources has been removed http://www.ungiwg.org/content/united-nations-international-and-administrative-boundaries-resources"),
    ("http://www.gadm.org/", "A3", "Global Administrative Areas", ""),
    ("http://www.iso.org/iso/country_codes.htm", "A4", "ISO Country (3166-1 alpha-2)", ""),
    ("http://www.geonames.org/", "G1", "Geonames", ""),
    ("http://www.openstreetmap.org/", "G2", "OpenStreetMap", "Note: the code should be formed by prefixing the relevant OpenStreetMap ID with node/ way/ or relation/ as appropriate, e.g. node/1234567"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetType.xml
BUDGET_TYPE = (
    ("code", "name", "description"),
    ("1", "Original", "The original budget allocated to the activity"),
    ("2", "Revised", "The updated budget for an activity"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/CRSAddOtherFlags.xml
C_R_S_ADD_OTHER_FLAGS = (
    ("code", "name", "description"),
    ("1", "Free standing technical cooperation", "Free standing technical cooperation (Col 24 in CRS++ Reporting format)"),
    ("2", "Programme-based approach", "Programme-based approach (Col 25 in CRS++ Reporting format)"),
    ("3", "Investment project", "Investment project (Col 26 in CRS++ Reporting format)"),
    ("4", "Associated financing", "Associated financing (Col 27 in CRS++ Reporting format)"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/CollaborationType.xml
COLLABORATION_TYPE = (
    ("code", "name", "description"),
    ("1", "Bilateral", "Bilateral transactions are those undertaken by a donor, excluding core contributions to other organisations (codes 2 and 3 below). It includes transactions channelled through other organisations."),
    ("2", "Multilateral (inflows)", "Multilateral contributions are those made to a recipient institution which:     i. conducts all or part of its activities in favour of development;     ii. is an international agency, institution or organisation whose members are governments, or a fund managed autonomously by such an agency; and     iii. pools contributions so that they lose their identity and become an integral part of its financial assets."),
    ("3", "Bilateral, core contributions to NGOs and other private bodies / PPPs", "Bilateral funds paid over to national and international non-governmental organisations (NGOs), Public Private Partnerships (PPPs), or other private bodies for use at their discretion."),
    ("4", "Multilateral outflows", "Aid activities financed from the multilateral institutions' regular budgets."),
    ("6", "Private sector outflows", ""),
    ("7", "Bilateral, ex-post reporting on NGOs’ activities funded through core contributions", ""),
    ("8", "bilateral, triangular co-operation: activities where one or more bilateral providers of development co-operation or international organisations support South-South co-operation, joining forces with developing countries to facilitate a sharing of knowledge and experience among all partners involved.", ""),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/BudgetStatus.xml
BUDGET_STATUS = (
    ("code", "name", "description"),
    ("1", "Indicative", "A non-binding estimate for the described budget."),
    ("2", "Committed", "A binding agreement for the described budget."),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/OrganisationIdentifier.xml
ORGANISATION_IDENTIFIER = (
    ("code", "name"),
    ("AT-1", "Federal Ministry of Finance"),
    ("AT-10", "Ministry for Agriculture and Environment"),
    ("AT-11", "Ministry of Defense"),
    ("AT-12", "Ministry of Interior"),
    ("AT-2", "Various ministries"),
    ("AT-3", "Federal Government of Austria"),
    ("AT-4", "Oesterreichische Kontrollbank AG"),
    ("AT-5", "Federal Ministry of Foreign Affairs"),
    ("AT-6", "Provincial governments, local communities "),
    ("AT-8", "Austrian Development Agency"),
    ("AT-9", "Education and Science Ministry"),
    ("AT-99", "Miscellaneous"),
    ("AU-5", "Australian Agency for International Development"),
    ("AU-72", "Export Finance and Insurance Corporation"),
    ("BE-10", "Directorate General for Co-operation and Development"),
    ("BE-20", "Official Federal Service of Foreign Affairs (excl. DGCD)"),
    ("BE-30", "Official Federal Service of Finance"),
    ("BE-31", "Ducroire National Office"),
    ("BE-39", "Other Official Federal Services"),
    ("BE-70", "Flanders Official Regional Ministries"),
    ("BE-80", "Walloon Official Regional Ministries"),
    ("BE-91", "Brussels Official Regional Ministries"),
    ("BE-94", "German speaking Official Regional Ministries"),
    ("CA-1", "Canadian International Development Agency"),
    ("CA-2", "International Development Research Centre"),
    ("CA-31", "Export Development Corporation"),
    ("CA-4", "Department of Finance"),
    ("CH-1", "Federal Administration (various departments)"),
    ("CH-10", "Swiss Agency for the Environment, Forests and Landscape "),
    ("CH-11", "Municipalities"),
    ("CH-4", "Swiss Agency for Development and Co-operation"),
    ("CH-5", "State Secretariat for Economic Affairs"),
    ("CH-6", "Federal Department of Foreign Affairs"),
    ("CH-7", "State Secretariat for Education and Research"),
    ("CH-8", "Federal Office for Migration"),
    ("CH-9", "Federal Department for Defence, Civil Protection and Sports "),
    ("DE-1", "Bundesministerium für Wirtschaftliche Zusammenarbeit und Entwicklung"),
    ("DE-11", "Foreign Office"),
    ("DE-12", "Federal States & Local Governments"),
    ("DE-14", "Federal Institutions"),
    ("DE-16", "Federal Ministries"),
    ("DE-17", "Foundations/Societies/Misc. (non federal)"),
    ("DE-2", "Kreditanstalt für Wiederaufbau"),
    ("DE-34", "Hermes Kreditversicherungs-AG"),
    ("DE-4", "German Investment and Development Company"),
    ("DE-52", "Deutsche Gesellschaft für Technische Zusammenarbeit"),
    ("DK-1", "Ministry of Foreign Affairs"),
    ("DK-2", "Danish International Development Agency (Not in CRS Directives)"),
    ("DK-4", "Not in CRS Directives"),
    ("DK-72", "EKR"),
    ("ES-1", "Instituto de Credito Oficial"),
    ("ES-10", "Ministry of Environment"),
    ("ES-11", "Ministry of Health"),
    ("ES-12", "Ministry of Labour and Social Affairs"),
    ("ES-13", "Ministry of Interior"),
    ("ES-14", "Ministry of Public Administration"),
    ("ES-15", "Compania Espanola de Seguros de Credito a la Exportación"),
    ("ES-16", "Municipalities"),
    ("ES-17", "Miscellaneous"),
    ("ES-18", "Ministry of Science and Technology"),
    ("ES-19", "Ministry of Defense"),
    ("ES-2", "Autonomous Governments"),
    ("ES-4", "Ministry of Agriculture, Fisheries, and Food "),
    ("ES-5", "Ministry of Foreign Affairs"),
    ("ES-6", "Ministry of Economy and Finance"),
    ("ES-7", "Ministry of Education, Culture and Sports "),
    ("ES-8", "Ministry of Public Works"),
    ("ES-9", "Ministry of Industry and Energy"),
    ("EU-1", "Commission of the European Communities"),
    ("EU-2", "European Development Fund"),
    ("EU-3", "European Investment Bank"),
    ("EU-4", "Humanitarian Aid Office of the European Commission"),
    ("FI-1", "Finnish Government"),
    ("FI-2", "FinnFund"),
    ("FI-3", "Ministry of Foreign Affairs"),
    ("FI-4", "FIDE"),
    ("FI-72", "FinnVera"),
    ("FR-10", "Ministry of Economy, Finance and Industry "),
    ("FR-17", "Ministry of Education, Higher education and Research "),
    ("FR-3", "French Development Agency"),
    ("FR-43", "Coface"),
    ("FR-6", "Ministry of Foreign Affairs"),
    ("GB-1", "Department for International Development"),
    ("GB-2", "CDC Capital Partners PLC"),
    ("GB-5", "Export Credit Guarantee Department"),
    ("GR-1", "Ministry of Foreign Affairs"),
    ("GR-2", "Ministry of National Economy"),
    ("GR-20", "Miscellaneous"),
    ("GR-3", "Ministry of the Interior, Public Administration and Decentralisation "),
    ("GR-4", "Ministry of National Defence"),
    ("GR-5", "Ministry of the Environment, Land Planning and Public Works "),
    ("GR-6", "Ministry of National Education and Religions"),
    ("GR-7", "Ministry of Agriculture"),
    ("GR-8", "Ministry of Health - Welfare"),
    ("GR-9", "Ministry of Merchant Marine"),
    ("IE-1", "Department of Foreign Affairs"),
    ("IE-71", "Department of Industry and Commerce"),
    ("IT-2", "Agenzia Erogazioni Per l'Agricoltura"),
    ("IT-4", "Direzione Generale per la Cooperazione allo Sviluppo"),
    ("IT-5", "Not in CRS Directives"),
    ("IT-7", "Central administration"),
    ("IT-74", "Sezione Speciale per l'Assicurazione del Credito all'Esportazione"),
    ("IT-8", "Local administration"),
    ("IT-9", "Artigiancassa"),
    ("JP-1", "Ministry of Agriculture, Forestry and Fisheries "),
    ("JP-10", "Japan Overseas Development Co-operation"),
    ("JP-11", "Japan Bank for International Co-operation"),
    ("JP-12", "Other Ministries"),
    ("JP-13", "Public Corporations"),
    ("JP-14", "Prefectures"),
    ("JP-15", "Ordinance-designed Cities"),
    ("JP-2", "Ministry of Foreign Affairs"),
    ("JP-7", "Overseas Fishery Co-operation Foundation"),
    ("JP-71", "Nippon Export and Investment Insurance"),
    ("JP-8", "Japanese International Co-operation Agency"),
    ("LU-1", "Lux-Development"),
    ("LU-2", "Ministry of Foreign Affairs"),
    ("LU-22", "Ducroire Office"),
    ("NL-1", "Ministry of Foreign Affairs (DGIS)"),
    ("NL-33", "NCM Credit Management Worldwide"),
    ("NL-4", "Netherlands Gov. through Netherlands Investment Bank for Developing Countries"),
    ("NO-1", "Norwegian Agency for Development Co-operation"),
    ("NO-4", "Ministry of Foreign Affairs"),
    ("NO-7", "Statens Nærings og Distriksutviklingsfond"),
    ("NO-71", "Garantiinstituttet for Eksportkreditt"),
    ("NO-72", "Eksport Finans"),
    ("NO-8", "NORFUND"),
    ("NZ-1", "Ministry of Foreign Affairs and Trade"),
    ("NZ-2", "New Zealand International Aid and Development Agency"),
    ("PT-1", "Portuguese Government"),
    ("PT-2", "Institute for Portuguese Development Aid"),
    ("PT-3", "Other"),
    ("PT-71", "Conselho de garantias financeiras"),
    ("SE-2", "Ministry of Foreign Affairs"),
    ("SE-6", "Swedish International Development Authority"),
    ("SE-71", "Swedish Export Credits Guarantee Board"),
    ("US-1", "Agency for International Development"),
    ("US-10", "Peace Corps"),
    ("US-11", "State Department"),
    ("US-12", "Trade and Development Agency"),
    ("US-13", "African Development Foundation"),
    ("US-15", "Centers for Disease Control and Prevention"),
    ("US-16", "National Institutes of Health"),
    ("US-17", "Department of Labor"),
    ("US-2", "Department of Agriculture"),
    ("US-31", "Export Import Bank"),
    ("US-5", "Department of Transportation"),
    ("US-6", "Department of Treasury"),
    ("US-7", "Department of Defense"),
    ("US-8", "Miscellaneous"),
    ("US-9", "Department of Interior"),
    ("41101", "Convention to Combat Desertification"),
    ("41102", "Desert Locust Control Organisation for Eastern Africa"),
    ("41103", "Economic Commission for Africa"),
    ("41104", "Economic Commission for Latin America and the Caribbean"),
    ("41105", "Economic and Social Commission for Western Asia"),
    ("41106", "Economic and Social Commission for Asia and the Pacific"),
    ("41107", "International Atomic Energy Agency (Contributions to Technical Cooperation Fund Only)"),
    ("41108", "International Fund for Agricultural Development"),
    ("41109", "International Research and Training Institute for the Advancement of Women"),
    ("41110", "Joint United Nations Programme on HIV/AIDS"),
    ("41111", "United Nations Capital Development Fund"),
    ("41112", "United Nations Conference on Trade and Development"),
    ("41114", "United Nations Development Programme"),
    ("41116", "United Nations Environment Programme"),
    ("41118", "United Nations Framework Convention on Climate Change"),
    ("41119", "United Nations Population Fund"),
    ("41120", "United Nations Human Settlement Programme"),
    ("41121", "United Nations Office of the United Nations High Commissioner for Refugees"),
    ("41122", "United Nations Children's Fund"),
    ("41123", "United Nations Industrial Development Organisation"),
    ("41124", "United Nations Development Fund for Women"),
    ("41125", "United Nations Institute for Training and Research"),
    ("41126", "United Nations Mine Action Service"),
    ("41127", "United Nations Office of Co-ordination of Humanitarian Affairs"),
    ("41128", "United Nations Office on Drugs and Crime"),
    ("41129", "United Nations Research Institute for Social Development"),
    ("41130", "United Nations Relief and Works Agency for Palestine Refugees in the Near East"),
    ("41131", "United Nations System Staff College"),
    ("41132", "United Nations System Standing Committee on Nutrition"),
    ("41133", "United Nations Special Initiative on Africa"),
    ("41134", "United Nations University (including Endowment Fund)"),
    ("41135", "United Nations Volunteers"),
    ("41136", "United Nations Voluntary Fund on Disability"),
    ("41137", "United Nations Voluntary Fund for Technical Co-operation in the Field of Human Rights"),
    ("41138", "United Nations Voluntary Fund for Victims of Torture"),
    ("41140", "World Food Programme"),
    ("41141", "United Nations Peacebuilding Fund (Window Two: Restricted Contributions Only)"),
    ("41142", "United Nations Democracy Fund"),
    ("41143", "World Health Organisation - core voluntary contributions account"),
    ("41301", "Food and Agricultural Organisation"),
    ("41302", "International Labour Organisation"),
    ("41303", "International Telecommunications Union"),
    ("41304", "United Nations Educational, Scientific and Cultural Organisation "),
    ("41305", "United Nations"),
    ("41306", "Universal Postal Union"),
    ("41307", "World Health Organisation - assessed contributions"),
    ("41308", "World Intellectual Property Organisation"),
    ("41309", "World Meteorological Organisation"),
    ("41310", "United Nations Department of Peacekeeping Operations (excluding UNTSO, UNMOGIP, UNFICYP, UNDOF) "),
    ("41311", "United Nations Peacebuilding Fund (Window One: Flexible Contributions Only)"),
    ("41312", "International Atomic Energy Agency - assessed contributions"),
    ("41313", "United Nations High Commissioner for Human Rights (extrabudgetary contributions only)"),
    ("41314", "United Nations Economic Commission for Europe (extrabudgetary contributions only)"),
    ("42001", "European Commission - Development Share of Budget"),
    ("42003", "European Commission - European Development Fund"),
    ("42004", "European Investment Bank (interest subsidies only)"),
    ("42005", "Facility for Euro-Mediterranean Investment and Partnership Trust Fund"),
    ("42006", "Global Energy Efficiency and Renewable Energy Fund"),
    ("43001", "International Monetary Fund - Poverty Reduction and Growth Facility Trust"),
    ("43002", "International Monetary Fund - Poverty Reduction and Growth Facility - Heavily Indebted Poor Countries Initiative Trust (includes HIPC, PRGF and PRGF-HIPC sub-accounts) "),
    ("43003", "International Monetary Fund - Subsidization of IMF Emergency Assistance for Natural Disasters"),
    ("44001", "International Bank for Reconstruction and Development"),
    ("44002", "International Development Association"),
    ("44003", "International Development Association - Heavily Indebted Poor Countries Debt Initiative Trust Fund"),
    ("44004", "International Finance Corporation"),
    ("44005", "Multilateral Investment Guarantee Agency"),
    ("44006", "Advance Market Commitments"),
    ("44007", "International Development Association - Multilateral Debt Relief Initiative"),
    ("45001", "World Trade Organisation - International Trade Centre"),
    ("45002", "World Trade Organisation - Advisory Centre on WTO Law"),
    ("45003", "World Trade Organisation - Doha Development Agenda Global Trust Fund"),
    ("46001", "African Solidarity Fund"),
    ("46002", "African Development Bank"),
    ("46003", "African Development Fund"),
    ("46004", "Asian Development Bank"),
    ("46005", "Asian Development Fund"),
    ("46006", "Black Sea Trade and Development Bank"),
    ("46007", "Central American Bank for Economic Integration"),
    ("46008", "Andean Development Corporation"),
    ("46009", "Caribbean Development Bank"),
    ("46012", "Inter-American Development Bank, Inter-American Investment Corporation and Multilateral Investment Fund "),
    ("46013", "Inter-American Development Fund for Special Operations"),
    ("47001", "African Capacity Building Foundation"),
    ("47002", "Asian Productivity Organisation"),
    ("47003", "Association of South East Asian Nations: Economic Co-operation"),
    ("47004", "ASEAN Cultural Fund"),
    ("47005", "African Union (excluding peacekeeping facilities)"),
    ("47008", "World Vegetable Centre"),
    ("47009", "African and Malagasy Council for Higher Education"),
    ("47010", "Commonwealth Agency for Public Administration and Management"),
    ("47011", "Caribbean Community Secretariat"),
    ("47012", "Caribbean Epidemiology Centre"),
    ("47013", "Commonwealth Foundation"),
    ("47014", "Commonwealth Fund for Technical Co-operation"),
    ("47015", "Consultative Group on International Agricultural Research"),
    ("47016", "Commonwealth Institute"),
    ("47017", "International Centre for Tropical Agriculture"),
    ("47018", "Centre for International Forestry Research"),
    ("47019", "International Centre for Advanced Mediterranean Agronomic Studies"),
    ("47020", "International Maize and Wheat Improvement Centre"),
    ("47021", "International Potato Centre"),
    ("47022", "Convention on International Trade in Endangered Species of Wild Flora and Fauna"),
    ("47023", "Commonwealth Legal Advisory Service"),
    ("47024", "Commonwealth Media Development Fund"),
    ("47025", "Commonwealth of Learning"),
    ("47026", "Community of Portuguese Speaking Countries"),
    ("47027", "Colombo Plan"),
    ("47028", "Commonwealth Partnership for Technical Management"),
    ("47029", "Sahel and West Africa Club"),
    ("47030", "Commonwealth Scientific Council"),
    ("47031", "Commonwealth Small States Office"),
    ("47032", "Commonwealth Trade and Investment Access Facility"),
    ("47033", "Commonwealth Youth Programme"),
    ("47034", "Economic Community of West African States"),
    ("47035", "Environmental Development Action in the Third World"),
    ("47036", "European and Mediterranean Plant Protection Organisation"),
    ("47037", "Eastern-Regional Organisation of Public Administration"),
    ("47038", "INTERPOL Fund for Aid and Technical Assistance to Developing Countries"),
    ("47040", "Forum Fisheries Agency"),
    ("47041", "Food and Fertilizer Technology Centre"),
    ("47042", "Foundation for International Training"),
    ("47043", "Global Crop Diversity Trust"),
    ("47044", "Global Environment Facility"),
    ("47045", "Global Fund to Fight AIDS, Tuberculosis and Malaria "),
    ("47046", "International Organisation of the Francophonic"),
    ("47047", "International African Institute"),
    ("47048", "Inter-American Indian Institute"),
    ("47049", "International Bureau of Education - International Educational Reporting System (IERS)"),
    ("47050", "International Cotton Advisory Committee"),
    ("47051", "International Centre for Agricultural Research in Dry Areas"),
    ("47053", "Centre for Health and Population Research"),
    ("47054", "International Centre of Insect Physiology and Ecology"),
    ("47055", "International Centre for Development Oriented Research in Agriculture"),
    ("47056", "World AgroForestry Centre"),
    ("47057", "International Crop Research for Semi-Arid Tropics"),
    ("47058", "International Institute for Democracy and Electoral Assistance"),
    ("47059", "International Development Law Organisation"),
    ("47060", "International Institute for Cotton"),
    ("47061", "Inter-American Institute for Co-operation on Agriculture"),
    ("47062", "International Institute of Tropical Agriculture"),
    ("47063", "International Livestock Research Institute"),
    ("47064", "International Network for Bamboo and Rattan"),
    ("47065", "Intergovernmental Oceanographic Commission"),
    ("47066", "International Organisation for Migration"),
    ("47067", "Intergovernmental Panel on Climate Change"),
    ("47068", "Asia-Pacific Fishery Commission"),
    ("47069", "Biodiversity International"),
    ("47070", "International Rice Research Institute"),
    ("47071", "International Seed Testing Association"),
    ("47073", "International Tropical Timber Organisation"),
    ("47074", "International Vaccine Institute"),
    ("47075", "International Water Management Institute"),
    ("47076", "Justice Studies Centre of the Americas"),
    ("47077", "Mekong River Commission"),
    ("47078", "Multilateral Fund for the Implementation of the Montreal Protocol"),
    ("47079", "Organisation of American States"),
    ("47080", "Organisation for Economic Co-operation and Development (Contributions to special funds for Technical Co-operation Activities Only)"),
    ("47081", "OECD Development Centre"),
    ("47082", "Organisation of Eastern Caribbean States"),
    ("47083", "Pan-American Health Organisation"),
    ("47084", "Pan-American Institute of Geography and History"),
    ("47085", "Pan-American Railway Congress Association"),
    ("47086", "Private Infrastructure Development Group"),
    ("47087", "Pacific Islands Forum Secretariat"),
    ("47088", "Relief Net"),
    ("47089", "Southern African Development Community"),
    ("47090", "Southern African Transport and Communications Commission"),
    ("47091", "(Colombo Plan) Special Commonwealth African Assistance Programme"),
    ("47092", "South East Asian Fisheries Development Centre"),
    ("47093", "South East Asian Ministers of Education"),
    ("47094", "South Pacific Applied Geoscience Commission"),
    ("47095", "South Pacific Board for Educational Assessment"),
    ("47096", "Secretariat of the Pacific Community"),
    ("47097", "Pacific Regional Environment Programme"),
    ("47098", "Unrepresented Nations and Peoples' Organisation"),
    ("47099", "University of the South Pacific"),
    ("47100", "West African Monetary Union"),
    ("47101", "Africa Rice Centre"),
    ("47102", "World Customs Organisation Fellowship Programme"),
    ("47103", "World Maritime University"),
    ("47104", "WorldFish Centre"),
    ("47105", "Common Fund for Commodities"),
    ("47106", "Geneva Centre for the Democratic Control of Armed Forces"),
    ("47107", "International Finance Facility for Immunisation"),
    ("47108", "Multi-Country Demobilisation and Reintegration Program"),
    ("47109", "Asia-Pacific Economic Cooperation Support Fund (except contributions tied to counter-terrorism activities)"),
    ("47110", "Organisation of the Black Sea Economic Cooperation"),
    ("47111", "Adaptation Fund"),
    ("47112", "Central European Initiative - Special Fund for Climate and Environmental Protection"),
    ("47113", "Economic and Monetary Community of Central Africa"),
    ("47116", "Integrated Framework for Trade-Related Technical Assistance to Least Developed Countries"),
    ("47117", "New Partnership for Africa's Development"),
    ("47118", "Regional Organisation for the Strengthening of Supreme Audit Institutions of Francophone Sub-Saharan Countries"),
    ("47119", "Sahara and Sahel Observatory"),
    ("47120", "South Asian Association for Regional Cooperation"),
    ("47121", "United Cities and Local Governments of Africa"),
    ("47122", "Global Alliance for Vaccines and Immunization"),
    ("47123", "Geneva International Centre for Humanitarian Demining"),
    ("47125", "European Bank for Reconstruction and Development - Early Transition Countries Initiative"),
    ("47126", "European Bank for Reconstruction and Development - Western Balkans Trust Fund"),
    ("47127", "Latin-American Energy Organisation"),
    ("21001", "Association of Geoscientists for International Development"),
    ("21002", "Agency for International Trade Information and Co-operation"),
    ("21003", "Latin American Council for Social Sciences"),
    ("21004", "Council for the Development of Economic and Social Research in Africa"),
    ("21005", "Consumer Unity and Trust Society International"),
    ("21006", "Development Gateway Foundation"),
    ("21007", "Environmental Liaison Centre International"),
    ("21008", "Eurostep"),
    ("21009", "Forum for Agricultural Research in Africa"),
    ("21010", "Forum for African Women Educationalists"),
    ("21011", "Global Campaign for Education"),
    ("21013", "Health Action International"),
    ("21014", "Human Rights Information and Documentation Systems"),
    ("21015", "International Catholic Rural Association"),
    ("21016", "International Committee of the Red Cross"),
    ("21017", "International Centre for Trade and Sustainable Development"),
    ("21018", "International Federation of Red Cross and Red Crescent Societies"),
    ("21019", "International Federation of Settlements and Neighbourhood Centres"),
    ("21020", "International HIV/AIDS Alliance"),
    ("21021", "International Institute for Environment and Development"),
    ("21022", "International Network for Alternative Financial Institutions"),
    ("21023", "International Planned Parenthood Federation"),
    ("21024", "Inter Press Service, International Association "),
    ("21025", "International Seismological Centre"),
    ("21026", "International Service for Human Rights"),
    ("21027", "International Trust Fund for Demining and Mine Victims Assistance"),
    ("21028", "International University Exchange Fund - IUEF Stip. in Africa and Latin America"),
    ("21029", "Doctors Without Borders"),
    ("21030", "Pan African Institute for Development"),
    ("21031", "PANOS Institute"),
    ("21032", "Population Services International"),
    ("21033", "Transparency International"),
    ("21034", "International Union Against Tuberculosis and Lung Disease"),
    ("21035", "World Organisation Against Torture"),
    ("21036", "World University Service"),
    ("21037", "Women's World Banking"),
    ("21038", "International Alert"),
    ("21039", "International Institute for Sustainable Development"),
    ("21040", "International Women's Tribune Centre"),
    ("21041", "Society for International Development"),
    ("21042", "International Peacebuilding Alliance"),
    ("21043", "European Parliamentarians for Africa"),
    ("21044", "International Council for the Control of Iodine Deficiency Disorders"),
    ("21045", "African Medical and Research Foundation"),
    ("21046", "Agency for Cooperation and Research in Development"),
    ("21047", "AgriCord"),
    ("21048", "Association of African Universities"),
    ("21049", "European Centre for Development Policy Management"),
    ("21050", "Geneva Call"),
    ("21051", "Institut Supérieur Panafricaine d'Economie Coopérative"),
    ("21053", "IPAS-Protecting Women's Health, Advancing Women's Reproductive Rights "),
    ("21054", "Life and Peace Institute"),
    ("21055", "Regional AIDS Training Network"),
    ("21056", "Renewable Energy and Energy Efficiency Partnership"),
    ("21057", "International Centre for Transitional Justice"),
    ("30001", "Global Alliance for Improved Nutrition"),
    ("30003", "Global e-Schools and Communities Initiative"),
    ("30004", "Global Water Partnership"),
    ("30005", "International AIDS Vaccine Initiative"),
    ("30006", "International Partnership on Microbicides"),
    ("30007", "Global Alliance for ICT and Development"),
    ("30008", "Cities Alliance"),
    ("30009", "Small Arms Survey"),
    ("30010", "International drug purchase facility"),
    ("30011", "International Union for the Conservation of Nature"),
    ("31001", "Global Development Network"),
    ("31002", "Global Knowledge Partnership"),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/RelatedActivityType.xml
RELATED_ACTIVITY_TYPE = (
    ("code", "name", "description"),
    ("1", _("Parent"), _("An activity that contains sub-activities (sub-components) which are reported separately to IATI")),
    ("2", _("Child"), _("A sub-activity (or sub-component) that sits within a larger activity (parent) which is also reported to IATI")),
    ("3", _("Sibling"), _("A sub-activity (or sub-component) that is related to another sub-activity with the same parent ")),
    ("4", _("Co-funded"), _("An activity that receives funding from more than one organisation")),
    ("5", _("Third Party"), _("A report by another organisation on the same activity you are reporting (excluding activities reported as part of a financial transaction - e.g. provider-activity-id or a co-funded activity, using code 4)")),
)

# From http://iatistandard.org/202/codelists/downloads/clv2/xml/FileFormat.xml
FILE_FORMAT = (
    ("category", "code"),
    ("application", "application/1d-interleaved-parityfec"),
    ("application", "application/3gpdash-qoe-report+xml"),
    ("application", "application/3gpp-ims+xml"),
    ("application", "application/A2L"),
    ("application", "application/activemessage"),
    ("application", "application/activemessage"),
    ("application", "application/alto-costmap+json"),
    ("application", "application/alto-costmapfilter+json"),
    ("application", "application/alto-directory+json"),
    ("application", "application/alto-endpointprop+json"),
    ("application", "application/alto-endpointpropparams+json"),
    ("application", "application/alto-endpointcost+json"),
    ("application", "application/alto-endpointcostparams+json"),
    ("application", "application/alto-error+json"),
    ("application", "application/alto-networkmapfilter+json"),
    ("application", "application/alto-networkmap+json"),
    ("application", "application/AML"),
    ("application", "application/andrew-inset"),
    ("application", "application/applefile"),
    ("application", "application/ATF"),
    ("application", "application/ATFX"),
    ("application", "application/atom+xml"),
    ("application", "application/atomcat+xml"),
    ("application", "application/atomdeleted+xml"),
    ("application", "application/atomicmail"),
    ("application", "application/atomsvc+xml"),
    ("application", "application/ATXML"),
    ("application", "application/auth-policy+xml"),
    ("application", "application/bacnet-xdd+zip"),
    ("application", "application/batch-SMTP"),
    ("application", "application/beep+xml"),
    ("application", "application/calendar+json"),
    ("application", "application/calendar+xml"),
    ("application", "application/call-completion"),
    ("application", "application/CALS-1840"),
    ("application", "application/cbor"),
    ("application", "application/ccmp+xml"),
    ("application", "application/ccxml+xml"),
    ("application", "application/CDFX+XML"),
    ("application", "application/cdmi-capability"),
    ("application", "application/cdmi-container"),
    ("application", "application/cdmi-domain"),
    ("application", "application/cdmi-object"),
    ("application", "application/cdmi-queue"),
    ("application", "application/cdni"),
    ("application", "application/CEA"),
    ("application", "application/cea-2018+xml"),
    ("application", "application/cellml+xml"),
    ("application", "application/cfw"),
    ("application", "application/clue_info+xml"),
    ("application", "application/cms"),
    ("application", "application/cnrp+xml"),
    ("application", "application/coap-group+json"),
    ("application", "application/coap-payload"),
    ("application", "application/commonground"),
    ("application", "application/conference-info+xml"),
    ("application", "application/cpl+xml"),
    ("application", "application/cose"),
    ("application", "application/cose-key"),
    ("application", "application/cose-key-set"),
    ("application", "application/csrattrs"),
    ("application", "application/csta+xml"),
    ("application", "application/CSTAdata+xml"),
    ("application", "application/csvm+json"),
    ("application", "application/cybercash"),
    ("application", "application/dash+xml"),
    ("application", "application/dashdelta"),
    ("application", "application/davmount+xml"),
    ("application", "application/dca-rft"),
    ("application", "application/DCD"),
    ("application", "application/dec-dx"),
    ("application", "application/dialog-info+xml"),
    ("application", "application/dicom"),
    ("application", "application/dicom+json"),
    ("application", "application/dicom+xml"),
    ("application", "application/DII"),
    ("application", "application/DIT"),
    ("application", "application/dns"),
    ("application", "application/dskpp+xml"),
    ("application", "application/dssc+der"),
    ("application", "application/dssc+xml"),
    ("application", "application/dvcs"),
    ("application", "application/ecmascript"),
    ("application", "application/EDI-consent"),
    ("application", "application/EDIFACT"),
    ("application", "application/EDI-X12"),
    ("application", "application/efi"),
    ("application", "application/EmergencyCallData.Comment+xml"),
    ("application", "application/EmergencyCallData.Control+xml"),
    ("application", "application/EmergencyCallData.DeviceInfo+xml"),
    ("application", "application/EmergencyCallData.eCall.MSD"),
    ("application", "application/EmergencyCallData.ProviderInfo+xml"),
    ("application", "application/EmergencyCallData.ServiceInfo+xml"),
    ("application", "application/EmergencyCallData.SubscriberInfo+xml"),
    ("application", "application/EmergencyCallData.VEDS+xml"),
    ("application", "application/emma+xml"),
    ("application", "application/emotionml+xml"),
    ("application", "application/encaprtp"),
    ("application", "application/epp+xml"),
    ("application", "application/epub+zip"),
    ("application", "application/eshop"),
    ("application", "application/example"),
    ("application", "application/exi"),
    ("application", "application/fastinfoset"),
    ("application", "application/fastsoap"),
    ("application", "application/fdt+xml"),
    ("application", "application/fits"),
    ("application", "application/font-sfnt"),
    ("application", "application/font-tdpfr"),
    ("application", "application/font-woff"),
    ("application", "application/framework-attributes+xml"),
    ("application", "application/geo+json"),
    ("application", "application/geo+json-seq"),
    ("application", "application/gml+xml"),
    ("application", "application/gzip"),
    ("application", "application/H224"),
    ("application", "application/held+xml"),
    ("application", "application/http"),
    ("application", "application/hyperstudio"),
    ("application", "application/ibe-key-request+xml"),
    ("application", "application/ibe-pkg-reply+xml"),
    ("application", "application/ibe-pp-data"),
    ("application", "application/iges"),
    ("application", "application/im-iscomposing+xml"),
    ("application", "application/index"),
    ("application", "application/index.cmd"),
    ("application", "application/index.obj"),
    ("application", "application/index.response"),
    ("application", "application/index.vnd"),
    ("application", "application/inkml+xml"),
    ("application", "application/iotp"),
    ("application", "application/ipfix"),
    ("application", "application/ipp"),
    ("application", "application/isup"),
    ("application", "application/its+xml"),
    ("application", "application/javascript"),
    ("application", "application/jose"),
    ("application", "application/jose+json"),
    ("application", "application/jrd+json"),
    ("application", "application/json"),
    ("application", "application/json-patch+json"),
    ("application", "application/json-seq"),
    ("application", "application/jwk+json"),
    ("application", "application/jwk-set+json"),
    ("application", "application/jwt"),
    ("application", "application/kpml-request+xml"),
    ("application", "application/kpml-response+xml"),
    ("application", "application/ld+json"),
    ("application", "application/lgr+xml"),
    ("application", "application/link-format"),
    ("application", "application/load-control+xml"),
    ("application", "application/lost+xml"),
    ("application", "application/lostsync+xml"),
    ("application", "application/LXF"),
    ("application", "application/mac-binhex40"),
    ("application", "application/macwriteii"),
    ("application", "application/mads+xml"),
    ("application", "application/marc"),
    ("application", "application/marcxml+xml"),
    ("application", "application/mathematica"),
    ("application", "application/mathml-content+xml"),
    ("application", "application/mathml-presentation+xml"),
    ("application", "application/mathml+xml"),
    ("application", "application/mbms-associated-procedure-description+xml"),
    ("application", "application/mbms-deregister+xml"),
    ("application", "application/mbms-envelope+xml"),
    ("application", "application/mbms-msk-response+xml"),
    ("application", "application/mbms-msk+xml"),
    ("application", "application/mbms-protection-description+xml"),
    ("application", "application/mbms-reception-report+xml"),
    ("application", "application/mbms-register-response+xml"),
    ("application", "application/mbms-register+xml"),
    ("application", "application/mbms-schedule+xml"),
    ("application", "application/mbms-user-service-description+xml"),
    ("application", "application/mbox"),
    ("application", "application/media_control+xml"),
    ("application", "application/media-policy-dataset+xml"),
    ("application", "application/mediaservercontrol+xml"),
    ("application", "application/merge-patch+json"),
    ("application", "application/metalink4+xml"),
    ("application", "application/mets+xml"),
    ("application", "application/MF4"),
    ("application", "application/mikey"),
    ("application", "application/mods+xml"),
    ("application", "application/moss-keys"),
    ("application", "application/moss-signature"),
    ("application", "application/mosskey-data"),
    ("application", "application/mosskey-request"),
    ("application", "application/mp21"),
    ("application", "application/mp4"),
    ("application", "application/mpeg4-generic"),
    ("application", "application/mpeg4-iod"),
    ("application", "application/mpeg4-iod-xmt"),
    ("application", "application/mrb-consumer+xml"),
    ("application", "application/mrb-publish+xml"),
    ("application", "application/msc-ivr+xml"),
    ("application", "application/msc-mixer+xml"),
    ("application", "application/msword"),
    ("application", "application/mud+json"),
    ("application", "application/mxf"),
    ("application", "application/n-quads"),
    ("application", "application/n-triples"),
    ("application", "application/nasdata"),
    ("application", "application/news-checkgroups"),
    ("application", "application/news-groupinfo"),
    ("application", "application/news-transmission"),
    ("application", "application/nlsml+xml"),
    ("application", "application/nss"),
    ("application", "application/ocsp-request"),
    ("application", "application/ocsp-response"),
    ("application", "application/octet-stream"),
    ("application", "application/oda"),
    ("application", "application/ODX"),
    ("application", "application/oebps-package+xml"),
    ("application", "application/ogg"),
    ("application", "application/oxps"),
    ("application", "application/p2p-overlay+xml"),
    ("application", "application/parityfec"),
    ("application", "application/patch-ops-error+xml"),
    ("application", "application/pdf"),
    ("application", "application/PDX"),
    ("application", "application/pgp-encrypted"),
    ("application", "application/pgp-keys"),
    ("application", "application/pgp-signature"),
    ("application", "application/pidf-diff+xml"),
    ("application", "application/pidf+xml"),
    ("application", "application/pkcs10"),
    ("application", "application/pkcs7-mime"),
    ("application", "application/pkcs7-signature"),
    ("application", "application/pkcs8"),
    ("application", "application/pkcs12"),
    ("application", "application/pkix-attr-cert"),
    ("application", "application/pkix-cert"),
    ("application", "application/pkix-crl"),
    ("application", "application/pkix-pkipath"),
    ("application", "application/pkixcmp"),
    ("application", "application/pls+xml"),
    ("application", "application/poc-settings+xml"),
    ("application", "application/postscript"),
    ("application", "application/ppsp-tracker+json"),
    ("application", "application/problem+json"),
    ("application", "application/problem+xml"),
    ("application", "application/provenance+xml"),
    ("application", "application/prs.alvestrand.titrax-sheet"),
    ("application", "application/prs.cww"),
    ("application", "application/prs.hpub+zip"),
    ("application", "application/prs.nprend"),
    ("application", "application/prs.plucker"),
    ("application", "application/prs.rdf-xml-crypt"),
    ("application", "application/prs.xsf+xml"),
    ("application", "application/pskc+xml"),
    ("application", "application/rdf+xml"),
    ("application", "application/qsig"),
    ("application", "application/raptorfec"),
    ("application", "application/rdap+json"),
    ("application", "application/reginfo+xml"),
    ("application", "application/relax-ng-compact-syntax"),
    ("application", "application/remote-printing"),
    ("application", "application/reputon+json"),
    ("application", "application/resource-lists-diff+xml"),
    ("application", "application/resource-lists+xml"),
    ("application", "application/rfc+xml"),
    ("application", "application/riscos"),
    ("application", "application/rlmi+xml"),
    ("application", "application/rls-services+xml"),
    ("application", "application/rpki-ghostbusters"),
    ("application", "application/rpki-manifest"),
    ("application", "application/rpki-publication"),
    ("application", "application/rpki-roa"),
    ("application", "application/rpki-updown"),
    ("application", "application/rtf"),
    ("application", "application/rtploopback"),
    ("application", "application/rtx"),
    ("application", "application/samlassertion+xml"),
    ("application", "application/samlmetadata+xml"),
    ("application", "application/sbml+xml"),
    ("application", "application/scaip+xml"),
    ("application", "application/scim+json"),
    ("application", "application/scvp-cv-request"),
    ("application", "application/scvp-cv-response"),
    ("application", "application/scvp-vp-request"),
    ("application", "application/scvp-vp-response"),
    ("application", "application/sdp"),
    ("application", "application/sep-exi"),
    ("application", "application/sep+xml"),
    ("application", "application/session-info"),
    ("application", "application/set-payment"),
    ("application", "application/set-payment-initiation"),
    ("application", "application/set-registration"),
    ("application", "application/set-registration-initiation"),
    ("application", "application/sgml"),
    ("application", "application/sgml-open-catalog"),
    ("application", "application/shf+xml"),
    ("application", "application/sieve"),
    ("application", "application/simple-filter+xml"),
    ("application", "application/simple-message-summary"),
    ("application", "application/simpleSymbolContainer"),
    ("application", "application/slate"),
    ("application", "application/smil"),
    ("application", "application/smil+xml"),
    ("application", "application/smpte336m"),
    ("application", "application/soap+fastinfoset"),
    ("application", "application/soap+xml"),
    ("application", "application/sparql-query"),
    ("application", "application/sparql-results+xml"),
    ("application", "application/spirits-event+xml"),
    ("application", "application/sql"),
    ("application", "application/srgs"),
    ("application", "application/srgs+xml"),
    ("application", "application/sru+xml"),
    ("application", "application/ssml+xml"),
    ("application", "application/tamp-apex-update"),
    ("application", "application/tamp-apex-update-confirm"),
    ("application", "application/tamp-community-update"),
    ("application", "application/tamp-community-update-confirm"),
    ("application", "application/tamp-error"),
    ("application", "application/tamp-sequence-adjust"),
    ("application", "application/tamp-sequence-adjust-confirm"),
    ("application", "application/tamp-status-query"),
    ("application", "application/tamp-status-response"),
    ("application", "application/tamp-update"),
    ("application", "application/tamp-update-confirm"),
    ("application", "application/tei+xml"),
    ("application", "application/thraud+xml"),
    ("application", "application/timestamp-query"),
    ("application", "application/timestamp-reply"),
    ("application", "application/timestamped-data"),
    ("application", "application/trig"),
    ("application", "application/ttml+xml"),
    ("application", "application/tve-trigger"),
    ("application", "application/ulpfec"),
    ("application", "application/urc-grpsheet+xml"),
    ("application", "application/urc-ressheet+xml"),
    ("application", "application/urc-targetdesc+xml"),
    ("application", "application/urc-uisocketdesc+xml"),
    ("application", "application/vcard+json"),
    ("application", "application/vcard+xml"),
    ("application", "application/vemmi"),
    ("application", "application/vnd.1000minds.decision-model+xml"),
    ("application", "application/vnd.3gpp.access-transfer-events+xml"),
    ("application", "application/vnd.3gpp.bsf+xml"),
    ("application", "application/vnd.3gpp.mid-call+xml"),
    ("application", "application/vnd.3gpp.pic-bw-large"),
    ("application", "application/vnd.3gpp.pic-bw-small"),
    ("application", "application/vnd.3gpp.pic-bw-var"),
    ("application", "application/vnd.3gpp-prose-pc3ch+xml"),
    ("application", "application/vnd.3gpp-prose+xml"),
    ("application", "application/vnd.3gpp.sms"),
    ("application", "application/vnd.3gpp.sms+xml"),
    ("application", "application/vnd.3gpp.srvcc-ext+xml"),
    ("application", "application/vnd.3gpp.SRVCC-info+xml"),
    ("application", "application/vnd.3gpp.state-and-event-info+xml"),
    ("application", "application/vnd.3gpp.ussd+xml"),
    ("application", "application/vnd.3gpp2.bcmcsinfo+xml"),
    ("application", "application/vnd.3gpp2.sms"),
    ("application", "application/vnd.3gpp2.tcap"),
    ("application", "application/vnd.3lightssoftware.imagescal"),
    ("application", "application/vnd.3M.Post-it-Notes"),
    ("application", "application/vnd.accpac.simply.aso"),
    ("application", "application/vnd.accpac.simply.imp"),
    ("application", "application/vnd.acucobol"),
    ("application", "application/vnd.acucorp"),
    ("application", "application/vnd.adobe.flash.movie"),
    ("application", "application/vnd.adobe.formscentral.fcdt"),
    ("application", "application/vnd.adobe.fxp"),
    ("application", "application/vnd.adobe.partial-upload"),
    ("application", "application/vnd.adobe.xdp+xml"),
    ("application", "application/vnd.adobe.xfdf"),
    ("application", "application/vnd.aether.imp"),
    ("application", "application/vnd.ah-barcode"),
    ("application", "application/vnd.ahead.space"),
    ("application", "application/vnd.airzip.filesecure.azf"),
    ("application", "application/vnd.airzip.filesecure.azs"),
    ("application", "application/vnd.amazon.mobi8-ebook"),
    ("application", "application/vnd.americandynamics.acc"),
    ("application", "application/vnd.amiga.ami"),
    ("application", "application/vnd.amundsen.maze+xml"),
    ("application", "application/vnd.anki"),
    ("application", "application/vnd.anser-web-certificate-issue-initiation"),
    ("application", "application/vnd.antix.game-component"),
    ("application", "application/vnd.apache.thrift.binary"),
    ("application", "application/vnd.apache.thrift.compact"),
    ("application", "application/vnd.apache.thrift.json"),
    ("application", "application/vnd.api+json"),
    ("application", "application/vnd.apothekende.reservation+json"),
    ("application", "application/vnd.apple.mpegurl"),
    ("application", "application/vnd.apple.installer+xml"),
    ("application", "application/vnd.arastra.swi"),
    ("application", "application/vnd.aristanetworks.swi"),
    ("application", "application/vnd.artsquare"),
    ("application", "application/vnd.astraea-software.iota"),
    ("application", "application/vnd.audiograph"),
    ("application", "application/vnd.autopackage"),
    ("application", "application/vnd.avistar+xml"),
    ("application", "application/vnd.balsamiq.bmml+xml"),
    ("application", "application/vnd.balsamiq.bmpr"),
    ("application", "application/vnd.bekitzur-stech+json"),
    ("application", "application/vnd.bint.med-content"),
    ("application", "application/vnd.biopax.rdf+xml"),
    ("application", "application/vnd.blueice.multipass"),
    ("application", "application/vnd.bluetooth.ep.oob"),
    ("application", "application/vnd.bluetooth.le.oob"),
    ("application", "application/vnd.bmi"),
    ("application", "application/vnd.businessobjects"),
    ("application", "application/vnd.cab-jscript"),
    ("application", "application/vnd.canon-cpdl"),
    ("application", "application/vnd.canon-lips"),
    ("application", "application/vnd.capasystems-pg+json"),
    ("application", "application/vnd.cendio.thinlinc.clientconf"),
    ("application", "application/vnd.century-systems.tcp_stream"),
    ("application", "application/vnd.chemdraw+xml"),
    ("application", "application/vnd.chess-pgn"),
    ("application", "application/vnd.chipnuts.karaoke-mmd"),
    ("application", "application/vnd.cinderella"),
    ("application", "application/vnd.cirpack.isdn-ext"),
    ("application", "application/vnd.citationstyles.style+xml"),
    ("application", "application/vnd.claymore"),
    ("application", "application/vnd.cloanto.rp9"),
    ("application", "application/vnd.clonk.c4group"),
    ("application", "application/vnd.cluetrust.cartomobile-config"),
    ("application", "application/vnd.cluetrust.cartomobile-config-pkg"),
    ("application", "application/vnd.coffeescript"),
    ("application", "application/vnd.collection.doc+json"),
    ("application", "application/vnd.collection+json"),
    ("application", "application/vnd.collection.next+json"),
    ("application", "application/vnd.comicbook+zip"),
    ("application", "application/vnd.commerce-battelle"),
    ("application", "application/vnd.commonspace"),
    ("application", "application/vnd.coreos.ignition+json"),
    ("application", "application/vnd.cosmocaller"),
    ("application", "application/vnd.contact.cmsg"),
    ("application", "application/vnd.crick.clicker"),
    ("application", "application/vnd.crick.clicker.keyboard"),
    ("application", "application/vnd.crick.clicker.palette"),
    ("application", "application/vnd.crick.clicker.template"),
    ("application", "application/vnd.crick.clicker.wordbank"),
    ("application", "application/vnd.criticaltools.wbs+xml"),
    ("application", "application/vnd.ctc-posml"),
    ("application", "application/vnd.ctct.ws+xml"),
    ("application", "application/vnd.cups-pdf"),
    ("application", "application/vnd.cups-postscript"),
    ("application", "application/vnd.cups-ppd"),
    ("application", "application/vnd.cups-raster"),
    ("application", "application/vnd.cups-raw"),
    ("application", "application/vnd.curl"),
    ("application", "application/vnd.cyan.dean.root+xml"),
    ("application", "application/vnd.cybank"),
    ("application", "application/vnd.d2l.coursepackage1p0+zip"),
    ("application", "application/vnd.dart"),
    ("application", "application/vnd.data-vision.rdz"),
    ("application", "application/vnd.datapackage+json"),
    ("application", "application/vnd.dataresource+json"),
    ("application", "application/vnd.debian.binary-package"),
    ("application", "application/vnd.dece.data"),
    ("application", "application/vnd.dece.ttml+xml"),
    ("application", "application/vnd.dece.unspecified"),
    ("application", "application/vnd.dece.zip"),
    ("application", "application/vnd.denovo.fcselayout-link"),
    ("application", "application/vnd.desmume.movie"),
    ("application", "application/vnd.dir-bi.plate-dl-nosuffix"),
    ("application", "application/vnd.dm.delegation+xml"),
    ("application", "application/vnd.dna"),
    ("application", "application/vnd.document+json"),
    ("application", "application/vnd.dolby.mobile.1"),
    ("application", "application/vnd.dolby.mobile.2"),
    ("application", "application/vnd.doremir.scorecloud-binary-document"),
    ("application", "application/vnd.dpgraph"),
    ("application", "application/vnd.dreamfactory"),
    ("application", "application/vnd.drive+json"),
    ("application", "application/vnd.dtg.local"),
    ("application", "application/vnd.dtg.local.flash"),
    ("application", "application/vnd.dtg.local.html"),
    ("application", "application/vnd.dvb.ait"),
    ("application", "application/vnd.dvb.dvbj"),
    ("application", "application/vnd.dvb.esgcontainer"),
    ("application", "application/vnd.dvb.ipdcdftnotifaccess"),
    ("application", "application/vnd.dvb.ipdcesgaccess"),
    ("application", "application/vnd.dvb.ipdcesgaccess2"),
    ("application", "application/vnd.dvb.ipdcesgpdd"),
    ("application", "application/vnd.dvb.ipdcroaming"),
    ("application", "application/vnd.dvb.iptv.alfec-base"),
    ("application", "application/vnd.dvb.iptv.alfec-enhancement"),
    ("application", "application/vnd.dvb.notif-aggregate-root+xml"),
    ("application", "application/vnd.dvb.notif-container+xml"),
    ("application", "application/vnd.dvb.notif-generic+xml"),
    ("application", "application/vnd.dvb.notif-ia-msglist+xml"),
    ("application", "application/vnd.dvb.notif-ia-registration-request+xml"),
    ("application", "application/vnd.dvb.notif-ia-registration-response+xml"),
    ("application", "application/vnd.dvb.notif-init+xml"),
    ("application", "application/vnd.dvb.pfr"),
    ("application", "application/vnd.dvb.service"),
    ("application", "application/vnd.dxr"),
    ("application", "application/vnd.dynageo"),
    ("application", "application/vnd.dzr"),
    ("application", "application/vnd.easykaraoke.cdgdownload"),
    ("application", "application/vnd.ecdis-update"),
    ("application", "application/vnd.ecowin.chart"),
    ("application", "application/vnd.ecowin.filerequest"),
    ("application", "application/vnd.ecowin.fileupdate"),
    ("application", "application/vnd.ecowin.series"),
    ("application", "application/vnd.ecowin.seriesrequest"),
    ("application", "application/vnd.ecowin.seriesupdate"),
    ("application", "application/vnd.efi.img"),
    ("application", "application/vnd.efi.iso"),
    ("application", "application/vnd.emclient.accessrequest+xml"),
    ("application", "application/vnd.enliven"),
    ("application", "application/vnd.enphase.envoy"),
    ("application", "application/vnd.eprints.data+xml"),
    ("application", "application/vnd.epson.esf"),
    ("application", "application/vnd.epson.msf"),
    ("application", "application/vnd.epson.quickanime"),
    ("application", "application/vnd.epson.salt"),
    ("application", "application/vnd.epson.ssf"),
    ("application", "application/vnd.ericsson.quickcall"),
    ("application", "application/vnd.espass-espass+zip"),
    ("application", "application/vnd.eszigno3+xml"),
    ("application", "application/vnd.etsi.aoc+xml"),
    ("application", "application/vnd.etsi.asic-s+zip"),
    ("application", "application/vnd.etsi.asic-e+zip"),
    ("application", "application/vnd.etsi.cug+xml"),
    ("application", "application/vnd.etsi.iptvcommand+xml"),
    ("application", "application/vnd.etsi.iptvdiscovery+xml"),
    ("application", "application/vnd.etsi.iptvprofile+xml"),
    ("application", "application/vnd.etsi.iptvsad-bc+xml"),
    ("application", "application/vnd.etsi.iptvsad-cod+xml"),
    ("application", "application/vnd.etsi.iptvsad-npvr+xml"),
    ("application", "application/vnd.etsi.iptvservice+xml"),
    ("application", "application/vnd.etsi.iptvsync+xml"),
    ("application", "application/vnd.etsi.iptvueprofile+xml"),
    ("application", "application/vnd.etsi.mcid+xml"),
    ("application", "application/vnd.etsi.mheg5"),
    ("application", "application/vnd.etsi.overload-control-policy-dataset+xml"),
    ("application", "application/vnd.etsi.pstn+xml"),
    ("application", "application/vnd.etsi.sci+xml"),
    ("application", "application/vnd.etsi.simservs+xml"),
    ("application", "application/vnd.etsi.timestamp-token"),
    ("application", "application/vnd.etsi.tsl+xml"),
    ("application", "application/vnd.etsi.tsl.der"),
    ("application", "application/vnd.evolv.ecig.theme"),
    ("application", "application/vnd.eudora.data"),
    ("application", "application/vnd.ezpix-album"),
    ("application", "application/vnd.ezpix-package"),
    ("application", "application/vnd.f-secure.mobile"),
    ("application", "application/vnd.fastcopy-disk-image"),
    ("application", "application/vnd.fdf"),
    ("application", "application/vnd.fdsn.mseed"),
    ("application", "application/vnd.fdsn.seed"),
    ("application", "application/vnd.ffsns"),
    ("application", "application/vnd.filmit.zfc"),
    ("application", "application/vnd.fints"),
    ("application", "application/vnd.firemonkeys.cloudcell"),
    ("application", "application/vnd.FloGraphIt"),
    ("application", "application/vnd.fluxtime.clip"),
    ("application", "application/vnd.font-fontforge-sfd"),
    ("application", "application/vnd.framemaker"),
    ("application", "application/vnd.frogans.fnc"),
    ("application", "application/vnd.frogans.ltf"),
    ("application", "application/vnd.fsc.weblaunch"),
    ("application", "application/vnd.fujitsu.oasys"),
    ("application", "application/vnd.fujitsu.oasys2"),
    ("application", "application/vnd.fujitsu.oasys3"),
    ("application", "application/vnd.fujitsu.oasysgp"),
    ("application", "application/vnd.fujitsu.oasysprs"),
    ("application", "application/vnd.fujixerox.ART4"),
    ("application", "application/vnd.fujixerox.ART-EX"),
    ("application", "application/vnd.fujixerox.ddd"),
    ("application", "application/vnd.fujixerox.docuworks"),
    ("application", "application/vnd.fujixerox.docuworks.binder"),
    ("application", "application/vnd.fujixerox.docuworks.container"),
    ("application", "application/vnd.fujixerox.HBPL"),
    ("application", "application/vnd.fut-misnet"),
    ("application", "application/vnd.fuzzysheet"),
    ("application", "application/vnd.genomatix.tuxedo"),
    ("application", "application/vnd.geo+json"),
    ("application", "application/vnd.geocube+xml"),
    ("application", "application/vnd.geogebra.file"),
    ("application", "application/vnd.geogebra.tool"),
    ("application", "application/vnd.geometry-explorer"),
    ("application", "application/vnd.geonext"),
    ("application", "application/vnd.geoplan"),
    ("application", "application/vnd.geospace"),
    ("application", "application/vnd.gerber"),
    ("application", "application/vnd.globalplatform.card-content-mgt"),
    ("application", "application/vnd.globalplatform.card-content-mgt-response"),
    ("application", "application/vnd.gmx"),
    ("application", "application/vnd.google-earth.kml+xml"),
    ("application", "application/vnd.google-earth.kmz"),
    ("application", "application/vnd.gov.sk.e-form+xml"),
    ("application", "application/vnd.gov.sk.e-form+zip"),
    ("application", "application/vnd.gov.sk.xmldatacontainer+xml"),
    ("application", "application/vnd.grafeq"),
    ("application", "application/vnd.gridmp"),
    ("application", "application/vnd.groove-account"),
    ("application", "application/vnd.groove-help"),
    ("application", "application/vnd.groove-identity-message"),
    ("application", "application/vnd.groove-injector"),
    ("application", "application/vnd.groove-tool-message"),
    ("application", "application/vnd.groove-tool-template"),
    ("application", "application/vnd.groove-vcard"),
    ("application", "application/vnd.hal+json"),
    ("application", "application/vnd.hal+xml"),
    ("application", "application/vnd.HandHeld-Entertainment+xml"),
    ("application", "application/vnd.hbci"),
    ("application", "application/vnd.hc+json"),
    ("application", "application/vnd.hcl-bireports"),
    ("application", "application/vnd.hdt"),
    ("application", "application/vnd.heroku+json"),
    ("application", "application/vnd.hhe.lesson-player"),
    ("application", "application/vnd.hp-HPGL"),
    ("application", "application/vnd.hp-hpid"),
    ("application", "application/vnd.hp-hps"),
    ("application", "application/vnd.hp-jlyt"),
    ("application", "application/vnd.hp-PCL"),
    ("application", "application/vnd.hp-PCLXL"),
    ("application", "application/vnd.httphone"),
    ("application", "application/vnd.hydrostatix.sof-data"),
    ("application", "application/vnd.hyper-item+json"),
    ("application", "application/vnd.hyperdrive+json"),
    ("application", "application/vnd.hzn-3d-crossword"),
    ("application", "application/vnd.ibm.afplinedata"),
    ("application", "application/vnd.ibm.electronic-media"),
    ("application", "application/vnd.ibm.MiniPay"),
    ("application", "application/vnd.ibm.modcap"),
    ("application", "application/vnd.ibm.rights-management"),
    ("application", "application/vnd.ibm.secure-container"),
    ("application", "application/vnd.iccprofile"),
    ("application", "application/vnd.ieee.1905"),
    ("application", "application/vnd.igloader"),
    ("application", "application/vnd.imagemeter.folder+zip"),
    ("application", "application/vnd.imagemeter.image+zip"),
    ("application", "application/vnd.immervision-ivp"),
    ("application", "application/vnd.immervision-ivu"),
    ("application", "application/vnd.ims.imsccv1p1"),
    ("application", "application/vnd.ims.imsccv1p2"),
    ("application", "application/vnd.ims.imsccv1p3"),
    ("application", "application/vnd.ims.lis.v2.result+json"),
    ("application", "application/vnd.ims.lti.v2.toolconsumerprofile+json"),
    ("application", "application/vnd.ims.lti.v2.toolproxy.id+json"),
    ("application", "application/vnd.ims.lti.v2.toolproxy+json"),
    ("application", "application/vnd.ims.lti.v2.toolsettings+json"),
    ("application", "application/vnd.ims.lti.v2.toolsettings.simple+json"),
    ("application", "application/vnd.informedcontrol.rms+xml"),
    ("application", "application/vnd.infotech.project"),
    ("application", "application/vnd.infotech.project+xml"),
    ("application", "application/vnd.informix-visionary"),
    ("application", "application/vnd.innopath.wamp.notification"),
    ("application", "application/vnd.insors.igm"),
    ("application", "application/vnd.intercon.formnet"),
    ("application", "application/vnd.intergeo"),
    ("application", "application/vnd.intertrust.digibox"),
    ("application", "application/vnd.intertrust.nncp"),
    ("application", "application/vnd.intu.qbo"),
    ("application", "application/vnd.intu.qfx"),
    ("application", "application/vnd.iptc.g2.catalogitem+xml"),
    ("application", "application/vnd.iptc.g2.conceptitem+xml"),
    ("application", "application/vnd.iptc.g2.knowledgeitem+xml"),
    ("application", "application/vnd.iptc.g2.newsitem+xml"),
    ("application", "application/vnd.iptc.g2.newsmessage+xml"),
    ("application", "application/vnd.iptc.g2.packageitem+xml"),
    ("application", "application/vnd.iptc.g2.planningitem+xml"),
    ("application", "application/vnd.ipunplugged.rcprofile"),
    ("application", "application/vnd.irepository.package+xml"),
    ("application", "application/vnd.is-xpr"),
    ("application", "application/vnd.isac.fcs"),
    ("application", "application/vnd.jam"),
    ("application", "application/vnd.japannet-directory-service"),
    ("application", "application/vnd.japannet-jpnstore-wakeup"),
    ("application", "application/vnd.japannet-payment-wakeup"),
    ("application", "application/vnd.japannet-registration"),
    ("application", "application/vnd.japannet-registration-wakeup"),
    ("application", "application/vnd.japannet-setstore-wakeup"),
    ("application", "application/vnd.japannet-verification"),
    ("application", "application/vnd.japannet-verification-wakeup"),
    ("application", "application/vnd.jcp.javame.midlet-rms"),
    ("application", "application/vnd.jisp"),
    ("application", "application/vnd.joost.joda-archive"),
    ("application", "application/vnd.jsk.isdn-ngn"),
    ("application", "application/vnd.kahootz"),
    ("application", "application/vnd.kde.karbon"),
    ("application", "application/vnd.kde.kchart"),
    ("application", "application/vnd.kde.kformula"),
    ("application", "application/vnd.kde.kivio"),
    ("application", "application/vnd.kde.kontour"),
    ("application", "application/vnd.kde.kpresenter"),
    ("application", "application/vnd.kde.kspread"),
    ("application", "application/vnd.kde.kword"),
    ("application", "application/vnd.kenameaapp"),
    ("application", "application/vnd.kidspiration"),
    ("application", "application/vnd.Kinar"),
    ("application", "application/vnd.koan"),
    ("application", "application/vnd.kodak-descriptor"),
    ("application", "application/vnd.las.las+json"),
    ("application", "application/vnd.las.las+xml"),
    ("application", "application/vnd.liberty-request+xml"),
    ("application", "application/vnd.llamagraphics.life-balance.desktop"),
    ("application", "application/vnd.llamagraphics.life-balance.exchange+xml"),
    ("application", "application/vnd.lotus-1-2-3"),
    ("application", "application/vnd.lotus-approach"),
    ("application", "application/vnd.lotus-freelance"),
    ("application", "application/vnd.lotus-notes"),
    ("application", "application/vnd.lotus-organizer"),
    ("application", "application/vnd.lotus-screencam"),
    ("application", "application/vnd.lotus-wordpro"),
    ("application", "application/vnd.macports.portpkg"),
    ("application", "application/vnd.macports.portpkg"),
    ("application", "application/vnd.mapbox-vector-tile"),
    ("application", "application/vnd.marlin.drm.actiontoken+xml"),
    ("application", "application/vnd.marlin.drm.conftoken+xml"),
    ("application", "application/vnd.marlin.drm.license+xml"),
    ("application", "application/vnd.marlin.drm.mdcf"),
    ("application", "application/vnd.mason+json"),
    ("application", "application/vnd.maxmind.maxmind-db"),
    ("application", "application/vnd.mcd"),
    ("application", "application/vnd.medcalcdata"),
    ("application", "application/vnd.mediastation.cdkey"),
    ("application", "application/vnd.meridian-slingshot"),
    ("application", "application/vnd.MFER"),
    ("application", "application/vnd.mfmp"),
    ("application", "application/vnd.micro+json"),
    ("application", "application/vnd.micrografx.flo"),
    ("application", "application/vnd.micrografx.igx"),
    ("application", "application/vnd.microsoft.portable-executable"),
    ("application", "application/vnd.microsoft.windows.thumbnail-cache"),
    ("application", "application/vnd.miele+json"),
    ("application", "application/vnd.mif"),
    ("application", "application/vnd.minisoft-hp3000-save"),
    ("application", "application/vnd.mitsubishi.misty-guard.trustweb"),
    ("application", "application/vnd.Mobius.DAF"),
    ("application", "application/vnd.Mobius.DIS"),
    ("application", "application/vnd.Mobius.MBK"),
    ("application", "application/vnd.Mobius.MQY"),
    ("application", "application/vnd.Mobius.MSL"),
    ("application", "application/vnd.Mobius.PLC"),
    ("application", "application/vnd.Mobius.TXF"),
    ("application", "application/vnd.mophun.application"),
    ("application", "application/vnd.mophun.certificate"),
    ("application", "application/vnd.motorola.flexsuite"),
    ("application", "application/vnd.motorola.flexsuite.adsi"),
    ("application", "application/vnd.motorola.flexsuite.fis"),
    ("application", "application/vnd.motorola.flexsuite.gotap"),
    ("application", "application/vnd.motorola.flexsuite.kmr"),
    ("application", "application/vnd.motorola.flexsuite.ttc"),
    ("application", "application/vnd.motorola.flexsuite.wem"),
    ("application", "application/vnd.motorola.iprm"),
    ("application", "application/vnd.mozilla.xul+xml"),
    ("application", "application/vnd.ms-artgalry"),
    ("application", "application/vnd.ms-asf"),
    ("application", "application/vnd.ms-cab-compressed"),
    ("application", "application/vnd.ms-3mfdocument"),
    ("application", "application/vnd.ms-excel"),
    ("application", "application/vnd.ms-excel.addin.macroEnabled.12"),
    ("application", "application/vnd.ms-excel.sheet.binary.macroEnabled.12"),
    ("application", "application/vnd.ms-excel.sheet.macroEnabled.12"),
    ("application", "application/vnd.ms-excel.template.macroEnabled.12"),
    ("application", "application/vnd.ms-fontobject"),
    ("application", "application/vnd.ms-htmlhelp"),
    ("application", "application/vnd.ms-ims"),
    ("application", "application/vnd.ms-lrm"),
    ("application", "application/vnd.ms-office.activeX+xml"),
    ("application", "application/vnd.ms-officetheme"),
    ("application", "application/vnd.ms-playready.initiator+xml"),
    ("application", "application/vnd.ms-powerpoint"),
    ("application", "application/vnd.ms-powerpoint.addin.macroEnabled.12"),
    ("application", "application/vnd.ms-powerpoint.presentation.macroEnabled.12"),
    ("application", "application/vnd.ms-powerpoint.slide.macroEnabled.12"),
    ("application", "application/vnd.ms-powerpoint.slideshow.macroEnabled.12"),
    ("application", "application/vnd.ms-powerpoint.template.macroEnabled.12"),
    ("application", "application/vnd.ms-PrintDeviceCapabilities+xml"),
    ("application", "application/vnd.ms-PrintSchemaTicket+xml"),
    ("application", "application/vnd.ms-project"),
    ("application", "application/vnd.ms-tnef"),
    ("application", "application/vnd.ms-windows.devicepairing"),
    ("application", "application/vnd.ms-windows.nwprinting.oob"),
    ("application", "application/vnd.ms-windows.printerpairing"),
    ("application", "application/vnd.ms-windows.wsd.oob"),
    ("application", "application/vnd.ms-wmdrm.lic-chlg-req"),
    ("application", "application/vnd.ms-wmdrm.lic-resp"),
    ("application", "application/vnd.ms-wmdrm.meter-chlg-req"),
    ("application", "application/vnd.ms-wmdrm.meter-resp"),
    ("application", "application/vnd.ms-word.document.macroEnabled.12"),
    ("application", "application/vnd.ms-word.template.macroEnabled.12"),
    ("application", "application/vnd.ms-works"),
    ("application", "application/vnd.ms-wpl"),
    ("application", "application/vnd.ms-xpsdocument"),
    ("application", "application/vnd.msa-disk-image"),
    ("application", "application/vnd.mseq"),
    ("application", "application/vnd.msign"),
    ("application", "application/vnd.multiad.creator"),
    ("application", "application/vnd.multiad.creator.cif"),
    ("application", "application/vnd.musician"),
    ("application", "application/vnd.music-niff"),
    ("application", "application/vnd.muvee.style"),
    ("application", "application/vnd.mynfc"),
    ("application", "application/vnd.ncd.control"),
    ("application", "application/vnd.ncd.reference"),
    ("application", "application/vnd.nearst.inv+json"),
    ("application", "application/vnd.nervana"),
    ("application", "application/vnd.netfpx"),
    ("application", "application/vnd.neurolanguage.nlu"),
    ("application", "application/vnd.nintendo.snes.rom"),
    ("application", "application/vnd.nintendo.nitro.rom"),
    ("application", "application/vnd.nitf"),
    ("application", "application/vnd.noblenet-directory"),
    ("application", "application/vnd.noblenet-sealer"),
    ("application", "application/vnd.noblenet-web"),
    ("application", "application/vnd.nokia.catalogs"),
    ("application", "application/vnd.nokia.conml+wbxml"),
    ("application", "application/vnd.nokia.conml+xml"),
    ("application", "application/vnd.nokia.iptv.config+xml"),
    ("application", "application/vnd.nokia.iSDS-radio-presets"),
    ("application", "application/vnd.nokia.landmark+wbxml"),
    ("application", "application/vnd.nokia.landmark+xml"),
    ("application", "application/vnd.nokia.landmarkcollection+xml"),
    ("application", "application/vnd.nokia.ncd"),
    ("application", "application/vnd.nokia.n-gage.ac+xml"),
    ("application", "application/vnd.nokia.n-gage.data"),
    ("application", "application/vnd.nokia.n-gage.symbian.install"),
    ("application", "application/vnd.nokia.pcd+wbxml"),
    ("application", "application/vnd.nokia.pcd+xml"),
    ("application", "application/vnd.nokia.radio-preset"),
    ("application", "application/vnd.nokia.radio-presets"),
    ("application", "application/vnd.novadigm.EDM"),
    ("application", "application/vnd.novadigm.EDX"),
    ("application", "application/vnd.novadigm.EXT"),
    ("application", "application/vnd.ntt-local.content-share"),
    ("application", "application/vnd.ntt-local.file-transfer"),
    ("application", "application/vnd.ntt-local.ogw_remote-access"),
    ("application", "application/vnd.ntt-local.sip-ta_remote"),
    ("application", "application/vnd.ntt-local.sip-ta_tcp_stream"),
    ("application", "application/vnd.oasis.opendocument.chart"),
    ("application", "application/vnd.oasis.opendocument.chart-template"),
    ("application", "application/vnd.oasis.opendocument.database"),
    ("application", "application/vnd.oasis.opendocument.formula"),
    ("application", "application/vnd.oasis.opendocument.formula-template"),
    ("application", "application/vnd.oasis.opendocument.graphics"),
    ("application", "application/vnd.oasis.opendocument.graphics-template"),
    ("application", "application/vnd.oasis.opendocument.image"),
    ("application", "application/vnd.oasis.opendocument.image-template"),
    ("application", "application/vnd.oasis.opendocument.presentation"),
    ("application", "application/vnd.oasis.opendocument.presentation-template"),
    ("application", "application/vnd.oasis.opendocument.spreadsheet"),
    ("application", "application/vnd.oasis.opendocument.spreadsheet-template"),
    ("application", "application/vnd.oasis.opendocument.text"),
    ("application", "application/vnd.oasis.opendocument.text-master"),
    ("application", "application/vnd.oasis.opendocument.text-template"),
    ("application", "application/vnd.oasis.opendocument.text-web"),
    ("application", "application/vnd.obn"),
    ("application", "application/vnd.ocf+cbor"),
    ("application", "application/vnd.oftn.l10n+json"),
    ("application", "application/vnd.oipf.contentaccessdownload+xml"),
    ("application", "application/vnd.oipf.contentaccessstreaming+xml"),
    ("application", "application/vnd.oipf.cspg-hexbinary"),
    ("application", "application/vnd.oipf.dae.svg+xml"),
    ("application", "application/vnd.oipf.dae.xhtml+xml"),
    ("application", "application/vnd.oipf.mippvcontrolmessage+xml"),
    ("application", "application/vnd.oipf.pae.gem"),
    ("application", "application/vnd.oipf.spdiscovery+xml"),
    ("application", "application/vnd.oipf.spdlist+xml"),
    ("application", "application/vnd.oipf.ueprofile+xml"),
    ("application", "application/vnd.oipf.userprofile+xml"),
    ("application", "application/vnd.olpc-sugar"),
    ("application", "application/vnd.oma.bcast.associated-procedure-parameter+xml"),
    ("application", "application/vnd.oma.bcast.drm-trigger+xml"),
    ("application", "application/vnd.oma.bcast.imd+xml"),
    ("application", "application/vnd.oma.bcast.ltkm"),
    ("application", "application/vnd.oma.bcast.notification+xml"),
    ("application", "application/vnd.oma.bcast.provisioningtrigger"),
    ("application", "application/vnd.oma.bcast.sgboot"),
    ("application", "application/vnd.oma.bcast.sgdd+xml"),
    ("application", "application/vnd.oma.bcast.sgdu"),
    ("application", "application/vnd.oma.bcast.simple-symbol-container"),
    ("application", "application/vnd.oma.bcast.smartcard-trigger+xml"),
    ("application", "application/vnd.oma.bcast.sprov+xml"),
    ("application", "application/vnd.oma.bcast.stkm"),
    ("application", "application/vnd.oma.cab-address-book+xml"),
    ("application", "application/vnd.oma.cab-feature-handler+xml"),
    ("application", "application/vnd.oma.cab-pcc+xml"),
    ("application", "application/vnd.oma.cab-subs-invite+xml"),
    ("application", "application/vnd.oma.cab-user-prefs+xml"),
    ("application", "application/vnd.oma.dcd"),
    ("application", "application/vnd.oma.dcdc"),
    ("application", "application/vnd.oma.dd2+xml"),
    ("application", "application/vnd.oma.drm.risd+xml"),
    ("application", "application/vnd.oma.group-usage-list+xml"),
    ("application", "application/vnd.oma.lwm2m+json"),
    ("application", "application/vnd.oma.lwm2m+tlv"),
    ("application", "application/vnd.oma.pal+xml"),
    ("application", "application/vnd.oma.poc.detailed-progress-report+xml"),
    ("application", "application/vnd.oma.poc.final-report+xml"),
    ("application", "application/vnd.oma.poc.groups+xml"),
    ("application", "application/vnd.oma.poc.invocation-descriptor+xml"),
    ("application", "application/vnd.oma.poc.optimized-progress-report+xml"),
    ("application", "application/vnd.oma.push"),
    ("application", "application/vnd.oma.scidm.messages+xml"),
    ("application", "application/vnd.oma.xcap-directory+xml"),
    ("application", "application/vnd.omads-email+xml"),
    ("application", "application/vnd.omads-file+xml"),
    ("application", "application/vnd.omads-folder+xml"),
    ("application", "application/vnd.omaloc-supl-init"),
    ("application", "application/vnd.oma-scws-config"),
    ("application", "application/vnd.oma-scws-http-request"),
    ("application", "application/vnd.oma-scws-http-response"),
    ("application", "application/vnd.onepager"),
    ("application", "application/vnd.onepagertamp"),
    ("application", "application/vnd.onepagertamx"),
    ("application", "application/vnd.onepagertat"),
    ("application", "application/vnd.onepagertatp"),
    ("application", "application/vnd.onepagertatx"),
    ("application", "application/vnd.openblox.game-binary"),
    ("application", "application/vnd.openblox.game+xml"),
    ("application", "application/vnd.openeye.oeb"),
    ("application", "application/vnd.openstreetmap.data+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.custom-properties+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.customXmlProperties+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawing+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.chart+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.extended-properties+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.comments+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.presentation"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.presProps+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slide"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slide+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slideshow"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.tags+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.template"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.template.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.template"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.theme+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.themeOverride+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.vmlDrawing"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.document"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.template"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml"),
    ("application", "application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml"),
    ("application", "application/vnd.openxmlformats-package.core-properties+xml"),
    ("application", "application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml"),
    ("application", "application/vnd.openxmlformats-package.relationships+xml"),
    ("application", "application/vnd.oracle.resource+json"),
    ("application", "application/vnd.orange.indata"),
    ("application", "application/vnd.osa.netdeploy"),
    ("application", "application/vnd.osgeo.mapguide.package"),
    ("application", "application/vnd.osgi.bundle"),
    ("application", "application/vnd.osgi.dp"),
    ("application", "application/vnd.osgi.subsystem"),
    ("application", "application/vnd.otps.ct-kip+xml"),
    ("application", "application/vnd.oxli.countgraph"),
    ("application", "application/vnd.pagerduty+json"),
    ("application", "application/vnd.palm"),
    ("application", "application/vnd.panoply"),
    ("application", "application/vnd.paos.xml"),
    ("application", "application/vnd.pawaafile"),
    ("application", "application/vnd.pcos"),
    ("application", "application/vnd.pg.format"),
    ("application", "application/vnd.pg.osasli"),
    ("application", "application/vnd.piaccess.application-licence"),
    ("application", "application/vnd.picsel"),
    ("application", "application/vnd.pmi.widget"),
    ("application", "application/vnd.poc.group-advertisement+xml"),
    ("application", "application/vnd.pocketlearn"),
    ("application", "application/vnd.powerbuilder6"),
    ("application", "application/vnd.powerbuilder6-s"),
    ("application", "application/vnd.powerbuilder7"),
    ("application", "application/vnd.powerbuilder75"),
    ("application", "application/vnd.powerbuilder75-s"),
    ("application", "application/vnd.powerbuilder7-s"),
    ("application", "application/vnd.preminet"),
    ("application", "application/vnd.previewsystems.box"),
    ("application", "application/vnd.proteus.magazine"),
    ("application", "application/vnd.publishare-delta-tree"),
    ("application", "application/vnd.pvi.ptid1"),
    ("application", "application/vnd.pwg-multiplexed"),
    ("application", "application/vnd.pwg-xhtml-print+xml"),
    ("application", "application/vnd.qualcomm.brew-app-res"),
    ("application", "application/vnd.quarantainenet"),
    ("application", "application/vnd.Quark.QuarkXPress"),
    ("application", "application/vnd.quobject-quoxdocument"),
    ("application", "application/vnd.radisys.moml+xml"),
    ("application", "application/vnd.radisys.msml-audit-conf+xml"),
    ("application", "application/vnd.radisys.msml-audit-conn+xml"),
    ("application", "application/vnd.radisys.msml-audit-dialog+xml"),
    ("application", "application/vnd.radisys.msml-audit-stream+xml"),
    ("application", "application/vnd.radisys.msml-audit+xml"),
    ("application", "application/vnd.radisys.msml-conf+xml"),
    ("application", "application/vnd.radisys.msml-dialog-base+xml"),
    ("application", "application/vnd.radisys.msml-dialog-fax-detect+xml"),
    ("application", "application/vnd.radisys.msml-dialog-fax-sendrecv+xml"),
    ("application", "application/vnd.radisys.msml-dialog-group+xml"),
    ("application", "application/vnd.radisys.msml-dialog-speech+xml"),
    ("application", "application/vnd.radisys.msml-dialog-transform+xml"),
    ("application", "application/vnd.radisys.msml-dialog+xml"),
    ("application", "application/vnd.radisys.msml+xml"),
    ("application", "application/vnd.rainstor.data"),
    ("application", "application/vnd.rapid"),
    ("application", "application/vnd.rar"),
    ("application", "application/vnd.realvnc.bed"),
    ("application", "application/vnd.recordare.musicxml"),
    ("application", "application/vnd.recordare.musicxml+xml"),
    ("application", "application/vnd.RenLearn.rlprint"),
    ("application", "application/vnd.rig.cryptonote"),
    ("application", "application/vnd.route66.link66+xml"),
    ("application", "application/vnd.rs-274x"),
    ("application", "application/vnd.ruckus.download"),
    ("application", "application/vnd.s3sms"),
    ("application", "application/vnd.sailingtracker.track"),
    ("application", "application/vnd.sbm.cid"),
    ("application", "application/vnd.sbm.mid2"),
    ("application", "application/vnd.scribus"),
    ("application", "application/vnd.sealed.3df"),
    ("application", "application/vnd.sealed.csf"),
    ("application", "application/vnd.sealed.doc"),
    ("application", "application/vnd.sealed.eml"),
    ("application", "application/vnd.sealed.mht"),
    ("application", "application/vnd.sealed.net"),
    ("application", "application/vnd.sealed.ppt"),
    ("application", "application/vnd.sealed.tiff"),
    ("application", "application/vnd.sealed.xls"),
    ("application", "application/vnd.sealedmedia.softseal.html"),
    ("application", "application/vnd.sealedmedia.softseal.pdf"),
    ("application", "application/vnd.seemail"),
    ("application", "application/vnd.sema"),
    ("application", "application/vnd.semd"),
    ("application", "application/vnd.semf"),
    ("application", "application/vnd.shana.informed.formdata"),
    ("application", "application/vnd.shana.informed.formtemplate"),
    ("application", "application/vnd.shana.informed.interchange"),
    ("application", "application/vnd.shana.informed.package"),
    ("application", "application/vnd.sigrok.session"),
    ("application", "application/vnd.SimTech-MindMapper"),
    ("application", "application/vnd.siren+json"),
    ("application", "application/vnd.smaf"),
    ("application", "application/vnd.smart.notebook"),
    ("application", "application/vnd.smart.teacher"),
    ("application", "application/vnd.software602.filler.form+xml"),
    ("application", "application/vnd.software602.filler.form-xml-zip"),
    ("application", "application/vnd.solent.sdkm+xml"),
    ("application", "application/vnd.spotfire.dxp"),
    ("application", "application/vnd.spotfire.sfs"),
    ("application", "application/vnd.sss-cod"),
    ("application", "application/vnd.sss-dtf"),
    ("application", "application/vnd.sss-ntf"),
    ("application", "application/vnd.stepmania.package"),
    ("application", "application/vnd.stepmania.stepchart"),
    ("application", "application/vnd.street-stream"),
    ("application", "application/vnd.sun.wadl+xml"),
    ("application", "application/vnd.sus-calendar"),
    ("application", "application/vnd.svd"),
    ("application", "application/vnd.swiftview-ics"),
    ("application", "application/vnd.syncml.dm.notification"),
    ("application", "application/vnd.syncml.dmddf+xml"),
    ("application", "application/vnd.syncml.dmtnds+wbxml"),
    ("application", "application/vnd.syncml.dmtnds+xml"),
    ("application", "application/vnd.syncml.dmddf+wbxml"),
    ("application", "application/vnd.syncml.dm+wbxml"),
    ("application", "application/vnd.syncml.dm+xml"),
    ("application", "application/vnd.syncml.ds.notification"),
    ("application", "application/vnd.syncml+xml"),
    ("application", "application/vnd.tableschema+json"),
    ("application", "application/vnd.tao.intent-module-archive"),
    ("application", "application/vnd.tcpdump.pcap"),
    ("application", "application/vnd.tml"),
    ("application", "application/vnd.tmd.mediaflex.api+xml"),
    ("application", "application/vnd.tmobile-livetv"),
    ("application", "application/vnd.tri.onesource"),
    ("application", "application/vnd.trid.tpt"),
    ("application", "application/vnd.triscape.mxs"),
    ("application", "application/vnd.trueapp"),
    ("application", "application/vnd.truedoc"),
    ("application", "application/vnd.ubisoft.webplayer"),
    ("application", "application/vnd.ufdl"),
    ("application", "application/vnd.uiq.theme"),
    ("application", "application/vnd.umajin"),
    ("application", "application/vnd.unity"),
    ("application", "application/vnd.uoml+xml"),
    ("application", "application/vnd.uplanet.alert"),
    ("application", "application/vnd.uplanet.alert-wbxml"),
    ("application", "application/vnd.uplanet.bearer-choice"),
    ("application", "application/vnd.uplanet.bearer-choice-wbxml"),
    ("application", "application/vnd.uplanet.cacheop"),
    ("application", "application/vnd.uplanet.cacheop-wbxml"),
    ("application", "application/vnd.uplanet.channel"),
    ("application", "application/vnd.uplanet.channel-wbxml"),
    ("application", "application/vnd.uplanet.list"),
    ("application", "application/vnd.uplanet.listcmd"),
    ("application", "application/vnd.uplanet.listcmd-wbxml"),
    ("application", "application/vnd.uplanet.list-wbxml"),
    ("application", "application/vnd.uri-map"),
    ("application", "application/vnd.uplanet.signal"),
    ("application", "application/vnd.valve.source.material"),
    ("application", "application/vnd.vcx"),
    ("application", "application/vnd.vd-study"),
    ("application", "application/vnd.vectorworks"),
    ("application", "application/vnd.vel+json"),
    ("application", "application/vnd.verimatrix.vcas"),
    ("application", "application/vnd.vidsoft.vidconference"),
    ("application", "application/vnd.visio"),
    ("application", "application/vnd.visionary"),
    ("application", "application/vnd.vividence.scriptfile"),
    ("application", "application/vnd.vsf"),
    ("application", "application/vnd.wap.sic"),
    ("application", "application/vnd.wap.slc"),
    ("application", "application/vnd.wap.wbxml"),
    ("application", "application/vnd.wap.wmlc"),
    ("application", "application/vnd.wap.wmlscriptc"),
    ("application", "application/vnd.webturbo"),
    ("application", "application/vnd.wfa.p2p"),
    ("application", "application/vnd.wfa.wsc"),
    ("application", "application/vnd.windows.devicepairing"),
    ("application", "application/vnd.wmc"),
    ("application", "application/vnd.wmf.bootstrap"),
    ("application", "application/vnd.wolfram.mathematica"),
    ("application", "application/vnd.wolfram.mathematica.package"),
    ("application", "application/vnd.wolfram.player"),
    ("application", "application/vnd.wordperfect"),
    ("application", "application/vnd.wqd"),
    ("application", "application/vnd.wrq-hp3000-labelled"),
    ("application", "application/vnd.wt.stf"),
    ("application", "application/vnd.wv.csp+xml"),
    ("application", "application/vnd.wv.csp+wbxml"),
    ("application", "application/vnd.wv.ssp+xml"),
    ("application", "application/vnd.xacml+json"),
    ("application", "application/vnd.xara"),
    ("application", "application/vnd.xfdl"),
    ("application", "application/vnd.xfdl.webform"),
    ("application", "application/vnd.xmi+xml"),
    ("application", "application/vnd.xmpie.cpkg"),
    ("application", "application/vnd.xmpie.dpkg"),
    ("application", "application/vnd.xmpie.plan"),
    ("application", "application/vnd.xmpie.ppkg"),
    ("application", "application/vnd.xmpie.xlim"),
    ("application", "application/vnd.yamaha.hv-dic"),
    ("application", "application/vnd.yamaha.hv-script"),
    ("application", "application/vnd.yamaha.hv-voice"),
    ("application", "application/vnd.yamaha.openscoreformat.osfpvg+xml"),
    ("application", "application/vnd.yamaha.openscoreformat"),
    ("application", "application/vnd.yamaha.remote-setup"),
    ("application", "application/vnd.yamaha.smaf-audio"),
    ("application", "application/vnd.yamaha.smaf-phrase"),
    ("application", "application/vnd.yamaha.through-ngn"),
    ("application", "application/vnd.yamaha.tunnel-udpencap"),
    ("application", "application/vnd.yaoweme"),
    ("application", "application/vnd.yellowriver-custom-menu"),
    ("application", "application/vnd.zul"),
    ("application", "application/vnd.zzazz.deck+xml"),
    ("application", "application/voicexml+xml"),
    ("application", "application/vq-rtcpxr"),
    ("application", "application/watcherinfo+xml"),
    ("application", "application/whoispp-query"),
    ("application", "application/whoispp-response"),
    ("application", "application/widget"),
    ("application", "application/wita"),
    ("application", "application/wordperfect5.1"),
    ("application", "application/wsdl+xml"),
    ("application", "application/wspolicy+xml"),
    ("application", "application/x-www-form-urlencoded"),
    ("application", "application/x400-bp"),
    ("application", "application/xacml+xml"),
    ("application", "application/xcap-att+xml"),
    ("application", "application/xcap-caps+xml"),
    ("application", "application/xcap-diff+xml"),
    ("application", "application/xcap-el+xml"),
    ("application", "application/xcap-error+xml"),
    ("application", "application/xcap-ns+xml"),
    ("application", "application/xcon-conference-info-diff+xml"),
    ("application", "application/xcon-conference-info+xml"),
    ("application", "application/xenc+xml"),
    ("application", "application/xhtml-voice+xml"),
    ("application", "application/xhtml+xml"),
    ("application", "application/xml"),
    ("application", "application/xml-dtd"),
    ("application", "application/xml-external-parsed-entity"),
    ("application", "application/xml-patch+xml"),
    ("application", "application/xmpp+xml"),
    ("application", "application/xop+xml"),
    ("application", "application/xslt+xml"),
    ("application", "application/xv+xml"),
    ("application", "application/yang"),
    ("application", "application/yang-data+json"),
    ("application", "application/yang-data+xml"),
    ("application", "application/yang-patch+json"),
    ("application", "application/yang-patch+xml"),
    ("application", "application/yin+xml"),
    ("application", "application/zip"),
    ("application", "application/zlib"),
    ("audio", "audio/1d-interleaved-parityfec"),
    ("audio", "audio/32kadpcm"),
    ("audio", "audio/3gpp"),
    ("audio", "audio/3gpp2"),
    ("audio", "audio/ac3"),
    ("audio", "audio/AMR"),
    ("audio", "audio/AMR-WB"),
    ("audio", "audio/amr-wb+"),
    ("audio", "audio/aptx"),
    ("audio", "audio/asc"),
    ("audio", "audio/ATRAC-ADVANCED-LOSSLESS"),
    ("audio", "audio/ATRAC-X"),
    ("audio", "audio/ATRAC3"),
    ("audio", "audio/basic"),
    ("audio", "audio/BV16"),
    ("audio", "audio/BV32"),
    ("audio", "audio/clearmode"),
    ("audio", "audio/CN"),
    ("audio", "audio/DAT12"),
    ("audio", "audio/dls"),
    ("audio", "audio/dsr-es201108"),
    ("audio", "audio/dsr-es202050"),
    ("audio", "audio/dsr-es202211"),
    ("audio", "audio/dsr-es202212"),
    ("audio", "audio/DV"),
    ("audio", "audio/DVI4"),
    ("audio", "audio/eac3"),
    ("audio", "audio/encaprtp"),
    ("audio", "audio/EVRC"),
    ("audio", "audio/EVRC-QCP"),
    ("audio", "audio/EVRC0"),
    ("audio", "audio/EVRC1"),
    ("audio", "audio/EVRCB"),
    ("audio", "audio/EVRCB0"),
    ("audio", "audio/EVRCB1"),
    ("audio", "audio/EVRCNW"),
    ("audio", "audio/EVRCNW0"),
    ("audio", "audio/EVRCNW1"),
    ("audio", "audio/EVRCWB"),
    ("audio", "audio/EVRCWB0"),
    ("audio", "audio/EVRCWB1"),
    ("audio", "audio/EVS"),
    ("audio", "audio/example"),
    ("audio", "audio/fwdred"),
    ("audio", "audio/G711-0"),
    ("audio", "audio/G719"),
    ("audio", "audio/G7221"),
    ("audio", "audio/G722"),
    ("audio", "audio/G723"),
    ("audio", "audio/G726-16"),
    ("audio", "audio/G726-24"),
    ("audio", "audio/G726-32"),
    ("audio", "audio/G726-40"),
    ("audio", "audio/G728"),
    ("audio", "audio/G729"),
    ("audio", "audio/G7291"),
    ("audio", "audio/G729D"),
    ("audio", "audio/G729E"),
    ("audio", "audio/GSM"),
    ("audio", "audio/GSM-EFR"),
    ("audio", "audio/GSM-HR-08"),
    ("audio", "audio/iLBC"),
    ("audio", "audio/ip-mr_v2.5"),
    ("audio", "audio/L8"),
    ("audio", "audio/L16"),
    ("audio", "audio/L20"),
    ("audio", "audio/L24"),
    ("audio", "audio/LPC"),
    ("audio", "audio/MELP"),
    ("audio", "audio/MELP600"),
    ("audio", "audio/MELP1200"),
    ("audio", "audio/MELP2400"),
    ("audio", "audio/mobile-xmf"),
    ("audio", "audio/MPA"),
    ("audio", "audio/mp4"),
    ("audio", "audio/MP4A-LATM"),
    ("audio", "audio/mpa-robust"),
    ("audio", "audio/mpeg"),
    ("audio", "audio/mpeg4-generic"),
    ("audio", "audio/ogg"),
    ("audio", "audio/opus"),
    ("audio", "audio/parityfec"),
    ("audio", "audio/PCMA"),
    ("audio", "audio/PCMA-WB"),
    ("audio", "audio/PCMU"),
    ("audio", "audio/PCMU-WB"),
    ("audio", "audio/prs.sid"),
    ("audio", "audio/QCELP"),
    ("audio", "audio/raptorfec"),
    ("audio", "audio/RED"),
    ("audio", "audio/rtp-enc-aescm128"),
    ("audio", "audio/rtploopback"),
    ("audio", "audio/rtp-midi"),
    ("audio", "audio/rtx"),
    ("audio", "audio/SMV"),
    ("audio", "audio/SMV0"),
    ("audio", "audio/SMV-QCP"),
    ("audio", "audio/sp-midi"),
    ("audio", "audio/speex"),
    ("audio", "audio/t140c"),
    ("audio", "audio/t38"),
    ("audio", "audio/telephone-event"),
    ("audio", "audio/tone"),
    ("audio", "audio/UEMCLIP"),
    ("audio", "audio/ulpfec"),
    ("audio", "audio/VDVI"),
    ("audio", "audio/VMR-WB"),
    ("audio", "audio/vnd.3gpp.iufp"),
    ("audio", "audio/vnd.4SB"),
    ("audio", "audio/vnd.audiokoz"),
    ("audio", "audio/vnd.CELP"),
    ("audio", "audio/vnd.cisco.nse"),
    ("audio", "audio/vnd.cmles.radio-events"),
    ("audio", "audio/vnd.cns.anp1"),
    ("audio", "audio/vnd.cns.inf1"),
    ("audio", "audio/vnd.dece.audio"),
    ("audio", "audio/vnd.digital-winds"),
    ("audio", "audio/vnd.dlna.adts"),
    ("audio", "audio/vnd.dolby.heaac.1"),
    ("audio", "audio/vnd.dolby.heaac.2"),
    ("audio", "audio/vnd.dolby.mlp"),
    ("audio", "audio/vnd.dolby.mps"),
    ("audio", "audio/vnd.dolby.pl2"),
    ("audio", "audio/vnd.dolby.pl2x"),
    ("audio", "audio/vnd.dolby.pl2z"),
    ("audio", "audio/vnd.dolby.pulse.1"),
    ("audio", "audio/vnd.dra"),
    ("audio", "audio/vnd.dts"),
    ("audio", "audio/vnd.dts.hd"),
    ("audio", "audio/vnd.dvb.file"),
    ("audio", "audio/vnd.everad.plj"),
    ("audio", "audio/vnd.hns.audio"),
    ("audio", "audio/vnd.lucent.voice"),
    ("audio", "audio/vnd.ms-playready.media.pya"),
    ("audio", "audio/vnd.nokia.mobile-xmf"),
    ("audio", "audio/vnd.nortel.vbk"),
    ("audio", "audio/vnd.nuera.ecelp4800"),
    ("audio", "audio/vnd.nuera.ecelp7470"),
    ("audio", "audio/vnd.nuera.ecelp9600"),
    ("audio", "audio/vnd.octel.sbc"),
    ("audio", "audio/vnd.qcelp"),
    ("audio", "audio/vnd.rhetorex.32kadpcm"),
    ("audio", "audio/vnd.rip"),
    ("audio", "audio/vnd.sealedmedia.softseal.mpeg"),
    ("audio", "audio/vnd.vmx.cvsd"),
    ("audio", "audio/vorbis"),
    ("audio", "audio/vorbis-config"),
    ("font", "font/collection"),
    ("font", "font/otf"),
    ("font", "font/sfnt"),
    ("font", "font/ttf"),
    ("font", "font/woff"),
    ("font", "font/woff2"),
    ("image", "image/bmp"),
    ("image", "image/cgm"),
    ("image", "image/dicom-rle"),
    ("image", "image/emf"),
    ("image", "image/example"),
    ("image", "image/fits"),
    ("image", "image/g3fax"),
    ("image", "image/gif"),
    ("image", "image/ief"),
    ("image", "image/jls"),
    ("image", "image/jp2"),
    ("image", "image/jpeg"),
    ("image", "image/jpm"),
    ("image", "image/jpx"),
    ("image", "image/ktx"),
    ("image", "image/naplps"),
    ("image", "image/png"),
    ("image", "image/prs.btif"),
    ("image", "image/prs.pti"),
    ("image", "image/pwg-raster"),
    ("image", "image/svg+xml"),
    ("image", "image/t38"),
    ("image", "image/tiff"),
    ("image", "image/tiff-fx"),
    ("image", "image/vnd.adobe.photoshop"),
    ("image", "image/vnd.airzip.accelerator.azv"),
    ("image", "image/vnd.cns.inf2"),
    ("image", "image/vnd.dece.graphic"),
    ("image", "image/vnd.djvu"),
    ("image", "image/vnd.dwg"),
    ("image", "image/vnd.dxf"),
    ("image", "image/vnd.dvb.subtitle"),
    ("image", "image/vnd.fastbidsheet"),
    ("image", "image/vnd.fpx"),
    ("image", "image/vnd.fst"),
    ("image", "image/vnd.fujixerox.edmics-mmr"),
    ("image", "image/vnd.fujixerox.edmics-rlc"),
    ("image", "image/vnd.globalgraphics.pgb"),
    ("image", "image/vnd.microsoft.icon"),
    ("image", "image/vnd.mix"),
    ("image", "image/vnd.ms-modi"),
    ("image", "image/vnd.mozilla.apng"),
    ("image", "image/vnd.net-fpx"),
    ("image", "image/vnd.radiance"),
    ("image", "image/vnd.sealed.png"),
    ("image", "image/vnd.sealedmedia.softseal.gif"),
    ("image", "image/vnd.sealedmedia.softseal.jpg"),
    ("image", "image/vnd.svf"),
    ("image", "image/vnd.tencent.tap"),
    ("image", "image/vnd.valve.source.texture"),
    ("image", "image/vnd.wap.wbmp"),
    ("image", "image/vnd.xiff"),
    ("image", "image/vnd.zbrush.pcx"),
    ("image", "image/wmf"),
    ("image", "image/x-emf"),
    ("image", "image/x-wmf"),
    ("message", "message/CPIM"),
    ("message", "message/delivery-status"),
    ("message", "message/disposition-notification"),
    ("message", "message/example"),
    ("message", "message/external-body"),
    ("message", "message/feedback-report"),
    ("message", "message/global"),
    ("message", "message/global-delivery-status"),
    ("message", "message/global-disposition-notification"),
    ("message", "message/global-headers"),
    ("message", "message/http"),
    ("message", "message/imdn+xml"),
    ("message", "message/news"),
    ("message", "message/partial"),
    ("message", "message/rfc822"),
    ("message", "message/s-http"),
    ("message", "message/sip"),
    ("message", "message/sipfrag"),
    ("message", "message/tracking-status"),
    ("message", "message/vnd.si.simp"),
    ("message", "message/vnd.wfa.wsc"),
    ("model", "model/3mf"),
    ("model", "model/example"),
    ("model", "model/gltf+json"),
    ("model", "model/iges"),
    ("model", "model/mesh"),
    ("model", "model/vnd.collada+xml"),
    ("model", "model/vnd.dwf"),
    ("model", "model/vnd.flatland.3dml"),
    ("model", "model/vnd.gdl"),
    ("model", "model/vnd.gs-gdl"),
    ("model", "model/vnd.gtw"),
    ("model", "model/vnd.moml+xml"),
    ("model", "model/vnd.mts"),
    ("model", "model/vnd.opengex"),
    ("model", "model/vnd.parasolid.transmit.binary"),
    ("model", "model/vnd.parasolid.transmit.text"),
    ("model", "model/vnd.rosette.annotated-data-model"),
    ("model", "model/vnd.valve.source.compiled-map"),
    ("model", "model/vnd.vtu"),
    ("model", "model/vrml"),
    ("model", "model/x3d-vrml"),
    ("model", "model/x3d+fastinfoset"),
    ("model", "model/x3d+xml"),
    ("multipart", "multipart/alternative"),
    ("multipart", "multipart/appledouble"),
    ("multipart", "multipart/byteranges"),
    ("multipart", "multipart/digest"),
    ("multipart", "multipart/encrypted"),
    ("multipart", "multipart/example"),
    ("multipart", "multipart/form-data"),
    ("multipart", "multipart/header-set"),
    ("multipart", "multipart/mixed"),
    ("multipart", "multipart/parallel"),
    ("multipart", "multipart/related"),
    ("multipart", "multipart/report"),
    ("multipart", "multipart/signed"),
    ("multipart", "multipart/vnd.bint.med-plus"),
    ("multipart", "multipart/voice-message"),
    ("multipart", "multipart/x-mixed-replace"),
    ("text", "text/1d-interleaved-parityfec"),
    ("text", "text/cache-manifest"),
    ("text", "text/calendar"),
    ("text", "text/css"),
    ("text", "text/csv"),
    ("text", "text/csv-schema"),
    ("text", "text/directory"),
    ("text", "text/dns"),
    ("text", "text/ecmascript"),
    ("text", "text/encaprtp"),
    ("text", "text/enriched"),
    ("text", "text/example"),
    ("text", "text/fwdred"),
    ("text", "text/grammar-ref-list"),
    ("text", "text/html"),
    ("text", "text/javascript"),
    ("text", "text/jcr-cnd"),
    ("text", "text/markdown"),
    ("text", "text/mizar"),
    ("text", "text/n3"),
    ("text", "text/parameters"),
    ("text", "text/parityfec"),
    ("text", "text/plain"),
    ("text", "text/provenance-notation"),
    ("text", "text/prs.fallenstein.rst"),
    ("text", "text/prs.lines.tag"),
    ("text", "text/prs.prop.logic"),
    ("text", "text/raptorfec"),
    ("text", "text/RED"),
    ("text", "text/rfc822-headers"),
    ("text", "text/richtext"),
    ("text", "text/rtf"),
    ("text", "text/rtp-enc-aescm128"),
    ("text", "text/rtploopback"),
    ("text", "text/rtx"),
    ("text", "text/sgml"),
    ("text", "text/strings"),
    ("text", "text/t140"),
    ("text", "text/tab-separated-values"),
    ("text", "text/troff"),
    ("text", "text/turtle"),
    ("text", "text/ulpfec"),
    ("text", "text/uri-list"),
    ("text", "text/vcard"),
    ("text", "text/vnd.a"),
    ("text", "text/vnd.abc"),
    ("text", "text/vnd.ascii-art"),
    ("text", "text/vnd.curl"),
    ("text", "text/vnd.debian.copyright"),
    ("text", "text/vnd.DMClientScript"),
    ("text", "text/vnd.dvb.subtitle"),
    ("text", "text/vnd.esmertec.theme-descriptor"),
    ("text", "text/vnd.fly"),
    ("text", "text/vnd.fmi.flexstor"),
    ("text", "text/vnd.graphviz"),
    ("text", "text/vnd.in3d.3dml"),
    ("text", "text/vnd.in3d.spot"),
    ("text", "text/vnd.IPTC.NewsML"),
    ("text", "text/vnd.IPTC.NITF"),
    ("text", "text/vnd.latex-z"),
    ("text", "text/vnd.motorola.reflex"),
    ("text", "text/vnd.ms-mediapackage"),
    ("text", "text/vnd.net2phone.commcenter.command"),
    ("text", "text/vnd.radisys.msml-basic-layout"),
    ("text", "text/vnd.si.uricatalogue"),
    ("text", "text/vnd.sun.j2me.app-descriptor"),
    ("text", "text/vnd.trolltech.linguist"),
    ("text", "text/vnd.wap.si"),
    ("text", "text/vnd.wap.sl"),
    ("text", "text/vnd.wap.wml"),
    ("text", "text/vnd.wap.wmlscript"),
    ("text", "text/xml"),
    ("text", "text/xml-external-parsed-entity"),
    ("video", "video/1d-interleaved-parityfec"),
    ("video", "video/3gpp"),
    ("video", "video/3gpp2"),
    ("video", "video/3gpp-tt"),
    ("video", "video/BMPEG"),
    ("video", "video/BT656"),
    ("video", "video/CelB"),
    ("video", "video/DV"),
    ("video", "video/encaprtp"),
    ("video", "video/example"),
    ("video", "video/H261"),
    ("video", "video/H263"),
    ("video", "video/H263-1998"),
    ("video", "video/H263-2000"),
    ("video", "video/H264"),
    ("video", "video/H264-RCDO"),
    ("video", "video/H264-SVC"),
    ("video", "video/H265"),
    ("video", "video/iso.segment"),
    ("video", "video/JPEG"),
    ("video", "video/jpeg2000"),
    ("video", "video/mj2"),
    ("video", "video/MP1S"),
    ("video", "video/MP2P"),
    ("video", "video/MP2T"),
    ("video", "video/mp4"),
    ("video", "video/MP4V-ES"),
    ("video", "video/MPV"),
    ("video", "video/mpeg"),
    ("video", "video/mpeg4-generic"),
    ("video", "video/nv"),
    ("video", "video/ogg"),
    ("video", "video/parityfec"),
    ("video", "video/pointer"),
    ("video", "video/quicktime"),
    ("video", "video/raptorfec"),
    ("video", "video/raw"),
    ("video", "video/rtp-enc-aescm128"),
    ("video", "video/rtploopback"),
    ("video", "video/rtx"),
    ("video", "video/SMPTE292M"),
    ("video", "video/ulpfec"),
    ("video", "video/vc1"),
    ("video", "video/vnd.CCTV"),
    ("video", "video/vnd.dece.hd"),
    ("video", "video/vnd.dece.mobile"),
    ("video", "video/vnd.dece.mp4"),
    ("video", "video/vnd.dece.pd"),
    ("video", "video/vnd.dece.sd"),
    ("video", "video/vnd.dece.video"),
    ("video", "video/vnd.directv.mpeg"),
    ("video", "video/vnd.directv.mpeg-tts"),
    ("video", "video/vnd.dlna.mpeg-tts"),
    ("video", "video/vnd.dvb.file"),
    ("video", "video/vnd.fvt"),
    ("video", "video/vnd.hns.video"),
    ("video", "video/vnd.iptvforum.1dparityfec-1010"),
    ("video", "video/vnd.iptvforum.1dparityfec-2005"),
    ("video", "video/vnd.iptvforum.2dparityfec-1010"),
    ("video", "video/vnd.iptvforum.2dparityfec-2005"),
    ("video", "video/vnd.iptvforum.ttsavc"),
    ("video", "video/vnd.iptvforum.ttsmpeg2"),
    ("video", "video/vnd.motorola.video"),
    ("video", "video/vnd.motorola.videop"),
    ("video", "video/vnd.mpegurl"),
    ("video", "video/vnd.ms-playready.media.pyv"),
    ("video", "video/vnd.nokia.interleaved-multimedia"),
    ("video", "video/vnd.nokia.videovoip"),
    ("video", "video/vnd.objectvideo"),
    ("video", "video/vnd.radgamettools.bink"),
    ("video", "video/vnd.radgamettools.smacker"),
    ("video", "video/vnd.sealed.mpeg1"),
    ("video", "video/vnd.sealed.mpeg4"),
    ("video", "video/vnd.sealed.swf"),
    ("video", "video/vnd.sealedmedia.softseal.mov"),
    ("video", "video/vnd.uvvu.mp4"),
    ("video", "video/vnd.vivo"),
    ("video", "video/VP8"),
)
