from exploits.sort import bucketsort
from test.exploits.dummy_output import DummyOutput
from input.ints import IntGenerator


def test_run():
    output = DummyOutput()
    n_inputs = 10
    bucketsort.options['n_inputs'] = n_inputs
    bucketsort.run(IntGenerator(), output)
    assert len(output) == n_inputs
    assert output[0] == 0
    assert output[1] == 255
    for i in range(2, len(output)):
        assert output[i] == i - 2


def test_more_inputs():
    output = DummyOutput()
    n_inputs = 255
    bucketsort.options['n_inputs'] = n_inputs
    bucketsort.run(IntGenerator(), output)
    assert len(output) == n_inputs
    assert output[0] == 0
    assert output[1] == 255
    for i in range(2, len(output)):
        assert output[i] == i - 2
